/* Photo.c generated by valac 0.42.7, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include "shotwell-graphics-processor.h"
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;


#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;


#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;


#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;


#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;


#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;


#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];

#define PHOTO_TYPE_CACHED_PIXBUF (photo_cached_pixbuf_get_type ())
#define PHOTO_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf))
#define PHOTO_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))
#define PHOTO_IS_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_IS_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_CACHED_PIXBUF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))

typedef struct _PhotoCachedPixbuf PhotoCachedPixbuf;
typedef struct _PhotoCachedPixbufClass PhotoCachedPixbufClass;
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;


#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;


#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;


#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef enum  {
	PHOTO_FILE_READER_ROLE_DEFAULT,
	PHOTO_FILE_READER_ROLE_THUMBNAIL
} PhotoFileReaderRole;


#define PHOTO_FILE_READER_TYPE_ROLE (photo_file_reader_role_get_type ())

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;


#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;
typedef struct _PhotoCachedPixbufPrivate PhotoCachedPixbufPrivate;
#define _photo_cached_pixbuf_unref0(var) ((var == NULL) ? NULL : (var = (photo_cached_pixbuf_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef void (*OneShotCallback) (gpointer user_data);
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoParamSpecCachedPixbuf PhotoParamSpecCachedPixbuf;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;


#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;


#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportID {
	gint64 id;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _PhotoCachedPixbuf {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoCachedPixbufPrivate * priv;
	Photo* photo;
	GdkPixbuf* pixbuf;
	GTimer* last_touched;
};

struct _PhotoCachedPixbufClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoCachedPixbuf *self);
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecCachedPixbuf {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gint PhotoTransformationState_private_offset;
static gpointer photo_transformation_state_parent_class = NULL;
static gint Photo_private_offset;
static gpointer photo_parent_class = NULL;
static GeeLinkedList* photo_source_pixbuf_cache;
static GRecMutex __lock_photo_photo_source_pixbuf_cache = {0};
static GeeLinkedList* photo_source_pixbuf_cache = NULL;
static guint photo_discard_source_id;
static guint photo_discard_source_id = (guint) 0;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gint PhotoPhotoTransformationStateImpl_private_offset;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_cached_pixbuf_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static gint LibraryPhotoSourceCollection_private_offset;
static gpointer library_photo_source_collection_parent_class = NULL;
static gint LibraryPhoto_private_offset;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gint LibraryPhotoSourceHoldingTank_private_offset;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
GType rating_get_type (void) G_GNUC_CONST;
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
static gpointer photo_cached_pixbuf_ref (gpointer instance);
static void photo_cached_pixbuf_unref (gpointer instance);
static GParamSpec* photo_param_spec_cached_pixbuf (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_cached_pixbuf (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_cached_pixbuf (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_cached_pixbuf (const GValue* value) G_GNUC_UNUSED;
static GType photo_cached_pixbuf_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC 10
#define PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT 1
#define PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT 3
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type,
                        PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_init_photo (void);
void photo_terminate_photo (void);
void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
gchar* data_object_to_string (DataObject* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              gboolean notify,
                                              GError** error);
void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
gboolean photo_file_interrogator_get_is_photo_corrupted (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d,
                          gboolean notify);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
gboolean jpeg_is_jpeg_bytes (GBytes* bytes,
                             GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
void photo_revert_to_master (Photo* self,
                             gboolean notify);
GdkPixbuf* photo_get_prefetched_copy (Photo* self,
                                      GError** error);
gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
void photo_discard_prefetched (Photo* self);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add86 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add87 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add88 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
GType photo_file_reader_role_get_type (void) G_GNUC_CONST;
void photo_file_reader_set_role (PhotoFileReader* self,
                                 PhotoFileReaderRole role);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation* * detected,
                                                GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState* * reimport_state,
                                            GError** error);
static void _vala_array_add89 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add90 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add91 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add92 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add93 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add94 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add95 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add96 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
Alteration* alteration_new_from_array (gchar** array,
                                       int array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow* * backing,
                                         DetectedPhotoInformation* * detected,
                                         GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState* * state,
                                              GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void media_source_set_title (MediaSource* self,
                             const gchar* title);
gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
void media_source_set_rating (MediaSource* self,
                              Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState* * state,
                                                     GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   int extensions_length1);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self,
                            GFile* file);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add97 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add98 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add99 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add100 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void photo_set_editable_file (Photo* self,
                              GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add101 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add102 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add103 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base,
                            Rating rating);
gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_set_import_id (Photo* self,
                          ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static void photo_real_set_exposure_time (Dateable* base,
                                   time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
void photo_set_exposure_time_persistent (Photo* self,
                                         time_t time,
                                         GError** error);
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState* * state,
                                        GError** error);
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState* * state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self,
                   Rotation rotation);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            int* result_length1);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
static GdkPixbuf* photo_run_source_pixbuf_cache (Photo* locate,
                                          gboolean keep,
                                          GError** error);
static PhotoCachedPixbuf* photo_cached_pixbuf_new (Photo* photo,
                                            GdkPixbuf* pixbuf);
static PhotoCachedPixbuf* photo_cached_pixbuf_construct (GType object_type,
                                                  Photo* photo,
                                                  GdkPixbuf* pixbuf);
static gboolean photo_trim_source_pixbuf_cache (void);
static gboolean _photo_trim_source_pixbuf_cache_gsource_func (gpointer self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self,
                                          GError** error);
void photo_open_with_external_editor (Photo* self,
                                      GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
void photo_reimport_editable (Photo* self,
                              GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add104 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add105 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add106 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add107 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add108 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add109 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
void photo_set_crop (Photo* self,
                     Box* crop);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
gboolean photo_enhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
static void photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj);
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static gchar** _vala_array_dup25 (gchar** self,
                           int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static void photo_finalize (GObject * obj);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      gpointer check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      gpointer get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            gpointer check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            gpointer get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self,
                      GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
gint utf8_ci_compare (void* a,
                      void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                         guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor,
                         gpointer monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto* * photo);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self,
                   MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
void tag_attach (Tag* self,
                 MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
static void library_photo_finalize (GObject * obj);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 3802 "Photo.c"
}


static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 48 "../src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 3811 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_IS_FILE (final_associated_file), NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "../src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 41 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "../src/Photo.vala"
	self->file = _tmp0_;
#line 42 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 42 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "../src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 43 "../src/Photo.vala"
	_tmp2_ = *import_id;
#line 43 "../src/Photo.vala"
	self->import_id = _tmp2_;
#line 44 "../src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 45 "../src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 45 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "../src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 46 "../src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 46 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "../src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 47 "../src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 47 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "../src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 48 "../src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 48 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "../src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 38 "../src/Photo.vala"
	return self;
#line 3888 "Photo.c"
}


PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 38 "../src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 3904 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 52 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 53 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "../src/Photo.vala"
	self->file = _tmp0_;
#line 54 "../src/Photo.vala"
	_tmp1_ = *import_id;
#line 54 "../src/Photo.vala"
	self->import_id = _tmp1_;
#line 55 "../src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "../src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "../src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "../src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "../src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "../src/Photo.vala"
	return self;
#line 3952 "Photo.c"
}


PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 52 "../src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 3962 "Photo.c"
}


static void
value_photo_import_params_init (GValue* value)
{
#line 21 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 3971 "Photo.c"
}


static void
value_photo_import_params_free_value (GValue* value)
{
#line 21 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 3982 "Photo.c"
	}
}


static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 21 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 3995 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3999 "Photo.c"
	}
}


static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4009 "Photo.c"
}


static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 21 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4021 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4028 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4032 "Photo.c"
		}
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4036 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4040 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4044 "Photo.c"
}


static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (!object_p) {
#line 21 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4060 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/Photo.vala"
		*object_p = NULL;
#line 4066 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4070 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4074 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	return NULL;
#line 4078 "Photo.c"
}


GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4098 "Photo.c"
}


gpointer
value_get_photo_import_params (const GValue* value)
{
#line 21 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4109 "Photo.c"
}


void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4132 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4136 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4142 "Photo.c"
	}
}


void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/Photo.vala"
	if (v_object) {
#line 21 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4164 "Photo.c"
	} else {
#line 21 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4168 "Photo.c"
	}
#line 21 "../src/Photo.vala"
	if (old) {
#line 21 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4174 "Photo.c"
	}
}


static void
photo_import_params_class_init (PhotoImportParamsClass * klass)
{
#line 21 "../src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4186 "Photo.c"
}


static void
photo_import_params_instance_init (PhotoImportParams * self)
{
	PhotoRow* _tmp0_;
#line 24 "../src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "../src/Photo.vala"
	self->row = _tmp0_;
#line 36 "../src/Photo.vala"
	self->keywords = NULL;
#line 21 "../src/Photo.vala"
	self->ref_count = 1;
#line 4204 "Photo.c"
}


static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 21 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 21 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "../src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4232 "Photo.c"
}


GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/Photo.vala"
	return instance;
#line 4261 "Photo.c"
}


void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4276 "Photo.c"
	}
}


static inline gpointer
photo_transformation_state_get_instance_private (PhotoTransformationState* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoTransformationState_private_offset);
}


gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 72 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 73 "../src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 73 "../src/Photo.vala"
	result = _tmp0_;
#line 73 "../src/Photo.vala"
	return result;
#line 4301 "Photo.c"
}


PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 63 "../src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 63 "../src/Photo.vala"
	return self;
#line 4313 "Photo.c"
}


static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 69 "../src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4322 "Photo.c"
}


static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass)
{
#line 63 "../src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoTransformationState_private_offset);
#line 63 "../src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "../src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4339 "Photo.c"
}


static void
photo_transformation_state_instance_init (PhotoTransformationState * self)
{
#line 63 "../src/Photo.vala"
	self->priv = photo_transformation_state_get_instance_private (self);
#line 64 "../src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4350 "Photo.c"
}


static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 63 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 63 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4362 "Photo.c"
}


GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		PhotoTransformationState_private_offset = g_type_add_instance_private (photo_transformation_state_type_id, sizeof (PhotoTransformationStatePrivate));
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean
rating_can_increase (Rating self)
{
	gboolean result = FALSE;
#line 87 "../src/Photo.vala"
	result = self < RATING_FIVE;
#line 87 "../src/Photo.vala"
	return result;
#line 4389 "Photo.c"
}


gboolean
rating_can_decrease (Rating self)
{
	gboolean result = FALSE;
#line 91 "../src/Photo.vala"
	result = self > RATING_REJECTED;
#line 91 "../src/Photo.vala"
	return result;
#line 4401 "Photo.c"
}


gboolean
rating_is_valid (Rating self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 95 "../src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 95 "../src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 4414 "Photo.c"
	} else {
#line 95 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 4418 "Photo.c"
	}
#line 95 "../src/Photo.vala"
	result = _tmp0_;
#line 95 "../src/Photo.vala"
	return result;
#line 4424 "Photo.c"
}


Rating
rating_increase (Rating self)
{
	Rating result = 0;
	Rating _tmp0_ = 0;
#line 99 "../src/Photo.vala"
	if (rating_can_increase (self)) {
#line 99 "../src/Photo.vala"
		_tmp0_ = self + 1;
#line 4437 "Photo.c"
	} else {
#line 99 "../src/Photo.vala"
		_tmp0_ = self;
#line 4441 "Photo.c"
	}
#line 99 "../src/Photo.vala"
	result = _tmp0_;
#line 99 "../src/Photo.vala"
	return result;
#line 4447 "Photo.c"
}


Rating
rating_decrease (Rating self)
{
	Rating result = 0;
	Rating _tmp0_ = 0;
#line 103 "../src/Photo.vala"
	if (rating_can_decrease (self)) {
#line 103 "../src/Photo.vala"
		_tmp0_ = self - 1;
#line 4460 "Photo.c"
	} else {
#line 103 "../src/Photo.vala"
		_tmp0_ = self;
#line 4464 "Photo.c"
	}
#line 103 "../src/Photo.vala"
	result = _tmp0_;
#line 103 "../src/Photo.vala"
	return result;
#line 4470 "Photo.c"
}


gint
rating_serialize (Rating self)
{
	gint result = 0;
#line 107 "../src/Photo.vala"
	switch (self) {
#line 107 "../src/Photo.vala"
		case RATING_REJECTED:
#line 4482 "Photo.c"
		{
#line 109 "../src/Photo.vala"
			result = -1;
#line 109 "../src/Photo.vala"
			return result;
#line 4488 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_UNRATED:
#line 4492 "Photo.c"
		{
#line 111 "../src/Photo.vala"
			result = 0;
#line 111 "../src/Photo.vala"
			return result;
#line 4498 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_ONE:
#line 4502 "Photo.c"
		{
#line 113 "../src/Photo.vala"
			result = 1;
#line 113 "../src/Photo.vala"
			return result;
#line 4508 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_TWO:
#line 4512 "Photo.c"
		{
#line 115 "../src/Photo.vala"
			result = 2;
#line 115 "../src/Photo.vala"
			return result;
#line 4518 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_THREE:
#line 4522 "Photo.c"
		{
#line 117 "../src/Photo.vala"
			result = 3;
#line 117 "../src/Photo.vala"
			return result;
#line 4528 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FOUR:
#line 4532 "Photo.c"
		{
#line 119 "../src/Photo.vala"
			result = 4;
#line 119 "../src/Photo.vala"
			return result;
#line 4538 "Photo.c"
		}
#line 107 "../src/Photo.vala"
		case RATING_FIVE:
#line 4542 "Photo.c"
		{
#line 121 "../src/Photo.vala"
			result = 5;
#line 121 "../src/Photo.vala"
			return result;
#line 4548 "Photo.c"
		}
		default:
		{
#line 123 "../src/Photo.vala"
			result = 0;
#line 123 "../src/Photo.vala"
			return result;
#line 4556 "Photo.c"
		}
	}
}


Rating
rating_unserialize (gint value)
{
	Rating result = 0;
#line 128 "../src/Photo.vala"
	if (value > ((gint) RATING_FIVE)) {
#line 129 "../src/Photo.vala"
		result = RATING_FIVE;
#line 129 "../src/Photo.vala"
		return result;
#line 4572 "Photo.c"
	} else {
#line 130 "../src/Photo.vala"
		if (value < ((gint) RATING_REJECTED)) {
#line 131 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 131 "../src/Photo.vala"
			return result;
#line 4580 "Photo.c"
		}
	}
#line 133 "../src/Photo.vala"
	switch (value) {
#line 133 "../src/Photo.vala"
		case -1:
#line 4587 "Photo.c"
		{
#line 135 "../src/Photo.vala"
			result = RATING_REJECTED;
#line 135 "../src/Photo.vala"
			return result;
#line 4593 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 0:
#line 4597 "Photo.c"
		{
#line 137 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 137 "../src/Photo.vala"
			return result;
#line 4603 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 1:
#line 4607 "Photo.c"
		{
#line 139 "../src/Photo.vala"
			result = RATING_ONE;
#line 139 "../src/Photo.vala"
			return result;
#line 4613 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 2:
#line 4617 "Photo.c"
		{
#line 141 "../src/Photo.vala"
			result = RATING_TWO;
#line 141 "../src/Photo.vala"
			return result;
#line 4623 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 3:
#line 4627 "Photo.c"
		{
#line 143 "../src/Photo.vala"
			result = RATING_THREE;
#line 143 "../src/Photo.vala"
			return result;
#line 4633 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 4:
#line 4637 "Photo.c"
		{
#line 145 "../src/Photo.vala"
			result = RATING_FOUR;
#line 145 "../src/Photo.vala"
			return result;
#line 4643 "Photo.c"
		}
#line 133 "../src/Photo.vala"
		case 5:
#line 4647 "Photo.c"
		{
#line 147 "../src/Photo.vala"
			result = RATING_FIVE;
#line 147 "../src/Photo.vala"
			return result;
#line 4653 "Photo.c"
		}
		default:
		{
#line 149 "../src/Photo.vala"
			result = RATING_UNRATED;
#line 149 "../src/Photo.vala"
			return result;
#line 4661 "Photo.c"
		}
	}
}


GType
rating_get_type (void)
{
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


static inline gpointer
photo_get_instance_private (Photo* self)
{
	return G_STRUCT_MEMBER_P (self, Photo_private_offset);
}


gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result = FALSE;
#line 225 "../src/Photo.vala"
	result = (self & exception) != 0;
#line 225 "../src/Photo.vala"
	return result;
#line 4697 "Photo.c"
}


gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result = FALSE;
#line 229 "../src/Photo.vala"
	result = (self & exception) == 0;
#line 229 "../src/Photo.vala"
	return result;
#line 4710 "Photo.c"
}


GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer
_photo_row_ref0 (gpointer self)
{
#line 397 "../src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4733 "Photo.c"
}


static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 418 "../src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4742 "Photo.c"
}


Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	PhotoFileFormat _tmp11_;
	BackingPhotoRow* _tmp12_;
	const gchar* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp21_;
	BackingPhotoID _tmp25_;
	gint64 _tmp26_;
	BackingPhotoRow* _tmp41_;
	PhotoFileFormat _tmp42_;
	gboolean _tmp57_ = FALSE;
	BackingPhotoRow* _tmp58_;
	PhotoFileFormat _tmp59_;
	PhotoBackingReaders* _tmp71_;
	PhotoFileReader* _tmp72_;
	PhotoRow* _tmp88_;
	time_t _tmp89_;
	GError* _inner_error0_ = NULL;
#line 396 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 396 "../src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 397 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 397 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 397 "../src/Photo.vala"
	self->row = _tmp0_;
#line 400 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp2_ = self->row;
#line 400 "../src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 400 "../src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 400 "../src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 400 "../src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 401 "../src/Photo.vala"
	_tmp5_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp6_ = self->row;
#line 401 "../src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 401 "../src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 401 "../src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 401 "../src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 405 "../src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 405 "../src/Photo.vala"
	_tmp10_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp11_ = _tmp10_->file_format;
#line 405 "../src/Photo.vala"
	_tmp12_ = row->master;
#line 405 "../src/Photo.vala"
	_tmp13_ = _tmp12_->filepath;
#line 405 "../src/Photo.vala"
	_tmp14_ = photo_file_format_create_reader (_tmp11_, _tmp13_);
#line 405 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 405 "../src/Photo.vala"
	_tmp9_->master = _tmp14_;
#line 408 "../src/Photo.vala"
	_tmp15_ = row->master;
#line 408 "../src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 408 "../src/Photo.vala"
	_tmp17_ = string_sliced_at_last_char (_tmp16_, (gunichar) G_DIR_SEPARATOR, 0);
#line 408 "../src/Photo.vala"
	basename = _tmp17_;
#line 409 "../src/Photo.vala"
	_tmp18_ = basename;
#line 409 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 4846 "Photo.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 410 "../src/Photo.vala"
		_tmp19_ = basename;
#line 410 "../src/Photo.vala"
		_tmp20_ = string_sliced_at (_tmp19_, 1);
#line 410 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 410 "../src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 4857 "Photo.c"
	}
#line 412 "../src/Photo.vala"
	_tmp21_ = self->priv->file_title;
#line 412 "../src/Photo.vala"
	if (is_string_empty (_tmp21_)) {
#line 4863 "Photo.c"
		BackingPhotoRow* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 413 "../src/Photo.vala"
		_tmp22_ = row->master;
#line 413 "../src/Photo.vala"
		_tmp23_ = _tmp22_->filepath;
#line 413 "../src/Photo.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 413 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 413 "../src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 4877 "Photo.c"
	}
#line 415 "../src/Photo.vala"
	_tmp25_ = row->editable_id;
#line 415 "../src/Photo.vala"
	_tmp26_ = _tmp25_.id;
#line 415 "../src/Photo.vala"
	if (_tmp26_ != BACKING_PHOTO_ID_INVALID) {
#line 4885 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp27_;
		BackingPhotoRow* _tmp28_;
		BackingPhotoRow* _tmp29_;
#line 416 "../src/Photo.vala"
		_tmp27_ = row->editable_id;
#line 416 "../src/Photo.vala"
		_tmp28_ = photo_get_backing_row (self, &_tmp27_);
#line 416 "../src/Photo.vala"
		e = _tmp28_;
#line 417 "../src/Photo.vala"
		_tmp29_ = e;
#line 417 "../src/Photo.vala"
		if (_tmp29_ != NULL) {
#line 4900 "Photo.c"
			BackingPhotoRow* _tmp30_;
			BackingPhotoRow* _tmp31_;
			PhotoBackingReaders* _tmp32_;
			BackingPhotoRow* _tmp33_;
			PhotoFileFormat _tmp34_;
			BackingPhotoRow* _tmp35_;
			const gchar* _tmp36_;
			PhotoFileReader* _tmp37_;
#line 418 "../src/Photo.vala"
			_tmp30_ = e;
#line 418 "../src/Photo.vala"
			_tmp31_ = _backing_photo_row_ref0 (_tmp30_);
#line 418 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 418 "../src/Photo.vala"
			self->priv->editable = _tmp31_;
#line 419 "../src/Photo.vala"
			_tmp32_ = self->priv->readers;
#line 419 "../src/Photo.vala"
			_tmp33_ = self->priv->editable;
#line 419 "../src/Photo.vala"
			_tmp34_ = _tmp33_->file_format;
#line 419 "../src/Photo.vala"
			_tmp35_ = self->priv->editable;
#line 419 "../src/Photo.vala"
			_tmp36_ = _tmp35_->filepath;
#line 419 "../src/Photo.vala"
			_tmp37_ = photo_file_format_create_reader (_tmp34_, _tmp36_);
#line 419 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp32_->editable);
#line 419 "../src/Photo.vala"
			_tmp32_->editable = _tmp37_;
#line 4933 "Photo.c"
		} else {
			{
				PhotoTable* _tmp38_;
				PhotoTable* _tmp39_;
				PhotoRow* _tmp40_;
#line 422 "../src/Photo.vala"
				_tmp38_ = photo_table_get_instance ();
#line 422 "../src/Photo.vala"
				_tmp39_ = _tmp38_;
#line 422 "../src/Photo.vala"
				_tmp40_ = self->row;
#line 422 "../src/Photo.vala"
				photo_table_detach_editable (_tmp39_, _tmp40_, &_inner_error0_);
#line 422 "../src/Photo.vala"
				_database_table_unref0 (_tmp39_);
#line 422 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 4953 "Photo.c"
						goto __catch264_database_error;
					}
#line 422 "../src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 422 "../src/Photo.vala"
					_g_free0 (basename);
#line 422 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 422 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 422 "../src/Photo.vala"
					return NULL;
#line 4966 "Photo.c"
				}
			}
			goto __finally264;
			__catch264_database_error:
			{
				GError* err = NULL;
#line 421 "../src/Photo.vala"
				err = _inner_error0_;
#line 421 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 421 "../src/Photo.vala"
				_g_error_free0 (err);
#line 4979 "Photo.c"
			}
			__finally264:
#line 421 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "../src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 421 "../src/Photo.vala"
				_g_free0 (basename);
#line 421 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 421 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 421 "../src/Photo.vala"
				return NULL;
#line 4994 "Photo.c"
			}
#line 429 "../src/Photo.vala"
			photo_remove_all_transformations (self, FALSE);
#line 4998 "Photo.c"
		}
#line 415 "../src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 5002 "Photo.c"
	}
#line 433 "../src/Photo.vala"
	_tmp41_ = row->master;
#line 433 "../src/Photo.vala"
	_tmp42_ = _tmp41_->file_format;
#line 433 "../src/Photo.vala"
	if (_tmp42_ == PHOTO_FILE_FORMAT_RAW) {
#line 5010 "Photo.c"
		GeeHashMap* _tmp43_;
		gint _tmp44_ = 0;
		RawDeveloper* _tmp45_;
#line 435 "../src/Photo.vala"
		_tmp43_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 435 "../src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 435 "../src/Photo.vala"
		self->priv->developments = _tmp43_;
#line 436 "../src/Photo.vala"
		_tmp45_ = raw_developer_as_array (&_tmp44_);
#line 5022 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 436 "../src/Photo.vala"
			d_collection = _tmp45_;
#line 436 "../src/Photo.vala"
			d_collection_length1 = _tmp44_;
#line 436 "../src/Photo.vala"
			for (d_it = 0; d_it < _tmp44_; d_it = d_it + 1) {
#line 5034 "Photo.c"
				RawDeveloper d = 0;
#line 436 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5038 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp46_;
					gint _tmp46__length1;
					RawDeveloper _tmp47_;
					BackingPhotoID _tmp48_;
					BackingPhotoID _tmp49_;
					gint64 _tmp50_;
#line 437 "../src/Photo.vala"
					_tmp46_ = row->development_ids;
#line 437 "../src/Photo.vala"
					_tmp46__length1 = row->development_ids_length1;
#line 437 "../src/Photo.vala"
					_tmp47_ = d;
#line 437 "../src/Photo.vala"
					_tmp48_ = _tmp46_[_tmp47_];
#line 437 "../src/Photo.vala"
					id = _tmp48_;
#line 438 "../src/Photo.vala"
					_tmp49_ = id;
#line 438 "../src/Photo.vala"
					_tmp50_ = _tmp49_.id;
#line 438 "../src/Photo.vala"
					if (_tmp50_ != BACKING_PHOTO_ID_INVALID) {
#line 5063 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp51_;
						BackingPhotoRow* _tmp52_;
						BackingPhotoRow* _tmp53_;
#line 439 "../src/Photo.vala"
						_tmp51_ = id;
#line 439 "../src/Photo.vala"
						_tmp52_ = photo_get_backing_row (self, &_tmp51_);
#line 439 "../src/Photo.vala"
						bpr = _tmp52_;
#line 440 "../src/Photo.vala"
						_tmp53_ = bpr;
#line 440 "../src/Photo.vala"
						if (_tmp53_ != NULL) {
#line 5078 "Photo.c"
							GeeHashMap* _tmp54_;
							RawDeveloper _tmp55_;
							BackingPhotoRow* _tmp56_;
#line 441 "../src/Photo.vala"
							_tmp54_ = self->priv->developments;
#line 441 "../src/Photo.vala"
							_tmp55_ = d;
#line 441 "../src/Photo.vala"
							_tmp56_ = bpr;
#line 441 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp55_), _tmp56_);
#line 5090 "Photo.c"
						}
#line 438 "../src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 5094 "Photo.c"
					}
				}
			}
#line 436 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5100 "Photo.c"
		}
	}
#line 447 "../src/Photo.vala"
	_tmp58_ = row->master;
#line 447 "../src/Photo.vala"
	_tmp59_ = _tmp58_->file_format;
#line 447 "../src/Photo.vala"
	if (_tmp59_ == PHOTO_FILE_FORMAT_RAW) {
#line 5109 "Photo.c"
		GeeHashMap* _tmp60_;
		RawDeveloper _tmp61_;
#line 447 "../src/Photo.vala"
		_tmp60_ = self->priv->developments;
#line 447 "../src/Photo.vala"
		_tmp61_ = row->developer;
#line 447 "../src/Photo.vala"
		_tmp57_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp61_));
#line 5118 "Photo.c"
	} else {
#line 447 "../src/Photo.vala"
		_tmp57_ = FALSE;
#line 5122 "Photo.c"
	}
#line 447 "../src/Photo.vala"
	if (_tmp57_) {
#line 5126 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp62_;
		RawDeveloper _tmp63_;
		gpointer _tmp64_;
		PhotoBackingReaders* _tmp65_;
		BackingPhotoRow* _tmp66_;
		PhotoFileFormat _tmp67_;
		BackingPhotoRow* _tmp68_;
		const gchar* _tmp69_;
		PhotoFileReader* _tmp70_;
#line 448 "../src/Photo.vala"
		_tmp62_ = self->priv->developments;
#line 448 "../src/Photo.vala"
		_tmp63_ = row->developer;
#line 448 "../src/Photo.vala"
		_tmp64_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp63_));
#line 448 "../src/Photo.vala"
		r = (BackingPhotoRow*) _tmp64_;
#line 449 "../src/Photo.vala"
		_tmp65_ = self->priv->readers;
#line 449 "../src/Photo.vala"
		_tmp66_ = r;
#line 449 "../src/Photo.vala"
		_tmp67_ = _tmp66_->file_format;
#line 449 "../src/Photo.vala"
		_tmp68_ = r;
#line 449 "../src/Photo.vala"
		_tmp69_ = _tmp68_->filepath;
#line 449 "../src/Photo.vala"
		_tmp70_ = photo_file_format_create_reader (_tmp67_, _tmp69_);
#line 449 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp65_->developer);
#line 449 "../src/Photo.vala"
		_tmp65_->developer = _tmp70_;
#line 447 "../src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 5163 "Photo.c"
	}
#line 453 "../src/Photo.vala"
	_tmp71_ = self->priv->readers;
#line 453 "../src/Photo.vala"
	_tmp72_ = _tmp71_->editable;
#line 453 "../src/Photo.vala"
	if (_tmp72_ != NULL) {
#line 5171 "Photo.c"
		BackingPhotoRow* _tmp73_;
		BackingPhotoRow* _tmp74_;
#line 454 "../src/Photo.vala"
		_tmp73_ = self->priv->editable;
#line 454 "../src/Photo.vala"
		_tmp74_ = _backing_photo_row_ref0 (_tmp73_);
#line 454 "../src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 454 "../src/Photo.vala"
		self->backing_photo_row = _tmp74_;
#line 5182 "Photo.c"
	} else {
		BackingPhotoRow* _tmp75_;
		PhotoFileFormat _tmp76_;
#line 455 "../src/Photo.vala"
		_tmp75_ = row->master;
#line 455 "../src/Photo.vala"
		_tmp76_ = _tmp75_->file_format;
#line 455 "../src/Photo.vala"
		if (_tmp76_ != PHOTO_FILE_FORMAT_RAW) {
#line 5192 "Photo.c"
			PhotoRow* _tmp77_;
			BackingPhotoRow* _tmp78_;
			BackingPhotoRow* _tmp79_;
#line 456 "../src/Photo.vala"
			_tmp77_ = self->row;
#line 456 "../src/Photo.vala"
			_tmp78_ = _tmp77_->master;
#line 456 "../src/Photo.vala"
			_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 456 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 456 "../src/Photo.vala"
			self->backing_photo_row = _tmp79_;
#line 5206 "Photo.c"
		} else {
			GeeHashMap* _tmp80_;
			RawDeveloper _tmp81_;
#line 460 "../src/Photo.vala"
			_tmp80_ = self->priv->developments;
#line 460 "../src/Photo.vala"
			_tmp81_ = row->developer;
#line 460 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp81_))) {
#line 5216 "Photo.c"
				GeeHashMap* _tmp82_;
				RawDeveloper _tmp83_;
				gpointer _tmp84_;
#line 461 "../src/Photo.vala"
				_tmp82_ = self->priv->developments;
#line 461 "../src/Photo.vala"
				_tmp83_ = row->developer;
#line 461 "../src/Photo.vala"
				_tmp84_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp83_));
#line 461 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 461 "../src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp84_;
#line 5230 "Photo.c"
			} else {
				PhotoRow* _tmp85_;
				BackingPhotoRow* _tmp86_;
				BackingPhotoRow* _tmp87_;
#line 464 "../src/Photo.vala"
				_tmp85_ = self->row;
#line 464 "../src/Photo.vala"
				_tmp86_ = _tmp85_->master;
#line 464 "../src/Photo.vala"
				_tmp87_ = _backing_photo_row_ref0 (_tmp86_);
#line 464 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 464 "../src/Photo.vala"
				self->backing_photo_row = _tmp87_;
#line 5245 "Photo.c"
			}
		}
	}
#line 468 "../src/Photo.vala"
	_tmp88_ = self->row;
#line 468 "../src/Photo.vala"
	_tmp89_ = _tmp88_->exposure_time;
#line 468 "../src/Photo.vala"
	self->priv->cached_exposure_time = _tmp89_;
#line 396 "../src/Photo.vala"
	_g_free0 (basename);
#line 396 "../src/Photo.vala"
	return self;
#line 5259 "Photo.c"
}


void
photo_init_photo (void)
{
	GeeLinkedList* _tmp0_;
#line 472 "../src/Photo.vala"
	_tmp0_ = gee_linked_list_new (PHOTO_TYPE_CACHED_PIXBUF, (GBoxedCopyFunc) photo_cached_pixbuf_ref, (GDestroyNotify) photo_cached_pixbuf_unref, NULL, NULL, NULL);
#line 472 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 472 "../src/Photo.vala"
	photo_source_pixbuf_cache = _tmp0_;
#line 5273 "Photo.c"
}


void
photo_terminate_photo (void)
{
	guint _tmp0_;
#line 476 "../src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 476 "../src/Photo.vala"
	photo_source_pixbuf_cache = NULL;
#line 478 "../src/Photo.vala"
	_tmp0_ = photo_discard_source_id;
#line 478 "../src/Photo.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 5289 "Photo.c"
		guint _tmp1_;
#line 479 "../src/Photo.vala"
		_tmp1_ = photo_discard_source_id;
#line 479 "../src/Photo.vala"
		g_source_remove (_tmp1_);
#line 480 "../src/Photo.vala"
		photo_discard_source_id = (guint) 0;
#line 5297 "Photo.c"
	}
}


static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 484 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 484 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 485 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 5313 "Photo.c"
}


void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
#line 484 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 484 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 5326 "Photo.c"
}


static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 489 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 5335 "Photo.c"
}


void
photo_notify_raw_development_modified (Photo* self)
{
#line 488 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 488 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 5346 "Photo.c"
}


static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 493 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 5355 "Photo.c"
}


void
photo_notify_baseline_replaced (Photo* self)
{
#line 492 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 492 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 5366 "Photo.c"
}


static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 496 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 497 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5378 "Photo.c"
}


void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 496 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 496 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 5390 "Photo.c"
}


static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 500 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 501 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5402 "Photo.c"
}


void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 500 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 500 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 5414 "Photo.c"
}


static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 504 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 505 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5426 "Photo.c"
}


void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 504 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 504 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 5438 "Photo.c"
}


static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 508 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 509 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5450 "Photo.c"
}


void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 508 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 508 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 5462 "Photo.c"
}


static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	GFile* _tmp11_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 512 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 513 "../src/Photo.vala"
	ret = TRUE;
#line 514 "../src/Photo.vala"
	file = NULL;
#line 5484 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 515 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 515 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5491 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 516 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 516 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 516 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5501 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 517 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 517 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 517 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 517 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 517 "../src/Photo.vala"
				file = _tmp5_;
#line 5515 "Photo.c"
			}
		}
		__finally265:
		{
			PhotoBackingReaders* _tmp6_;
#line 515 "../src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 515 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5525 "Photo.c"
		}
#line 515 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5529 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 515 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 515 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 515 "../src/Photo.vala"
			return _tmp7_;
#line 5537 "Photo.c"
		}
	}
#line 520 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 522 "../src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5544 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 523 "../src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5549 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 523 "../src/Photo.vala"
			d_collection = _tmp9_;
#line 523 "../src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 523 "../src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 5561 "Photo.c"
				RawDeveloper d = 0;
#line 523 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5565 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 524 "../src/Photo.vala"
					_tmp10_ = d;
#line 524 "../src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 5572 "Photo.c"
				}
			}
#line 523 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5577 "Photo.c"
		}
	}
#line 528 "../src/Photo.vala"
	_tmp11_ = file;
#line 528 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 5584 "Photo.c"
		{
			gboolean _tmp12_ = FALSE;
			GFile* _tmp13_;
#line 530 "../src/Photo.vala"
			_tmp13_ = file;
#line 530 "../src/Photo.vala"
			_tmp12_ = g_file_trash (_tmp13_, NULL, &_inner_error0_);
#line 530 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5594 "Photo.c"
				goto __catch266_g_error;
			}
#line 530 "../src/Photo.vala"
			ret = _tmp12_;
#line 5599 "Photo.c"
		}
		goto __finally266;
		__catch266_g_error:
		{
			GError* err = NULL;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 529 "../src/Photo.vala"
			err = _inner_error0_;
#line 529 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 532 "../src/Photo.vala"
			ret = FALSE;
#line 533 "../src/Photo.vala"
			_tmp14_ = file;
#line 533 "../src/Photo.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 533 "../src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 533 "../src/Photo.vala"
			_tmp17_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 533 "../src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 533 "../src/Photo.vala"
			_tmp19_ = err;
#line 533 "../src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 533 "../src/Photo.vala"
			g_message ("Photo.vala:533: Unable to move editable %s for %s to trash: %s", _tmp16_, _tmp18_, _tmp20_);
#line 533 "../src/Photo.vala"
			_g_free0 (_tmp18_);
#line 533 "../src/Photo.vala"
			_g_free0 (_tmp16_);
#line 529 "../src/Photo.vala"
			_g_error_free0 (err);
#line 5640 "Photo.c"
		}
		__finally266:
#line 529 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5645 "Photo.c"
			gboolean _tmp21_ = FALSE;
#line 529 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 529 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 529 "../src/Photo.vala"
			return _tmp21_;
#line 5653 "Photo.c"
		}
	}
#line 539 "../src/Photo.vala"
	_tmp23_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 539 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5660 "Photo.c"
		gboolean _tmp24_ = FALSE;
#line 539 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 539 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 539 "../src/Photo.vala"
		return _tmp24_;
#line 5668 "Photo.c"
	}
#line 539 "../src/Photo.vala"
	if (_tmp23_) {
#line 5672 "Photo.c"
		gboolean _tmp25_;
#line 539 "../src/Photo.vala"
		_tmp25_ = ret;
#line 539 "../src/Photo.vala"
		_tmp22_ = _tmp25_;
#line 5678 "Photo.c"
	} else {
#line 539 "../src/Photo.vala"
		_tmp22_ = FALSE;
#line 5682 "Photo.c"
	}
#line 539 "../src/Photo.vala"
	result = _tmp22_;
#line 539 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 539 "../src/Photo.vala"
	return result;
#line 5690 "Photo.c"
}


static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 544 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 544 "../src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 545 "../src/Photo.vala"
	_tmp0_ = *id;
#line 545 "../src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 545 "../src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 546 "../src/Photo.vala"
		result = NULL;
#line 546 "../src/Photo.vala"
		return result;
#line 5718 "Photo.c"
	}
#line 548 "../src/Photo.vala"
	backing_row = NULL;
#line 5722 "Photo.c"
	{
		BackingPhotoRow* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		BackingPhotoID _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
		BackingPhotoRow* _tmp8_;
#line 550 "../src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 550 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 550 "../src/Photo.vala"
		_tmp5_ = *id;
#line 550 "../src/Photo.vala"
		_tmp6_ = backing_photo_table_fetch (_tmp4_, &_tmp5_, &_inner_error0_);
#line 550 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 550 "../src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 550 "../src/Photo.vala"
		_tmp2_ = _tmp7_;
#line 550 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5749 "Photo.c"
				goto __catch267_database_error;
			}
#line 550 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 550 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 550 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 550 "../src/Photo.vala"
			return NULL;
#line 5760 "Photo.c"
		}
#line 550 "../src/Photo.vala"
		_tmp8_ = _tmp2_;
#line 550 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 550 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 550 "../src/Photo.vala"
		backing_row = _tmp8_;
#line 549 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp2_);
#line 5772 "Photo.c"
	}
	goto __finally267;
	__catch267_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 549 "../src/Photo.vala"
		err = _inner_error0_;
#line 549 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 552 "../src/Photo.vala"
		_tmp9_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 552 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 552 "../src/Photo.vala"
		_tmp11_ = err;
#line 552 "../src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 552 "../src/Photo.vala"
		g_warning ("Photo.vala:552: Unable to fetch backing state for %s: %s", _tmp10_, _tmp12_);
#line 552 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 549 "../src/Photo.vala"
		_g_error_free0 (err);
#line 5800 "Photo.c"
	}
	__finally267:
#line 549 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 549 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 549 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 549 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 549 "../src/Photo.vala"
		return NULL;
#line 5813 "Photo.c"
	}
#line 555 "../src/Photo.vala"
	_tmp13_ = backing_row;
#line 555 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 5819 "Photo.c"
		{
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoID _tmp16_;
#line 557 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 557 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 557 "../src/Photo.vala"
			_tmp16_ = *id;
#line 557 "../src/Photo.vala"
			backing_photo_table_remove (_tmp15_, &_tmp16_, &_inner_error0_);
#line 557 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 557 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5838 "Photo.c"
					goto __catch268_database_error;
				}
#line 557 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 557 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 557 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 557 "../src/Photo.vala"
				return NULL;
#line 5849 "Photo.c"
			}
		}
		goto __finally268;
		__catch268_database_error:
		{
			GError* err = NULL;
#line 556 "../src/Photo.vala"
			err = _inner_error0_;
#line 556 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 556 "../src/Photo.vala"
			_g_error_free0 (err);
#line 5862 "Photo.c"
		}
		__finally268:
#line 556 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 556 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 556 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 556 "../src/Photo.vala"
			return NULL;
#line 5875 "Photo.c"
		}
#line 561 "../src/Photo.vala"
		result = NULL;
#line 561 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 561 "../src/Photo.vala"
		return result;
#line 5883 "Photo.c"
	}
#line 564 "../src/Photo.vala"
	result = backing_row;
#line 564 "../src/Photo.vala"
	return result;
#line 5889 "Photo.c"
}


gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 569 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 5901 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 570 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 570 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5909 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 571 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 571 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 5917 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 572 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 572 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 572 "../src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 572 "../src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 572 "../src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 572 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 5934 "Photo.c"
			} else {
#line 571 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 5938 "Photo.c"
			}
#line 571 "../src/Photo.vala"
			result = _tmp1_;
#line 5942 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 570 "../src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 570 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5949 "Photo.c"
			}
#line 571 "../src/Photo.vala"
			return result;
#line 5953 "Photo.c"
		}
		__finally269:
		{
			GeeHashMap* _tmp8_;
#line 570 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 570 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5962 "Photo.c"
		}
#line 570 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 570 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 570 "../src/Photo.vala"
		return _tmp9_;
#line 5970 "Photo.c"
	}
}


gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 577 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 5983 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 578 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 578 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5990 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 579 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 579 "../src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 580 "../src/Photo.vala"
				result = TRUE;
#line 5999 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 578 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 578 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6006 "Photo.c"
				}
#line 580 "../src/Photo.vala"
				return result;
#line 6010 "Photo.c"
			}
		}
		__finally270:
		{
			GeeHashMap* _tmp3_;
#line 578 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 578 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6020 "Photo.c"
		}
#line 578 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6024 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 578 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 578 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 578 "../src/Photo.vala"
			return _tmp4_;
#line 6032 "Photo.c"
		}
	}
#line 583 "../src/Photo.vala"
	switch (d) {
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6039 "Photo.c"
		{
#line 585 "../src/Photo.vala"
			result = TRUE;
#line 585 "../src/Photo.vala"
			return result;
#line 6045 "Photo.c"
		}
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6049 "Photo.c"
		{
#line 588 "../src/Photo.vala"
			result = FALSE;
#line 588 "../src/Photo.vala"
			return result;
#line 6055 "Photo.c"
		}
#line 583 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6059 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
				guint _tmp7_;
#line 592 "../src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 592 "../src/Photo.vala"
				meta = _tmp5_;
#line 592 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6073 "Photo.c"
					goto __catch271_g_error;
				}
#line 593 "../src/Photo.vala"
				_tmp6_ = meta;
#line 593 "../src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 595 "../src/Photo.vala"
				_tmp7_ = num_previews;
#line 595 "../src/Photo.vala"
				if (_tmp7_ > ((guint) 0)) {
#line 6084 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp8_;
					guint _tmp9_;
					PhotoPreview* _tmp10_;
					PhotoPreview* _tmp11_;
					Dimensions dims = {0};
					PhotoPreview* _tmp12_;
					Dimensions _tmp13_ = {0};
					gint _tmp14_ = 0;
					Dimensions _tmp15_;
					gint _tmp16_;
					Dimensions _tmp17_;
					gint _tmp18_;
					gint preview_major_axis = 0;
					gint _tmp23_;
#line 596 "../src/Photo.vala"
					_tmp8_ = meta;
#line 596 "../src/Photo.vala"
					_tmp9_ = num_previews;
#line 596 "../src/Photo.vala"
					_tmp10_ = photo_metadata_get_preview (_tmp8_, _tmp9_ - 1);
#line 596 "../src/Photo.vala"
					prev = _tmp10_;
#line 599 "../src/Photo.vala"
					_tmp11_ = prev;
#line 599 "../src/Photo.vala"
					if (_tmp11_ == NULL) {
#line 600 "../src/Photo.vala"
						result = FALSE;
#line 600 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 600 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 600 "../src/Photo.vala"
						return result;
#line 6120 "Photo.c"
					}
#line 602 "../src/Photo.vala"
					_tmp12_ = prev;
#line 602 "../src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp12_, &_tmp13_);
#line 602 "../src/Photo.vala"
					dims = _tmp13_;
#line 605 "../src/Photo.vala"
					_tmp15_ = dims;
#line 605 "../src/Photo.vala"
					_tmp16_ = _tmp15_.width;
#line 605 "../src/Photo.vala"
					_tmp17_ = dims;
#line 605 "../src/Photo.vala"
					_tmp18_ = _tmp17_.height;
#line 605 "../src/Photo.vala"
					if (_tmp16_ > _tmp18_) {
#line 6138 "Photo.c"
						Dimensions _tmp19_;
						gint _tmp20_;
#line 605 "../src/Photo.vala"
						_tmp19_ = dims;
#line 605 "../src/Photo.vala"
						_tmp20_ = _tmp19_.width;
#line 605 "../src/Photo.vala"
						_tmp14_ = _tmp20_;
#line 6147 "Photo.c"
					} else {
						Dimensions _tmp21_;
						gint _tmp22_;
#line 605 "../src/Photo.vala"
						_tmp21_ = dims;
#line 605 "../src/Photo.vala"
						_tmp22_ = _tmp21_.height;
#line 605 "../src/Photo.vala"
						_tmp14_ = _tmp22_;
#line 6157 "Photo.c"
					}
#line 605 "../src/Photo.vala"
					preview_major_axis = _tmp14_;
#line 606 "../src/Photo.vala"
					_tmp23_ = preview_major_axis;
#line 606 "../src/Photo.vala"
					if (_tmp23_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 607 "../src/Photo.vala"
						result = FALSE;
#line 607 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 607 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 607 "../src/Photo.vala"
						return result;
#line 6173 "Photo.c"
					}
#line 610 "../src/Photo.vala"
					result = TRUE;
#line 610 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 610 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 610 "../src/Photo.vala"
					return result;
#line 6183 "Photo.c"
				}
#line 614 "../src/Photo.vala"
				result = FALSE;
#line 614 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 614 "../src/Photo.vala"
				return result;
#line 6191 "Photo.c"
			}
			goto __finally271;
			__catch271_g_error:
			{
				GError* e = NULL;
				GError* _tmp24_;
				const gchar* _tmp25_;
#line 591 "../src/Photo.vala"
				e = _inner_error0_;
#line 591 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 616 "../src/Photo.vala"
				_tmp24_ = e;
#line 616 "../src/Photo.vala"
				_tmp25_ = _tmp24_->message;
#line 616 "../src/Photo.vala"
				g_debug ("Photo.vala:616: Error accessing embedded preview. Message: %s", _tmp25_);
#line 591 "../src/Photo.vala"
				_g_error_free0 (e);
#line 6211 "Photo.c"
			}
			__finally271:
#line 591 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6216 "Photo.c"
				gboolean _tmp26_ = FALSE;
#line 591 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 591 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 591 "../src/Photo.vala"
				return _tmp26_;
#line 6224 "Photo.c"
			}
#line 618 "../src/Photo.vala"
			result = FALSE;
#line 618 "../src/Photo.vala"
			return result;
#line 6230 "Photo.c"
		}
		default:
		{
#line 621 "../src/Photo.vala"
			g_assert_not_reached ();
#line 6236 "Photo.c"
		}
	}
}


void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         gboolean notify,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 628 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 628 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 629 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 629 "../src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 629 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 629 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 629 "../src/Photo.vala"
		return;
#line 6265 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 630 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 630 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6273 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 631 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 631 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), bpr);
#line 6280 "Photo.c"
		}
		__finally272:
		{
			GeeHashMap* _tmp3_;
#line 630 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 630 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6289 "Photo.c"
		}
#line 630 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 630 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 630 "../src/Photo.vala"
			return;
#line 6297 "Photo.c"
		}
	}
#line 634 "../src/Photo.vala"
	if (notify) {
#line 6302 "Photo.c"
		Alteration* _tmp4_;
		Alteration* _tmp5_;
#line 635 "../src/Photo.vala"
		_tmp4_ = alteration_new ("image", "developer");
#line 635 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 635 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp5_);
#line 635 "../src/Photo.vala"
		_alteration_unref0 (_tmp5_);
#line 6313 "Photo.c"
	}
}


void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp4_;
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp6_;
	PhotoFileInterrogator* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	gboolean _tmp11_ = FALSE;
	DetectedPhotoInformation* _tmp12_;
	DetectedPhotoInformation* _tmp14_;
	Dimensions _tmp15_;
	GFileInfo* _tmp16_;
	GTimeVal _tmp17_;
	glong _tmp18_;
	Orientation _tmp19_ = 0;
	DetectedPhotoInformation* _tmp20_;
	PhotoMetadata* _tmp21_;
	BackingPhotoTable* _tmp24_;
	BackingPhotoTable* _tmp25_;
	PhotoTable* _tmp26_;
	PhotoTable* _tmp27_;
	BackingPhotoID _tmp28_;
	GError* _inner_error0_ = NULL;
#line 638 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 638 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 640 "../src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 640 "../src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 640 "../src/Photo.vala"
	file = _tmp1_;
#line 641 "../src/Photo.vala"
	_tmp2_ = file;
#line 641 "../src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 641 "../src/Photo.vala"
	info = _tmp3_;
#line 641 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 641 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 641 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 641 "../src/Photo.vala"
		return;
#line 6380 "Photo.c"
	}
#line 643 "../src/Photo.vala"
	_tmp4_ = info;
#line 643 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp4_, &_tmp5_);
#line 643 "../src/Photo.vala"
	timestamp = _tmp5_;
#line 645 "../src/Photo.vala"
	_tmp6_ = file;
#line 645 "../src/Photo.vala"
	_tmp7_ = photo_file_interrogator_new (_tmp6_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 645 "../src/Photo.vala"
	interrogator = _tmp7_;
#line 647 "../src/Photo.vala"
	_tmp8_ = interrogator;
#line 647 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp8_, &_inner_error0_);
#line 647 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 647 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 647 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 647 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 647 "../src/Photo.vala"
		return;
#line 6410 "Photo.c"
	}
#line 649 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 649 "../src/Photo.vala"
	_tmp10_ = photo_file_interrogator_get_detected_photo_information (_tmp9_);
#line 649 "../src/Photo.vala"
	detected = _tmp10_;
#line 650 "../src/Photo.vala"
	_tmp12_ = detected;
#line 650 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 650 "../src/Photo.vala"
		_tmp11_ = TRUE;
#line 6424 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp13_;
#line 650 "../src/Photo.vala"
		_tmp13_ = interrogator;
#line 650 "../src/Photo.vala"
		_tmp11_ = photo_file_interrogator_get_is_photo_corrupted (_tmp13_);
#line 6431 "Photo.c"
	}
#line 650 "../src/Photo.vala"
	if (_tmp11_) {
#line 653 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 653 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 653 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 653 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 653 "../src/Photo.vala"
		return;
#line 6445 "Photo.c"
	}
#line 656 "../src/Photo.vala"
	_tmp14_ = detected;
#line 656 "../src/Photo.vala"
	_tmp15_ = _tmp14_->image_dim;
#line 656 "../src/Photo.vala"
	bpr->dim = _tmp15_;
#line 657 "../src/Photo.vala"
	_tmp16_ = info;
#line 657 "../src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp16_);
#line 658 "../src/Photo.vala"
	_tmp17_ = timestamp;
#line 658 "../src/Photo.vala"
	_tmp18_ = _tmp17_.tv_sec;
#line 658 "../src/Photo.vala"
	bpr->timestamp = (time_t) _tmp18_;
#line 659 "../src/Photo.vala"
	_tmp20_ = detected;
#line 659 "../src/Photo.vala"
	_tmp21_ = _tmp20_->metadata;
#line 659 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 6469 "Photo.c"
		DetectedPhotoInformation* _tmp22_;
		PhotoMetadata* _tmp23_;
#line 659 "../src/Photo.vala"
		_tmp22_ = detected;
#line 659 "../src/Photo.vala"
		_tmp23_ = _tmp22_->metadata;
#line 659 "../src/Photo.vala"
		_tmp19_ = photo_metadata_get_orientation (_tmp23_);
#line 6478 "Photo.c"
	} else {
#line 660 "../src/Photo.vala"
		_tmp19_ = ORIENTATION_TOP_LEFT;
#line 6482 "Photo.c"
	}
#line 659 "../src/Photo.vala"
	bpr->original_orientation = _tmp19_;
#line 663 "../src/Photo.vala"
	_tmp24_ = backing_photo_table_get_instance ();
#line 663 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 663 "../src/Photo.vala"
	backing_photo_table_add (_tmp25_, bpr, &_inner_error0_);
#line 663 "../src/Photo.vala"
	_database_table_unref0 (_tmp25_);
#line 663 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 663 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 663 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 663 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 663 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 663 "../src/Photo.vala"
		return;
#line 6508 "Photo.c"
	}
#line 664 "../src/Photo.vala"
	_tmp26_ = photo_table_get_instance ();
#line 664 "../src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 664 "../src/Photo.vala"
	_tmp28_ = bpr->id;
#line 664 "../src/Photo.vala"
	photo_table_update_raw_development (_tmp27_, row, d, &_tmp28_, &_inner_error0_);
#line 664 "../src/Photo.vala"
	_database_table_unref0 (_tmp27_);
#line 664 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 664 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 664 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 664 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 664 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 664 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 664 "../src/Photo.vala"
		return;
#line 6534 "Photo.c"
	}
#line 638 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 638 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 638 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 638 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 6544 "Photo.c"
}


static void
photo_develop_photo (Photo* self,
                     RawDeveloper d,
                     gboolean notify)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 669 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 670 "../src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 671 "../src/Photo.vala"
	bps = NULL;
#line 673 "../src/Photo.vala"
	switch (d) {
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6566 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp12_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp17_;
				const gchar* _tmp18_;
				PhotoFileWriter* _tmp19_;
				PhotoFileWriter* _tmp20_;
				GdkPixbuf* _tmp21_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp22_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp23_;
				const gchar* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_;
				PhotoMetadata* _tmp27_;
#line 677 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 677 "../src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 677 "../src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 677 "../src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 677 "../src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 677 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6603 "Photo.c"
					goto __catch273_g_error;
				}
#line 677 "../src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 677 "../src/Photo.vala"
				_tmp0_ = NULL;
#line 677 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 677 "../src/Photo.vala"
				bps = _tmp5_;
#line 678 "../src/Photo.vala"
				pix = NULL;
#line 6616 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 679 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 679 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6623 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 684 "../src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 684 "../src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 684 "../src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 684 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6637 "Photo.c"
							goto __finally274;
						}
#line 684 "../src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 684 "../src/Photo.vala"
						_tmp7_ = NULL;
#line 684 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 684 "../src/Photo.vala"
						pix = _tmp10_;
#line 679 "../src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6650 "Photo.c"
					}
					__finally274:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp11_;
#line 679 "../src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 679 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6660 "Photo.c"
					}
#line 679 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 679 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 679 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6668 "Photo.c"
						goto __catch273_g_error;
					}
				}
#line 687 "../src/Photo.vala"
				_tmp12_ = pix;
#line 687 "../src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 688 "../src/Photo.vala"
					g_debug ("Photo.vala:688: Could not get preview pixbuf");
#line 689 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 689 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6682 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp13_;
#line 713 "../src/Photo.vala"
						_tmp13_ = wrote_img_to_disk;
#line 713 "../src/Photo.vala"
						if (_tmp13_) {
#line 6690 "Photo.c"
							{
								BackingPhotoRow* _tmp14_;
#line 716 "../src/Photo.vala"
								_tmp14_ = bps;
#line 716 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp14_, notify, &_inner_error0_);
#line 716 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6699 "Photo.c"
									goto __catch275_g_error;
								}
#line 718 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6704 "Photo.c"
							}
							goto __finally275;
							__catch275_g_error:
							{
								GError* e = NULL;
								GError* _tmp15_;
								const gchar* _tmp16_;
#line 714 "../src/Photo.vala"
								e = _inner_error0_;
#line 714 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 720 "../src/Photo.vala"
								_tmp15_ = e;
#line 720 "../src/Photo.vala"
								_tmp16_ = _tmp15_->message;
#line 720 "../src/Photo.vala"
								g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp16_);
#line 714 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6724 "Photo.c"
							}
							__finally275:
#line 714 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6729 "Photo.c"
								goto __catch273_g_error;
							}
						}
					}
#line 689 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 689 "../src/Photo.vala"
					return;
#line 6738 "Photo.c"
				}
#line 693 "../src/Photo.vala"
				_tmp17_ = bps;
#line 693 "../src/Photo.vala"
				_tmp18_ = _tmp17_->filepath;
#line 693 "../src/Photo.vala"
				_tmp19_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp18_, &_inner_error0_);
#line 693 "../src/Photo.vala"
				writer = _tmp19_;
#line 693 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 693 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 693 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6754 "Photo.c"
					goto __catch273_g_error;
				}
#line 694 "../src/Photo.vala"
				_tmp20_ = writer;
#line 694 "../src/Photo.vala"
				_tmp21_ = pix;
#line 694 "../src/Photo.vala"
				photo_file_writer_write (_tmp20_, _tmp21_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 694 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 694 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 694 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 694 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6771 "Photo.c"
					goto __catch273_g_error;
				}
#line 702 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 707 "../src/Photo.vala"
				_tmp22_ = photo_get_master_metadata (self, &_inner_error0_);
#line 707 "../src/Photo.vala"
				meta = _tmp22_;
#line 707 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 707 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 707 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6788 "Photo.c"
					goto __catch273_g_error;
				}
#line 708 "../src/Photo.vala"
				_tmp23_ = bps;
#line 708 "../src/Photo.vala"
				_tmp24_ = _tmp23_->filepath;
#line 708 "../src/Photo.vala"
				_tmp25_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp24_, &_inner_error0_);
#line 708 "../src/Photo.vala"
				mwriter = _tmp25_;
#line 708 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 708 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 708 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 708 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 708 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6809 "Photo.c"
					goto __catch273_g_error;
				}
#line 709 "../src/Photo.vala"
				_tmp26_ = mwriter;
#line 709 "../src/Photo.vala"
				_tmp27_ = meta;
#line 709 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp26_, _tmp27_, &_inner_error0_);
#line 709 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 709 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 709 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 709 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 709 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6830 "Photo.c"
					goto __catch273_g_error;
				}
#line 675 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 675 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 675 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 675 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 675 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 6843 "Photo.c"
			}
			goto __finally273;
			__catch273_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 675 "../src/Photo.vala"
				err = _inner_error0_;
#line 675 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 711 "../src/Photo.vala"
				_tmp28_ = err;
#line 711 "../src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 711 "../src/Photo.vala"
				g_debug ("Photo.vala:711: Error developing photo: %s", _tmp29_);
#line 675 "../src/Photo.vala"
				_g_error_free0 (err);
#line 6863 "Photo.c"
			}
			__finally273:
			{
				GError* _inner_error1_ = NULL;
				gboolean _tmp30_;
#line 713 "../src/Photo.vala"
				_tmp30_ = wrote_img_to_disk;
#line 713 "../src/Photo.vala"
				if (_tmp30_) {
#line 6873 "Photo.c"
					{
						BackingPhotoRow* _tmp31_;
#line 716 "../src/Photo.vala"
						_tmp31_ = bps;
#line 716 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp31_, notify, &_inner_error1_);
#line 716 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 6882 "Photo.c"
							goto __catch276_g_error;
						}
#line 718 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6887 "Photo.c"
					}
					goto __finally276;
					__catch276_g_error:
					{
						GError* e = NULL;
						GError* _tmp32_;
						const gchar* _tmp33_;
#line 714 "../src/Photo.vala"
						e = _inner_error1_;
#line 714 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 720 "../src/Photo.vala"
						_tmp32_ = e;
#line 720 "../src/Photo.vala"
						_tmp33_ = _tmp32_->message;
#line 720 "../src/Photo.vala"
						g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp33_);
#line 714 "../src/Photo.vala"
						_g_error_free0 (e);
#line 6907 "Photo.c"
					}
					__finally276:
#line 714 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 714 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 714 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 714 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 714 "../src/Photo.vala"
						return;
#line 6920 "Photo.c"
					}
				}
			}
#line 675 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 675 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 675 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 675 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 675 "../src/Photo.vala"
				return;
#line 6934 "Photo.c"
			}
#line 726 "../src/Photo.vala"
			break;
#line 6938 "Photo.c"
		}
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6942 "Photo.c"
		{
#line 730 "../src/Photo.vala"
			break;
#line 6946 "Photo.c"
		}
#line 673 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6950 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp34_;
				guint c = 0U;
				PhotoMetadata* _tmp35_;
				guint _tmp36_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp41_;
				guint _tmp42_;
				PhotoPreview* _tmp43_;
				PhotoPreview* _tmp44_;
				GBytes* pix = NULL;
				PhotoPreview* _tmp49_;
				GBytes* _tmp50_;
				GBytes* _tmp51_;
				BackingPhotoRow* _tmp56_ = NULL;
				PhotoRow* _tmp57_;
				BackingPhotoRow* _tmp58_;
				const gchar* _tmp59_;
				BackingPhotoRow* _tmp60_;
				BackingPhotoRow* _tmp61_;
				gboolean _tmp62_ = FALSE;
				GBytes* _tmp63_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp83_;
				const gchar* _tmp84_;
				PhotoFileMetadataWriter* _tmp85_;
				PhotoFileMetadataWriter* _tmp86_;
				PhotoMetadata* _tmp87_;
#line 735 "../src/Photo.vala"
				_tmp34_ = photo_get_master_metadata (self, &_inner_error0_);
#line 735 "../src/Photo.vala"
				meta = _tmp34_;
#line 735 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6987 "Photo.c"
					goto __catch277_g_error;
				}
#line 736 "../src/Photo.vala"
				_tmp35_ = meta;
#line 736 "../src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp35_);
#line 737 "../src/Photo.vala"
				_tmp36_ = c;
#line 737 "../src/Photo.vala"
				if (_tmp36_ <= ((guint) 0)) {
#line 738 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7000 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp37_;
#line 783 "../src/Photo.vala"
						_tmp37_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
						if (_tmp37_) {
#line 7008 "Photo.c"
							{
								BackingPhotoRow* _tmp38_;
#line 786 "../src/Photo.vala"
								_tmp38_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp38_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7017 "Photo.c"
									goto __catch278_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7022 "Photo.c"
							}
							goto __finally278;
							__catch278_g_error:
							{
								GError* e = NULL;
								GError* _tmp39_;
								const gchar* _tmp40_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp39_ = e;
#line 790 "../src/Photo.vala"
								_tmp40_ = _tmp39_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp40_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7042 "Photo.c"
							}
							__finally278:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7047 "Photo.c"
								goto __catch277_g_error;
							}
						}
					}
#line 738 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 738 "../src/Photo.vala"
					return;
#line 7056 "Photo.c"
				}
#line 739 "../src/Photo.vala"
				_tmp41_ = meta;
#line 739 "../src/Photo.vala"
				_tmp42_ = c;
#line 739 "../src/Photo.vala"
				_tmp43_ = photo_metadata_get_preview (_tmp41_, _tmp42_ - 1);
#line 739 "../src/Photo.vala"
				prev = _tmp43_;
#line 740 "../src/Photo.vala"
				_tmp44_ = prev;
#line 740 "../src/Photo.vala"
				if (_tmp44_ == NULL) {
#line 741 "../src/Photo.vala"
					g_debug ("Photo.vala:741: Could not get preview from metadata");
#line 742 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 742 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7076 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp45_;
#line 783 "../src/Photo.vala"
						_tmp45_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
						if (_tmp45_) {
#line 7084 "Photo.c"
							{
								BackingPhotoRow* _tmp46_;
#line 786 "../src/Photo.vala"
								_tmp46_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp46_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7093 "Photo.c"
									goto __catch279_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7098 "Photo.c"
							}
							goto __finally279;
							__catch279_g_error:
							{
								GError* e = NULL;
								GError* _tmp47_;
								const gchar* _tmp48_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp47_ = e;
#line 790 "../src/Photo.vala"
								_tmp48_ = _tmp47_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp48_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7118 "Photo.c"
							}
							__finally279:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7123 "Photo.c"
								goto __catch277_g_error;
							}
						}
					}
#line 742 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 742 "../src/Photo.vala"
					return;
#line 7132 "Photo.c"
				}
#line 745 "../src/Photo.vala"
				_tmp49_ = prev;
#line 745 "../src/Photo.vala"
				_tmp50_ = photo_preview_flatten (_tmp49_, &_inner_error0_);
#line 745 "../src/Photo.vala"
				pix = _tmp50_;
#line 745 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 745 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7146 "Photo.c"
					goto __catch277_g_error;
				}
#line 746 "../src/Photo.vala"
				_tmp51_ = pix;
#line 746 "../src/Photo.vala"
				if (_tmp51_ == NULL) {
#line 747 "../src/Photo.vala"
					g_debug ("Photo.vala:747: Could not get preview pixbuf");
#line 748 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 748 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 748 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7161 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp52_;
#line 783 "../src/Photo.vala"
						_tmp52_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
						if (_tmp52_) {
#line 7169 "Photo.c"
							{
								BackingPhotoRow* _tmp53_;
#line 786 "../src/Photo.vala"
								_tmp53_ = bps;
#line 786 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp53_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7178 "Photo.c"
									goto __catch280_g_error;
								}
#line 788 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7183 "Photo.c"
							}
							goto __finally280;
							__catch280_g_error:
							{
								GError* e = NULL;
								GError* _tmp54_;
								const gchar* _tmp55_;
#line 784 "../src/Photo.vala"
								e = _inner_error0_;
#line 784 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
								_tmp54_ = e;
#line 790 "../src/Photo.vala"
								_tmp55_ = _tmp54_->message;
#line 790 "../src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp55_);
#line 784 "../src/Photo.vala"
								_g_error_free0 (e);
#line 7203 "Photo.c"
							}
							__finally280:
#line 784 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7208 "Photo.c"
								goto __catch277_g_error;
							}
						}
					}
#line 748 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 748 "../src/Photo.vala"
					return;
#line 7217 "Photo.c"
				}
#line 752 "../src/Photo.vala"
				_tmp57_ = self->row;
#line 752 "../src/Photo.vala"
				_tmp58_ = _tmp57_->master;
#line 752 "../src/Photo.vala"
				_tmp59_ = _tmp58_->filepath;
#line 752 "../src/Photo.vala"
				_tmp60_ = raw_developer_create_backing_row_for_development (d, _tmp59_, NULL, &_inner_error0_);
#line 752 "../src/Photo.vala"
				_tmp56_ = _tmp60_;
#line 752 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 752 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 752 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 752 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7237 "Photo.c"
					goto __catch277_g_error;
				}
#line 752 "../src/Photo.vala"
				_tmp61_ = _tmp56_;
#line 752 "../src/Photo.vala"
				_tmp56_ = NULL;
#line 752 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 752 "../src/Photo.vala"
				bps = _tmp61_;
#line 756 "../src/Photo.vala"
				_tmp63_ = pix;
#line 756 "../src/Photo.vala"
				_tmp62_ = jpeg_is_jpeg_bytes (_tmp63_, &_inner_error0_);
#line 756 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 756 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 756 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 756 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7262 "Photo.c"
					goto __catch277_g_error;
				}
#line 756 "../src/Photo.vala"
				if (_tmp62_) {
#line 7267 "Photo.c"
					GFile* outfile = NULL;
					BackingPhotoRow* _tmp64_;
					const gchar* _tmp65_;
					GFile* _tmp66_;
					GFile* _tmp67_;
					GBytes* _tmp68_;
					gsize _tmp69_ = 0;
					guint8* _tmp70_;
#line 757 "../src/Photo.vala"
					_tmp64_ = bps;
#line 757 "../src/Photo.vala"
					_tmp65_ = _tmp64_->filepath;
#line 757 "../src/Photo.vala"
					_tmp66_ = g_file_new_for_path (_tmp65_);
#line 757 "../src/Photo.vala"
					outfile = _tmp66_;
#line 758 "../src/Photo.vala"
					_tmp67_ = outfile;
#line 758 "../src/Photo.vala"
					_tmp68_ = pix;
#line 758 "../src/Photo.vala"
					_tmp70_ = g_bytes_get_data (_tmp68_, &_tmp69_);
#line 758 "../src/Photo.vala"
					g_file_replace_contents (_tmp67_, _tmp70_, (gsize) _tmp69_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 758 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 758 "../src/Photo.vala"
						_g_object_unref0 (outfile);
#line 758 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 758 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 758 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 758 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7304 "Photo.c"
						goto __catch277_g_error;
					}
#line 756 "../src/Photo.vala"
					_g_object_unref0 (outfile);
#line 7309 "Photo.c"
				} else {
					GdkPixbuf* pixbuf = NULL;
					PhotoPreview* _tmp71_;
					GdkPixbuf* _tmp72_;
					GdkPixbuf* _tmp73_;
					PhotoFileWriter* writer = NULL;
					BackingPhotoRow* _tmp78_;
					const gchar* _tmp79_;
					PhotoFileWriter* _tmp80_;
					PhotoFileWriter* _tmp81_;
					GdkPixbuf* _tmp82_;
#line 761 "../src/Photo.vala"
					_tmp71_ = prev;
#line 761 "../src/Photo.vala"
					_tmp72_ = photo_preview_get_pixbuf (_tmp71_, &_inner_error0_);
#line 761 "../src/Photo.vala"
					pixbuf = _tmp72_;
#line 761 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 761 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 761 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 761 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7337 "Photo.c"
						goto __catch277_g_error;
					}
#line 762 "../src/Photo.vala"
					_tmp73_ = pixbuf;
#line 762 "../src/Photo.vala"
					if (_tmp73_ == NULL) {
#line 763 "../src/Photo.vala"
						g_debug ("Photo.vala:763: Could not get preview pixbuf");
#line 764 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 764 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 764 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 764 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 764 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7356 "Photo.c"
						{
							GError* _inner_error0_ = NULL;
							gboolean _tmp74_;
#line 783 "../src/Photo.vala"
							_tmp74_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
							if (_tmp74_) {
#line 7364 "Photo.c"
								{
									BackingPhotoRow* _tmp75_;
#line 786 "../src/Photo.vala"
									_tmp75_ = bps;
#line 786 "../src/Photo.vala"
									photo_add_backing_photo_for_development (self, d, _tmp75_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7373 "Photo.c"
										goto __catch281_g_error;
									}
#line 788 "../src/Photo.vala"
									photo_notify_raw_development_modified (self);
#line 7378 "Photo.c"
								}
								goto __finally281;
								__catch281_g_error:
								{
									GError* e = NULL;
									GError* _tmp76_;
									const gchar* _tmp77_;
#line 784 "../src/Photo.vala"
									e = _inner_error0_;
#line 784 "../src/Photo.vala"
									_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
									_tmp76_ = e;
#line 790 "../src/Photo.vala"
									_tmp77_ = _tmp76_->message;
#line 790 "../src/Photo.vala"
									g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp77_);
#line 784 "../src/Photo.vala"
									_g_error_free0 (e);
#line 7398 "Photo.c"
								}
								__finally281:
#line 784 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7403 "Photo.c"
									goto __catch277_g_error;
								}
							}
						}
#line 764 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 764 "../src/Photo.vala"
						return;
#line 7412 "Photo.c"
					}
#line 767 "../src/Photo.vala"
					_tmp78_ = bps;
#line 767 "../src/Photo.vala"
					_tmp79_ = _tmp78_->filepath;
#line 767 "../src/Photo.vala"
					_tmp80_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp79_, &_inner_error0_);
#line 767 "../src/Photo.vala"
					writer = _tmp80_;
#line 767 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 767 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 767 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 767 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 767 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 767 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7434 "Photo.c"
						goto __catch277_g_error;
					}
#line 768 "../src/Photo.vala"
					_tmp81_ = writer;
#line 768 "../src/Photo.vala"
					_tmp82_ = pixbuf;
#line 768 "../src/Photo.vala"
					photo_file_writer_write (_tmp81_, _tmp82_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 768 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "../src/Photo.vala"
						_photo_file_adapter_unref0 (writer);
#line 768 "../src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 768 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 768 "../src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 768 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 768 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7457 "Photo.c"
						goto __catch277_g_error;
					}
#line 756 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 756 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 7464 "Photo.c"
				}
#line 774 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 777 "../src/Photo.vala"
				_tmp83_ = bps;
#line 777 "../src/Photo.vala"
				_tmp84_ = _tmp83_->filepath;
#line 777 "../src/Photo.vala"
				_tmp85_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp84_, &_inner_error0_);
#line 777 "../src/Photo.vala"
				mwriter = _tmp85_;
#line 777 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 777 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 777 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 777 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 777 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7486 "Photo.c"
					goto __catch277_g_error;
				}
#line 778 "../src/Photo.vala"
				_tmp86_ = mwriter;
#line 778 "../src/Photo.vala"
				_tmp87_ = meta;
#line 778 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp86_, _tmp87_, &_inner_error0_);
#line 778 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 778 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 778 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 778 "../src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 778 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 778 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7507 "Photo.c"
					goto __catch277_g_error;
				}
#line 733 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 733 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp56_);
#line 733 "../src/Photo.vala"
				_g_bytes_unref0 (pix);
#line 733 "../src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 733 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 7520 "Photo.c"
			}
			goto __finally277;
			__catch277_g_error:
			{
				GError* e = NULL;
				GError* _tmp88_;
				const gchar* _tmp89_;
#line 733 "../src/Photo.vala"
				e = _inner_error0_;
#line 733 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 780 "../src/Photo.vala"
				_tmp88_ = e;
#line 780 "../src/Photo.vala"
				_tmp89_ = _tmp88_->message;
#line 780 "../src/Photo.vala"
				g_debug ("Photo.vala:780: Error accessing embedded preview. Message: %s", _tmp89_);
#line 781 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7540 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
					gboolean _tmp90_;
#line 783 "../src/Photo.vala"
					_tmp90_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
					if (_tmp90_) {
#line 7548 "Photo.c"
						{
							BackingPhotoRow* _tmp91_;
#line 786 "../src/Photo.vala"
							_tmp91_ = bps;
#line 786 "../src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp91_, notify, &_inner_error0_);
#line 786 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7557 "Photo.c"
								goto __catch282_g_error;
							}
#line 788 "../src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 7562 "Photo.c"
						}
						goto __finally282;
						__catch282_g_error:
						{
							GError* e = NULL;
							GError* _tmp92_;
							const gchar* _tmp93_;
#line 784 "../src/Photo.vala"
							e = _inner_error0_;
#line 784 "../src/Photo.vala"
							_inner_error0_ = NULL;
#line 790 "../src/Photo.vala"
							_tmp92_ = e;
#line 790 "../src/Photo.vala"
							_tmp93_ = _tmp92_->message;
#line 790 "../src/Photo.vala"
							g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp93_);
#line 784 "../src/Photo.vala"
							_g_error_free0 (e);
#line 7582 "Photo.c"
						}
						__finally282:
#line 784 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 784 "../src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 7589 "Photo.c"
						}
					}
				}
#line 781 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 781 "../src/Photo.vala"
				return;
#line 7597 "Photo.c"
			}
			__finally277:
			{
				GError* _inner_error1_ = NULL;
				gboolean _tmp94_;
#line 783 "../src/Photo.vala"
				_tmp94_ = wrote_img_to_disk;
#line 783 "../src/Photo.vala"
				if (_tmp94_) {
#line 7607 "Photo.c"
					{
						BackingPhotoRow* _tmp95_;
#line 786 "../src/Photo.vala"
						_tmp95_ = bps;
#line 786 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp95_, notify, &_inner_error1_);
#line 786 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 7616 "Photo.c"
							goto __catch283_g_error;
						}
#line 788 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7621 "Photo.c"
					}
					goto __finally283;
					__catch283_g_error:
					{
						GError* e = NULL;
						GError* _tmp96_;
						const gchar* _tmp97_;
#line 784 "../src/Photo.vala"
						e = _inner_error1_;
#line 784 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 790 "../src/Photo.vala"
						_tmp96_ = e;
#line 790 "../src/Photo.vala"
						_tmp97_ = _tmp96_->message;
#line 790 "../src/Photo.vala"
						g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp97_);
#line 784 "../src/Photo.vala"
						_g_error_free0 (e);
#line 7641 "Photo.c"
					}
					__finally283:
#line 784 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 784 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 784 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 784 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 784 "../src/Photo.vala"
						return;
#line 7654 "Photo.c"
					}
				}
			}
#line 733 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 733 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 733 "../src/Photo.vala"
				return;
#line 7668 "Photo.c"
			}
#line 795 "../src/Photo.vala"
			break;
#line 7672 "Photo.c"
		}
		default:
		{
#line 798 "../src/Photo.vala"
			g_assert_not_reached ();
#line 7678 "Photo.c"
		}
	}
#line 669 "../src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 7683 "Photo.c"
}


void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 803 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 7694 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 804 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 804 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7701 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 805 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 805 "../src/Photo.vala"
			_tmp1_->developer = d;
#line 7708 "Photo.c"
		}
		__finally284:
		{
			PhotoRow* _tmp2_;
#line 804 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 804 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7717 "Photo.c"
		}
#line 804 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 804 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 804 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 804 "../src/Photo.vala"
			return;
#line 7727 "Photo.c"
		}
	}
}


void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d,
                         gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 810 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 811 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 812 "../src/Photo.vala"
		return;
#line 7747 "Photo.c"
	}
#line 817 "../src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 817 "../src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7753 "Photo.c"
	} else {
#line 817 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 7757 "Photo.c"
	}
#line 817 "../src/Photo.vala"
	if (_tmp0_) {
#line 818 "../src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7763 "Photo.c"
	}
#line 822 "../src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 822 "../src/Photo.vala"
		_tmp1_ = d != RAW_DEVELOPER_CAMERA;
#line 7769 "Photo.c"
	} else {
#line 822 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 7773 "Photo.c"
	}
#line 822 "../src/Photo.vala"
	if (_tmp1_) {
#line 823 "../src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7779 "Photo.c"
	}
	{
		GeeHashMap* _tmp2_;
#line 825 "../src/Photo.vala"
		_tmp2_ = self->priv->developments;
#line 825 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7787 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp3_;
			RawDeveloper _tmp4_;
			GeeHashMap* _tmp5_;
			PhotoRow* _tmp7_;
			GeeHashMap* _tmp8_;
			gpointer _tmp9_;
			PhotoBackingReaders* _tmp10_;
			BackingPhotoRow* _tmp11_;
			PhotoFileFormat _tmp12_;
			BackingPhotoRow* _tmp13_;
			const gchar* _tmp14_;
			PhotoFileReader* _tmp15_;
			BackingPhotoRow* _tmp20_;
			Orientation _tmp21_;
			gboolean _tmp30_ = FALSE;
			RawDeveloper _tmp31_;
#line 826 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 826 "../src/Photo.vala"
			_tmp4_ = _tmp3_->developer;
#line 826 "../src/Photo.vala"
			stale_raw_developer = _tmp4_;
#line 829 "../src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 830 "../src/Photo.vala"
				photo_develop_photo (self, d, notify);
#line 7816 "Photo.c"
			}
#line 832 "../src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 832 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 7822 "Photo.c"
				{
					GeeHashMap* _tmp6_;
#line 825 "../src/Photo.vala"
					_tmp6_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7829 "Photo.c"
				}
#line 833 "../src/Photo.vala"
				return;
#line 7833 "Photo.c"
			}
#line 836 "../src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 839 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 839 "../src/Photo.vala"
			_tmp7_->developer = d;
#line 840 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 840 "../src/Photo.vala"
			_tmp9_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 840 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 840 "../src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp9_;
#line 841 "../src/Photo.vala"
			_tmp10_ = self->priv->readers;
#line 841 "../src/Photo.vala"
			_tmp11_ = self->backing_photo_row;
#line 841 "../src/Photo.vala"
			_tmp12_ = _tmp11_->file_format;
#line 841 "../src/Photo.vala"
			_tmp13_ = self->backing_photo_row;
#line 841 "../src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 841 "../src/Photo.vala"
			_tmp15_ = photo_file_format_create_reader (_tmp12_, _tmp14_);
#line 841 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_->developer);
#line 841 "../src/Photo.vala"
			_tmp10_->developer = _tmp15_;
#line 7865 "Photo.c"
			{
				GdkPixbuf* _tmp16_;
				GdkPixbuf* _tmp17_;
#line 844 "../src/Photo.vala"
				_tmp16_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 844 "../src/Photo.vala"
				_tmp17_ = _tmp16_;
#line 844 "../src/Photo.vala"
				_g_object_unref0 (_tmp17_);
#line 844 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7877 "Photo.c"
					goto __catch286_g_error;
				}
			}
			goto __finally286;
			__catch286_g_error:
			{
				GError* e = NULL;
#line 843 "../src/Photo.vala"
				e = _inner_error0_;
#line 843 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 847 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7891 "Photo.c"
				{
					GeeHashMap* _tmp18_;
#line 825 "../src/Photo.vala"
					_tmp18_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7898 "Photo.c"
				}
#line 847 "../src/Photo.vala"
				return;
#line 7902 "Photo.c"
			}
			__finally286:
#line 843 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7907 "Photo.c"
				{
					GeeHashMap* _tmp19_;
#line 825 "../src/Photo.vala"
					_tmp19_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7914 "Photo.c"
				}
#line 843 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 843 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 843 "../src/Photo.vala"
				return;
#line 7922 "Photo.c"
			}
#line 850 "../src/Photo.vala"
			_tmp20_ = self->backing_photo_row;
#line 850 "../src/Photo.vala"
			_tmp21_ = _tmp20_->original_orientation;
#line 850 "../src/Photo.vala"
			photo_set_orientation (self, _tmp21_);
#line 7930 "Photo.c"
			{
				PhotoTable* _tmp22_;
				PhotoTable* _tmp23_;
				PhotoRow* _tmp24_;
				BackingPhotoRow* _tmp25_;
				BackingPhotoID _tmp26_;
#line 853 "../src/Photo.vala"
				_tmp22_ = photo_table_get_instance ();
#line 853 "../src/Photo.vala"
				_tmp23_ = _tmp22_;
#line 853 "../src/Photo.vala"
				_tmp24_ = self->row;
#line 853 "../src/Photo.vala"
				_tmp25_ = self->backing_photo_row;
#line 853 "../src/Photo.vala"
				_tmp26_ = _tmp25_->id;
#line 853 "../src/Photo.vala"
				photo_table_update_raw_development (_tmp23_, _tmp24_, d, &_tmp26_, &_inner_error0_);
#line 853 "../src/Photo.vala"
				_database_table_unref0 (_tmp23_);
#line 853 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7953 "Photo.c"
					goto __catch287_g_error;
				}
			}
			goto __finally287;
			__catch287_g_error:
			{
				GError* e = NULL;
				GError* _tmp27_;
				const gchar* _tmp28_;
#line 852 "../src/Photo.vala"
				e = _inner_error0_;
#line 852 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 855 "../src/Photo.vala"
				_tmp27_ = e;
#line 855 "../src/Photo.vala"
				_tmp28_ = _tmp27_->message;
#line 855 "../src/Photo.vala"
				g_warning ("Photo.vala:855: Error updating database: %s", _tmp28_);
#line 852 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7975 "Photo.c"
			}
			__finally287:
#line 852 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7980 "Photo.c"
				{
					GeeHashMap* _tmp29_;
#line 825 "../src/Photo.vala"
					_tmp29_ = self->priv->developments;
#line 825 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7987 "Photo.c"
				}
#line 852 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 852 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 852 "../src/Photo.vala"
				return;
#line 7995 "Photo.c"
			}
#line 862 "../src/Photo.vala"
			_tmp31_ = stale_raw_developer;
#line 862 "../src/Photo.vala"
			if (_tmp31_ != RAW_DEVELOPER_CAMERA) {
#line 8001 "Photo.c"
				RawDeveloper _tmp32_;
				PhotoRow* _tmp33_;
				RawDeveloper _tmp34_;
#line 863 "../src/Photo.vala"
				_tmp32_ = stale_raw_developer;
#line 863 "../src/Photo.vala"
				_tmp33_ = self->row;
#line 863 "../src/Photo.vala"
				_tmp34_ = _tmp33_->developer;
#line 863 "../src/Photo.vala"
				_tmp30_ = _tmp32_ != _tmp34_;
#line 8013 "Photo.c"
			} else {
#line 862 "../src/Photo.vala"
				_tmp30_ = FALSE;
#line 8017 "Photo.c"
			}
#line 862 "../src/Photo.vala"
			if (_tmp30_) {
#line 8021 "Photo.c"
				RawDeveloper _tmp35_;
#line 866 "../src/Photo.vala"
				_tmp35_ = stale_raw_developer;
#line 866 "../src/Photo.vala"
				photo_delete_raw_development (self, _tmp35_);
#line 8027 "Photo.c"
			}
		}
		__finally285:
		{
			GeeHashMap* _tmp36_;
#line 825 "../src/Photo.vala"
			_tmp36_ = self->priv->developments;
#line 825 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8037 "Photo.c"
		}
#line 825 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 825 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 825 "../src/Photo.vala"
			return;
#line 8047 "Photo.c"
		}
	}
#line 873 "../src/Photo.vala"
	if (notify) {
#line 8052 "Photo.c"
		Alteration* _tmp37_;
		Alteration* _tmp38_;
#line 874 "../src/Photo.vala"
		_tmp37_ = alteration_new ("image", "developer");
#line 874 "../src/Photo.vala"
		_tmp38_ = _tmp37_;
#line 874 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp38_);
#line 874 "../src/Photo.vala"
		_alteration_unref0 (_tmp38_);
#line 8063 "Photo.c"
	}
#line 875 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 8067 "Photo.c"
}


RawDeveloper
photo_get_raw_developer (Photo* self)
{
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 878 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 879 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 879 "../src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 879 "../src/Photo.vala"
	result = _tmp1_;
#line 879 "../src/Photo.vala"
	return result;
#line 8087 "Photo.c"
}


static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
#line 884 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 885 "../src/Photo.vala"
	ret = FALSE;
#line 8102 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 887 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 887 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8109 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp33_;
#line 888 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 888 "../src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 889 "../src/Photo.vala"
				result = FALSE;
#line 8128 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 887 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 887 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8135 "Photo.c"
				}
#line 889 "../src/Photo.vala"
				return result;
#line 8139 "Photo.c"
			}
#line 893 "../src/Photo.vala"
			_tmp3_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 893 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 893 "../src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 893 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 893 "../src/Photo.vala"
			g_debug ("Photo.vala:893: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 893 "../src/Photo.vala"
			_g_free0 (_tmp6_);
#line 893 "../src/Photo.vala"
			_g_free0 (_tmp4_);
#line 894 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 894 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 894 "../src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 895 "../src/Photo.vala"
			_tmp9_ = bpr;
#line 895 "../src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 895 "../src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 8167 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 896 "../src/Photo.vala"
				_tmp11_ = bpr;
#line 896 "../src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 896 "../src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 896 "../src/Photo.vala"
				f = _tmp13_;
#line 8180 "Photo.c"
				{
#line 898 "../src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 8184 "Photo.c"
						GFile* _tmp14_;
#line 899 "../src/Photo.vala"
						_tmp14_ = f;
#line 899 "../src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 899 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8192 "Photo.c"
							goto __catch289_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 901 "../src/Photo.vala"
						_tmp15_ = f;
#line 901 "../src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 901 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8203 "Photo.c"
							goto __catch289_g_error;
						}
					}
				}
				goto __finally289;
				__catch289_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 897 "../src/Photo.vala"
					e = _inner_error0_;
#line 897 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 903 "../src/Photo.vala"
					_tmp16_ = bpr;
#line 903 "../src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 903 "../src/Photo.vala"
					_tmp18_ = e;
#line 903 "../src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 903 "../src/Photo.vala"
					g_warning ("Photo.vala:903: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 897 "../src/Photo.vala"
					_g_error_free0 (e);
#line 8232 "Photo.c"
				}
				__finally289:
#line 897 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8237 "Photo.c"
					gboolean _tmp21_ = FALSE;
#line 897 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 897 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 897 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 897 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 8247 "Photo.c"
					{
						GeeHashMap* _tmp20_;
#line 887 "../src/Photo.vala"
						_tmp20_ = self->priv->developments;
#line 887 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8254 "Photo.c"
					}
#line 897 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 897 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 897 "../src/Photo.vala"
					return _tmp21_;
#line 8262 "Photo.c"
				}
#line 895 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 8266 "Photo.c"
			}
			{
				PhotoTable* _tmp22_;
				PhotoTable* _tmp23_;
				PhotoRow* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoTable* _tmp26_;
				BackingPhotoRow* _tmp27_;
				BackingPhotoID _tmp28_;
#line 909 "../src/Photo.vala"
				_tmp22_ = photo_table_get_instance ();
#line 909 "../src/Photo.vala"
				_tmp23_ = _tmp22_;
#line 909 "../src/Photo.vala"
				_tmp24_ = self->row;
#line 909 "../src/Photo.vala"
				photo_table_remove_development (_tmp23_, _tmp24_, d, &_inner_error0_);
#line 909 "../src/Photo.vala"
				_database_table_unref0 (_tmp23_);
#line 909 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8288 "Photo.c"
					goto __catch290_g_error;
				}
#line 910 "../src/Photo.vala"
				_tmp25_ = backing_photo_table_get_instance ();
#line 910 "../src/Photo.vala"
				_tmp26_ = _tmp25_;
#line 910 "../src/Photo.vala"
				_tmp27_ = bpr;
#line 910 "../src/Photo.vala"
				_tmp28_ = _tmp27_->id;
#line 910 "../src/Photo.vala"
				backing_photo_table_remove (_tmp26_, &_tmp28_, &_inner_error0_);
#line 910 "../src/Photo.vala"
				_database_table_unref0 (_tmp26_);
#line 910 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8305 "Photo.c"
					goto __catch290_g_error;
				}
			}
			goto __finally290;
			__catch290_g_error:
			{
				GError* e = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 908 "../src/Photo.vala"
				e = _inner_error0_;
#line 908 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 912 "../src/Photo.vala"
				_tmp29_ = e;
#line 912 "../src/Photo.vala"
				_tmp30_ = _tmp29_->message;
#line 912 "../src/Photo.vala"
				g_warning ("Photo.vala:912: Database error while deleting RAW development: %s", _tmp30_);
#line 908 "../src/Photo.vala"
				_g_error_free0 (e);
#line 8327 "Photo.c"
			}
			__finally290:
#line 908 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8332 "Photo.c"
				gboolean _tmp32_ = FALSE;
#line 908 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 908 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 8338 "Photo.c"
				{
					GeeHashMap* _tmp31_;
#line 887 "../src/Photo.vala"
					_tmp31_ = self->priv->developments;
#line 887 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8345 "Photo.c"
				}
#line 908 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 908 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 908 "../src/Photo.vala"
				return _tmp32_;
#line 8353 "Photo.c"
			}
#line 915 "../src/Photo.vala"
			_tmp33_ = self->priv->developments;
#line 915 "../src/Photo.vala"
			ret = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), NULL);
#line 887 "../src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 8361 "Photo.c"
		}
		__finally288:
		{
			GeeHashMap* _tmp34_;
#line 887 "../src/Photo.vala"
			_tmp34_ = self->priv->developments;
#line 887 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8370 "Photo.c"
		}
#line 887 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8374 "Photo.c"
			gboolean _tmp35_ = FALSE;
#line 887 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 887 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 887 "../src/Photo.vala"
			return _tmp35_;
#line 8382 "Photo.c"
		}
	}
#line 918 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 919 "../src/Photo.vala"
	result = ret;
#line 919 "../src/Photo.vala"
	return result;
#line 8391 "Photo.c"
}


void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 923 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 8402 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 924 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 924 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8409 "Photo.c"
		{
			RawDeveloper dev = 0;
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
#line 925 "../src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 926 "../src/Photo.vala"
			dev = d;
#line 927 "../src/Photo.vala"
			_tmp1_ = dev;
#line 927 "../src/Photo.vala"
			if (_tmp1_ == RAW_DEVELOPER_CAMERA) {
#line 928 "../src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 8424 "Photo.c"
			}
#line 930 "../src/Photo.vala"
			_tmp2_ = dev;
#line 930 "../src/Photo.vala"
			photo_set_raw_developer (self, _tmp2_, TRUE);
#line 8430 "Photo.c"
		}
		__finally291:
		{
			GeeHashMap* _tmp3_;
#line 924 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 924 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8439 "Photo.c"
		}
#line 924 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 924 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 924 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 924 "../src/Photo.vala"
			return;
#line 8449 "Photo.c"
		}
	}
}


static void
_vala_array_add86 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 937 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 937 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 937 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8467 "Photo.c"
	}
#line 937 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 937 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8473 "Photo.c"
}


static void
_vala_array_add87 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 939 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 939 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 939 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8489 "Photo.c"
	}
#line 939 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 939 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8495 "Photo.c"
}


static void
_vala_array_add88 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 946 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 946 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 946 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8511 "Photo.c"
	}
#line 946 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 946 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 8517 "Photo.c"
}


static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    int* result_length1)
{
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp24_;
	gint _tmp24__length1;
	GError* _inner_error0_ = NULL;
#line 934 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 935 "../src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 935 "../src/Photo.vala"
	backing = _tmp0_;
#line 935 "../src/Photo.vala"
	backing_length1 = 0;
#line 935 "../src/Photo.vala"
	_backing_size_ = backing_length1;
#line 8544 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 936 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 936 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8551 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
#line 937 "../src/Photo.vala"
			_tmp2_ = backing;
#line 937 "../src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 937 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 937 "../src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 937 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 937 "../src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 937 "../src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 937 "../src/Photo.vala"
			_vala_array_add86 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 938 "../src/Photo.vala"
			if (photo_has_editable (self)) {
#line 8578 "Photo.c"
				BackingFileState** _tmp8_;
				gint _tmp8__length1;
				BackingPhotoRow* _tmp9_;
				BackingFileState* _tmp10_;
#line 939 "../src/Photo.vala"
				_tmp8_ = backing;
#line 939 "../src/Photo.vala"
				_tmp8__length1 = backing_length1;
#line 939 "../src/Photo.vala"
				_tmp9_ = self->priv->editable;
#line 939 "../src/Photo.vala"
				_tmp10_ = backing_file_state_new_from_photo_row (_tmp9_, NULL);
#line 939 "../src/Photo.vala"
				_vala_array_add87 (&backing, &backing_length1, &_backing_size_, _tmp10_);
#line 8593 "Photo.c"
			}
#line 941 "../src/Photo.vala"
			if (photo_is_developed (self)) {
#line 8597 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
#line 942 "../src/Photo.vala"
				_tmp11_ = photo_get_raw_development_photo_rows (self);
#line 942 "../src/Photo.vala"
				dev_rows = _tmp11_;
#line 943 "../src/Photo.vala"
				_tmp12_ = dev_rows;
#line 943 "../src/Photo.vala"
				if (_tmp12_ != NULL) {
#line 8609 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_;
#line 944 "../src/Photo.vala"
						_tmp13_ = dev_rows;
#line 944 "../src/Photo.vala"
						_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 944 "../src/Photo.vala"
						_r_it = _tmp14_;
#line 944 "../src/Photo.vala"
						while (TRUE) {
#line 8622 "Photo.c"
							GeeIterator* _tmp15_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp16_;
							gpointer _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							BackingFileState** _tmp20_;
							gint _tmp20__length1;
							BackingPhotoRow* _tmp21_;
							BackingFileState* _tmp22_;
#line 944 "../src/Photo.vala"
							_tmp15_ = _r_it;
#line 944 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp15_)) {
#line 944 "../src/Photo.vala"
								break;
#line 8639 "Photo.c"
							}
#line 944 "../src/Photo.vala"
							_tmp16_ = _r_it;
#line 944 "../src/Photo.vala"
							_tmp17_ = gee_iterator_get (_tmp16_);
#line 944 "../src/Photo.vala"
							r = (BackingPhotoRow*) _tmp17_;
#line 945 "../src/Photo.vala"
							_tmp18_ = r;
#line 945 "../src/Photo.vala"
							_tmp19_ = _tmp18_->filepath;
#line 945 "../src/Photo.vala"
							g_debug ("Photo.vala:945: adding: %s", _tmp19_);
#line 946 "../src/Photo.vala"
							_tmp20_ = backing;
#line 946 "../src/Photo.vala"
							_tmp20__length1 = backing_length1;
#line 946 "../src/Photo.vala"
							_tmp21_ = r;
#line 946 "../src/Photo.vala"
							_tmp22_ = backing_file_state_new_from_photo_row (_tmp21_, NULL);
#line 946 "../src/Photo.vala"
							_vala_array_add88 (&backing, &backing_length1, &_backing_size_, _tmp22_);
#line 944 "../src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 8665 "Photo.c"
						}
#line 944 "../src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 8669 "Photo.c"
					}
				}
#line 941 "../src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 8674 "Photo.c"
			}
		}
		__finally292:
		{
			PhotoRow* _tmp23_;
#line 936 "../src/Photo.vala"
			_tmp23_ = self->row;
#line 936 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8684 "Photo.c"
		}
#line 936 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 936 "../src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 936 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 936 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 936 "../src/Photo.vala"
			return NULL;
#line 8696 "Photo.c"
		}
	}
#line 952 "../src/Photo.vala"
	_tmp24_ = backing;
#line 952 "../src/Photo.vala"
	_tmp24__length1 = backing_length1;
#line 952 "../src/Photo.vala"
	if (result_length1) {
#line 952 "../src/Photo.vala"
		*result_length1 = _tmp24__length1;
#line 8707 "Photo.c"
	}
#line 952 "../src/Photo.vala"
	result = _tmp24_;
#line 952 "../src/Photo.vala"
	return result;
#line 8713 "Photo.c"
}


static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result = NULL;
#line 955 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 956 "../src/Photo.vala"
	switch (mode) {
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 8728 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 958 "../src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 958 "../src/Photo.vala"
			result = _tmp0_;
#line 958 "../src/Photo.vala"
			return result;
#line 8737 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 8741 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 961 "../src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 961 "../src/Photo.vala"
			result = _tmp1_;
#line 961 "../src/Photo.vala"
			return result;
#line 8750 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 8754 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 964 "../src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 964 "../src/Photo.vala"
			result = _tmp2_;
#line 964 "../src/Photo.vala"
			return result;
#line 8763 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8767 "Photo.c"
		{
#line 967 "../src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8771 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 968 "../src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 968 "../src/Photo.vala"
				result = _tmp3_;
#line 968 "../src/Photo.vala"
				return result;
#line 8779 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 970 "../src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 970 "../src/Photo.vala"
				result = _tmp4_;
#line 970 "../src/Photo.vala"
				return result;
#line 8788 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 973 "../src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 973 "../src/Photo.vala"
			g_error ("Photo.vala:973: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8798 "Photo.c"
		}
	}
}


static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 979 "../src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8809 "Photo.c"
}


static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 977 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8820 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 978 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 978 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8827 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 979 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 979 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 979 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 979 "../src/Photo.vala"
			result = _tmp3_;
#line 8840 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 978 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 978 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8847 "Photo.c"
			}
#line 979 "../src/Photo.vala"
			return result;
#line 8851 "Photo.c"
		}
		__finally293:
		{
			PhotoBackingReaders* _tmp5_;
#line 978 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 978 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8860 "Photo.c"
		}
#line 978 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 978 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 978 "../src/Photo.vala"
		return NULL;
#line 8868 "Photo.c"
	}
}


PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 983 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8880 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 984 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 984 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8887 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 985 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 985 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 985 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 985 "../src/Photo.vala"
			result = _tmp3_;
#line 8900 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 984 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 984 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8907 "Photo.c"
			}
#line 985 "../src/Photo.vala"
			return result;
#line 8911 "Photo.c"
		}
		__finally294:
		{
			PhotoBackingReaders* _tmp5_;
#line 984 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 984 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8920 "Photo.c"
		}
#line 984 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 984 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 984 "../src/Photo.vala"
		return NULL;
#line 8928 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 990 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8940 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 991 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 991 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8947 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 992 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 992 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 992 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8962 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 993 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 993 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 993 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 993 "../src/Photo.vala"
				result = _tmp5_;
#line 8974 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 991 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 991 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8981 "Photo.c"
				}
#line 993 "../src/Photo.vala"
				return result;
#line 8985 "Photo.c"
			}
#line 995 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 995 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 995 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8993 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 996 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 996 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 996 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 996 "../src/Photo.vala"
				result = _tmp11_;
#line 9005 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 991 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 991 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9012 "Photo.c"
				}
#line 996 "../src/Photo.vala"
				return result;
#line 9016 "Photo.c"
			}
#line 998 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 998 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 998 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 998 "../src/Photo.vala"
			result = _tmp15_;
#line 9026 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 991 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 991 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9033 "Photo.c"
			}
#line 998 "../src/Photo.vala"
			return result;
#line 9037 "Photo.c"
		}
		__finally295:
		{
			PhotoBackingReaders* _tmp17_;
#line 991 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 991 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9046 "Photo.c"
		}
#line 991 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 991 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 991 "../src/Photo.vala"
		return NULL;
#line 9054 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1003 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9066 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1004 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9073 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 1005 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1005 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1005 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9088 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1006 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1006 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 1006 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 1006 "../src/Photo.vala"
				result = _tmp5_;
#line 9100 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 1004 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9107 "Photo.c"
				}
#line 1006 "../src/Photo.vala"
				return result;
#line 9111 "Photo.c"
			}
#line 1008 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1008 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 1008 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 9119 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 1009 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 1009 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 1009 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 1009 "../src/Photo.vala"
				result = _tmp11_;
#line 9131 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 1004 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9138 "Photo.c"
				}
#line 1009 "../src/Photo.vala"
				return result;
#line 9142 "Photo.c"
			}
#line 1011 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 1011 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1011 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 1011 "../src/Photo.vala"
			result = _tmp15_;
#line 9152 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 1004 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9159 "Photo.c"
			}
#line 1011 "../src/Photo.vala"
			return result;
#line 9163 "Photo.c"
		}
		__finally296:
		{
			PhotoBackingReaders* _tmp17_;
#line 1004 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 1004 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9172 "Photo.c"
		}
#line 1004 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1004 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1004 "../src/Photo.vala"
		return NULL;
#line 9180 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1016 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9192 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1017 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9199 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1018 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1018 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1018 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 1018 "../src/Photo.vala"
			result = _tmp3_;
#line 9212 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 1017 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9219 "Photo.c"
			}
#line 1018 "../src/Photo.vala"
			return result;
#line 9223 "Photo.c"
		}
		__finally297:
		{
			PhotoBackingReaders* _tmp5_;
#line 1017 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 1017 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9232 "Photo.c"
		}
#line 1017 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1017 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1017 "../src/Photo.vala"
		return NULL;
#line 9240 "Photo.c"
	}
}


gboolean
photo_is_developed (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1022 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9252 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1023 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9260 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1024 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1024 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1024 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9270 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1023 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9277 "Photo.c"
			}
#line 1024 "../src/Photo.vala"
			return result;
#line 9281 "Photo.c"
		}
		__finally298:
		{
			PhotoBackingReaders* _tmp4_;
#line 1023 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1023 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9290 "Photo.c"
		}
#line 1023 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1023 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1023 "../src/Photo.vala"
		return _tmp5_;
#line 9298 "Photo.c"
	}
}


gboolean
photo_has_editable (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1028 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9310 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1029 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9318 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1030 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1030 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1030 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9328 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1029 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9335 "Photo.c"
			}
#line 1030 "../src/Photo.vala"
			return result;
#line 9339 "Photo.c"
		}
		__finally299:
		{
			PhotoBackingReaders* _tmp4_;
#line 1029 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1029 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9348 "Photo.c"
		}
#line 1029 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1029 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1029 "../src/Photo.vala"
		return _tmp5_;
#line 9356 "Photo.c"
	}
}


gboolean
photo_does_master_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1034 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9368 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1035 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9376 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1036 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1036 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1036 "../src/Photo.vala"
			result = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9386 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1035 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9393 "Photo.c"
			}
#line 1036 "../src/Photo.vala"
			return result;
#line 9397 "Photo.c"
		}
		__finally300:
		{
			PhotoBackingReaders* _tmp4_;
#line 1035 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1035 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9406 "Photo.c"
		}
#line 1035 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1035 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1035 "../src/Photo.vala"
		return _tmp5_;
#line 9414 "Photo.c"
	}
}


gboolean
photo_does_editable_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1041 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9426 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 1042 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9434 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1043 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 1043 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 1043 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 9445 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1043 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1043 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 1043 "../src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9454 "Photo.c"
			} else {
#line 1043 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 9458 "Photo.c"
			}
#line 1043 "../src/Photo.vala"
			result = _tmp1_;
#line 9462 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 1042 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9469 "Photo.c"
			}
#line 1043 "../src/Photo.vala"
			return result;
#line 9473 "Photo.c"
		}
		__finally301:
		{
			PhotoBackingReaders* _tmp7_;
#line 1042 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1042 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9482 "Photo.c"
		}
#line 1042 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1042 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1042 "../src/Photo.vala"
		return _tmp8_;
#line 9490 "Photo.c"
	}
}


gboolean
photo_is_master_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1047 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9502 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1048 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9510 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1049 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1049 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1049 "../src/Photo.vala"
			result = _tmp2_ == NULL;
#line 9520 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1048 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9527 "Photo.c"
			}
#line 1049 "../src/Photo.vala"
			return result;
#line 9531 "Photo.c"
		}
		__finally302:
		{
			PhotoBackingReaders* _tmp4_;
#line 1048 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1048 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9540 "Photo.c"
		}
#line 1048 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1048 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1048 "../src/Photo.vala"
		return _tmp5_;
#line 9548 "Photo.c"
	}
}


gboolean
photo_is_master_source (Photo* self)
{
	gboolean result = FALSE;
#line 1053 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1054 "../src/Photo.vala"
	result = !photo_has_editable (self);
#line 1054 "../src/Photo.vala"
	return result;
#line 9563 "Photo.c"
}


gboolean
photo_is_editable_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1057 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9574 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1058 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9582 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1059 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1059 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1059 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9592 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1058 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9599 "Photo.c"
			}
#line 1059 "../src/Photo.vala"
			return result;
#line 9603 "Photo.c"
		}
		__finally303:
		{
			PhotoBackingReaders* _tmp4_;
#line 1058 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1058 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9612 "Photo.c"
		}
#line 1058 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1058 "../src/Photo.vala"
		return _tmp5_;
#line 9620 "Photo.c"
	}
}


gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result = FALSE;
#line 1063 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1064 "../src/Photo.vala"
	result = photo_has_editable (self);
#line 1064 "../src/Photo.vala"
	return result;
#line 9635 "Photo.c"
}


BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1067 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9646 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1068 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1068 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9653 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 1069 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1069 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1069 "../src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1069 "../src/Photo.vala"
			result = _tmp3_;
#line 9666 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1068 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1068 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9673 "Photo.c"
			}
#line 1069 "../src/Photo.vala"
			return result;
#line 9677 "Photo.c"
		}
		__finally304:
		{
			PhotoRow* _tmp5_;
#line 1068 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1068 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9686 "Photo.c"
		}
#line 1068 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1068 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1068 "../src/Photo.vala"
		return NULL;
#line 9694 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1073 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9706 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1074 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1074 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9713 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1076 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1076 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 9720 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 1077 "../src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 1077 "../src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1077 "../src/Photo.vala"
				result = _tmp3_;
#line 9729 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 1074 "../src/Photo.vala"
					_tmp4_ = self->row;
#line 1074 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9736 "Photo.c"
				}
#line 1077 "../src/Photo.vala"
				return result;
#line 9740 "Photo.c"
			} else {
#line 1079 "../src/Photo.vala"
				result = NULL;
#line 9744 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 1074 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 1074 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9751 "Photo.c"
				}
#line 1079 "../src/Photo.vala"
				return result;
#line 9755 "Photo.c"
			}
		}
		__finally305:
		{
			PhotoRow* _tmp6_;
#line 1074 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1074 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9765 "Photo.c"
		}
#line 1074 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1074 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1074 "../src/Photo.vala"
		return NULL;
#line 9773 "Photo.c"
	}
}


GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GeeCollection* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1083 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9785 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1084 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1084 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9792 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1085 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1085 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9800 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 1085 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1085 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1085 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1085 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "../src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9814 "Photo.c"
			} else {
#line 1085 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9820 "Photo.c"
			}
#line 1085 "../src/Photo.vala"
			result = _tmp1_;
#line 9824 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1084 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 1084 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9831 "Photo.c"
			}
#line 1085 "../src/Photo.vala"
			return result;
#line 9835 "Photo.c"
		}
		__finally306:
		{
			PhotoRow* _tmp7_;
#line 1084 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1084 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9844 "Photo.c"
		}
#line 1084 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1084 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1084 "../src/Photo.vala"
		return NULL;
#line 9852 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1089 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9865 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1090 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1090 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9872 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1091 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1091 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9880 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1091 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1091 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 1091 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "../src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9891 "Photo.c"
			} else {
#line 1091 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9897 "Photo.c"
			}
#line 1091 "../src/Photo.vala"
			result = _tmp1_;
#line 9901 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1090 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 1090 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9908 "Photo.c"
			}
#line 1091 "../src/Photo.vala"
			return result;
#line 9912 "Photo.c"
		}
		__finally307:
		{
			PhotoRow* _tmp6_;
#line 1090 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 1090 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9921 "Photo.c"
		}
#line 1090 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1090 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1090 "../src/Photo.vala"
		return NULL;
#line 9929 "Photo.c"
	}
}


static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1101 "../src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1101 "../src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1101 "../src/Photo.vala"
	return dup;
#line 9944 "Photo.c"
}


static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1101 "../src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9953 "Photo.c"
}


PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
#line 1095 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1096 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1096 "../src/Photo.vala"
	reader = _tmp0_;
#line 1097 "../src/Photo.vala"
	_tmp1_ = reader;
#line 1097 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1098 "../src/Photo.vala"
		result = NULL;
#line 1098 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1098 "../src/Photo.vala"
		return result;
#line 9983 "Photo.c"
	}
#line 1101 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1101 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1101 "../src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1101 "../src/Photo.vala"
	result = _tmp4_;
#line 1101 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1101 "../src/Photo.vala"
	return result;
#line 9997 "Photo.c"
}


PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
#line 1104 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1104 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1105 "../src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1107 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1107 "../src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1107 "../src/Photo.vala"
	switch (_tmp1_) {
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10023 "Photo.c"
		{
#line 1109 "../src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1110 "../src/Photo.vala"
			break;
#line 10029 "Photo.c"
		}
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 10033 "Photo.c"
		{
#line 1113 "../src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1114 "../src/Photo.vala"
			break;
#line 10039 "Photo.c"
		}
#line 1107 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10043 "Photo.c"
		{
			ExportFormatParameters _tmp2_;
			PhotoFileFormat _tmp3_;
#line 1117 "../src/Photo.vala"
			_tmp2_ = *params;
#line 1117 "../src/Photo.vala"
			_tmp3_ = _tmp2_.specified_format;
#line 1117 "../src/Photo.vala"
			_result_ = _tmp3_;
#line 1118 "../src/Photo.vala"
			break;
#line 10055 "Photo.c"
		}
		default:
		{
#line 1121 "../src/Photo.vala"
			g_error ("Photo.vala:1121: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 10061 "Photo.c"
		}
	}
#line 1124 "../src/Photo.vala"
	result = _result_;
#line 1124 "../src/Photo.vala"
	return result;
#line 10068 "Photo.c"
}


gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 1127 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1127 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1128 "../src/Photo.vala"
	_result_ = NULL;
#line 1130 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1130 "../src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1130 "../src/Photo.vala"
	switch (_tmp1_) {
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10095 "Photo.c"
		{
			GFile* _tmp2_;
			GFile* _tmp3_;
			gchar* _tmp4_;
#line 1132 "../src/Photo.vala"
			_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1132 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1132 "../src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1132 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1132 "../src/Photo.vala"
			_result_ = _tmp4_;
#line 1132 "../src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1133 "../src/Photo.vala"
			break;
#line 10114 "Photo.c"
		}
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1130 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10120 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
			gchar* _tmp7_;
#line 1137 "../src/Photo.vala"
			_tmp5_ = *params;
#line 1137 "../src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1137 "../src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1137 "../src/Photo.vala"
			result = _tmp7_;
#line 1137 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1137 "../src/Photo.vala"
			return result;
#line 10137 "Photo.c"
		}
		default:
		{
#line 1140 "../src/Photo.vala"
			g_error ("Photo.vala:1140: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 10143 "Photo.c"
		}
	}
#line 1143 "../src/Photo.vala"
	_tmp8_ = _result_;
#line 1143 "../src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1144 "../src/Photo.vala"
	result = _result_;
#line 1144 "../src/Photo.vala"
	return result;
#line 10154 "Photo.c"
}


ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	ImportResult result = 0;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp23_;
	PhotoFileSnifferOptions _tmp24_;
	PhotoFileInterrogator* _tmp25_;
	PhotoFileInterrogator* _tmp32_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp33_;
	DetectedPhotoInformation* _tmp34_;
	gboolean _tmp35_ = FALSE;
	DetectedPhotoInformation* _tmp36_;
	PhotoFileSnifferOptions _tmp39_;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp49_;
	gchar* comment = NULL;
	gchar* _tmp50_;
	Rating rating = 0;
	DetectedPhotoInformation* _tmp51_;
	PhotoMetadata* _tmp52_;
	gboolean _tmp71_ = FALSE;
	gboolean _tmp72_ = FALSE;
	DetectedPhotoInformation* _tmp73_;
	GdkColorspace _tmp74_;
	PhotoRow* _tmp82_;
	PhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	GFile* _tmp85_;
	gchar* _tmp86_;
	PhotoRow* _tmp87_;
	BackingPhotoRow* _tmp88_;
	DetectedPhotoInformation* _tmp89_;
	Dimensions _tmp90_;
	PhotoRow* _tmp91_;
	BackingPhotoRow* _tmp92_;
	GFileInfo* _tmp93_;
	PhotoRow* _tmp94_;
	BackingPhotoRow* _tmp95_;
	GTimeVal _tmp96_;
	glong _tmp97_;
	PhotoRow* _tmp98_;
	time_t _tmp99_;
	PhotoRow* _tmp100_;
	Orientation _tmp101_;
	PhotoRow* _tmp102_;
	BackingPhotoRow* _tmp103_;
	Orientation _tmp104_;
	PhotoRow* _tmp105_;
	ImportID _tmp106_;
	PhotoRow* _tmp107_;
	PhotoRow* _tmp108_;
	PhotoRow* _tmp109_;
	DetectedPhotoInformation* _tmp110_;
	const gchar* _tmp111_;
	gchar* _tmp112_;
	PhotoRow* _tmp113_;
	DetectedPhotoInformation* _tmp114_;
	const gchar* _tmp115_;
	gchar* _tmp116_;
	PhotoRow* _tmp117_;
	DetectedPhotoInformation* _tmp118_;
	const gchar* _tmp119_;
	gchar* _tmp120_;
	PhotoRow* _tmp121_;
	PhotoRow* _tmp122_;
	PhotoRow* _tmp123_;
	BackingPhotoRow* _tmp124_;
	DetectedPhotoInformation* _tmp125_;
	PhotoFileFormat _tmp126_;
	PhotoRow* _tmp127_;
	const gchar* _tmp128_;
	gchar* _tmp129_;
	PhotoRow* _tmp130_;
	const gchar* _tmp131_;
	gchar* _tmp132_;
	PhotoRow* _tmp133_;
	Rating _tmp134_;
	Thumbnails* _tmp135_;
	GError* _inner_error0_ = NULL;
#line 1159 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 1163 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1163 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1163 "../src/Photo.vala"
	file = _tmp1_;
#line 1165 "../src/Photo.vala"
	info = NULL;
#line 10264 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1167 "../src/Photo.vala"
		_tmp3_ = file;
#line 1167 "../src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1167 "../src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1167 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10278 "Photo.c"
			goto __catch308_g_error;
		}
#line 1167 "../src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1167 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 1167 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1167 "../src/Photo.vala"
		info = _tmp5_;
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 10291 "Photo.c"
	}
	goto __finally308;
	__catch308_g_error:
	{
		GError* err = NULL;
#line 1166 "../src/Photo.vala"
		err = _inner_error0_;
#line 1166 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1170 "../src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1170 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1170 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1170 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1170 "../src/Photo.vala"
		return result;
#line 10311 "Photo.c"
	}
	__finally308:
#line 1166 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1166 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1166 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1166 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1166 "../src/Photo.vala"
		return 0;
#line 10326 "Photo.c"
	}
#line 1173 "../src/Photo.vala"
	_tmp6_ = info;
#line 1173 "../src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1174 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1174 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1174 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1174 "../src/Photo.vala"
		return result;
#line 10340 "Photo.c"
	}
#line 1176 "../src/Photo.vala"
	_tmp7_ = file;
#line 1176 "../src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 10346 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1177 "../src/Photo.vala"
		_tmp8_ = file;
#line 1177 "../src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1177 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1177 "../src/Photo.vala"
		g_message ("Photo.vala:1177: Not importing %s: Not an image file", _tmp10_);
#line 1177 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1179 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1179 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1179 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1179 "../src/Photo.vala"
		return result;
#line 10368 "Photo.c"
	}
#line 1182 "../src/Photo.vala"
	_tmp11_ = file;
#line 1182 "../src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 10374 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1183 "../src/Photo.vala"
		_tmp12_ = file;
#line 1183 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1183 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1183 "../src/Photo.vala"
		g_message ("Photo.vala:1183: Not importing %s: Unsupported extension", _tmp14_);
#line 1183 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1185 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1185 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1185 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1185 "../src/Photo.vala"
		return result;
#line 10396 "Photo.c"
	}
#line 1188 "../src/Photo.vala"
	_tmp15_ = info;
#line 1188 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1188 "../src/Photo.vala"
	timestamp = _tmp16_;
#line 1191 "../src/Photo.vala"
	_tmp19_ = params->exif_md5;
#line 1191 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 10408 "Photo.c"
		const gchar* _tmp20_;
#line 1191 "../src/Photo.vala"
		_tmp20_ = params->thumbnail_md5;
#line 1191 "../src/Photo.vala"
		_tmp18_ = _tmp20_ != NULL;
#line 10414 "Photo.c"
	} else {
#line 1191 "../src/Photo.vala"
		_tmp18_ = FALSE;
#line 10418 "Photo.c"
	}
#line 1191 "../src/Photo.vala"
	if (_tmp18_) {
#line 10422 "Photo.c"
		const gchar* _tmp21_;
#line 1191 "../src/Photo.vala"
		_tmp21_ = params->full_md5;
#line 1191 "../src/Photo.vala"
		_tmp17_ = _tmp21_ != NULL;
#line 10428 "Photo.c"
	} else {
#line 1191 "../src/Photo.vala"
		_tmp17_ = FALSE;
#line 10432 "Photo.c"
	}
#line 1191 "../src/Photo.vala"
	if (_tmp17_) {
#line 10436 "Photo.c"
		PhotoFileSnifferOptions _tmp22_;
#line 1192 "../src/Photo.vala"
		_tmp22_ = params->sniffer_options;
#line 1192 "../src/Photo.vala"
		params->sniffer_options = _tmp22_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 10442 "Photo.c"
	}
#line 1195 "../src/Photo.vala"
	_tmp23_ = file;
#line 1195 "../src/Photo.vala"
	_tmp24_ = params->sniffer_options;
#line 1195 "../src/Photo.vala"
	_tmp25_ = photo_file_interrogator_new (_tmp23_, _tmp24_);
#line 1195 "../src/Photo.vala"
	interrogator = _tmp25_;
#line 10452 "Photo.c"
	{
		PhotoFileInterrogator* _tmp26_;
#line 1197 "../src/Photo.vala"
		_tmp26_ = interrogator;
#line 1197 "../src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp26_, &_inner_error0_);
#line 1197 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10461 "Photo.c"
			goto __catch309_g_error;
		}
	}
	goto __finally309;
	__catch309_g_error:
	{
		GError* err = NULL;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1196 "../src/Photo.vala"
		err = _inner_error0_;
#line 1196 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1199 "../src/Photo.vala"
		_tmp27_ = file;
#line 1199 "../src/Photo.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 1199 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1199 "../src/Photo.vala"
		_tmp30_ = err;
#line 1199 "../src/Photo.vala"
		_tmp31_ = _tmp30_->message;
#line 1199 "../src/Photo.vala"
		g_warning ("Photo.vala:1199: Unable to interrogate photo file %s: %s", _tmp29_, _tmp31_);
#line 1199 "../src/Photo.vala"
		_g_free0 (_tmp29_);
#line 1201 "../src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1201 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1201 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1201 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1201 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1201 "../src/Photo.vala"
		return result;
#line 10504 "Photo.c"
	}
	__finally309:
#line 1196 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1196 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1196 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1196 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1196 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1196 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1196 "../src/Photo.vala"
		return 0;
#line 10521 "Photo.c"
	}
#line 1204 "../src/Photo.vala"
	_tmp32_ = interrogator;
#line 1204 "../src/Photo.vala"
	if (photo_file_interrogator_get_is_photo_corrupted (_tmp32_)) {
#line 1205 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1205 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1205 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1205 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1205 "../src/Photo.vala"
		return result;
#line 10537 "Photo.c"
	}
#line 1208 "../src/Photo.vala"
	_tmp33_ = interrogator;
#line 1208 "../src/Photo.vala"
	_tmp34_ = photo_file_interrogator_get_detected_photo_information (_tmp33_);
#line 1208 "../src/Photo.vala"
	detected = _tmp34_;
#line 1209 "../src/Photo.vala"
	_tmp36_ = detected;
#line 1209 "../src/Photo.vala"
	if (_tmp36_ == NULL) {
#line 1209 "../src/Photo.vala"
		_tmp35_ = TRUE;
#line 10551 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp37_;
		PhotoFileFormat _tmp38_;
#line 1209 "../src/Photo.vala"
		_tmp37_ = detected;
#line 1209 "../src/Photo.vala"
		_tmp38_ = _tmp37_->file_format;
#line 1209 "../src/Photo.vala"
		_tmp35_ = _tmp38_ == PHOTO_FILE_FORMAT_UNKNOWN;
#line 10561 "Photo.c"
	}
#line 1209 "../src/Photo.vala"
	if (_tmp35_) {
#line 1210 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1210 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1210 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1210 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1210 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1210 "../src/Photo.vala"
		return result;
#line 10577 "Photo.c"
	}
#line 1213 "../src/Photo.vala"
	_tmp39_ = params->sniffer_options;
#line 1213 "../src/Photo.vala"
	if ((_tmp39_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 10583 "Photo.c"
		DetectedPhotoInformation* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		DetectedPhotoInformation* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		DetectedPhotoInformation* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
#line 1214 "../src/Photo.vala"
		_tmp40_ = detected;
#line 1214 "../src/Photo.vala"
		_tmp41_ = params->exif_md5;
#line 1214 "../src/Photo.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 1214 "../src/Photo.vala"
		_g_free0 (_tmp40_->exif_md5);
#line 1214 "../src/Photo.vala"
		_tmp40_->exif_md5 = _tmp42_;
#line 1215 "../src/Photo.vala"
		_tmp43_ = detected;
#line 1215 "../src/Photo.vala"
		_tmp44_ = params->thumbnail_md5;
#line 1215 "../src/Photo.vala"
		_tmp45_ = g_strdup (_tmp44_);
#line 1215 "../src/Photo.vala"
		_g_free0 (_tmp43_->thumbnail_md5);
#line 1215 "../src/Photo.vala"
		_tmp43_->thumbnail_md5 = _tmp45_;
#line 1216 "../src/Photo.vala"
		_tmp46_ = detected;
#line 1216 "../src/Photo.vala"
		_tmp47_ = params->full_md5;
#line 1216 "../src/Photo.vala"
		_tmp48_ = g_strdup (_tmp47_);
#line 1216 "../src/Photo.vala"
		_g_free0 (_tmp46_->md5);
#line 1216 "../src/Photo.vala"
		_tmp46_->md5 = _tmp48_;
#line 10623 "Photo.c"
	}
#line 1219 "../src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1220 "../src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1221 "../src/Photo.vala"
	_tmp49_ = g_strdup ("");
#line 1221 "../src/Photo.vala"
	title = _tmp49_;
#line 1222 "../src/Photo.vala"
	_tmp50_ = g_strdup ("");
#line 1222 "../src/Photo.vala"
	comment = _tmp50_;
#line 1223 "../src/Photo.vala"
	rating = RATING_UNRATED;
#line 1230 "../src/Photo.vala"
	_tmp51_ = detected;
#line 1230 "../src/Photo.vala"
	_tmp52_ = _tmp51_->metadata;
#line 1230 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 10645 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp53_;
		PhotoMetadata* _tmp54_;
		MetadataDateTime* _tmp55_;
		MetadataDateTime* _tmp56_;
		DetectedPhotoInformation* _tmp58_;
		PhotoMetadata* _tmp59_;
		DetectedPhotoInformation* _tmp60_;
		PhotoMetadata* _tmp61_;
		gchar* _tmp62_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		gchar* _tmp65_;
		DetectedPhotoInformation* _tmp66_;
		PhotoMetadata* _tmp67_;
		GeeSet* _tmp68_;
		DetectedPhotoInformation* _tmp69_;
		PhotoMetadata* _tmp70_;
#line 1231 "../src/Photo.vala"
		_tmp53_ = detected;
#line 1231 "../src/Photo.vala"
		_tmp54_ = _tmp53_->metadata;
#line 1231 "../src/Photo.vala"
		_tmp55_ = photo_metadata_get_exposure_date_time (_tmp54_);
#line 1231 "../src/Photo.vala"
		date_time = _tmp55_;
#line 1232 "../src/Photo.vala"
		_tmp56_ = date_time;
#line 1232 "../src/Photo.vala"
		if (_tmp56_ != NULL) {
#line 10676 "Photo.c"
			MetadataDateTime* _tmp57_;
#line 1233 "../src/Photo.vala"
			_tmp57_ = date_time;
#line 1233 "../src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp57_);
#line 10682 "Photo.c"
		}
#line 1235 "../src/Photo.vala"
		_tmp58_ = detected;
#line 1235 "../src/Photo.vala"
		_tmp59_ = _tmp58_->metadata;
#line 1235 "../src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp59_);
#line 1236 "../src/Photo.vala"
		_tmp60_ = detected;
#line 1236 "../src/Photo.vala"
		_tmp61_ = _tmp60_->metadata;
#line 1236 "../src/Photo.vala"
		_tmp62_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1236 "../src/Photo.vala"
		_g_free0 (title);
#line 1236 "../src/Photo.vala"
		title = _tmp62_;
#line 1237 "../src/Photo.vala"
		_tmp63_ = detected;
#line 1237 "../src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1237 "../src/Photo.vala"
		_tmp65_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1237 "../src/Photo.vala"
		_g_free0 (comment);
#line 1237 "../src/Photo.vala"
		comment = _tmp65_;
#line 1238 "../src/Photo.vala"
		_tmp66_ = detected;
#line 1238 "../src/Photo.vala"
		_tmp67_ = _tmp66_->metadata;
#line 1238 "../src/Photo.vala"
		_tmp68_ = photo_metadata_get_keywords (_tmp67_, NULL, NULL, NULL);
#line 1238 "../src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1238 "../src/Photo.vala"
		params->keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1239 "../src/Photo.vala"
		_tmp69_ = detected;
#line 1239 "../src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1239 "../src/Photo.vala"
		rating = photo_metadata_get_rating (_tmp70_);
#line 1230 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10728 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	_tmp73_ = detected;
#line 1243 "../src/Photo.vala"
	_tmp74_ = _tmp73_->colorspace;
#line 1243 "../src/Photo.vala"
	if (_tmp74_ != GDK_COLORSPACE_RGB) {
#line 1243 "../src/Photo.vala"
		_tmp72_ = TRUE;
#line 10738 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp75_;
		gint _tmp76_;
#line 1244 "../src/Photo.vala"
		_tmp75_ = detected;
#line 1244 "../src/Photo.vala"
		_tmp76_ = _tmp75_->channels;
#line 1244 "../src/Photo.vala"
		_tmp72_ = _tmp76_ < 3;
#line 10748 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	if (_tmp72_) {
#line 1243 "../src/Photo.vala"
		_tmp71_ = TRUE;
#line 10754 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp77_;
		gint _tmp78_;
#line 1245 "../src/Photo.vala"
		_tmp77_ = detected;
#line 1245 "../src/Photo.vala"
		_tmp78_ = _tmp77_->bits_per_channel;
#line 1245 "../src/Photo.vala"
		_tmp71_ = _tmp78_ != 8;
#line 10764 "Photo.c"
	}
#line 1243 "../src/Photo.vala"
	if (_tmp71_) {
#line 10768 "Photo.c"
		GFile* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
#line 1246 "../src/Photo.vala"
		_tmp79_ = file;
#line 1246 "../src/Photo.vala"
		_tmp80_ = g_file_get_path (_tmp79_);
#line 1246 "../src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 1246 "../src/Photo.vala"
		g_message ("Photo.vala:1246: Not importing %s: Unsupported color format", _tmp81_);
#line 1246 "../src/Photo.vala"
		_g_free0 (_tmp81_);
#line 1248 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1248 "../src/Photo.vala"
		_g_free0 (comment);
#line 1248 "../src/Photo.vala"
		_g_free0 (title);
#line 1248 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1248 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1248 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1248 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1248 "../src/Photo.vala"
		return result;
#line 10798 "Photo.c"
	}
#line 1254 "../src/Photo.vala"
	_tmp82_ = params->row;
#line 1254 "../src/Photo.vala"
	photo_id_init (&_tmp82_->photo_id, PHOTO_ID_INVALID);
#line 1255 "../src/Photo.vala"
	_tmp83_ = params->row;
#line 1255 "../src/Photo.vala"
	_tmp84_ = _tmp83_->master;
#line 1255 "../src/Photo.vala"
	_tmp85_ = file;
#line 1255 "../src/Photo.vala"
	_tmp86_ = g_file_get_path (_tmp85_);
#line 1255 "../src/Photo.vala"
	_g_free0 (_tmp84_->filepath);
#line 1255 "../src/Photo.vala"
	_tmp84_->filepath = _tmp86_;
#line 1256 "../src/Photo.vala"
	_tmp87_ = params->row;
#line 1256 "../src/Photo.vala"
	_tmp88_ = _tmp87_->master;
#line 1256 "../src/Photo.vala"
	_tmp89_ = detected;
#line 1256 "../src/Photo.vala"
	_tmp90_ = _tmp89_->image_dim;
#line 1256 "../src/Photo.vala"
	_tmp88_->dim = _tmp90_;
#line 1257 "../src/Photo.vala"
	_tmp91_ = params->row;
#line 1257 "../src/Photo.vala"
	_tmp92_ = _tmp91_->master;
#line 1257 "../src/Photo.vala"
	_tmp93_ = info;
#line 1257 "../src/Photo.vala"
	_tmp92_->filesize = g_file_info_get_size (_tmp93_);
#line 1258 "../src/Photo.vala"
	_tmp94_ = params->row;
#line 1258 "../src/Photo.vala"
	_tmp95_ = _tmp94_->master;
#line 1258 "../src/Photo.vala"
	_tmp96_ = timestamp;
#line 1258 "../src/Photo.vala"
	_tmp97_ = _tmp96_.tv_sec;
#line 1258 "../src/Photo.vala"
	_tmp95_->timestamp = (time_t) _tmp97_;
#line 1259 "../src/Photo.vala"
	_tmp98_ = params->row;
#line 1259 "../src/Photo.vala"
	_tmp99_ = exposure_time;
#line 1259 "../src/Photo.vala"
	_tmp98_->exposure_time = _tmp99_;
#line 1260 "../src/Photo.vala"
	_tmp100_ = params->row;
#line 1260 "../src/Photo.vala"
	_tmp101_ = orientation;
#line 1260 "../src/Photo.vala"
	_tmp100_->orientation = _tmp101_;
#line 1261 "../src/Photo.vala"
	_tmp102_ = params->row;
#line 1261 "../src/Photo.vala"
	_tmp103_ = _tmp102_->master;
#line 1261 "../src/Photo.vala"
	_tmp104_ = orientation;
#line 1261 "../src/Photo.vala"
	_tmp103_->original_orientation = _tmp104_;
#line 1262 "../src/Photo.vala"
	_tmp105_ = params->row;
#line 1262 "../src/Photo.vala"
	_tmp106_ = params->import_id;
#line 1262 "../src/Photo.vala"
	_tmp105_->import_id = _tmp106_;
#line 1263 "../src/Photo.vala"
	_tmp107_ = params->row;
#line 1263 "../src/Photo.vala"
	event_id_init (&_tmp107_->event_id, EVENT_ID_INVALID);
#line 1264 "../src/Photo.vala"
	_tmp108_ = params->row;
#line 1264 "../src/Photo.vala"
	_g_object_unref0 (_tmp108_->transformations);
#line 1264 "../src/Photo.vala"
	_tmp108_->transformations = NULL;
#line 1265 "../src/Photo.vala"
	_tmp109_ = params->row;
#line 1265 "../src/Photo.vala"
	_tmp110_ = detected;
#line 1265 "../src/Photo.vala"
	_tmp111_ = _tmp110_->md5;
#line 1265 "../src/Photo.vala"
	_tmp112_ = g_strdup (_tmp111_);
#line 1265 "../src/Photo.vala"
	_g_free0 (_tmp109_->md5);
#line 1265 "../src/Photo.vala"
	_tmp109_->md5 = _tmp112_;
#line 1266 "../src/Photo.vala"
	_tmp113_ = params->row;
#line 1266 "../src/Photo.vala"
	_tmp114_ = detected;
#line 1266 "../src/Photo.vala"
	_tmp115_ = _tmp114_->thumbnail_md5;
#line 1266 "../src/Photo.vala"
	_tmp116_ = g_strdup (_tmp115_);
#line 1266 "../src/Photo.vala"
	_g_free0 (_tmp113_->thumbnail_md5);
#line 1266 "../src/Photo.vala"
	_tmp113_->thumbnail_md5 = _tmp116_;
#line 1267 "../src/Photo.vala"
	_tmp117_ = params->row;
#line 1267 "../src/Photo.vala"
	_tmp118_ = detected;
#line 1267 "../src/Photo.vala"
	_tmp119_ = _tmp118_->exif_md5;
#line 1267 "../src/Photo.vala"
	_tmp120_ = g_strdup (_tmp119_);
#line 1267 "../src/Photo.vala"
	_g_free0 (_tmp117_->exif_md5);
#line 1267 "../src/Photo.vala"
	_tmp117_->exif_md5 = _tmp120_;
#line 1268 "../src/Photo.vala"
	_tmp121_ = params->row;
#line 1268 "../src/Photo.vala"
	_tmp121_->time_created = (time_t) 0;
#line 1269 "../src/Photo.vala"
	_tmp122_ = params->row;
#line 1269 "../src/Photo.vala"
	_tmp122_->flags = (guint64) 0;
#line 1270 "../src/Photo.vala"
	_tmp123_ = params->row;
#line 1270 "../src/Photo.vala"
	_tmp124_ = _tmp123_->master;
#line 1270 "../src/Photo.vala"
	_tmp125_ = detected;
#line 1270 "../src/Photo.vala"
	_tmp126_ = _tmp125_->file_format;
#line 1270 "../src/Photo.vala"
	_tmp124_->file_format = _tmp126_;
#line 1271 "../src/Photo.vala"
	_tmp127_ = params->row;
#line 1271 "../src/Photo.vala"
	_tmp128_ = title;
#line 1271 "../src/Photo.vala"
	_tmp129_ = g_strdup (_tmp128_);
#line 1271 "../src/Photo.vala"
	_g_free0 (_tmp127_->title);
#line 1271 "../src/Photo.vala"
	_tmp127_->title = _tmp129_;
#line 1272 "../src/Photo.vala"
	_tmp130_ = params->row;
#line 1272 "../src/Photo.vala"
	_tmp131_ = comment;
#line 1272 "../src/Photo.vala"
	_tmp132_ = g_strdup (_tmp131_);
#line 1272 "../src/Photo.vala"
	_g_free0 (_tmp130_->comment);
#line 1272 "../src/Photo.vala"
	_tmp130_->comment = _tmp132_;
#line 1273 "../src/Photo.vala"
	_tmp133_ = params->row;
#line 1273 "../src/Photo.vala"
	_tmp134_ = rating;
#line 1273 "../src/Photo.vala"
	_tmp133_->rating = _tmp134_;
#line 1275 "../src/Photo.vala"
	_tmp135_ = params->thumbnails;
#line 1275 "../src/Photo.vala"
	if (_tmp135_ != NULL) {
#line 10964 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp136_;
		BackingPhotoRow* _tmp137_;
		PhotoFileFormat _tmp138_;
		PhotoRow* _tmp139_;
		BackingPhotoRow* _tmp140_;
		const gchar* _tmp141_;
		PhotoFileReader* _tmp142_;
		PhotoFileReader* _tmp143_;
#line 1276 "../src/Photo.vala"
		_tmp136_ = params->row;
#line 1276 "../src/Photo.vala"
		_tmp137_ = _tmp136_->master;
#line 1276 "../src/Photo.vala"
		_tmp138_ = _tmp137_->file_format;
#line 1276 "../src/Photo.vala"
		_tmp139_ = params->row;
#line 1276 "../src/Photo.vala"
		_tmp140_ = _tmp139_->master;
#line 1276 "../src/Photo.vala"
		_tmp141_ = _tmp140_->filepath;
#line 1276 "../src/Photo.vala"
		_tmp142_ = photo_file_format_create_reader (_tmp138_, _tmp141_);
#line 1276 "../src/Photo.vala"
		reader = _tmp142_;
#line 1278 "../src/Photo.vala"
		_tmp143_ = reader;
#line 1278 "../src/Photo.vala"
		photo_file_reader_set_role (_tmp143_, PHOTO_FILE_READER_ROLE_THUMBNAIL);
#line 10994 "Photo.c"
		{
			Thumbnails* _tmp144_;
			PhotoFileReader* _tmp145_;
			PhotoRow* _tmp146_;
			Orientation _tmp147_;
			PhotoRow* _tmp148_;
			BackingPhotoRow* _tmp149_;
			Dimensions _tmp150_;
#line 1280 "../src/Photo.vala"
			_tmp144_ = params->thumbnails;
#line 1280 "../src/Photo.vala"
			_tmp145_ = reader;
#line 1280 "../src/Photo.vala"
			_tmp146_ = params->row;
#line 1280 "../src/Photo.vala"
			_tmp147_ = _tmp146_->orientation;
#line 1280 "../src/Photo.vala"
			_tmp148_ = params->row;
#line 1280 "../src/Photo.vala"
			_tmp149_ = _tmp148_->master;
#line 1280 "../src/Photo.vala"
			_tmp150_ = _tmp149_->dim;
#line 1280 "../src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp144_, _tmp145_, _tmp147_, &_tmp150_, &_inner_error0_);
#line 1280 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11021 "Photo.c"
				goto __catch310_g_error;
			}
		}
		goto __finally310;
		__catch310_g_error:
		{
			GError* err = NULL;
			GError* _tmp151_;
#line 1279 "../src/Photo.vala"
			err = _inner_error0_;
#line 1279 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1283 "../src/Photo.vala"
			_tmp151_ = err;
#line 1283 "../src/Photo.vala"
			result = import_result_convert_error (_tmp151_, IMPORT_RESULT_FILE_ERROR);
#line 1283 "../src/Photo.vala"
			_g_error_free0 (err);
#line 1283 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1283 "../src/Photo.vala"
			_g_free0 (comment);
#line 1283 "../src/Photo.vala"
			_g_free0 (title);
#line 1283 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1283 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1283 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1283 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1283 "../src/Photo.vala"
			return result;
#line 11056 "Photo.c"
		}
		__finally310:
#line 1279 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1279 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1279 "../src/Photo.vala"
			_g_free0 (comment);
#line 1279 "../src/Photo.vala"
			_g_free0 (title);
#line 1279 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1279 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1279 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1279 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1279 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1279 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1279 "../src/Photo.vala"
			return 0;
#line 11081 "Photo.c"
		}
#line 1275 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 11085 "Photo.c"
	}
#line 1290 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1290 "../src/Photo.vala"
	_g_free0 (comment);
#line 1290 "../src/Photo.vala"
	_g_free0 (title);
#line 1290 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1290 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1290 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1290 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1290 "../src/Photo.vala"
	return result;
#line 11103 "Photo.c"
}


void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoRow* _tmp29_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp30_;
	PhotoFileSnifferOptions _tmp31_;
	PhotoFileInterrogator* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 1293 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1294 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1294 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1294 "../src/Photo.vala"
	file = _tmp1_;
#line 1295 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 1295 "../src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1296 "../src/Photo.vala"
	_tmp3_ = params->row;
#line 1296 "../src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1296 "../src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1296 "../src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1296 "../src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1297 "../src/Photo.vala"
	_tmp6_ = params->row;
#line 1297 "../src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1297 "../src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1298 "../src/Photo.vala"
	_tmp8_ = params->row;
#line 1298 "../src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1298 "../src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1299 "../src/Photo.vala"
	_tmp10_ = params->row;
#line 1299 "../src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1299 "../src/Photo.vala"
	_tmp11_->timestamp = (time_t) 0;
#line 1300 "../src/Photo.vala"
	_tmp12_ = params->row;
#line 1300 "../src/Photo.vala"
	_tmp12_->exposure_time = (time_t) 0;
#line 1301 "../src/Photo.vala"
	_tmp13_ = params->row;
#line 1301 "../src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1302 "../src/Photo.vala"
	_tmp14_ = params->row;
#line 1302 "../src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1302 "../src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1303 "../src/Photo.vala"
	_tmp16_ = params->row;
#line 1303 "../src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1303 "../src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1304 "../src/Photo.vala"
	_tmp18_ = params->row;
#line 1304 "../src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1305 "../src/Photo.vala"
	_tmp19_ = params->row;
#line 1305 "../src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1305 "../src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1306 "../src/Photo.vala"
	_tmp20_ = params->row;
#line 1306 "../src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1306 "../src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1307 "../src/Photo.vala"
	_tmp21_ = params->row;
#line 1307 "../src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1307 "../src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1308 "../src/Photo.vala"
	_tmp22_ = params->row;
#line 1308 "../src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1308 "../src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1309 "../src/Photo.vala"
	_tmp23_ = params->row;
#line 1309 "../src/Photo.vala"
	_tmp23_->time_created = (time_t) 0;
#line 1310 "../src/Photo.vala"
	_tmp24_ = params->row;
#line 1310 "../src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1311 "../src/Photo.vala"
	_tmp25_ = params->row;
#line 1311 "../src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1311 "../src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1312 "../src/Photo.vala"
	_tmp27_ = params->row;
#line 1312 "../src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1312 "../src/Photo.vala"
	_tmp27_->title = NULL;
#line 1313 "../src/Photo.vala"
	_tmp28_ = params->row;
#line 1313 "../src/Photo.vala"
	_g_free0 (_tmp28_->comment);
#line 1313 "../src/Photo.vala"
	_tmp28_->comment = NULL;
#line 1314 "../src/Photo.vala"
	_tmp29_ = params->row;
#line 1314 "../src/Photo.vala"
	_tmp29_->rating = RATING_UNRATED;
#line 1316 "../src/Photo.vala"
	_tmp30_ = params->file;
#line 1316 "../src/Photo.vala"
	_tmp31_ = params->sniffer_options;
#line 1316 "../src/Photo.vala"
	_tmp32_ = photo_file_interrogator_new (_tmp30_, _tmp31_);
#line 1316 "../src/Photo.vala"
	interrogator = _tmp32_;
#line 11272 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp33_;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		DetectedPhotoInformation* _tmp36_;
#line 1318 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1318 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11283 "Photo.c"
			goto __catch311_g_error;
		}
#line 1319 "../src/Photo.vala"
		_tmp33_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1319 "../src/Photo.vala"
		detected = _tmp33_;
#line 1320 "../src/Photo.vala"
		_tmp36_ = detected;
#line 1320 "../src/Photo.vala"
		if (_tmp36_ != NULL) {
#line 1320 "../src/Photo.vala"
			_tmp35_ = !photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 11296 "Photo.c"
		} else {
#line 1320 "../src/Photo.vala"
			_tmp35_ = FALSE;
#line 11300 "Photo.c"
		}
#line 1320 "../src/Photo.vala"
		if (_tmp35_) {
#line 11304 "Photo.c"
			DetectedPhotoInformation* _tmp37_;
			PhotoFileFormat _tmp38_;
#line 1320 "../src/Photo.vala"
			_tmp37_ = detected;
#line 1320 "../src/Photo.vala"
			_tmp38_ = _tmp37_->file_format;
#line 1320 "../src/Photo.vala"
			_tmp34_ = _tmp38_ != PHOTO_FILE_FORMAT_UNKNOWN;
#line 11313 "Photo.c"
		} else {
#line 1320 "../src/Photo.vala"
			_tmp34_ = FALSE;
#line 11317 "Photo.c"
		}
#line 1320 "../src/Photo.vala"
		if (_tmp34_) {
#line 11321 "Photo.c"
			PhotoRow* _tmp39_;
			BackingPhotoRow* _tmp40_;
			DetectedPhotoInformation* _tmp41_;
			PhotoFileFormat _tmp42_;
#line 1321 "../src/Photo.vala"
			_tmp39_ = params->row;
#line 1321 "../src/Photo.vala"
			_tmp40_ = _tmp39_->master;
#line 1321 "../src/Photo.vala"
			_tmp41_ = detected;
#line 1321 "../src/Photo.vala"
			_tmp42_ = _tmp41_->file_format;
#line 1321 "../src/Photo.vala"
			_tmp40_->file_format = _tmp42_;
#line 11336 "Photo.c"
		}
#line 1317 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 11340 "Photo.c"
	}
	goto __finally311;
	__catch311_g_error:
	{
		GError* err = NULL;
		gchar* _tmp43_;
		gchar* _tmp44_;
		GError* _tmp45_;
		const gchar* _tmp46_;
#line 1317 "../src/Photo.vala"
		err = _inner_error0_;
#line 1317 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1323 "../src/Photo.vala"
		_tmp43_ = g_file_get_path (file);
#line 1323 "../src/Photo.vala"
		_tmp44_ = _tmp43_;
#line 1323 "../src/Photo.vala"
		_tmp45_ = err;
#line 1323 "../src/Photo.vala"
		_tmp46_ = _tmp45_->message;
#line 1323 "../src/Photo.vala"
		g_debug ("Photo.vala:1323: Unable to interrogate photo file %s: %s", _tmp44_, _tmp46_);
#line 1323 "../src/Photo.vala"
		_g_free0 (_tmp44_);
#line 1317 "../src/Photo.vala"
		_g_error_free0 (err);
#line 11368 "Photo.c"
	}
	__finally311:
#line 1317 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1317 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1317 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1317 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1317 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1317 "../src/Photo.vala"
		return;
#line 11383 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1293 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 11389 "Photo.c"
}


BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation* * detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp17_;
	GTimeVal _tmp18_ = {0};
	BackingPhotoRow* _tmp19_;
	gchar* _tmp20_;
	BackingPhotoRow* _tmp21_;
	GTimeVal _tmp22_;
	glong _tmp23_;
	BackingPhotoRow* _tmp24_;
	GFileInfo* _tmp25_;
	BackingPhotoRow* _tmp26_;
	DetectedPhotoInformation* _tmp27_;
	PhotoFileFormat _tmp28_;
	BackingPhotoRow* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	Dimensions _tmp31_;
	Orientation _tmp32_ = 0;
	DetectedPhotoInformation* _tmp33_;
	PhotoMetadata* _tmp34_;
	BackingPhotoRow* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 1327 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1327 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1329 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1329 "../src/Photo.vala"
	_vala_detected = NULL;
#line 1331 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1331 "../src/Photo.vala"
	backing = _tmp0_;
#line 1333 "../src/Photo.vala"
	info = NULL;
#line 11447 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1335 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1335 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1335 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11458 "Photo.c"
			goto __catch312_g_error;
		}
#line 1335 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1335 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 1335 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1335 "../src/Photo.vala"
		info = _tmp3_;
#line 1334 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 11471 "Photo.c"
	}
	goto __finally312;
	__catch312_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1334 "../src/Photo.vala"
		err = _inner_error0_;
#line 1334 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1338 "../src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1338 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1338 "../src/Photo.vala"
		_tmp6_ = err;
#line 1338 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1338 "../src/Photo.vala"
		g_critical ("Photo.vala:1338: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1338 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1340 "../src/Photo.vala"
		result = NULL;
#line 1340 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1340 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1340 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1340 "../src/Photo.vala"
		if (detected) {
#line 1340 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11509 "Photo.c"
		} else {
#line 1340 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11513 "Photo.c"
		}
#line 1340 "../src/Photo.vala"
		return result;
#line 11517 "Photo.c"
	}
	__finally312:
#line 1334 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1334 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1334 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1334 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1334 "../src/Photo.vala"
		return NULL;
#line 11530 "Photo.c"
	}
#line 1344 "../src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1344 "../src/Photo.vala"
	interrogator = _tmp8_;
#line 1345 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 1345 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1345 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1345 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1345 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1345 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1345 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1345 "../src/Photo.vala"
		return NULL;
#line 11552 "Photo.c"
	}
#line 1346 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 1346 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1346 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1346 "../src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1347 "../src/Photo.vala"
	_tmp13_ = _vala_detected;
#line 1347 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 1347 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 11568 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp14_;
#line 1347 "../src/Photo.vala"
		_tmp14_ = interrogator;
#line 1347 "../src/Photo.vala"
		_tmp12_ = photo_file_interrogator_get_is_photo_corrupted (_tmp14_);
#line 11575 "Photo.c"
	}
#line 1347 "../src/Photo.vala"
	if (_tmp12_) {
#line 11579 "Photo.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 1348 "../src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 1348 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1348 "../src/Photo.vala"
		g_critical ("Photo.vala:1348: Photo update: %s no longer a recognized image", _tmp16_);
#line 1348 "../src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1350 "../src/Photo.vala"
		result = NULL;
#line 1350 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1350 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1350 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1350 "../src/Photo.vala"
		if (detected) {
#line 1350 "../src/Photo.vala"
			*detected = _vala_detected;
#line 11602 "Photo.c"
		} else {
#line 1350 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11606 "Photo.c"
		}
#line 1350 "../src/Photo.vala"
		return result;
#line 11610 "Photo.c"
	}
#line 1353 "../src/Photo.vala"
	_tmp17_ = info;
#line 1353 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp17_, &_tmp18_);
#line 1353 "../src/Photo.vala"
	modification_time = _tmp18_;
#line 1355 "../src/Photo.vala"
	_tmp19_ = backing;
#line 1355 "../src/Photo.vala"
	_tmp20_ = g_file_get_path (file);
#line 1355 "../src/Photo.vala"
	_g_free0 (_tmp19_->filepath);
#line 1355 "../src/Photo.vala"
	_tmp19_->filepath = _tmp20_;
#line 1356 "../src/Photo.vala"
	_tmp21_ = backing;
#line 1356 "../src/Photo.vala"
	_tmp22_ = modification_time;
#line 1356 "../src/Photo.vala"
	_tmp23_ = _tmp22_.tv_sec;
#line 1356 "../src/Photo.vala"
	_tmp21_->timestamp = (time_t) _tmp23_;
#line 1357 "../src/Photo.vala"
	_tmp24_ = backing;
#line 1357 "../src/Photo.vala"
	_tmp25_ = info;
#line 1357 "../src/Photo.vala"
	_tmp24_->filesize = g_file_info_get_size (_tmp25_);
#line 1358 "../src/Photo.vala"
	_tmp26_ = backing;
#line 1358 "../src/Photo.vala"
	_tmp27_ = _vala_detected;
#line 1358 "../src/Photo.vala"
	_tmp28_ = _tmp27_->file_format;
#line 1358 "../src/Photo.vala"
	_tmp26_->file_format = _tmp28_;
#line 1359 "../src/Photo.vala"
	_tmp29_ = backing;
#line 1359 "../src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1359 "../src/Photo.vala"
	_tmp31_ = _tmp30_->image_dim;
#line 1359 "../src/Photo.vala"
	_tmp29_->dim = _tmp31_;
#line 1360 "../src/Photo.vala"
	_tmp33_ = _vala_detected;
#line 1360 "../src/Photo.vala"
	_tmp34_ = _tmp33_->metadata;
#line 1360 "../src/Photo.vala"
	if (_tmp34_ != NULL) {
#line 11662 "Photo.c"
		DetectedPhotoInformation* _tmp35_;
		PhotoMetadata* _tmp36_;
#line 1361 "../src/Photo.vala"
		_tmp35_ = _vala_detected;
#line 1361 "../src/Photo.vala"
		_tmp36_ = _tmp35_->metadata;
#line 1361 "../src/Photo.vala"
		_tmp32_ = photo_metadata_get_orientation (_tmp36_);
#line 11671 "Photo.c"
	} else {
#line 1361 "../src/Photo.vala"
		_tmp32_ = ORIENTATION_TOP_LEFT;
#line 11675 "Photo.c"
	}
#line 1360 "../src/Photo.vala"
	_tmp37_ = backing;
#line 1360 "../src/Photo.vala"
	_tmp37_->original_orientation = _tmp32_;
#line 1363 "../src/Photo.vala"
	result = backing;
#line 1363 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1363 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1363 "../src/Photo.vala"
	if (detected) {
#line 1363 "../src/Photo.vala"
		*detected = _vala_detected;
#line 11691 "Photo.c"
	} else {
#line 1363 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11695 "Photo.c"
	}
#line 1363 "../src/Photo.vala"
	return result;
#line 11699 "Photo.c"
}


static void
_vala_array_add89 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1459 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1459 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1459 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11715 "Photo.c"
	}
#line 1459 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1459 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11721 "Photo.c"
}


static void
_vala_array_add90 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1462 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1462 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1462 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11737 "Photo.c"
	}
#line 1462 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1462 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11743 "Photo.c"
}


static void
_vala_array_add91 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1469 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1469 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1469 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11759 "Photo.c"
	}
#line 1469 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1469 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11765 "Photo.c"
}


static void
_vala_array_add92 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1472 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1472 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1472 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11781 "Photo.c"
	}
#line 1472 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1472 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11787 "Photo.c"
}


static void
_vala_array_add93 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1475 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1475 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1475 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11803 "Photo.c"
	}
#line 1475 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1475 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11809 "Photo.c"
}


static void
_vala_array_add94 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1478 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1478 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1478 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11825 "Photo.c"
	}
#line 1478 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1478 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11831 "Photo.c"
}


static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1488 "../src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 11840 "Photo.c"
}


gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState* * reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	GdkColorspace _tmp15_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp23_;
	gchar** list = NULL;
	gchar** _tmp29_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow* _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	BackingPhotoRow* _tmp39_;
	Orientation _tmp40_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	PhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	BackingPhotoRow* _tmp85_;
	PhotoRow* _tmp86_;
	DetectedPhotoInformation* _tmp87_;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	PhotoRow* _tmp90_;
	DetectedPhotoInformation* _tmp91_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
	PhotoRow* _tmp94_;
	DetectedPhotoInformation* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp98_;
	PhotoMetadata* _tmp99_;
	PhotoRow* _tmp120_;
	PhotoMetadata* _tmp121_;
	gchar** _tmp122_;
	gint _tmp122__length1;
	PhotoReimportMasterStateImpl* _tmp123_;
	GError* _inner_error0_ = NULL;
#line 1427 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1428 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1428 "../src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1430 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1430 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1430 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1430 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1430 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1430 "../src/Photo.vala"
	file = _tmp3_;
#line 1433 "../src/Photo.vala"
	_tmp4_ = file;
#line 1433 "../src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1433 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1433 "../src/Photo.vala"
	detected = _tmp5_;
#line 1433 "../src/Photo.vala"
	backing = _tmp6_;
#line 1433 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11937 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1433 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1433 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1433 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1433 "../src/Photo.vala"
		return _tmp7_;
#line 11947 "Photo.c"
	}
#line 1435 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1435 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 11953 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1436 "../src/Photo.vala"
		_tmp9_ = file;
#line 1436 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1436 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1436 "../src/Photo.vala"
		g_warning ("Photo.vala:1436: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1436 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1437 "../src/Photo.vala"
		result = FALSE;
#line 1437 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1437 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1437 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1437 "../src/Photo.vala"
		if (reimport_state) {
#line 1437 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11979 "Photo.c"
		} else {
#line 1437 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11983 "Photo.c"
		}
#line 1437 "../src/Photo.vala"
		return result;
#line 11987 "Photo.c"
	}
#line 1441 "../src/Photo.vala"
	_tmp14_ = detected;
#line 1441 "../src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 1441 "../src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 1441 "../src/Photo.vala"
		_tmp13_ = TRUE;
#line 11997 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
		gint _tmp17_;
#line 1442 "../src/Photo.vala"
		_tmp16_ = detected;
#line 1442 "../src/Photo.vala"
		_tmp17_ = _tmp16_->channels;
#line 1442 "../src/Photo.vala"
		_tmp13_ = _tmp17_ < 3;
#line 12007 "Photo.c"
	}
#line 1441 "../src/Photo.vala"
	if (_tmp13_) {
#line 1441 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 12013 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_;
		gint _tmp19_;
#line 1443 "../src/Photo.vala"
		_tmp18_ = detected;
#line 1443 "../src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1443 "../src/Photo.vala"
		_tmp12_ = _tmp19_ != 8;
#line 12023 "Photo.c"
	}
#line 1441 "../src/Photo.vala"
	if (_tmp12_) {
#line 12027 "Photo.c"
		GFile* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1444 "../src/Photo.vala"
		_tmp20_ = file;
#line 1444 "../src/Photo.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 1444 "../src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1444 "../src/Photo.vala"
		g_warning ("Photo.vala:1444: Not re-importing %s: Unsupported color format", _tmp22_);
#line 1444 "../src/Photo.vala"
		_g_free0 (_tmp22_);
#line 1446 "../src/Photo.vala"
		result = FALSE;
#line 1446 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1446 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1446 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1446 "../src/Photo.vala"
		if (reimport_state) {
#line 1446 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12053 "Photo.c"
		} else {
#line 1446 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12057 "Photo.c"
		}
#line 1446 "../src/Photo.vala"
		return result;
#line 12061 "Photo.c"
	}
#line 1450 "../src/Photo.vala"
	_tmp23_ = photo_row_new ();
#line 1450 "../src/Photo.vala"
	updated_row = _tmp23_;
#line 12067 "Photo.c"
	{
		PhotoRow* _tmp24_;
#line 1451 "../src/Photo.vala"
		_tmp24_ = self->row;
#line 1451 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12074 "Photo.c"
		{
			PhotoRow* _tmp25_;
			PhotoRow* _tmp26_;
#line 1452 "../src/Photo.vala"
			_tmp25_ = self->row;
#line 1452 "../src/Photo.vala"
			_tmp26_ = _photo_row_ref0 (_tmp25_);
#line 1452 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1452 "../src/Photo.vala"
			updated_row = _tmp26_;
#line 12086 "Photo.c"
		}
		__finally313:
		{
			PhotoRow* _tmp27_;
#line 1451 "../src/Photo.vala"
			_tmp27_ = self->row;
#line 1451 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12095 "Photo.c"
		}
#line 1451 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12099 "Photo.c"
			gboolean _tmp28_ = FALSE;
#line 1451 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1451 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1451 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1451 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1451 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1451 "../src/Photo.vala"
			return _tmp28_;
#line 12113 "Photo.c"
		}
	}
#line 1456 "../src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1456 "../src/Photo.vala"
	list = _tmp29_;
#line 1456 "../src/Photo.vala"
	list_length1 = 0;
#line 1456 "../src/Photo.vala"
	_list_size_ = list_length1;
#line 1458 "../src/Photo.vala"
	_tmp30_ = updated_row;
#line 1458 "../src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1458 "../src/Photo.vala"
	_tmp32_ = detected;
#line 1458 "../src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1458 "../src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 12134 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 1459 "../src/Photo.vala"
		_tmp34_ = list;
#line 1459 "../src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1459 "../src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1459 "../src/Photo.vala"
		_vala_array_add89 (&list, &list_length1, &_list_size_, _tmp35_);
#line 12146 "Photo.c"
	}
#line 1461 "../src/Photo.vala"
	_tmp36_ = updated_row;
#line 1461 "../src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1461 "../src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1461 "../src/Photo.vala"
	_tmp39_ = backing;
#line 1461 "../src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1461 "../src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 12160 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		PhotoRow* _tmp43_;
		BackingPhotoRow* _tmp44_;
		BackingPhotoRow* _tmp45_;
		Orientation _tmp46_;
#line 1462 "../src/Photo.vala"
		_tmp41_ = list;
#line 1462 "../src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1462 "../src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1462 "../src/Photo.vala"
		_vala_array_add90 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1463 "../src/Photo.vala"
		_tmp43_ = updated_row;
#line 1463 "../src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1463 "../src/Photo.vala"
		_tmp45_ = backing;
#line 1463 "../src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1463 "../src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 12186 "Photo.c"
	}
#line 1466 "../src/Photo.vala"
	_tmp47_ = detected;
#line 1466 "../src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1466 "../src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 12194 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_;
		PhotoRow* _tmp59_;
		const gchar* _tmp60_;
		DetectedPhotoInformation* _tmp61_;
		PhotoMetadata* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gboolean _tmp65_;
		PhotoRow* _tmp68_;
		const gchar* _tmp69_;
		DetectedPhotoInformation* _tmp70_;
		PhotoMetadata* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		gboolean _tmp74_;
		PhotoRow* _tmp77_;
		Rating _tmp78_;
		DetectedPhotoInformation* _tmp79_;
		PhotoMetadata* _tmp80_;
#line 1467 "../src/Photo.vala"
		_tmp49_ = detected;
#line 1467 "../src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1467 "../src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1467 "../src/Photo.vala"
		date_time = _tmp51_;
#line 1468 "../src/Photo.vala"
		_tmp53_ = date_time;
#line 1468 "../src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 12231 "Photo.c"
			PhotoRow* _tmp54_;
			time_t _tmp55_;
			MetadataDateTime* _tmp56_;
#line 1468 "../src/Photo.vala"
			_tmp54_ = updated_row;
#line 1468 "../src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1468 "../src/Photo.vala"
			_tmp56_ = date_time;
#line 1468 "../src/Photo.vala"
			_tmp52_ = _tmp55_ != metadata_date_time_get_timestamp (_tmp56_);
#line 12243 "Photo.c"
		} else {
#line 1468 "../src/Photo.vala"
			_tmp52_ = FALSE;
#line 12247 "Photo.c"
		}
#line 1468 "../src/Photo.vala"
		if (_tmp52_) {
#line 12251 "Photo.c"
			gchar** _tmp57_;
			gint _tmp57__length1;
			gchar* _tmp58_;
#line 1469 "../src/Photo.vala"
			_tmp57_ = list;
#line 1469 "../src/Photo.vala"
			_tmp57__length1 = list_length1;
#line 1469 "../src/Photo.vala"
			_tmp58_ = g_strdup ("metadata:exposure-time");
#line 1469 "../src/Photo.vala"
			_vala_array_add91 (&list, &list_length1, &_list_size_, _tmp58_);
#line 12263 "Photo.c"
		}
#line 1471 "../src/Photo.vala"
		_tmp59_ = updated_row;
#line 1471 "../src/Photo.vala"
		_tmp60_ = _tmp59_->title;
#line 1471 "../src/Photo.vala"
		_tmp61_ = detected;
#line 1471 "../src/Photo.vala"
		_tmp62_ = _tmp61_->metadata;
#line 1471 "../src/Photo.vala"
		_tmp63_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1471 "../src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 1471 "../src/Photo.vala"
		_tmp65_ = g_strcmp0 (_tmp60_, _tmp64_) != 0;
#line 1471 "../src/Photo.vala"
		_g_free0 (_tmp64_);
#line 1471 "../src/Photo.vala"
		if (_tmp65_) {
#line 12283 "Photo.c"
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar* _tmp67_;
#line 1472 "../src/Photo.vala"
			_tmp66_ = list;
#line 1472 "../src/Photo.vala"
			_tmp66__length1 = list_length1;
#line 1472 "../src/Photo.vala"
			_tmp67_ = g_strdup ("metadata:name");
#line 1472 "../src/Photo.vala"
			_vala_array_add92 (&list, &list_length1, &_list_size_, _tmp67_);
#line 12295 "Photo.c"
		}
#line 1474 "../src/Photo.vala"
		_tmp68_ = updated_row;
#line 1474 "../src/Photo.vala"
		_tmp69_ = _tmp68_->comment;
#line 1474 "../src/Photo.vala"
		_tmp70_ = detected;
#line 1474 "../src/Photo.vala"
		_tmp71_ = _tmp70_->metadata;
#line 1474 "../src/Photo.vala"
		_tmp72_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1474 "../src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 1474 "../src/Photo.vala"
		_tmp74_ = g_strcmp0 (_tmp69_, _tmp73_) != 0;
#line 1474 "../src/Photo.vala"
		_g_free0 (_tmp73_);
#line 1474 "../src/Photo.vala"
		if (_tmp74_) {
#line 12315 "Photo.c"
			gchar** _tmp75_;
			gint _tmp75__length1;
			gchar* _tmp76_;
#line 1475 "../src/Photo.vala"
			_tmp75_ = list;
#line 1475 "../src/Photo.vala"
			_tmp75__length1 = list_length1;
#line 1475 "../src/Photo.vala"
			_tmp76_ = g_strdup ("metadata:comment");
#line 1475 "../src/Photo.vala"
			_vala_array_add93 (&list, &list_length1, &_list_size_, _tmp76_);
#line 12327 "Photo.c"
		}
#line 1477 "../src/Photo.vala"
		_tmp77_ = updated_row;
#line 1477 "../src/Photo.vala"
		_tmp78_ = _tmp77_->rating;
#line 1477 "../src/Photo.vala"
		_tmp79_ = detected;
#line 1477 "../src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 1477 "../src/Photo.vala"
		if (_tmp78_ != photo_metadata_get_rating (_tmp80_)) {
#line 12339 "Photo.c"
			gchar** _tmp81_;
			gint _tmp81__length1;
			gchar* _tmp82_;
#line 1478 "../src/Photo.vala"
			_tmp81_ = list;
#line 1478 "../src/Photo.vala"
			_tmp81__length1 = list_length1;
#line 1478 "../src/Photo.vala"
			_tmp82_ = g_strdup ("metadata:rating");
#line 1478 "../src/Photo.vala"
			_vala_array_add94 (&list, &list_length1, &_list_size_, _tmp82_);
#line 12351 "Photo.c"
		}
#line 1466 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12355 "Photo.c"
	}
#line 1481 "../src/Photo.vala"
	_tmp83_ = updated_row;
#line 1481 "../src/Photo.vala"
	_tmp84_ = backing;
#line 1481 "../src/Photo.vala"
	_tmp85_ = _backing_photo_row_ref0 (_tmp84_);
#line 1481 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp83_->master);
#line 1481 "../src/Photo.vala"
	_tmp83_->master = _tmp85_;
#line 1482 "../src/Photo.vala"
	_tmp86_ = updated_row;
#line 1482 "../src/Photo.vala"
	_tmp87_ = detected;
#line 1482 "../src/Photo.vala"
	_tmp88_ = _tmp87_->md5;
#line 1482 "../src/Photo.vala"
	_tmp89_ = g_strdup (_tmp88_);
#line 1482 "../src/Photo.vala"
	_g_free0 (_tmp86_->md5);
#line 1482 "../src/Photo.vala"
	_tmp86_->md5 = _tmp89_;
#line 1483 "../src/Photo.vala"
	_tmp90_ = updated_row;
#line 1483 "../src/Photo.vala"
	_tmp91_ = detected;
#line 1483 "../src/Photo.vala"
	_tmp92_ = _tmp91_->exif_md5;
#line 1483 "../src/Photo.vala"
	_tmp93_ = g_strdup (_tmp92_);
#line 1483 "../src/Photo.vala"
	_g_free0 (_tmp90_->exif_md5);
#line 1483 "../src/Photo.vala"
	_tmp90_->exif_md5 = _tmp93_;
#line 1484 "../src/Photo.vala"
	_tmp94_ = updated_row;
#line 1484 "../src/Photo.vala"
	_tmp95_ = detected;
#line 1484 "../src/Photo.vala"
	_tmp96_ = _tmp95_->thumbnail_md5;
#line 1484 "../src/Photo.vala"
	_tmp97_ = g_strdup (_tmp96_);
#line 1484 "../src/Photo.vala"
	_g_free0 (_tmp94_->thumbnail_md5);
#line 1484 "../src/Photo.vala"
	_tmp94_->thumbnail_md5 = _tmp97_;
#line 1486 "../src/Photo.vala"
	metadata = NULL;
#line 1487 "../src/Photo.vala"
	_tmp98_ = detected;
#line 1487 "../src/Photo.vala"
	_tmp99_ = _tmp98_->metadata;
#line 1487 "../src/Photo.vala"
	if (_tmp99_ != NULL) {
#line 12411 "Photo.c"
		DetectedPhotoInformation* _tmp100_;
		PhotoMetadata* _tmp101_;
		PhotoMetadata* _tmp102_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp103_;
		PhotoMetadata* _tmp104_;
		MetadataDateTime* _tmp105_;
		MetadataDateTime* _tmp106_;
		PhotoRow* _tmp109_;
		DetectedPhotoInformation* _tmp110_;
		PhotoMetadata* _tmp111_;
		gchar* _tmp112_;
		PhotoRow* _tmp113_;
		DetectedPhotoInformation* _tmp114_;
		PhotoMetadata* _tmp115_;
		gchar* _tmp116_;
		PhotoRow* _tmp117_;
		DetectedPhotoInformation* _tmp118_;
		PhotoMetadata* _tmp119_;
#line 1488 "../src/Photo.vala"
		_tmp100_ = detected;
#line 1488 "../src/Photo.vala"
		_tmp101_ = _tmp100_->metadata;
#line 1488 "../src/Photo.vala"
		_tmp102_ = _media_metadata_ref0 (_tmp101_);
#line 1488 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1488 "../src/Photo.vala"
		metadata = _tmp102_;
#line 1490 "../src/Photo.vala"
		_tmp103_ = detected;
#line 1490 "../src/Photo.vala"
		_tmp104_ = _tmp103_->metadata;
#line 1490 "../src/Photo.vala"
		_tmp105_ = photo_metadata_get_exposure_date_time (_tmp104_);
#line 1490 "../src/Photo.vala"
		date_time = _tmp105_;
#line 1491 "../src/Photo.vala"
		_tmp106_ = date_time;
#line 1491 "../src/Photo.vala"
		if (_tmp106_ != NULL) {
#line 12453 "Photo.c"
			PhotoRow* _tmp107_;
			MetadataDateTime* _tmp108_;
#line 1492 "../src/Photo.vala"
			_tmp107_ = updated_row;
#line 1492 "../src/Photo.vala"
			_tmp108_ = date_time;
#line 1492 "../src/Photo.vala"
			_tmp107_->exposure_time = metadata_date_time_get_timestamp (_tmp108_);
#line 12462 "Photo.c"
		}
#line 1494 "../src/Photo.vala"
		_tmp109_ = updated_row;
#line 1494 "../src/Photo.vala"
		_tmp110_ = detected;
#line 1494 "../src/Photo.vala"
		_tmp111_ = _tmp110_->metadata;
#line 1494 "../src/Photo.vala"
		_tmp112_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1494 "../src/Photo.vala"
		_g_free0 (_tmp109_->title);
#line 1494 "../src/Photo.vala"
		_tmp109_->title = _tmp112_;
#line 1495 "../src/Photo.vala"
		_tmp113_ = updated_row;
#line 1495 "../src/Photo.vala"
		_tmp114_ = detected;
#line 1495 "../src/Photo.vala"
		_tmp115_ = _tmp114_->metadata;
#line 1495 "../src/Photo.vala"
		_tmp116_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp115_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1495 "../src/Photo.vala"
		_g_free0 (_tmp113_->comment);
#line 1495 "../src/Photo.vala"
		_tmp113_->comment = _tmp116_;
#line 1496 "../src/Photo.vala"
		_tmp117_ = updated_row;
#line 1496 "../src/Photo.vala"
		_tmp118_ = detected;
#line 1496 "../src/Photo.vala"
		_tmp119_ = _tmp118_->metadata;
#line 1496 "../src/Photo.vala"
		_tmp117_->rating = photo_metadata_get_rating (_tmp119_);
#line 1487 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12498 "Photo.c"
	}
#line 1499 "../src/Photo.vala"
	_tmp120_ = updated_row;
#line 1499 "../src/Photo.vala"
	_tmp121_ = metadata;
#line 1499 "../src/Photo.vala"
	_tmp122_ = list;
#line 1499 "../src/Photo.vala"
	_tmp122__length1 = list_length1;
#line 1499 "../src/Photo.vala"
	_tmp123_ = photo_reimport_master_state_impl_new (_tmp120_, _tmp121_, _tmp122_, _tmp122__length1);
#line 1499 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1499 "../src/Photo.vala"
	_vala_reimport_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1501 "../src/Photo.vala"
	result = TRUE;
#line 1501 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1501 "../src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1501 "../src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1501 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1501 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1501 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1501 "../src/Photo.vala"
	if (reimport_state) {
#line 1501 "../src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 12532 "Photo.c"
	} else {
#line 1501 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12536 "Photo.c"
	}
#line 1501 "../src/Photo.vala"
	return result;
#line 12540 "Photo.c"
}


static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1504 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1504 "../src/Photo.vala"
	return;
#line 12552 "Photo.c"
}


void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
#line 1504 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1504 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 12564 "Photo.c"
}


static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1508 "../src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 12573 "Photo.c"
}


static void
_vala_array_add95 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1526 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1526 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1526 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12589 "Photo.c"
	}
#line 1526 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1526 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12595 "Photo.c"
}


static void
_vala_array_add96 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1528 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1528 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1528 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12611 "Photo.c"
	}
#line 1528 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1528 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 12617 "Photo.c"
}


void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp19_;
	gboolean _tmp21_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	PhotoMetadata* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 1507 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1507 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1508 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1508 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 1510 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1510 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1510 "../src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1510 "../src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1510 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1510 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1510 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1510 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1510 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1510 "../src/Photo.vala"
			return;
#line 12665 "Photo.c"
		} else {
#line 1510 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1510 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1510 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1510 "../src/Photo.vala"
			return;
#line 12675 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1512 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1512 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12684 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
			gboolean _tmp17_;
#line 1514 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1514 "../src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1514 "../src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1514 "../src/Photo.vala"
			original_master = _tmp7_;
#line 1515 "../src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1515 "../src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1515 "../src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1515 "../src/Photo.vala"
			self->row = _tmp9_;
#line 1516 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 1516 "../src/Photo.vala"
			_tmp11_ = original_master;
#line 1516 "../src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1516 "../src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1516 "../src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1517 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1517 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1517 "../src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1517 "../src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1517 "../src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1518 "../src/Photo.vala"
			_tmp17_ = reimport_state->metadata_only;
#line 1518 "../src/Photo.vala"
			if (!_tmp17_) {
#line 1519 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 12742 "Photo.c"
			}
#line 1512 "../src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 12746 "Photo.c"
		}
		__finally314:
		{
			PhotoRow* _tmp18_;
#line 1512 "../src/Photo.vala"
			_tmp18_ = self->row;
#line 1512 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12755 "Photo.c"
		}
#line 1512 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1512 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1512 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1512 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1512 "../src/Photo.vala"
				return;
#line 12767 "Photo.c"
			} else {
#line 1512 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1512 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1512 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1512 "../src/Photo.vala"
				return;
#line 12777 "Photo.c"
			}
		}
	}
#line 1522 "../src/Photo.vala"
	_tmp19_ = reimport_state->metadata;
#line 1522 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 12785 "Photo.c"
		PhotoMetadata* _tmp20_;
#line 1523 "../src/Photo.vala"
		_tmp20_ = reimport_state->metadata;
#line 1523 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp20_);
#line 12791 "Photo.c"
	}
#line 1525 "../src/Photo.vala"
	_tmp21_ = reimport_state->metadata_only;
#line 1525 "../src/Photo.vala"
	if (!_tmp21_) {
#line 12797 "Photo.c"
		gchar** _tmp22_;
		gint _tmp22__length1;
		gchar* _tmp23_;
#line 1526 "../src/Photo.vala"
		_tmp22_ = reimport_state->alterations;
#line 1526 "../src/Photo.vala"
		_tmp22__length1 = reimport_state->alterations_length1;
#line 1526 "../src/Photo.vala"
		_tmp23_ = g_strdup ("image:master");
#line 1526 "../src/Photo.vala"
		_vala_array_add95 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp23_);
#line 1527 "../src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 12811 "Photo.c"
			gchar** _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp25_;
#line 1528 "../src/Photo.vala"
			_tmp24_ = reimport_state->alterations;
#line 1528 "../src/Photo.vala"
			_tmp24__length1 = reimport_state->alterations_length1;
#line 1528 "../src/Photo.vala"
			_tmp25_ = g_strdup ("image:baseline");
#line 1528 "../src/Photo.vala"
			_vala_array_add96 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp25_);
#line 12823 "Photo.c"
		}
	}
#line 1531 "../src/Photo.vala"
	_tmp26_ = reimport_state->alterations;
#line 1531 "../src/Photo.vala"
	_tmp26__length1 = reimport_state->alterations_length1;
#line 1531 "../src/Photo.vala"
	if (_tmp26__length1 > 0) {
#line 12832 "Photo.c"
		gchar** _tmp27_;
		gint _tmp27__length1;
		Alteration* _tmp28_;
		Alteration* _tmp29_;
#line 1532 "../src/Photo.vala"
		_tmp27_ = reimport_state->alterations;
#line 1532 "../src/Photo.vala"
		_tmp27__length1 = reimport_state->alterations_length1;
#line 1532 "../src/Photo.vala"
		_tmp28_ = alteration_new_from_array (_tmp27_, _tmp27__length1);
#line 1532 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1532 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp29_);
#line 1532 "../src/Photo.vala"
		_alteration_unref0 (_tmp29_);
#line 12849 "Photo.c"
	}
#line 1534 "../src/Photo.vala"
	_tmp30_ = reimport_state->metadata;
#line 1534 "../src/Photo.vala"
	photo_notify_master_reimported (self, _tmp30_);
#line 1536 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 12857 "Photo.c"
		PhotoMetadata* _tmp31_;
#line 1537 "../src/Photo.vala"
		_tmp31_ = reimport_state->metadata;
#line 1537 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp31_);
#line 12863 "Photo.c"
	}
#line 1539 "../src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 12867 "Photo.c"
		PhotoMetadata* _tmp32_;
#line 1540 "../src/Photo.vala"
		_tmp32_ = reimport_state->metadata;
#line 1540 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp32_);
#line 12873 "Photo.c"
	}
#line 1507 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 12877 "Photo.c"
}


static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow* * backing,
                                DetectedPhotoInformation* * detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GdkColorspace _tmp9_;
	GError* _inner_error0_ = NULL;
#line 1544 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1544 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1546 "../src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1546 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1546 "../src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1546 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1546 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12915 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1546 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1546 "../src/Photo.vala"
		return _tmp3_;
#line 12921 "Photo.c"
	}
#line 1546 "../src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1546 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1546 "../src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1546 "../src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1548 "../src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1548 "../src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1549 "../src/Photo.vala"
		result = FALSE;
#line 1549 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1549 "../src/Photo.vala"
		if (backing) {
#line 1549 "../src/Photo.vala"
			*backing = _vala_backing;
#line 12943 "Photo.c"
		} else {
#line 1549 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12947 "Photo.c"
		}
#line 1549 "../src/Photo.vala"
		if (detected) {
#line 1549 "../src/Photo.vala"
			*detected = _vala_detected;
#line 12953 "Photo.c"
		} else {
#line 1549 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12957 "Photo.c"
		}
#line 1549 "../src/Photo.vala"
		return result;
#line 12961 "Photo.c"
	}
#line 1553 "../src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1553 "../src/Photo.vala"
	_tmp9_ = _tmp8_->colorspace;
#line 1553 "../src/Photo.vala"
	if (_tmp9_ != GDK_COLORSPACE_RGB) {
#line 1553 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 12971 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
		gint _tmp11_;
#line 1554 "../src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1554 "../src/Photo.vala"
		_tmp11_ = _tmp10_->channels;
#line 1554 "../src/Photo.vala"
		_tmp7_ = _tmp11_ < 3;
#line 12981 "Photo.c"
	}
#line 1553 "../src/Photo.vala"
	if (_tmp7_) {
#line 1553 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 12987 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_;
		gint _tmp13_;
#line 1555 "../src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1555 "../src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1555 "../src/Photo.vala"
		_tmp6_ = _tmp13_ != 8;
#line 12997 "Photo.c"
	}
#line 1553 "../src/Photo.vala"
	if (_tmp6_) {
#line 13001 "Photo.c"
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1556 "../src/Photo.vala"
		_tmp14_ = g_file_get_path (file);
#line 1556 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1556 "../src/Photo.vala"
		g_warning ("Photo.vala:1556: Not re-importing %s: Unsupported color format", _tmp15_);
#line 1556 "../src/Photo.vala"
		_g_free0 (_tmp15_);
#line 1558 "../src/Photo.vala"
		result = FALSE;
#line 1558 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1558 "../src/Photo.vala"
		if (backing) {
#line 1558 "../src/Photo.vala"
			*backing = _vala_backing;
#line 13020 "Photo.c"
		} else {
#line 1558 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 13024 "Photo.c"
		}
#line 1558 "../src/Photo.vala"
		if (detected) {
#line 1558 "../src/Photo.vala"
			*detected = _vala_detected;
#line 13030 "Photo.c"
		} else {
#line 1558 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 13034 "Photo.c"
		}
#line 1558 "../src/Photo.vala"
		return result;
#line 13038 "Photo.c"
	}
#line 1561 "../src/Photo.vala"
	result = TRUE;
#line 1561 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1561 "../src/Photo.vala"
	if (backing) {
#line 1561 "../src/Photo.vala"
		*backing = _vala_backing;
#line 13048 "Photo.c"
	} else {
#line 1561 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 13052 "Photo.c"
	}
#line 1561 "../src/Photo.vala"
	if (detected) {
#line 1561 "../src/Photo.vala"
		*detected = _vala_detected;
#line 13058 "Photo.c"
	} else {
#line 1561 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 13062 "Photo.c"
	}
#line 1561 "../src/Photo.vala"
	return result;
#line 13066 "Photo.c"
}


gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* * state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1565 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1566 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1566 "../src/Photo.vala"
	_vala_state = NULL;
#line 1568 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1568 "../src/Photo.vala"
	file = _tmp0_;
#line 1569 "../src/Photo.vala"
	_tmp1_ = file;
#line 1569 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1570 "../src/Photo.vala"
		result = FALSE;
#line 1570 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1570 "../src/Photo.vala"
		if (state) {
#line 1570 "../src/Photo.vala"
			*state = _vala_state;
#line 13114 "Photo.c"
		} else {
#line 1570 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13118 "Photo.c"
		}
#line 1570 "../src/Photo.vala"
		return result;
#line 13122 "Photo.c"
	}
#line 1574 "../src/Photo.vala"
	_tmp3_ = file;
#line 1574 "../src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1574 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1574 "../src/Photo.vala"
	backing = _tmp4_;
#line 1574 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1574 "../src/Photo.vala"
	detected = _tmp5_;
#line 1574 "../src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1574 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13140 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1574 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1574 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1574 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1574 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1574 "../src/Photo.vala"
		return _tmp7_;
#line 13152 "Photo.c"
	}
#line 1574 "../src/Photo.vala"
	if (!_tmp2_) {
#line 1575 "../src/Photo.vala"
		result = FALSE;
#line 1575 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1575 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1575 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1575 "../src/Photo.vala"
		if (state) {
#line 1575 "../src/Photo.vala"
			*state = _vala_state;
#line 13168 "Photo.c"
		} else {
#line 1575 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13172 "Photo.c"
		}
#line 1575 "../src/Photo.vala"
		return result;
#line 13176 "Photo.c"
	}
#line 1577 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1577 "../src/Photo.vala"
	_tmp9_ = detected;
#line 1577 "../src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1577 "../src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1577 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1577 "../src/Photo.vala"
	_vala_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1579 "../src/Photo.vala"
	result = TRUE;
#line 1579 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1579 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1579 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1579 "../src/Photo.vala"
	if (state) {
#line 1579 "../src/Photo.vala"
		*state = _vala_state;
#line 13202 "Photo.c"
	} else {
#line 1579 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 13206 "Photo.c"
	}
#line 1579 "../src/Photo.vala"
	return result;
#line 13210 "Photo.c"
}


static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1588 "../src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 13219 "Photo.c"
}


void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	gboolean _tmp3_;
	PhotoReimportEditableStateImpl* _tmp19_;
	PhotoMetadata* _tmp20_;
	gchar* list = NULL;
	gchar* _tmp33_;
	PhotoReimportEditableStateImpl* _tmp34_;
	gboolean _tmp35_;
	const gchar* _tmp38_;
	Alteration* _tmp39_;
	Alteration* _tmp40_;
	PhotoReimportEditableStateImpl* _tmp41_;
	PhotoMetadata* _tmp42_;
	GError* _inner_error0_ = NULL;
#line 1583 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1583 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1584 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1584 "../src/Photo.vala"
	editable_id = _tmp0_;
#line 1585 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1586 "../src/Photo.vala"
		return;
#line 13258 "Photo.c"
	}
#line 1588 "../src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1588 "../src/Photo.vala"
	reimport_state = _tmp1_;
#line 1590 "../src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1590 "../src/Photo.vala"
	_tmp3_ = _tmp2_->metadata_only;
#line 1590 "../src/Photo.vala"
	if (!_tmp3_) {
#line 13270 "Photo.c"
		BackingPhotoTable* _tmp4_;
		BackingPhotoTable* _tmp5_;
		PhotoReimportEditableStateImpl* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 1591 "../src/Photo.vala"
		_tmp4_ = backing_photo_table_get_instance ();
#line 1591 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1591 "../src/Photo.vala"
		_tmp6_ = reimport_state;
#line 1591 "../src/Photo.vala"
		_tmp7_ = _tmp6_->backing_state;
#line 1591 "../src/Photo.vala"
		backing_photo_table_update (_tmp5_, _tmp7_, &_inner_error0_);
#line 1591 "../src/Photo.vala"
		_database_table_unref0 (_tmp5_);
#line 1591 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1591 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1591 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1591 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1591 "../src/Photo.vala"
				return;
#line 13297 "Photo.c"
			} else {
#line 1591 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1591 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1591 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1591 "../src/Photo.vala"
				return;
#line 13307 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp8_;
#line 1593 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 1593 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13316 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp9_;
				BackingPhotoRow* _tmp10_;
				BackingPhotoRow* _tmp11_;
				PhotoReimportEditableStateImpl* _tmp12_;
				BackingPhotoRow* _tmp13_;
				Orientation _tmp14_;
#line 1594 "../src/Photo.vala"
				_tmp9_ = reimport_state;
#line 1594 "../src/Photo.vala"
				_tmp10_ = _tmp9_->backing_state;
#line 1594 "../src/Photo.vala"
				_tmp11_ = _backing_photo_row_ref0 (_tmp10_);
#line 1594 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1594 "../src/Photo.vala"
				self->priv->editable = _tmp11_;
#line 1595 "../src/Photo.vala"
				_tmp12_ = reimport_state;
#line 1595 "../src/Photo.vala"
				_tmp13_ = _tmp12_->backing_state;
#line 1595 "../src/Photo.vala"
				_tmp14_ = _tmp13_->original_orientation;
#line 1595 "../src/Photo.vala"
				photo_set_orientation (self, _tmp14_);
#line 1596 "../src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 13344 "Photo.c"
			}
			__finally315:
			{
				PhotoRow* _tmp15_;
#line 1593 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 1593 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13353 "Photo.c"
			}
#line 1593 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1593 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1593 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1593 "../src/Photo.vala"
					return;
#line 13365 "Photo.c"
				} else {
#line 1593 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1593 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1593 "../src/Photo.vala"
					return;
#line 13375 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp16_;
		BackingPhotoRow* _tmp17_;
		Orientation _tmp18_;
#line 1599 "../src/Photo.vala"
		_tmp16_ = reimport_state;
#line 1599 "../src/Photo.vala"
		_tmp17_ = _tmp16_->backing_state;
#line 1599 "../src/Photo.vala"
		_tmp18_ = _tmp17_->original_orientation;
#line 1599 "../src/Photo.vala"
		photo_set_orientation (self, _tmp18_);
#line 13391 "Photo.c"
	}
#line 1602 "../src/Photo.vala"
	_tmp19_ = reimport_state;
#line 1602 "../src/Photo.vala"
	_tmp20_ = _tmp19_->metadata;
#line 1602 "../src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 13399 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp21_;
		PhotoMetadata* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		PhotoReimportEditableStateImpl* _tmp25_;
		PhotoMetadata* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		PhotoReimportEditableStateImpl* _tmp29_;
		PhotoMetadata* _tmp30_;
		PhotoReimportEditableStateImpl* _tmp31_;
		PhotoMetadata* _tmp32_;
#line 1603 "../src/Photo.vala"
		_tmp21_ = reimport_state;
#line 1603 "../src/Photo.vala"
		_tmp22_ = _tmp21_->metadata;
#line 1603 "../src/Photo.vala"
		_tmp23_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1603 "../src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 1603 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp24_);
#line 1603 "../src/Photo.vala"
		_g_free0 (_tmp24_);
#line 1604 "../src/Photo.vala"
		_tmp25_ = reimport_state;
#line 1604 "../src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 1604 "../src/Photo.vala"
		_tmp27_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1604 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 1604 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp28_);
#line 1604 "../src/Photo.vala"
		_g_free0 (_tmp28_);
#line 1605 "../src/Photo.vala"
		_tmp29_ = reimport_state;
#line 1605 "../src/Photo.vala"
		_tmp30_ = _tmp29_->metadata;
#line 1605 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), photo_metadata_get_rating (_tmp30_));
#line 1606 "../src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1606 "../src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1606 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 13448 "Photo.c"
	}
#line 1609 "../src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1609 "../src/Photo.vala"
	list = _tmp33_;
#line 1610 "../src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1610 "../src/Photo.vala"
	_tmp35_ = _tmp34_->metadata_only;
#line 1610 "../src/Photo.vala"
	if (!_tmp35_) {
#line 13460 "Photo.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
#line 1611 "../src/Photo.vala"
		_tmp36_ = list;
#line 1611 "../src/Photo.vala"
		_tmp37_ = g_strconcat (_tmp36_, "image:editable,image:baseline", NULL);
#line 1611 "../src/Photo.vala"
		_g_free0 (list);
#line 1611 "../src/Photo.vala"
		list = _tmp37_;
#line 13471 "Photo.c"
	}
#line 1613 "../src/Photo.vala"
	_tmp38_ = list;
#line 1613 "../src/Photo.vala"
	_tmp39_ = alteration_new_from_list (_tmp38_);
#line 1613 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 1613 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp40_);
#line 1613 "../src/Photo.vala"
	_alteration_unref0 (_tmp40_);
#line 1615 "../src/Photo.vala"
	_tmp41_ = reimport_state;
#line 1615 "../src/Photo.vala"
	_tmp42_ = _tmp41_->metadata;
#line 1615 "../src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp42_);
#line 1617 "../src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 13491 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp43_;
		PhotoMetadata* _tmp44_;
#line 1618 "../src/Photo.vala"
		_tmp43_ = reimport_state;
#line 1618 "../src/Photo.vala"
		_tmp44_ = _tmp43_->metadata;
#line 1618 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp44_);
#line 13500 "Photo.c"
	}
#line 1620 "../src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 13504 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp45_;
		PhotoMetadata* _tmp46_;
#line 1621 "../src/Photo.vala"
		_tmp45_ = reimport_state;
#line 1621 "../src/Photo.vala"
		_tmp46_ = _tmp45_->metadata;
#line 1621 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp46_);
#line 13513 "Photo.c"
	}
#line 1583 "../src/Photo.vala"
	_g_free0 (list);
#line 1583 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 13519 "Photo.c"
}


static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1643 "../src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 13528 "Photo.c"
}


gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* * state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 1625 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1626 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1626 "../src/Photo.vala"
	_vala_state = NULL;
#line 1628 "../src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1628 "../src/Photo.vala"
	files = _tmp0_;
#line 1629 "../src/Photo.vala"
	_tmp1_ = files;
#line 1629 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1630 "../src/Photo.vala"
		result = FALSE;
#line 1630 "../src/Photo.vala"
		_g_object_unref0 (files);
#line 1630 "../src/Photo.vala"
		if (state) {
#line 1630 "../src/Photo.vala"
			*state = _vala_state;
#line 13570 "Photo.c"
		} else {
#line 1630 "../src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13574 "Photo.c"
		}
#line 1630 "../src/Photo.vala"
		return result;
#line 13578 "Photo.c"
	}
#line 1632 "../src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1632 "../src/Photo.vala"
	reimport_state = _tmp2_;
#line 13584 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1634 "../src/Photo.vala"
		_tmp3_ = files;
#line 1634 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1634 "../src/Photo.vala"
		_file_it = _tmp4_;
#line 1634 "../src/Photo.vala"
		while (TRUE) {
#line 13597 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1634 "../src/Photo.vala"
			_tmp5_ = _file_it;
#line 1634 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1634 "../src/Photo.vala"
				break;
#line 13619 "Photo.c"
			}
#line 1634 "../src/Photo.vala"
			_tmp6_ = _file_it;
#line 1634 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1634 "../src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1637 "../src/Photo.vala"
			_tmp9_ = file;
#line 1637 "../src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1637 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1637 "../src/Photo.vala"
			backing = _tmp10_;
#line 1637 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1637 "../src/Photo.vala"
			detected = _tmp11_;
#line 1637 "../src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1637 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13643 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1637 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1637 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1637 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1637 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1637 "../src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1637 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1637 "../src/Photo.vala"
				_g_object_unref0 (files);
#line 1637 "../src/Photo.vala"
				return _tmp13_;
#line 13661 "Photo.c"
			}
#line 1637 "../src/Photo.vala"
			if (!_tmp8_) {
#line 1638 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1638 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1638 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1638 "../src/Photo.vala"
				continue;
#line 13673 "Photo.c"
			}
#line 1640 "../src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1640 "../src/Photo.vala"
			_tmp15_ = backing;
#line 1640 "../src/Photo.vala"
			_tmp16_ = detected;
#line 1640 "../src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1640 "../src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1634 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1634 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1634 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 13691 "Photo.c"
		}
#line 1634 "../src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 13695 "Photo.c"
	}
#line 1643 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1643 "../src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState));
#line 1643 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1643 "../src/Photo.vala"
	_vala_state = _tmp19_;
#line 1644 "../src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1644 "../src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1644 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1644 "../src/Photo.vala"
	_g_object_unref0 (files);
#line 1644 "../src/Photo.vala"
	if (state) {
#line 1644 "../src/Photo.vala"
		*state = _vala_state;
#line 13717 "Photo.c"
	} else {
#line 1644 "../src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13721 "Photo.c"
	}
#line 1644 "../src/Photo.vala"
	return result;
#line 13725 "Photo.c"
}


void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp29_;
	PhotoReimportRawDevelopmentStateImpl* _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp34_;
	Alteration* _tmp35_;
	Alteration* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1648 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1648 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1649 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1650 "../src/Photo.vala"
		return;
#line 13752 "Photo.c"
	}
#line 1652 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1652 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 13758 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1654 "../src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1654 "../src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1654 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1654 "../src/Photo.vala"
		_dev_it = _tmp3_;
#line 1654 "../src/Photo.vala"
		while (TRUE) {
#line 13774 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
			gboolean _tmp8_;
#line 1654 "../src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1654 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1654 "../src/Photo.vala"
				break;
#line 13787 "Photo.c"
			}
#line 1654 "../src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1654 "../src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1654 "../src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1655 "../src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1655 "../src/Photo.vala"
			_tmp8_ = _tmp7_->metadata_only;
#line 1655 "../src/Photo.vala"
			if (!_tmp8_) {
#line 13801 "Photo.c"
				BackingPhotoTable* _tmp9_;
				BackingPhotoTable* _tmp10_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1656 "../src/Photo.vala"
				_tmp9_ = backing_photo_table_get_instance ();
#line 1656 "../src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1656 "../src/Photo.vala"
				_tmp11_ = dev;
#line 1656 "../src/Photo.vala"
				_tmp12_ = _tmp11_->backing;
#line 1656 "../src/Photo.vala"
				backing_photo_table_update (_tmp10_, _tmp12_, &_inner_error0_);
#line 1656 "../src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1656 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1656 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1656 "../src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1656 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1656 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1656 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1656 "../src/Photo.vala"
						return;
#line 13832 "Photo.c"
					} else {
#line 1656 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1656 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1656 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1656 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1656 "../src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1656 "../src/Photo.vala"
						return;
#line 13846 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp13_;
#line 1658 "../src/Photo.vala"
					_tmp13_ = self->row;
#line 1658 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 13855 "Photo.c"
					{
						gint _tmp14_ = 0;
						RawDeveloper* _tmp15_;
#line 1660 "../src/Photo.vala"
						_tmp15_ = raw_developer_as_array (&_tmp14_);
#line 13861 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1660 "../src/Photo.vala"
							d_collection = _tmp15_;
#line 1660 "../src/Photo.vala"
							d_collection_length1 = _tmp14_;
#line 1660 "../src/Photo.vala"
							for (d_it = 0; d_it < _tmp14_; d_it = d_it + 1) {
#line 13873 "Photo.c"
								RawDeveloper d = 0;
#line 1660 "../src/Photo.vala"
								d = d_collection[d_it];
#line 13877 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp16_;
									BackingPhotoID* _tmp17_;
									gint _tmp17__length1;
									RawDeveloper _tmp18_;
									BackingPhotoID _tmp19_;
									BackingPhotoID _tmp20_;
									gint64 _tmp21_;
#line 1661 "../src/Photo.vala"
									_tmp16_ = self->row;
#line 1661 "../src/Photo.vala"
									_tmp17_ = _tmp16_->development_ids;
#line 1661 "../src/Photo.vala"
									_tmp17__length1 = _tmp16_->development_ids_length1;
#line 1661 "../src/Photo.vala"
									_tmp18_ = d;
#line 1661 "../src/Photo.vala"
									_tmp19_ = _tmp17_[_tmp18_];
#line 1661 "../src/Photo.vala"
									id = _tmp19_;
#line 1662 "../src/Photo.vala"
									_tmp20_ = id;
#line 1662 "../src/Photo.vala"
									_tmp21_ = _tmp20_.id;
#line 1662 "../src/Photo.vala"
									if (_tmp21_ != BACKING_PHOTO_ID_INVALID) {
#line 13905 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp22_;
										BackingPhotoRow* _tmp23_;
										BackingPhotoRow* _tmp24_;
#line 1663 "../src/Photo.vala"
										_tmp22_ = id;
#line 1663 "../src/Photo.vala"
										_tmp23_ = photo_get_backing_row (self, &_tmp22_);
#line 1663 "../src/Photo.vala"
										bpr = _tmp23_;
#line 1664 "../src/Photo.vala"
										_tmp24_ = bpr;
#line 1664 "../src/Photo.vala"
										if (_tmp24_ != NULL) {
#line 13920 "Photo.c"
											GeeHashMap* _tmp25_;
											RawDeveloper _tmp26_;
											BackingPhotoRow* _tmp27_;
#line 1665 "../src/Photo.vala"
											_tmp25_ = self->priv->developments;
#line 1665 "../src/Photo.vala"
											_tmp26_ = d;
#line 1665 "../src/Photo.vala"
											_tmp27_ = bpr;
#line 1665 "../src/Photo.vala"
											gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp26_), _tmp27_);
#line 13932 "Photo.c"
										}
#line 1662 "../src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 13936 "Photo.c"
									}
								}
							}
#line 1660 "../src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 13942 "Photo.c"
						}
					}
					__finally316:
					{
						PhotoRow* _tmp28_;
#line 1658 "../src/Photo.vala"
						_tmp28_ = self->row;
#line 1658 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13952 "Photo.c"
					}
#line 1658 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1658 "../src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1658 "../src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1658 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1658 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1658 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1658 "../src/Photo.vala"
							return;
#line 13968 "Photo.c"
						} else {
#line 1658 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1658 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1658 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1658 "../src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1658 "../src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1658 "../src/Photo.vala"
							return;
#line 13982 "Photo.c"
						}
					}
				}
			}
#line 1654 "../src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 13989 "Photo.c"
		}
#line 1654 "../src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 13993 "Photo.c"
	}
#line 1672 "../src/Photo.vala"
	_tmp29_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1672 "../src/Photo.vala"
	list = _tmp29_;
#line 1673 "../src/Photo.vala"
	_tmp30_ = reimport_state;
#line 1673 "../src/Photo.vala"
	_tmp31_ = _tmp30_->metadata_only;
#line 1673 "../src/Photo.vala"
	if (!_tmp31_) {
#line 14005 "Photo.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1674 "../src/Photo.vala"
		_tmp32_ = list;
#line 1674 "../src/Photo.vala"
		_tmp33_ = g_strconcat (_tmp32_, "image:editable,image:baseline", NULL);
#line 1674 "../src/Photo.vala"
		_g_free0 (list);
#line 1674 "../src/Photo.vala"
		list = _tmp33_;
#line 14016 "Photo.c"
	}
#line 1676 "../src/Photo.vala"
	_tmp34_ = list;
#line 1676 "../src/Photo.vala"
	_tmp35_ = alteration_new_from_list (_tmp34_);
#line 1676 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 1676 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 1676 "../src/Photo.vala"
	_alteration_unref0 (_tmp36_);
#line 1678 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1648 "../src/Photo.vala"
	_g_free0 (list);
#line 1648 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 14034 "Photo.c"
}


static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1681 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1682 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1682 "../src/Photo.vala"
	result = _tmp0_;
#line 1682 "../src/Photo.vala"
	return result;
#line 14052 "Photo.c"
}


static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1685 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1686 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1686 "../src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1686 "../src/Photo.vala"
	result = _tmp1_;
#line 1686 "../src/Photo.vala"
	return result;
#line 14073 "Photo.c"
}


static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1689 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1693 "../src/Photo.vala"
	_tmp0_ = data_source_get_typename (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1693 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1693 "../src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource)));
#line 1693 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1693 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1693 "../src/Photo.vala"
	result = _tmp3_;
#line 1693 "../src/Photo.vala"
	return result;
#line 14102 "Photo.c"
}


void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1697 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1697 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1698 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1698 "../src/Photo.vala"
	modification = _tmp0_;
#line 14121 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1701 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1701 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14129 "Photo.c"
			{
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				time_t _tmp4_;
				GTimeVal _tmp5_;
				glong _tmp6_;
				PhotoTable* _tmp8_;
				PhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				PhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				PhotoRow* _tmp14_;
				BackingPhotoRow* _tmp15_;
				GTimeVal _tmp16_;
				glong _tmp17_;
#line 1702 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1702 "../src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 1702 "../src/Photo.vala"
				_tmp4_ = _tmp3_->timestamp;
#line 1702 "../src/Photo.vala"
				_tmp5_ = modification;
#line 1702 "../src/Photo.vala"
				_tmp6_ = _tmp5_.tv_sec;
#line 1702 "../src/Photo.vala"
				if (_tmp4_ == ((time_t) _tmp6_)) {
#line 14158 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp7_;
#line 1701 "../src/Photo.vala"
						_tmp7_ = self->row;
#line 1701 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14166 "Photo.c"
					}
#line 1703 "../src/Photo.vala"
					return;
#line 14170 "Photo.c"
				}
#line 1705 "../src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1705 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1705 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 1705 "../src/Photo.vala"
				_tmp11_ = _tmp10_->photo_id;
#line 1705 "../src/Photo.vala"
				_tmp12_ = modification;
#line 1705 "../src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1705 "../src/Photo.vala"
				photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error0_);
#line 1705 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1705 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14190 "Photo.c"
					goto __finally318;
				}
#line 1706 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 1706 "../src/Photo.vala"
				_tmp15_ = _tmp14_->master;
#line 1706 "../src/Photo.vala"
				_tmp16_ = modification;
#line 1706 "../src/Photo.vala"
				_tmp17_ = _tmp16_.tv_sec;
#line 1706 "../src/Photo.vala"
				_tmp15_->timestamp = (time_t) _tmp17_;
#line 14203 "Photo.c"
			}
			__finally318:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp18_;
#line 1701 "../src/Photo.vala"
				_tmp18_ = self->row;
#line 1701 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14213 "Photo.c"
			}
#line 1701 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1701 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 14219 "Photo.c"
					goto __catch317_database_error;
				}
#line 1701 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1701 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1701 "../src/Photo.vala"
				return;
#line 14228 "Photo.c"
			}
		}
	}
	goto __finally317;
	__catch317_database_error:
	{
		GError* err = NULL;
		GError* _tmp19_;
#line 1700 "../src/Photo.vala"
		err = _inner_error0_;
#line 1700 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1709 "../src/Photo.vala"
		_tmp19_ = err;
#line 1709 "../src/Photo.vala"
		app_window_database_error (_tmp19_);
#line 1711 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1711 "../src/Photo.vala"
		return;
#line 14249 "Photo.c"
	}
	__finally317:
#line 1700 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1700 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1700 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1700 "../src/Photo.vala"
		return;
#line 14260 "Photo.c"
	}
#line 1714 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 14264 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1715 "../src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1715 "../src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1715 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp21_);
#line 1715 "../src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 14275 "Photo.c"
	} else {
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1717 "../src/Photo.vala"
		_tmp22_ = alteration_new ("metadata", "master-timestamp");
#line 1717 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1717 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 1717 "../src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 14287 "Photo.c"
	}
}


void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered = FALSE;
	gboolean _tmp18_;
	GError* _inner_error0_ = NULL;
#line 1721 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1721 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1722 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1722 "../src/Photo.vala"
	modification = _tmp0_;
#line 1724 "../src/Photo.vala"
	altered = FALSE;
#line 14312 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1725 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1725 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14319 "Photo.c"
		{
			gboolean _tmp2_ = FALSE;
			PhotoRow* _tmp3_;
#line 1726 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1726 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp3_->editable_id)) {
#line 14327 "Photo.c"
				BackingPhotoRow* _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
#line 1726 "../src/Photo.vala"
				_tmp4_ = self->priv->editable;
#line 1726 "../src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1726 "../src/Photo.vala"
				_tmp6_ = modification;
#line 1726 "../src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1726 "../src/Photo.vala"
				_tmp2_ = _tmp5_ != ((time_t) _tmp7_);
#line 14342 "Photo.c"
			} else {
#line 1726 "../src/Photo.vala"
				_tmp2_ = FALSE;
#line 14346 "Photo.c"
			}
#line 1726 "../src/Photo.vala"
			if (_tmp2_) {
#line 14350 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				BackingPhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				BackingPhotoRow* _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
#line 1727 "../src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1727 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1727 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 1727 "../src/Photo.vala"
				_tmp11_ = _tmp10_->editable_id;
#line 1727 "../src/Photo.vala"
				_tmp12_ = modification;
#line 1727 "../src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1727 "../src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error0_);
#line 1727 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1727 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14378 "Photo.c"
					goto __finally319;
				}
#line 1729 "../src/Photo.vala"
				_tmp14_ = self->priv->editable;
#line 1729 "../src/Photo.vala"
				_tmp15_ = modification;
#line 1729 "../src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1729 "../src/Photo.vala"
				_tmp14_->timestamp = (time_t) _tmp16_;
#line 1730 "../src/Photo.vala"
				altered = TRUE;
#line 14391 "Photo.c"
			}
		}
		__finally319:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp17_;
#line 1725 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 1725 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14402 "Photo.c"
		}
#line 1725 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1725 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1725 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1725 "../src/Photo.vala"
				return;
#line 14412 "Photo.c"
			} else {
#line 1725 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1725 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1725 "../src/Photo.vala"
				return;
#line 14420 "Photo.c"
			}
		}
	}
#line 1734 "../src/Photo.vala"
	_tmp18_ = altered;
#line 1734 "../src/Photo.vala"
	if (_tmp18_) {
#line 14428 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 1735 "../src/Photo.vala"
		_tmp19_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1735 "../src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 1735 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp20_);
#line 1735 "../src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 14439 "Photo.c"
	}
}


void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1739 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1741 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 14453 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1742 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1742 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1742 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1742 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1742 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1742 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1742 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 1742 "../src/Photo.vala"
		while (TRUE) {
#line 14477 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1742 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1742 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1742 "../src/Photo.vala"
				break;
#line 14492 "Photo.c"
			}
#line 1742 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1742 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1742 "../src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1743 "../src/Photo.vala"
			_tmp8_ = photo;
#line 1743 "../src/Photo.vala"
			_tmp9_ = photo;
#line 1743 "../src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1743 "../src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1743 "../src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1743 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1743 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1743 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1743 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1743 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1743 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1743 "../src/Photo.vala"
					return;
#line 14524 "Photo.c"
				} else {
#line 1743 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1743 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1743 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1743 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1743 "../src/Photo.vala"
					return;
#line 14536 "Photo.c"
				}
			}
#line 1742 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 14541 "Photo.c"
		}
#line 1742 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 14545 "Photo.c"
	}
#line 1744 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1744 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1744 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1744 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1744 "../src/Photo.vala"
			return;
#line 14557 "Photo.c"
		} else {
#line 1744 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1744 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1744 "../src/Photo.vala"
			return;
#line 14565 "Photo.c"
		}
	}
}


static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
#line 1747 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1748 "../src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1748 "../src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 14583 "Photo.c"
	} else {
#line 1749 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 14587 "Photo.c"
	}
#line 1748 "../src/Photo.vala"
	result = _tmp0_;
#line 1748 "../src/Photo.vala"
	return result;
#line 14593 "Photo.c"
}


static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1752 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1753 "../src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1753 "../src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp1_, &_inner_error0_);
#line 1753 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1753 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1753 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1753 "../src/Photo.vala"
		return NULL;
#line 14623 "Photo.c"
	}
#line 1753 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1753 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1753 "../src/Photo.vala"
	result = _tmp3_;
#line 1753 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1753 "../src/Photo.vala"
	return result;
#line 14635 "Photo.c"
}


gboolean
photo_is_file_image (GFile* file)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1756 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1760 "../src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1761 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 14650 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1761 "../src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1761 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1761 "../src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1761 "../src/Photo.vala"
		_g_free0 (_tmp2_);
#line 14662 "Photo.c"
	}
#line 1760 "../src/Photo.vala"
	result = _tmp0_;
#line 1760 "../src/Photo.vala"
	return result;
#line 14668 "Photo.c"
}


static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          int extensions_length1)
{
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 1764 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1766 "../src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1766 "../src/Photo.vala"
	_g_free0 (name);
#line 1766 "../src/Photo.vala"
	name = _tmp0_;
#line 1766 "../src/Photo.vala"
	_g_free0 (ext);
#line 1766 "../src/Photo.vala"
	ext = _tmp1_;
#line 1767 "../src/Photo.vala"
	_tmp2_ = ext;
#line 1767 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1768 "../src/Photo.vala"
		result = FALSE;
#line 1768 "../src/Photo.vala"
		_g_free0 (ext);
#line 1768 "../src/Photo.vala"
		_g_free0 (name);
#line 1768 "../src/Photo.vala"
		return result;
#line 14709 "Photo.c"
	}
#line 1771 "../src/Photo.vala"
	_tmp3_ = ext;
#line 1771 "../src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1771 "../src/Photo.vala"
	_g_free0 (ext);
#line 1771 "../src/Photo.vala"
	ext = _tmp4_;
#line 14719 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1774 "../src/Photo.vala"
		extension_collection = extensions;
#line 1774 "../src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1774 "../src/Photo.vala"
		for (extension_it = 0; extension_it < extensions_length1; extension_it = extension_it + 1) {
#line 14731 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1774 "../src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1774 "../src/Photo.vala"
			extension = _tmp5_;
#line 14738 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1775 "../src/Photo.vala"
				_tmp6_ = ext;
#line 1775 "../src/Photo.vala"
				_tmp7_ = extension;
#line 1775 "../src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1776 "../src/Photo.vala"
					result = TRUE;
#line 1776 "../src/Photo.vala"
					_g_free0 (extension);
#line 1776 "../src/Photo.vala"
					_g_free0 (ext);
#line 1776 "../src/Photo.vala"
					_g_free0 (name);
#line 1776 "../src/Photo.vala"
					return result;
#line 14758 "Photo.c"
				}
#line 1774 "../src/Photo.vala"
				_g_free0 (extension);
#line 14762 "Photo.c"
			}
		}
	}
#line 1779 "../src/Photo.vala"
	result = FALSE;
#line 1779 "../src/Photo.vala"
	_g_free0 (ext);
#line 1779 "../src/Photo.vala"
	_g_free0 (name);
#line 1779 "../src/Photo.vala"
	return result;
#line 14774 "Photo.c"
}


gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
#line 1785 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 1788 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1788 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1788 "../src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1788 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1788 "../src/Photo.vala"
	result = _tmp2_;
#line 1788 "../src/Photo.vala"
	return result;
#line 14802 "Photo.c"
}


PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         int* result_length1)
{
	PhotoID* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
#line 1794 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 1797 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1797 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1797 "../src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1797 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1797 "../src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1797 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1797 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1797 "../src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1797 "../src/Photo.vala"
	if (result_length1) {
#line 1797 "../src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 14844 "Photo.c"
	}
#line 1797 "../src/Photo.vala"
	result = _tmp5_;
#line 1797 "../src/Photo.vala"
	return result;
#line 14850 "Photo.c"
}


gint64
photo_get_photo_key (DataSource* source)
{
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1804 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1805 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_PHOTO, Photo), &_tmp0_);
#line 1805 "../src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1805 "../src/Photo.vala"
	result = _tmp1_;
#line 1805 "../src/Photo.vala"
	return result;
#line 14870 "Photo.c"
}


static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1823 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1824 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1824 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1824 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1824 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1824 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1824 "../src/Photo.vala"
	result = _tmp3_;
#line 1824 "../src/Photo.vala"
	return result;
#line 14899 "Photo.c"
}


static void
_vala_array_add97 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1867 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1867 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1867 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14915 "Photo.c"
	}
#line 1867 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1867 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14921 "Photo.c"
}


static void
_vala_array_add98 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1872 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1872 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1872 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14937 "Photo.c"
	}
#line 1872 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1872 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14943 "Photo.c"
}


static void
_vala_array_add99 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1875 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1875 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1875 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14959 "Photo.c"
	}
#line 1875 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1875 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14965 "Photo.c"
}


static void
_vala_array_add100 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1878 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1878 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1878 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14981 "Photo.c"
	}
#line 1878 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1878 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14987 "Photo.c"
}


void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp33_;
	GError* _inner_error0_ = NULL;
#line 1829 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1829 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1830 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1830 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1832 "../src/Photo.vala"
	altered = FALSE;
#line 1833 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1834 "../src/Photo.vala"
	is_source = FALSE;
#line 1835 "../src/Photo.vala"
	name_changed = FALSE;
#line 1836 "../src/Photo.vala"
	old_file = NULL;
#line 15022 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1838 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1838 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15030 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1839 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1839 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15038 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1840 "../src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1840 "../src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1840 "../src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1840 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1840 "../src/Photo.vala"
						old_file = _tmp5_;
#line 1841 "../src/Photo.vala"
						_tmp6_ = old_file;
#line 1841 "../src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 15058 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							PhotoFileFormat _tmp19_;
							const gchar* _tmp20_;
							PhotoFileReader* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PhotoRow* _tmp23_;
							const gchar* _tmp24_;
#line 1842 "../src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1842 "../src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1842 "../src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1842 "../src/Photo.vala"
							_tmp10_ = filepath;
#line 1842 "../src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1842 "../src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1842 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15091 "Photo.c"
								goto __finally322;
							}
#line 1844 "../src/Photo.vala"
							_tmp11_ = self->row;
#line 1844 "../src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1844 "../src/Photo.vala"
							_tmp13_ = filepath;
#line 1844 "../src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1844 "../src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1844 "../src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1845 "../src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1845 "../src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1845 "../src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1846 "../src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1846 "../src/Photo.vala"
							_tmp17_ = self->row;
#line 1846 "../src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1846 "../src/Photo.vala"
							_tmp19_ = _tmp18_->file_format;
#line 1846 "../src/Photo.vala"
							_tmp20_ = filepath;
#line 1846 "../src/Photo.vala"
							_tmp21_ = photo_file_format_create_reader (_tmp19_, _tmp20_);
#line 1846 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1846 "../src/Photo.vala"
							_tmp16_->master = _tmp21_;
#line 1848 "../src/Photo.vala"
							altered = TRUE;
#line 1849 "../src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1850 "../src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1851 "../src/Photo.vala"
							_tmp23_ = self->row;
#line 1851 "../src/Photo.vala"
							_tmp24_ = _tmp23_->title;
#line 1851 "../src/Photo.vala"
							if (is_string_empty (_tmp24_)) {
#line 15140 "Photo.c"
								GFile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
#line 1852 "../src/Photo.vala"
								_tmp25_ = old_file;
#line 1852 "../src/Photo.vala"
								_tmp26_ = g_file_get_basename (_tmp25_);
#line 1852 "../src/Photo.vala"
								_tmp27_ = _tmp26_;
#line 1852 "../src/Photo.vala"
								_tmp28_ = g_file_get_basename (file);
#line 1852 "../src/Photo.vala"
								_tmp29_ = _tmp28_;
#line 1852 "../src/Photo.vala"
								_tmp22_ = g_strcmp0 (_tmp27_, _tmp29_) != 0;
#line 1852 "../src/Photo.vala"
								_g_free0 (_tmp29_);
#line 1852 "../src/Photo.vala"
								_g_free0 (_tmp27_);
#line 15162 "Photo.c"
							} else {
#line 1851 "../src/Photo.vala"
								_tmp22_ = FALSE;
#line 15166 "Photo.c"
							}
#line 1851 "../src/Photo.vala"
							name_changed = _tmp22_;
#line 15170 "Photo.c"
						}
					}
					__finally322:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp30_;
#line 1839 "../src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1839 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15181 "Photo.c"
					}
#line 1839 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15185 "Photo.c"
						goto __finally321;
					}
				}
			}
			__finally321:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp31_;
#line 1838 "../src/Photo.vala"
				_tmp31_ = self->row;
#line 1838 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15198 "Photo.c"
			}
#line 1838 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1838 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15204 "Photo.c"
					goto __catch320_database_error;
				}
#line 1838 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1838 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1838 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1838 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1838 "../src/Photo.vala"
				return;
#line 15217 "Photo.c"
			}
		}
	}
	goto __finally320;
	__catch320_database_error:
	{
		GError* err = NULL;
		GError* _tmp32_;
#line 1837 "../src/Photo.vala"
		err = _inner_error0_;
#line 1837 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1857 "../src/Photo.vala"
		_tmp32_ = err;
#line 1857 "../src/Photo.vala"
		app_window_database_error (_tmp32_);
#line 1837 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15236 "Photo.c"
	}
	__finally320:
#line 1837 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1837 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1837 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1837 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1837 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1837 "../src/Photo.vala"
		return;
#line 15251 "Photo.c"
	}
#line 1860 "../src/Photo.vala"
	_tmp33_ = altered;
#line 1860 "../src/Photo.vala"
	if (_tmp33_) {
#line 15257 "Photo.c"
		GFile* _tmp34_;
		gboolean _tmp35_;
		gchar** alteration_list = NULL;
		gchar** _tmp36_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		gchar* _tmp38_;
		gboolean _tmp39_;
		gboolean _tmp42_;
		gboolean _tmp45_;
		gchar** _tmp48_;
		gint _tmp48__length1;
		Alteration* _tmp49_;
		Alteration* _tmp50_;
#line 1861 "../src/Photo.vala"
		_tmp34_ = old_file;
#line 1861 "../src/Photo.vala"
		media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp34_, file);
#line 1863 "../src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1863 "../src/Photo.vala"
		if (_tmp35_) {
#line 1864 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15284 "Photo.c"
		}
#line 1866 "../src/Photo.vala"
		_tmp36_ = g_new0 (gchar*, 0 + 1);
#line 1866 "../src/Photo.vala"
		alteration_list = _tmp36_;
#line 1866 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1866 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1867 "../src/Photo.vala"
		_tmp37_ = alteration_list;
#line 1867 "../src/Photo.vala"
		_tmp37__length1 = alteration_list_length1;
#line 1867 "../src/Photo.vala"
		_tmp38_ = g_strdup ("backing:master");
#line 1867 "../src/Photo.vala"
		_vala_array_add97 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 1871 "../src/Photo.vala"
		_tmp39_ = name_changed;
#line 1871 "../src/Photo.vala"
		if (_tmp39_) {
#line 15306 "Photo.c"
			gchar** _tmp40_;
			gint _tmp40__length1;
			gchar* _tmp41_;
#line 1872 "../src/Photo.vala"
			_tmp40_ = alteration_list;
#line 1872 "../src/Photo.vala"
			_tmp40__length1 = alteration_list_length1;
#line 1872 "../src/Photo.vala"
			_tmp41_ = g_strdup ("metadata:name");
#line 1872 "../src/Photo.vala"
			_vala_array_add98 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp41_);
#line 15318 "Photo.c"
		}
#line 1874 "../src/Photo.vala"
		_tmp42_ = is_source;
#line 1874 "../src/Photo.vala"
		if (_tmp42_) {
#line 15324 "Photo.c"
			gchar** _tmp43_;
			gint _tmp43__length1;
			gchar* _tmp44_;
#line 1875 "../src/Photo.vala"
			_tmp43_ = alteration_list;
#line 1875 "../src/Photo.vala"
			_tmp43__length1 = alteration_list_length1;
#line 1875 "../src/Photo.vala"
			_tmp44_ = g_strdup ("backing:source");
#line 1875 "../src/Photo.vala"
			_vala_array_add99 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp44_);
#line 15336 "Photo.c"
		}
#line 1877 "../src/Photo.vala"
		_tmp45_ = is_baseline;
#line 1877 "../src/Photo.vala"
		if (_tmp45_) {
#line 15342 "Photo.c"
			gchar** _tmp46_;
			gint _tmp46__length1;
			gchar* _tmp47_;
#line 1878 "../src/Photo.vala"
			_tmp46_ = alteration_list;
#line 1878 "../src/Photo.vala"
			_tmp46__length1 = alteration_list_length1;
#line 1878 "../src/Photo.vala"
			_tmp47_ = g_strdup ("backing:baseline");
#line 1878 "../src/Photo.vala"
			_vala_array_add100 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
#line 15354 "Photo.c"
		}
#line 1880 "../src/Photo.vala"
		_tmp48_ = alteration_list;
#line 1880 "../src/Photo.vala"
		_tmp48__length1 = alteration_list_length1;
#line 1880 "../src/Photo.vala"
		_tmp49_ = alteration_new_from_array (_tmp48_, _tmp48__length1);
#line 1880 "../src/Photo.vala"
		_tmp50_ = _tmp49_;
#line 1880 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp50_);
#line 1880 "../src/Photo.vala"
		_alteration_unref0 (_tmp50_);
#line 1860 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15370 "Photo.c"
	}
#line 1829 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1829 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15376 "Photo.c"
}


static void
_vala_array_add101 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1920 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1920 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1920 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15392 "Photo.c"
	}
#line 1920 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1920 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15398 "Photo.c"
}


static void
_vala_array_add102 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1923 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1923 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1923 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15414 "Photo.c"
	}
#line 1923 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1923 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15420 "Photo.c"
}


static void
_vala_array_add103 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1926 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1926 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1926 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15436 "Photo.c"
	}
#line 1926 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1926 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 15442 "Photo.c"
}


void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
#line 1886 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1886 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1887 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1887 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1889 "../src/Photo.vala"
	altered = FALSE;
#line 1890 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1891 "../src/Photo.vala"
	is_source = FALSE;
#line 1892 "../src/Photo.vala"
	old_file = NULL;
#line 15474 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1894 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1894 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15482 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1895 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1895 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15490 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1896 "../src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1896 "../src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1896 "../src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 15504 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1896 "../src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1896 "../src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1896 "../src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1896 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1896 "../src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 15518 "Photo.c"
						} else {
#line 1896 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1896 "../src/Photo.vala"
							_tmp3_ = NULL;
#line 15524 "Photo.c"
						}
#line 1896 "../src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1896 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1896 "../src/Photo.vala"
						old_file = _tmp9_;
#line 1897 "../src/Photo.vala"
						_tmp11_ = old_file;
#line 1897 "../src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 15536 "Photo.c"
							GFile* _tmp12_;
#line 1897 "../src/Photo.vala"
							_tmp12_ = old_file;
#line 1897 "../src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 15542 "Photo.c"
						} else {
#line 1897 "../src/Photo.vala"
							_tmp10_ = FALSE;
#line 15546 "Photo.c"
						}
#line 1897 "../src/Photo.vala"
						if (_tmp10_) {
#line 15550 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_;
#line 1898 "../src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1898 "../src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1898 "../src/Photo.vala"
							_tmp15_ = self->row;
#line 1898 "../src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1898 "../src/Photo.vala"
							_tmp17_ = filepath;
#line 1898 "../src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1898 "../src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1898 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1898 "../src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 15582 "Photo.c"
								goto __finally325;
							}
#line 1900 "../src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1900 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1900 "../src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1900 "../src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1900 "../src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1901 "../src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1901 "../src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1901 "../src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1901 "../src/Photo.vala"
							_tmp24_ = filepath;
#line 1901 "../src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1901 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1901 "../src/Photo.vala"
							_tmp21_->editable = _tmp25_;
#line 1903 "../src/Photo.vala"
							altered = TRUE;
#line 1904 "../src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1905 "../src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 15615 "Photo.c"
						}
#line 1895 "../src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 15619 "Photo.c"
					}
					__finally325:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp26_;
#line 1895 "../src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1895 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15629 "Photo.c"
					}
#line 1895 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15633 "Photo.c"
						goto __finally324;
					}
				}
			}
			__finally324:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp27_;
#line 1894 "../src/Photo.vala"
				_tmp27_ = self->row;
#line 1894 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15646 "Photo.c"
			}
#line 1894 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1894 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15652 "Photo.c"
					goto __catch323_database_error;
				}
#line 1894 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1894 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1894 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1894 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1894 "../src/Photo.vala"
				return;
#line 15665 "Photo.c"
			}
		}
	}
	goto __finally323;
	__catch323_database_error:
	{
		GError* err = NULL;
		GError* _tmp28_;
#line 1893 "../src/Photo.vala"
		err = _inner_error0_;
#line 1893 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1910 "../src/Photo.vala"
		_tmp28_ = err;
#line 1910 "../src/Photo.vala"
		app_window_database_error (_tmp28_);
#line 1893 "../src/Photo.vala"
		_g_error_free0 (err);
#line 15684 "Photo.c"
	}
	__finally323:
#line 1893 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1893 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1893 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1893 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1893 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1893 "../src/Photo.vala"
		return;
#line 15699 "Photo.c"
	}
#line 1913 "../src/Photo.vala"
	_tmp29_ = altered;
#line 1913 "../src/Photo.vala"
	if (_tmp29_) {
#line 15705 "Photo.c"
		GFile* _tmp30_;
		gboolean _tmp31_;
		gchar** alteration_list = NULL;
		gchar** _tmp32_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gboolean _tmp35_;
		gboolean _tmp38_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		Alteration* _tmp42_;
		Alteration* _tmp43_;
#line 1914 "../src/Photo.vala"
		_tmp30_ = old_file;
#line 1914 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, file);
#line 1916 "../src/Photo.vala"
		_tmp31_ = is_baseline;
#line 1916 "../src/Photo.vala"
		if (_tmp31_) {
#line 1917 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15731 "Photo.c"
		}
#line 1919 "../src/Photo.vala"
		_tmp32_ = g_new0 (gchar*, 0 + 1);
#line 1919 "../src/Photo.vala"
		alteration_list = _tmp32_;
#line 1919 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1919 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1920 "../src/Photo.vala"
		_tmp33_ = alteration_list;
#line 1920 "../src/Photo.vala"
		_tmp33__length1 = alteration_list_length1;
#line 1920 "../src/Photo.vala"
		_tmp34_ = g_strdup ("backing:editable");
#line 1920 "../src/Photo.vala"
		_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 1922 "../src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1922 "../src/Photo.vala"
		if (_tmp35_) {
#line 15753 "Photo.c"
			gchar** _tmp36_;
			gint _tmp36__length1;
			gchar* _tmp37_;
#line 1923 "../src/Photo.vala"
			_tmp36_ = alteration_list;
#line 1923 "../src/Photo.vala"
			_tmp36__length1 = alteration_list_length1;
#line 1923 "../src/Photo.vala"
			_tmp37_ = g_strdup ("backing:baseline");
#line 1923 "../src/Photo.vala"
			_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 15765 "Photo.c"
		}
#line 1925 "../src/Photo.vala"
		_tmp38_ = is_source;
#line 1925 "../src/Photo.vala"
		if (_tmp38_) {
#line 15771 "Photo.c"
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar* _tmp40_;
#line 1926 "../src/Photo.vala"
			_tmp39_ = alteration_list;
#line 1926 "../src/Photo.vala"
			_tmp39__length1 = alteration_list_length1;
#line 1926 "../src/Photo.vala"
			_tmp40_ = g_strdup ("backing:source");
#line 1926 "../src/Photo.vala"
			_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 15783 "Photo.c"
		}
#line 1928 "../src/Photo.vala"
		_tmp41_ = alteration_list;
#line 1928 "../src/Photo.vala"
		_tmp41__length1 = alteration_list_length1;
#line 1928 "../src/Photo.vala"
		_tmp42_ = alteration_new_from_array (_tmp41_, _tmp41__length1);
#line 1928 "../src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 1928 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp43_);
#line 1928 "../src/Photo.vala"
		_alteration_unref0 (_tmp43_);
#line 1913 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15799 "Photo.c"
	}
#line 1886 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1886 "../src/Photo.vala"
	_g_free0 (filepath);
#line 15805 "Photo.c"
}


void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1933 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1934 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 1936 "../src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1936 "../src/Photo.vala"
	map_iter = _tmp0_;
#line 1937 "../src/Photo.vala"
	while (TRUE) {
#line 15826 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1937 "../src/Photo.vala"
		_tmp1_ = map_iter;
#line 1937 "../src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1937 "../src/Photo.vala"
			break;
#line 15840 "Photo.c"
		}
#line 1938 "../src/Photo.vala"
		_tmp2_ = map_iter;
#line 1938 "../src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1938 "../src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1938 "../src/Photo.vala"
		_tmp5_ = map_iter;
#line 1938 "../src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1938 "../src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1938 "../src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1938 "../src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1938 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 15860 "Photo.c"
	}
#line 1940 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1940 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1940 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1940 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1940 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1940 "../src/Photo.vala"
			return;
#line 15874 "Photo.c"
		} else {
#line 1940 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1940 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1940 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1940 "../src/Photo.vala"
			return;
#line 15884 "Photo.c"
		}
	}
#line 1933 "../src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 15889 "Photo.c"
}


GFile*
photo_get_actual_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1945 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1946 "../src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1946 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1946 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1946 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1946 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1946 "../src/Photo.vala"
	result = _tmp3_;
#line 1946 "../src/Photo.vala"
	return result;
#line 15917 "Photo.c"
}


static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1949 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1950 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1950 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1950 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1950 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1950 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1950 "../src/Photo.vala"
	result = _tmp3_;
#line 1950 "../src/Photo.vala"
	return result;
#line 15946 "Photo.c"
}


GFile*
photo_get_editable_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1953 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1954 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1954 "../src/Photo.vala"
	reader = _tmp0_;
#line 1956 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1956 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 15968 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1956 "../src/Photo.vala"
		_tmp3_ = reader;
#line 1956 "../src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1956 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1956 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 15979 "Photo.c"
	} else {
#line 1956 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1956 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 15985 "Photo.c"
	}
#line 1956 "../src/Photo.vala"
	result = _tmp1_;
#line 1956 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1956 "../src/Photo.vala"
	return result;
#line 15993 "Photo.c"
}


GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1959 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1960 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1961 "../src/Photo.vala"
		result = NULL;
#line 1961 "../src/Photo.vala"
		return result;
#line 16012 "Photo.c"
	}
#line 1963 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1963 "../src/Photo.vala"
	ret = _tmp0_;
#line 16018 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1964 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1964 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16025 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1965 "../src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1965 "../src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1965 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1965 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1965 "../src/Photo.vala"
				_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1965 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1965 "../src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1965 "../src/Photo.vala"
				_row_it = _tmp7_;
#line 1965 "../src/Photo.vala"
				while (TRUE) {
#line 16053 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1965 "../src/Photo.vala"
					_tmp8_ = _row_it;
#line 1965 "../src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1965 "../src/Photo.vala"
						break;
#line 16069 "Photo.c"
					}
#line 1965 "../src/Photo.vala"
					_tmp9_ = _row_it;
#line 1965 "../src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1965 "../src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1966 "../src/Photo.vala"
					_tmp11_ = ret;
#line 1966 "../src/Photo.vala"
					_tmp12_ = row;
#line 1966 "../src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1966 "../src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1966 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1966 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 1966 "../src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1965 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 16093 "Photo.c"
				}
#line 1965 "../src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 16097 "Photo.c"
			}
		}
		__finally326:
		{
			PhotoRow* _tmp16_;
#line 1964 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 1964 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16107 "Photo.c"
		}
#line 1964 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1964 "../src/Photo.vala"
			_g_object_unref0 (ret);
#line 1964 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1964 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1964 "../src/Photo.vala"
			return NULL;
#line 16119 "Photo.c"
		}
	}
#line 1969 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (ret, GEE_TYPE_COLLECTION, GeeCollection);
#line 1969 "../src/Photo.vala"
	return result;
#line 16126 "Photo.c"
}


GFile*
photo_get_source_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1972 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1973 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1973 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1973 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1973 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1973 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1973 "../src/Photo.vala"
	result = _tmp3_;
#line 1973 "../src/Photo.vala"
	return result;
#line 16154 "Photo.c"
}


PhotoFileFormat
photo_get_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 1976 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16165 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1977 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1977 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16172 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1978 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1978 "../src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1978 "../src/Photo.vala"
			result = _tmp2_;
#line 16182 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1977 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1977 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16189 "Photo.c"
			}
#line 1978 "../src/Photo.vala"
			return result;
#line 16193 "Photo.c"
		}
		__finally327:
		{
			PhotoRow* _tmp4_;
#line 1977 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1977 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16202 "Photo.c"
		}
#line 1977 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1977 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1977 "../src/Photo.vala"
		return 0;
#line 16210 "Photo.c"
	}
}


PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_;
#line 1982 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1983 "../src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1984 "../src/Photo.vala"
	_tmp0_ = file_format;
#line 1984 "../src/Photo.vala"
	if (!photo_file_format_can_write (_tmp0_)) {
#line 1985 "../src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 16231 "Photo.c"
	}
#line 1987 "../src/Photo.vala"
	result = file_format;
#line 1987 "../src/Photo.vala"
	return result;
#line 16237 "Photo.c"
}


PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 1990 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16248 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1991 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1991 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16255 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1992 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1992 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1992 "../src/Photo.vala"
			result = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 16265 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1991 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1991 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16272 "Photo.c"
			}
#line 1992 "../src/Photo.vala"
			return result;
#line 16276 "Photo.c"
		}
		__finally328:
		{
			PhotoRow* _tmp4_;
#line 1991 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1991 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16285 "Photo.c"
		}
#line 1991 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1991 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1991 "../src/Photo.vala"
		return 0;
#line 16293 "Photo.c"
	}
}


static time_t
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	time_t result = 0;
	GError* _inner_error0_ = NULL;
#line 1996 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16306 "Photo.c"
	{
		PhotoRow* _tmp0_;
		time_t _tmp5_ = 0;
#line 1997 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1997 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16314 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			time_t _tmp2_;
#line 1998 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1998 "../src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1998 "../src/Photo.vala"
			result = _tmp2_;
#line 16324 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1997 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1997 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16331 "Photo.c"
			}
#line 1998 "../src/Photo.vala"
			return result;
#line 16335 "Photo.c"
		}
		__finally329:
		{
			PhotoRow* _tmp4_;
#line 1997 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1997 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16344 "Photo.c"
		}
#line 1997 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1997 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1997 "../src/Photo.vala"
		return _tmp5_;
#line 16352 "Photo.c"
	}
}


void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2002 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16364 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2003 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2003 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16371 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 2004 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2004 "../src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 2004 "../src/Photo.vala"
			*result = _tmp2_;
#line 16381 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2003 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2003 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16388 "Photo.c"
			}
#line 2004 "../src/Photo.vala"
			return;
#line 16392 "Photo.c"
		}
		__finally330:
		{
			PhotoRow* _tmp4_;
#line 2003 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2003 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16401 "Photo.c"
		}
#line 2003 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2003 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2003 "../src/Photo.vala"
		return;
#line 16409 "Photo.c"
	}
}


static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 2009 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2010 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2010 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2010 "../src/Photo.vala"
	*result = _tmp1_;
#line 2010 "../src/Photo.vala"
	return;
#line 16431 "Photo.c"
}


inline gint64
photo_get_raw_event_id (Photo* self)
{
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 2014 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 2015 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 2015 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2015 "../src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 2015 "../src/Photo.vala"
	result = _tmp2_;
#line 2015 "../src/Photo.vala"
	return result;
#line 16454 "Photo.c"
}


static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2018 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16466 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2019 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2019 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16473 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 2020 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2020 "../src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 2020 "../src/Photo.vala"
			*result = _tmp2_;
#line 16483 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2019 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2019 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16490 "Photo.c"
			}
#line 2020 "../src/Photo.vala"
			return;
#line 16494 "Photo.c"
		}
		__finally331:
		{
			PhotoRow* _tmp4_;
#line 2019 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2019 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16503 "Photo.c"
		}
#line 2019 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2019 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2019 "../src/Photo.vala"
		return;
#line 16511 "Photo.c"
	}
}


void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2024 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16523 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2025 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2025 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16530 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 2026 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2026 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 2026 "../src/Photo.vala"
			*result = _tmp2_;
#line 16540 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2025 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2025 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16547 "Photo.c"
			}
#line 2026 "../src/Photo.vala"
			return;
#line 16551 "Photo.c"
		}
		__finally332:
		{
			PhotoRow* _tmp4_;
#line 2025 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2025 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16560 "Photo.c"
		}
#line 2025 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2025 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2025 "../src/Photo.vala"
		return;
#line 16568 "Photo.c"
	}
}


static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2030 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16581 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2031 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2031 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16588 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2032 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2032 "../src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 2032 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2032 "../src/Photo.vala"
			result = _tmp3_;
#line 16601 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2031 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2031 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16608 "Photo.c"
			}
#line 2032 "../src/Photo.vala"
			return result;
#line 16612 "Photo.c"
		}
		__finally333:
		{
			PhotoRow* _tmp5_;
#line 2031 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2031 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16621 "Photo.c"
		}
#line 2031 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2031 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2031 "../src/Photo.vala"
		return NULL;
#line 16629 "Photo.c"
	}
}


guint64
photo_get_flags (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2038 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 16641 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2039 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2039 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16649 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 2040 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2040 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2040 "../src/Photo.vala"
			result = _tmp2_;
#line 16659 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2039 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2039 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16666 "Photo.c"
			}
#line 2040 "../src/Photo.vala"
			return result;
#line 16670 "Photo.c"
		}
		__finally334:
		{
			PhotoRow* _tmp4_;
#line 2039 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2039 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16679 "Photo.c"
		}
#line 2039 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2039 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2039 "../src/Photo.vala"
		return _tmp5_;
#line 16687 "Photo.c"
	}
}


static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2044 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2044 "../src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 2045 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2045 "../src/Photo.vala"
	alteration = _tmp0_;
#line 2046 "../src/Photo.vala"
	if (additional_alteration != NULL) {
#line 16709 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2047 "../src/Photo.vala"
		_tmp1_ = alteration;
#line 2047 "../src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2047 "../src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2047 "../src/Photo.vala"
		alteration = _tmp2_;
#line 16720 "Photo.c"
	}
#line 2049 "../src/Photo.vala"
	_tmp3_ = alteration;
#line 2049 "../src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2044 "../src/Photo.vala"
	_alteration_unref0 (alteration);
#line 16728 "Photo.c"
}


guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2052 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2052 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 16745 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2054 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2054 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16752 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			gboolean _tmp4_;
#line 2055 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2055 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2055 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2055 "../src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2055 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2056 "../src/Photo.vala"
			_tmp4_ = committed;
#line 2056 "../src/Photo.vala"
			if (_tmp4_) {
#line 16772 "Photo.c"
				PhotoRow* _tmp5_;
#line 2057 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2057 "../src/Photo.vala"
				_tmp5_->flags = flags;
#line 16778 "Photo.c"
			}
		}
		__finally335:
		{
			PhotoRow* _tmp6_;
#line 2054 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2054 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16788 "Photo.c"
		}
#line 2054 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16792 "Photo.c"
			guint64 _tmp7_ = 0ULL;
#line 2054 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2054 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2054 "../src/Photo.vala"
			return _tmp7_;
#line 16800 "Photo.c"
		}
	}
#line 2060 "../src/Photo.vala"
	_tmp8_ = committed;
#line 2060 "../src/Photo.vala"
	if (_tmp8_) {
#line 2061 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16809 "Photo.c"
	}
#line 2063 "../src/Photo.vala"
	result = flags;
#line 2063 "../src/Photo.vala"
	return result;
#line 16815 "Photo.c"
}


gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2066 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 16827 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2067 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2067 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16835 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 2068 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2068 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2068 "../src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp2_, mask);
#line 16845 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2067 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2067 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16852 "Photo.c"
			}
#line 2068 "../src/Photo.vala"
			return result;
#line 16856 "Photo.c"
		}
		__finally336:
		{
			PhotoRow* _tmp4_;
#line 2067 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2067 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16865 "Photo.c"
		}
#line 2067 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2067 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2067 "../src/Photo.vala"
		return _tmp5_;
#line 16873 "Photo.c"
	}
}


guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2072 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2072 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2073 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2075 "../src/Photo.vala"
	committed = FALSE;
#line 16896 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2076 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2076 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16903 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2077 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2077 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2077 "../src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp2_, mask);
#line 2078 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2078 "../src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2078 "../src/Photo.vala"
			_tmp5_ = flags;
#line 2078 "../src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 16924 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2079 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2079 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2079 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2079 "../src/Photo.vala"
				_tmp9_ = flags;
#line 2079 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2079 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2080 "../src/Photo.vala"
				_tmp10_ = committed;
#line 2080 "../src/Photo.vala"
				if (_tmp10_) {
#line 16946 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2081 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2081 "../src/Photo.vala"
					_tmp12_ = flags;
#line 2081 "../src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 16955 "Photo.c"
				}
			}
		}
		__finally337:
		{
			PhotoRow* _tmp13_;
#line 2076 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 2076 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16966 "Photo.c"
		}
#line 2076 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16970 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2076 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2076 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2076 "../src/Photo.vala"
			return _tmp14_;
#line 16978 "Photo.c"
		}
	}
#line 2085 "../src/Photo.vala"
	_tmp15_ = committed;
#line 2085 "../src/Photo.vala"
	if (_tmp15_) {
#line 2086 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16987 "Photo.c"
	}
#line 2088 "../src/Photo.vala"
	result = flags;
#line 2088 "../src/Photo.vala"
	return result;
#line 16993 "Photo.c"
}


guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2091 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2091 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2092 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2094 "../src/Photo.vala"
	committed = FALSE;
#line 17015 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2095 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2095 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17022 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2096 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2096 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2096 "../src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp2_, mask);
#line 2097 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2097 "../src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2097 "../src/Photo.vala"
			_tmp5_ = flags;
#line 2097 "../src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17043 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2098 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2098 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2098 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2098 "../src/Photo.vala"
				_tmp9_ = flags;
#line 2098 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2098 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2099 "../src/Photo.vala"
				_tmp10_ = committed;
#line 2099 "../src/Photo.vala"
				if (_tmp10_) {
#line 17065 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2100 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2100 "../src/Photo.vala"
					_tmp12_ = flags;
#line 2100 "../src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17074 "Photo.c"
				}
			}
		}
		__finally338:
		{
			PhotoRow* _tmp13_;
#line 2095 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 2095 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17085 "Photo.c"
		}
#line 2095 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17089 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2095 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2095 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2095 "../src/Photo.vala"
			return _tmp14_;
#line 17097 "Photo.c"
		}
	}
#line 2104 "../src/Photo.vala"
	_tmp15_ = committed;
#line 2104 "../src/Photo.vala"
	if (_tmp15_) {
#line 2105 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17106 "Photo.c"
	}
#line 2107 "../src/Photo.vala"
	result = flags;
#line 2107 "../src/Photo.vala"
	return result;
#line 17112 "Photo.c"
}


guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2110 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2110 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2111 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2113 "../src/Photo.vala"
	committed = FALSE;
#line 17135 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2114 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2114 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17142 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2115 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2115 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2115 "../src/Photo.vala"
			flags = (_tmp2_ | add) & (~remove);
#line 2116 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2116 "../src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2116 "../src/Photo.vala"
			_tmp5_ = flags;
#line 2116 "../src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17163 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2117 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2117 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2117 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2117 "../src/Photo.vala"
				_tmp9_ = flags;
#line 2117 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2117 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2118 "../src/Photo.vala"
				_tmp10_ = committed;
#line 2118 "../src/Photo.vala"
				if (_tmp10_) {
#line 17185 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2119 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2119 "../src/Photo.vala"
					_tmp12_ = flags;
#line 2119 "../src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17194 "Photo.c"
				}
			}
		}
		__finally339:
		{
			PhotoRow* _tmp13_;
#line 2114 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 2114 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17205 "Photo.c"
		}
#line 2114 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17209 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2114 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2114 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2114 "../src/Photo.vala"
			return _tmp14_;
#line 17217 "Photo.c"
		}
	}
#line 2123 "../src/Photo.vala"
	_tmp15_ = committed;
#line 2123 "../src/Photo.vala"
	if (_tmp15_) {
#line 2124 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17226 "Photo.c"
	}
#line 2126 "../src/Photo.vala"
	result = flags;
#line 2126 "../src/Photo.vala"
	return result;
#line 17232 "Photo.c"
}


void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2129 "../src/Photo.vala"
	g_return_if_fail ((add == NULL) || GEE_IS_COLLECTION (add));
#line 2129 "../src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 2129 "../src/Photo.vala"
	g_return_if_fail ((remove == NULL) || GEE_IS_COLLECTION (remove));
#line 2129 "../src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 2132 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 2134 "../src/Photo.vala"
	if (add != NULL) {
#line 17258 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2135 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (add, GEE_TYPE_ITERABLE, GeeIterable));
#line 2135 "../src/Photo.vala"
			_photo_it = _tmp0_;
#line 2135 "../src/Photo.vala"
			while (TRUE) {
#line 17268 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2135 "../src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2135 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2135 "../src/Photo.vala"
					break;
#line 17280 "Photo.c"
				}
#line 2135 "../src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2135 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2135 "../src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2136 "../src/Photo.vala"
				_tmp4_ = photo;
#line 2136 "../src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2135 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 17294 "Photo.c"
			}
#line 2135 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17298 "Photo.c"
		}
	}
#line 2139 "../src/Photo.vala"
	if (remove != NULL) {
#line 17303 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2140 "../src/Photo.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 2140 "../src/Photo.vala"
			_photo_it = _tmp5_;
#line 2140 "../src/Photo.vala"
			while (TRUE) {
#line 17313 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2140 "../src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2140 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2140 "../src/Photo.vala"
					break;
#line 17325 "Photo.c"
				}
#line 2140 "../src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2140 "../src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2140 "../src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2141 "../src/Photo.vala"
				_tmp9_ = photo;
#line 2141 "../src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2140 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 17339 "Photo.c"
			}
#line 2140 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17343 "Photo.c"
		}
	}
#line 2144 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2144 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2144 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2144 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2144 "../src/Photo.vala"
			return;
#line 17356 "Photo.c"
		} else {
#line 2144 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2144 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2144 "../src/Photo.vala"
			return;
#line 17364 "Photo.c"
		}
	}
}


guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2147 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2147 "../src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2148 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2150 "../src/Photo.vala"
	committed = FALSE;
#line 17388 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2151 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2151 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17395 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2152 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2152 "../src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2152 "../src/Photo.vala"
			flags = _tmp2_ ^ mask;
#line 2153 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2153 "../src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2153 "../src/Photo.vala"
			_tmp5_ = flags;
#line 2153 "../src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17416 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2154 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2154 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2154 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2154 "../src/Photo.vala"
				_tmp9_ = flags;
#line 2154 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2154 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2155 "../src/Photo.vala"
				_tmp10_ = committed;
#line 2155 "../src/Photo.vala"
				if (_tmp10_) {
#line 17438 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2156 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2156 "../src/Photo.vala"
					_tmp12_ = flags;
#line 2156 "../src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17447 "Photo.c"
				}
			}
		}
		__finally340:
		{
			PhotoRow* _tmp13_;
#line 2151 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 2151 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17458 "Photo.c"
		}
#line 2151 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17462 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2151 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2151 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2151 "../src/Photo.vala"
			return _tmp14_;
#line 17470 "Photo.c"
		}
	}
#line 2160 "../src/Photo.vala"
	_tmp15_ = committed;
#line 2160 "../src/Photo.vala"
	if (_tmp15_) {
#line 2161 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17479 "Photo.c"
	}
#line 2163 "../src/Photo.vala"
	result = flags;
#line 2163 "../src/Photo.vala"
	return result;
#line 17485 "Photo.c"
}


gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2166 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 17496 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2167 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2167 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17504 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2168 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2168 "../src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2168 "../src/Photo.vala"
			result = _tmp2_;
#line 17514 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2167 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2167 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17521 "Photo.c"
			}
#line 2168 "../src/Photo.vala"
			return result;
#line 17525 "Photo.c"
		}
		__finally341:
		{
			PhotoRow* _tmp4_;
#line 2167 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2167 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17534 "Photo.c"
		}
#line 2167 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2167 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2167 "../src/Photo.vala"
		return _tmp5_;
#line 17542 "Photo.c"
	}
}


void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2172 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2173 "../src/Photo.vala"
	committed = FALSE;
#line 17559 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2174 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2174 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17566 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2175 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2175 "../src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2175 "../src/Photo.vala"
			if (_tmp2_ != dirty) {
#line 17576 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
				PhotoRow* _tmp6_;
#line 2176 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2176 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2176 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2176 "../src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp4_, &_tmp5_, dirty, &_inner_error0_);
#line 2176 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2176 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17593 "Photo.c"
					goto __finally342;
				}
#line 2177 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2177 "../src/Photo.vala"
				_tmp6_->metadata_dirty = dirty;
#line 2178 "../src/Photo.vala"
				committed = TRUE;
#line 17602 "Photo.c"
			}
		}
		__finally342:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp7_;
#line 2174 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2174 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17613 "Photo.c"
		}
#line 2174 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2174 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2174 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 2174 "../src/Photo.vala"
				return;
#line 17623 "Photo.c"
			} else {
#line 2174 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2174 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2174 "../src/Photo.vala"
				return;
#line 17631 "Photo.c"
			}
		}
	}
#line 2182 "../src/Photo.vala"
	_tmp8_ = committed;
#line 2182 "../src/Photo.vala"
	if (_tmp8_) {
#line 17639 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2183 "../src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "master-dirty");
#line 2183 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2183 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2183 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 17650 "Photo.c"
	}
}


static Rating
photo_real_get_rating (MediaSource* base)
{
	Photo * self;
	Rating result = 0;
	GError* _inner_error0_ = NULL;
#line 2186 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17663 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2187 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2187 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17670 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2188 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2188 "../src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2188 "../src/Photo.vala"
			result = _tmp2_;
#line 17680 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2187 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2187 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17687 "Photo.c"
			}
#line 2188 "../src/Photo.vala"
			return result;
#line 17691 "Photo.c"
		}
		__finally343:
		{
			PhotoRow* _tmp4_;
#line 2187 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2187 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17700 "Photo.c"
		}
#line 2187 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2187 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2187 "../src/Photo.vala"
		return 0;
#line 17708 "Photo.c"
	}
}


static void
photo_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 2192 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2193 "../src/Photo.vala"
	committed = FALSE;
#line 17725 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2195 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2195 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17732 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Rating _tmp3_;
#line 2196 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2196 "../src/Photo.vala"
			_tmp3_ = _tmp2_->rating;
#line 2196 "../src/Photo.vala"
			if (rating != _tmp3_) {
#line 2196 "../src/Photo.vala"
				_tmp1_ = rating_is_valid (rating);
#line 17745 "Photo.c"
			} else {
#line 2196 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 17749 "Photo.c"
			}
#line 2196 "../src/Photo.vala"
			if (_tmp1_) {
#line 17753 "Photo.c"
				PhotoTable* _tmp4_;
				PhotoTable* _tmp5_;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_;
#line 2197 "../src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2197 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2197 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2197 "../src/Photo.vala"
				committed = photo_table_set_rating (_tmp5_, &_tmp6_, rating);
#line 2197 "../src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2198 "../src/Photo.vala"
				_tmp7_ = committed;
#line 2198 "../src/Photo.vala"
				if (_tmp7_) {
#line 17772 "Photo.c"
					PhotoRow* _tmp8_;
#line 2199 "../src/Photo.vala"
					_tmp8_ = self->row;
#line 2199 "../src/Photo.vala"
					_tmp8_->rating = rating;
#line 17778 "Photo.c"
				}
			}
		}
		__finally344:
		{
			PhotoRow* _tmp9_;
#line 2195 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2195 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17789 "Photo.c"
		}
#line 2195 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2195 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2195 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2195 "../src/Photo.vala"
			return;
#line 17799 "Photo.c"
		}
	}
#line 2203 "../src/Photo.vala"
	_tmp10_ = committed;
#line 2203 "../src/Photo.vala"
	if (_tmp10_) {
#line 17806 "Photo.c"
		Alteration* _tmp11_;
		Alteration* _tmp12_;
#line 2204 "../src/Photo.vala"
		_tmp11_ = alteration_new ("metadata", "rating");
#line 2204 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 2204 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp12_);
#line 2204 "../src/Photo.vala"
		_alteration_unref0 (_tmp12_);
#line 17817 "Photo.c"
	}
}


static void
photo_real_increase_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2207 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17829 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2208 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2208 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17836 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2209 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2209 "../src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2209 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp2_));
#line 17846 "Photo.c"
		}
		__finally345:
		{
			PhotoRow* _tmp3_;
#line 2208 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2208 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17855 "Photo.c"
		}
#line 2208 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2208 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2208 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2208 "../src/Photo.vala"
			return;
#line 17865 "Photo.c"
		}
	}
}


static void
photo_real_decrease_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2213 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17878 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2214 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2214 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17885 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2215 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2215 "../src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2215 "../src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp2_));
#line 17895 "Photo.c"
		}
		__finally346:
		{
			PhotoRow* _tmp3_;
#line 2214 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2214 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17904 "Photo.c"
		}
#line 2214 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2214 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2214 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2214 "../src/Photo.vala"
			return;
#line 17914 "Photo.c"
		}
	}
}


static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2219 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2219 "../src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 17931 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2224 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2224 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2224 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2224 "../src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2224 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2224 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2224 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17950 "Photo.c"
				goto __catch347_database_error;
			}
#line 2224 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2224 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2224 "../src/Photo.vala"
			return;
#line 17959 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2225 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2225 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 17967 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2226 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2226 "../src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2226 "../src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2226 "../src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 17979 "Photo.c"
			}
			__finally348:
			{
				PhotoRow* _tmp6_;
#line 2225 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2225 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17988 "Photo.c"
			}
#line 2225 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2225 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 17994 "Photo.c"
					goto __catch347_database_error;
				}
#line 2225 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2225 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2225 "../src/Photo.vala"
				return;
#line 18003 "Photo.c"
			}
		}
	}
	goto __finally347;
	__catch347_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2223 "../src/Photo.vala"
		err = _inner_error0_;
#line 2223 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2229 "../src/Photo.vala"
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2229 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2229 "../src/Photo.vala"
		_tmp9_ = err;
#line 2229 "../src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2229 "../src/Photo.vala"
		g_warning ("Photo.vala:2229: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2229 "../src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2223 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18033 "Photo.c"
	}
	__finally347:
#line 2223 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2223 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2223 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2223 "../src/Photo.vala"
		return;
#line 18044 "Photo.c"
	}
}


static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2237 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2237 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 18060 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2238 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2238 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18068 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 2239 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2239 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2239 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2239 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2239 "../src/Photo.vala"
			_tmp5_ = *event_id;
#line 2239 "../src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2239 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2239 "../src/Photo.vala"
			committed = _tmp6_;
#line 2241 "../src/Photo.vala"
			_tmp7_ = committed;
#line 2241 "../src/Photo.vala"
			if (_tmp7_) {
#line 18098 "Photo.c"
				PhotoRow* _tmp8_;
				EventID _tmp9_;
#line 2242 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 2242 "../src/Photo.vala"
				_tmp9_ = *event_id;
#line 2242 "../src/Photo.vala"
				_tmp8_->event_id = _tmp9_;
#line 18107 "Photo.c"
			}
#line 2244 "../src/Photo.vala"
			result = committed;
#line 18111 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2238 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 2238 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18118 "Photo.c"
			}
#line 2244 "../src/Photo.vala"
			return result;
#line 18122 "Photo.c"
		}
		__finally349:
		{
			PhotoRow* _tmp11_;
#line 2238 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2238 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18131 "Photo.c"
		}
#line 2238 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2238 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2238 "../src/Photo.vala"
		return _tmp12_;
#line 18139 "Photo.c"
	}
}


static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gint64 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 2248 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2250 "../src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 18164 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2250 "../src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2250 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2250 "../src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2250 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2250 "../src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2250 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2250 "../src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2250 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2250 "../src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2250 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2250 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2250 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 18196 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2250 "../src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2250 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2250 "../src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 18205 "Photo.c"
	}
#line 2249 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2249 "../src/Photo.vala"
	_tmp10_ = _tmp9_.id;
#line 2249 "../src/Photo.vala"
	_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp10_);
#line 2249 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2249 "../src/Photo.vala"
	_tmp13_ = photo_get_master_reader (self);
#line 2249 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2249 "../src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2249 "../src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2249 "../src/Photo.vala"
	_tmp17_ = g_strdup_printf ("[%s] %s%s", _tmp12_, _tmp16_, _tmp0_);
#line 2249 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2249 "../src/Photo.vala"
	_g_free0 (_tmp16_);
#line 2249 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp14_);
#line 2249 "../src/Photo.vala"
	_g_free0 (_tmp12_);
#line 2249 "../src/Photo.vala"
	result = _tmp18_;
#line 2249 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2249 "../src/Photo.vala"
	return result;
#line 18239 "Photo.c"
}


static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 2253 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2253 "../src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2255 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_PHOTO) ? ((Photo*) source) : NULL);
#line 2255 "../src/Photo.vala"
	photo = _tmp0_;
#line 2256 "../src/Photo.vala"
	_tmp1_ = photo;
#line 2256 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 18264 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2257 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2257 "../src/Photo.vala"
		photo_id = _tmp2_;
#line 2258 "../src/Photo.vala"
		_tmp3_ = photo;
#line 2258 "../src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2258 "../src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2260 "../src/Photo.vala"
		_tmp6_ = photo;
#line 2260 "../src/Photo.vala"
		if (self != _tmp6_) {
#line 18286 "Photo.c"
			PhotoID _tmp7_;
			gint64 _tmp8_;
#line 2260 "../src/Photo.vala"
			_tmp7_ = photo_id;
#line 2260 "../src/Photo.vala"
			_tmp8_ = _tmp7_.id;
#line 2260 "../src/Photo.vala"
			_tmp5_ = _tmp8_ != PHOTO_ID_INVALID;
#line 18295 "Photo.c"
		} else {
#line 2260 "../src/Photo.vala"
			_tmp5_ = FALSE;
#line 18299 "Photo.c"
		}
#line 2260 "../src/Photo.vala"
		if (_tmp5_) {
#line 18303 "Photo.c"
			PhotoID _tmp9_;
			gint64 _tmp10_;
			PhotoID _tmp11_;
			gint64 _tmp12_;
#line 2261 "../src/Photo.vala"
			_tmp9_ = photo_id;
#line 2261 "../src/Photo.vala"
			_tmp10_ = _tmp9_.id;
#line 2261 "../src/Photo.vala"
			_tmp11_ = other_photo_id;
#line 2261 "../src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 2261 "../src/Photo.vala"
			_vala_assert (_tmp10_ != _tmp12_, "photo_id.id != other_photo_id.id");
#line 18318 "Photo.c"
		}
	}
#line 2265 "../src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), source);
#line 2265 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 2265 "../src/Photo.vala"
	return result;
#line 18327 "Photo.c"
}


static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_;
	gboolean _tmp15_ = FALSE;
	DetectedPhotoInformation* _tmp16_;
	gboolean success = FALSE;
	gboolean _tmp34_;
	GError* _inner_error0_ = NULL;
#line 2269 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2270 "../src/Photo.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2270 "../src/Photo.vala"
	file = _tmp0_;
#line 2272 "../src/Photo.vala"
	info = NULL;
#line 18357 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2274 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2274 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2274 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18368 "Photo.c"
			goto __catch350_g_error;
		}
#line 2274 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2274 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 2274 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2274 "../src/Photo.vala"
		info = _tmp3_;
#line 2273 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 18381 "Photo.c"
	}
	goto __finally350;
	__catch350_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2273 "../src/Photo.vala"
		err = _inner_error0_;
#line 2273 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2277 "../src/Photo.vala"
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2277 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2277 "../src/Photo.vala"
		_tmp6_ = err->message;
#line 2277 "../src/Photo.vala"
		g_error ("Photo.vala:2277: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2277 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2273 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18406 "Photo.c"
	}
	__finally350:
#line 2273 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2273 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2273 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2273 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2273 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2273 "../src/Photo.vala"
		return;
#line 18421 "Photo.c"
	}
#line 2280 "../src/Photo.vala"
	_tmp7_ = info;
#line 2280 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2280 "../src/Photo.vala"
	timestamp = _tmp8_;
#line 2283 "../src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2283 "../src/Photo.vala"
	interrogator = _tmp9_;
#line 18433 "Photo.c"
	{
#line 2285 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2285 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18439 "Photo.c"
			goto __catch351_g_error;
		}
	}
	goto __finally351;
	__catch351_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 2284 "../src/Photo.vala"
		err = _inner_error0_;
#line 2284 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2287 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2287 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2287 "../src/Photo.vala"
		_tmp12_ = err;
#line 2287 "../src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2287 "../src/Photo.vala"
		g_warning ("Photo.vala:2287: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2287 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2284 "../src/Photo.vala"
		_g_error_free0 (err);
#line 18469 "Photo.c"
	}
	__finally351:
#line 2284 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2284 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2284 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2284 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2284 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2284 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2284 "../src/Photo.vala"
		return;
#line 18486 "Photo.c"
	}
#line 2290 "../src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2290 "../src/Photo.vala"
	detected = _tmp14_;
#line 2291 "../src/Photo.vala"
	_tmp16_ = detected;
#line 2291 "../src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 2291 "../src/Photo.vala"
		_tmp15_ = TRUE;
#line 18498 "Photo.c"
	} else {
#line 2291 "../src/Photo.vala"
		_tmp15_ = photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 18502 "Photo.c"
	}
#line 2291 "../src/Photo.vala"
	if (_tmp15_) {
#line 18506 "Photo.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 2292 "../src/Photo.vala"
		_tmp17_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2292 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2292 "../src/Photo.vala"
		g_critical ("Photo.vala:2292: file_exif_updated: %s no longer an image", _tmp18_);
#line 2292 "../src/Photo.vala"
		_g_free0 (_tmp18_);
#line 2294 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2294 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2294 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2294 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2294 "../src/Photo.vala"
		return;
#line 18527 "Photo.c"
	}
	{
		PhotoRow* _tmp19_;
#line 2298 "../src/Photo.vala"
		_tmp19_ = self->row;
#line 2298 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18535 "Photo.c"
		{
			PhotoTable* _tmp20_;
			PhotoTable* _tmp21_;
			PhotoID _tmp22_ = {0};
			GFileInfo* _tmp23_;
			GTimeVal _tmp24_;
			glong _tmp25_;
			DetectedPhotoInformation* _tmp26_;
			const gchar* _tmp27_;
			DetectedPhotoInformation* _tmp28_;
			const gchar* _tmp29_;
			DetectedPhotoInformation* _tmp30_;
			const gchar* _tmp31_;
			PhotoRow* _tmp32_;
#line 2299 "../src/Photo.vala"
			_tmp20_ = photo_table_get_instance ();
#line 2299 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 2299 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp22_);
#line 2299 "../src/Photo.vala"
			_tmp23_ = info;
#line 2299 "../src/Photo.vala"
			_tmp24_ = timestamp;
#line 2299 "../src/Photo.vala"
			_tmp25_ = _tmp24_.tv_sec;
#line 2299 "../src/Photo.vala"
			_tmp26_ = detected;
#line 2299 "../src/Photo.vala"
			_tmp27_ = _tmp26_->md5;
#line 2299 "../src/Photo.vala"
			_tmp28_ = detected;
#line 2299 "../src/Photo.vala"
			_tmp29_ = _tmp28_->exif_md5;
#line 2299 "../src/Photo.vala"
			_tmp30_ = detected;
#line 2299 "../src/Photo.vala"
			_tmp31_ = _tmp30_->thumbnail_md5;
#line 2299 "../src/Photo.vala"
			_tmp32_ = self->row;
#line 2299 "../src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp21_, &_tmp22_, g_file_info_get_size (_tmp23_), _tmp25_, _tmp27_, _tmp29_, _tmp31_, _tmp32_);
#line 2299 "../src/Photo.vala"
			_database_table_unref0 (_tmp21_);
#line 18580 "Photo.c"
		}
		__finally352:
		{
			PhotoRow* _tmp33_;
#line 2298 "../src/Photo.vala"
			_tmp33_ = self->row;
#line 2298 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18589 "Photo.c"
		}
#line 2298 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2298 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2298 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2298 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 2298 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 2298 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2298 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2298 "../src/Photo.vala"
			return;
#line 18607 "Photo.c"
		}
	}
#line 2303 "../src/Photo.vala"
	_tmp34_ = success;
#line 2303 "../src/Photo.vala"
	if (_tmp34_) {
#line 18614 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2304 "../src/Photo.vala"
		_tmp35_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2304 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2304 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 2304 "../src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 18625 "Photo.c"
	}
#line 2269 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2269 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2269 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 2269 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 18635 "Photo.c"
}


static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2309 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18647 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2310 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2310 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18655 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2311 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2311 "../src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2311 "../src/Photo.vala"
			result = (guint64) _tmp2_;
#line 18665 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2310 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2310 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18672 "Photo.c"
			}
#line 2311 "../src/Photo.vala"
			return result;
#line 18676 "Photo.c"
		}
		__finally353:
		{
			PhotoRow* _tmp4_;
#line 2310 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2310 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18685 "Photo.c"
		}
#line 2310 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2310 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2310 "../src/Photo.vala"
		return _tmp5_;
#line 18693 "Photo.c"
	}
}


static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2315 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18706 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp6_ = 0ULL;
#line 2316 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2316 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18714 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			gint64 _tmp3_;
#line 2317 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2317 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2317 "../src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2317 "../src/Photo.vala"
			result = (guint64) _tmp3_;
#line 18727 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2316 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2316 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18734 "Photo.c"
			}
#line 2317 "../src/Photo.vala"
			return result;
#line 18738 "Photo.c"
		}
		__finally354:
		{
			PhotoRow* _tmp5_;
#line 2316 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2316 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18747 "Photo.c"
		}
#line 2316 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2316 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2316 "../src/Photo.vala"
		return _tmp6_;
#line 18755 "Photo.c"
	}
}


guint64
photo_get_editable_filesize (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2321 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 18767 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2322 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2322 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18775 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2323 "../src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2323 "../src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2323 "../src/Photo.vala"
			result = (guint64) _tmp2_;
#line 18785 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2322 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2322 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18792 "Photo.c"
			}
#line 2323 "../src/Photo.vala"
			return result;
#line 18796 "Photo.c"
		}
		__finally355:
		{
			PhotoRow* _tmp4_;
#line 2322 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2322 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18805 "Photo.c"
		}
#line 2322 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2322 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2322 "../src/Photo.vala"
		return _tmp5_;
#line 18813 "Photo.c"
	}
}


static time_t
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	time_t result = 0;
	time_t _tmp0_;
#line 2327 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2328 "../src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2328 "../src/Photo.vala"
	result = _tmp0_;
#line 2328 "../src/Photo.vala"
	return result;
#line 18832 "Photo.c"
}


static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2331 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18844 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2332 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2332 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18851 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2333 "../src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2333 "../src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2333 "../src/Photo.vala"
			result = _tmp2_;
#line 18861 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2332 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2332 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18868 "Photo.c"
			}
#line 2333 "../src/Photo.vala"
			return result;
#line 18872 "Photo.c"
		}
		__finally356:
		{
			PhotoRow* _tmp4_;
#line 2332 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2332 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18881 "Photo.c"
		}
#line 2332 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2332 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2332 "../src/Photo.vala"
		return NULL;
#line 18889 "Photo.c"
	}
}


static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2337 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18902 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2338 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2338 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18909 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2339 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2339 "../src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2339 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2339 "../src/Photo.vala"
			result = _tmp3_;
#line 18922 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2338 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2338 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18929 "Photo.c"
			}
#line 2339 "../src/Photo.vala"
			return result;
#line 18933 "Photo.c"
		}
		__finally357:
		{
			PhotoRow* _tmp5_;
#line 2338 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2338 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18942 "Photo.c"
		}
#line 2338 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2338 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2338 "../src/Photo.vala"
		return NULL;
#line 18950 "Photo.c"
	}
}


static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2343 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18963 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2344 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2344 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18970 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2345 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2345 "../src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2345 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2345 "../src/Photo.vala"
			result = _tmp3_;
#line 18983 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2344 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2344 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18990 "Photo.c"
			}
#line 2345 "../src/Photo.vala"
			return result;
#line 18994 "Photo.c"
		}
		__finally358:
		{
			PhotoRow* _tmp5_;
#line 2344 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2344 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19003 "Photo.c"
		}
#line 2344 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2344 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2344 "../src/Photo.vala"
		return NULL;
#line 19011 "Photo.c"
	}
}


static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
#line 2349 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2350 "../src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2350 "../src/Photo.vala"
	new_title = _tmp0_;
#line 2352 "../src/Photo.vala"
	committed = FALSE;
#line 19034 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2353 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2353 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19041 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2354 "../src/Photo.vala"
			_tmp2_ = new_title;
#line 2354 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2354 "../src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2354 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 19060 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2353 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2353 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19067 "Photo.c"
				}
#line 2355 "../src/Photo.vala"
				_g_free0 (new_title);
#line 2355 "../src/Photo.vala"
				return;
#line 19073 "Photo.c"
			}
#line 2357 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2357 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2357 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2357 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2357 "../src/Photo.vala"
			_tmp10_ = new_title;
#line 2357 "../src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2357 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2358 "../src/Photo.vala"
			_tmp11_ = committed;
#line 2358 "../src/Photo.vala"
			if (_tmp11_) {
#line 19093 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2359 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 2359 "../src/Photo.vala"
				_tmp13_ = new_title;
#line 2359 "../src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2359 "../src/Photo.vala"
				_g_free0 (_tmp12_->title);
#line 2359 "../src/Photo.vala"
				_tmp12_->title = _tmp14_;
#line 19107 "Photo.c"
			}
		}
		__finally359:
		{
			PhotoRow* _tmp15_;
#line 2353 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2353 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19117 "Photo.c"
		}
#line 2353 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2353 "../src/Photo.vala"
			_g_free0 (new_title);
#line 2353 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2353 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2353 "../src/Photo.vala"
			return;
#line 19129 "Photo.c"
		}
	}
#line 2362 "../src/Photo.vala"
	_tmp16_ = committed;
#line 2362 "../src/Photo.vala"
	if (_tmp16_) {
#line 19136 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 2363 "../src/Photo.vala"
		_tmp17_ = alteration_new ("metadata", "name");
#line 2363 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2363 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 2363 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 19147 "Photo.c"
	}
#line 2349 "../src/Photo.vala"
	_g_free0 (new_title);
#line 19151 "Photo.c"
}


static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 2366 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2367 "../src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2367 "../src/Photo.vala"
	new_comment = _tmp0_;
#line 2369 "../src/Photo.vala"
	committed = FALSE;
#line 19174 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2370 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2370 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19181 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2371 "../src/Photo.vala"
			_tmp2_ = new_comment;
#line 2371 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2371 "../src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2371 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2372 "../src/Photo.vala"
				result = TRUE;
#line 19202 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2370 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2370 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19209 "Photo.c"
				}
#line 2372 "../src/Photo.vala"
				_g_free0 (new_comment);
#line 2372 "../src/Photo.vala"
				return result;
#line 19215 "Photo.c"
			}
#line 2374 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2374 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2374 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2374 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2374 "../src/Photo.vala"
			_tmp10_ = new_comment;
#line 2374 "../src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2374 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2375 "../src/Photo.vala"
			_tmp11_ = committed;
#line 2375 "../src/Photo.vala"
			if (_tmp11_) {
#line 19235 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2376 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 2376 "../src/Photo.vala"
				_tmp13_ = new_comment;
#line 2376 "../src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2376 "../src/Photo.vala"
				_g_free0 (_tmp12_->comment);
#line 2376 "../src/Photo.vala"
				_tmp12_->comment = _tmp14_;
#line 19249 "Photo.c"
			}
		}
		__finally360:
		{
			PhotoRow* _tmp15_;
#line 2370 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2370 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19259 "Photo.c"
		}
#line 2370 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19263 "Photo.c"
			gboolean _tmp16_ = FALSE;
#line 2370 "../src/Photo.vala"
			_g_free0 (new_comment);
#line 2370 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2370 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2370 "../src/Photo.vala"
			return _tmp16_;
#line 19273 "Photo.c"
		}
	}
#line 2379 "../src/Photo.vala"
	_tmp17_ = committed;
#line 2379 "../src/Photo.vala"
	if (_tmp17_) {
#line 19280 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2380 "../src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "comment");
#line 2380 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2380 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
#line 2380 "../src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 19291 "Photo.c"
	}
#line 2382 "../src/Photo.vala"
	result = committed;
#line 2382 "../src/Photo.vala"
	_g_free0 (new_comment);
#line 2382 "../src/Photo.vala"
	return result;
#line 19299 "Photo.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 2392 "../src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 19308 "Photo.c"
}


void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 2385 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2385 "../src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2386 "../src/Photo.vala"
	dberr = NULL;
#line 19325 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2387 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2387 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19332 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2389 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2389 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2389 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2389 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2389 "../src/Photo.vala"
				_tmp5_ = *import_id;
#line 2389 "../src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2389 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2389 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2389 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19360 "Photo.c"
						goto __catch362_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2387 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2387 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19369 "Photo.c"
					}
#line 2389 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2389 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2389 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2389 "../src/Photo.vala"
					return;
#line 19379 "Photo.c"
				}
#line 2390 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2390 "../src/Photo.vala"
				_tmp8_ = *import_id;
#line 2390 "../src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 19387 "Photo.c"
			}
			goto __finally362;
			__catch362_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2388 "../src/Photo.vala"
				err = _inner_error0_;
#line 2388 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2392 "../src/Photo.vala"
				_tmp9_ = err;
#line 2392 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2392 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2392 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2388 "../src/Photo.vala"
				_g_error_free0 (err);
#line 19409 "Photo.c"
			}
			__finally362:
#line 2388 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19414 "Photo.c"
				{
					PhotoRow* _tmp11_;
#line 2387 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2387 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19421 "Photo.c"
				}
#line 2388 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2388 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2388 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2388 "../src/Photo.vala"
				return;
#line 19431 "Photo.c"
			}
		}
		__finally361:
		{
			PhotoRow* _tmp12_;
#line 2387 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2387 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19441 "Photo.c"
		}
#line 2387 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2387 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2387 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2387 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2387 "../src/Photo.vala"
			return;
#line 19453 "Photo.c"
		}
	}
#line 2396 "../src/Photo.vala"
	_tmp13_ = dberr;
#line 2396 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 19460 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2397 "../src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2397 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2397 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 2397 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 19471 "Photo.c"
	} else {
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 2399 "../src/Photo.vala"
		_tmp16_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2399 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2399 "../src/Photo.vala"
		_tmp18_ = dberr;
#line 2399 "../src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2399 "../src/Photo.vala"
		g_warning ("Photo.vala:2399: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2399 "../src/Photo.vala"
		_g_free0 (_tmp17_);
#line 19489 "Photo.c"
	}
#line 2385 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 19493 "Photo.c"
}


void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2402 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2403 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2403 "../src/Photo.vala"
	source = _tmp0_;
#line 2406 "../src/Photo.vala"
	_tmp1_ = source;
#line 2406 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19526 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2407 "../src/Photo.vala"
		_tmp2_ = source;
#line 2407 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2407 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2407 "../src/Photo.vala"
		g_warning ("Photo.vala:2407: No photo file writer available for %s", _tmp4_);
#line 2407 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2409 "../src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2411 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2411 "../src/Photo.vala"
		return;
#line 19546 "Photo.c"
	}
#line 2414 "../src/Photo.vala"
	_tmp5_ = source;
#line 2414 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2414 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2414 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2414 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2414 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2414 "../src/Photo.vala"
		return;
#line 19562 "Photo.c"
	}
#line 2415 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2415 "../src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2417 "../src/Photo.vala"
	_tmp8_ = source;
#line 2417 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2417 "../src/Photo.vala"
	writer = _tmp9_;
#line 2417 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2417 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2417 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2417 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2417 "../src/Photo.vala"
		return;
#line 19584 "Photo.c"
	}
#line 2418 "../src/Photo.vala"
	_tmp10_ = source;
#line 2418 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2418 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2418 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2418 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19596 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2420 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2420 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2420 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2420 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19608 "Photo.c"
			goto __finally363;
		}
	}
	__finally363:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2422 "../src/Photo.vala"
		_tmp15_ = source;
#line 2422 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2422 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2422 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2422 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19628 "Photo.c"
	}
#line 2419 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2419 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2419 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2419 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2419 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2419 "../src/Photo.vala"
		return;
#line 19642 "Photo.c"
	}
#line 2425 "../src/Photo.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2427 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2402 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2402 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2402 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19654 "Photo.c"
}


void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2430 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2431 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2431 "../src/Photo.vala"
	source = _tmp0_;
#line 2434 "../src/Photo.vala"
	_tmp1_ = source;
#line 2434 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19687 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2435 "../src/Photo.vala"
		_tmp2_ = source;
#line 2435 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2435 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2435 "../src/Photo.vala"
		g_warning ("Photo.vala:2435: No photo file writer available for %s", _tmp4_);
#line 2435 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2437 "../src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2439 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2439 "../src/Photo.vala"
		return;
#line 19707 "Photo.c"
	}
#line 2442 "../src/Photo.vala"
	_tmp5_ = source;
#line 2442 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2442 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2442 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2442 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2442 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2442 "../src/Photo.vala"
		return;
#line 19723 "Photo.c"
	}
#line 2443 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2443 "../src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2445 "../src/Photo.vala"
	_tmp8_ = source;
#line 2445 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2445 "../src/Photo.vala"
	writer = _tmp9_;
#line 2445 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2445 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2445 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2445 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2445 "../src/Photo.vala"
		return;
#line 19745 "Photo.c"
	}
#line 2446 "../src/Photo.vala"
	_tmp10_ = source;
#line 2446 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2446 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2446 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2446 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19757 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2448 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2448 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2448 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2448 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19769 "Photo.c"
			goto __finally364;
		}
	}
	__finally364:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2450 "../src/Photo.vala"
		_tmp15_ = source;
#line 2450 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2450 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2450 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2450 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 19789 "Photo.c"
	}
#line 2447 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2447 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2447 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2447 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2447 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2447 "../src/Photo.vala"
		return;
#line 19803 "Photo.c"
	}
#line 2453 "../src/Photo.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2455 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2430 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2430 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2430 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 19815 "Photo.c"
}


static void
photo_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2458 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19829 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2460 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2460 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19836 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_;
#line 2461 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2461 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2461 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2461 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2461 "../src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2461 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2462 "../src/Photo.vala"
			_tmp5_ = committed;
#line 2462 "../src/Photo.vala"
			if (_tmp5_) {
#line 19859 "Photo.c"
				PhotoRow* _tmp6_;
#line 2463 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2463 "../src/Photo.vala"
				_tmp6_->exposure_time = time;
#line 2464 "../src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 19867 "Photo.c"
			}
		}
		__finally365:
		{
			PhotoRow* _tmp7_;
#line 2460 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2460 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19877 "Photo.c"
		}
#line 2460 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2460 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2460 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2460 "../src/Photo.vala"
			return;
#line 19887 "Photo.c"
		}
	}
#line 2468 "../src/Photo.vala"
	_tmp8_ = committed;
#line 2468 "../src/Photo.vala"
	if (_tmp8_) {
#line 19894 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2469 "../src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "exposure-time");
#line 2469 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2469 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2469 "../src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 19905 "Photo.c"
	}
}


void
photo_set_exposure_time_persistent (Photo* self,
                                    time_t time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2472 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2473 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2473 "../src/Photo.vala"
	source = _tmp0_;
#line 2476 "../src/Photo.vala"
	_tmp1_ = source;
#line 2476 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19941 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2477 "../src/Photo.vala"
		_tmp2_ = source;
#line 2477 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2477 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2477 "../src/Photo.vala"
		g_warning ("Photo.vala:2477: No photo file writer available for %s", _tmp4_);
#line 2477 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2479 "../src/Photo.vala"
		dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2481 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2481 "../src/Photo.vala"
		return;
#line 19961 "Photo.c"
	}
#line 2484 "../src/Photo.vala"
	_tmp5_ = source;
#line 2484 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2484 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2484 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2484 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2484 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2484 "../src/Photo.vala"
		return;
#line 19977 "Photo.c"
	}
#line 2485 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2485 "../src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2485 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2485 "../src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2485 "../src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2487 "../src/Photo.vala"
	_tmp10_ = source;
#line 2487 "../src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2487 "../src/Photo.vala"
	writer = _tmp11_;
#line 2487 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2487 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2487 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2487 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2487 "../src/Photo.vala"
		return;
#line 20005 "Photo.c"
	}
#line 2488 "../src/Photo.vala"
	_tmp12_ = source;
#line 2488 "../src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2488 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2488 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2488 "../src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 20017 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2490 "../src/Photo.vala"
		_tmp15_ = writer;
#line 2490 "../src/Photo.vala"
		_tmp16_ = metadata;
#line 2490 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2490 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20029 "Photo.c"
			goto __finally366;
		}
	}
	__finally366:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2492 "../src/Photo.vala"
		_tmp17_ = source;
#line 2492 "../src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2492 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2492 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2492 "../src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 20049 "Photo.c"
	}
#line 2489 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2489 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2489 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2489 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2489 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2489 "../src/Photo.vala"
		return;
#line 20063 "Photo.c"
	}
#line 2495 "../src/Photo.vala"
	dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2497 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2472 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2472 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2472 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 20075 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2513 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2515 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2515 "../src/Photo.vala"
	returned_dims = _tmp0_;
#line 2518 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20108 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp1_;
#line 2519 "../src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2522 "../src/Photo.vala"
		_tmp1_ = ori_tmp;
#line 2522 "../src/Photo.vala"
		switch (_tmp1_) {
#line 2522 "../src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2522 "../src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2522 "../src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2522 "../src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 20125 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp2_;
				gint _tmp3_;
				Dimensions _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 2528 "../src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2528 "../src/Photo.vala"
				_tmp3_ = _tmp2_.width;
#line 2528 "../src/Photo.vala"
				width_tmp = _tmp3_;
#line 2530 "../src/Photo.vala"
				_tmp4_ = returned_dims;
#line 2530 "../src/Photo.vala"
				_tmp5_ = _tmp4_.height;
#line 2530 "../src/Photo.vala"
				returned_dims.width = _tmp5_;
#line 2531 "../src/Photo.vala"
				_tmp6_ = width_tmp;
#line 2531 "../src/Photo.vala"
				returned_dims.height = _tmp6_;
#line 2532 "../src/Photo.vala"
				break;
#line 20151 "Photo.c"
			}
			default:
			{
#line 2536 "../src/Photo.vala"
				break;
#line 20157 "Photo.c"
			}
		}
	}
#line 2541 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 20163 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp7_ = 0.0;
		Dimensions _tmp8_;
		gint _tmp9_;
		Dimensions _tmp10_;
		gint _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_;
		gdouble _tmp16_;
#line 2543 "../src/Photo.vala"
		angle = 0.0;
#line 2545 "../src/Photo.vala"
		photo_get_straighten (self, &_tmp7_);
#line 2545 "../src/Photo.vala"
		angle = _tmp7_;
#line 2547 "../src/Photo.vala"
		_tmp8_ = returned_dims;
#line 2547 "../src/Photo.vala"
		_tmp9_ = _tmp8_.width;
#line 2547 "../src/Photo.vala"
		_tmp10_ = returned_dims;
#line 2547 "../src/Photo.vala"
		_tmp11_ = _tmp10_.height;
#line 2547 "../src/Photo.vala"
		_tmp12_ = angle;
#line 2547 "../src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp9_, (gdouble) _tmp11_, _tmp12_, &_tmp13_, &_tmp14_);
#line 2547 "../src/Photo.vala"
		x_size = _tmp13_;
#line 2547 "../src/Photo.vala"
		y_size = _tmp14_;
#line 2549 "../src/Photo.vala"
		_tmp15_ = x_size;
#line 2549 "../src/Photo.vala"
		returned_dims.width = (gint) _tmp15_;
#line 2550 "../src/Photo.vala"
		_tmp16_ = y_size;
#line 2550 "../src/Photo.vala"
		returned_dims.height = (gint) _tmp16_;
#line 20207 "Photo.c"
	}
#line 2554 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 20211 "Photo.c"
		Box crop = {0};
		Box _tmp17_ = {0};
		gboolean _tmp18_;
#line 2556 "../src/Photo.vala"
		_tmp18_ = photo_get_crop (self, &_tmp17_, disallowed_steps);
#line 2556 "../src/Photo.vala"
		crop = _tmp17_;
#line 2556 "../src/Photo.vala"
		if (_tmp18_) {
#line 20221 "Photo.c"
			Dimensions _tmp19_ = {0};
#line 2557 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 2557 "../src/Photo.vala"
			returned_dims = _tmp19_;
#line 20227 "Photo.c"
		}
	}
#line 2560 "../src/Photo.vala"
	*result = returned_dims;
#line 2560 "../src/Photo.vala"
	return;
#line 20234 "Photo.c"
}


static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2564 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2565 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2565 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2565 "../src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2567 "../src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2567 "../src/Photo.vala"
	map = _tmp1_;
#line 2568 "../src/Photo.vala"
	_tmp2_ = map;
#line 2568 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 20263 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2569 "../src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2569 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 20269 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2571 "../src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2571 "../src/Photo.vala"
		_tmp5_ = map;
#line 2571 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 20279 "Photo.c"
	}
#line 2573 "../src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2573 "../src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2573 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2573 "../src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2564 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20291 "Photo.c"
}


PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2577 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20302 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2578 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2578 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20309 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2579 "../src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2579 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2580 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20320 "Photo.c"
			}
#line 2582 "../src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2582 "../src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2582 "../src/Photo.vala"
			result = _tmp3_;
#line 20328 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2578 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2578 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20335 "Photo.c"
			}
#line 2582 "../src/Photo.vala"
			return result;
#line 20339 "Photo.c"
		}
		__finally367:
		{
			PhotoRow* _tmp5_;
#line 2578 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2578 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20348 "Photo.c"
		}
#line 2578 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2578 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2578 "../src/Photo.vala"
		return NULL;
#line 20356 "Photo.c"
	}
}


PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	PixelTransformer* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2586 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20368 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2587 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2587 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20375 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2588 "../src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2588 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2589 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20386 "Photo.c"
			}
#line 2591 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2591 "../src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2591 "../src/Photo.vala"
			result = _tmp3_;
#line 20394 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2587 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2587 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20401 "Photo.c"
			}
#line 2591 "../src/Photo.vala"
			return result;
#line 20405 "Photo.c"
		}
		__finally368:
		{
			PhotoRow* _tmp5_;
#line 2587 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2587 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20414 "Photo.c"
		}
#line 2587 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2587 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2587 "../src/Photo.vala"
		return NULL;
#line 20422 "Photo.c"
	}
}


gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result = FALSE;
#line 2595 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2596 "../src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2596 "../src/Photo.vala"
	return result;
#line 20437 "Photo.c"
}


PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
#line 2599 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2600 "../src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2600 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2600 "../src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2600 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2600 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2600 "../src/Photo.vala"
	result = _tmp3_;
#line 2600 "../src/Photo.vala"
	return result;
#line 20466 "Photo.c"
}


void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp5_;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 2603 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2603 "../src/Photo.vala"
	g_return_if_fail (IS_PIXEL_TRANSFORMATION_BUNDLE (new_adjustments));
#line 2606 "../src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 20485 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp2_;
		{
			PhotoRow* _tmp0_;
#line 2608 "../src/Photo.vala"
			_tmp0_ = self->row;
#line 2608 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20494 "Photo.c"
			{
#line 2609 "../src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2610 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2610 "../src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2611 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2611 "../src/Photo.vala"
				self->priv->transformer = NULL;
#line 20506 "Photo.c"
			}
			__finally369:
			{
				PhotoRow* _tmp1_;
#line 2608 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 2608 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20515 "Photo.c"
			}
#line 2608 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2608 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2608 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2608 "../src/Photo.vala"
				return;
#line 20525 "Photo.c"
			}
		}
#line 2614 "../src/Photo.vala"
		_tmp2_ = _result_;
#line 2614 "../src/Photo.vala"
		if (_tmp2_) {
#line 20532 "Photo.c"
			Alteration* _tmp3_;
			Alteration* _tmp4_;
#line 2615 "../src/Photo.vala"
			_tmp3_ = alteration_new ("image", "color-adjustments");
#line 2615 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 2615 "../src/Photo.vala"
			data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 2615 "../src/Photo.vala"
			_alteration_unref0 (_tmp4_);
#line 20543 "Photo.c"
		}
#line 2617 "../src/Photo.vala"
		return;
#line 20547 "Photo.c"
	}
#line 2621 "../src/Photo.vala"
	_tmp5_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2621 "../src/Photo.vala"
	map = _tmp5_;
#line 20553 "Photo.c"
	{
		PhotoRow* _tmp6_;
#line 2624 "../src/Photo.vala"
		_tmp6_ = self->row;
#line 2624 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20560 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
			PixelTransformer* _tmp8_;
			KeyValueMap* _tmp26_;
#line 2625 "../src/Photo.vala"
			_tmp8_ = self->priv->transformer;
#line 2625 "../src/Photo.vala"
			if (_tmp8_ == NULL) {
#line 2625 "../src/Photo.vala"
				_tmp7_ = TRUE;
#line 20571 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp9_;
#line 2625 "../src/Photo.vala"
				_tmp9_ = self->priv->adjustments;
#line 2625 "../src/Photo.vala"
				_tmp7_ = _tmp9_ == NULL;
#line 20578 "Photo.c"
			}
#line 2625 "../src/Photo.vala"
			if (_tmp7_) {
#line 20582 "Photo.c"
				PixelTransformationBundle* _tmp10_;
				PixelTransformer* _tmp11_;
#line 2627 "../src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2627 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2627 "../src/Photo.vala"
				self->priv->adjustments = _tmp10_;
#line 2628 "../src/Photo.vala"
				_tmp11_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2628 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2628 "../src/Photo.vala"
				self->priv->transformer = _tmp11_;
#line 20597 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp25_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp12_;
					GeeIterable* _tmp13_;
					GeeIterator* _tmp14_;
					GeeIterator* _tmp15_;
#line 2631 "../src/Photo.vala"
					_tmp12_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2631 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 2631 "../src/Photo.vala"
					_tmp14_ = gee_iterable_iterator (_tmp13_);
#line 2631 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 2631 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 2631 "../src/Photo.vala"
					_transformation_it = _tmp15_;
#line 2631 "../src/Photo.vala"
					while (TRUE) {
#line 20620 "Photo.c"
						GeeIterator* _tmp16_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp17_;
						gpointer _tmp18_;
						PixelTransformer* _tmp19_;
						PixelTransformationBundle* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
						PixelTransformation* _tmp24_;
#line 2631 "../src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2631 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp16_)) {
#line 2631 "../src/Photo.vala"
							break;
#line 20637 "Photo.c"
						}
#line 2631 "../src/Photo.vala"
						_tmp17_ = _transformation_it;
#line 2631 "../src/Photo.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 2631 "../src/Photo.vala"
						transformation = (PixelTransformation*) _tmp18_;
#line 2632 "../src/Photo.vala"
						_tmp19_ = self->priv->transformer;
#line 2632 "../src/Photo.vala"
						_tmp20_ = self->priv->adjustments;
#line 2632 "../src/Photo.vala"
						_tmp21_ = transformation;
#line 2632 "../src/Photo.vala"
						_tmp22_ = pixel_transformation_bundle_get_transformation (_tmp20_, pixel_transformation_get_transformation_type (_tmp21_));
#line 2632 "../src/Photo.vala"
						_tmp23_ = _tmp22_;
#line 2632 "../src/Photo.vala"
						_tmp24_ = transformation;
#line 2632 "../src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp19_, _tmp23_, _tmp24_);
#line 2632 "../src/Photo.vala"
						_pixel_transformation_unref0 (_tmp23_);
#line 2631 "../src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 20663 "Photo.c"
					}
#line 2631 "../src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 20667 "Photo.c"
				}
#line 2637 "../src/Photo.vala"
				_tmp25_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2637 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2637 "../src/Photo.vala"
				self->priv->adjustments = _tmp25_;
#line 20675 "Photo.c"
			}
#line 2640 "../src/Photo.vala"
			_tmp26_ = map;
#line 2640 "../src/Photo.vala"
			committed = photo_set_transformation (self, _tmp26_);
#line 20681 "Photo.c"
		}
		__finally370:
		{
			PhotoRow* _tmp27_;
#line 2624 "../src/Photo.vala"
			_tmp27_ = self->row;
#line 2624 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20690 "Photo.c"
		}
#line 2624 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2624 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2624 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2624 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2624 "../src/Photo.vala"
			return;
#line 20702 "Photo.c"
		}
	}
#line 2643 "../src/Photo.vala"
	_tmp28_ = committed;
#line 2643 "../src/Photo.vala"
	if (_tmp28_) {
#line 20709 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2644 "../src/Photo.vala"
		_tmp29_ = alteration_new ("image", "color-adjustments");
#line 2644 "../src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2644 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp30_);
#line 2644 "../src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 20720 "Photo.c"
	}
#line 2603 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20724 "Photo.c"
}


static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	PhotoMetadata* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2648 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 20736 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2650 "../src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2650 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2650 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2650 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2650 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2650 "../src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2650 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20758 "Photo.c"
			goto __catch371_g_error;
		}
#line 2650 "../src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2650 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 2650 "../src/Photo.vala"
		result = _tmp5_;
#line 2650 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2650 "../src/Photo.vala"
		return result;
#line 20771 "Photo.c"
	}
	goto __finally371;
	__catch371_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2649 "../src/Photo.vala"
		err = _inner_error0_;
#line 2649 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2652 "../src/Photo.vala"
		_tmp6_ = err;
#line 2652 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2652 "../src/Photo.vala"
		g_warning ("Photo.vala:2652: Unable to load metadata: %s", _tmp7_);
#line 2654 "../src/Photo.vala"
		result = NULL;
#line 2654 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2654 "../src/Photo.vala"
		return result;
#line 20795 "Photo.c"
	}
	__finally371:
#line 2649 "../src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2649 "../src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2649 "../src/Photo.vala"
	return NULL;
#line 20804 "Photo.c"
}


PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 2658 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2659 "../src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2659 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2659 "../src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2659 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2659 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2659 "../src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2659 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2659 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2659 "../src/Photo.vala"
		return NULL;
#line 20840 "Photo.c"
	}
#line 2659 "../src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2659 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 2659 "../src/Photo.vala"
	result = _tmp5_;
#line 2659 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2659 "../src/Photo.vala"
	return result;
#line 20852 "Photo.c"
}


PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 2662 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2663 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2663 "../src/Photo.vala"
	reader = _tmp0_;
#line 2665 "../src/Photo.vala"
	_tmp2_ = reader;
#line 2665 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 20876 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2665 "../src/Photo.vala"
		_tmp3_ = reader;
#line 2665 "../src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2665 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2665 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2665 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2665 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2665 "../src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2665 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2665 "../src/Photo.vala"
			return NULL;
#line 20897 "Photo.c"
		}
	} else {
#line 2665 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2665 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 20904 "Photo.c"
	}
#line 2665 "../src/Photo.vala"
	result = _tmp1_;
#line 2665 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2665 "../src/Photo.vala"
	return result;
#line 20912 "Photo.c"
}


gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState* * state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 2671 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2671 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2673 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2673 "../src/Photo.vala"
	_vala_state = NULL;
#line 2675 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2675 "../src/Photo.vala"
	master_reader = _tmp0_;
#line 2677 "../src/Photo.vala"
	_tmp1_ = master_reader;
#line 2677 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2678 "../src/Photo.vala"
		result = FALSE;
#line 2678 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2678 "../src/Photo.vala"
		if (state) {
#line 2678 "../src/Photo.vala"
			*state = _vala_state;
#line 20959 "Photo.c"
		} else {
#line 2678 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 20963 "Photo.c"
		}
#line 2678 "../src/Photo.vala"
		return result;
#line 20967 "Photo.c"
	}
#line 2680 "../src/Photo.vala"
	_tmp3_ = master_reader;
#line 2680 "../src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2680 "../src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2680 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20977 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2680 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2680 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2680 "../src/Photo.vala"
		return _tmp5_;
#line 20985 "Photo.c"
	}
#line 2680 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2680 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20991 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2680 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2680 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2680 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2680 "../src/Photo.vala"
		return _tmp6_;
#line 21001 "Photo.c"
	}
#line 2682 "../src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2682 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2682 "../src/Photo.vala"
	_vala_state = _tmp8_;
#line 2682 "../src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2682 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21013 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2682 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2682 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2682 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2682 "../src/Photo.vala"
		return _tmp10_;
#line 21023 "Photo.c"
	}
#line 2682 "../src/Photo.vala"
	if (!_tmp7_) {
#line 2683 "../src/Photo.vala"
		result = FALSE;
#line 2683 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2683 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2683 "../src/Photo.vala"
		if (state) {
#line 2683 "../src/Photo.vala"
			*state = _vala_state;
#line 21037 "Photo.c"
		} else {
#line 2683 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 21041 "Photo.c"
		}
#line 2683 "../src/Photo.vala"
		return result;
#line 21045 "Photo.c"
	}
#line 2685 "../src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2685 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2687 "../src/Photo.vala"
	result = TRUE;
#line 2687 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2687 "../src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2687 "../src/Photo.vala"
	if (state) {
#line 2687 "../src/Photo.vala"
		*state = _vala_state;
#line 21061 "Photo.c"
	} else {
#line 2687 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 21065 "Photo.c"
	}
#line 2687 "../src/Photo.vala"
	return result;
#line 21069 "Photo.c"
}


void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2690 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2690 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2691 "../src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2691 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2691 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2691 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2691 "../src/Photo.vala"
			return;
#line 21093 "Photo.c"
		} else {
#line 2691 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2691 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2691 "../src/Photo.vala"
			return;
#line 21101 "Photo.c"
		}
	}
}


gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState* * state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2694 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2694 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2696 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2696 "../src/Photo.vala"
	_vala_state = NULL;
#line 2698 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2698 "../src/Photo.vala"
	editable_reader = _tmp0_;
#line 2699 "../src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2699 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2700 "../src/Photo.vala"
		result = FALSE;
#line 2700 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2700 "../src/Photo.vala"
		if (state) {
#line 2700 "../src/Photo.vala"
			*state = _vala_state;
#line 21151 "Photo.c"
		} else {
#line 2700 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21155 "Photo.c"
		}
#line 2700 "../src/Photo.vala"
		return result;
#line 21159 "Photo.c"
	}
#line 2702 "../src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2702 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2703 "../src/Photo.vala"
		result = FALSE;
#line 2703 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2703 "../src/Photo.vala"
		if (state) {
#line 2703 "../src/Photo.vala"
			*state = _vala_state;
#line 21173 "Photo.c"
		} else {
#line 2703 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21177 "Photo.c"
		}
#line 2703 "../src/Photo.vala"
		return result;
#line 21181 "Photo.c"
	}
#line 2705 "../src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2705 "../src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2705 "../src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2705 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21191 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2705 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2705 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2705 "../src/Photo.vala"
		return _tmp6_;
#line 21199 "Photo.c"
	}
#line 2705 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2705 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21205 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2705 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2705 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2705 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2705 "../src/Photo.vala"
		return _tmp7_;
#line 21215 "Photo.c"
	}
#line 2707 "../src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2707 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2707 "../src/Photo.vala"
	_vala_state = _tmp9_;
#line 2707 "../src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2707 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21227 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2707 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2707 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2707 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2707 "../src/Photo.vala"
		return _tmp11_;
#line 21237 "Photo.c"
	}
#line 2707 "../src/Photo.vala"
	if (!_tmp8_) {
#line 2708 "../src/Photo.vala"
		result = FALSE;
#line 2708 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2708 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2708 "../src/Photo.vala"
		if (state) {
#line 2708 "../src/Photo.vala"
			*state = _vala_state;
#line 21251 "Photo.c"
		} else {
#line 2708 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21255 "Photo.c"
		}
#line 2708 "../src/Photo.vala"
		return result;
#line 21259 "Photo.c"
	}
#line 2710 "../src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2710 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2712 "../src/Photo.vala"
	result = TRUE;
#line 2712 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2712 "../src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2712 "../src/Photo.vala"
	if (state) {
#line 2712 "../src/Photo.vala"
		*state = _vala_state;
#line 21275 "Photo.c"
	} else {
#line 2712 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 21279 "Photo.c"
	}
#line 2712 "../src/Photo.vala"
	return result;
#line 21283 "Photo.c"
}


void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2715 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2715 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2716 "../src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2716 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2716 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2716 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2716 "../src/Photo.vala"
			return;
#line 21307 "Photo.c"
		} else {
#line 2716 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2716 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2716 "../src/Photo.vala"
			return;
#line 21315 "Photo.c"
		}
	}
}


void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2721 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 21328 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2722 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2722 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21335 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2723 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2723 "../src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2723 "../src/Photo.vala"
			*result = _tmp2_;
#line 21345 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2722 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2722 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21352 "Photo.c"
			}
#line 2723 "../src/Photo.vala"
			return;
#line 21356 "Photo.c"
		}
		__finally372:
		{
			PhotoRow* _tmp4_;
#line 2722 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2722 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21365 "Photo.c"
		}
#line 2722 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2722 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2722 "../src/Photo.vala"
		return;
#line 21373 "Photo.c"
	}
}


gboolean
photo_has_transformations (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2727 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 21385 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp10_ = FALSE;
#line 2728 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2728 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21393 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
#line 2729 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2729 "../src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2729 "../src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2729 "../src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2729 "../src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2730 "../src/Photo.vala"
				_tmp1_ = TRUE;
#line 21412 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2731 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2731 "../src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2731 "../src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 21422 "Photo.c"
			}
#line 2729 "../src/Photo.vala"
			result = _tmp1_;
#line 21426 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2728 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 2728 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21433 "Photo.c"
			}
#line 2729 "../src/Photo.vala"
			return result;
#line 21437 "Photo.c"
		}
		__finally373:
		{
			PhotoRow* _tmp9_;
#line 2728 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2728 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21446 "Photo.c"
		}
#line 2728 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2728 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2728 "../src/Photo.vala"
		return _tmp10_;
#line 21454 "Photo.c"
	}
}


gboolean
photo_only_metadata_changed (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 2735 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2736 "../src/Photo.vala"
	date_time = NULL;
#line 2738 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2738 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2739 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2739 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21480 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2740 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2740 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2740 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2740 "../src/Photo.vala"
		date_time = _tmp3_;
#line 21491 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp20_ = FALSE;
#line 2742 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 2742 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21500 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2743 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2743 "../src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2743 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 21511 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
#line 2744 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2744 "../src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2744 "../src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2744 "../src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2744 "../src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2744 "../src/Photo.vala"
					_tmp8_ = TRUE;
#line 21529 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
#line 2745 "../src/Photo.vala"
					_tmp14_ = date_time;
#line 2745 "../src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 21537 "Photo.c"
						PhotoRow* _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
#line 2745 "../src/Photo.vala"
						_tmp15_ = self->row;
#line 2745 "../src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2745 "../src/Photo.vala"
						_tmp17_ = date_time;
#line 2745 "../src/Photo.vala"
						_tmp13_ = _tmp16_ != metadata_date_time_get_timestamp (_tmp17_);
#line 21549 "Photo.c"
					} else {
#line 2745 "../src/Photo.vala"
						_tmp13_ = FALSE;
#line 21553 "Photo.c"
					}
#line 2745 "../src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 21557 "Photo.c"
				}
#line 2744 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21561 "Photo.c"
			} else {
#line 2743 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 21565 "Photo.c"
			}
#line 2743 "../src/Photo.vala"
			result = _tmp5_;
#line 21569 "Photo.c"
			{
				PhotoRow* _tmp18_;
#line 2742 "../src/Photo.vala"
				_tmp18_ = self->row;
#line 2742 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21576 "Photo.c"
			}
#line 2743 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2743 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2743 "../src/Photo.vala"
			return result;
#line 21584 "Photo.c"
		}
		__finally374:
		{
			PhotoRow* _tmp19_;
#line 2742 "../src/Photo.vala"
			_tmp19_ = self->row;
#line 2742 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21593 "Photo.c"
		}
#line 2742 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2742 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2742 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2742 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2742 "../src/Photo.vala"
		return _tmp20_;
#line 21605 "Photo.c"
	}
#line 2735 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2735 "../src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 21611 "Photo.c"
}


gboolean
photo_has_alterations (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2749 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2750 "../src/Photo.vala"
	date_time = NULL;
#line 2751 "../src/Photo.vala"
	title = NULL;
#line 2752 "../src/Photo.vala"
	comment = NULL;
#line 2754 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2754 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2755 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2755 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21643 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2756 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2756 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2756 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2756 "../src/Photo.vala"
		date_time = _tmp3_;
#line 2757 "../src/Photo.vala"
		_tmp4_ = metadata;
#line 2757 "../src/Photo.vala"
		_tmp5_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2757 "../src/Photo.vala"
		_g_free0 (title);
#line 2757 "../src/Photo.vala"
		title = _tmp5_;
#line 2758 "../src/Photo.vala"
		_tmp6_ = metadata;
#line 2758 "../src/Photo.vala"
		_tmp7_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2758 "../src/Photo.vala"
		_g_free0 (comment);
#line 2758 "../src/Photo.vala"
		comment = _tmp7_;
#line 21674 "Photo.c"
	}
#line 2762 "../src/Photo.vala"
	_tmp8_ = date_time;
#line 2762 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 21680 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2764 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2764 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 21687 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				time_t _tmp11_;
				PhotoRow* _tmp12_;
				time_t _tmp13_;
#line 2766 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2766 "../src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2766 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 2766 "../src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2766 "../src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2768 "../src/Photo.vala"
					result = TRUE;
#line 21705 "Photo.c"
					{
						PhotoRow* _tmp14_;
#line 2764 "../src/Photo.vala"
						_tmp14_ = self->row;
#line 2764 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21712 "Photo.c"
					}
#line 2768 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2768 "../src/Photo.vala"
					_g_free0 (comment);
#line 2768 "../src/Photo.vala"
					_g_free0 (title);
#line 2768 "../src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2768 "../src/Photo.vala"
					return result;
#line 21724 "Photo.c"
				}
			}
			__finally375:
			{
				PhotoRow* _tmp15_;
#line 2764 "../src/Photo.vala"
				_tmp15_ = self->row;
#line 2764 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21734 "Photo.c"
			}
#line 2764 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21738 "Photo.c"
				gboolean _tmp16_ = FALSE;
#line 2764 "../src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2764 "../src/Photo.vala"
				_g_free0 (comment);
#line 2764 "../src/Photo.vala"
				_g_free0 (title);
#line 2764 "../src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2764 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2764 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2764 "../src/Photo.vala"
				return _tmp16_;
#line 21754 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp17_;
		gboolean _tmp41_ = FALSE;
#line 2773 "../src/Photo.vala"
		_tmp17_ = self->row;
#line 2773 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21765 "Photo.c"
		{
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			PhotoRow* _tmp22_;
			GeeHashMap* _tmp23_;
#line 2774 "../src/Photo.vala"
			_tmp22_ = self->row;
#line 2774 "../src/Photo.vala"
			_tmp23_ = _tmp22_->transformations;
#line 2774 "../src/Photo.vala"
			if (_tmp23_ != NULL) {
#line 2774 "../src/Photo.vala"
				_tmp21_ = TRUE;
#line 21781 "Photo.c"
			} else {
				PhotoRow* _tmp24_;
				Orientation _tmp25_;
				BackingPhotoRow* _tmp26_;
				Orientation _tmp27_;
#line 2775 "../src/Photo.vala"
				_tmp24_ = self->row;
#line 2775 "../src/Photo.vala"
				_tmp25_ = _tmp24_->orientation;
#line 2775 "../src/Photo.vala"
				_tmp26_ = self->backing_photo_row;
#line 2775 "../src/Photo.vala"
				_tmp27_ = _tmp26_->original_orientation;
#line 2775 "../src/Photo.vala"
				_tmp21_ = _tmp25_ != _tmp27_;
#line 21797 "Photo.c"
			}
#line 2774 "../src/Photo.vala"
			if (_tmp21_) {
#line 2774 "../src/Photo.vala"
				_tmp20_ = TRUE;
#line 21803 "Photo.c"
			} else {
				gboolean _tmp28_ = FALSE;
				MetadataDateTime* _tmp29_;
#line 2776 "../src/Photo.vala"
				_tmp29_ = date_time;
#line 2776 "../src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 21811 "Photo.c"
					PhotoRow* _tmp30_;
					time_t _tmp31_;
					MetadataDateTime* _tmp32_;
#line 2776 "../src/Photo.vala"
					_tmp30_ = self->row;
#line 2776 "../src/Photo.vala"
					_tmp31_ = _tmp30_->exposure_time;
#line 2776 "../src/Photo.vala"
					_tmp32_ = date_time;
#line 2776 "../src/Photo.vala"
					_tmp28_ = _tmp31_ != metadata_date_time_get_timestamp (_tmp32_);
#line 21823 "Photo.c"
				} else {
#line 2776 "../src/Photo.vala"
					_tmp28_ = FALSE;
#line 21827 "Photo.c"
				}
#line 2776 "../src/Photo.vala"
				_tmp20_ = _tmp28_;
#line 21831 "Photo.c"
			}
#line 2774 "../src/Photo.vala"
			if (_tmp20_) {
#line 2774 "../src/Photo.vala"
				_tmp19_ = TRUE;
#line 21837 "Photo.c"
			} else {
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2777 "../src/Photo.vala"
				_tmp33_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2777 "../src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2777 "../src/Photo.vala"
				_tmp35_ = comment;
#line 2777 "../src/Photo.vala"
				_tmp19_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2777 "../src/Photo.vala"
				_g_free0 (_tmp34_);
#line 21852 "Photo.c"
			}
#line 2774 "../src/Photo.vala"
			if (_tmp19_) {
#line 2774 "../src/Photo.vala"
				_tmp18_ = TRUE;
#line 21858 "Photo.c"
			} else {
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 2778 "../src/Photo.vala"
				_tmp36_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2778 "../src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2778 "../src/Photo.vala"
				_tmp38_ = title;
#line 2778 "../src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2778 "../src/Photo.vala"
				_g_free0 (_tmp37_);
#line 21873 "Photo.c"
			}
#line 2774 "../src/Photo.vala"
			result = _tmp18_;
#line 21877 "Photo.c"
			{
				PhotoRow* _tmp39_;
#line 2773 "../src/Photo.vala"
				_tmp39_ = self->row;
#line 2773 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21884 "Photo.c"
			}
#line 2774 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2774 "../src/Photo.vala"
			_g_free0 (comment);
#line 2774 "../src/Photo.vala"
			_g_free0 (title);
#line 2774 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2774 "../src/Photo.vala"
			return result;
#line 21896 "Photo.c"
		}
		__finally376:
		{
			PhotoRow* _tmp40_;
#line 2773 "../src/Photo.vala"
			_tmp40_ = self->row;
#line 2773 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21905 "Photo.c"
		}
#line 2773 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2773 "../src/Photo.vala"
		_g_free0 (comment);
#line 2773 "../src/Photo.vala"
		_g_free0 (title);
#line 2773 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2773 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2773 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2773 "../src/Photo.vala"
		return _tmp41_;
#line 21921 "Photo.c"
	}
#line 2749 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2749 "../src/Photo.vala"
	_g_free0 (comment);
#line 2749 "../src/Photo.vala"
	_g_free0 (title);
#line 2749 "../src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 21931 "Photo.c"
}


PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	PhotoTransformationState* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2783 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 21942 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2784 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2784 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21949 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PhotoPhotoTransformationStateImpl* _tmp13_;
#line 2787 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2787 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21964 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2787 "../src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2787 "../src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2787 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2787 "../src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 21975 "Photo.c"
			} else {
#line 2787 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2787 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 21981 "Photo.c"
			}
#line 2788 "../src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2788 "../src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 21987 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2788 "../src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2788 "../src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2788 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2788 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21998 "Photo.c"
			} else {
#line 2788 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2788 "../src/Photo.vala"
				_tmp5_ = NULL;
#line 22004 "Photo.c"
			}
#line 2785 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2785 "../src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2785 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2785 "../src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2785 "../src/Photo.vala"
			_tmp13_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_);
#line 2785 "../src/Photo.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 2785 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2785 "../src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 22022 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2784 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2784 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22029 "Photo.c"
			}
#line 2785 "../src/Photo.vala"
			return result;
#line 22033 "Photo.c"
		}
		__finally377:
		{
			PhotoRow* _tmp15_;
#line 2784 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2784 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22042 "Photo.c"
		}
#line 2784 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2784 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2784 "../src/Photo.vala"
		return NULL;
#line 22050 "Photo.c"
	}
}


static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2809 "../src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 22060 "Photo.c"
}


static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2810 "../src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 22069 "Photo.c"
}


gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* _tmp4_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 2792 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2792 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2793 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (state, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2793 "../src/Photo.vala"
	state_impl = _tmp0_;
#line 2794 "../src/Photo.vala"
	_tmp1_ = state_impl;
#line 2794 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2795 "../src/Photo.vala"
		result = FALSE;
#line 2795 "../src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2795 "../src/Photo.vala"
		return result;
#line 22113 "Photo.c"
	}
#line 2797 "../src/Photo.vala"
	_tmp2_ = state_impl;
#line 2797 "../src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2798 "../src/Photo.vala"
	_tmp3_ = state_impl;
#line 2798 "../src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_transformations (_tmp3_);
#line 2798 "../src/Photo.vala"
	saved_transformations = _tmp4_;
#line 2799 "../src/Photo.vala"
	_tmp5_ = state_impl;
#line 2799 "../src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformer (_tmp5_);
#line 2799 "../src/Photo.vala"
	saved_transformer = _tmp6_;
#line 2800 "../src/Photo.vala"
	_tmp7_ = state_impl;
#line 2800 "../src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp7_);
#line 2800 "../src/Photo.vala"
	saved_adjustments = _tmp8_;
#line 22137 "Photo.c"
	{
		PhotoRow* _tmp9_;
#line 2803 "../src/Photo.vala"
		_tmp9_ = self->row;
#line 2803 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22144 "Photo.c"
		{
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
			Orientation _tmp14_;
			GeeHashMap* _tmp15_;
			gboolean _tmp16_;
#line 2804 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2804 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2804 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2804 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2804 "../src/Photo.vala"
			_tmp14_ = saved_orientation;
#line 2804 "../src/Photo.vala"
			_tmp15_ = saved_transformations;
#line 2804 "../src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp11_, &_tmp13_, _tmp14_, _tmp15_);
#line 2804 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 2806 "../src/Photo.vala"
			_tmp16_ = committed;
#line 2806 "../src/Photo.vala"
			if (_tmp16_) {
#line 22173 "Photo.c"
				PhotoRow* _tmp17_;
				Orientation _tmp18_;
				PhotoRow* _tmp19_;
				GeeHashMap* _tmp20_;
				GeeHashMap* _tmp21_;
				PixelTransformer* _tmp22_;
				PixelTransformer* _tmp23_;
				PixelTransformationBundle* _tmp24_;
				PixelTransformationBundle* _tmp25_;
#line 2807 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 2807 "../src/Photo.vala"
				_tmp18_ = saved_orientation;
#line 2807 "../src/Photo.vala"
				_tmp17_->orientation = _tmp18_;
#line 2808 "../src/Photo.vala"
				_tmp19_ = self->row;
#line 2808 "../src/Photo.vala"
				_tmp20_ = saved_transformations;
#line 2808 "../src/Photo.vala"
				_tmp21_ = _g_object_ref0 (_tmp20_);
#line 2808 "../src/Photo.vala"
				_g_object_unref0 (_tmp19_->transformations);
#line 2808 "../src/Photo.vala"
				_tmp19_->transformations = _tmp21_;
#line 2809 "../src/Photo.vala"
				_tmp22_ = saved_transformer;
#line 2809 "../src/Photo.vala"
				_tmp23_ = _pixel_transformer_ref0 (_tmp22_);
#line 2809 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2809 "../src/Photo.vala"
				self->priv->transformer = _tmp23_;
#line 2810 "../src/Photo.vala"
				_tmp24_ = saved_adjustments;
#line 2810 "../src/Photo.vala"
				_tmp25_ = _pixel_transformation_bundle_ref0 (_tmp24_);
#line 2810 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2810 "../src/Photo.vala"
				self->priv->adjustments = _tmp25_;
#line 22215 "Photo.c"
			}
		}
		__finally378:
		{
			PhotoRow* _tmp26_;
#line 2803 "../src/Photo.vala"
			_tmp26_ = self->row;
#line 2803 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22225 "Photo.c"
		}
#line 2803 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22229 "Photo.c"
			gboolean _tmp27_ = FALSE;
#line 2803 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2803 "../src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2803 "../src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2803 "../src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2803 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2803 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2803 "../src/Photo.vala"
			return _tmp27_;
#line 22245 "Photo.c"
		}
	}
#line 2814 "../src/Photo.vala"
	_tmp28_ = committed;
#line 2814 "../src/Photo.vala"
	if (_tmp28_) {
#line 22252 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2815 "../src/Photo.vala"
		_tmp29_ = alteration_new ("image", "transformation-state");
#line 2815 "../src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2815 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp30_);
#line 2815 "../src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 22263 "Photo.c"
	}
#line 2817 "../src/Photo.vala"
	result = committed;
#line 2817 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2817 "../src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2817 "../src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2817 "../src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2817 "../src/Photo.vala"
	return result;
#line 22277 "Photo.c"
}


void
photo_remove_all_transformations (Photo* self,
                                  gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	GError* _inner_error0_ = NULL;
#line 2820 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2821 "../src/Photo.vala"
	is_altered = FALSE;
#line 22293 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2822 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2822 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22300 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			Orientation _tmp7_;
			BackingPhotoRow* _tmp8_;
			Orientation _tmp9_;
#line 2823 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2823 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2823 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2823 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2823 "../src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2823 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2824 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2824 "../src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2824 "../src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2826 "../src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2826 "../src/Photo.vala"
			self->priv->transformer = NULL;
#line 2827 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2827 "../src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2829 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2829 "../src/Photo.vala"
			_tmp7_ = _tmp6_->orientation;
#line 2829 "../src/Photo.vala"
			_tmp8_ = self->backing_photo_row;
#line 2829 "../src/Photo.vala"
			_tmp9_ = _tmp8_->original_orientation;
#line 2829 "../src/Photo.vala"
			if (_tmp7_ != _tmp9_) {
#line 22347 "Photo.c"
				PhotoTable* _tmp10_;
				PhotoTable* _tmp11_;
				PhotoRow* _tmp12_;
				PhotoID _tmp13_;
				BackingPhotoRow* _tmp14_;
				Orientation _tmp15_;
				PhotoRow* _tmp16_;
				BackingPhotoRow* _tmp17_;
				Orientation _tmp18_;
#line 2830 "../src/Photo.vala"
				_tmp10_ = photo_table_get_instance ();
#line 2830 "../src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2830 "../src/Photo.vala"
				_tmp12_ = self->row;
#line 2830 "../src/Photo.vala"
				_tmp13_ = _tmp12_->photo_id;
#line 2830 "../src/Photo.vala"
				_tmp14_ = self->backing_photo_row;
#line 2830 "../src/Photo.vala"
				_tmp15_ = _tmp14_->original_orientation;
#line 2830 "../src/Photo.vala"
				photo_table_set_orientation (_tmp11_, &_tmp13_, _tmp15_);
#line 2830 "../src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 2832 "../src/Photo.vala"
				_tmp16_ = self->row;
#line 2832 "../src/Photo.vala"
				_tmp17_ = self->backing_photo_row;
#line 2832 "../src/Photo.vala"
				_tmp18_ = _tmp17_->original_orientation;
#line 2832 "../src/Photo.vala"
				_tmp16_->orientation = _tmp18_;
#line 2833 "../src/Photo.vala"
				is_altered = TRUE;
#line 22383 "Photo.c"
			}
		}
		__finally379:
		{
			PhotoRow* _tmp19_;
#line 2822 "../src/Photo.vala"
			_tmp19_ = self->row;
#line 2822 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22393 "Photo.c"
		}
#line 2822 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2822 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2822 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2822 "../src/Photo.vala"
			return;
#line 22403 "Photo.c"
		}
	}
#line 2837 "../src/Photo.vala"
	_tmp21_ = is_altered;
#line 2837 "../src/Photo.vala"
	if (_tmp21_) {
#line 2837 "../src/Photo.vala"
		_tmp20_ = notify;
#line 22412 "Photo.c"
	} else {
#line 2837 "../src/Photo.vala"
		_tmp20_ = FALSE;
#line 22416 "Photo.c"
	}
#line 2837 "../src/Photo.vala"
	if (_tmp20_) {
#line 22420 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 2838 "../src/Photo.vala"
		_tmp22_ = alteration_new ("image", "revert");
#line 2838 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2838 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 2838 "../src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 22431 "Photo.c"
	}
}


Orientation
photo_get_original_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2841 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22443 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2842 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2842 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22450 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2843 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2843 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2843 "../src/Photo.vala"
			result = _tmp2_;
#line 22460 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2842 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2842 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22467 "Photo.c"
			}
#line 2843 "../src/Photo.vala"
			return result;
#line 22471 "Photo.c"
		}
		__finally380:
		{
			PhotoRow* _tmp4_;
#line 2842 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2842 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22480 "Photo.c"
		}
#line 2842 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2842 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2842 "../src/Photo.vala"
		return 0;
#line 22488 "Photo.c"
	}
}


Orientation
photo_get_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2847 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22500 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2848 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2848 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22507 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2849 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2849 "../src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2849 "../src/Photo.vala"
			result = _tmp2_;
#line 22517 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2848 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2848 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22524 "Photo.c"
			}
#line 2849 "../src/Photo.vala"
			return result;
#line 22528 "Photo.c"
		}
		__finally381:
		{
			PhotoRow* _tmp4_;
#line 2848 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2848 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22537 "Photo.c"
		}
#line 2848 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2848 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2848 "../src/Photo.vala"
		return 0;
#line 22545 "Photo.c"
	}
}


gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean result = FALSE;
	gboolean committed = FALSE;
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
#line 2853 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2854 "../src/Photo.vala"
	committed = FALSE;
#line 22562 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2855 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2855 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22569 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2856 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2856 "../src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2856 "../src/Photo.vala"
			if (_tmp2_ != orientation) {
#line 22579 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoRow* _tmp5_;
				PhotoID _tmp6_;
				gboolean _tmp7_;
#line 2857 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2857 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2857 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2857 "../src/Photo.vala"
				_tmp6_ = _tmp5_->photo_id;
#line 2857 "../src/Photo.vala"
				committed = photo_table_set_orientation (_tmp4_, &_tmp6_, orientation);
#line 2857 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2858 "../src/Photo.vala"
				_tmp7_ = committed;
#line 2858 "../src/Photo.vala"
				if (_tmp7_) {
#line 22601 "Photo.c"
					PhotoRow* _tmp8_;
#line 2859 "../src/Photo.vala"
					_tmp8_ = self->row;
#line 2859 "../src/Photo.vala"
					_tmp8_->orientation = orientation;
#line 22607 "Photo.c"
				}
			}
		}
		__finally382:
		{
			PhotoRow* _tmp9_;
#line 2855 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2855 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22618 "Photo.c"
		}
#line 2855 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22622 "Photo.c"
			gboolean _tmp10_ = FALSE;
#line 2855 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2855 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2855 "../src/Photo.vala"
			return _tmp10_;
#line 22630 "Photo.c"
		}
	}
#line 2863 "../src/Photo.vala"
	_tmp11_ = committed;
#line 2863 "../src/Photo.vala"
	if (_tmp11_) {
#line 22637 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2864 "../src/Photo.vala"
		_tmp12_ = alteration_new ("image", "orientation");
#line 2864 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2864 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp13_);
#line 2864 "../src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 22648 "Photo.c"
	}
#line 2866 "../src/Photo.vala"
	result = committed;
#line 2866 "../src/Photo.vala"
	return result;
#line 22654 "Photo.c"
}


gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 2869 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2870 "../src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2870 "../src/Photo.vala"
	result = _tmp0_;
#line 2870 "../src/Photo.vala"
	return result;
#line 22671 "Photo.c"
}


static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2874 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2874 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22686 "Photo.c"
		{
#line 2875 "../src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 22690 "Photo.c"
		}
		__finally383:
		{
			PhotoRow* _tmp1_;
#line 2874 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2874 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22699 "Photo.c"
		}
#line 2874 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2874 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2874 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2874 "../src/Photo.vala"
			return;
#line 22709 "Photo.c"
		}
	}
}


void
photo_rotate (Photo* self,
              Rotation rotation)
{
#line 2873 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2873 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 22723 "Photo.c"
}


static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2879 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2879 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22737 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2880 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2880 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22745 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2881 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2881 "../src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2881 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 22756 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2881 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2881 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2881 "../src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 22765 "Photo.c"
			} else {
#line 2881 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 22769 "Photo.c"
			}
#line 2881 "../src/Photo.vala"
			result = _tmp1_;
#line 22773 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2880 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2880 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22780 "Photo.c"
			}
#line 2881 "../src/Photo.vala"
			return result;
#line 22784 "Photo.c"
		}
		__finally384:
		{
			PhotoRow* _tmp7_;
#line 2880 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2880 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22793 "Photo.c"
		}
#line 2880 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2880 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2880 "../src/Photo.vala"
		return _tmp8_;
#line 22801 "Photo.c"
	}
}


static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
#line 2888 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2888 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2889 "../src/Photo.vala"
	map = NULL;
#line 22819 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2890 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2890 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22826 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2891 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2891 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2891 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22836 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2892 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2892 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2892 "../src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 2892 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2892 "../src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2893 "../src/Photo.vala"
				_tmp6_ = map;
#line 2893 "../src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 22855 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2894 "../src/Photo.vala"
					_tmp7_ = map;
#line 2894 "../src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2894 "../src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2894 "../src/Photo.vala"
					map = _tmp8_;
#line 22866 "Photo.c"
				}
			}
		}
		__finally385:
		{
			PhotoRow* _tmp9_;
#line 2890 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2890 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22877 "Photo.c"
		}
#line 2890 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2890 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2890 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2890 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2890 "../src/Photo.vala"
			return NULL;
#line 22889 "Photo.c"
		}
	}
#line 2898 "../src/Photo.vala"
	result = map;
#line 2898 "../src/Photo.vala"
	return result;
#line 22896 "Photo.c"
}


static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2901 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2901 "../src/Photo.vala"
	g_return_val_if_fail (IS_KEY_VALUE_MAP (trans), FALSE);
#line 22910 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2902 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2902 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22918 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2903 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2903 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2903 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22937 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2904 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2904 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2904 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2904 "../src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 22948 "Photo.c"
			}
#line 2906 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2906 "../src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2906 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2906 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2906 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, trans);
#line 2906 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2908 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2908 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2908 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2908 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2908 "../src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2908 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2908 "../src/Photo.vala"
			result = _tmp13_;
#line 22976 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2902 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2902 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22983 "Photo.c"
			}
#line 2908 "../src/Photo.vala"
			return result;
#line 22987 "Photo.c"
		}
		__finally386:
		{
			PhotoRow* _tmp15_;
#line 2902 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2902 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22996 "Photo.c"
		}
#line 2902 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2902 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2902 "../src/Photo.vala"
		return _tmp16_;
#line 23004 "Photo.c"
	}
}


static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 2912 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2912 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 23023 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2914 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2914 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23030 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2915 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2915 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2915 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 23044 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2916 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2916 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2916 "../src/Photo.vala"
				altered_cache = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name, NULL);
#line 2917 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2917 "../src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2917 "../src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 2917 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2917 "../src/Photo.vala"
				if (_tmp8_ == 0) {
#line 23067 "Photo.c"
					PhotoRow* _tmp9_;
#line 2918 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 2918 "../src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2918 "../src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 23075 "Photo.c"
				}
			} else {
#line 2920 "../src/Photo.vala"
				altered_cache = FALSE;
#line 23080 "Photo.c"
			}
#line 2923 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2923 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2923 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2923 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2923 "../src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2923 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 23094 "Photo.c"
		}
		__finally387:
		{
			PhotoRow* _tmp14_;
#line 2914 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2914 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23103 "Photo.c"
		}
#line 2914 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23107 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2914 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2914 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2914 "../src/Photo.vala"
			return _tmp15_;
#line 23115 "Photo.c"
		}
	}
#line 2927 "../src/Photo.vala"
	_tmp17_ = altered_cache;
#line 2927 "../src/Photo.vala"
	if (_tmp17_) {
#line 2927 "../src/Photo.vala"
		_tmp16_ = TRUE;
#line 23124 "Photo.c"
	} else {
#line 2927 "../src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 23128 "Photo.c"
	}
#line 2927 "../src/Photo.vala"
	result = _tmp16_;
#line 2927 "../src/Photo.vala"
	return result;
#line 23134 "Photo.c"
}


gboolean
photo_has_crop (Photo* self)
{
	gboolean result = FALSE;
#line 2930 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2931 "../src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2931 "../src/Photo.vala"
	return result;
#line 23148 "Photo.c"
}


gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 2935 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2936 "../src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2938 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2938 "../src/Photo.vala"
	map = _tmp0_;
#line 2939 "../src/Photo.vala"
	_tmp1_ = map;
#line 2939 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2940 "../src/Photo.vala"
		result = FALSE;
#line 2940 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2940 "../src/Photo.vala"
		if (crop) {
#line 2940 "../src/Photo.vala"
			*crop = _vala_crop;
#line 23197 "Photo.c"
		}
#line 2940 "../src/Photo.vala"
		return result;
#line 23201 "Photo.c"
	}
#line 2942 "../src/Photo.vala"
	_tmp2_ = map;
#line 2942 "../src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2943 "../src/Photo.vala"
	_tmp3_ = map;
#line 2943 "../src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 2944 "../src/Photo.vala"
	_tmp4_ = map;
#line 2944 "../src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 2945 "../src/Photo.vala"
	_tmp5_ = map;
#line 2945 "../src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 2947 "../src/Photo.vala"
	_tmp9_ = left;
#line 2947 "../src/Photo.vala"
	if (_tmp9_ == -1) {
#line 2947 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 23225 "Photo.c"
	} else {
		gint _tmp10_;
#line 2947 "../src/Photo.vala"
		_tmp10_ = top;
#line 2947 "../src/Photo.vala"
		_tmp8_ = _tmp10_ == -1;
#line 23232 "Photo.c"
	}
#line 2947 "../src/Photo.vala"
	if (_tmp8_) {
#line 2947 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 23238 "Photo.c"
	} else {
		gint _tmp11_;
#line 2947 "../src/Photo.vala"
		_tmp11_ = right;
#line 2947 "../src/Photo.vala"
		_tmp7_ = _tmp11_ == -1;
#line 23245 "Photo.c"
	}
#line 2947 "../src/Photo.vala"
	if (_tmp7_) {
#line 2947 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 23251 "Photo.c"
	} else {
		gint _tmp12_;
#line 2947 "../src/Photo.vala"
		_tmp12_ = bottom;
#line 2947 "../src/Photo.vala"
		_tmp6_ = _tmp12_ == -1;
#line 23258 "Photo.c"
	}
#line 2947 "../src/Photo.vala"
	if (_tmp6_) {
#line 2948 "../src/Photo.vala"
		result = FALSE;
#line 2948 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2948 "../src/Photo.vala"
		if (crop) {
#line 2948 "../src/Photo.vala"
			*crop = _vala_crop;
#line 23270 "Photo.c"
		}
#line 2948 "../src/Photo.vala"
		return result;
#line 23274 "Photo.c"
	}
#line 2950 "../src/Photo.vala"
	_tmp13_ = left;
#line 2950 "../src/Photo.vala"
	_tmp14_ = top;
#line 2950 "../src/Photo.vala"
	_tmp15_ = right;
#line 2950 "../src/Photo.vala"
	_tmp16_ = bottom;
#line 2950 "../src/Photo.vala"
	box_init (&_vala_crop, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 2952 "../src/Photo.vala"
	result = TRUE;
#line 2952 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2952 "../src/Photo.vala"
	if (crop) {
#line 2952 "../src/Photo.vala"
		*crop = _vala_crop;
#line 23294 "Photo.c"
	}
#line 2952 "../src/Photo.vala"
	return result;
#line 23298 "Photo.c"
}


static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
#line 2956 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2956 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2957 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2957 "../src/Photo.vala"
	map = _tmp0_;
#line 2958 "../src/Photo.vala"
	_tmp1_ = map;
#line 2958 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 2958 "../src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2958 "../src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2959 "../src/Photo.vala"
	_tmp4_ = map;
#line 2959 "../src/Photo.vala"
	_tmp5_ = *crop;
#line 2959 "../src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2959 "../src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2960 "../src/Photo.vala"
	_tmp7_ = map;
#line 2960 "../src/Photo.vala"
	_tmp8_ = *crop;
#line 2960 "../src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2960 "../src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2961 "../src/Photo.vala"
	_tmp10_ = map;
#line 2961 "../src/Photo.vala"
	_tmp11_ = *crop;
#line 2961 "../src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2961 "../src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2963 "../src/Photo.vala"
	_tmp13_ = map;
#line 2963 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp13_)) {
#line 23365 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2964 "../src/Photo.vala"
		_tmp14_ = alteration_new ("image", "crop");
#line 2964 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2964 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 2964 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 23376 "Photo.c"
	}
#line 2956 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23380 "Photo.c"
}


static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 2967 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2968 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2968 "../src/Photo.vala"
	map = _tmp0_;
#line 2969 "../src/Photo.vala"
	_tmp1_ = map;
#line 2969 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2970 "../src/Photo.vala"
		_vala_angle = 0.0;
#line 2972 "../src/Photo.vala"
		result = FALSE;
#line 2972 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2972 "../src/Photo.vala"
		if (angle) {
#line 2972 "../src/Photo.vala"
			*angle = _vala_angle;
#line 23414 "Photo.c"
		}
#line 2972 "../src/Photo.vala"
		return result;
#line 23418 "Photo.c"
	}
#line 2975 "../src/Photo.vala"
	_tmp2_ = map;
#line 2975 "../src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2977 "../src/Photo.vala"
	result = TRUE;
#line 2977 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2977 "../src/Photo.vala"
	if (angle) {
#line 2977 "../src/Photo.vala"
		*angle = _vala_angle;
#line 23432 "Photo.c"
	}
#line 2977 "../src/Photo.vala"
	return result;
#line 23436 "Photo.c"
}


static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 2980 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2981 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2981 "../src/Photo.vala"
	map = _tmp0_;
#line 2982 "../src/Photo.vala"
	_tmp1_ = map;
#line 2982 "../src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 2984 "../src/Photo.vala"
	_tmp2_ = map;
#line 2984 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 23462 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 2985 "../src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 2985 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2985 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 2985 "../src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 23473 "Photo.c"
	}
#line 2980 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23477 "Photo.c"
}


static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                int* result_length1)
{
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	EditingToolsRedeyeInstance* res = NULL;
	gint _tmp6_;
	EditingToolsRedeyeInstance* _tmp7_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp8_ = {0};
	EditingToolsRedeyeInstance* _tmp45_;
	gint _tmp45__length1;
#line 2990 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2991 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2991 "../src/Photo.vala"
	map = _tmp0_;
#line 2992 "../src/Photo.vala"
	_tmp1_ = map;
#line 2992 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23511 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 2993 "../src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2993 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2993 "../src/Photo.vala"
		_tmp3__length1 = 0;
#line 2993 "../src/Photo.vala"
		if (result_length1) {
#line 2993 "../src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 23525 "Photo.c"
		}
#line 2993 "../src/Photo.vala"
		result = _tmp3_;
#line 2993 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2993 "../src/Photo.vala"
		return result;
#line 23533 "Photo.c"
	}
#line 2995 "../src/Photo.vala"
	_tmp4_ = map;
#line 2995 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2996 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 2996 "../src/Photo.vala"
	_vala_assert (_tmp5_ > 0, "num_points > 0");
#line 2998 "../src/Photo.vala"
	_tmp6_ = num_points;
#line 2998 "../src/Photo.vala"
	_tmp7_ = g_new0 (EditingToolsRedeyeInstance, _tmp6_);
#line 2998 "../src/Photo.vala"
	res = _tmp7_;
#line 2998 "../src/Photo.vala"
	res_length1 = _tmp6_;
#line 2998 "../src/Photo.vala"
	_res_size_ = res_length1;
#line 3000 "../src/Photo.vala"
	_tmp8_.x = 0;
#line 3000 "../src/Photo.vala"
	default_point = _tmp8_;
#line 3001 "../src/Photo.vala"
	default_point.x = -1;
#line 3002 "../src/Photo.vala"
	default_point.y = -1;
#line 23561 "Photo.c"
	{
		gint i = 0;
#line 3004 "../src/Photo.vala"
		i = 0;
#line 23566 "Photo.c"
		{
			gboolean _tmp9_ = FALSE;
#line 3004 "../src/Photo.vala"
			_tmp9_ = TRUE;
#line 3004 "../src/Photo.vala"
			while (TRUE) {
#line 23573 "Photo.c"
				gint _tmp11_;
				gint _tmp12_;
				gchar* center_key = NULL;
				gint _tmp13_;
				gchar* _tmp14_;
				gchar* radius_key = NULL;
				gint _tmp15_;
				gchar* _tmp16_;
				EditingToolsRedeyeInstance* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				KeyValueMap* _tmp19_;
				const gchar* _tmp20_;
				GdkPoint _tmp21_;
				GdkPoint _tmp22_ = {0};
				EditingToolsRedeyeInstance* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				EditingToolsRedeyeInstance _tmp25_;
				GdkPoint _tmp26_;
				gint _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				EditingToolsRedeyeInstance* _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				EditingToolsRedeyeInstance _tmp32_;
				GdkPoint _tmp33_;
				gint _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				EditingToolsRedeyeInstance* _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_;
				KeyValueMap* _tmp39_;
				const gchar* _tmp40_;
				EditingToolsRedeyeInstance* _tmp41_;
				gint _tmp41__length1;
				gint _tmp42_;
				EditingToolsRedeyeInstance _tmp43_;
				gint _tmp44_;
#line 3004 "../src/Photo.vala"
				if (!_tmp9_) {
#line 23617 "Photo.c"
					gint _tmp10_;
#line 3004 "../src/Photo.vala"
					_tmp10_ = i;
#line 3004 "../src/Photo.vala"
					i = _tmp10_ + 1;
#line 23623 "Photo.c"
				}
#line 3004 "../src/Photo.vala"
				_tmp9_ = FALSE;
#line 3004 "../src/Photo.vala"
				_tmp11_ = i;
#line 3004 "../src/Photo.vala"
				_tmp12_ = num_points;
#line 3004 "../src/Photo.vala"
				if (!(_tmp11_ < _tmp12_)) {
#line 3004 "../src/Photo.vala"
					break;
#line 23635 "Photo.c"
				}
#line 3005 "../src/Photo.vala"
				_tmp13_ = i;
#line 3005 "../src/Photo.vala"
				_tmp14_ = g_strdup_printf ("center%d", _tmp13_);
#line 3005 "../src/Photo.vala"
				center_key = _tmp14_;
#line 3006 "../src/Photo.vala"
				_tmp15_ = i;
#line 3006 "../src/Photo.vala"
				_tmp16_ = g_strdup_printf ("radius%d", _tmp15_);
#line 3006 "../src/Photo.vala"
				radius_key = _tmp16_;
#line 3008 "../src/Photo.vala"
				_tmp17_ = res;
#line 3008 "../src/Photo.vala"
				_tmp17__length1 = res_length1;
#line 3008 "../src/Photo.vala"
				_tmp18_ = i;
#line 3008 "../src/Photo.vala"
				_tmp19_ = map;
#line 3008 "../src/Photo.vala"
				_tmp20_ = center_key;
#line 3008 "../src/Photo.vala"
				_tmp21_ = default_point;
#line 3008 "../src/Photo.vala"
				key_value_map_get_point (_tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 3008 "../src/Photo.vala"
				_tmp17_[_tmp18_].center = _tmp22_;
#line 3009 "../src/Photo.vala"
				_tmp23_ = res;
#line 3009 "../src/Photo.vala"
				_tmp23__length1 = res_length1;
#line 3009 "../src/Photo.vala"
				_tmp24_ = i;
#line 3009 "../src/Photo.vala"
				_tmp25_ = _tmp23_[_tmp24_];
#line 3009 "../src/Photo.vala"
				_tmp26_ = _tmp25_.center;
#line 3009 "../src/Photo.vala"
				_tmp27_ = _tmp26_.x;
#line 3009 "../src/Photo.vala"
				_tmp28_ = default_point;
#line 3009 "../src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 3009 "../src/Photo.vala"
				_vala_assert (_tmp27_ != _tmp29_, "res[i].center.x != default_point.x");
#line 3010 "../src/Photo.vala"
				_tmp30_ = res;
#line 3010 "../src/Photo.vala"
				_tmp30__length1 = res_length1;
#line 3010 "../src/Photo.vala"
				_tmp31_ = i;
#line 3010 "../src/Photo.vala"
				_tmp32_ = _tmp30_[_tmp31_];
#line 3010 "../src/Photo.vala"
				_tmp33_ = _tmp32_.center;
#line 3010 "../src/Photo.vala"
				_tmp34_ = _tmp33_.y;
#line 3010 "../src/Photo.vala"
				_tmp35_ = default_point;
#line 3010 "../src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 3010 "../src/Photo.vala"
				_vala_assert (_tmp34_ != _tmp36_, "res[i].center.y != default_point.y");
#line 3012 "../src/Photo.vala"
				_tmp37_ = res;
#line 3012 "../src/Photo.vala"
				_tmp37__length1 = res_length1;
#line 3012 "../src/Photo.vala"
				_tmp38_ = i;
#line 3012 "../src/Photo.vala"
				_tmp39_ = map;
#line 3012 "../src/Photo.vala"
				_tmp40_ = radius_key;
#line 3012 "../src/Photo.vala"
				_tmp37_[_tmp38_].radius = key_value_map_get_int (_tmp39_, _tmp40_, -1);
#line 3013 "../src/Photo.vala"
				_tmp41_ = res;
#line 3013 "../src/Photo.vala"
				_tmp41__length1 = res_length1;
#line 3013 "../src/Photo.vala"
				_tmp42_ = i;
#line 3013 "../src/Photo.vala"
				_tmp43_ = _tmp41_[_tmp42_];
#line 3013 "../src/Photo.vala"
				_tmp44_ = _tmp43_.radius;
#line 3013 "../src/Photo.vala"
				_vala_assert (_tmp44_ != -1, "res[i].radius != -1");
#line 3004 "../src/Photo.vala"
				_g_free0 (radius_key);
#line 3004 "../src/Photo.vala"
				_g_free0 (center_key);
#line 23729 "Photo.c"
			}
		}
	}
#line 3016 "../src/Photo.vala"
	_tmp45_ = res;
#line 3016 "../src/Photo.vala"
	_tmp45__length1 = res_length1;
#line 3016 "../src/Photo.vala"
	if (result_length1) {
#line 3016 "../src/Photo.vala"
		*result_length1 = _tmp45__length1;
#line 23741 "Photo.c"
	}
#line 3016 "../src/Photo.vala"
	result = _tmp45_;
#line 3016 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3016 "../src/Photo.vala"
	return result;
#line 23749 "Photo.c"
}


gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result = FALSE;
#line 3019 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3020 "../src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3020 "../src/Photo.vala"
	return result;
#line 23763 "Photo.c"
}


void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* radius_key = NULL;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* center_key = NULL;
	gint _tmp9_;
	gchar* _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	gint _tmp14_;
	KeyValueMap* _tmp15_;
	const gchar* _tmp16_;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	KeyValueMap* _tmp19_;
	gint _tmp20_;
	KeyValueMap* _tmp21_;
#line 3024 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3024 "../src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3025 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3025 "../src/Photo.vala"
	map = _tmp0_;
#line 3026 "../src/Photo.vala"
	_tmp1_ = map;
#line 3026 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23807 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3027 "../src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3027 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3027 "../src/Photo.vala"
		map = _tmp2_;
#line 3028 "../src/Photo.vala"
		_tmp3_ = map;
#line 3028 "../src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 23820 "Photo.c"
	}
#line 3031 "../src/Photo.vala"
	_tmp4_ = map;
#line 3031 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3032 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 3032 "../src/Photo.vala"
	_vala_assert (_tmp5_ >= 0, "num_points >= 0");
#line 3034 "../src/Photo.vala"
	_tmp6_ = num_points;
#line 3034 "../src/Photo.vala"
	num_points = _tmp6_ + 1;
#line 3036 "../src/Photo.vala"
	_tmp7_ = num_points;
#line 3036 "../src/Photo.vala"
	_tmp8_ = g_strdup_printf ("radius%d", _tmp7_ - 1);
#line 3036 "../src/Photo.vala"
	radius_key = _tmp8_;
#line 3037 "../src/Photo.vala"
	_tmp9_ = num_points;
#line 3037 "../src/Photo.vala"
	_tmp10_ = g_strdup_printf ("center%d", _tmp9_ - 1);
#line 3037 "../src/Photo.vala"
	center_key = _tmp10_;
#line 3039 "../src/Photo.vala"
	_tmp11_ = map;
#line 3039 "../src/Photo.vala"
	_tmp12_ = radius_key;
#line 3039 "../src/Photo.vala"
	_tmp13_ = *redeye;
#line 3039 "../src/Photo.vala"
	_tmp14_ = _tmp13_.radius;
#line 3039 "../src/Photo.vala"
	key_value_map_set_int (_tmp11_, _tmp12_, _tmp14_);
#line 3040 "../src/Photo.vala"
	_tmp15_ = map;
#line 3040 "../src/Photo.vala"
	_tmp16_ = center_key;
#line 3040 "../src/Photo.vala"
	_tmp17_ = *redeye;
#line 3040 "../src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 3040 "../src/Photo.vala"
	key_value_map_set_point (_tmp15_, _tmp16_, &_tmp18_);
#line 3042 "../src/Photo.vala"
	_tmp19_ = map;
#line 3042 "../src/Photo.vala"
	_tmp20_ = num_points;
#line 3042 "../src/Photo.vala"
	key_value_map_set_int (_tmp19_, "num_points", _tmp20_);
#line 3044 "../src/Photo.vala"
	_tmp21_ = map;
#line 3044 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp21_)) {
#line 23876 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 3045 "../src/Photo.vala"
		_tmp22_ = alteration_new ("image", "redeye");
#line 3045 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 3045 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 3045 "../src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 23887 "Photo.c"
	}
#line 3024 "../src/Photo.vala"
	_g_free0 (center_key);
#line 3024 "../src/Photo.vala"
	_g_free0 (radius_key);
#line 3024 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23895 "Photo.c"
}


static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 3059 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3059 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23914 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3061 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3061 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23922 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3063 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3063 "../src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3063 "../src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3063 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3063 "../src/Photo.vala"
			result = _tmp4_;
#line 23938 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3061 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 3061 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23945 "Photo.c"
			}
#line 3063 "../src/Photo.vala"
			if (scaled_image) {
#line 3063 "../src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23951 "Photo.c"
			}
#line 3063 "../src/Photo.vala"
			if (scaled_to_viewport) {
#line 3063 "../src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23957 "Photo.c"
			}
#line 3063 "../src/Photo.vala"
			return result;
#line 23961 "Photo.c"
		}
		__finally388:
		{
			PhotoRow* _tmp6_;
#line 3061 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 3061 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23970 "Photo.c"
		}
#line 3061 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3061 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3061 "../src/Photo.vala"
		return _tmp7_;
#line 23978 "Photo.c"
	}
#line 3059 "../src/Photo.vala"
	if (scaled_image) {
#line 3059 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23984 "Photo.c"
	}
#line 3059 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3059 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23990 "Photo.c"
	}
}


static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp36_ = FALSE;
	Dimensions _tmp37_;
	gint _tmp38_;
	Dimensions _tmp39_;
	gint _tmp40_;
#line 3069 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3069 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3071 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3071 "../src/Photo.vala"
	raw = _tmp0_;
#line 3073 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24023 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3074 "../src/Photo.vala"
		_tmp1_ = raw;
#line 3074 "../src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3075 "../src/Photo.vala"
		_tmp2_ = raw;
#line 3075 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3077 "../src/Photo.vala"
		result = FALSE;
#line 3077 "../src/Photo.vala"
		if (scaled_image) {
#line 3077 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 24040 "Photo.c"
		}
#line 3077 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3077 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24046 "Photo.c"
		}
#line 3077 "../src/Photo.vala"
		return result;
#line 24050 "Photo.c"
	}
#line 3080 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3085 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3086 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3088 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 24060 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3090 "../src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3090 "../src/Photo.vala"
		crop = _tmp3_;
#line 3090 "../src/Photo.vala"
		if (_tmp4_) {
#line 24070 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			Box _tmp15_ = {0};
			Dimensions _tmp16_ = {0};
			gboolean _tmp17_ = FALSE;
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
#line 3093 "../src/Photo.vala"
			_tmp5_ = raw;
#line 3093 "../src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3094 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24088 "Photo.c"
				Orientation _tmp6_;
				Dimensions _tmp7_;
				Box _tmp8_;
				Box _tmp9_ = {0};
				Orientation _tmp10_;
				Dimensions _tmp11_;
				Dimensions _tmp12_ = {0};
#line 3095 "../src/Photo.vala"
				_tmp6_ = orientation;
#line 3095 "../src/Photo.vala"
				_tmp7_ = raw;
#line 3095 "../src/Photo.vala"
				_tmp8_ = crop;
#line 3095 "../src/Photo.vala"
				orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 3095 "../src/Photo.vala"
				crop = _tmp9_;
#line 3096 "../src/Photo.vala"
				_tmp10_ = orientation;
#line 3096 "../src/Photo.vala"
				_tmp11_ = raw;
#line 3096 "../src/Photo.vala"
				orientation_rotate_dimensions (_tmp10_, &_tmp11_, &_tmp12_);
#line 3096 "../src/Photo.vala"
				rotated_raw = _tmp12_;
#line 24114 "Photo.c"
			}
#line 3100 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp13_);
#line 3100 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp13_, &_tmp14_);
#line 3100 "../src/Photo.vala"
			box_get_scaled (&crop, &_tmp14_, &_tmp15_);
#line 3100 "../src/Photo.vala"
			scaled_crop = _tmp15_;
#line 3103 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp16_);
#line 3103 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp16_;
#line 3106 "../src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3107 "../src/Photo.vala"
				_tmp17_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 24132 "Photo.c"
			} else {
#line 3106 "../src/Photo.vala"
				_tmp17_ = FALSE;
#line 24136 "Photo.c"
			}
#line 3106 "../src/Photo.vala"
			if (_tmp17_) {
#line 24140 "Photo.c"
				Dimensions _tmp18_;
				Dimensions _tmp19_ = {0};
#line 3108 "../src/Photo.vala"
				_tmp18_ = raw;
#line 3108 "../src/Photo.vala"
				_vala_scaled_image = _tmp18_;
#line 3109 "../src/Photo.vala"
				box_get_dimensions (&crop, &_tmp19_);
#line 3109 "../src/Photo.vala"
				_vala_scaled_to_viewport = _tmp19_;
#line 3111 "../src/Photo.vala"
				result = FALSE;
#line 3111 "../src/Photo.vala"
				if (scaled_image) {
#line 3111 "../src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 24157 "Photo.c"
				}
#line 3111 "../src/Photo.vala"
				if (scaled_to_viewport) {
#line 3111 "../src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24163 "Photo.c"
				}
#line 3111 "../src/Photo.vala"
				return result;
#line 24167 "Photo.c"
			}
#line 3116 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp20_);
#line 3116 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp21_);
#line 3116 "../src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp20_, &_tmp21_, &_tmp22_);
#line 3116 "../src/Photo.vala"
			_vala_scaled_image = _tmp22_;
#line 3120 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24179 "Photo.c"
				Orientation _tmp23_;
				Dimensions _tmp24_;
				Dimensions _tmp25_ = {0};
#line 3121 "../src/Photo.vala"
				_tmp23_ = orientation;
#line 3121 "../src/Photo.vala"
				_tmp24_ = _vala_scaled_image;
#line 3121 "../src/Photo.vala"
				orientation_derotate_dimensions (_tmp23_, &_tmp24_, &_tmp25_);
#line 3121 "../src/Photo.vala"
				_vala_scaled_image = _tmp25_;
#line 24191 "Photo.c"
			}
		}
	}
#line 3126 "../src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 24197 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp26_;
		Dimensions _tmp30_;
		Dimensions _tmp31_ = {0};
		Dimensions _tmp32_;
#line 3128 "../src/Photo.vala"
		_tmp26_ = raw;
#line 3128 "../src/Photo.vala"
		rotated_raw = _tmp26_;
#line 3129 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24209 "Photo.c"
			Orientation _tmp27_;
			Dimensions _tmp28_;
			Dimensions _tmp29_ = {0};
#line 3130 "../src/Photo.vala"
			_tmp27_ = orientation;
#line 3130 "../src/Photo.vala"
			_tmp28_ = raw;
#line 3130 "../src/Photo.vala"
			orientation_rotate_dimensions (_tmp27_, &_tmp28_, &_tmp29_);
#line 3130 "../src/Photo.vala"
			rotated_raw = _tmp29_;
#line 24221 "Photo.c"
		}
#line 3132 "../src/Photo.vala"
		_tmp30_ = rotated_raw;
#line 3132 "../src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp30_, &_tmp31_);
#line 3132 "../src/Photo.vala"
		_vala_scaled_image = _tmp31_;
#line 3133 "../src/Photo.vala"
		_tmp32_ = _vala_scaled_image;
#line 3133 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp32_;
#line 3136 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24235 "Photo.c"
			Orientation _tmp33_;
			Dimensions _tmp34_;
			Dimensions _tmp35_ = {0};
#line 3137 "../src/Photo.vala"
			_tmp33_ = orientation;
#line 3137 "../src/Photo.vala"
			_tmp34_ = _vala_scaled_image;
#line 3137 "../src/Photo.vala"
			orientation_derotate_dimensions (_tmp33_, &_tmp34_, &_tmp35_);
#line 3137 "../src/Photo.vala"
			_vala_scaled_image = _tmp35_;
#line 24247 "Photo.c"
		}
	}
#line 3141 "../src/Photo.vala"
	_tmp37_ = _vala_scaled_image;
#line 3141 "../src/Photo.vala"
	_tmp38_ = _tmp37_.width;
#line 3141 "../src/Photo.vala"
	_tmp39_ = raw;
#line 3141 "../src/Photo.vala"
	_tmp40_ = _tmp39_.width;
#line 3141 "../src/Photo.vala"
	if (_tmp38_ >= _tmp40_) {
#line 24260 "Photo.c"
		Dimensions _tmp41_;
		gint _tmp42_;
		Dimensions _tmp43_;
		gint _tmp44_;
#line 3141 "../src/Photo.vala"
		_tmp41_ = _vala_scaled_image;
#line 3141 "../src/Photo.vala"
		_tmp42_ = _tmp41_.height;
#line 3141 "../src/Photo.vala"
		_tmp43_ = raw;
#line 3141 "../src/Photo.vala"
		_tmp44_ = _tmp43_.height;
#line 3141 "../src/Photo.vala"
		_tmp36_ = _tmp42_ >= _tmp44_;
#line 24275 "Photo.c"
	} else {
#line 3141 "../src/Photo.vala"
		_tmp36_ = FALSE;
#line 24279 "Photo.c"
	}
#line 3141 "../src/Photo.vala"
	if (_tmp36_) {
#line 24283 "Photo.c"
		Dimensions _tmp45_;
#line 3142 "../src/Photo.vala"
		_tmp45_ = raw;
#line 3142 "../src/Photo.vala"
		_vala_scaled_image = _tmp45_;
#line 3144 "../src/Photo.vala"
		result = FALSE;
#line 3144 "../src/Photo.vala"
		if (scaled_image) {
#line 3144 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 24295 "Photo.c"
		}
#line 3144 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3144 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24301 "Photo.c"
		}
#line 3144 "../src/Photo.vala"
		return result;
#line 24305 "Photo.c"
	}
#line 3147 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area()");
#line 3148 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area()");
#line 3150 "../src/Photo.vala"
	result = TRUE;
#line 3150 "../src/Photo.vala"
	if (scaled_image) {
#line 3150 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 24317 "Photo.c"
	}
#line 3150 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3150 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24323 "Photo.c"
	}
#line 3150 "../src/Photo.vala"
	return result;
#line 24327 "Photo.c"
}


static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean _tmp9_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp14_;
	Dimensions _tmp15_ = {0};
	Dimensions _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
	Dimensions _tmp19_ = {0};
	GError* _inner_error0_ = NULL;
#line 3156 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3156 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3159 "../src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3159 "../src/Photo.vala"
	loader = _tmp0_;
#line 3162 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24367 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3167 "../src/Photo.vala"
		_tmp2_ = loader;
#line 3167 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3167 "../src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3167 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3167 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3167 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3167 "../src/Photo.vala"
			return NULL;
#line 24386 "Photo.c"
		}
#line 3167 "../src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3167 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 3167 "../src/Photo.vala"
		result = _tmp4_;
#line 3167 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3167 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3167 "../src/Photo.vala"
		return result;
#line 24400 "Photo.c"
	}
#line 3172 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3172 "../src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3172 "../src/Photo.vala"
	scaled_image = _tmp6_;
#line 3172 "../src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3172 "../src/Photo.vala"
	is_scaled = _tmp8_;
#line 3174 "../src/Photo.vala"
	_tmp9_ = is_scaled;
#line 3174 "../src/Photo.vala"
	if (!_tmp9_) {
#line 24416 "Photo.c"
		GdkPixbuf* _tmp10_ = NULL;
		PhotoFileReader* _tmp11_;
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 3179 "../src/Photo.vala"
		_tmp11_ = loader;
#line 3179 "../src/Photo.vala"
		_tmp12_ = photo_file_reader_unscaled_read (_tmp11_, &_inner_error0_);
#line 3179 "../src/Photo.vala"
		_tmp10_ = _tmp12_;
#line 3179 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3179 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3179 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3179 "../src/Photo.vala"
			return NULL;
#line 24435 "Photo.c"
		}
#line 3179 "../src/Photo.vala"
		_tmp13_ = _tmp10_;
#line 3179 "../src/Photo.vala"
		_tmp10_ = NULL;
#line 3179 "../src/Photo.vala"
		result = _tmp13_;
#line 3179 "../src/Photo.vala"
		_g_object_unref0 (_tmp10_);
#line 3179 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3179 "../src/Photo.vala"
		return result;
#line 24449 "Photo.c"
	}
#line 3182 "../src/Photo.vala"
	_tmp14_ = loader;
#line 3182 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp15_);
#line 3182 "../src/Photo.vala"
	_tmp16_ = scaled_image;
#line 3182 "../src/Photo.vala"
	_tmp17_ = photo_file_reader_scaled_read (_tmp14_, &_tmp15_, &_tmp16_, &_inner_error0_);
#line 3182 "../src/Photo.vala"
	pixbuf = _tmp17_;
#line 3182 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3182 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3182 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3182 "../src/Photo.vala"
		return NULL;
#line 24469 "Photo.c"
	}
#line 3190 "../src/Photo.vala"
	_tmp18_ = pixbuf;
#line 3190 "../src/Photo.vala"
	dimensions_for_pixbuf (_tmp18_, &_tmp19_);
#line 3190 "../src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp19_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 3192 "../src/Photo.vala"
	result = pixbuf;
#line 3192 "../src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3192 "../src/Photo.vala"
	return result;
#line 24483 "Photo.c"
}


GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3197 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3197 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3198 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3198 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3198 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3198 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3198 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3198 "../src/Photo.vala"
		return NULL;
#line 24515 "Photo.c"
	}
#line 3198 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3198 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3198 "../src/Photo.vala"
	result = _tmp3_;
#line 3198 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3198 "../src/Photo.vala"
	return result;
#line 24527 "Photo.c"
}


GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3202 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3202 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3203 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3203 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3203 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3203 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3203 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3203 "../src/Photo.vala"
		return NULL;
#line 24559 "Photo.c"
	}
#line 3203 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3203 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3203 "../src/Photo.vala"
	result = _tmp3_;
#line 3203 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3203 "../src/Photo.vala"
	return result;
#line 24571 "Photo.c"
}


static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 3207 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3207 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 24594 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3221 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3221 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24601 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3222 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3222 "../src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3222 "../src/Photo.vala"
			scaled_image = _tmp2_;
#line 3222 "../src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3224 "../src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 24616 "Photo.c"
		}
		__finally389:
		{
			PhotoRow* _tmp4_;
#line 3221 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 3221 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24625 "Photo.c"
		}
#line 3221 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3221 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3221 "../src/Photo.vala"
			return NULL;
#line 24633 "Photo.c"
		}
	}
#line 3228 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3228 "../src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3228 "../src/Photo.vala"
	pixbuf = _tmp6_;
#line 3228 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3228 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3228 "../src/Photo.vala"
		return NULL;
#line 24648 "Photo.c"
	}
#line 3234 "../src/Photo.vala"
	if (rotate) {
#line 24652 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3235 "../src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3235 "../src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3235 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3235 "../src/Photo.vala"
		pixbuf = _tmp8_;
#line 24663 "Photo.c"
	}
#line 3244 "../src/Photo.vala"
	result = pixbuf;
#line 3244 "../src/Photo.vala"
	return result;
#line 24669 "Photo.c"
}


static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3247 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 3247 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3248 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3248 "../src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3248 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3248 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3248 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3248 "../src/Photo.vala"
		return NULL;
#line 24701 "Photo.c"
	}
#line 3248 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3248 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3248 "../src/Photo.vala"
	result = _tmp3_;
#line 3248 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3248 "../src/Photo.vala"
	return result;
#line 24713 "Photo.c"
}


/**
     * One-stop shopping for the source pixbuf cache.
     *
     * The source pixbuf cache holds untransformed, unscaled (full-sized) pixbufs of Photo objects.
     * These can be rather large and shouldn't be held in memory for too long, nor should many be
     * allowed to stack up.
     *
     * If locate is non-null, a source pixbuf is returned for the Photo.  If keep is true, the
     * pixbuf is stored in the cache.  (Thus, passing a Photo w/ keep == false will drop the cached
     * pixbuf.)  If Photo is non-null but keep is false, null is returned.
     *
     * Whether locate is null or not, the cache is walked in its entirety, dropping expired pixbufs
     * and dropping excessive pixbufs from the LRU.  Locating a Photo "touches" the pixbuf, i.e.
     * it moves to the head of the LRU.
     */
static gpointer
_photo_cached_pixbuf_ref0 (gpointer self)
{
#line 3283 "../src/Photo.vala"
	return self ? photo_cached_pixbuf_ref (self) : NULL;
#line 24737 "Photo.c"
}


static gboolean
_photo_trim_source_pixbuf_cache_gsource_func (gpointer self)
{
	gboolean result;
	result = photo_trim_source_pixbuf_cache ();
#line 3335 "../src/Photo.vala"
	return result;
#line 24748 "Photo.c"
}


static GdkPixbuf*
photo_run_source_pixbuf_cache (Photo* locate,
                               gboolean keep,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	GError* _inner_error0_ = NULL;
#line 3266 "../src/Photo.vala"
	g_return_val_if_fail ((locate == NULL) || IS_PHOTO (locate), NULL);
#line 24761 "Photo.c"
	{
		GeeLinkedList* _tmp0_;
#line 3267 "../src/Photo.vala"
		_tmp0_ = photo_source_pixbuf_cache;
#line 3267 "../src/Photo.vala"
		g_rec_mutex_lock (&__lock_photo_photo_source_pixbuf_cache);
#line 24768 "Photo.c"
		{
			PhotoCachedPixbuf* found = NULL;
			gdouble min_elapsed = 0.0;
			gint count = 0;
			GeeIterator* iter = NULL;
			GeeLinkedList* _tmp1_;
			GeeIterator* _tmp2_;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_ = FALSE;
			PhotoCachedPixbuf* _tmp24_;
			gboolean _tmp32_ = FALSE;
			PhotoCachedPixbuf* _tmp33_;
			guint _tmp45_;
			GeeLinkedList* _tmp47_;
			gint _tmp48_;
			gint _tmp49_;
			GdkPixbuf* _tmp53_ = NULL;
			PhotoCachedPixbuf* _tmp54_;
			GdkPixbuf* _tmp57_;
#line 3268 "../src/Photo.vala"
			found = NULL;
#line 3272 "../src/Photo.vala"
			min_elapsed = DBL_MAX;
#line 3273 "../src/Photo.vala"
			count = 0;
#line 3274 "../src/Photo.vala"
			_tmp1_ = photo_source_pixbuf_cache;
#line 3274 "../src/Photo.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3274 "../src/Photo.vala"
			iter = _tmp2_;
#line 3275 "../src/Photo.vala"
			while (TRUE) {
#line 24802 "Photo.c"
				GeeIterator* _tmp3_;
				PhotoCachedPixbuf* cached_pixbuf = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				gdouble elapsed = 0.0;
				PhotoCachedPixbuf* _tmp6_;
				GTimer* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 3275 "../src/Photo.vala"
				_tmp3_ = iter;
#line 3275 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 3275 "../src/Photo.vala"
					break;
#line 24817 "Photo.c"
				}
#line 3276 "../src/Photo.vala"
				_tmp4_ = iter;
#line 3276 "../src/Photo.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 3276 "../src/Photo.vala"
				cached_pixbuf = (PhotoCachedPixbuf*) _tmp5_;
#line 3278 "../src/Photo.vala"
				_tmp6_ = cached_pixbuf;
#line 3278 "../src/Photo.vala"
				_tmp7_ = _tmp6_->last_touched;
#line 3278 "../src/Photo.vala"
				elapsed = trunc (g_timer_elapsed (_tmp7_, NULL)) + 1;
#line 3280 "../src/Photo.vala"
				if (locate != NULL) {
#line 24833 "Photo.c"
					PhotoCachedPixbuf* _tmp9_;
					Photo* _tmp10_;
#line 3280 "../src/Photo.vala"
					_tmp9_ = cached_pixbuf;
#line 3280 "../src/Photo.vala"
					_tmp10_ = _tmp9_->photo;
#line 3280 "../src/Photo.vala"
					_tmp8_ = data_source_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (locate, TYPE_DATA_SOURCE, DataSource));
#line 24842 "Photo.c"
				} else {
#line 3280 "../src/Photo.vala"
					_tmp8_ = FALSE;
#line 24846 "Photo.c"
				}
#line 3280 "../src/Photo.vala"
				if (_tmp8_) {
#line 24850 "Photo.c"
					GeeIterator* _tmp11_;
					PhotoCachedPixbuf* _tmp12_;
					PhotoCachedPixbuf* _tmp13_;
					gint _tmp14_;
#line 3282 "../src/Photo.vala"
					_tmp11_ = iter;
#line 3282 "../src/Photo.vala"
					gee_iterator_remove (_tmp11_);
#line 3283 "../src/Photo.vala"
					_tmp12_ = cached_pixbuf;
#line 3283 "../src/Photo.vala"
					_tmp13_ = _photo_cached_pixbuf_ref0 (_tmp12_);
#line 3283 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 3283 "../src/Photo.vala"
					found = _tmp13_;
#line 3286 "../src/Photo.vala"
					_tmp14_ = count;
#line 3286 "../src/Photo.vala"
					count = _tmp14_ + 1;
#line 24871 "Photo.c"
				} else {
					gdouble _tmp15_;
#line 3287 "../src/Photo.vala"
					_tmp15_ = elapsed;
#line 3287 "../src/Photo.vala"
					if (_tmp15_ >= ((gdouble) PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC)) {
#line 24878 "Photo.c"
						GeeIterator* _tmp16_;
#line 3288 "../src/Photo.vala"
						_tmp16_ = iter;
#line 3288 "../src/Photo.vala"
						gee_iterator_remove (_tmp16_);
#line 24884 "Photo.c"
					} else {
						gint _tmp17_;
#line 3289 "../src/Photo.vala"
						_tmp17_ = count;
#line 3289 "../src/Photo.vala"
						if (_tmp17_ >= PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT) {
#line 24891 "Photo.c"
							GeeIterator* _tmp18_;
#line 3290 "../src/Photo.vala"
							_tmp18_ = iter;
#line 3290 "../src/Photo.vala"
							gee_iterator_remove (_tmp18_);
#line 24897 "Photo.c"
						} else {
							gdouble _tmp19_;
							gdouble _tmp20_;
							gint _tmp21_;
#line 3294 "../src/Photo.vala"
							_tmp19_ = elapsed;
#line 3294 "../src/Photo.vala"
							_tmp20_ = min_elapsed;
#line 3294 "../src/Photo.vala"
							min_elapsed = MIN (_tmp19_, _tmp20_);
#line 3295 "../src/Photo.vala"
							_tmp21_ = count;
#line 3295 "../src/Photo.vala"
							count = _tmp21_ + 1;
#line 24912 "Photo.c"
						}
					}
				}
#line 3275 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (cached_pixbuf);
#line 24918 "Photo.c"
			}
#line 3300 "../src/Photo.vala"
			_tmp24_ = found;
#line 3300 "../src/Photo.vala"
			if (_tmp24_ == NULL) {
#line 3300 "../src/Photo.vala"
				_tmp23_ = locate != NULL;
#line 24926 "Photo.c"
			} else {
#line 3300 "../src/Photo.vala"
				_tmp23_ = FALSE;
#line 24930 "Photo.c"
			}
#line 3300 "../src/Photo.vala"
			if (_tmp23_) {
#line 3300 "../src/Photo.vala"
				_tmp22_ = keep;
#line 24936 "Photo.c"
			} else {
#line 3300 "../src/Photo.vala"
				_tmp22_ = FALSE;
#line 24940 "Photo.c"
			}
#line 3300 "../src/Photo.vala"
			if (_tmp22_) {
#line 24944 "Photo.c"
				GdkPixbuf* _tmp25_ = NULL;
				Scaling _tmp26_ = {0};
				GdkPixbuf* _tmp27_;
				PhotoCachedPixbuf* _tmp28_;
#line 3302 "../src/Photo.vala"
				scaling_for_original (&_tmp26_);
#line 3302 "../src/Photo.vala"
				_tmp27_ = photo_load_raw_pixbuf (locate, &_tmp26_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3302 "../src/Photo.vala"
				_tmp25_ = _tmp27_;
#line 3302 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3302 "../src/Photo.vala"
					_g_object_unref0 (iter);
#line 3302 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 24961 "Photo.c"
					goto __finally390;
				}
#line 3301 "../src/Photo.vala"
				_tmp28_ = photo_cached_pixbuf_new (locate, _tmp25_);
#line 3301 "../src/Photo.vala"
				_photo_cached_pixbuf_unref0 (found);
#line 3301 "../src/Photo.vala"
				found = _tmp28_;
#line 3300 "../src/Photo.vala"
				_g_object_unref0 (_tmp25_);
#line 24972 "Photo.c"
			} else {
				PhotoCachedPixbuf* _tmp29_;
#line 3303 "../src/Photo.vala"
				_tmp29_ = found;
#line 3303 "../src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 24979 "Photo.c"
					PhotoCachedPixbuf* _tmp30_;
					GTimer* _tmp31_;
#line 3305 "../src/Photo.vala"
					_tmp30_ = found;
#line 3305 "../src/Photo.vala"
					_tmp31_ = _tmp30_->last_touched;
#line 3305 "../src/Photo.vala"
					g_timer_start (_tmp31_);
#line 24988 "Photo.c"
				}
			}
#line 3309 "../src/Photo.vala"
			_tmp33_ = found;
#line 3309 "../src/Photo.vala"
			if (_tmp33_ != NULL) {
#line 3309 "../src/Photo.vala"
				_tmp32_ = keep;
#line 24997 "Photo.c"
			} else {
#line 3309 "../src/Photo.vala"
				_tmp32_ = FALSE;
#line 25001 "Photo.c"
			}
#line 3309 "../src/Photo.vala"
			if (_tmp32_) {
#line 25005 "Photo.c"
				GeeLinkedList* _tmp34_;
				PhotoCachedPixbuf* _tmp35_;
				PhotoCachedPixbuf* _tmp36_;
				GTimer* _tmp37_;
				gdouble _tmp38_;
#line 3310 "../src/Photo.vala"
				_tmp34_ = photo_source_pixbuf_cache;
#line 3310 "../src/Photo.vala"
				_tmp35_ = found;
#line 3310 "../src/Photo.vala"
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, _tmp35_);
#line 3315 "../src/Photo.vala"
				_tmp36_ = found;
#line 3315 "../src/Photo.vala"
				_tmp37_ = _tmp36_->last_touched;
#line 3315 "../src/Photo.vala"
				_tmp38_ = min_elapsed;
#line 3315 "../src/Photo.vala"
				min_elapsed = MIN (g_timer_elapsed (_tmp37_, NULL), _tmp38_);
#line 3319 "../src/Photo.vala"
				while (TRUE) {
#line 25027 "Photo.c"
					GeeLinkedList* _tmp39_;
					gint _tmp40_;
					gint _tmp41_;
					GeeLinkedList* _tmp42_;
					gpointer _tmp43_;
					PhotoCachedPixbuf* _tmp44_;
#line 3319 "../src/Photo.vala"
					_tmp39_ = photo_source_pixbuf_cache;
#line 3319 "../src/Photo.vala"
					_tmp40_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3319 "../src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 3319 "../src/Photo.vala"
					if (!(_tmp41_ > PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT)) {
#line 3319 "../src/Photo.vala"
						break;
#line 25044 "Photo.c"
					}
#line 3320 "../src/Photo.vala"
					_tmp42_ = photo_source_pixbuf_cache;
#line 3320 "../src/Photo.vala"
					_tmp43_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_DEQUE, GeeDeque));
#line 3320 "../src/Photo.vala"
					_tmp44_ = (PhotoCachedPixbuf*) _tmp43_;
#line 3320 "../src/Photo.vala"
					_photo_cached_pixbuf_unref0 (_tmp44_);
#line 25054 "Photo.c"
				}
			}
#line 3324 "../src/Photo.vala"
			_tmp45_ = photo_discard_source_id;
#line 3324 "../src/Photo.vala"
			if (_tmp45_ != ((guint) 0)) {
#line 25061 "Photo.c"
				guint _tmp46_;
#line 3325 "../src/Photo.vala"
				_tmp46_ = photo_discard_source_id;
#line 3325 "../src/Photo.vala"
				g_source_remove (_tmp46_);
#line 3326 "../src/Photo.vala"
				photo_discard_source_id = (guint) 0;
#line 25069 "Photo.c"
			}
#line 3330 "../src/Photo.vala"
			_tmp47_ = photo_source_pixbuf_cache;
#line 3330 "../src/Photo.vala"
			_tmp48_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3330 "../src/Photo.vala"
			_tmp49_ = _tmp48_;
#line 3330 "../src/Photo.vala"
			if (_tmp49_ > PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT) {
#line 25079 "Photo.c"
				gdouble _tmp50_;
				guint retry_sec = 0U;
				gdouble _tmp51_;
				guint _tmp52_;
#line 3331 "../src/Photo.vala"
				_tmp50_ = min_elapsed;
#line 3331 "../src/Photo.vala"
				_vala_assert (_tmp50_ >= 0.0, "min_elapsed >= 0.0");
#line 3334 "../src/Photo.vala"
				_tmp51_ = min_elapsed;
#line 3334 "../src/Photo.vala"
				retry_sec = PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC - ((guint) trunc (_tmp51_));
#line 3335 "../src/Photo.vala"
				_tmp52_ = retry_sec;
#line 3335 "../src/Photo.vala"
				photo_discard_source_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, _tmp52_, _photo_trim_source_pixbuf_cache_gsource_func, NULL, NULL);
#line 25096 "Photo.c"
			}
#line 3338 "../src/Photo.vala"
			_tmp54_ = found;
#line 3338 "../src/Photo.vala"
			if (_tmp54_ != NULL) {
#line 25102 "Photo.c"
				PhotoCachedPixbuf* _tmp55_;
				GdkPixbuf* _tmp56_;
#line 3338 "../src/Photo.vala"
				_tmp55_ = found;
#line 3338 "../src/Photo.vala"
				_tmp56_ = _tmp55_->pixbuf;
#line 3338 "../src/Photo.vala"
				_tmp53_ = _tmp56_;
#line 25111 "Photo.c"
			} else {
#line 3338 "../src/Photo.vala"
				_tmp53_ = NULL;
#line 25115 "Photo.c"
			}
#line 3338 "../src/Photo.vala"
			_tmp57_ = _g_object_ref0 (_tmp53_);
#line 3338 "../src/Photo.vala"
			result = _tmp57_;
#line 3338 "../src/Photo.vala"
			_g_object_unref0 (iter);
#line 3338 "../src/Photo.vala"
			_photo_cached_pixbuf_unref0 (found);
#line 25125 "Photo.c"
			{
				GError* _inner_error0_ = NULL;
				GeeLinkedList* _tmp58_;
#line 3267 "../src/Photo.vala"
				_tmp58_ = photo_source_pixbuf_cache;
#line 3267 "../src/Photo.vala"
				g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 25133 "Photo.c"
			}
#line 3338 "../src/Photo.vala"
			return result;
#line 25137 "Photo.c"
		}
		__finally390:
		{
			GError* _inner_error1_ = NULL;
			GeeLinkedList* _tmp59_;
#line 3267 "../src/Photo.vala"
			_tmp59_ = photo_source_pixbuf_cache;
#line 3267 "../src/Photo.vala"
			g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 25147 "Photo.c"
		}
#line 3267 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3267 "../src/Photo.vala"
		return NULL;
#line 25153 "Photo.c"
	}
}


static gboolean
photo_trim_source_pixbuf_cache (void)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3344 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (NULL, FALSE, &_inner_error0_);
#line 3344 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3344 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3344 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25174 "Photo.c"
			goto __catch391_g_error;
		}
	}
	goto __finally391;
	__catch391_g_error:
	{
		GError* err = NULL;
#line 3343 "../src/Photo.vala"
		err = _inner_error0_;
#line 3343 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 3343 "../src/Photo.vala"
		_g_error_free0 (err);
#line 25188 "Photo.c"
	}
	__finally391:
#line 3343 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25193 "Photo.c"
		gboolean _tmp2_ = FALSE;
#line 3343 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3343 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3343 "../src/Photo.vala"
		return _tmp2_;
#line 25201 "Photo.c"
	}
#line 3348 "../src/Photo.vala"
	result = FALSE;
#line 3348 "../src/Photo.vala"
	return result;
#line 25207 "Photo.c"
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A copy of the Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self,
                           GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 3356 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3357 "../src/Photo.vala"
	_tmp1_ = photo_run_source_pixbuf_cache (self, TRUE, &_inner_error0_);
#line 3357 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3357 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3357 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3357 "../src/Photo.vala"
		return NULL;
#line 25237 "Photo.c"
	}
#line 3357 "../src/Photo.vala"
	_tmp2_ = gdk_pixbuf_copy (_tmp0_);
#line 3357 "../src/Photo.vala"
	result = _tmp2_;
#line 3357 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3357 "../src/Photo.vala"
	return result;
#line 25247 "Photo.c"
}


/**
     * @brief Discards the cached version of the unmodified image.
     */
void
photo_discard_prefetched (Photo* self)
{
	GError* _inner_error0_ = NULL;
#line 3363 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 25260 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3365 "../src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (self, FALSE, &_inner_error0_);
#line 3365 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3365 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3365 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25272 "Photo.c"
			goto __catch392_g_error;
		}
	}
	goto __finally392;
	__catch392_g_error:
	{
		GError* err = NULL;
#line 3364 "../src/Photo.vala"
		err = _inner_error0_;
#line 3364 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 3364 "../src/Photo.vala"
		_g_error_free0 (err);
#line 25286 "Photo.c"
	}
	__finally392:
#line 3364 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3364 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3364 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3364 "../src/Photo.vala"
		return;
#line 25297 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	gboolean _tmp64_;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_;
	GError* _inner_error0_ = NULL;
#line 3381 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3381 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3394 "../src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3394 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3394 "../src/Photo.vala"
	if (_tmp4_) {
#line 3395 "../src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 25357 "Photo.c"
	} else {
#line 3394 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 25361 "Photo.c"
	}
#line 3394 "../src/Photo.vala"
	if (_tmp2_) {
#line 25365 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3396 "../src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3396 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 25372 "Photo.c"
		} else {
#line 3396 "../src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 25376 "Photo.c"
		}
#line 3396 "../src/Photo.vala"
		if (_tmp6_) {
#line 3396 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 25382 "Photo.c"
		} else {
#line 3397 "../src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 25386 "Photo.c"
		}
#line 3396 "../src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 25390 "Photo.c"
	} else {
#line 3394 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 25394 "Photo.c"
	}
#line 3394 "../src/Photo.vala"
	if (_tmp1_) {
#line 3398 "../src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 25400 "Photo.c"
	} else {
#line 3394 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 25404 "Photo.c"
	}
#line 3394 "../src/Photo.vala"
	if (_tmp0_) {
#line 3399 "../src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self), TRUE);
#line 25410 "Photo.c"
	}
#line 3404 "../src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3405 "../src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3406 "../src/Photo.vala"
	redeye_instances = NULL;
#line 3406 "../src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3406 "../src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3409 "../src/Photo.vala"
	transformer = NULL;
#line 25424 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3412 "../src/Photo.vala"
		_tmp7_ = self->row;
#line 3412 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 25431 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3413 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3413 "../src/Photo.vala"
			original = _tmp8_;
#line 3414 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), exceptions, &_tmp9_);
#line 3414 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3414 "../src/Photo.vala"
			scaled = _tmp10_;
#line 3415 "../src/Photo.vala"
			_tmp11_ = scaled;
#line 3415 "../src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3417 "../src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3417 "../src/Photo.vala"
			_tmp13_ = scaled;
#line 3417 "../src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3419 "../src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3419 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3419 "../src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3419 "../src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3419 "../src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3421 "../src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3421 "../src/Photo.vala"
			crop = _tmp16_;
#line 3421 "../src/Photo.vala"
			is_cropped = _tmp17_;
#line 3423 "../src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3423 "../src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3423 "../src/Photo.vala"
			is_straightened = _tmp19_;
#line 3425 "../src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 25489 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3426 "../src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3426 "../src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3426 "../src/Photo.vala"
				transformer = _tmp20_;
#line 25497 "Photo.c"
			}
#line 3428 "../src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 25501 "Photo.c"
		}
		__finally393:
		{
			PhotoRow* _tmp21_;
#line 3412 "../src/Photo.vala"
			_tmp21_ = self->row;
#line 3412 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25510 "Photo.c"
		}
#line 3412 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3412 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3412 "../src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3412 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3412 "../src/Photo.vala"
			return NULL;
#line 25522 "Photo.c"
		}
	}
#line 3435 "../src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 3435 "../src/Photo.vala"
	pixbuf = _tmp22_;
#line 3435 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3435 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3435 "../src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3435 "../src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3435 "../src/Photo.vala"
		return NULL;
#line 25539 "Photo.c"
	}
#line 3442 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 25543 "Photo.c"
		EditingToolsRedeyeInstance* _tmp23_;
		gint _tmp23__length1;
#line 3447 "../src/Photo.vala"
		_tmp23_ = redeye_instances;
#line 3447 "../src/Photo.vala"
		_tmp23__length1 = redeye_instances_length1;
#line 25550 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3447 "../src/Photo.vala"
			instance_collection = _tmp23_;
#line 3447 "../src/Photo.vala"
			instance_collection_length1 = _tmp23__length1;
#line 3447 "../src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp23__length1; instance_it = instance_it + 1) {
#line 25562 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3447 "../src/Photo.vala"
				instance = instance_collection[instance_it];
#line 25566 "Photo.c"
				{
					GdkPixbuf* _tmp24_;
					EditingToolsRedeyeInstance _tmp25_;
					GdkPixbuf* _tmp26_;
#line 3448 "../src/Photo.vala"
					_tmp24_ = pixbuf;
#line 3448 "../src/Photo.vala"
					_tmp25_ = instance;
#line 3448 "../src/Photo.vala"
					_tmp26_ = photo_do_redeye (self, _tmp24_, &_tmp25_);
#line 3448 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3448 "../src/Photo.vala"
					pixbuf = _tmp26_;
#line 25581 "Photo.c"
				}
			}
		}
	}
#line 3456 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 25588 "Photo.c"
		gboolean _tmp27_;
#line 3460 "../src/Photo.vala"
		_tmp27_ = is_straightened;
#line 3460 "../src/Photo.vala"
		if (_tmp27_) {
#line 25594 "Photo.c"
			GdkPixbuf* _tmp28_;
			gdouble _tmp29_;
			GdkPixbuf* _tmp30_;
#line 3461 "../src/Photo.vala"
			_tmp28_ = pixbuf;
#line 3461 "../src/Photo.vala"
			_tmp29_ = straightening_angle;
#line 3461 "../src/Photo.vala"
			_tmp30_ = rotate_arb (_tmp28_, _tmp29_);
#line 3461 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3461 "../src/Photo.vala"
			pixbuf = _tmp30_;
#line 25608 "Photo.c"
		}
	}
#line 3470 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 25613 "Photo.c"
		gboolean _tmp31_;
#line 3474 "../src/Photo.vala"
		_tmp31_ = is_cropped;
#line 3474 "../src/Photo.vala"
		if (_tmp31_) {
#line 25619 "Photo.c"
			Box _tmp32_;
			gint _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			gint _tmp38_;
			GdkPixbuf* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			Box _tmp42_;
			gint _tmp43_;
			Box _tmp44_;
			gint _tmp45_;
			GdkPixbuf* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
			Box _tmp49_;
			gint _tmp50_;
			Box _tmp51_;
			gint _tmp52_;
			GdkPixbuf* _tmp53_;
			gint _tmp54_;
			gint _tmp55_;
			GdkPixbuf* _tmp56_;
			Box _tmp57_;
			gint _tmp58_;
			Box _tmp59_;
			gint _tmp60_;
			GdkPixbuf* _tmp61_;
#line 3479 "../src/Photo.vala"
			_tmp32_ = crop;
#line 3479 "../src/Photo.vala"
			_tmp33_ = _tmp32_.left;
#line 3479 "../src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3479 "../src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_width (_tmp34_);
#line 3479 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3479 "../src/Photo.vala"
			crop.left = CLAMP (_tmp33_, 0, _tmp36_ - 2);
#line 3480 "../src/Photo.vala"
			_tmp37_ = crop;
#line 3480 "../src/Photo.vala"
			_tmp38_ = _tmp37_.top;
#line 3480 "../src/Photo.vala"
			_tmp39_ = pixbuf;
#line 3480 "../src/Photo.vala"
			_tmp40_ = gdk_pixbuf_get_height (_tmp39_);
#line 3480 "../src/Photo.vala"
			_tmp41_ = _tmp40_;
#line 3480 "../src/Photo.vala"
			crop.top = CLAMP (_tmp38_, 0, _tmp41_ - 2);
#line 3482 "../src/Photo.vala"
			_tmp42_ = crop;
#line 3482 "../src/Photo.vala"
			_tmp43_ = _tmp42_.right;
#line 3482 "../src/Photo.vala"
			_tmp44_ = crop;
#line 3482 "../src/Photo.vala"
			_tmp45_ = _tmp44_.left;
#line 3482 "../src/Photo.vala"
			_tmp46_ = pixbuf;
#line 3482 "../src/Photo.vala"
			_tmp47_ = gdk_pixbuf_get_width (_tmp46_);
#line 3482 "../src/Photo.vala"
			_tmp48_ = _tmp47_;
#line 3482 "../src/Photo.vala"
			crop.right = CLAMP (_tmp43_, _tmp45_ + 1, _tmp48_ - 1);
#line 3483 "../src/Photo.vala"
			_tmp49_ = crop;
#line 3483 "../src/Photo.vala"
			_tmp50_ = _tmp49_.bottom;
#line 3483 "../src/Photo.vala"
			_tmp51_ = crop;
#line 3483 "../src/Photo.vala"
			_tmp52_ = _tmp51_.top;
#line 3483 "../src/Photo.vala"
			_tmp53_ = pixbuf;
#line 3483 "../src/Photo.vala"
			_tmp54_ = gdk_pixbuf_get_height (_tmp53_);
#line 3483 "../src/Photo.vala"
			_tmp55_ = _tmp54_;
#line 3483 "../src/Photo.vala"
			crop.bottom = CLAMP (_tmp50_, _tmp52_ + 1, _tmp55_ - 1);
#line 3485 "../src/Photo.vala"
			_tmp56_ = pixbuf;
#line 3485 "../src/Photo.vala"
			_tmp57_ = crop;
#line 3485 "../src/Photo.vala"
			_tmp58_ = _tmp57_.left;
#line 3485 "../src/Photo.vala"
			_tmp59_ = crop;
#line 3485 "../src/Photo.vala"
			_tmp60_ = _tmp59_.top;
#line 3485 "../src/Photo.vala"
			_tmp61_ = gdk_pixbuf_new_subpixbuf (_tmp56_, _tmp58_, _tmp60_, box_get_width (&crop), box_get_height (&crop));
#line 3485 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3485 "../src/Photo.vala"
			pixbuf = _tmp61_;
#line 25722 "Photo.c"
		}
	}
#line 3495 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 25727 "Photo.c"
		GdkPixbuf* _tmp62_;
		GdkPixbuf* _tmp63_;
#line 3499 "../src/Photo.vala"
		_tmp62_ = pixbuf;
#line 3499 "../src/Photo.vala"
		_tmp63_ = orientation_rotate_pixbuf (orientation, _tmp62_);
#line 3499 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3499 "../src/Photo.vala"
		pixbuf = _tmp63_;
#line 25738 "Photo.c"
	}
#line 3506 "../src/Photo.vala"
	_tmp64_ = is_scaled;
#line 3506 "../src/Photo.vala"
	if (_tmp64_) {
#line 25744 "Photo.c"
		GdkPixbuf* _tmp65_;
		Dimensions _tmp66_;
		gint _tmp67_;
		Dimensions _tmp68_;
		gint _tmp69_;
		GdkPixbuf* _tmp70_;
#line 3510 "../src/Photo.vala"
		_tmp65_ = pixbuf;
#line 3510 "../src/Photo.vala"
		_tmp66_ = scaled_to_viewport;
#line 3510 "../src/Photo.vala"
		_tmp67_ = _tmp66_.width;
#line 3510 "../src/Photo.vala"
		_tmp68_ = scaled_to_viewport;
#line 3510 "../src/Photo.vala"
		_tmp69_ = _tmp68_.height;
#line 3510 "../src/Photo.vala"
		_tmp70_ = gdk_pixbuf_scale_simple (_tmp65_, _tmp67_, _tmp69_, GDK_INTERP_BILINEAR);
#line 3510 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3510 "../src/Photo.vala"
		pixbuf = _tmp70_;
#line 25767 "Photo.c"
	}
#line 3518 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 25771 "Photo.c"
		PixelTransformer* _tmp71_;
#line 3522 "../src/Photo.vala"
		_tmp71_ = transformer;
#line 3522 "../src/Photo.vala"
		if (_tmp71_ != NULL) {
#line 25777 "Photo.c"
			PixelTransformer* _tmp72_;
			GdkPixbuf* _tmp73_;
#line 3523 "../src/Photo.vala"
			_tmp72_ = transformer;
#line 3523 "../src/Photo.vala"
			_tmp73_ = pixbuf;
#line 3523 "../src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp72_, _tmp73_, NULL);
#line 25786 "Photo.c"
		}
	}
#line 3532 "../src/Photo.vala"
	_tmp75_ = is_scaled;
#line 3532 "../src/Photo.vala"
	if (_tmp75_) {
#line 25793 "Photo.c"
		gboolean _tmp76_;
#line 3532 "../src/Photo.vala"
		_tmp76_ = is_straightened;
#line 3532 "../src/Photo.vala"
		_tmp74_ = !_tmp76_;
#line 25799 "Photo.c"
	} else {
#line 3532 "../src/Photo.vala"
		_tmp74_ = FALSE;
#line 25803 "Photo.c"
	}
#line 3532 "../src/Photo.vala"
	if (_tmp74_) {
#line 25807 "Photo.c"
		GdkPixbuf* _tmp77_;
		Dimensions _tmp78_ = {0};
#line 3533 "../src/Photo.vala"
		_tmp77_ = pixbuf;
#line 3533 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp77_, &_tmp78_);
#line 3533 "../src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp78_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 25816 "Photo.c"
	}
#line 3541 "../src/Photo.vala"
	result = pixbuf;
#line 3541 "../src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3541 "../src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3541 "../src/Photo.vala"
	return result;
#line 25826 "Photo.c"
}


static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3549 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3549 "../src/Photo.vala"
	return _tmp0_;
#line 25838 "Photo.c"
}


gboolean
photo_has_user_generated_metadata (Photo* self)
{
#line 3549 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3549 "../src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 25849 "Photo.c"
}


static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3553 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3553 "../src/Photo.vala"
	return;
#line 25861 "Photo.c"
}


void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
#line 3553 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3553 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 25873 "Photo.c"
}


gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result = NULL;
#line 3560 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3561 "../src/Photo.vala"
	if (file_format != NULL) {
#line 25886 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3562 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3562 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3562 "../src/Photo.vala"
		_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3562 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3562 "../src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3562 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3562 "../src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3562 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3562 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3562 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3562 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3562 "../src/Photo.vala"
		result = _tmp7_;
#line 3562 "../src/Photo.vala"
		return result;
#line 25921 "Photo.c"
	} else {
#line 3564 "../src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 25925 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3565 "../src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3565 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3565 "../src/Photo.vala"
			_tmp10_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3565 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3565 "../src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3565 "../src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3565 "../src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3565 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3565 "../src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3565 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3565 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3565 "../src/Photo.vala"
			result = _tmp15_;
#line 3565 "../src/Photo.vala"
			return result;
#line 25960 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3568 "../src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3568 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3568 "../src/Photo.vala"
			_tmp18_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3568 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3568 "../src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3568 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3568 "../src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3568 "../src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3568 "../src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3568 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3568 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3568 "../src/Photo.vala"
			result = _tmp23_;
#line 3568 "../src/Photo.vala"
			return result;
#line 25996 "Photo.c"
		}
	}
}


static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp56_;
	PhotoMetadata* _tmp57_;
	PhotoMetadata* _tmp59_;
	PhotoFileMetadataWriter* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	PhotoFileMetadataWriter* _tmp82_;
	PhotoMetadata* _tmp83_;
	GError* _inner_error0_ = NULL;
#line 3574 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3574 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3577 "../src/Photo.vala"
	export_reader = NULL;
#line 3578 "../src/Photo.vala"
	is_master = TRUE;
#line 26057 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3579 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3579 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 26064 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3580 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3580 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3580 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 26075 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3580 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3580 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3580 "../src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 26084 "Photo.c"
			} else {
#line 3580 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 26088 "Photo.c"
			}
#line 3580 "../src/Photo.vala"
			if (_tmp1_) {
#line 26092 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3581 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3581 "../src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3581 "../src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3581 "../src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3581 "../src/Photo.vala"
				export_reader = _tmp8_;
#line 3582 "../src/Photo.vala"
				is_master = FALSE;
#line 26108 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3583 "../src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3583 "../src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3583 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 26119 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3583 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3583 "../src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3583 "../src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 26128 "Photo.c"
				} else {
#line 3583 "../src/Photo.vala"
					_tmp9_ = FALSE;
#line 26132 "Photo.c"
				}
#line 3583 "../src/Photo.vala"
				if (_tmp9_) {
#line 26136 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3584 "../src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3584 "../src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3584 "../src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3584 "../src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3584 "../src/Photo.vala"
					export_reader = _tmp16_;
#line 3585 "../src/Photo.vala"
					is_master = FALSE;
#line 26152 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3586 "../src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3586 "../src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3586 "../src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 26162 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3587 "../src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3587 "../src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3587 "../src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3587 "../src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3587 "../src/Photo.vala"
						export_reader = _tmp21_;
#line 26176 "Photo.c"
					}
				}
			}
		}
		__finally394:
		{
			PhotoBackingReaders* _tmp22_;
#line 3579 "../src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3579 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26188 "Photo.c"
		}
#line 3579 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26192 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3579 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3579 "../src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3579 "../src/Photo.vala"
			return _tmp23_;
#line 26200 "Photo.c"
		}
	}
#line 3591 "../src/Photo.vala"
	_tmp24_ = export_reader;
#line 3591 "../src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3592 "../src/Photo.vala"
		result = FALSE;
#line 3592 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3592 "../src/Photo.vala"
		return result;
#line 26213 "Photo.c"
	}
#line 3594 "../src/Photo.vala"
	_tmp25_ = export_reader;
#line 3594 "../src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3594 "../src/Photo.vala"
	format_properties = _tmp26_;
#line 3597 "../src/Photo.vala"
	_tmp27_ = format_properties;
#line 3597 "../src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3597 "../src/Photo.vala"
	dest_file = _tmp28_;
#line 3600 "../src/Photo.vala"
	_tmp29_ = export_reader;
#line 3600 "../src/Photo.vala"
	_tmp30_ = dest_file;
#line 3600 "../src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3600 "../src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3600 "../src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp32_, &_inner_error0_);
#line 3600 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3600 "../src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3600 "../src/Photo.vala"
	writer = _tmp34_;
#line 3600 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26245 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3600 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3600 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3600 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3600 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3600 "../src/Photo.vala"
		return _tmp35_;
#line 26257 "Photo.c"
	}
#line 3603 "../src/Photo.vala"
	_tmp36_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3603 "../src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3603 "../src/Photo.vala"
	_tmp38_ = writer;
#line 3603 "../src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3603 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3603 "../src/Photo.vala"
	g_debug ("Photo.vala:3603: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3603 "../src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3603 "../src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3605 "../src/Photo.vala"
	_tmp41_ = export_reader;
#line 3605 "../src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3605 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3605 "../src/Photo.vala"
	_tmp44_ = dest_file;
#line 3605 "../src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3605 "../src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3605 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26289 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3605 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3605 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3605 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3605 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3605 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3605 "../src/Photo.vala"
		return _tmp45_;
#line 26303 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 26307 "Photo.c"
		gboolean _tmp51_;
#line 3610 "../src/Photo.vala"
		_tmp51_ = is_master;
#line 3610 "../src/Photo.vala"
		_tmp50_ = _tmp51_;
#line 26313 "Photo.c"
	} else {
#line 3610 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 26317 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (_tmp50_) {
#line 3610 "../src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 26323 "Photo.c"
	} else {
#line 3610 "../src/Photo.vala"
		_tmp49_ = FALSE;
#line 26327 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (_tmp49_) {
#line 26331 "Photo.c"
		gchar* _tmp52_;
		gchar* _tmp53_;
#line 3611 "../src/Photo.vala"
		_tmp52_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3611 "../src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3611 "../src/Photo.vala"
		_tmp48_ = _tmp53_ == NULL;
#line 3611 "../src/Photo.vala"
		_g_free0 (_tmp53_);
#line 26342 "Photo.c"
	} else {
#line 3610 "../src/Photo.vala"
		_tmp48_ = FALSE;
#line 26346 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (_tmp48_) {
#line 26350 "Photo.c"
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 3611 "../src/Photo.vala"
		_tmp54_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3611 "../src/Photo.vala"
		_tmp55_ = _tmp54_;
#line 3611 "../src/Photo.vala"
		_tmp47_ = _tmp55_ == NULL;
#line 3611 "../src/Photo.vala"
		_g_free0 (_tmp55_);
#line 26361 "Photo.c"
	} else {
#line 3610 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 26365 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (_tmp47_) {
#line 3611 "../src/Photo.vala"
		_tmp46_ = export_metadata;
#line 26371 "Photo.c"
	} else {
#line 3610 "../src/Photo.vala"
		_tmp46_ = FALSE;
#line 26375 "Photo.c"
	}
#line 3610 "../src/Photo.vala"
	if (_tmp46_) {
#line 3612 "../src/Photo.vala"
		result = TRUE;
#line 3612 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3612 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3612 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3612 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3612 "../src/Photo.vala"
		return result;
#line 26391 "Photo.c"
	}
#line 3615 "../src/Photo.vala"
	_tmp56_ = export_reader;
#line 3615 "../src/Photo.vala"
	_tmp57_ = photo_file_reader_read_metadata (_tmp56_, &_inner_error0_);
#line 3615 "../src/Photo.vala"
	metadata = _tmp57_;
#line 3615 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26401 "Photo.c"
		gboolean _tmp58_ = FALSE;
#line 3615 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3615 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3615 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3615 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3615 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3615 "../src/Photo.vala"
		return _tmp58_;
#line 26415 "Photo.c"
	}
#line 3616 "../src/Photo.vala"
	_tmp59_ = metadata;
#line 3616 "../src/Photo.vala"
	if (_tmp59_ == NULL) {
#line 26421 "Photo.c"
		PhotoFileReader* _tmp60_;
		PhotoMetadata* _tmp61_;
#line 3617 "../src/Photo.vala"
		_tmp60_ = export_reader;
#line 3617 "../src/Photo.vala"
		_tmp61_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3617 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3617 "../src/Photo.vala"
		metadata = _tmp61_;
#line 26432 "Photo.c"
	}
#line 3619 "../src/Photo.vala"
	_tmp62_ = writer;
#line 3619 "../src/Photo.vala"
	_tmp63_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3619 "../src/Photo.vala"
	_tmp64_ = _tmp63_;
#line 3619 "../src/Photo.vala"
	g_debug ("Photo.vala:3619: Updating metadata of %s", _tmp64_);
#line 3619 "../src/Photo.vala"
	_g_free0 (_tmp64_);
#line 3621 "../src/Photo.vala"
	if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 26446 "Photo.c"
		PhotoMetadata* _tmp65_;
		MetadataDateTime* _tmp66_;
		MetadataDateTime* _tmp67_;
#line 3622 "../src/Photo.vala"
		_tmp65_ = metadata;
#line 3622 "../src/Photo.vala"
		_tmp66_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3622 "../src/Photo.vala"
		_tmp67_ = _tmp66_;
#line 3622 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp65_, _tmp67_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3622 "../src/Photo.vala"
		_metadata_date_time_unref0 (_tmp67_);
#line 26460 "Photo.c"
	} else {
		PhotoMetadata* _tmp68_;
#line 3624 "../src/Photo.vala"
		_tmp68_ = metadata;
#line 3624 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp68_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26467 "Photo.c"
	}
#line 3626 "../src/Photo.vala"
	if (export_metadata) {
#line 26471 "Photo.c"
		PhotoMetadata* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		PhotoMetadata* _tmp72_;
		gchar* _tmp73_;
		gchar* _tmp74_;
		PhotoMetadata* _tmp75_;
		Dimensions _tmp76_ = {0};
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp78_;
		PhotoMetadata* _tmp80_;
#line 3628 "../src/Photo.vala"
		_tmp69_ = metadata;
#line 3628 "../src/Photo.vala"
		_tmp70_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3628 "../src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 3628 "../src/Photo.vala"
		photo_metadata_set_title (_tmp69_, _tmp71_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3628 "../src/Photo.vala"
		_g_free0 (_tmp71_);
#line 3629 "../src/Photo.vala"
		_tmp72_ = metadata;
#line 3629 "../src/Photo.vala"
		_tmp73_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3629 "../src/Photo.vala"
		_tmp74_ = _tmp73_;
#line 3629 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp72_, _tmp74_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3629 "../src/Photo.vala"
		_g_free0 (_tmp74_);
#line 3630 "../src/Photo.vala"
		_tmp75_ = metadata;
#line 3630 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp76_);
#line 3630 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp75_, &_tmp76_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3631 "../src/Photo.vala"
		_tmp77_ = metadata;
#line 3631 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp77_, photo_get_orientation (self));
#line 3632 "../src/Photo.vala"
		_tmp78_ = metadata;
#line 3632 "../src/Photo.vala"
		photo_metadata_set_software (_tmp78_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3634 "../src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 26519 "Photo.c"
			PhotoMetadata* _tmp79_;
#line 3635 "../src/Photo.vala"
			_tmp79_ = metadata;
#line 3635 "../src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp79_);
#line 26525 "Photo.c"
		}
#line 3637 "../src/Photo.vala"
		_tmp80_ = metadata;
#line 3637 "../src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp80_);
#line 26531 "Photo.c"
	} else {
		PhotoMetadata* _tmp81_;
#line 3641 "../src/Photo.vala"
		_tmp81_ = metadata;
#line 3641 "../src/Photo.vala"
		photo_metadata_clear (_tmp81_);
#line 26538 "Photo.c"
	}
#line 3643 "../src/Photo.vala"
	_tmp82_ = writer;
#line 3643 "../src/Photo.vala"
	_tmp83_ = metadata;
#line 3643 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp82_, _tmp83_, &_inner_error0_);
#line 3643 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26548 "Photo.c"
		gboolean _tmp84_ = FALSE;
#line 3643 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3643 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3643 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3643 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3643 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3643 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3643 "../src/Photo.vala"
		return _tmp84_;
#line 26564 "Photo.c"
	}
#line 3645 "../src/Photo.vala"
	result = TRUE;
#line 3645 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3645 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3645 "../src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3645 "../src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3645 "../src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3645 "../src/Photo.vala"
	return result;
#line 26580 "Photo.c"
}


gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 3651 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3651 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3652 "../src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3652 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 26601 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 26605 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp2_) {
#line 3652 "../src/Photo.vala"
		_tmp1_ = TRUE;
#line 26611 "Photo.c"
	} else {
#line 3652 "../src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 26615 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	if (_tmp1_) {
#line 3652 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 26621 "Photo.c"
	} else {
#line 3653 "../src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 26625 "Photo.c"
	}
#line 3652 "../src/Photo.vala"
	result = _tmp0_;
#line 3652 "../src/Photo.vala"
	return result;
#line 26631 "Photo.c"
}


void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 3659 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3659 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (dest_file));
#line 3659 "../src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3661 "../src/Photo.vala"
	if (direct_copy_unmodified) {
#line 26685 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3662 "../src/Photo.vala"
		_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3662 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3662 "../src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3662 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3662 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3662 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3662 "../src/Photo.vala"
			return;
#line 26702 "Photo.c"
		}
#line 3664 "../src/Photo.vala"
		return;
#line 26706 "Photo.c"
	}
#line 3671 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 26710 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3671 "../src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3671 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 26716 "Photo.c"
		} else {
#line 3671 "../src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 26720 "Photo.c"
		}
#line 3671 "../src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 26724 "Photo.c"
	} else {
#line 3671 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 26728 "Photo.c"
	}
#line 3671 "../src/Photo.vala"
	if (_tmp4_) {
#line 3672 "../src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 26734 "Photo.c"
	} else {
#line 3671 "../src/Photo.vala"
		_tmp3_ = FALSE;
#line 26738 "Photo.c"
	}
#line 3671 "../src/Photo.vala"
	if (_tmp3_) {
#line 3672 "../src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 26744 "Photo.c"
	} else {
#line 3671 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 26748 "Photo.c"
	}
#line 3671 "../src/Photo.vala"
	if (_tmp2_) {
#line 26752 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3673 "../src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3673 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3673 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3673 "../src/Photo.vala"
			return;
#line 26762 "Photo.c"
		}
#line 3673 "../src/Photo.vala"
		if (_tmp6_) {
#line 3674 "../src/Photo.vala"
			return;
#line 26768 "Photo.c"
		}
	}
#line 3680 "../src/Photo.vala"
	_tmp7_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 3680 "../src/Photo.vala"
	metadata = _tmp7_;
#line 3681 "../src/Photo.vala"
	_tmp8_ = metadata;
#line 3681 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 26779 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3682 "../src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3682 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3682 "../src/Photo.vala"
		metadata = _tmp9_;
#line 26787 "Photo.c"
	}
#line 3684 "../src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3685 "../src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 26793 "Photo.c"
	}
#line 3687 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3687 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3687 "../src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3687 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3687 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3687 "../src/Photo.vala"
	writer = _tmp13_;
#line 3687 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3687 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3687 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3687 "../src/Photo.vala"
		return;
#line 26815 "Photo.c"
	}
#line 3689 "../src/Photo.vala"
	_tmp14_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3689 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3689 "../src/Photo.vala"
	_tmp16_ = writer;
#line 3689 "../src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3689 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3690 "../src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3689 "../src/Photo.vala"
	g_debug ("Photo.vala:3689: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3689 "../src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3689 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3696 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3696 "../src/Photo.vala"
		_tmp20_ = TRUE;
#line 26839 "Photo.c"
	} else {
#line 3697 "../src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 26843 "Photo.c"
	}
#line 3696 "../src/Photo.vala"
	if (_tmp20_) {
#line 26847 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3698 "../src/Photo.vala"
		_tmp22_ = *scaling;
#line 3698 "../src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3698 "../src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3698 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3698 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3698 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3698 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3698 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3698 "../src/Photo.vala"
			return;
#line 26870 "Photo.c"
		}
#line 3698 "../src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3698 "../src/Photo.vala"
		_tmp21_ = NULL;
#line 3698 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3698 "../src/Photo.vala"
		pixbuf = _tmp24_;
#line 3696 "../src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 26882 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3702 "../src/Photo.vala"
		_tmp26_ = *scaling;
#line 3702 "../src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3702 "../src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3702 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3702 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3702 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3702 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3702 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3702 "../src/Photo.vala"
			return;
#line 26906 "Photo.c"
		}
#line 3702 "../src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3702 "../src/Photo.vala"
		_tmp25_ = NULL;
#line 3702 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3702 "../src/Photo.vala"
		pixbuf = _tmp28_;
#line 3696 "../src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 26918 "Photo.c"
	}
#line 3706 "../src/Photo.vala"
	_tmp29_ = writer;
#line 3706 "../src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3706 "../src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3706 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3706 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3706 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3706 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3706 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3706 "../src/Photo.vala"
		return;
#line 26938 "Photo.c"
	}
#line 3708 "../src/Photo.vala"
	_tmp31_ = writer;
#line 3708 "../src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3708 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3708 "../src/Photo.vala"
	g_debug ("Photo.vala:3708: Setting EXIF for %s", _tmp33_);
#line 3708 "../src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3711 "../src/Photo.vala"
	if (export_metadata) {
#line 26952 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3713 "../src/Photo.vala"
		_tmp34_ = metadata;
#line 3713 "../src/Photo.vala"
		_tmp35_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3713 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3713 "../src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3713 "../src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3714 "../src/Photo.vala"
		_tmp37_ = metadata;
#line 3714 "../src/Photo.vala"
		_tmp38_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3714 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3714 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3714 "../src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3715 "../src/Photo.vala"
		_tmp40_ = metadata;
#line 3715 "../src/Photo.vala"
		photo_metadata_set_software (_tmp40_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3717 "../src/Photo.vala"
		if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 26989 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3718 "../src/Photo.vala"
			_tmp41_ = metadata;
#line 3718 "../src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3718 "../src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3718 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3718 "../src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 27003 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3720 "../src/Photo.vala"
			_tmp44_ = metadata;
#line 3720 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 27010 "Photo.c"
		}
#line 3722 "../src/Photo.vala"
		_tmp45_ = metadata;
#line 3722 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3723 "../src/Photo.vala"
		_tmp46_ = metadata;
#line 3723 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3724 "../src/Photo.vala"
		_tmp47_ = metadata;
#line 3724 "../src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3726 "../src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 27026 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3727 "../src/Photo.vala"
			_tmp48_ = metadata;
#line 3727 "../src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 27032 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3731 "../src/Photo.vala"
		_tmp49_ = metadata;
#line 3731 "../src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 27040 "Photo.c"
	}
#line 3738 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3738 "../src/Photo.vala"
		_tmp50_ = TRUE;
#line 27046 "Photo.c"
	} else {
#line 3739 "../src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 27050 "Photo.c"
	}
#line 3738 "../src/Photo.vala"
	if (_tmp50_) {
#line 27054 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3740 "../src/Photo.vala"
		_tmp51_ = metadata;
#line 3740 "../src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3740 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3741 "../src/Photo.vala"
		_tmp53_ = metadata;
#line 3741 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 27068 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3744 "../src/Photo.vala"
		_tmp54_ = metadata;
#line 3744 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3744 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3744 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3745 "../src/Photo.vala"
		_tmp57_ = metadata;
#line 3745 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 27086 "Photo.c"
	}
#line 3748 "../src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3748 "../src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3748 "../src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error0_);
#line 3748 "../src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3748 "../src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3748 "../src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3748 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3748 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3748 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3748 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3748 "../src/Photo.vala"
		return;
#line 27112 "Photo.c"
	}
#line 3748 "../src/Photo.vala"
	_tmp63_ = metadata;
#line 3748 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error0_);
#line 3748 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3748 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3748 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3748 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3748 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3748 "../src/Photo.vala"
		return;
#line 27132 "Photo.c"
	}
#line 3659 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3659 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3659 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3659 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 27142 "Photo.c"
}


static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp3_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* editable_basename = NULL;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean collision = FALSE;
	GFile* _tmp21_ = NULL;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 3751 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 27178 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3753 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3753 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 27185 "Photo.c"
		{
			GFile* _tmp1_;
#line 3754 "../src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3755 "../src/Photo.vala"
			_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3755 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3755 "../src/Photo.vala"
			backing = _tmp1_;
#line 27196 "Photo.c"
		}
		__finally395:
		{
			PhotoRow* _tmp2_;
#line 3753 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 3753 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27205 "Photo.c"
		}
#line 3753 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3753 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3753 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3753 "../src/Photo.vala"
			return NULL;
#line 27215 "Photo.c"
		}
	}
#line 3758 "../src/Photo.vala"
	_tmp3_ = _vala_file_format;
#line 3758 "../src/Photo.vala"
	if (!photo_file_format_can_write (_tmp3_)) {
#line 3759 "../src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 27224 "Photo.c"
	}
#line 3762 "../src/Photo.vala"
	_tmp4_ = g_file_get_basename (backing);
#line 3762 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3762 "../src/Photo.vala"
	disassemble_filename (_tmp5_, &_tmp6_, &_tmp7_);
#line 3762 "../src/Photo.vala"
	_g_free0 (name);
#line 3762 "../src/Photo.vala"
	name = _tmp6_;
#line 3762 "../src/Photo.vala"
	_g_free0 (ext);
#line 3762 "../src/Photo.vala"
	ext = _tmp7_;
#line 3762 "../src/Photo.vala"
	_g_free0 (_tmp5_);
#line 3764 "../src/Photo.vala"
	_tmp9_ = ext;
#line 3764 "../src/Photo.vala"
	if (_tmp9_ == NULL) {
#line 3764 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 27248 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_;
		PhotoFileFormatProperties* _tmp11_;
		PhotoFileFormatProperties* _tmp12_;
		const gchar* _tmp13_;
#line 3764 "../src/Photo.vala"
		_tmp10_ = _vala_file_format;
#line 3764 "../src/Photo.vala"
		_tmp11_ = photo_file_format_get_properties (_tmp10_);
#line 3764 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 3764 "../src/Photo.vala"
		_tmp13_ = ext;
#line 3764 "../src/Photo.vala"
		_tmp8_ = !photo_file_format_properties_is_recognized_extension (_tmp12_, _tmp13_);
#line 3764 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp12_);
#line 27266 "Photo.c"
	}
#line 3764 "../src/Photo.vala"
	if (_tmp8_) {
#line 27270 "Photo.c"
		PhotoFileFormat _tmp14_;
		PhotoFileFormatProperties* _tmp15_;
		PhotoFileFormatProperties* _tmp16_;
		gchar* _tmp17_;
#line 3765 "../src/Photo.vala"
		_tmp14_ = _vala_file_format;
#line 3765 "../src/Photo.vala"
		_tmp15_ = photo_file_format_get_properties (_tmp14_);
#line 3765 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 3765 "../src/Photo.vala"
		_tmp17_ = photo_file_format_properties_get_default_extension (_tmp16_);
#line 3765 "../src/Photo.vala"
		_g_free0 (ext);
#line 3765 "../src/Photo.vala"
		ext = _tmp17_;
#line 3765 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp16_);
#line 27289 "Photo.c"
	}
#line 3767 "../src/Photo.vala"
	_tmp18_ = name;
#line 3767 "../src/Photo.vala"
	_tmp19_ = ext;
#line 3767 "../src/Photo.vala"
	_tmp20_ = g_strdup_printf ("%s_%s.%s", _tmp18_, _ ("modified"), _tmp19_);
#line 3767 "../src/Photo.vala"
	editable_basename = _tmp20_;
#line 3770 "../src/Photo.vala"
	_tmp22_ = g_file_get_parent (backing);
#line 3770 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3770 "../src/Photo.vala"
	_tmp25_ = generate_unique_file (_tmp23_, editable_basename, &_tmp24_, &_inner_error0_);
#line 3770 "../src/Photo.vala"
	collision = _tmp24_;
#line 3770 "../src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 3770 "../src/Photo.vala"
	_g_object_unref0 (_tmp23_);
#line 3770 "../src/Photo.vala"
	_tmp21_ = _tmp26_;
#line 3770 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3770 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3770 "../src/Photo.vala"
		_g_free0 (editable_basename);
#line 3770 "../src/Photo.vala"
		_g_free0 (ext);
#line 3770 "../src/Photo.vala"
		_g_free0 (name);
#line 3770 "../src/Photo.vala"
		_g_object_unref0 (backing);
#line 3770 "../src/Photo.vala"
		return NULL;
#line 27327 "Photo.c"
	}
#line 3770 "../src/Photo.vala"
	_tmp27_ = _tmp21_;
#line 3770 "../src/Photo.vala"
	_tmp21_ = NULL;
#line 3770 "../src/Photo.vala"
	result = _tmp27_;
#line 3770 "../src/Photo.vala"
	_g_object_unref0 (_tmp21_);
#line 3770 "../src/Photo.vala"
	_g_free0 (editable_basename);
#line 3770 "../src/Photo.vala"
	_g_free0 (ext);
#line 3770 "../src/Photo.vala"
	_g_free0 (name);
#line 3770 "../src/Photo.vala"
	_g_object_unref0 (backing);
#line 3770 "../src/Photo.vala"
	if (file_format) {
#line 3770 "../src/Photo.vala"
		*file_format = _vala_file_format;
#line 27349 "Photo.c"
	}
#line 3770 "../src/Photo.vala"
	return result;
#line 27353 "Photo.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 3792 "../src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 27362 "Photo.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3792 "../src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 27371 "Photo.c"
}


static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     GError** error)
{
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* commandline = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp14_;
	GAppInfo* _tmp15_;
	gchar** argv = NULL;
	gchar** _tmp20_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	GPid child_pid = 0;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GPid _tmp28_ = 0;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
#line 3773 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3774 "../src/Photo.vala"
	if (file_format == PHOTO_FILE_FORMAT_RAW) {
#line 27411 "Photo.c"
		ConfigFacade* _tmp1_;
		ConfigFacade* _tmp2_;
		gchar* _tmp3_;
#line 3774 "../src/Photo.vala"
		_tmp1_ = config_facade_get_instance ();
#line 3774 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3774 "../src/Photo.vala"
		_tmp3_ = configuration_facade_get_external_raw_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3774 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3774 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 3774 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 27427 "Photo.c"
	} else {
		ConfigFacade* _tmp4_;
		ConfigFacade* _tmp5_;
		gchar* _tmp6_;
#line 3775 "../src/Photo.vala"
		_tmp4_ = config_facade_get_instance ();
#line 3775 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3775 "../src/Photo.vala"
		_tmp6_ = configuration_facade_get_external_photo_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3775 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3775 "../src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 3775 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 27444 "Photo.c"
	}
#line 3774 "../src/Photo.vala"
	_tmp7_ = g_strdup (_tmp0_);
#line 3774 "../src/Photo.vala"
	commandline = _tmp7_;
#line 3777 "../src/Photo.vala"
	_tmp8_ = commandline;
#line 3777 "../src/Photo.vala"
	if (is_string_empty (_tmp8_)) {
#line 3778 "../src/Photo.vala"
		result = FALSE;
#line 3778 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3778 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3778 "../src/Photo.vala"
		return result;
#line 27462 "Photo.c"
	}
	{
		GAppInfo* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GAppInfo* _tmp11_;
		GAppInfo* _tmp12_;
#line 3782 "../src/Photo.vala"
		_tmp10_ = commandline;
#line 3782 "../src/Photo.vala"
		_tmp11_ = g_app_info_create_from_commandline (_tmp10_, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3782 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3782 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27477 "Photo.c"
			goto __catch396_g_error;
		}
#line 3782 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3782 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3782 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3782 "../src/Photo.vala"
		app = _tmp12_;
#line 3781 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 27490 "Photo.c"
	}
	goto __finally396;
	__catch396_g_error:
	{
		GError* er = NULL;
#line 3781 "../src/Photo.vala"
		er = _inner_error0_;
#line 3781 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 3785 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3785 "../src/Photo.vala"
		app = NULL;
#line 3781 "../src/Photo.vala"
		_g_error_free0 (er);
#line 27506 "Photo.c"
	}
	__finally396:
#line 3781 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27511 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 3781 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3781 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3781 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3781 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3781 "../src/Photo.vala"
		return _tmp13_;
#line 27523 "Photo.c"
	}
#line 3788 "../src/Photo.vala"
	files = NULL;
#line 3789 "../src/Photo.vala"
	_tmp14_ = _g_object_ref0 (file);
#line 3789 "../src/Photo.vala"
	files = g_list_insert (files, _tmp14_, -1);
#line 3791 "../src/Photo.vala"
	_tmp15_ = app;
#line 3791 "../src/Photo.vala"
	if (_tmp15_ != NULL) {
#line 27535 "Photo.c"
		gboolean _tmp16_ = FALSE;
		GAppInfo* _tmp17_;
		GList* _tmp18_;
#line 3792 "../src/Photo.vala"
		_tmp17_ = app;
#line 3792 "../src/Photo.vala"
		_tmp18_ = files;
#line 3792 "../src/Photo.vala"
		_tmp16_ = g_app_info_launch (_tmp17_, _tmp18_, NULL, &_inner_error0_);
#line 3792 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27547 "Photo.c"
			gboolean _tmp19_ = FALSE;
#line 3792 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3792 "../src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3792 "../src/Photo.vala"
			_g_object_unref0 (app);
#line 3792 "../src/Photo.vala"
			_g_free0 (commandline);
#line 3792 "../src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3792 "../src/Photo.vala"
			return _tmp19_;
#line 27561 "Photo.c"
		}
#line 3792 "../src/Photo.vala"
		result = _tmp16_;
#line 3792 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3792 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3792 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3792 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3792 "../src/Photo.vala"
		return result;
#line 27575 "Photo.c"
	}
#line 3794 "../src/Photo.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 3794 "../src/Photo.vala"
	argv = _tmp20_;
#line 3794 "../src/Photo.vala"
	argv_length1 = 2;
#line 3794 "../src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3795 "../src/Photo.vala"
	_tmp21_ = argv;
#line 3795 "../src/Photo.vala"
	_tmp21__length1 = argv_length1;
#line 3795 "../src/Photo.vala"
	_tmp22_ = commandline;
#line 3795 "../src/Photo.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 3795 "../src/Photo.vala"
	_g_free0 (_tmp21_[0]);
#line 3795 "../src/Photo.vala"
	_tmp21_[0] = _tmp23_;
#line 3796 "../src/Photo.vala"
	_tmp24_ = argv;
#line 3796 "../src/Photo.vala"
	_tmp24__length1 = argv_length1;
#line 3796 "../src/Photo.vala"
	_tmp25_ = g_file_get_path (file);
#line 3796 "../src/Photo.vala"
	_g_free0 (_tmp24_[1]);
#line 3796 "../src/Photo.vala"
	_tmp24_[1] = _tmp25_;
#line 3800 "../src/Photo.vala"
	_tmp27_ = argv;
#line 3800 "../src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3800 "../src/Photo.vala"
	_tmp29_ = g_spawn_async ("/", _tmp27_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp28_, &_inner_error0_);
#line 3800 "../src/Photo.vala"
	child_pid = _tmp28_;
#line 3800 "../src/Photo.vala"
	_tmp26_ = _tmp29_;
#line 3800 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27619 "Photo.c"
		gboolean _tmp30_ = FALSE;
#line 3800 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3800 "../src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3800 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3800 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3800 "../src/Photo.vala"
		_g_free0 (commandline);
#line 3800 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3800 "../src/Photo.vala"
		return _tmp30_;
#line 27635 "Photo.c"
	}
#line 3800 "../src/Photo.vala"
	result = _tmp26_;
#line 3800 "../src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3800 "../src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3800 "../src/Photo.vala"
	_g_object_unref0 (app);
#line 3800 "../src/Photo.vala"
	_g_free0 (commandline);
#line 3800 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3800 "../src/Photo.vala"
	return result;
#line 27651 "Photo.c"
}


void
photo_open_with_raw_external_editor (Photo* self,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3810 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3811 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3811 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3811 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), &_inner_error0_);
#line 3811 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3811 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3811 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3811 "../src/Photo.vala"
		return;
#line 27678 "Photo.c"
	}
}


void
photo_open_with_external_editor (Photo* self,
                                 GError** error)
{
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GFile* _tmp23_;
	GFile* _tmp40_;
	GFileMonitor* _tmp41_;
	GFile* _tmp43_;
	GError* _inner_error0_ = NULL;
#line 3815 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3816 "../src/Photo.vala"
	current_editable_file = NULL;
#line 3817 "../src/Photo.vala"
	create_editable_file = NULL;
#line 27705 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3819 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3819 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27712 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3820 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3820 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3820 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27723 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3821 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3821 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3821 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3821 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3821 "../src/Photo.vala"
				current_editable_file = _tmp5_;
#line 27737 "Photo.c"
			}
#line 3823 "../src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3823 "../src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 27743 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3824 "../src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3824 "../src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3824 "../src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3824 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27756 "Photo.c"
					goto __finally397;
				}
#line 3824 "../src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3824 "../src/Photo.vala"
				_tmp7_ = NULL;
#line 3824 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3824 "../src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3823 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 27769 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3826 "../src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3826 "../src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3826 "../src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 27779 "Photo.c"
			}
		}
		__finally397:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp13_;
#line 3819 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3819 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27790 "Photo.c"
		}
#line 3819 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3819 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3819 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3819 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3819 "../src/Photo.vala"
			return;
#line 27802 "Photo.c"
		}
	}
#line 3831 "../src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3831 "../src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 27809 "Photo.c"
		GFile* _tmp17_;
#line 3831 "../src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3831 "../src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 27815 "Photo.c"
	} else {
#line 3831 "../src/Photo.vala"
		_tmp15_ = FALSE;
#line 27819 "Photo.c"
	}
#line 3831 "../src/Photo.vala"
	if (_tmp15_) {
#line 27823 "Photo.c"
		gboolean _tmp18_ = FALSE;
		GFile* _tmp19_;
#line 3832 "../src/Photo.vala"
		_tmp19_ = current_editable_file;
#line 3832 "../src/Photo.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 3832 "../src/Photo.vala"
			_tmp18_ = TRUE;
#line 27832 "Photo.c"
		} else {
#line 3832 "../src/Photo.vala"
			_tmp18_ = photo_has_transformations (self);
#line 27836 "Photo.c"
		}
#line 3832 "../src/Photo.vala"
		_tmp14_ = _tmp18_;
#line 27840 "Photo.c"
	} else {
#line 3831 "../src/Photo.vala"
		_tmp14_ = FALSE;
#line 27844 "Photo.c"
	}
#line 3831 "../src/Photo.vala"
	if (_tmp14_) {
#line 27848 "Photo.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 3833 "../src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3833 "../src/Photo.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 3833 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3833 "../src/Photo.vala"
		create_editable_file = _tmp21_;
#line 27859 "Photo.c"
	}
#line 3836 "../src/Photo.vala"
	_tmp23_ = create_editable_file;
#line 3836 "../src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 27865 "Photo.c"
		PhotoFileFormat _tmp24_;
#line 3836 "../src/Photo.vala"
		_tmp24_ = editable_file_format;
#line 3836 "../src/Photo.vala"
		_tmp22_ = photo_file_format_can_write (_tmp24_);
#line 27871 "Photo.c"
	} else {
#line 3836 "../src/Photo.vala"
		_tmp22_ = FALSE;
#line 27875 "Photo.c"
	}
#line 3836 "../src/Photo.vala"
	if (_tmp22_) {
#line 27879 "Photo.c"
		PhotoFileFormat _tmp36_;
		GFile* _tmp37_;
		GFile* _tmp38_;
		GFile* _tmp39_;
#line 3837 "../src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27886 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
			PhotoFileFormat _tmp27_;
#line 3840 "../src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3840 "../src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3840 "../src/Photo.vala"
			_tmp27_ = editable_file_format;
#line 3840 "../src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, _tmp27_, FALSE, TRUE, &_inner_error0_);
#line 3840 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27901 "Photo.c"
				goto __catch398_g_error;
			}
		}
		goto __finally398;
		__catch398_g_error:
		{
			GError* err = NULL;
			GError* _tmp34_;
			GError* _tmp35_;
#line 3839 "../src/Photo.vala"
			err = _inner_error0_;
#line 3839 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 27915 "Photo.c"
			{
				GFile* _tmp28_;
#line 3845 "../src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3845 "../src/Photo.vala"
				g_file_delete (_tmp28_, NULL, &_inner_error0_);
#line 3845 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27924 "Photo.c"
					goto __catch399_g_error;
				}
			}
			goto __finally399;
			__catch399_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GError* _tmp32_;
				const gchar* _tmp33_;
#line 3844 "../src/Photo.vala"
				delete_err = _inner_error0_;
#line 3844 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 3848 "../src/Photo.vala"
				_tmp29_ = create_editable_file;
#line 3848 "../src/Photo.vala"
				_tmp30_ = g_file_get_path (_tmp29_);
#line 3848 "../src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 3848 "../src/Photo.vala"
				_tmp32_ = delete_err;
#line 3848 "../src/Photo.vala"
				_tmp33_ = _tmp32_->message;
#line 3848 "../src/Photo.vala"
				g_warning ("Photo.vala:3848: Unable to delete editable file %s after export error:" \
" %s", _tmp31_, _tmp33_);
#line 3848 "../src/Photo.vala"
				_g_free0 (_tmp31_);
#line 3844 "../src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27957 "Photo.c"
			}
			__finally399:
#line 3844 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3844 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3844 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3844 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3844 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3844 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3844 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3844 "../src/Photo.vala"
				return;
#line 27976 "Photo.c"
			}
#line 3852 "../src/Photo.vala"
			_tmp34_ = err;
#line 3852 "../src/Photo.vala"
			_tmp35_ = _g_error_copy0 (_tmp34_);
#line 3852 "../src/Photo.vala"
			_inner_error0_ = _tmp35_;
#line 3852 "../src/Photo.vala"
			_g_error_free0 (err);
#line 27986 "Photo.c"
			goto __finally398;
		}
		__finally398:
#line 3839 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3839 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3839 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3839 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3839 "../src/Photo.vala"
			return;
#line 28000 "Photo.c"
		}
#line 3856 "../src/Photo.vala"
		_tmp36_ = editable_file_format;
#line 3856 "../src/Photo.vala"
		_tmp37_ = create_editable_file;
#line 3856 "../src/Photo.vala"
		photo_attach_editable (self, _tmp36_, _tmp37_, &_inner_error0_);
#line 3856 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3856 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3856 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3856 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3856 "../src/Photo.vala"
			return;
#line 28018 "Photo.c"
		}
#line 3858 "../src/Photo.vala"
		_tmp38_ = create_editable_file;
#line 3858 "../src/Photo.vala"
		_tmp39_ = _g_object_ref0 (_tmp38_);
#line 3858 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3858 "../src/Photo.vala"
		current_editable_file = _tmp39_;
#line 28028 "Photo.c"
	}
#line 3861 "../src/Photo.vala"
	_tmp40_ = current_editable_file;
#line 3861 "../src/Photo.vala"
	_vala_assert (_tmp40_ != NULL, "current_editable_file != null");
#line 3864 "../src/Photo.vala"
	_tmp41_ = self->priv->editable_monitor;
#line 3864 "../src/Photo.vala"
	if (_tmp41_ == NULL) {
#line 28038 "Photo.c"
		GFile* _tmp42_;
#line 3865 "../src/Photo.vala"
		_tmp42_ = current_editable_file;
#line 3865 "../src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp42_, &_inner_error0_);
#line 3865 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3865 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3865 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3865 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3865 "../src/Photo.vala"
			return;
#line 28054 "Photo.c"
		}
	}
#line 3867 "../src/Photo.vala"
	_tmp43_ = current_editable_file;
#line 3867 "../src/Photo.vala"
	photo_launch_editor (_tmp43_, photo_get_file_format (self), &_inner_error0_);
#line 3867 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3867 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3867 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3867 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3867 "../src/Photo.vala"
		return;
#line 28071 "Photo.c"
	}
#line 3815 "../src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3815 "../src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 28077 "Photo.c"
}


void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3870 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3871 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 28089 "Photo.c"
}


static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3881 "../src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 28102 "Photo.c"
}


static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3874 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3874 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3875 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3878 "../src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3880 "../src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3880 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3880 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3880 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3880 "../src/Photo.vala"
		return;
#line 28134 "Photo.c"
	}
#line 3880 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3880 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3880 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3880 "../src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3881 "../src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3881 "../src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3874 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 28150 "Photo.c"
}


static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3884 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3885 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3885 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3886 "../src/Photo.vala"
		return;
#line 28172 "Photo.c"
	}
#line 3889 "../src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3889 "../src/Photo.vala"
	file = _tmp1_;
#line 3890 "../src/Photo.vala"
	_tmp2_ = file;
#line 3890 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 28182 "Photo.c"
		GFile* _tmp3_;
#line 3891 "../src/Photo.vala"
		_tmp3_ = file;
#line 3891 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 28188 "Photo.c"
	}
#line 3893 "../src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3893 "../src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3893 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3894 "../src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3894 "../src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3895 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3895 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3884 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 28206 "Photo.c"
}


static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3898 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3898 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3903 "../src/Photo.vala"
	photo_remove_all_transformations (self, FALSE);
#line 3904 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3904 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3904 "../src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3904 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3904 "../src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3904 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3904 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3904 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3904 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3904 "../src/Photo.vala"
		return;
#line 28247 "Photo.c"
	}
}


static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3907 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3908 "../src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3908 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3908 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3908 "../src/Photo.vala"
		return;
#line 28267 "Photo.c"
	}
}


void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3911 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3912 "../src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3912 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3912 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3912 "../src/Photo.vala"
		return;
#line 28287 "Photo.c"
	}
}


static void
_vala_array_add104 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4019 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4019 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4019 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28304 "Photo.c"
	}
#line 4019 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4019 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28310 "Photo.c"
}


static void
_vala_array_add105 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4020 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4020 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4020 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28326 "Photo.c"
	}
#line 4020 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4020 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28332 "Photo.c"
}


static void
_vala_array_add106 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4023 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4023 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4023 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28348 "Photo.c"
	}
#line 4023 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4023 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28354 "Photo.c"
}


static void
_vala_array_add107 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4027 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4027 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4027 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28370 "Photo.c"
	}
#line 4027 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4027 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28376 "Photo.c"
}


static void
_vala_array_add108 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4028 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4028 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4028 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28392 "Photo.c"
	}
#line 4028 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4028 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28398 "Photo.c"
}


static void
_vala_array_add109 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4031 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4031 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4031 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28414 "Photo.c"
	}
#line 4031 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4031 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 28420 "Photo.c"
}


static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp87_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp96_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp97_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	GError* _inner_error0_ = NULL;
#line 3917 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3917 "../src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3919 "../src/Photo.vala"
	if (only_attributes) {
#line 3919 "../src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 28470 "Photo.c"
	} else {
#line 3919 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 28474 "Photo.c"
	}
#line 3919 "../src/Photo.vala"
	if (_tmp1_) {
#line 3919 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 28480 "Photo.c"
	} else {
#line 3919 "../src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 28484 "Photo.c"
	}
#line 3919 "../src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3921 "../src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3921 "../src/Photo.vala"
	old_reader = _tmp2_;
#line 3923 "../src/Photo.vala"
	_tmp3_ = new_reader;
#line 3923 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 28496 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3923 "../src/Photo.vala"
		_tmp4_ = old_reader;
#line 3923 "../src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 28502 "Photo.c"
	}
#line 3923 "../src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3923 "../src/Photo.vala"
	reader = _tmp5_;
#line 3924 "../src/Photo.vala"
	_tmp6_ = reader;
#line 3924 "../src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3925 "../src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3927 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3927 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3927 "../src/Photo.vala"
		return;
#line 28520 "Photo.c"
	}
#line 3930 "../src/Photo.vala"
	timestamp_changed = FALSE;
#line 3931 "../src/Photo.vala"
	filesize_changed = FALSE;
#line 3932 "../src/Photo.vala"
	is_new_editable = FALSE;
#line 3934 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3934 "../src/Photo.vala"
	editable_id = _tmp7_;
#line 3935 "../src/Photo.vala"
	_tmp8_ = reader;
#line 3935 "../src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3935 "../src/Photo.vala"
	file = _tmp9_;
#line 3938 "../src/Photo.vala"
	_tmp10_ = file;
#line 3938 "../src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3938 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3938 "../src/Photo.vala"
	detected = _tmp11_;
#line 3938 "../src/Photo.vala"
	backing = _tmp12_;
#line 3938 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3938 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3938 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3938 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 3938 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3938 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3938 "../src/Photo.vala"
		return;
#line 28562 "Photo.c"
	}
#line 3942 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 28566 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3944 "../src/Photo.vala"
		_tmp13_ = backing;
#line 3944 "../src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 28572 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3945 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3945 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3945 "../src/Photo.vala"
			_tmp16_ = backing;
#line 3945 "../src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3945 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3945 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3945 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3945 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3945 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3945 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3945 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3945 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3945 "../src/Photo.vala"
				return;
#line 28602 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3946 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 3946 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28610 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
					Orientation _tmp28_;
#line 3947 "../src/Photo.vala"
					timestamp_changed = TRUE;
#line 3948 "../src/Photo.vala"
					filesize_changed = TRUE;
#line 3950 "../src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3950 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3950 "../src/Photo.vala"
					_tmp20_ = self->row;
#line 3950 "../src/Photo.vala"
					_tmp21_ = backing;
#line 3950 "../src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3950 "../src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3950 "../src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3950 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28643 "Photo.c"
						goto __finally400;
					}
#line 3951 "../src/Photo.vala"
					_tmp23_ = backing;
#line 3951 "../src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3951 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3951 "../src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3952 "../src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3952 "../src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3952 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3952 "../src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3953 "../src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3953 "../src/Photo.vala"
					_tmp28_ = _tmp27_->original_orientation;
#line 3953 "../src/Photo.vala"
					photo_set_orientation (self, _tmp28_);
#line 28668 "Photo.c"
				}
				__finally400:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp29_;
#line 3946 "../src/Photo.vala"
					_tmp29_ = self->row;
#line 3946 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28678 "Photo.c"
				}
#line 3946 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3946 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3946 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3946 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3946 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3946 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3946 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3946 "../src/Photo.vala"
					return;
#line 28696 "Photo.c"
				}
			}
		}
#line 3956 "../src/Photo.vala"
		is_new_editable = TRUE;
#line 28702 "Photo.c"
	}
#line 3959 "../src/Photo.vala"
	if (only_attributes) {
#line 28706 "Photo.c"
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp38_;
		GTimeVal _tmp39_ = {0};
		BackingPhotoTable* _tmp40_;
		BackingPhotoTable* _tmp41_;
		BackingPhotoID _tmp42_;
		GTimeVal _tmp43_;
		glong _tmp44_;
		GFileInfo* _tmp45_;
#line 3961 "../src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid()");
#line 28719 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 3965 "../src/Photo.vala"
			_tmp31_ = file;
#line 3965 "../src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 3965 "../src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 3965 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28733 "Photo.c"
				goto __catch401_g_error;
			}
#line 3965 "../src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 3965 "../src/Photo.vala"
			_tmp30_ = NULL;
#line 3965 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3965 "../src/Photo.vala"
			info = _tmp33_;
#line 3964 "../src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 28746 "Photo.c"
		}
		goto __finally401;
		__catch401_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3964 "../src/Photo.vala"
			err = _inner_error0_;
#line 3964 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3967 "../src/Photo.vala"
			_tmp34_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3967 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 3967 "../src/Photo.vala"
			_tmp36_ = err;
#line 3967 "../src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 3967 "../src/Photo.vala"
			g_warning ("Photo.vala:3967: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 3967 "../src/Photo.vala"
			_g_free0 (_tmp35_);
#line 3968 "../src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3970 "../src/Photo.vala"
			_g_error_free0 (err);
#line 3970 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3970 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3970 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3970 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 3970 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3970 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3970 "../src/Photo.vala"
			return;
#line 28790 "Photo.c"
		}
		__finally401:
#line 3964 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3964 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3964 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3964 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3964 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3964 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 3964 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3964 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3964 "../src/Photo.vala"
			return;
#line 28811 "Photo.c"
		}
#line 3973 "../src/Photo.vala"
		_tmp38_ = info;
#line 3973 "../src/Photo.vala"
		g_file_info_get_modification_time (_tmp38_, &_tmp39_);
#line 3973 "../src/Photo.vala"
		timestamp = _tmp39_;
#line 3975 "../src/Photo.vala"
		_tmp40_ = backing_photo_table_get_instance ();
#line 3975 "../src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 3975 "../src/Photo.vala"
		_tmp42_ = editable_id;
#line 3975 "../src/Photo.vala"
		_tmp43_ = timestamp;
#line 3975 "../src/Photo.vala"
		_tmp44_ = _tmp43_.tv_sec;
#line 3975 "../src/Photo.vala"
		_tmp45_ = info;
#line 3975 "../src/Photo.vala"
		backing_photo_table_update_attributes (_tmp41_, &_tmp42_, (time_t) _tmp44_, g_file_info_get_size (_tmp45_), &_inner_error0_);
#line 3975 "../src/Photo.vala"
		_database_table_unref0 (_tmp41_);
#line 3975 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3975 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3975 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3975 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3975 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3975 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 3975 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3975 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3975 "../src/Photo.vala"
			return;
#line 28853 "Photo.c"
		}
		{
			PhotoRow* _tmp46_;
#line 3977 "../src/Photo.vala"
			_tmp46_ = self->row;
#line 3977 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 28861 "Photo.c"
			{
				BackingPhotoRow* _tmp47_;
				time_t _tmp48_;
				GTimeVal _tmp49_;
				glong _tmp50_;
				BackingPhotoRow* _tmp51_;
				gint64 _tmp52_;
				GFileInfo* _tmp53_;
				BackingPhotoRow* _tmp54_;
				GTimeVal _tmp55_;
				glong _tmp56_;
				BackingPhotoRow* _tmp57_;
				GFileInfo* _tmp58_;
#line 3978 "../src/Photo.vala"
				_tmp47_ = self->priv->editable;
#line 3978 "../src/Photo.vala"
				_tmp48_ = _tmp47_->timestamp;
#line 3978 "../src/Photo.vala"
				_tmp49_ = timestamp;
#line 3978 "../src/Photo.vala"
				_tmp50_ = _tmp49_.tv_sec;
#line 3978 "../src/Photo.vala"
				timestamp_changed = _tmp48_ != ((time_t) _tmp50_);
#line 3979 "../src/Photo.vala"
				_tmp51_ = self->priv->editable;
#line 3979 "../src/Photo.vala"
				_tmp52_ = _tmp51_->filesize;
#line 3979 "../src/Photo.vala"
				_tmp53_ = info;
#line 3979 "../src/Photo.vala"
				filesize_changed = _tmp52_ != g_file_info_get_size (_tmp53_);
#line 3981 "../src/Photo.vala"
				_tmp54_ = self->priv->editable;
#line 3981 "../src/Photo.vala"
				_tmp55_ = timestamp;
#line 3981 "../src/Photo.vala"
				_tmp56_ = _tmp55_.tv_sec;
#line 3981 "../src/Photo.vala"
				_tmp54_->timestamp = (time_t) _tmp56_;
#line 3982 "../src/Photo.vala"
				_tmp57_ = self->priv->editable;
#line 3982 "../src/Photo.vala"
				_tmp58_ = info;
#line 3982 "../src/Photo.vala"
				_tmp57_->filesize = g_file_info_get_size (_tmp58_);
#line 28907 "Photo.c"
			}
			__finally402:
			{
				PhotoRow* _tmp59_;
#line 3977 "../src/Photo.vala"
				_tmp59_ = self->row;
#line 3977 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28916 "Photo.c"
			}
#line 3977 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3977 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3977 "../src/Photo.vala"
				_g_object_unref0 (info);
#line 3977 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3977 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3977 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3977 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3977 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3977 "../src/Photo.vala"
				return;
#line 28936 "Photo.c"
			}
		}
#line 3959 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 28941 "Photo.c"
	} else {
		gboolean _tmp60_ = FALSE;
#line 3986 "../src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 28946 "Photo.c"
			gboolean _tmp61_;
#line 3986 "../src/Photo.vala"
			_tmp61_ = is_new_editable;
#line 3986 "../src/Photo.vala"
			_tmp60_ = !_tmp61_;
#line 28952 "Photo.c"
		} else {
#line 3986 "../src/Photo.vala"
			_tmp60_ = FALSE;
#line 28956 "Photo.c"
		}
#line 3986 "../src/Photo.vala"
		if (_tmp60_) {
#line 28960 "Photo.c"
			BackingPhotoRow* _tmp62_;
			BackingPhotoID _tmp63_;
			BackingPhotoTable* _tmp64_;
			BackingPhotoTable* _tmp65_;
			BackingPhotoRow* _tmp66_;
#line 3991 "../src/Photo.vala"
			_tmp62_ = backing;
#line 3991 "../src/Photo.vala"
			_tmp63_ = editable_id;
#line 3991 "../src/Photo.vala"
			_tmp62_->id = _tmp63_;
#line 3992 "../src/Photo.vala"
			_tmp64_ = backing_photo_table_get_instance ();
#line 3992 "../src/Photo.vala"
			_tmp65_ = _tmp64_;
#line 3992 "../src/Photo.vala"
			_tmp66_ = backing;
#line 3992 "../src/Photo.vala"
			backing_photo_table_update (_tmp65_, _tmp66_, &_inner_error0_);
#line 3992 "../src/Photo.vala"
			_database_table_unref0 (_tmp65_);
#line 3992 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3992 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3992 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3992 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3992 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3992 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3992 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3992 "../src/Photo.vala"
				return;
#line 28998 "Photo.c"
			}
			{
				PhotoRow* _tmp67_;
#line 3993 "../src/Photo.vala"
				_tmp67_ = self->row;
#line 3993 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 29006 "Photo.c"
				{
					BackingPhotoRow* _tmp68_;
					time_t _tmp69_;
					BackingPhotoRow* _tmp70_;
					time_t _tmp71_;
					BackingPhotoRow* _tmp72_;
					gint64 _tmp73_;
					BackingPhotoRow* _tmp74_;
					gint64 _tmp75_;
					BackingPhotoRow* _tmp76_;
					BackingPhotoRow* _tmp77_;
					BackingPhotoRow* _tmp78_;
					BackingPhotoRow* _tmp79_;
					BackingPhotoRow* _tmp80_;
					Orientation _tmp81_;
#line 3994 "../src/Photo.vala"
					_tmp68_ = self->priv->editable;
#line 3994 "../src/Photo.vala"
					_tmp69_ = _tmp68_->timestamp;
#line 3994 "../src/Photo.vala"
					_tmp70_ = backing;
#line 3994 "../src/Photo.vala"
					_tmp71_ = _tmp70_->timestamp;
#line 3994 "../src/Photo.vala"
					timestamp_changed = _tmp69_ != _tmp71_;
#line 3995 "../src/Photo.vala"
					_tmp72_ = self->priv->editable;
#line 3995 "../src/Photo.vala"
					_tmp73_ = _tmp72_->filesize;
#line 3995 "../src/Photo.vala"
					_tmp74_ = backing;
#line 3995 "../src/Photo.vala"
					_tmp75_ = _tmp74_->filesize;
#line 3995 "../src/Photo.vala"
					filesize_changed = _tmp73_ != _tmp75_;
#line 3997 "../src/Photo.vala"
					_tmp76_ = backing;
#line 3997 "../src/Photo.vala"
					_tmp77_ = _backing_photo_row_ref0 (_tmp76_);
#line 3997 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3997 "../src/Photo.vala"
					self->priv->editable = _tmp77_;
#line 3998 "../src/Photo.vala"
					_tmp78_ = self->priv->editable;
#line 3998 "../src/Photo.vala"
					_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 3998 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3998 "../src/Photo.vala"
					self->backing_photo_row = _tmp79_;
#line 3999 "../src/Photo.vala"
					_tmp80_ = self->backing_photo_row;
#line 3999 "../src/Photo.vala"
					_tmp81_ = _tmp80_->original_orientation;
#line 3999 "../src/Photo.vala"
					photo_set_orientation (self, _tmp81_);
#line 29064 "Photo.c"
				}
				__finally403:
				{
					PhotoRow* _tmp82_;
#line 3993 "../src/Photo.vala"
					_tmp82_ = self->row;
#line 3993 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29073 "Photo.c"
				}
#line 3993 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3993 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3993 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3993 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3993 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3993 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3993 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3993 "../src/Photo.vala"
					return;
#line 29091 "Photo.c"
				}
			}
		}
	}
#line 4005 "../src/Photo.vala"
	if (new_reader != NULL) {
#line 29098 "Photo.c"
		{
			PhotoBackingReaders* _tmp83_;
#line 4006 "../src/Photo.vala"
			_tmp83_ = self->priv->readers;
#line 4006 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29105 "Photo.c"
			{
				PhotoBackingReaders* _tmp84_;
				PhotoFileReader* _tmp85_;
#line 4007 "../src/Photo.vala"
				_tmp84_ = self->priv->readers;
#line 4007 "../src/Photo.vala"
				_tmp85_ = _photo_file_adapter_ref0 (new_reader);
#line 4007 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp84_->editable);
#line 4007 "../src/Photo.vala"
				_tmp84_->editable = _tmp85_;
#line 29117 "Photo.c"
			}
			__finally404:
			{
				PhotoBackingReaders* _tmp86_;
#line 4006 "../src/Photo.vala"
				_tmp86_ = self->priv->readers;
#line 4006 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29126 "Photo.c"
			}
#line 4006 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4006 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4006 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4006 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4006 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4006 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4006 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4006 "../src/Photo.vala"
				return;
#line 29144 "Photo.c"
			}
		}
	}
#line 4011 "../src/Photo.vala"
	if (!only_attributes) {
#line 29150 "Photo.c"
		PhotoFileReader* _tmp88_;
		PhotoFileReader* _tmp89_;
#line 4011 "../src/Photo.vala"
		_tmp88_ = reader;
#line 4011 "../src/Photo.vala"
		_tmp89_ = old_reader;
#line 4011 "../src/Photo.vala"
		_tmp87_ = _tmp88_ != _tmp89_;
#line 29159 "Photo.c"
	} else {
#line 4011 "../src/Photo.vala"
		_tmp87_ = FALSE;
#line 29163 "Photo.c"
	}
#line 4011 "../src/Photo.vala"
	if (_tmp87_) {
#line 29167 "Photo.c"
		GFile* _tmp90_ = NULL;
		PhotoFileReader* _tmp91_;
		GFile* _tmp94_ = NULL;
#line 4012 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4013 "../src/Photo.vala"
		_tmp91_ = old_reader;
#line 4013 "../src/Photo.vala"
		if (_tmp91_ != NULL) {
#line 29177 "Photo.c"
			PhotoFileReader* _tmp92_;
			GFile* _tmp93_;
#line 4013 "../src/Photo.vala"
			_tmp92_ = old_reader;
#line 4013 "../src/Photo.vala"
			_tmp93_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4013 "../src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4013 "../src/Photo.vala"
			_tmp90_ = _tmp93_;
#line 29188 "Photo.c"
		} else {
#line 4013 "../src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4013 "../src/Photo.vala"
			_tmp90_ = NULL;
#line 29194 "Photo.c"
		}
#line 4014 "../src/Photo.vala"
		if (new_reader != NULL) {
#line 29198 "Photo.c"
			GFile* _tmp95_;
#line 4014 "../src/Photo.vala"
			_tmp95_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (new_reader, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4014 "../src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 4014 "../src/Photo.vala"
			_tmp94_ = _tmp95_;
#line 29206 "Photo.c"
		} else {
#line 4014 "../src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 4014 "../src/Photo.vala"
			_tmp94_ = NULL;
#line 29212 "Photo.c"
		}
#line 4013 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp90_, _tmp94_);
#line 4011 "../src/Photo.vala"
		_g_object_unref0 (_tmp94_);
#line 4011 "../src/Photo.vala"
		_g_object_unref0 (_tmp90_);
#line 29220 "Photo.c"
	}
#line 4017 "../src/Photo.vala"
	_tmp96_ = g_new0 (gchar*, 0 + 1);
#line 4017 "../src/Photo.vala"
	alteration_list = _tmp96_;
#line 4017 "../src/Photo.vala"
	alteration_list_length1 = 0;
#line 4017 "../src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4018 "../src/Photo.vala"
	_tmp97_ = timestamp_changed;
#line 4018 "../src/Photo.vala"
	if (_tmp97_) {
#line 29234 "Photo.c"
		gchar** _tmp98_;
		gint _tmp98__length1;
		gchar* _tmp99_;
		gchar** _tmp100_;
		gint _tmp100__length1;
		gchar* _tmp101_;
#line 4019 "../src/Photo.vala"
		_tmp98_ = alteration_list;
#line 4019 "../src/Photo.vala"
		_tmp98__length1 = alteration_list_length1;
#line 4019 "../src/Photo.vala"
		_tmp99_ = g_strdup ("metadata:editable-timestamp");
#line 4019 "../src/Photo.vala"
		_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp99_);
#line 4020 "../src/Photo.vala"
		_tmp100_ = alteration_list;
#line 4020 "../src/Photo.vala"
		_tmp100__length1 = alteration_list_length1;
#line 4020 "../src/Photo.vala"
		_tmp101_ = g_strdup ("metadata:baseline-timestamp");
#line 4020 "../src/Photo.vala"
		_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp101_);
#line 4022 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29259 "Photo.c"
			gchar** _tmp102_;
			gint _tmp102__length1;
			gchar* _tmp103_;
#line 4023 "../src/Photo.vala"
			_tmp102_ = alteration_list;
#line 4023 "../src/Photo.vala"
			_tmp102__length1 = alteration_list_length1;
#line 4023 "../src/Photo.vala"
			_tmp103_ = g_strdup ("metadata:source-timestamp");
#line 4023 "../src/Photo.vala"
			_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp103_);
#line 29271 "Photo.c"
		}
	}
#line 4026 "../src/Photo.vala"
	_tmp105_ = filesize_changed;
#line 4026 "../src/Photo.vala"
	if (_tmp105_) {
#line 4026 "../src/Photo.vala"
		_tmp104_ = TRUE;
#line 29280 "Photo.c"
	} else {
#line 4026 "../src/Photo.vala"
		_tmp104_ = new_reader != NULL;
#line 29284 "Photo.c"
	}
#line 4026 "../src/Photo.vala"
	if (_tmp104_) {
#line 29288 "Photo.c"
		gchar** _tmp106_;
		gint _tmp106__length1;
		gchar* _tmp107_;
		gchar** _tmp108_;
		gint _tmp108__length1;
		gchar* _tmp109_;
#line 4027 "../src/Photo.vala"
		_tmp106_ = alteration_list;
#line 4027 "../src/Photo.vala"
		_tmp106__length1 = alteration_list_length1;
#line 4027 "../src/Photo.vala"
		_tmp107_ = g_strdup ("image:editable");
#line 4027 "../src/Photo.vala"
		_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp107_);
#line 4028 "../src/Photo.vala"
		_tmp108_ = alteration_list;
#line 4028 "../src/Photo.vala"
		_tmp108__length1 = alteration_list_length1;
#line 4028 "../src/Photo.vala"
		_tmp109_ = g_strdup ("image:baseline");
#line 4028 "../src/Photo.vala"
		_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp109_);
#line 4030 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29313 "Photo.c"
			gchar** _tmp110_;
			gint _tmp110__length1;
			gchar* _tmp111_;
#line 4031 "../src/Photo.vala"
			_tmp110_ = alteration_list;
#line 4031 "../src/Photo.vala"
			_tmp110__length1 = alteration_list_length1;
#line 4031 "../src/Photo.vala"
			_tmp111_ = g_strdup ("image:source");
#line 4031 "../src/Photo.vala"
			_vala_array_add109 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp111_);
#line 29325 "Photo.c"
		}
	}
#line 4034 "../src/Photo.vala"
	_tmp112_ = alteration_list;
#line 4034 "../src/Photo.vala"
	_tmp112__length1 = alteration_list_length1;
#line 4034 "../src/Photo.vala"
	if (_tmp112__length1 > 0) {
#line 29334 "Photo.c"
		gchar** _tmp113_;
		gint _tmp113__length1;
		Alteration* _tmp114_;
		Alteration* _tmp115_;
#line 4035 "../src/Photo.vala"
		_tmp113_ = alteration_list;
#line 4035 "../src/Photo.vala"
		_tmp113__length1 = alteration_list_length1;
#line 4035 "../src/Photo.vala"
		_tmp114_ = alteration_new_from_array (_tmp113_, _tmp113__length1);
#line 4035 "../src/Photo.vala"
		_tmp115_ = _tmp114_;
#line 4035 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp115_);
#line 4035 "../src/Photo.vala"
		_alteration_unref0 (_tmp115_);
#line 29351 "Photo.c"
	}
#line 3917 "../src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3917 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3917 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3917 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3917 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3917 "../src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 29365 "Photo.c"
}


static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp8_;
	gboolean _tmp26_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_;
	GError* _inner_error0_ = NULL;
#line 4038 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4039 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4041 "../src/Photo.vala"
	has_editable = FALSE;
#line 4042 "../src/Photo.vala"
	editable_file = NULL;
#line 29392 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4043 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4043 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29399 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4044 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4044 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4044 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 29409 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4045 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4045 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4045 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4045 "../src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4045 "../src/Photo.vala"
				editable_file = _tmp5_;
#line 4046 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4046 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4046 "../src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4047 "../src/Photo.vala"
				has_editable = TRUE;
#line 29432 "Photo.c"
			}
		}
		__finally405:
		{
			PhotoBackingReaders* _tmp7_;
#line 4043 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4043 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29442 "Photo.c"
		}
#line 4043 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4043 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4043 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4043 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4043 "../src/Photo.vala"
			return;
#line 29454 "Photo.c"
		}
	}
#line 4051 "../src/Photo.vala"
	_tmp8_ = has_editable;
#line 4051 "../src/Photo.vala"
	if (_tmp8_) {
#line 29461 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4052 "../src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 29465 "Photo.c"
		{
			{
				PhotoRow* _tmp9_;
#line 4054 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 4054 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 29473 "Photo.c"
				{
					PhotoRow* _tmp10_;
					BackingPhotoID _tmp11_;
					PhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
					BackingPhotoRow* _tmp17_;
#line 4055 "../src/Photo.vala"
					_tmp10_ = self->row;
#line 4055 "../src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 4055 "../src/Photo.vala"
					editable_id = _tmp11_;
#line 4056 "../src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 29488 "Photo.c"
						PhotoTable* _tmp12_;
						PhotoTable* _tmp13_;
						PhotoRow* _tmp14_;
#line 4057 "../src/Photo.vala"
						_tmp12_ = photo_table_get_instance ();
#line 4057 "../src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 4057 "../src/Photo.vala"
						_tmp14_ = self->row;
#line 4057 "../src/Photo.vala"
						photo_table_detach_editable (_tmp13_, _tmp14_, &_inner_error0_);
#line 4057 "../src/Photo.vala"
						_database_table_unref0 (_tmp13_);
#line 4057 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29504 "Photo.c"
							goto __finally407;
						}
					}
#line 4058 "../src/Photo.vala"
					_tmp15_ = self->row;
#line 4058 "../src/Photo.vala"
					_tmp16_ = _tmp15_->master;
#line 4058 "../src/Photo.vala"
					_tmp17_ = _backing_photo_row_ref0 (_tmp16_);
#line 4058 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4058 "../src/Photo.vala"
					self->backing_photo_row = _tmp17_;
#line 29518 "Photo.c"
				}
				__finally407:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp18_;
#line 4054 "../src/Photo.vala"
					_tmp18_ = self->row;
#line 4054 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29528 "Photo.c"
				}
#line 4054 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4054 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 29534 "Photo.c"
						goto __catch406_database_error;
					}
#line 4054 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4054 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4054 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4054 "../src/Photo.vala"
					return;
#line 29545 "Photo.c"
				}
			}
		}
		goto __finally406;
		__catch406_database_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 4053 "../src/Photo.vala"
			err = _inner_error0_;
#line 4053 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4061 "../src/Photo.vala"
			_tmp19_ = err;
#line 4061 "../src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 4061 "../src/Photo.vala"
			g_warning ("Photo.vala:4061: Unable to remove editable from PhotoTable: %s", _tmp20_);
#line 4053 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29567 "Photo.c"
		}
		__finally406:
#line 4053 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4053 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4053 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4053 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4053 "../src/Photo.vala"
			return;
#line 29580 "Photo.c"
		}
		{
#line 4065 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 29585 "Photo.c"
				BackingPhotoTable* _tmp21_;
				BackingPhotoTable* _tmp22_;
				BackingPhotoID _tmp23_;
#line 4066 "../src/Photo.vala"
				_tmp21_ = backing_photo_table_get_instance ();
#line 4066 "../src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 4066 "../src/Photo.vala"
				_tmp23_ = editable_id;
#line 4066 "../src/Photo.vala"
				backing_photo_table_remove (_tmp22_, &_tmp23_, &_inner_error0_);
#line 4066 "../src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 4066 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4066 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 29603 "Photo.c"
						goto __catch408_database_error;
					}
#line 4066 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4066 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4066 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4066 "../src/Photo.vala"
					return;
#line 29614 "Photo.c"
				}
			}
		}
		goto __finally408;
		__catch408_database_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 4064 "../src/Photo.vala"
			err = _inner_error0_;
#line 4064 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4068 "../src/Photo.vala"
			_tmp24_ = err;
#line 4068 "../src/Photo.vala"
			_tmp25_ = _tmp24_->message;
#line 4068 "../src/Photo.vala"
			g_warning ("Photo.vala:4068: Unable to remove editable from BackingPhotoTable: %s", _tmp25_);
#line 4064 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29636 "Photo.c"
		}
		__finally408:
#line 4064 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4064 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4064 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4064 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4064 "../src/Photo.vala"
			return;
#line 29649 "Photo.c"
		}
	}
#line 4072 "../src/Photo.vala"
	if (remove_transformations) {
#line 4073 "../src/Photo.vala"
		photo_remove_all_transformations (self, FALSE);
#line 29656 "Photo.c"
	}
#line 4075 "../src/Photo.vala"
	_tmp26_ = has_editable;
#line 4075 "../src/Photo.vala"
	if (_tmp26_) {
#line 29662 "Photo.c"
		GFile* _tmp27_;
#line 4076 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4077 "../src/Photo.vala"
		_tmp27_ = editable_file;
#line 4077 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp27_, NULL);
#line 29670 "Photo.c"
	}
#line 4080 "../src/Photo.vala"
	if (delete_editable) {
#line 29674 "Photo.c"
		GFile* _tmp29_;
#line 4080 "../src/Photo.vala"
		_tmp29_ = editable_file;
#line 4080 "../src/Photo.vala"
		_tmp28_ = _tmp29_ != NULL;
#line 29680 "Photo.c"
	} else {
#line 4080 "../src/Photo.vala"
		_tmp28_ = FALSE;
#line 29684 "Photo.c"
	}
#line 4080 "../src/Photo.vala"
	if (_tmp28_) {
#line 29688 "Photo.c"
		{
			GFile* _tmp30_;
#line 4082 "../src/Photo.vala"
			_tmp30_ = editable_file;
#line 4082 "../src/Photo.vala"
			g_file_trash (_tmp30_, NULL, &_inner_error0_);
#line 4082 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29697 "Photo.c"
				goto __catch409_g_error;
			}
		}
		goto __finally409;
		__catch409_g_error:
		{
			GError* err = NULL;
			GFile* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 4081 "../src/Photo.vala"
			err = _inner_error0_;
#line 4081 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4084 "../src/Photo.vala"
			_tmp31_ = editable_file;
#line 4084 "../src/Photo.vala"
			_tmp32_ = g_file_get_path (_tmp31_);
#line 4084 "../src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 4084 "../src/Photo.vala"
			_tmp34_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4084 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 4084 "../src/Photo.vala"
			_tmp36_ = err;
#line 4084 "../src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 4084 "../src/Photo.vala"
			g_warning ("Photo.vala:4084: Unable to trash editable %s for %s: %s", _tmp33_, _tmp35_, _tmp37_);
#line 4084 "../src/Photo.vala"
			_g_free0 (_tmp35_);
#line 4084 "../src/Photo.vala"
			_g_free0 (_tmp33_);
#line 4081 "../src/Photo.vala"
			_g_error_free0 (err);
#line 29738 "Photo.c"
		}
		__finally409:
#line 4081 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4081 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4081 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4081 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4081 "../src/Photo.vala"
			return;
#line 29751 "Photo.c"
		}
	}
#line 4089 "../src/Photo.vala"
	_tmp40_ = has_editable;
#line 4089 "../src/Photo.vala"
	if (_tmp40_) {
#line 4089 "../src/Photo.vala"
		_tmp39_ = TRUE;
#line 29760 "Photo.c"
	} else {
#line 4089 "../src/Photo.vala"
		_tmp39_ = remove_transformations;
#line 29764 "Photo.c"
	}
#line 4089 "../src/Photo.vala"
	if (_tmp39_) {
#line 4089 "../src/Photo.vala"
		_tmp38_ = notify;
#line 29770 "Photo.c"
	} else {
#line 4089 "../src/Photo.vala"
		_tmp38_ = FALSE;
#line 29774 "Photo.c"
	}
#line 4089 "../src/Photo.vala"
	if (_tmp38_) {
#line 29778 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 4090 "../src/Photo.vala"
		_tmp41_ = alteration_new ("image", "revert");
#line 4090 "../src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 4090 "../src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp42_);
#line 4090 "../src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 29789 "Photo.c"
	}
#line 4038 "../src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29793 "Photo.c"
}


static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4112 "../src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 29802 "Photo.c"
}


static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4121 "../src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 29811 "Photo.c"
}


static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4130 "../src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 29820 "Photo.c"
}


static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 4093 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4093 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 4093 "../src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 29840 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4095 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4095 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29847 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp3_;
			PhotoFileReader* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			gboolean _tmp7_;
#line 4096 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4096 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4096 "../src/Photo.vala"
			_vala_assert (_tmp2_ != NULL, "readers.editable != null");
#line 4098 "../src/Photo.vala"
			_tmp3_ = self->priv->readers;
#line 4098 "../src/Photo.vala"
			_tmp4_ = _tmp3_->editable;
#line 4098 "../src/Photo.vala"
			_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4098 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 4098 "../src/Photo.vala"
			_tmp7_ = !g_file_equal (file, _tmp6_);
#line 4098 "../src/Photo.vala"
			_g_object_unref0 (_tmp6_);
#line 4098 "../src/Photo.vala"
			if (_tmp7_) {
#line 29876 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_;
#line 4095 "../src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 4095 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29883 "Photo.c"
				}
#line 4102 "../src/Photo.vala"
				return;
#line 29887 "Photo.c"
			}
		}
		__finally410:
		{
			PhotoBackingReaders* _tmp9_;
#line 4095 "../src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 4095 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29897 "Photo.c"
		}
#line 4095 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4095 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4095 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4095 "../src/Photo.vala"
			return;
#line 29907 "Photo.c"
		}
	}
#line 4106 "../src/Photo.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4106 "../src/Photo.vala"
	_tmp11_ = g_file_get_path (file);
#line 4106 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 4106 "../src/Photo.vala"
	g_debug ("Photo.vala:4106: EDITABLE %s: %s", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, _tmp12_);
#line 4106 "../src/Photo.vala"
	_g_free0 (_tmp12_);
#line 4108 "../src/Photo.vala"
	switch (event) {
#line 4108 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4108 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29926 "Photo.c"
		{
			OneShotScheduler* _tmp13_;
			OneShotScheduler* _tmp15_;
#line 4111 "../src/Photo.vala"
			_tmp13_ = self->priv->reimport_editable_scheduler;
#line 4111 "../src/Photo.vala"
			if (_tmp13_ == NULL) {
#line 29934 "Photo.c"
				OneShotScheduler* _tmp14_;
#line 4112 "../src/Photo.vala"
				_tmp14_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4112 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4112 "../src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp14_;
#line 29942 "Photo.c"
			}
#line 4116 "../src/Photo.vala"
			_tmp15_ = self->priv->reimport_editable_scheduler;
#line 4116 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp15_, (guint) 1000, TRUE);
#line 4117 "../src/Photo.vala"
			break;
#line 29950 "Photo.c"
		}
#line 4108 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29954 "Photo.c"
		{
			OneShotScheduler* _tmp16_;
			OneShotScheduler* _tmp18_;
#line 4120 "../src/Photo.vala"
			_tmp16_ = self->priv->update_editable_attributes_scheduler;
#line 4120 "../src/Photo.vala"
			if (_tmp16_ == NULL) {
#line 29962 "Photo.c"
				OneShotScheduler* _tmp17_;
#line 4121 "../src/Photo.vala"
				_tmp17_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4121 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4121 "../src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp17_;
#line 29970 "Photo.c"
			}
#line 4125 "../src/Photo.vala"
			_tmp18_ = self->priv->update_editable_attributes_scheduler;
#line 4125 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp18_, (guint) 1000, TRUE);
#line 4126 "../src/Photo.vala"
			break;
#line 29978 "Photo.c"
		}
#line 4108 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29982 "Photo.c"
		{
			OneShotScheduler* _tmp19_;
			OneShotScheduler* _tmp21_;
#line 4129 "../src/Photo.vala"
			_tmp19_ = self->priv->remove_editable_scheduler;
#line 4129 "../src/Photo.vala"
			if (_tmp19_ == NULL) {
#line 29990 "Photo.c"
				OneShotScheduler* _tmp20_;
#line 4130 "../src/Photo.vala"
				_tmp20_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4130 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4130 "../src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp20_;
#line 29998 "Photo.c"
			}
#line 4134 "../src/Photo.vala"
			_tmp21_ = self->priv->remove_editable_scheduler;
#line 4134 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp21_, (guint) 3000, TRUE);
#line 4135 "../src/Photo.vala"
			break;
#line 30006 "Photo.c"
		}
		default:
#line 4108 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 30011 "Photo.c"
		{
#line 4140 "../src/Photo.vala"
			break;
#line 30015 "Photo.c"
		}
	}
#line 4145 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 30020 "Photo.c"
}


static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4148 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4150 "../src/Photo.vala"
	photo_discard_prefetched (self);
#line 4152 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4152 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4152 "../src/Photo.vala"
	g_debug ("Photo.vala:4152: Reimporting editable for %s", _tmp1_);
#line 4152 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 30042 "Photo.c"
	{
#line 4154 "../src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4154 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30048 "Photo.c"
			goto __catch411_g_error;
		}
	}
	goto __finally411;
	__catch411_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4153 "../src/Photo.vala"
		err = _inner_error0_;
#line 4153 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4156 "../src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4156 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4156 "../src/Photo.vala"
		_tmp4_ = err;
#line 4156 "../src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4156 "../src/Photo.vala"
		g_warning ("Photo.vala:4156: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4156 "../src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4153 "../src/Photo.vala"
		_g_error_free0 (err);
#line 30078 "Photo.c"
	}
	__finally411:
#line 4153 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4153 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4153 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4153 "../src/Photo.vala"
		return;
#line 30089 "Photo.c"
	}
}


static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4161 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4162 "../src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4162 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4162 "../src/Photo.vala"
	g_debug ("Photo.vala:4162: Updating editable attributes for %s", _tmp1_);
#line 4162 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 30110 "Photo.c"
	{
#line 4164 "../src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4164 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30116 "Photo.c"
			goto __catch412_g_error;
		}
	}
	goto __finally412;
	__catch412_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4163 "../src/Photo.vala"
		err = _inner_error0_;
#line 4163 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4166 "../src/Photo.vala"
		_tmp2_ = err;
#line 4166 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4166 "../src/Photo.vala"
		g_warning ("Photo.vala:4166: Unable to update editable attributes: %s", _tmp3_);
#line 4163 "../src/Photo.vala"
		_g_error_free0 (err);
#line 30138 "Photo.c"
	}
	__finally412:
#line 4163 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4163 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4163 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4163 "../src/Photo.vala"
		return;
#line 30149 "Photo.c"
	}
}


static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4170 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4171 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4171 "../src/Photo.vala"
	reader = _tmp0_;
#line 4172 "../src/Photo.vala"
	_tmp1_ = reader;
#line 4172 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4173 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4173 "../src/Photo.vala"
		return;
#line 30180 "Photo.c"
	}
#line 4175 "../src/Photo.vala"
	_tmp2_ = reader;
#line 4175 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4175 "../src/Photo.vala"
	file = _tmp3_;
#line 4176 "../src/Photo.vala"
	_tmp4_ = file;
#line 4176 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 30192 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4177 "../src/Photo.vala"
		_tmp5_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4177 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4177 "../src/Photo.vala"
		g_debug ("Photo.vala:4177: Not removing editable for %s: file exists", _tmp6_);
#line 4177 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4179 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 4179 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4179 "../src/Photo.vala"
		return;
#line 30209 "Photo.c"
	}
#line 4182 "../src/Photo.vala"
	_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4182 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4182 "../src/Photo.vala"
	g_debug ("Photo.vala:4182: Removing editable for %s: file no longer exists", _tmp8_);
#line 4182 "../src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4183 "../src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4170 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 4170 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 30225 "Photo.c"
}


void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4191 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4192 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4192 "../src/Photo.vala"
	dim = _tmp0_;
#line 4193 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4195 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4195 "../src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4195 "../src/Photo.vala"
	*result = _tmp2_;
#line 4195 "../src/Photo.vala"
	return;
#line 30254 "Photo.c"
}


void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4199 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4200 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4200 "../src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4200 "../src/Photo.vala"
	*result = _tmp1_;
#line 4200 "../src/Photo.vala"
	return;
#line 30274 "Photo.c"
}


gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
#line 4204 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4206 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4206 "../src/Photo.vala"
	raw = _tmp0_;
#line 4206 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4207 "../src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4209 "../src/Photo.vala"
		result = FALSE;
#line 4209 "../src/Photo.vala"
		if (crop) {
#line 4209 "../src/Photo.vala"
			*crop = _vala_crop;
#line 30307 "Photo.c"
		}
#line 4209 "../src/Photo.vala"
		return result;
#line 30311 "Photo.c"
	}
#line 4212 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4212 "../src/Photo.vala"
	dim = _tmp2_;
#line 4213 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4215 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 30321 "Photo.c"
		Orientation _tmp3_;
		Dimensions _tmp4_;
		Box _tmp5_;
		Box _tmp6_ = {0};
#line 4216 "../src/Photo.vala"
		_tmp3_ = orientation;
#line 4216 "../src/Photo.vala"
		_tmp4_ = dim;
#line 4216 "../src/Photo.vala"
		_tmp5_ = raw;
#line 4216 "../src/Photo.vala"
		orientation_rotate_box (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 4216 "../src/Photo.vala"
		_vala_crop = _tmp6_;
#line 30336 "Photo.c"
	} else {
		Box _tmp7_;
#line 4218 "../src/Photo.vala"
		_tmp7_ = raw;
#line 4218 "../src/Photo.vala"
		_vala_crop = _tmp7_;
#line 30343 "Photo.c"
	}
#line 4220 "../src/Photo.vala"
	result = TRUE;
#line 4220 "../src/Photo.vala"
	if (crop) {
#line 4220 "../src/Photo.vala"
		*crop = _vala_crop;
#line 30351 "Photo.c"
	}
#line 4220 "../src/Photo.vala"
	return result;
#line 30355 "Photo.c"
}


void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	gint _tmp5_;
	Dimensions _tmp6_;
	gint _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	Box _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	Box _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	Box _tmp18_;
	gint _tmp19_;
	Box _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Box _tmp24_;
#line 4224 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4224 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4225 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4225 "../src/Photo.vala"
	dim = _tmp0_;
#line 4226 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4228 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4228 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 4228 "../src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4228 "../src/Photo.vala"
	derotated = _tmp3_;
#line 4230 "../src/Photo.vala"
	_tmp4_ = derotated;
#line 4230 "../src/Photo.vala"
	_tmp5_ = _tmp4_.left;
#line 4230 "../src/Photo.vala"
	_tmp6_ = dim;
#line 4230 "../src/Photo.vala"
	_tmp7_ = _tmp6_.width;
#line 4230 "../src/Photo.vala"
	derotated.left = CLAMP (_tmp5_, 0, _tmp7_ - 2);
#line 4231 "../src/Photo.vala"
	_tmp8_ = derotated;
#line 4231 "../src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 4231 "../src/Photo.vala"
	_tmp10_ = derotated;
#line 4231 "../src/Photo.vala"
	_tmp11_ = _tmp10_.left;
#line 4231 "../src/Photo.vala"
	_tmp12_ = dim;
#line 4231 "../src/Photo.vala"
	_tmp13_ = _tmp12_.width;
#line 4231 "../src/Photo.vala"
	derotated.right = CLAMP (_tmp9_, _tmp11_, _tmp13_ - 1);
#line 4233 "../src/Photo.vala"
	_tmp14_ = derotated;
#line 4233 "../src/Photo.vala"
	_tmp15_ = _tmp14_.top;
#line 4233 "../src/Photo.vala"
	_tmp16_ = dim;
#line 4233 "../src/Photo.vala"
	_tmp17_ = _tmp16_.height;
#line 4233 "../src/Photo.vala"
	derotated.top = CLAMP (_tmp15_, 0, _tmp17_ - 2);
#line 4234 "../src/Photo.vala"
	_tmp18_ = derotated;
#line 4234 "../src/Photo.vala"
	_tmp19_ = _tmp18_.bottom;
#line 4234 "../src/Photo.vala"
	_tmp20_ = derotated;
#line 4234 "../src/Photo.vala"
	_tmp21_ = _tmp20_.top;
#line 4234 "../src/Photo.vala"
	_tmp22_ = dim;
#line 4234 "../src/Photo.vala"
	_tmp23_ = _tmp22_.height;
#line 4234 "../src/Photo.vala"
	derotated.bottom = CLAMP (_tmp19_, _tmp21_, _tmp23_ - 1);
#line 4236 "../src/Photo.vala"
	_tmp24_ = derotated;
#line 4236 "../src/Photo.vala"
	photo_set_raw_crop (self, &_tmp24_);
#line 30461 "Photo.c"
}


gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 4239 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4240 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4240 "../src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4240 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4241 "../src/Photo.vala"
		result = FALSE;
#line 4241 "../src/Photo.vala"
		if (theta) {
#line 4241 "../src/Photo.vala"
			*theta = _vala_theta;
#line 30487 "Photo.c"
		}
#line 4241 "../src/Photo.vala"
		return result;
#line 30491 "Photo.c"
	}
#line 4243 "../src/Photo.vala"
	result = TRUE;
#line 4243 "../src/Photo.vala"
	if (theta) {
#line 4243 "../src/Photo.vala"
		*theta = _vala_theta;
#line 30499 "Photo.c"
	}
#line 4243 "../src/Photo.vala"
	return result;
#line 30503 "Photo.c"
}


void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4246 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4247 "../src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 30515 "Photo.c"
}


static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint _tmp1_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	EditingToolsRedeyeInstance _tmp22_;
	gint _tmp23_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp24_;
	GdkPoint _tmp25_;
	gint _tmp26_;
	EditingToolsRedeyeInstance _tmp27_;
	gint _tmp28_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp29_;
	GdkPoint _tmp30_;
	gint _tmp31_;
	EditingToolsRedeyeInstance _tmp32_;
	gint _tmp33_;
	gint _tmp34_ = 0;
	gint _tmp35_;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	gint _tmp40_ = 0;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp80_;
	GdkPoint _tmp81_;
	gint _tmp82_;
	EditingToolsRedeyeInstance _tmp83_;
	GdkPoint _tmp84_;
	gint _tmp85_;
	EditingToolsRedeyeInstance _tmp86_;
	gint _tmp87_;
	gint* _tmp88_;
	gint _tmp88__length1;
	GdkPixbuf* _tmp122_;
#line 4250 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4250 "../src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 4250 "../src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4260 "../src/Photo.vala"
	_tmp0_ = *inst;
#line 4260 "../src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4260 "../src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4261 "../src/Photo.vala"
	_tmp2_ = *inst;
#line 4261 "../src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4261 "../src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4261 "../src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4261 "../src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4261 "../src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4263 "../src/Photo.vala"
	i = 0;
#line 30601 "Photo.c"
	{
		gdouble y = 0.0;
		gdouble _tmp5_;
#line 4264 "../src/Photo.vala"
		_tmp5_ = r;
#line 4264 "../src/Photo.vala"
		y = _tmp5_;
#line 30609 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
#line 4264 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 4264 "../src/Photo.vala"
			while (TRUE) {
#line 30616 "Photo.c"
				gdouble _tmp8_;
				gdouble theta = 0.0;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gint x = 0;
				gdouble _tmp11_;
				gdouble _tmp12_;
				gint* _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				EditingToolsRedeyeInstance _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 4264 "../src/Photo.vala"
				if (!_tmp6_) {
#line 30633 "Photo.c"
					gdouble _tmp7_;
#line 4264 "../src/Photo.vala"
					_tmp7_ = y;
#line 4264 "../src/Photo.vala"
					y = _tmp7_ - 1.0;
#line 30639 "Photo.c"
				}
#line 4264 "../src/Photo.vala"
				_tmp6_ = FALSE;
#line 4264 "../src/Photo.vala"
				_tmp8_ = y;
#line 4264 "../src/Photo.vala"
				if (!(_tmp8_ >= 0.0)) {
#line 4264 "../src/Photo.vala"
					break;
#line 30649 "Photo.c"
				}
#line 4265 "../src/Photo.vala"
				_tmp9_ = y;
#line 4265 "../src/Photo.vala"
				_tmp10_ = r;
#line 4265 "../src/Photo.vala"
				theta = asin (_tmp9_ / _tmp10_);
#line 4266 "../src/Photo.vala"
				_tmp11_ = r;
#line 4266 "../src/Photo.vala"
				_tmp12_ = theta;
#line 4266 "../src/Photo.vala"
				x = (gint) ((_tmp11_ * cos (_tmp12_)) + 0.5);
#line 4267 "../src/Photo.vala"
				_tmp13_ = x_insets_first_quadrant;
#line 4267 "../src/Photo.vala"
				_tmp13__length1 = x_insets_first_quadrant_length1;
#line 4267 "../src/Photo.vala"
				_tmp14_ = i;
#line 4267 "../src/Photo.vala"
				_tmp15_ = *inst;
#line 4267 "../src/Photo.vala"
				_tmp16_ = _tmp15_.radius;
#line 4267 "../src/Photo.vala"
				_tmp17_ = x;
#line 4267 "../src/Photo.vala"
				_tmp13_[_tmp14_] = _tmp16_ - _tmp17_;
#line 4269 "../src/Photo.vala"
				_tmp18_ = i;
#line 4269 "../src/Photo.vala"
				i = _tmp18_ + 1;
#line 30681 "Photo.c"
			}
		}
	}
#line 4272 "../src/Photo.vala"
	_tmp19_ = *inst;
#line 4272 "../src/Photo.vala"
	_tmp20_ = _tmp19_.center;
#line 4272 "../src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4272 "../src/Photo.vala"
	_tmp22_ = *inst;
#line 4272 "../src/Photo.vala"
	_tmp23_ = _tmp22_.radius;
#line 4272 "../src/Photo.vala"
	x_bounds_min = _tmp21_ - _tmp23_;
#line 4273 "../src/Photo.vala"
	_tmp24_ = *inst;
#line 4273 "../src/Photo.vala"
	_tmp25_ = _tmp24_.center;
#line 4273 "../src/Photo.vala"
	_tmp26_ = _tmp25_.x;
#line 4273 "../src/Photo.vala"
	_tmp27_ = *inst;
#line 4273 "../src/Photo.vala"
	_tmp28_ = _tmp27_.radius;
#line 4273 "../src/Photo.vala"
	x_bounds_max = _tmp26_ + _tmp28_;
#line 4274 "../src/Photo.vala"
	_tmp29_ = *inst;
#line 4274 "../src/Photo.vala"
	_tmp30_ = _tmp29_.center;
#line 4274 "../src/Photo.vala"
	_tmp31_ = _tmp30_.y;
#line 4274 "../src/Photo.vala"
	_tmp32_ = *inst;
#line 4274 "../src/Photo.vala"
	_tmp33_ = _tmp32_.radius;
#line 4274 "../src/Photo.vala"
	ymin = _tmp31_ - _tmp33_;
#line 4275 "../src/Photo.vala"
	_tmp35_ = ymin;
#line 4275 "../src/Photo.vala"
	if (_tmp35_ < 0) {
#line 4275 "../src/Photo.vala"
		_tmp34_ = 0;
#line 30727 "Photo.c"
	} else {
		gint _tmp36_;
#line 4275 "../src/Photo.vala"
		_tmp36_ = ymin;
#line 4275 "../src/Photo.vala"
		_tmp34_ = _tmp36_;
#line 30734 "Photo.c"
	}
#line 4275 "../src/Photo.vala"
	ymin = _tmp34_;
#line 4276 "../src/Photo.vala"
	_tmp37_ = *inst;
#line 4276 "../src/Photo.vala"
	_tmp38_ = _tmp37_.center;
#line 4276 "../src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4276 "../src/Photo.vala"
	ymax = _tmp39_;
#line 4277 "../src/Photo.vala"
	_tmp41_ = ymax;
#line 4277 "../src/Photo.vala"
	_tmp42_ = gdk_pixbuf_get_height (pixbuf);
#line 4277 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 4277 "../src/Photo.vala"
	if (_tmp41_ > (_tmp43_ - 1)) {
#line 30754 "Photo.c"
		gint _tmp44_;
		gint _tmp45_;
#line 4277 "../src/Photo.vala"
		_tmp44_ = gdk_pixbuf_get_height (pixbuf);
#line 4277 "../src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 4277 "../src/Photo.vala"
		_tmp40_ = _tmp45_ - 1;
#line 30763 "Photo.c"
	} else {
		gint _tmp46_;
#line 4277 "../src/Photo.vala"
		_tmp46_ = ymax;
#line 4277 "../src/Photo.vala"
		_tmp40_ = _tmp46_;
#line 30770 "Photo.c"
	}
#line 4277 "../src/Photo.vala"
	ymax = _tmp40_;
#line 4281 "../src/Photo.vala"
	inset_index = 0;
#line 30776 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp47_;
#line 4282 "../src/Photo.vala"
		_tmp47_ = ymin;
#line 4282 "../src/Photo.vala"
		y_it = _tmp47_;
#line 30784 "Photo.c"
		{
			gboolean _tmp48_ = FALSE;
#line 4282 "../src/Photo.vala"
			_tmp48_ = TRUE;
#line 4282 "../src/Photo.vala"
			while (TRUE) {
#line 30791 "Photo.c"
				gint _tmp50_;
				gint _tmp51_;
				gint xmin = 0;
				gint _tmp52_;
				gint* _tmp53_;
				gint _tmp53__length1;
				gint _tmp54_;
				gint _tmp55_;
				gint _tmp56_ = 0;
				gint _tmp57_;
				gint xmax = 0;
				gint _tmp59_;
				gint* _tmp60_;
				gint _tmp60__length1;
				gint _tmp61_;
				gint _tmp62_;
				gint _tmp63_ = 0;
				gint _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
				gint _tmp79_;
#line 4282 "../src/Photo.vala"
				if (!_tmp48_) {
#line 30815 "Photo.c"
					gint _tmp49_;
#line 4282 "../src/Photo.vala"
					_tmp49_ = y_it;
#line 4282 "../src/Photo.vala"
					y_it = _tmp49_ + 1;
#line 30821 "Photo.c"
				}
#line 4282 "../src/Photo.vala"
				_tmp48_ = FALSE;
#line 4282 "../src/Photo.vala"
				_tmp50_ = y_it;
#line 4282 "../src/Photo.vala"
				_tmp51_ = ymax;
#line 4282 "../src/Photo.vala"
				if (!(_tmp50_ <= _tmp51_)) {
#line 4282 "../src/Photo.vala"
					break;
#line 30833 "Photo.c"
				}
#line 4283 "../src/Photo.vala"
				_tmp52_ = x_bounds_min;
#line 4283 "../src/Photo.vala"
				_tmp53_ = x_insets_first_quadrant;
#line 4283 "../src/Photo.vala"
				_tmp53__length1 = x_insets_first_quadrant_length1;
#line 4283 "../src/Photo.vala"
				_tmp54_ = inset_index;
#line 4283 "../src/Photo.vala"
				_tmp55_ = _tmp53_[_tmp54_];
#line 4283 "../src/Photo.vala"
				xmin = _tmp52_ + _tmp55_;
#line 4284 "../src/Photo.vala"
				_tmp57_ = xmin;
#line 4284 "../src/Photo.vala"
				if (_tmp57_ < 0) {
#line 4284 "../src/Photo.vala"
					_tmp56_ = 0;
#line 30853 "Photo.c"
				} else {
					gint _tmp58_;
#line 4284 "../src/Photo.vala"
					_tmp58_ = xmin;
#line 4284 "../src/Photo.vala"
					_tmp56_ = _tmp58_;
#line 30860 "Photo.c"
				}
#line 4284 "../src/Photo.vala"
				xmin = _tmp56_;
#line 4285 "../src/Photo.vala"
				_tmp59_ = x_bounds_max;
#line 4285 "../src/Photo.vala"
				_tmp60_ = x_insets_first_quadrant;
#line 4285 "../src/Photo.vala"
				_tmp60__length1 = x_insets_first_quadrant_length1;
#line 4285 "../src/Photo.vala"
				_tmp61_ = inset_index;
#line 4285 "../src/Photo.vala"
				_tmp62_ = _tmp60_[_tmp61_];
#line 4285 "../src/Photo.vala"
				xmax = _tmp59_ - _tmp62_;
#line 4286 "../src/Photo.vala"
				_tmp64_ = xmax;
#line 4286 "../src/Photo.vala"
				_tmp65_ = gdk_pixbuf_get_width (pixbuf);
#line 4286 "../src/Photo.vala"
				_tmp66_ = _tmp65_;
#line 4286 "../src/Photo.vala"
				if (_tmp64_ > (_tmp66_ - 1)) {
#line 30884 "Photo.c"
					gint _tmp67_;
					gint _tmp68_;
#line 4286 "../src/Photo.vala"
					_tmp67_ = gdk_pixbuf_get_width (pixbuf);
#line 4286 "../src/Photo.vala"
					_tmp68_ = _tmp67_;
#line 4286 "../src/Photo.vala"
					_tmp63_ = _tmp68_ - 1;
#line 30893 "Photo.c"
				} else {
					gint _tmp69_;
#line 4286 "../src/Photo.vala"
					_tmp69_ = xmax;
#line 4286 "../src/Photo.vala"
					_tmp63_ = _tmp69_;
#line 30900 "Photo.c"
				}
#line 4286 "../src/Photo.vala"
				xmax = _tmp63_;
#line 30904 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp70_;
#line 4288 "../src/Photo.vala"
					_tmp70_ = xmin;
#line 4288 "../src/Photo.vala"
					x_it = _tmp70_;
#line 30912 "Photo.c"
					{
						gboolean _tmp71_ = FALSE;
#line 4288 "../src/Photo.vala"
						_tmp71_ = TRUE;
#line 4288 "../src/Photo.vala"
						while (TRUE) {
#line 30919 "Photo.c"
							gint _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							GdkPixbuf* _tmp77_;
							GdkPixbuf* _tmp78_;
#line 4288 "../src/Photo.vala"
							if (!_tmp71_) {
#line 30928 "Photo.c"
								gint _tmp72_;
#line 4288 "../src/Photo.vala"
								_tmp72_ = x_it;
#line 4288 "../src/Photo.vala"
								x_it = _tmp72_ + 1;
#line 30934 "Photo.c"
							}
#line 4288 "../src/Photo.vala"
							_tmp71_ = FALSE;
#line 4288 "../src/Photo.vala"
							_tmp73_ = x_it;
#line 4288 "../src/Photo.vala"
							_tmp74_ = xmax;
#line 4288 "../src/Photo.vala"
							if (!(_tmp73_ <= _tmp74_)) {
#line 4288 "../src/Photo.vala"
								break;
#line 30946 "Photo.c"
							}
#line 4289 "../src/Photo.vala"
							_tmp75_ = x_it;
#line 4289 "../src/Photo.vala"
							_tmp76_ = y_it;
#line 4289 "../src/Photo.vala"
							_tmp77_ = photo_red_reduce_pixel (self, pixbuf, _tmp75_, _tmp76_);
#line 4289 "../src/Photo.vala"
							_tmp78_ = _tmp77_;
#line 4289 "../src/Photo.vala"
							_g_object_unref0 (_tmp78_);
#line 30958 "Photo.c"
						}
					}
				}
#line 4291 "../src/Photo.vala"
				_tmp79_ = inset_index;
#line 4291 "../src/Photo.vala"
				inset_index = _tmp79_ + 1;
#line 30966 "Photo.c"
			}
		}
	}
#line 4296 "../src/Photo.vala"
	_tmp80_ = *inst;
#line 4296 "../src/Photo.vala"
	_tmp81_ = _tmp80_.center;
#line 4296 "../src/Photo.vala"
	_tmp82_ = _tmp81_.y;
#line 4296 "../src/Photo.vala"
	ymin = _tmp82_;
#line 4297 "../src/Photo.vala"
	_tmp83_ = *inst;
#line 4297 "../src/Photo.vala"
	_tmp84_ = _tmp83_.center;
#line 4297 "../src/Photo.vala"
	_tmp85_ = _tmp84_.y;
#line 4297 "../src/Photo.vala"
	_tmp86_ = *inst;
#line 4297 "../src/Photo.vala"
	_tmp87_ = _tmp86_.radius;
#line 4297 "../src/Photo.vala"
	ymax = _tmp85_ + _tmp87_;
#line 4298 "../src/Photo.vala"
	_tmp88_ = x_insets_first_quadrant;
#line 4298 "../src/Photo.vala"
	_tmp88__length1 = x_insets_first_quadrant_length1;
#line 4298 "../src/Photo.vala"
	inset_index = _tmp88__length1 - 1;
#line 30996 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp89_;
#line 4299 "../src/Photo.vala"
		_tmp89_ = ymin;
#line 4299 "../src/Photo.vala"
		y_it = _tmp89_;
#line 31004 "Photo.c"
		{
			gboolean _tmp90_ = FALSE;
#line 4299 "../src/Photo.vala"
			_tmp90_ = TRUE;
#line 4299 "../src/Photo.vala"
			while (TRUE) {
#line 31011 "Photo.c"
				gint _tmp92_;
				gint _tmp93_;
				gint xmin = 0;
				gint _tmp94_;
				gint* _tmp95_;
				gint _tmp95__length1;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_ = 0;
				gint _tmp99_;
				gint xmax = 0;
				gint _tmp101_;
				gint* _tmp102_;
				gint _tmp102__length1;
				gint _tmp103_;
				gint _tmp104_;
				gint _tmp105_ = 0;
				gint _tmp106_;
				gint _tmp107_;
				gint _tmp108_;
				gint _tmp121_;
#line 4299 "../src/Photo.vala"
				if (!_tmp90_) {
#line 31035 "Photo.c"
					gint _tmp91_;
#line 4299 "../src/Photo.vala"
					_tmp91_ = y_it;
#line 4299 "../src/Photo.vala"
					y_it = _tmp91_ + 1;
#line 31041 "Photo.c"
				}
#line 4299 "../src/Photo.vala"
				_tmp90_ = FALSE;
#line 4299 "../src/Photo.vala"
				_tmp92_ = y_it;
#line 4299 "../src/Photo.vala"
				_tmp93_ = ymax;
#line 4299 "../src/Photo.vala"
				if (!(_tmp92_ <= _tmp93_)) {
#line 4299 "../src/Photo.vala"
					break;
#line 31053 "Photo.c"
				}
#line 4300 "../src/Photo.vala"
				_tmp94_ = x_bounds_min;
#line 4300 "../src/Photo.vala"
				_tmp95_ = x_insets_first_quadrant;
#line 4300 "../src/Photo.vala"
				_tmp95__length1 = x_insets_first_quadrant_length1;
#line 4300 "../src/Photo.vala"
				_tmp96_ = inset_index;
#line 4300 "../src/Photo.vala"
				_tmp97_ = _tmp95_[_tmp96_];
#line 4300 "../src/Photo.vala"
				xmin = _tmp94_ + _tmp97_;
#line 4301 "../src/Photo.vala"
				_tmp99_ = xmin;
#line 4301 "../src/Photo.vala"
				if (_tmp99_ < 0) {
#line 4301 "../src/Photo.vala"
					_tmp98_ = 0;
#line 31073 "Photo.c"
				} else {
					gint _tmp100_;
#line 4301 "../src/Photo.vala"
					_tmp100_ = xmin;
#line 4301 "../src/Photo.vala"
					_tmp98_ = _tmp100_;
#line 31080 "Photo.c"
				}
#line 4301 "../src/Photo.vala"
				xmin = _tmp98_;
#line 4302 "../src/Photo.vala"
				_tmp101_ = x_bounds_max;
#line 4302 "../src/Photo.vala"
				_tmp102_ = x_insets_first_quadrant;
#line 4302 "../src/Photo.vala"
				_tmp102__length1 = x_insets_first_quadrant_length1;
#line 4302 "../src/Photo.vala"
				_tmp103_ = inset_index;
#line 4302 "../src/Photo.vala"
				_tmp104_ = _tmp102_[_tmp103_];
#line 4302 "../src/Photo.vala"
				xmax = _tmp101_ - _tmp104_;
#line 4303 "../src/Photo.vala"
				_tmp106_ = xmax;
#line 4303 "../src/Photo.vala"
				_tmp107_ = gdk_pixbuf_get_width (pixbuf);
#line 4303 "../src/Photo.vala"
				_tmp108_ = _tmp107_;
#line 4303 "../src/Photo.vala"
				if (_tmp106_ > (_tmp108_ - 1)) {
#line 31104 "Photo.c"
					gint _tmp109_;
					gint _tmp110_;
#line 4303 "../src/Photo.vala"
					_tmp109_ = gdk_pixbuf_get_width (pixbuf);
#line 4303 "../src/Photo.vala"
					_tmp110_ = _tmp109_;
#line 4303 "../src/Photo.vala"
					_tmp105_ = _tmp110_ - 1;
#line 31113 "Photo.c"
				} else {
					gint _tmp111_;
#line 4303 "../src/Photo.vala"
					_tmp111_ = xmax;
#line 4303 "../src/Photo.vala"
					_tmp105_ = _tmp111_;
#line 31120 "Photo.c"
				}
#line 4303 "../src/Photo.vala"
				xmax = _tmp105_;
#line 31124 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp112_;
#line 4305 "../src/Photo.vala"
					_tmp112_ = xmin;
#line 4305 "../src/Photo.vala"
					x_it = _tmp112_;
#line 31132 "Photo.c"
					{
						gboolean _tmp113_ = FALSE;
#line 4305 "../src/Photo.vala"
						_tmp113_ = TRUE;
#line 4305 "../src/Photo.vala"
						while (TRUE) {
#line 31139 "Photo.c"
							gint _tmp115_;
							gint _tmp116_;
							gint _tmp117_;
							gint _tmp118_;
							GdkPixbuf* _tmp119_;
							GdkPixbuf* _tmp120_;
#line 4305 "../src/Photo.vala"
							if (!_tmp113_) {
#line 31148 "Photo.c"
								gint _tmp114_;
#line 4305 "../src/Photo.vala"
								_tmp114_ = x_it;
#line 4305 "../src/Photo.vala"
								x_it = _tmp114_ + 1;
#line 31154 "Photo.c"
							}
#line 4305 "../src/Photo.vala"
							_tmp113_ = FALSE;
#line 4305 "../src/Photo.vala"
							_tmp115_ = x_it;
#line 4305 "../src/Photo.vala"
							_tmp116_ = xmax;
#line 4305 "../src/Photo.vala"
							if (!(_tmp115_ <= _tmp116_)) {
#line 4305 "../src/Photo.vala"
								break;
#line 31166 "Photo.c"
							}
#line 4306 "../src/Photo.vala"
							_tmp117_ = x_it;
#line 4306 "../src/Photo.vala"
							_tmp118_ = y_it;
#line 4306 "../src/Photo.vala"
							_tmp119_ = photo_red_reduce_pixel (self, pixbuf, _tmp117_, _tmp118_);
#line 4306 "../src/Photo.vala"
							_tmp120_ = _tmp119_;
#line 4306 "../src/Photo.vala"
							_g_object_unref0 (_tmp120_);
#line 31178 "Photo.c"
						}
					}
				}
#line 4308 "../src/Photo.vala"
				_tmp121_ = inset_index;
#line 4308 "../src/Photo.vala"
				inset_index = _tmp121_ - 1;
#line 31186 "Photo.c"
			}
		}
	}
#line 4311 "../src/Photo.vala"
	_tmp122_ = _g_object_ref0 (pixbuf);
#line 4311 "../src/Photo.vala"
	result = _tmp122_;
#line 4311 "../src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4311 "../src/Photo.vala"
	return result;
#line 31198 "Photo.c"
}


static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp19_;
#line 4314 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4314 "../src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 4315 "../src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4322 "../src/Photo.vala"
	if (x >= 0) {
#line 4322 "../src/Photo.vala"
		_tmp2_ = y >= 0;
#line 31224 "Photo.c"
	} else {
#line 4322 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 31228 "Photo.c"
	}
#line 4322 "../src/Photo.vala"
	if (_tmp2_) {
#line 31232 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4322 "../src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4322 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4322 "../src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 31241 "Photo.c"
	} else {
#line 4322 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 31245 "Photo.c"
	}
#line 4322 "../src/Photo.vala"
	if (_tmp1_) {
#line 31249 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4322 "../src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4322 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4322 "../src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 31258 "Photo.c"
	} else {
#line 4322 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 31262 "Photo.c"
	}
#line 4322 "../src/Photo.vala"
	if (_tmp0_) {
#line 31266 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_;
		guchar _tmp10_;
		guchar b = '\0';
		guchar* _tmp11_;
		gint _tmp11__length1;
		gint _tmp12_;
		guchar _tmp13_;
		guchar r = '\0';
		guchar _tmp14_;
		guchar _tmp15_;
		guchar* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		guchar _tmp18_;
#line 4323 "../src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4323 "../src/Photo.vala"
		pixel_data = _tmp7_;
#line 4323 "../src/Photo.vala"
		pixel_data_length1 = -1;
#line 4323 "../src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4333 "../src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4333 "../src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4333 "../src/Photo.vala"
		_tmp9_ = px_start_byte_offset;
#line 4333 "../src/Photo.vala"
		_tmp10_ = _tmp8_[_tmp9_ + 1];
#line 4333 "../src/Photo.vala"
		g = _tmp10_;
#line 4334 "../src/Photo.vala"
		_tmp11_ = pixel_data;
#line 4334 "../src/Photo.vala"
		_tmp11__length1 = pixel_data_length1;
#line 4334 "../src/Photo.vala"
		_tmp12_ = px_start_byte_offset;
#line 4334 "../src/Photo.vala"
		_tmp13_ = _tmp11_[_tmp12_ + 2];
#line 4334 "../src/Photo.vala"
		b = _tmp13_;
#line 4336 "../src/Photo.vala"
		_tmp14_ = g;
#line 4336 "../src/Photo.vala"
		_tmp15_ = b;
#line 4336 "../src/Photo.vala"
		r = (guchar) ((_tmp14_ + _tmp15_) / 2);
#line 4338 "../src/Photo.vala"
		_tmp16_ = pixel_data;
#line 4338 "../src/Photo.vala"
		_tmp16__length1 = pixel_data_length1;
#line 4338 "../src/Photo.vala"
		_tmp17_ = px_start_byte_offset;
#line 4338 "../src/Photo.vala"
		_tmp18_ = r;
#line 4338 "../src/Photo.vala"
		_tmp16_[_tmp17_] = _tmp18_;
#line 31332 "Photo.c"
	}
#line 4341 "../src/Photo.vala"
	_tmp19_ = _g_object_ref0 (pixbuf);
#line 4341 "../src/Photo.vala"
	result = _tmp19_;
#line 4341 "../src/Photo.vala"
	return result;
#line 31340 "Photo.c"
}


void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp3_ = {0};
	gboolean _tmp4_;
	GdkPoint derotated_point = {0};
	Orientation _tmp9_;
	Dimensions _tmp10_;
	GdkPoint _tmp11_;
	GdkPoint _tmp12_ = {0};
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 4344 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4344 "../src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4345 "../src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4347 "../src/Photo.vala"
	_tmp0_ = unscaled_orientation;
#line 4347 "../src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 4347 "../src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4347 "../src/Photo.vala"
	unscaled_dims = _tmp2_;
#line 4350 "../src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4351 "../src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4354 "../src/Photo.vala"
	_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 4354 "../src/Photo.vala"
	crop_box = _tmp3_;
#line 4354 "../src/Photo.vala"
	if (_tmp4_) {
#line 31392 "Photo.c"
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 4355 "../src/Photo.vala"
		_tmp5_ = crop_box;
#line 4355 "../src/Photo.vala"
		_tmp6_ = _tmp5_.left;
#line 4355 "../src/Photo.vala"
		unscaled_x_offset_raw = _tmp6_;
#line 4356 "../src/Photo.vala"
		_tmp7_ = crop_box;
#line 4356 "../src/Photo.vala"
		_tmp8_ = _tmp7_.top;
#line 4356 "../src/Photo.vala"
		unscaled_y_offset_raw = _tmp8_;
#line 31409 "Photo.c"
	}
#line 4359 "../src/Photo.vala"
	_tmp9_ = unscaled_orientation;
#line 4359 "../src/Photo.vala"
	_tmp10_ = unscaled_dims;
#line 4359 "../src/Photo.vala"
	_tmp11_ = *unscaled_point;
#line 4359 "../src/Photo.vala"
	orientation_derotate_point (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 4359 "../src/Photo.vala"
	derotated_point = _tmp12_;
#line 4363 "../src/Photo.vala"
	_tmp13_ = derotated_point.x;
#line 4363 "../src/Photo.vala"
	_tmp14_ = unscaled_x_offset_raw;
#line 4363 "../src/Photo.vala"
	derotated_point.x = _tmp13_ + _tmp14_;
#line 4364 "../src/Photo.vala"
	_tmp15_ = derotated_point.y;
#line 4364 "../src/Photo.vala"
	_tmp16_ = unscaled_y_offset_raw;
#line 4364 "../src/Photo.vala"
	derotated_point.y = _tmp15_ + _tmp16_;
#line 4366 "../src/Photo.vala"
	*result = derotated_point;
#line 4366 "../src/Photo.vala"
	return;
#line 31437 "Photo.c"
}


void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_;
	gint _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	GdkPoint _tmp44_;
	gint _tmp45_;
	GdkPoint _tmp46_;
	gint _tmp47_;
#line 4369 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4369 "../src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4370 "../src/Photo.vala"
	_tmp0_.x = 0;
#line 4370 "../src/Photo.vala"
	upper_left = _tmp0_;
#line 4371 "../src/Photo.vala"
	_tmp1_.x = 0;
#line 4371 "../src/Photo.vala"
	lower_right = _tmp1_;
#line 4372 "../src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4372 "../src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4372 "../src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4373 "../src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4373 "../src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4373 "../src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4374 "../src/Photo.vala"
	_tmp6_ = upper_left;
#line 4374 "../src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4374 "../src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4374 "../src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4374 "../src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4375 "../src/Photo.vala"
	_tmp10_ = upper_left;
#line 4375 "../src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4375 "../src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4375 "../src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4375 "../src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4377 "../src/Photo.vala"
	_tmp14_ = upper_left;
#line 4377 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4377 "../src/Photo.vala"
	upper_left = _tmp15_;
#line 4378 "../src/Photo.vala"
	_tmp16_ = lower_right;
#line 4378 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4378 "../src/Photo.vala"
	lower_right = _tmp17_;
#line 4380 "../src/Photo.vala"
	_tmp18_ = upper_left;
#line 4380 "../src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4380 "../src/Photo.vala"
	_tmp20_ = lower_right;
#line 4380 "../src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4380 "../src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 31553 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp22_;
		gint _tmp23_;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 4381 "../src/Photo.vala"
		_tmp22_ = upper_left;
#line 4381 "../src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4381 "../src/Photo.vala"
		temp = _tmp23_;
#line 4382 "../src/Photo.vala"
		_tmp24_ = lower_right;
#line 4382 "../src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4382 "../src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4383 "../src/Photo.vala"
		_tmp26_ = temp;
#line 4383 "../src/Photo.vala"
		lower_right.x = _tmp26_;
#line 31576 "Photo.c"
	}
#line 4385 "../src/Photo.vala"
	_tmp27_ = upper_left;
#line 4385 "../src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4385 "../src/Photo.vala"
	_tmp29_ = lower_right;
#line 4385 "../src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4385 "../src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 31588 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp31_;
		gint _tmp32_;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 4386 "../src/Photo.vala"
		_tmp31_ = upper_left;
#line 4386 "../src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4386 "../src/Photo.vala"
		temp = _tmp32_;
#line 4387 "../src/Photo.vala"
		_tmp33_ = lower_right;
#line 4387 "../src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4387 "../src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4388 "../src/Photo.vala"
		_tmp35_ = temp;
#line 4388 "../src/Photo.vala"
		lower_right.y = _tmp35_;
#line 31611 "Photo.c"
	}
#line 4391 "../src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4392 "../src/Photo.vala"
	_tmp36_ = upper_left;
#line 4392 "../src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4392 "../src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4393 "../src/Photo.vala"
	_tmp38_ = upper_left;
#line 4393 "../src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4393 "../src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4394 "../src/Photo.vala"
	_tmp40_ = lower_right;
#line 4394 "../src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4394 "../src/Photo.vala"
	_tmp42_ = upper_left;
#line 4394 "../src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4394 "../src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4395 "../src/Photo.vala"
	_tmp44_ = lower_right;
#line 4395 "../src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4395 "../src/Photo.vala"
	_tmp46_ = upper_left;
#line 4395 "../src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4395 "../src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4397 "../src/Photo.vala"
	*result = raw_rect;
#line 4397 "../src/Photo.vala"
	return;
#line 31651 "Photo.c"
}


PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 4400 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4401 "../src/Photo.vala"
	pixbuf = NULL;
#line 31668 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4408 "../src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4408 "../src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4408 "../src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4408 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31682 "Photo.c"
			goto __catch413_g_error;
		}
#line 4408 "../src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4408 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 4408 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4408 "../src/Photo.vala"
		pixbuf = _tmp3_;
#line 4407 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 31695 "Photo.c"
	}
	goto __finally413;
	__catch413_g_error:
	{
		GError* e = NULL;
#line 4407 "../src/Photo.vala"
		e = _inner_error0_;
#line 4407 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4415 "../src/Photo.vala"
		g_warning ("Photo.vala:4415: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4417 "../src/Photo.vala"
		result = NULL;
#line 4417 "../src/Photo.vala"
		_g_error_free0 (e);
#line 4417 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4417 "../src/Photo.vala"
		return result;
#line 31715 "Photo.c"
	}
	__finally413:
#line 4407 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4407 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4407 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4407 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4407 "../src/Photo.vala"
		return NULL;
#line 31728 "Photo.c"
	}
#line 4424 "../src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4424 "../src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4424 "../src/Photo.vala"
	transformations = _tmp5_;
#line 4432 "../src/Photo.vala"
	result = transformations;
#line 4432 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4432 "../src/Photo.vala"
	return result;
#line 31742 "Photo.c"
}


gboolean
photo_enhance (Photo* self)
{
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4435 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4436 "../src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4436 "../src/Photo.vala"
	transformations = _tmp0_;
#line 4438 "../src/Photo.vala"
	_tmp1_ = transformations;
#line 4438 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4439 "../src/Photo.vala"
		result = FALSE;
#line 4439 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4439 "../src/Photo.vala"
		return result;
#line 31770 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4444 "../src/Photo.vala"
		_tmp2_ = self->row;
#line 4444 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31778 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4445 "../src/Photo.vala"
			_tmp3_ = transformations;
#line 4445 "../src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 31785 "Photo.c"
		}
		__finally414:
		{
			PhotoRow* _tmp4_;
#line 4444 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 4444 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31794 "Photo.c"
		}
#line 4444 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31798 "Photo.c"
			gboolean _tmp5_ = FALSE;
#line 4444 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4444 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4444 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4444 "../src/Photo.vala"
			return _tmp5_;
#line 31808 "Photo.c"
		}
	}
#line 4452 "../src/Photo.vala"
	result = TRUE;
#line 4452 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4452 "../src/Photo.vala"
	return result;
#line 31817 "Photo.c"
}


gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
	gboolean _tmp0_;
#line 346 "../src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 346 "../src/Photo.vala"
	result = _tmp0_;
#line 346 "../src/Photo.vala"
	return result;
#line 31832 "Photo.c"
}


void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 346 "../src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 31841 "Photo.c"
}


static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
#line 355 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 355 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 31854 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31880 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 31886 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31892 "Photo.c"
}


static void
photo_real_raw_development_modified (Photo* self)
{
}


static void
photo_real_baseline_replaced (Photo* self)
{
}


static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 373 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31914 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 158 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "../src/Photo.vala"
		data1 = closure->data;
#line 158 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31940 "Photo.c"
	} else {
#line 158 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "../src/Photo.vala"
		data2 = closure->data;
#line 31946 "Photo.c"
	}
#line 158 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 158 "../src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31952 "Photo.c"
}


static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 377 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31962 "Photo.c"
}


static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 384 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31972 "Photo.c"
}


static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 391 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 31982 "Photo.c"
}


static inline gpointer
photo_photo_transformation_state_impl_get_instance_private (PhotoPhotoTransformationStateImpl* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPhotoTransformationStateImpl_private_offset);
}


static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 254 "../src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 31999 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	PixelTransformer* _tmp2_;
	PixelTransformationBundle* _tmp3_;
#line 241 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || GEE_IS_HASH_MAP (transformations), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || IS_PIXEL_TRANSFORMER (transformer), NULL);
#line 241 "../src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || IS_PIXEL_TRANSFORMATION_BUNDLE (adjustments), NULL);
#line 241 "../src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 244 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 244 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 244 "../src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 245 "../src/Photo.vala"
	self->priv->orientation = orientation;
#line 246 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 246 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 246 "../src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 247 "../src/Photo.vala"
	_tmp2_ = _pixel_transformer_ref0 (transformer);
#line 247 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 247 "../src/Photo.vala"
	self->priv->transformer = _tmp2_;
#line 248 "../src/Photo.vala"
	_tmp3_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 248 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 248 "../src/Photo.vala"
	self->priv->adjustments = _tmp3_;
#line 250 "../src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 241 "../src/Photo.vala"
	return self;
#line 32056 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments)
{
#line 241 "../src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 32069 "Photo.c"
}


static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result = 0;
	Orientation _tmp0_;
#line 257 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 258 "../src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 258 "../src/Photo.vala"
	result = _tmp0_;
#line 258 "../src/Photo.vala"
	return result;
#line 32086 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 261 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 262 "../src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 262 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 262 "../src/Photo.vala"
	result = _tmp1_;
#line 262 "../src/Photo.vala"
	return result;
#line 32106 "Photo.c"
}


static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 265 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 266 "../src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 32122 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 266 "../src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 266 "../src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 32133 "Photo.c"
	} else {
#line 266 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 32139 "Photo.c"
	}
#line 266 "../src/Photo.vala"
	result = _tmp0_;
#line 266 "../src/Photo.vala"
	return result;
#line 32145 "Photo.c"
}


static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 269 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 270 "../src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 32161 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 270 "../src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 270 "../src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 32172 "Photo.c"
	} else {
#line 270 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 32178 "Photo.c"
	}
#line 270 "../src/Photo.vala"
	result = _tmp0_;
#line 270 "../src/Photo.vala"
	return result;
#line 32184 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* result = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
#line 273 "../src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || GEE_IS_HASH_MAP (original), NULL);
#line 275 "../src/Photo.vala"
	if (original == NULL) {
#line 276 "../src/Photo.vala"
		result = NULL;
#line 276 "../src/Photo.vala"
		return result;
#line 32202 "Photo.c"
	}
#line 278 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 278 "../src/Photo.vala"
	clone = _tmp0_;
#line 32208 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 279 "../src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 279 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 279 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 279 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 279 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 279 "../src/Photo.vala"
		_object_it = _tmp5_;
#line 279 "../src/Photo.vala"
		while (TRUE) {
#line 32232 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 279 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 279 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 279 "../src/Photo.vala"
				break;
#line 32250 "Photo.c"
			}
#line 279 "../src/Photo.vala"
			_tmp7_ = _object_it;
#line 279 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 279 "../src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 280 "../src/Photo.vala"
			_tmp9_ = clone;
#line 280 "../src/Photo.vala"
			_tmp10_ = object;
#line 280 "../src/Photo.vala"
			_tmp11_ = object;
#line 280 "../src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 280 "../src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 280 "../src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 280 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 280 "../src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 280 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 279 "../src/Photo.vala"
			_g_free0 (object);
#line 32280 "Photo.c"
		}
#line 279 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 32284 "Photo.c"
	}
#line 282 "../src/Photo.vala"
	result = clone;
#line 282 "../src/Photo.vala"
	return result;
#line 32290 "Photo.c"
}


static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 285 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 286 "../src/Photo.vala"
	if (!photo_transformation_state_is_broken (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))) {
#line 287 "../src/Photo.vala"
		g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState), photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 32303 "Photo.c"
	}
}


static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass)
{
#line 234 "../src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 234 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPhotoTransformationStateImpl_private_offset);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 32317 "Photo.c"
}


static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self)
{
#line 234 "../src/Photo.vala"
	self->priv = photo_photo_transformation_state_impl_get_instance_private (self);
#line 32326 "Photo.c"
}


static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 234 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 254 "../src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 254 "../src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 254 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 235 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 237 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 238 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 239 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 234 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 32354 "Photo.c"
}


static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		PhotoPhotoTransformationStateImpl_private_offset = g_type_add_instance_private (photo_photo_transformation_state_impl_type_id, sizeof (PhotoPhotoTransformationStateImplPrivate));
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 291 "../src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 291 "../src/Photo.vala"
	return self;
#line 32381 "Photo.c"
}


static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 291 "../src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 32390 "Photo.c"
}


static void
photo_value_backing_readers_init (GValue* value)
{
#line 291 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32399 "Photo.c"
}


static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 291 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 32410 "Photo.c"
	}
}


static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 291 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 32423 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32427 "Photo.c"
	}
}


static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32437 "Photo.c"
}


static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 291 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32449 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32456 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 291 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32460 "Photo.c"
		}
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 32464 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32468 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 32472 "Photo.c"
}


static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (!object_p) {
#line 291 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32488 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 291 "../src/Photo.vala"
		*object_p = NULL;
#line 32494 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 291 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32498 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 32502 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	return NULL;
#line 32506 "Photo.c"
}


static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 291 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 291 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32526 "Photo.c"
}


static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 291 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32537 "Photo.c"
}


static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 291 "../src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 32560 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32564 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32570 "Photo.c"
	}
}


static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "../src/Photo.vala"
	if (v_object) {
#line 291 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32592 "Photo.c"
	} else {
#line 291 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32596 "Photo.c"
	}
#line 291 "../src/Photo.vala"
	if (old) {
#line 291 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32602 "Photo.c"
	}
}


static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass)
{
#line 291 "../src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 291 "../src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 32614 "Photo.c"
}


static void
photo_backing_readers_instance_init (PhotoBackingReaders * self)
{
#line 291 "../src/Photo.vala"
	self->ref_count = 1;
#line 32623 "Photo.c"
}


static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 291 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 291 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 292 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 293 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 294 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 32641 "Photo.c"
}


static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 291 "../src/Photo.vala"
	return instance;
#line 32670 "Photo.c"
}


static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 291 "../src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 291 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32685 "Photo.c"
	}
}


static PhotoCachedPixbuf*
photo_cached_pixbuf_construct (GType object_type,
                               Photo* photo,
                               GdkPixbuf* pixbuf)
{
	PhotoCachedPixbuf* self = NULL;
	Photo* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 302 "../src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 302 "../src/Photo.vala"
	self = (PhotoCachedPixbuf*) g_type_create_instance (object_type);
#line 303 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 303 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 303 "../src/Photo.vala"
	self->photo = _tmp0_;
#line 304 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (pixbuf);
#line 304 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 304 "../src/Photo.vala"
	self->pixbuf = _tmp1_;
#line 302 "../src/Photo.vala"
	return self;
#line 32718 "Photo.c"
}


static PhotoCachedPixbuf*
photo_cached_pixbuf_new (Photo* photo,
                         GdkPixbuf* pixbuf)
{
#line 302 "../src/Photo.vala"
	return photo_cached_pixbuf_construct (PHOTO_TYPE_CACHED_PIXBUF, photo, pixbuf);
#line 32728 "Photo.c"
}


static void
photo_value_cached_pixbuf_init (GValue* value)
{
#line 297 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32737 "Photo.c"
}


static void
photo_value_cached_pixbuf_free_value (GValue* value)
{
#line 297 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (value->data[0].v_pointer);
#line 32748 "Photo.c"
	}
}


static void
photo_value_cached_pixbuf_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 297 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_cached_pixbuf_ref (src_value->data[0].v_pointer);
#line 32761 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32765 "Photo.c"
	}
}


static gpointer
photo_value_cached_pixbuf_peek_pointer (const GValue* value)
{
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32775 "Photo.c"
}


static gchar*
photo_value_cached_pixbuf_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 297 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32787 "Photo.c"
		PhotoCachedPixbuf * object;
		object = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32794 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 297 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32798 "Photo.c"
		}
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = photo_cached_pixbuf_ref (object);
#line 32802 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32806 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 32810 "Photo.c"
}


static gchar*
photo_value_cached_pixbuf_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoCachedPixbuf ** object_p;
	object_p = collect_values[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (!object_p) {
#line 297 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32826 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 297 "../src/Photo.vala"
		*object_p = NULL;
#line 32832 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 297 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32836 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		*object_p = photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 32840 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	return NULL;
#line 32844 "Photo.c"
}


static GParamSpec*
photo_param_spec_cached_pixbuf (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	PhotoParamSpecCachedPixbuf* spec;
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 297 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 297 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32864 "Photo.c"
}


static gpointer
photo_value_get_cached_pixbuf (const GValue* value)
{
#line 297 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32875 "Photo.c"
}


static void
photo_value_set_cached_pixbuf (GValue* value,
                               gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 32898 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32902 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 32908 "Photo.c"
	}
}


static void
photo_value_take_cached_pixbuf (GValue* value,
                                gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "../src/Photo.vala"
	if (v_object) {
#line 297 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32930 "Photo.c"
	} else {
#line 297 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32934 "Photo.c"
	}
#line 297 "../src/Photo.vala"
	if (old) {
#line 297 "../src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 32940 "Photo.c"
	}
}


static void
photo_cached_pixbuf_class_init (PhotoCachedPixbufClass * klass)
{
#line 297 "../src/Photo.vala"
	photo_cached_pixbuf_parent_class = g_type_class_peek_parent (klass);
#line 297 "../src/Photo.vala"
	((PhotoCachedPixbufClass *) klass)->finalize = photo_cached_pixbuf_finalize;
#line 32952 "Photo.c"
}


static void
photo_cached_pixbuf_instance_init (PhotoCachedPixbuf * self)
{
	GTimer* _tmp0_;
#line 300 "../src/Photo.vala"
	_tmp0_ = g_timer_new ();
#line 300 "../src/Photo.vala"
	self->last_touched = _tmp0_;
#line 297 "../src/Photo.vala"
	self->ref_count = 1;
#line 32966 "Photo.c"
}


static void
photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj)
{
	PhotoCachedPixbuf * self;
#line 297 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf);
#line 297 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 298 "../src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 299 "../src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 300 "../src/Photo.vala"
	_g_timer_destroy0 (self->last_touched);
#line 32984 "Photo.c"
}


static GType
photo_cached_pixbuf_get_type (void)
{
	static volatile gsize photo_cached_pixbuf_type_id__volatile = 0;
	if (g_once_init_enter (&photo_cached_pixbuf_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_cached_pixbuf_init, photo_value_cached_pixbuf_free_value, photo_value_cached_pixbuf_copy_value, photo_value_cached_pixbuf_peek_pointer, "p", photo_value_cached_pixbuf_collect_value, "p", photo_value_cached_pixbuf_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoCachedPixbufClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_cached_pixbuf_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoCachedPixbuf), 0, (GInstanceInitFunc) photo_cached_pixbuf_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_cached_pixbuf_type_id;
		photo_cached_pixbuf_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoCachedPixbuf", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_cached_pixbuf_type_id__volatile, photo_cached_pixbuf_type_id);
	}
	return photo_cached_pixbuf_type_id__volatile;
}


static gpointer
photo_cached_pixbuf_ref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 297 "../src/Photo.vala"
	return instance;
#line 33013 "Photo.c"
}


static void
photo_cached_pixbuf_unref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 297 "../src/Photo.vala"
		PHOTO_CACHED_PIXBUF_GET_CLASS (self)->finalize (self);
#line 297 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33028 "Photo.c"
	}
}


PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1366 "../src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1366 "../src/Photo.vala"
	return self;
#line 33041 "Photo.c"
}


static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1366 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33050 "Photo.c"
}


static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1366 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1366 "../src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 33061 "Photo.c"
	}
}


static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1366 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1366 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 33074 "Photo.c"
	} else {
#line 1366 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33078 "Photo.c"
	}
}


static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1366 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33088 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1366 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33100 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1366 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1366 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33107 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1366 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33111 "Photo.c"
		}
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 33115 "Photo.c"
	} else {
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33119 "Photo.c"
	}
#line 1366 "../src/Photo.vala"
	return NULL;
#line 33123 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1366 "../src/Photo.vala"
	if (!object_p) {
#line 1366 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33139 "Photo.c"
	}
#line 1366 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1366 "../src/Photo.vala"
		*object_p = NULL;
#line 33145 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1366 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33149 "Photo.c"
	} else {
#line 1366 "../src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 33153 "Photo.c"
	}
#line 1366 "../src/Photo.vala"
	return NULL;
#line 33157 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1366 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1366 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1366 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1366 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33177 "Photo.c"
}


gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1366 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1366 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33188 "Photo.c"
}


void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1366 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1366 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1366 "../src/Photo.vala"
	if (v_object) {
#line 1366 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1366 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1366 "../src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 33211 "Photo.c"
	} else {
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33215 "Photo.c"
	}
#line 1366 "../src/Photo.vala"
	if (old) {
#line 1366 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 33221 "Photo.c"
	}
}


void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1366 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1366 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1366 "../src/Photo.vala"
	if (v_object) {
#line 1366 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1366 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33243 "Photo.c"
	} else {
#line 1366 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33247 "Photo.c"
	}
#line 1366 "../src/Photo.vala"
	if (old) {
#line 1366 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 33253 "Photo.c"
	}
}


static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass)
{
#line 1366 "../src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1366 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 33265 "Photo.c"
}


static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self)
{
#line 1366 "../src/Photo.vala"
	self->ref_count = 1;
#line 33274 "Photo.c"
}


static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1366 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1366 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33286 "Photo.c"
}


GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1366 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1366 "../src/Photo.vala"
	return instance;
#line 33315 "Photo.c"
}


void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1366 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1366 "../src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1366 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33330 "Photo.c"
	}
}


static gchar**
_vala_array_dup25 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 1378 "../src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1378 "../src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 33345 "Photo.c"
		gchar* _tmp0_;
#line 1378 "../src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1378 "../src/Photo.vala"
		result[i] = _tmp0_;
#line 33351 "Photo.c"
	}
#line 1378 "../src/Photo.vala"
	return result;
#line 33355 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            int alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1375 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1375 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1375 "../src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1376 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1376 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1376 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1377 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1377 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1377 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1378 "../src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup25 (alterations, alterations_length1) : ((gpointer) alterations);
#line 1378 "../src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1378 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1378 "../src/Photo.vala"
	self->alterations = _tmp2_;
#line 1378 "../src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1378 "../src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1375 "../src/Photo.vala"
	return self;
#line 33403 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      int alterations_length1)
{
#line 1375 "../src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 33415 "Photo.c"
}


static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass)
{
#line 1369 "../src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1369 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 33426 "Photo.c"
}


static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self)
{
	PhotoRow* _tmp0_;
#line 1370 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1370 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1373 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 33440 "Photo.c"
}


static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1369 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1370 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1371 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1372 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1369 "../src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 33458 "Photo.c"
}


static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1382 "../src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1382 "../src/Photo.vala"
	return self;
#line 33484 "Photo.c"
}


static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1382 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33493 "Photo.c"
}


static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1382 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1382 "../src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 33504 "Photo.c"
	}
}


static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1382 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1382 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 33517 "Photo.c"
	} else {
#line 1382 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33521 "Photo.c"
	}
}


static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1382 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33531 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1382 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33543 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1382 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1382 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33550 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1382 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33554 "Photo.c"
		}
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 33558 "Photo.c"
	} else {
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33562 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	return NULL;
#line 33566 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1382 "../src/Photo.vala"
	if (!object_p) {
#line 1382 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33582 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1382 "../src/Photo.vala"
		*object_p = NULL;
#line 33588 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1382 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33592 "Photo.c"
	} else {
#line 1382 "../src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 33596 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	return NULL;
#line 33600 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1382 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1382 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1382 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1382 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33620 "Photo.c"
}


gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1382 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1382 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33631 "Photo.c"
}


void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1382 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1382 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1382 "../src/Photo.vala"
	if (v_object) {
#line 1382 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1382 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1382 "../src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 33654 "Photo.c"
	} else {
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33658 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	if (old) {
#line 1382 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 33664 "Photo.c"
	}
}


void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1382 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1382 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1382 "../src/Photo.vala"
	if (v_object) {
#line 1382 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1382 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33686 "Photo.c"
	} else {
#line 1382 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33690 "Photo.c"
	}
#line 1382 "../src/Photo.vala"
	if (old) {
#line 1382 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 33696 "Photo.c"
	}
}


static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass)
{
#line 1382 "../src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1382 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 33708 "Photo.c"
}


static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self)
{
#line 1382 "../src/Photo.vala"
	self->ref_count = 1;
#line 33717 "Photo.c"
}


static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1382 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1382 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33729 "Photo.c"
}


GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1382 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1382 "../src/Photo.vala"
	return instance;
#line 33758 "Photo.c"
}


void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1382 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1382 "../src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1382 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33773 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1390 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1390 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1390 "../src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1391 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1391 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1391 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1392 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1392 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1392 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1390 "../src/Photo.vala"
	return self;
#line 33806 "Photo.c"
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1390 "../src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 33816 "Photo.c"
}


static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass)
{
#line 1385 "../src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1385 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 33827 "Photo.c"
}


static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self)
{
	BackingPhotoRow* _tmp0_;
#line 1386 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1386 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1388 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 33841 "Photo.c"
}


static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1385 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1386 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1387 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1385 "../src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 33857 "Photo.c"
}


static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1396 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1396 "../src/Photo.vala"
	return self;
#line 33883 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1396 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33892 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1396 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1396 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 33903 "Photo.c"
	}
}


static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1396 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1396 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 33916 "Photo.c"
	} else {
#line 1396 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33920 "Photo.c"
	}
}


static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1396 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 33930 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1396 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33942 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1396 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1396 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33949 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1396 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33953 "Photo.c"
		}
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 33957 "Photo.c"
	} else {
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33961 "Photo.c"
	}
#line 1396 "../src/Photo.vala"
	return NULL;
#line 33965 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1396 "../src/Photo.vala"
	if (!object_p) {
#line 1396 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33981 "Photo.c"
	}
#line 1396 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1396 "../src/Photo.vala"
		*object_p = NULL;
#line 33987 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1396 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33991 "Photo.c"
	} else {
#line 1396 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33995 "Photo.c"
	}
#line 1396 "../src/Photo.vala"
	return NULL;
#line 33999 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1396 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1396 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1396 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1396 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 34019 "Photo.c"
}


gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1396 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1396 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 34030 "Photo.c"
}


void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1396 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1396 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1396 "../src/Photo.vala"
	if (v_object) {
#line 1396 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1396 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1396 "../src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 34053 "Photo.c"
	} else {
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34057 "Photo.c"
	}
#line 1396 "../src/Photo.vala"
	if (old) {
#line 1396 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 34063 "Photo.c"
	}
}


void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1396 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1396 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1396 "../src/Photo.vala"
	if (v_object) {
#line 1396 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1396 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34085 "Photo.c"
	} else {
#line 1396 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34089 "Photo.c"
	}
#line 1396 "../src/Photo.vala"
	if (old) {
#line 1396 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 34095 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass)
{
#line 1396 "../src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1396 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 34107 "Photo.c"
}


static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self)
{
#line 1396 "../src/Photo.vala"
	self->ref_count = 1;
#line 34116 "Photo.c"
}


static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1396 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1396 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 34128 "Photo.c"
}


GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1396 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1396 "../src/Photo.vala"
	return instance;
#line 34157 "Photo.c"
}


void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1396 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1396 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1396 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 34172 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1413 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1413 "../src/Photo.vala"
	return self;
#line 34185 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1413 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 34194 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1416 "../src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1416 "../src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1416 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1417 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1417 "../src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1417 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1417 "../src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1417 "../src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 34222 "Photo.c"
}


static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1420 "../src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1421 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1421 "../src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1421 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1421 "../src/Photo.vala"
	result = _tmp2_;
#line 1421 "../src/Photo.vala"
	return result;
#line 34245 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1404 "../src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1404 "../src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1404 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1405 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1405 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1405 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1406 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1406 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1406 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1404 "../src/Photo.vala"
	return self;
#line 34277 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1404 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 34287 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1400 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 34296 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1400 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 34307 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1400 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 34320 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 34324 "Photo.c"
	}
}


static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1400 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 34334 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1400 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 34346 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1400 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1400 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34353 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1400 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34357 "Photo.c"
		}
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 34361 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34365 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	return NULL;
#line 34369 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (!object_p) {
#line 1400 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 34385 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1400 "../src/Photo.vala"
		*object_p = NULL;
#line 34391 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1400 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 34395 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 34399 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	return NULL;
#line 34403 "Photo.c"
}


static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1400 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1400 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1400 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1400 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 34423 "Photo.c"
}


static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1400 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1400 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 34434 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1400 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1400 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (v_object) {
#line 1400 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1400 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 34457 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34461 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (old) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 34467 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1400 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1400 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "../src/Photo.vala"
	if (v_object) {
#line 1400 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1400 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34489 "Photo.c"
	} else {
#line 1400 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34493 "Photo.c"
	}
#line 1400 "../src/Photo.vala"
	if (old) {
#line 1400 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 34499 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass)
{
#line 1400 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1400 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 34511 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self)
{
	BackingPhotoRow* _tmp0_;
#line 1401 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1401 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1400 "../src/Photo.vala"
	self->ref_count = 1;
#line 34525 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1400 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1400 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1401 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1402 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 34541 "Photo.c"
}


GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1400 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1400 "../src/Photo.vala"
	return instance;
#line 34570 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1400 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1400 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1400 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 34585 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass)
{
#line 1399 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1399 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 34597 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self)
{
	GeeArrayList* _tmp0_;
#line 1410 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1410 "../src/Photo.vala"
	self->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1411 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 34611 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1399 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1410 "../src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1399 "../src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 34625 "Photo.c"
}


static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void
photo_class_init (PhotoClass * klass)
{
#line 158 "../src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 158 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &Photo_private_offset);
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, int*)) photo_real_get_backing_files_state;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 158 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) photo_real_get_timestamp;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) photo_real_get_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) photo_real_set_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) photo_real_increase_rating;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) photo_real_decrease_rating;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 158 "../src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 158 "../src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 158 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 158 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 158 "../src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "../src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 323 "../src/Photo.vala"
	g_rec_mutex_init (&__lock_photo_photo_source_pixbuf_cache);
#line 34772 "Photo.c"
}


static void
photo_dateable_interface_init (DateableIface * iface)
{
#line 158 "../src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "../src/Photo.vala"
	iface->get_exposure_time = (time_t (*) (Dateable*)) photo_real_get_exposure_time;
#line 158 "../src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) photo_real_set_exposure_time;
#line 34785 "Photo.c"
}


static void
photo_instance_init (Photo * self)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 158 "../src/Photo.vala"
	self->priv = photo_get_instance_private (self);
#line 328 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 329 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 329 "../src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 330 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 330 "../src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 331 "../src/Photo.vala"
	self->priv->transformer = NULL;
#line 332 "../src/Photo.vala"
	self->priv->adjustments = NULL;
#line 334 "../src/Photo.vala"
	self->priv->file_title = NULL;
#line 335 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 336 "../src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 337 "../src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 338 "../src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 340 "../src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 343 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	self->priv->developments = NULL;
#line 350 "../src/Photo.vala"
	self->backing_photo_row = NULL;
#line 34830 "Photo.c"
}


static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 158 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 328 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 328 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 329 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 330 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 330 "../src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 331 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 332 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 334 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 335 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 336 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 337 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 338 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 343 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 343 "../src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 350 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 158 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 34872 "Photo.c"
}


GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		Photo_private_offset = g_type_add_instance_private (photo_type_id, sizeof (PhotoPrivate));
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 34903 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 34909 "Photo.c"
	}
}


static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "../src/Photo.vala"
	switch (property_id) {
#line 34924 "Photo.c"
		default:
#line 158 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "../src/Photo.vala"
		break;
#line 34930 "Photo.c"
	}
}


static inline gpointer
library_photo_source_collection_get_instance_private (LibraryPhotoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceCollection_private_offset);
}


GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4476 "../src/Photo.vala"
	return result;
#line 34964 "Photo.c"
}


static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4476 "../src/Photo.vala"
	return result;
#line 34977 "Photo.c"
}


static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4480 "../src/Photo.vala"
	return result;
#line 34990 "Photo.c"
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4480 "../src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4480 "../src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4480 "../src/Photo.vala"
	return dup;
#line 35004 "Photo.c"
}


static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4482 "../src/Photo.vala"
	return result;
#line 35017 "Photo.c"
}


static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4502 "../src/Photo.vala"
	return result;
#line 35029 "Photo.c"
}


static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4504 "../src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 35041 "Photo.c"
}


static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4505 "../src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 35053 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4502 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4504 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4504 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4504 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4504 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4505 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4505 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4505 "../src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4505 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4501 "../src/Photo.vala"
	return self;
#line 35085 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4501 "../src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 35094 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4509 "../src/Photo.vala"
	return result;
#line 35107 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4508 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4509 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4509 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4509 "../src/Photo.vala"
	return result;
#line 35125 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4513 "../src/Photo.vala"
	return result;
#line 35138 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4512 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4513 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4513 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4513 "../src/Photo.vala"
	return result;
#line 35156 "Photo.c"
}


static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	PhotoMonitor* _tmp0_;
#line 4516 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4516 "../src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4516 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 4517 "../src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4517 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 4517 "../src/Photo.vala"
	return result;
#line 35180 "Photo.c"
}


static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4520 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4520 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4521 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_LIBRARY_PHOTO);
#line 4521 "../src/Photo.vala"
	return result;
#line 35198 "Photo.c"
}


static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4524 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4525 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4525 "../src/Photo.vala"
	result = _tmp0_;
#line 4525 "../src/Photo.vala"
	return result;
#line 35216 "Photo.c"
}


static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4528 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4528 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 4529 "../src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4529 "../src/Photo.vala"
	return result;
#line 35234 "Photo.c"
}


static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4541 "../src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 35246 "Photo.c"
}


static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4547 "../src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 35256 "Photo.c"
}


static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4532 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4532 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 4532 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 4534 "../src/Photo.vala"
	if (added != NULL) {
#line 35274 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4535 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4535 "../src/Photo.vala"
			_object_it = _tmp0_;
#line 4535 "../src/Photo.vala"
			while (TRUE) {
#line 35284 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_;
				gint64 _tmp30_ = 0LL;
				LibraryPhoto* _tmp31_;
				BackingPhotoRow* _tmp32_;
				BackingPhotoRow* _tmp33_;
				gboolean _tmp34_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp39_;
				gint64 _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeHashMap* _tmp42_;
				LibraryPhoto* _tmp43_;
				gint64 _tmp44_;
				gint64 _tmp45_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
#line 4535 "../src/Photo.vala"
				_tmp1_ = _object_it;
#line 4535 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4535 "../src/Photo.vala"
					break;
#line 35331 "Photo.c"
				}
#line 4535 "../src/Photo.vala"
				_tmp2_ = _object_it;
#line 4535 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4535 "../src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4536 "../src/Photo.vala"
				_tmp4_ = object;
#line 4536 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4536 "../src/Photo.vala"
				photo = _tmp5_;
#line 4538 "../src/Photo.vala"
				_tmp6_ = photo;
#line 4538 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 4538 "../src/Photo.vala"
				editable = _tmp7_;
#line 4539 "../src/Photo.vala"
				_tmp8_ = editable;
#line 4539 "../src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 35355 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4540 "../src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4540 "../src/Photo.vala"
					_tmp10_ = editable;
#line 4540 "../src/Photo.vala"
					_tmp11_ = photo;
#line 4540 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp11_);
#line 35367 "Photo.c"
				}
#line 4541 "../src/Photo.vala"
				_tmp12_ = photo;
#line 4541 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4543 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4543 "../src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo));
#line 4543 "../src/Photo.vala"
				raw_list = _tmp14_;
#line 4544 "../src/Photo.vala"
				_tmp15_ = raw_list;
#line 4544 "../src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 35383 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4545 "../src/Photo.vala"
						_tmp16_ = raw_list;
#line 4545 "../src/Photo.vala"
						_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4545 "../src/Photo.vala"
						_f_it = _tmp17_;
#line 4545 "../src/Photo.vala"
						while (TRUE) {
#line 35396 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4545 "../src/Photo.vala"
							_tmp18_ = _f_it;
#line 4545 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4545 "../src/Photo.vala"
								break;
#line 35410 "Photo.c"
							}
#line 4545 "../src/Photo.vala"
							_tmp19_ = _f_it;
#line 4545 "../src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4545 "../src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4546 "../src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4546 "../src/Photo.vala"
							_tmp22_ = f;
#line 4546 "../src/Photo.vala"
							_tmp23_ = photo;
#line 4546 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_, _tmp23_);
#line 4545 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 35428 "Photo.c"
						}
#line 4545 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 35432 "Photo.c"
					}
				}
#line 4547 "../src/Photo.vala"
				_tmp24_ = photo;
#line 4547 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4549 "../src/Photo.vala"
				_tmp25_ = photo;
#line 4549 "../src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 4549 "../src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4549 "../src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4549 "../src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 4549 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4549 "../src/Photo.vala"
				master_filesize = _tmp29_;
#line 4550 "../src/Photo.vala"
				_tmp31_ = photo;
#line 4550 "../src/Photo.vala"
				_tmp32_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO, Photo));
#line 4550 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4550 "../src/Photo.vala"
				_tmp34_ = _tmp33_ != NULL;
#line 4550 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp33_);
#line 4550 "../src/Photo.vala"
				if (_tmp34_) {
#line 35465 "Photo.c"
					LibraryPhoto* _tmp35_;
					BackingPhotoRow* _tmp36_;
					BackingPhotoRow* _tmp37_;
					gint64 _tmp38_;
#line 4551 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4551 "../src/Photo.vala"
					_tmp36_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo));
#line 4551 "../src/Photo.vala"
					_tmp37_ = _tmp36_;
#line 4551 "../src/Photo.vala"
					_tmp38_ = _tmp37_->filesize;
#line 4551 "../src/Photo.vala"
					_tmp30_ = _tmp38_;
#line 4551 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp37_);
#line 35482 "Photo.c"
				} else {
#line 4552 "../src/Photo.vala"
					_tmp30_ = (gint64) -1;
#line 35486 "Photo.c"
				}
#line 4550 "../src/Photo.vala"
				editable_filesize = _tmp30_;
#line 4553 "../src/Photo.vala"
				_tmp39_ = self->priv->filesize_to_photo;
#line 4553 "../src/Photo.vala"
				_tmp40_ = master_filesize;
#line 4553 "../src/Photo.vala"
				_tmp41_ = photo;
#line 4553 "../src/Photo.vala"
				gee_multi_map_set (_tmp39_, &_tmp40_, _tmp41_);
#line 4554 "../src/Photo.vala"
				_tmp42_ = self->priv->photo_to_master_filesize;
#line 4554 "../src/Photo.vala"
				_tmp43_ = photo;
#line 4554 "../src/Photo.vala"
				_tmp44_ = master_filesize;
#line 4554 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp43_, &_tmp44_);
#line 4555 "../src/Photo.vala"
				_tmp45_ = editable_filesize;
#line 4555 "../src/Photo.vala"
				if (_tmp45_ >= ((gint64) 0)) {
#line 35510 "Photo.c"
					GeeMultiMap* _tmp46_;
					gint64 _tmp47_;
					LibraryPhoto* _tmp48_;
					GeeHashMap* _tmp49_;
					LibraryPhoto* _tmp50_;
					gint64 _tmp51_;
#line 4556 "../src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4556 "../src/Photo.vala"
					_tmp47_ = editable_filesize;
#line 4556 "../src/Photo.vala"
					_tmp48_ = photo;
#line 4556 "../src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp47_, _tmp48_);
#line 4557 "../src/Photo.vala"
					_tmp49_ = self->priv->photo_to_editable_filesize;
#line 4557 "../src/Photo.vala"
					_tmp50_ = photo;
#line 4557 "../src/Photo.vala"
					_tmp51_ = editable_filesize;
#line 4557 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp50_, &_tmp51_);
#line 35533 "Photo.c"
				}
#line 4560 "../src/Photo.vala"
				_tmp52_ = photo;
#line 4560 "../src/Photo.vala"
				_tmp53_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, TYPE_PHOTO, Photo));
#line 4560 "../src/Photo.vala"
				raw_rows = _tmp53_;
#line 4561 "../src/Photo.vala"
				_tmp54_ = raw_rows;
#line 4561 "../src/Photo.vala"
				if (_tmp54_ != NULL) {
#line 35545 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp55_;
						GeeIterator* _tmp56_;
#line 4562 "../src/Photo.vala"
						_tmp55_ = raw_rows;
#line 4562 "../src/Photo.vala"
						_tmp56_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4562 "../src/Photo.vala"
						_row_it = _tmp56_;
#line 4562 "../src/Photo.vala"
						while (TRUE) {
#line 35558 "Photo.c"
							GeeIterator* _tmp57_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp58_;
							gpointer _tmp59_;
							BackingPhotoRow* _tmp60_;
							gint64 _tmp61_;
#line 4562 "../src/Photo.vala"
							_tmp57_ = _row_it;
#line 4562 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp57_)) {
#line 4562 "../src/Photo.vala"
								break;
#line 35571 "Photo.c"
							}
#line 4562 "../src/Photo.vala"
							_tmp58_ = _row_it;
#line 4562 "../src/Photo.vala"
							_tmp59_ = gee_iterator_get (_tmp58_);
#line 4562 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp59_;
#line 4563 "../src/Photo.vala"
							_tmp60_ = row;
#line 4563 "../src/Photo.vala"
							_tmp61_ = _tmp60_->filesize;
#line 4563 "../src/Photo.vala"
							if (_tmp61_ >= ((gint64) 0)) {
#line 35585 "Photo.c"
								GeeMultiMap* _tmp62_;
								BackingPhotoRow* _tmp63_;
								gint64 _tmp64_;
								LibraryPhoto* _tmp65_;
								GeeMultiMap* _tmp66_;
								LibraryPhoto* _tmp67_;
								BackingPhotoRow* _tmp68_;
								gint64 _tmp69_;
#line 4564 "../src/Photo.vala"
								_tmp62_ = self->priv->filesize_to_photo;
#line 4564 "../src/Photo.vala"
								_tmp63_ = row;
#line 4564 "../src/Photo.vala"
								_tmp64_ = _tmp63_->filesize;
#line 4564 "../src/Photo.vala"
								_tmp65_ = photo;
#line 4564 "../src/Photo.vala"
								gee_multi_map_set (_tmp62_, &_tmp64_, _tmp65_);
#line 4565 "../src/Photo.vala"
								_tmp66_ = self->priv->photo_to_raw_development_filesize;
#line 4565 "../src/Photo.vala"
								_tmp67_ = photo;
#line 4565 "../src/Photo.vala"
								_tmp68_ = row;
#line 4565 "../src/Photo.vala"
								_tmp69_ = _tmp68_->filesize;
#line 4565 "../src/Photo.vala"
								gee_multi_map_set (_tmp66_, _tmp67_, &_tmp69_);
#line 35614 "Photo.c"
							}
#line 4562 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35618 "Photo.c"
						}
#line 4562 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 35622 "Photo.c"
					}
				}
#line 4535 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4535 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4535 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4535 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4535 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 35635 "Photo.c"
			}
#line 4535 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 35639 "Photo.c"
		}
	}
#line 4572 "../src/Photo.vala"
	if (removed != NULL) {
#line 35644 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp70_;
#line 4573 "../src/Photo.vala"
			_tmp70_ = gee_iterable_iterator (removed);
#line 4573 "../src/Photo.vala"
			_object_it = _tmp70_;
#line 4573 "../src/Photo.vala"
			while (TRUE) {
#line 35654 "Photo.c"
				GeeIterator* _tmp71_;
				DataObject* object = NULL;
				GeeIterator* _tmp72_;
				gpointer _tmp73_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp74_;
				LibraryPhoto* _tmp75_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp76_;
				GFile* _tmp77_;
				GFile* _tmp78_;
				LibraryPhoto* _tmp85_;
				guint _tmp86_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp87_;
				GeeCollection* _tmp88_;
				GeeCollection* _tmp89_;
				LibraryPhoto* _tmp97_;
				guint _tmp98_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp99_;
				BackingPhotoRow* _tmp100_;
				BackingPhotoRow* _tmp101_;
				gint64 _tmp102_;
				gint64 _tmp103_;
				gint64 _tmp104_ = 0LL;
				LibraryPhoto* _tmp105_;
				BackingPhotoRow* _tmp106_;
				BackingPhotoRow* _tmp107_;
				gboolean _tmp108_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp113_;
				gint64 _tmp114_;
				LibraryPhoto* _tmp115_;
				GeeHashMap* _tmp116_;
				LibraryPhoto* _tmp117_;
				gint64 _tmp118_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp124_;
				GeeCollection* _tmp125_;
				GeeCollection* _tmp126_;
#line 4573 "../src/Photo.vala"
				_tmp71_ = _object_it;
#line 4573 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp71_)) {
#line 4573 "../src/Photo.vala"
					break;
#line 35702 "Photo.c"
				}
#line 4573 "../src/Photo.vala"
				_tmp72_ = _object_it;
#line 4573 "../src/Photo.vala"
				_tmp73_ = gee_iterator_get (_tmp72_);
#line 4573 "../src/Photo.vala"
				object = (DataObject*) _tmp73_;
#line 4574 "../src/Photo.vala"
				_tmp74_ = object;
#line 4574 "../src/Photo.vala"
				_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4574 "../src/Photo.vala"
				photo = _tmp75_;
#line 4576 "../src/Photo.vala"
				_tmp76_ = photo;
#line 4576 "../src/Photo.vala"
				_tmp77_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, TYPE_PHOTO, Photo));
#line 4576 "../src/Photo.vala"
				editable = _tmp77_;
#line 4577 "../src/Photo.vala"
				_tmp78_ = editable;
#line 4577 "../src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 35726 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp79_;
					LibraryPhoto* _tmp80_;
					GFile* _tmp81_;
					GFile* _tmp82_;
					gboolean _tmp83_;
					gboolean _tmp84_;
#line 4578 "../src/Photo.vala"
					_tmp79_ = self->priv->by_editable_file;
#line 4578 "../src/Photo.vala"
					_tmp80_ = photo;
#line 4578 "../src/Photo.vala"
					_tmp81_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_PHOTO, Photo));
#line 4578 "../src/Photo.vala"
					_tmp82_ = _tmp81_;
#line 4578 "../src/Photo.vala"
					_tmp83_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp82_, NULL);
#line 4578 "../src/Photo.vala"
					_g_object_unref0 (_tmp82_);
#line 4578 "../src/Photo.vala"
					is_removed = _tmp83_;
#line 4579 "../src/Photo.vala"
					_tmp84_ = is_removed;
#line 4579 "../src/Photo.vala"
					_vala_assert (_tmp84_, "is_removed");
#line 35752 "Photo.c"
				}
#line 4581 "../src/Photo.vala"
				_tmp85_ = photo;
#line 4581 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp86_, NULL, FALSE);
#line 4581 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp86_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4583 "../src/Photo.vala"
				_tmp87_ = photo;
#line 4583 "../src/Photo.vala"
				_tmp88_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp87_, TYPE_PHOTO, Photo));
#line 4583 "../src/Photo.vala"
				raw_list = _tmp88_;
#line 4584 "../src/Photo.vala"
				_tmp89_ = raw_list;
#line 4584 "../src/Photo.vala"
				if (_tmp89_ != NULL) {
#line 35770 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp90_;
						GeeIterator* _tmp91_;
#line 4585 "../src/Photo.vala"
						_tmp90_ = raw_list;
#line 4585 "../src/Photo.vala"
						_tmp91_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp90_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4585 "../src/Photo.vala"
						_f_it = _tmp91_;
#line 4585 "../src/Photo.vala"
						while (TRUE) {
#line 35783 "Photo.c"
							GeeIterator* _tmp92_;
							GFile* f = NULL;
							GeeIterator* _tmp93_;
							gpointer _tmp94_;
							GeeHashMap* _tmp95_;
							GFile* _tmp96_;
#line 4585 "../src/Photo.vala"
							_tmp92_ = _f_it;
#line 4585 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp92_)) {
#line 4585 "../src/Photo.vala"
								break;
#line 35796 "Photo.c"
							}
#line 4585 "../src/Photo.vala"
							_tmp93_ = _f_it;
#line 4585 "../src/Photo.vala"
							_tmp94_ = gee_iterator_get (_tmp93_);
#line 4585 "../src/Photo.vala"
							f = (GFile*) _tmp94_;
#line 4586 "../src/Photo.vala"
							_tmp95_ = self->priv->by_raw_development_file;
#line 4586 "../src/Photo.vala"
							_tmp96_ = f;
#line 4586 "../src/Photo.vala"
							gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp95_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp96_, NULL);
#line 4585 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 35812 "Photo.c"
						}
#line 4585 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 35816 "Photo.c"
					}
				}
#line 4587 "../src/Photo.vala"
				_tmp97_ = photo;
#line 4587 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp98_, NULL, FALSE);
#line 4587 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp98_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4589 "../src/Photo.vala"
				_tmp99_ = photo;
#line 4589 "../src/Photo.vala"
				_tmp100_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, TYPE_PHOTO, Photo));
#line 4589 "../src/Photo.vala"
				_tmp101_ = _tmp100_;
#line 4589 "../src/Photo.vala"
				_tmp102_ = _tmp101_->filesize;
#line 4589 "../src/Photo.vala"
				_tmp103_ = _tmp102_;
#line 4589 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp101_);
#line 4589 "../src/Photo.vala"
				master_filesize = _tmp103_;
#line 4590 "../src/Photo.vala"
				_tmp105_ = photo;
#line 4590 "../src/Photo.vala"
				_tmp106_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, TYPE_PHOTO, Photo));
#line 4590 "../src/Photo.vala"
				_tmp107_ = _tmp106_;
#line 4590 "../src/Photo.vala"
				_tmp108_ = _tmp107_ != NULL;
#line 4590 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp107_);
#line 4590 "../src/Photo.vala"
				if (_tmp108_) {
#line 35851 "Photo.c"
					LibraryPhoto* _tmp109_;
					BackingPhotoRow* _tmp110_;
					BackingPhotoRow* _tmp111_;
					gint64 _tmp112_;
#line 4591 "../src/Photo.vala"
					_tmp109_ = photo;
#line 4591 "../src/Photo.vala"
					_tmp110_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, TYPE_PHOTO, Photo));
#line 4591 "../src/Photo.vala"
					_tmp111_ = _tmp110_;
#line 4591 "../src/Photo.vala"
					_tmp112_ = _tmp111_->filesize;
#line 4591 "../src/Photo.vala"
					_tmp104_ = _tmp112_;
#line 4591 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp111_);
#line 35868 "Photo.c"
				} else {
#line 4592 "../src/Photo.vala"
					_tmp104_ = (gint64) -1;
#line 35872 "Photo.c"
				}
#line 4590 "../src/Photo.vala"
				editable_filesize = _tmp104_;
#line 4593 "../src/Photo.vala"
				_tmp113_ = self->priv->filesize_to_photo;
#line 4593 "../src/Photo.vala"
				_tmp114_ = master_filesize;
#line 4593 "../src/Photo.vala"
				_tmp115_ = photo;
#line 4593 "../src/Photo.vala"
				gee_multi_map_remove (_tmp113_, &_tmp114_, _tmp115_);
#line 4594 "../src/Photo.vala"
				_tmp116_ = self->priv->photo_to_master_filesize;
#line 4594 "../src/Photo.vala"
				_tmp117_ = photo;
#line 4594 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp117_, NULL);
#line 4595 "../src/Photo.vala"
				_tmp118_ = editable_filesize;
#line 4595 "../src/Photo.vala"
				if (_tmp118_ >= ((gint64) 0)) {
#line 35894 "Photo.c"
					GeeMultiMap* _tmp119_;
					gint64 _tmp120_;
					LibraryPhoto* _tmp121_;
					GeeHashMap* _tmp122_;
					LibraryPhoto* _tmp123_;
#line 4596 "../src/Photo.vala"
					_tmp119_ = self->priv->filesize_to_photo;
#line 4596 "../src/Photo.vala"
					_tmp120_ = editable_filesize;
#line 4596 "../src/Photo.vala"
					_tmp121_ = photo;
#line 4596 "../src/Photo.vala"
					gee_multi_map_remove (_tmp119_, &_tmp120_, _tmp121_);
#line 4597 "../src/Photo.vala"
					_tmp122_ = self->priv->photo_to_editable_filesize;
#line 4597 "../src/Photo.vala"
					_tmp123_ = photo;
#line 4597 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp122_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp123_, NULL);
#line 35914 "Photo.c"
				}
#line 4600 "../src/Photo.vala"
				_tmp124_ = photo;
#line 4600 "../src/Photo.vala"
				_tmp125_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp124_, TYPE_PHOTO, Photo));
#line 4600 "../src/Photo.vala"
				raw_rows = _tmp125_;
#line 4601 "../src/Photo.vala"
				_tmp126_ = raw_rows;
#line 4601 "../src/Photo.vala"
				if (_tmp126_ != NULL) {
#line 35926 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp127_;
						GeeIterator* _tmp128_;
#line 4602 "../src/Photo.vala"
						_tmp127_ = raw_rows;
#line 4602 "../src/Photo.vala"
						_tmp128_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp127_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4602 "../src/Photo.vala"
						_row_it = _tmp128_;
#line 4602 "../src/Photo.vala"
						while (TRUE) {
#line 35939 "Photo.c"
							GeeIterator* _tmp129_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp130_;
							gpointer _tmp131_;
							BackingPhotoRow* _tmp132_;
							gint64 _tmp133_;
#line 4602 "../src/Photo.vala"
							_tmp129_ = _row_it;
#line 4602 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp129_)) {
#line 4602 "../src/Photo.vala"
								break;
#line 35952 "Photo.c"
							}
#line 4602 "../src/Photo.vala"
							_tmp130_ = _row_it;
#line 4602 "../src/Photo.vala"
							_tmp131_ = gee_iterator_get (_tmp130_);
#line 4602 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp131_;
#line 4603 "../src/Photo.vala"
							_tmp132_ = row;
#line 4603 "../src/Photo.vala"
							_tmp133_ = _tmp132_->filesize;
#line 4603 "../src/Photo.vala"
							if (_tmp133_ >= ((gint64) 0)) {
#line 35966 "Photo.c"
								GeeMultiMap* _tmp134_;
								BackingPhotoRow* _tmp135_;
								gint64 _tmp136_;
								LibraryPhoto* _tmp137_;
								GeeMultiMap* _tmp138_;
								LibraryPhoto* _tmp139_;
								BackingPhotoRow* _tmp140_;
								gint64 _tmp141_;
#line 4604 "../src/Photo.vala"
								_tmp134_ = self->priv->filesize_to_photo;
#line 4604 "../src/Photo.vala"
								_tmp135_ = row;
#line 4604 "../src/Photo.vala"
								_tmp136_ = _tmp135_->filesize;
#line 4604 "../src/Photo.vala"
								_tmp137_ = photo;
#line 4604 "../src/Photo.vala"
								gee_multi_map_remove (_tmp134_, &_tmp136_, _tmp137_);
#line 4605 "../src/Photo.vala"
								_tmp138_ = self->priv->photo_to_raw_development_filesize;
#line 4605 "../src/Photo.vala"
								_tmp139_ = photo;
#line 4605 "../src/Photo.vala"
								_tmp140_ = row;
#line 4605 "../src/Photo.vala"
								_tmp141_ = _tmp140_->filesize;
#line 4605 "../src/Photo.vala"
								gee_multi_map_remove (_tmp138_, _tmp139_, &_tmp141_);
#line 35995 "Photo.c"
							}
#line 4602 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35999 "Photo.c"
						}
#line 4602 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 36003 "Photo.c"
					}
				}
#line 4573 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4573 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4573 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4573 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4573 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 36016 "Photo.c"
			}
#line 4573 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 36020 "Photo.c"
		}
	}
#line 4612 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
#line 36025 "Photo.c"
}


static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4615 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4615 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4615 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 4615 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 4616 "../src/Photo.vala"
	if (old_file != NULL) {
#line 36045 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
		gboolean _tmp1_;
#line 4617 "../src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4617 "../src/Photo.vala"
		is_removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 4618 "../src/Photo.vala"
		_tmp1_ = is_removed;
#line 4618 "../src/Photo.vala"
		_vala_assert (_tmp1_, "is_removed");
#line 36057 "Photo.c"
	}
#line 4621 "../src/Photo.vala"
	if (new_file != NULL) {
#line 36061 "Photo.c"
		GeeHashMap* _tmp2_;
#line 4622 "../src/Photo.vala"
		_tmp2_ = self->priv->by_editable_file;
#line 4622 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 36067 "Photo.c"
	}
}


static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
#line 4625 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4625 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4626 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 4626 "../src/Photo.vala"
	photo = _tmp0_;
#line 4627 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4627 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4628 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4628 "../src/Photo.vala"
		return;
#line 36105 "Photo.c"
	}
#line 4631 "../src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4631 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4631 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 36113 "Photo.c"
		GeeMultiMap* _tmp18_;
		LibraryPhoto* _tmp19_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4632 "../src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4632 "../src/Photo.vala"
			_tmp5_ = photo;
#line 4632 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4632 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4632 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4632 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4632 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4632 "../src/Photo.vala"
			_s_it = _tmp9_;
#line 4632 "../src/Photo.vala"
			while (TRUE) {
#line 36142 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				gint64 _tmp16_;
				LibraryPhoto* _tmp17_;
#line 4632 "../src/Photo.vala"
				_tmp10_ = _s_it;
#line 4632 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4632 "../src/Photo.vala"
					break;
#line 36158 "Photo.c"
				}
#line 4632 "../src/Photo.vala"
				_tmp11_ = _s_it;
#line 4632 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4632 "../src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4632 "../src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4632 "../src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4632 "../src/Photo.vala"
				s = _tmp14_;
#line 4633 "../src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4633 "../src/Photo.vala"
				_tmp16_ = s;
#line 4633 "../src/Photo.vala"
				_tmp17_ = photo;
#line 4633 "../src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &_tmp16_, _tmp17_);
#line 36180 "Photo.c"
			}
#line 4632 "../src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 36184 "Photo.c"
		}
#line 4634 "../src/Photo.vala"
		_tmp18_ = self->priv->photo_to_raw_development_filesize;
#line 4634 "../src/Photo.vala"
		_tmp19_ = photo;
#line 4634 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 36192 "Photo.c"
	}
#line 4638 "../src/Photo.vala"
	_tmp20_ = photo;
#line 4638 "../src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 4638 "../src/Photo.vala"
	raw_list = _tmp21_;
#line 4639 "../src/Photo.vala"
	_tmp22_ = raw_list;
#line 4639 "../src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 36204 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp23_;
			GeeIterator* _tmp24_;
#line 4640 "../src/Photo.vala"
			_tmp23_ = raw_list;
#line 4640 "../src/Photo.vala"
			_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4640 "../src/Photo.vala"
			_f_it = _tmp24_;
#line 4640 "../src/Photo.vala"
			while (TRUE) {
#line 36217 "Photo.c"
				GeeIterator* _tmp25_;
				GFile* f = NULL;
				GeeIterator* _tmp26_;
				gpointer _tmp27_;
				GeeHashMap* _tmp28_;
				GFile* _tmp29_;
				LibraryPhoto* _tmp30_;
#line 4640 "../src/Photo.vala"
				_tmp25_ = _f_it;
#line 4640 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp25_)) {
#line 4640 "../src/Photo.vala"
					break;
#line 36231 "Photo.c"
				}
#line 4640 "../src/Photo.vala"
				_tmp26_ = _f_it;
#line 4640 "../src/Photo.vala"
				_tmp27_ = gee_iterator_get (_tmp26_);
#line 4640 "../src/Photo.vala"
				f = (GFile*) _tmp27_;
#line 4641 "../src/Photo.vala"
				_tmp28_ = self->priv->by_raw_development_file;
#line 4641 "../src/Photo.vala"
				_tmp29_ = f;
#line 4641 "../src/Photo.vala"
				_tmp30_ = photo;
#line 4641 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 4640 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 36249 "Photo.c"
			}
#line 4640 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 36253 "Photo.c"
		}
	}
#line 4643 "../src/Photo.vala"
	_tmp31_ = photo;
#line 4643 "../src/Photo.vala"
	_tmp32_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO, Photo));
#line 4643 "../src/Photo.vala"
	raw_rows = _tmp32_;
#line 4644 "../src/Photo.vala"
	_tmp33_ = raw_rows;
#line 4644 "../src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 36266 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
#line 4645 "../src/Photo.vala"
			_tmp34_ = raw_rows;
#line 4645 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4645 "../src/Photo.vala"
			_row_it = _tmp35_;
#line 4645 "../src/Photo.vala"
			while (TRUE) {
#line 36279 "Photo.c"
				GeeIterator* _tmp36_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp37_;
				gpointer _tmp38_;
				BackingPhotoRow* _tmp39_;
				gint64 _tmp40_;
#line 4645 "../src/Photo.vala"
				_tmp36_ = _row_it;
#line 4645 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp36_)) {
#line 4645 "../src/Photo.vala"
					break;
#line 36292 "Photo.c"
				}
#line 4645 "../src/Photo.vala"
				_tmp37_ = _row_it;
#line 4645 "../src/Photo.vala"
				_tmp38_ = gee_iterator_get (_tmp37_);
#line 4645 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp38_;
#line 4646 "../src/Photo.vala"
				_tmp39_ = row;
#line 4646 "../src/Photo.vala"
				_tmp40_ = _tmp39_->filesize;
#line 4646 "../src/Photo.vala"
				if (_tmp40_ > ((gint64) 0)) {
#line 36306 "Photo.c"
					GeeMultiMap* _tmp41_;
					BackingPhotoRow* _tmp42_;
					gint64 _tmp43_;
					LibraryPhoto* _tmp44_;
					GeeMultiMap* _tmp45_;
					LibraryPhoto* _tmp46_;
					BackingPhotoRow* _tmp47_;
					gint64 _tmp48_;
#line 4647 "../src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4647 "../src/Photo.vala"
					_tmp42_ = row;
#line 4647 "../src/Photo.vala"
					_tmp43_ = _tmp42_->filesize;
#line 4647 "../src/Photo.vala"
					_tmp44_ = photo;
#line 4647 "../src/Photo.vala"
					gee_multi_map_set (_tmp41_, &_tmp43_, _tmp44_);
#line 4648 "../src/Photo.vala"
					_tmp45_ = self->priv->photo_to_raw_development_filesize;
#line 4648 "../src/Photo.vala"
					_tmp46_ = photo;
#line 4648 "../src/Photo.vala"
					_tmp47_ = row;
#line 4648 "../src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4648 "../src/Photo.vala"
					gee_multi_map_set (_tmp45_, _tmp46_, &_tmp48_);
#line 36335 "Photo.c"
				}
#line 4645 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36339 "Photo.c"
			}
#line 4645 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36343 "Photo.c"
		}
	}
#line 4625 "../src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4625 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4625 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 36352 "Photo.c"
}


static gpointer
__int64_dup0 (gpointer self)
{
#line 4664 "../src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 36361 "Photo.c"
}


static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4654 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4654 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 36374 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4655 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4655 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4655 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4655 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4655 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4655 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4655 "../src/Photo.vala"
		_object_it = _tmp4_;
#line 4655 "../src/Photo.vala"
		while (TRUE) {
#line 36398 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4655 "../src/Photo.vala"
			_tmp5_ = _object_it;
#line 4655 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4655 "../src/Photo.vala"
				break;
#line 36417 "Photo.c"
			}
#line 4655 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 4655 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4655 "../src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4656 "../src/Photo.vala"
			_tmp8_ = object;
#line 4656 "../src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4656 "../src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4658 "../src/Photo.vala"
			_tmp10_ = object;
#line 4658 "../src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4658 "../src/Photo.vala"
			photo = _tmp11_;
#line 4660 "../src/Photo.vala"
			_tmp13_ = alteration;
#line 4660 "../src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4660 "../src/Photo.vala"
				_tmp12_ = TRUE;
#line 36443 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4660 "../src/Photo.vala"
				_tmp14_ = alteration;
#line 4660 "../src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 36450 "Photo.c"
			}
#line 4660 "../src/Photo.vala"
			if (_tmp12_) {
#line 36454 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				gint64 _tmp31_;
				LibraryPhoto* _tmp32_;
				gint64 _tmp33_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp39_;
				BackingPhotoRow* _tmp40_;
				BackingPhotoRow* _tmp41_;
				gint64 _tmp42_;
				gint64 _tmp43_;
				gint64 _tmp44_ = 0LL;
				LibraryPhoto* _tmp45_;
				BackingPhotoRow* _tmp46_;
				BackingPhotoRow* _tmp47_;
				gboolean _tmp48_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp53_;
				LibraryPhoto* _tmp54_;
				gint64 _tmp55_;
				GeeMultiMap* _tmp56_;
				gint64 _tmp57_;
				LibraryPhoto* _tmp58_;
				gint64 _tmp59_;
#line 4661 "../src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4661 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4661 "../src/Photo.vala"
				_tmp17_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_);
#line 4661 "../src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4661 "../src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4661 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4661 "../src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4662 "../src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4662 "../src/Photo.vala"
				_tmp22_ = photo;
#line 4662 "../src/Photo.vala"
				if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_)) {
#line 36510 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4663 "../src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4663 "../src/Photo.vala"
					_tmp24_ = photo;
#line 4663 "../src/Photo.vala"
					_tmp25_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_);
#line 4663 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4663 "../src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 36524 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4664 "../src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4664 "../src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4664 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4664 "../src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 36536 "Photo.c"
				}
#line 4662 "../src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4666 "../src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4666 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4666 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, NULL);
#line 4667 "../src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4667 "../src/Photo.vala"
				_tmp31_ = old_master_filesize;
#line 4667 "../src/Photo.vala"
				_tmp32_ = photo;
#line 4667 "../src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &_tmp31_, _tmp32_);
#line 4668 "../src/Photo.vala"
				_tmp33_ = old_editable_filesize;
#line 4668 "../src/Photo.vala"
				if (_tmp33_ >= ((gint64) 0)) {
#line 36558 "Photo.c"
					GeeHashMap* _tmp34_;
					LibraryPhoto* _tmp35_;
					GeeMultiMap* _tmp36_;
					gint64 _tmp37_;
					LibraryPhoto* _tmp38_;
#line 4669 "../src/Photo.vala"
					_tmp34_ = self->priv->photo_to_editable_filesize;
#line 4669 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4669 "../src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp35_, NULL);
#line 4670 "../src/Photo.vala"
					_tmp36_ = self->priv->filesize_to_photo;
#line 4670 "../src/Photo.vala"
					_tmp37_ = old_editable_filesize;
#line 4670 "../src/Photo.vala"
					_tmp38_ = photo;
#line 4670 "../src/Photo.vala"
					gee_multi_map_remove (_tmp36_, &_tmp37_, _tmp38_);
#line 36578 "Photo.c"
				}
#line 4673 "../src/Photo.vala"
				_tmp39_ = photo;
#line 4673 "../src/Photo.vala"
				_tmp40_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_PHOTO, Photo));
#line 4673 "../src/Photo.vala"
				_tmp41_ = _tmp40_;
#line 4673 "../src/Photo.vala"
				_tmp42_ = _tmp41_->filesize;
#line 4673 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4673 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp41_);
#line 4673 "../src/Photo.vala"
				master_filesize = _tmp43_;
#line 4674 "../src/Photo.vala"
				_tmp45_ = photo;
#line 4674 "../src/Photo.vala"
				_tmp46_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4674 "../src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 4674 "../src/Photo.vala"
				_tmp48_ = _tmp47_ != NULL;
#line 4674 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp47_);
#line 4674 "../src/Photo.vala"
				if (_tmp48_) {
#line 36606 "Photo.c"
					LibraryPhoto* _tmp49_;
					BackingPhotoRow* _tmp50_;
					BackingPhotoRow* _tmp51_;
					gint64 _tmp52_;
#line 4675 "../src/Photo.vala"
					_tmp49_ = photo;
#line 4675 "../src/Photo.vala"
					_tmp50_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_PHOTO, Photo));
#line 4675 "../src/Photo.vala"
					_tmp51_ = _tmp50_;
#line 4675 "../src/Photo.vala"
					_tmp52_ = _tmp51_->filesize;
#line 4675 "../src/Photo.vala"
					_tmp44_ = _tmp52_;
#line 4675 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp51_);
#line 36623 "Photo.c"
				} else {
#line 4676 "../src/Photo.vala"
					_tmp44_ = (gint64) -1;
#line 36627 "Photo.c"
				}
#line 4674 "../src/Photo.vala"
				editable_filesize = _tmp44_;
#line 4677 "../src/Photo.vala"
				_tmp53_ = self->priv->photo_to_master_filesize;
#line 4677 "../src/Photo.vala"
				_tmp54_ = photo;
#line 4677 "../src/Photo.vala"
				_tmp55_ = master_filesize;
#line 4677 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp54_, &_tmp55_);
#line 4678 "../src/Photo.vala"
				_tmp56_ = self->priv->filesize_to_photo;
#line 4678 "../src/Photo.vala"
				_tmp57_ = master_filesize;
#line 4678 "../src/Photo.vala"
				_tmp58_ = photo;
#line 4678 "../src/Photo.vala"
				gee_multi_map_set (_tmp56_, &_tmp57_, _tmp58_);
#line 4679 "../src/Photo.vala"
				_tmp59_ = editable_filesize;
#line 4679 "../src/Photo.vala"
				if (_tmp59_ >= ((gint64) 0)) {
#line 36651 "Photo.c"
					GeeHashMap* _tmp60_;
					LibraryPhoto* _tmp61_;
					gint64 _tmp62_;
					GeeMultiMap* _tmp63_;
					gint64 _tmp64_;
					LibraryPhoto* _tmp65_;
#line 4680 "../src/Photo.vala"
					_tmp60_ = self->priv->photo_to_editable_filesize;
#line 4680 "../src/Photo.vala"
					_tmp61_ = photo;
#line 4680 "../src/Photo.vala"
					_tmp62_ = editable_filesize;
#line 4680 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp61_, &_tmp62_);
#line 4681 "../src/Photo.vala"
					_tmp63_ = self->priv->filesize_to_photo;
#line 4681 "../src/Photo.vala"
					_tmp64_ = editable_filesize;
#line 4681 "../src/Photo.vala"
					_tmp65_ = photo;
#line 4681 "../src/Photo.vala"
					gee_multi_map_set (_tmp63_, &_tmp64_, _tmp65_);
#line 36674 "Photo.c"
				}
#line 4660 "../src/Photo.vala"
				_g_free0 (_tmp20_);
#line 36678 "Photo.c"
			}
#line 4655 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4655 "../src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4655 "../src/Photo.vala"
			_g_object_unref0 (object);
#line 36686 "Photo.c"
		}
#line 4655 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 36690 "Photo.c"
	}
#line 4686 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), items);
#line 36694 "Photo.c"
}


static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4690 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4690 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 4691 "../src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4691 "../src/Photo.vala"
	map = _tmp0_;
#line 36713 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4692 "../src/Photo.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4692 "../src/Photo.vala"
		_media_it = _tmp1_;
#line 4692 "../src/Photo.vala"
		while (TRUE) {
#line 36723 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			gboolean _tmp10_ = FALSE;
			PhotoMetadata* _tmp11_;
			LibraryPhoto* _tmp17_;
			GeeCollection* _tmp18_;
			GeeCollection* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp51_ = FALSE;
			PhotoMetadata* _tmp52_;
#line 4692 "../src/Photo.vala"
			_tmp2_ = _media_it;
#line 4692 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4692 "../src/Photo.vala"
				break;
#line 36751 "Photo.c"
			}
#line 4692 "../src/Photo.vala"
			_tmp3_ = _media_it;
#line 4692 "../src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4692 "../src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4693 "../src/Photo.vala"
			_tmp5_ = media;
#line 4693 "../src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4693 "../src/Photo.vala"
			photo = _tmp6_;
#line 4694 "../src/Photo.vala"
			_tmp7_ = photo;
#line 4694 "../src/Photo.vala"
			_tmp8_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_SOURCE, PhotoSource));
#line 4694 "../src/Photo.vala"
			metadata = _tmp8_;
#line 4697 "../src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4697 "../src/Photo.vala"
			global_index = _tmp9_;
#line 4704 "../src/Photo.vala"
			htag_index = NULL;
#line 4705 "../src/Photo.vala"
			_tmp11_ = metadata;
#line 4705 "../src/Photo.vala"
			if (_tmp11_ != NULL) {
#line 36781 "Photo.c"
				PhotoMetadata* _tmp12_;
#line 4705 "../src/Photo.vala"
				_tmp12_ = metadata;
#line 4705 "../src/Photo.vala"
				_tmp10_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 36787 "Photo.c"
			} else {
#line 4705 "../src/Photo.vala"
				_tmp10_ = FALSE;
#line 36791 "Photo.c"
			}
#line 4705 "../src/Photo.vala"
			if (_tmp10_) {
#line 36795 "Photo.c"
				PhotoMetadata* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				HierarchicalTagIndex* _tmp16_;
#line 4706 "../src/Photo.vala"
				_tmp13_ = metadata;
#line 4706 "../src/Photo.vala"
				_tmp14_ = photo_metadata_get_hierarchical_keywords (_tmp13_);
#line 4706 "../src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 4706 "../src/Photo.vala"
				_tmp16_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4706 "../src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4706 "../src/Photo.vala"
				htag_index = _tmp16_;
#line 4706 "../src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 36814 "Photo.c"
			}
#line 4710 "../src/Photo.vala"
			_tmp17_ = photo;
#line 4710 "../src/Photo.vala"
			_tmp18_ = library_photo_get_import_keywords (_tmp17_);
#line 4710 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 4710 "../src/Photo.vala"
			_tmp20_ = _tmp19_ != NULL;
#line 4710 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 4710 "../src/Photo.vala"
			if (_tmp20_) {
#line 36828 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp21_;
					GeeCollection* _tmp22_;
					GeeCollection* _tmp23_;
					GeeIterator* _tmp24_;
					GeeIterator* _tmp25_;
#line 4711 "../src/Photo.vala"
					_tmp21_ = photo;
#line 4711 "../src/Photo.vala"
					_tmp22_ = library_photo_get_import_keywords (_tmp21_);
#line 4711 "../src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4711 "../src/Photo.vala"
					_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4711 "../src/Photo.vala"
					_tmp25_ = _tmp24_;
#line 4711 "../src/Photo.vala"
					_g_object_unref0 (_tmp23_);
#line 4711 "../src/Photo.vala"
					_keyword_it = _tmp25_;
#line 4711 "../src/Photo.vala"
					while (TRUE) {
#line 36852 "Photo.c"
						GeeIterator* _tmp26_;
						gchar* keyword = NULL;
						GeeIterator* _tmp27_;
						gpointer _tmp28_;
						gboolean _tmp29_ = FALSE;
						HierarchicalTagIndex* _tmp30_;
						gchar* name = NULL;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						HierarchicalTagIndex* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp45_;
#line 4711 "../src/Photo.vala"
						_tmp26_ = _keyword_it;
#line 4711 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp26_)) {
#line 4711 "../src/Photo.vala"
							break;
#line 36871 "Photo.c"
						}
#line 4711 "../src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4711 "../src/Photo.vala"
						_tmp28_ = gee_iterator_get (_tmp27_);
#line 4711 "../src/Photo.vala"
						keyword = (gchar*) _tmp28_;
#line 4712 "../src/Photo.vala"
						_tmp30_ = htag_index;
#line 4712 "../src/Photo.vala"
						if (_tmp30_ != NULL) {
#line 36883 "Photo.c"
							HierarchicalTagIndex* _tmp31_;
							const gchar* _tmp32_;
#line 4712 "../src/Photo.vala"
							_tmp31_ = htag_index;
#line 4712 "../src/Photo.vala"
							_tmp32_ = keyword;
#line 4712 "../src/Photo.vala"
							_tmp29_ = hierarchical_tag_index_is_tag_in_index (_tmp31_, _tmp32_);
#line 36892 "Photo.c"
						} else {
#line 4712 "../src/Photo.vala"
							_tmp29_ = FALSE;
#line 36896 "Photo.c"
						}
#line 4712 "../src/Photo.vala"
						if (_tmp29_) {
#line 4713 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4713 "../src/Photo.vala"
							continue;
#line 36904 "Photo.c"
						}
#line 4715 "../src/Photo.vala"
						_tmp33_ = keyword;
#line 4715 "../src/Photo.vala"
						_tmp34_ = tag_prep_tag_name (_tmp33_);
#line 4715 "../src/Photo.vala"
						name = _tmp34_;
#line 4717 "../src/Photo.vala"
						_tmp35_ = global_index;
#line 4717 "../src/Photo.vala"
						_tmp36_ = name;
#line 4717 "../src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp35_, _tmp36_)) {
#line 36918 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp37_;
							const gchar* _tmp38_;
							gchar* _tmp39_;
							GeeHashMultiMap* _tmp40_;
							const gchar* _tmp41_;
							Tag* _tmp42_;
							Tag* _tmp43_;
							LibraryPhoto* _tmp44_;
#line 4718 "../src/Photo.vala"
							_tmp37_ = global_index;
#line 4718 "../src/Photo.vala"
							_tmp38_ = name;
#line 4718 "../src/Photo.vala"
							_tmp39_ = hierarchical_tag_index_get_path_for_name (_tmp37_, _tmp38_);
#line 4718 "../src/Photo.vala"
							most_derived_path = _tmp39_;
#line 4719 "../src/Photo.vala"
							_tmp40_ = map;
#line 4719 "../src/Photo.vala"
							_tmp41_ = most_derived_path;
#line 4719 "../src/Photo.vala"
							_tmp42_ = tag_for_path (_tmp41_);
#line 4719 "../src/Photo.vala"
							_tmp43_ = _tmp42_;
#line 4719 "../src/Photo.vala"
							_tmp44_ = photo;
#line 4719 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp43_, _tmp44_);
#line 4719 "../src/Photo.vala"
							_g_object_unref0 (_tmp43_);
#line 4720 "../src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4720 "../src/Photo.vala"
							_g_free0 (name);
#line 4720 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4720 "../src/Photo.vala"
							continue;
#line 36958 "Photo.c"
						}
#line 4723 "../src/Photo.vala"
						_tmp45_ = name;
#line 4723 "../src/Photo.vala"
						if (_tmp45_ != NULL) {
#line 36964 "Photo.c"
							GeeHashMultiMap* _tmp46_;
							const gchar* _tmp47_;
							Tag* _tmp48_;
							Tag* _tmp49_;
							LibraryPhoto* _tmp50_;
#line 4724 "../src/Photo.vala"
							_tmp46_ = map;
#line 4724 "../src/Photo.vala"
							_tmp47_ = name;
#line 4724 "../src/Photo.vala"
							_tmp48_ = tag_for_path (_tmp47_);
#line 4724 "../src/Photo.vala"
							_tmp49_ = _tmp48_;
#line 4724 "../src/Photo.vala"
							_tmp50_ = photo;
#line 4724 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp49_, _tmp50_);
#line 4724 "../src/Photo.vala"
							_g_object_unref0 (_tmp49_);
#line 36984 "Photo.c"
						}
#line 4711 "../src/Photo.vala"
						_g_free0 (name);
#line 4711 "../src/Photo.vala"
						_g_free0 (keyword);
#line 36990 "Photo.c"
					}
#line 4711 "../src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 36994 "Photo.c"
				}
			}
#line 4728 "../src/Photo.vala"
			_tmp52_ = metadata;
#line 4728 "../src/Photo.vala"
			if (_tmp52_ != NULL) {
#line 37001 "Photo.c"
				PhotoMetadata* _tmp53_;
#line 4728 "../src/Photo.vala"
				_tmp53_ = metadata;
#line 4728 "../src/Photo.vala"
				_tmp51_ = photo_metadata_has_hierarchical_keywords (_tmp53_);
#line 37007 "Photo.c"
			} else {
#line 4728 "../src/Photo.vala"
				_tmp51_ = FALSE;
#line 37011 "Photo.c"
			}
#line 4728 "../src/Photo.vala"
			if (_tmp51_) {
#line 37015 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 4729 "../src/Photo.vala"
					_tmp54_ = htag_index;
#line 4729 "../src/Photo.vala"
					_tmp55_ = hierarchical_tag_index_get_all_paths (_tmp54_);
#line 4729 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 4729 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4729 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4729 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 4729 "../src/Photo.vala"
					_path_it = _tmp58_;
#line 4729 "../src/Photo.vala"
					while (TRUE) {
#line 37039 "Photo.c"
						GeeIterator* _tmp59_;
						gchar* path = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						gchar* name = NULL;
						const gchar* _tmp62_;
						gchar* _tmp63_;
						const gchar* _tmp64_;
#line 4729 "../src/Photo.vala"
						_tmp59_ = _path_it;
#line 4729 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 4729 "../src/Photo.vala"
							break;
#line 37054 "Photo.c"
						}
#line 4729 "../src/Photo.vala"
						_tmp60_ = _path_it;
#line 4729 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 4729 "../src/Photo.vala"
						path = (gchar*) _tmp61_;
#line 4730 "../src/Photo.vala"
						_tmp62_ = path;
#line 4730 "../src/Photo.vala"
						_tmp63_ = tag_prep_tag_name (_tmp62_);
#line 4730 "../src/Photo.vala"
						name = _tmp63_;
#line 4731 "../src/Photo.vala"
						_tmp64_ = name;
#line 4731 "../src/Photo.vala"
						if (_tmp64_ != NULL) {
#line 37072 "Photo.c"
							GeeHashMultiMap* _tmp65_;
							const gchar* _tmp66_;
							Tag* _tmp67_;
							Tag* _tmp68_;
							LibraryPhoto* _tmp69_;
#line 4732 "../src/Photo.vala"
							_tmp65_ = map;
#line 4732 "../src/Photo.vala"
							_tmp66_ = name;
#line 4732 "../src/Photo.vala"
							_tmp67_ = tag_for_path (_tmp66_);
#line 4732 "../src/Photo.vala"
							_tmp68_ = _tmp67_;
#line 4732 "../src/Photo.vala"
							_tmp69_ = photo;
#line 4732 "../src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp68_, _tmp69_);
#line 4732 "../src/Photo.vala"
							_g_object_unref0 (_tmp68_);
#line 37092 "Photo.c"
						}
#line 4729 "../src/Photo.vala"
						_g_free0 (name);
#line 4729 "../src/Photo.vala"
						_g_free0 (path);
#line 37098 "Photo.c"
					}
#line 4729 "../src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 37102 "Photo.c"
				}
			}
#line 4692 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4692 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4692 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4692 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4692 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 37115 "Photo.c"
		}
#line 4692 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37119 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp70_;
#line 4737 "../src/Photo.vala"
		_tmp70_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4737 "../src/Photo.vala"
		_media_it = _tmp70_;
#line 4737 "../src/Photo.vala"
		while (TRUE) {
#line 37130 "Photo.c"
			GeeIterator* _tmp71_;
			MediaSource* media = NULL;
			GeeIterator* _tmp72_;
			gpointer _tmp73_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp74_;
			LibraryPhoto* _tmp75_;
			LibraryPhoto* _tmp76_;
#line 4737 "../src/Photo.vala"
			_tmp71_ = _media_it;
#line 4737 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp71_)) {
#line 4737 "../src/Photo.vala"
				break;
#line 37145 "Photo.c"
			}
#line 4737 "../src/Photo.vala"
			_tmp72_ = _media_it;
#line 4737 "../src/Photo.vala"
			_tmp73_ = gee_iterator_get (_tmp72_);
#line 4737 "../src/Photo.vala"
			media = (MediaSource*) _tmp73_;
#line 4738 "../src/Photo.vala"
			_tmp74_ = media;
#line 4738 "../src/Photo.vala"
			_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4738 "../src/Photo.vala"
			photo = _tmp75_;
#line 4739 "../src/Photo.vala"
			_tmp76_ = photo;
#line 4739 "../src/Photo.vala"
			library_photo_clear_import_keywords (_tmp76_);
#line 4737 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4737 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 37167 "Photo.c"
		}
#line 4737 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37171 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp77_;
		GeeSet* _tmp78_;
		GeeSet* _tmp79_;
		GeeIterator* _tmp80_;
		GeeIterator* _tmp81_;
#line 4742 "../src/Photo.vala"
		_tmp77_ = map;
#line 4742 "../src/Photo.vala"
		_tmp78_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 4742 "../src/Photo.vala"
		_tmp79_ = _tmp78_;
#line 4742 "../src/Photo.vala"
		_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4742 "../src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 4742 "../src/Photo.vala"
		_g_object_unref0 (_tmp79_);
#line 4742 "../src/Photo.vala"
		_tag_it = _tmp81_;
#line 4742 "../src/Photo.vala"
		while (TRUE) {
#line 37196 "Photo.c"
			GeeIterator* _tmp82_;
			Tag* tag = NULL;
			GeeIterator* _tmp83_;
			gpointer _tmp84_;
			Tag* _tmp85_;
			GeeHashMultiMap* _tmp86_;
			Tag* _tmp87_;
			GeeCollection* _tmp88_;
			GeeCollection* _tmp89_;
#line 4742 "../src/Photo.vala"
			_tmp82_ = _tag_it;
#line 4742 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp82_)) {
#line 4742 "../src/Photo.vala"
				break;
#line 37212 "Photo.c"
			}
#line 4742 "../src/Photo.vala"
			_tmp83_ = _tag_it;
#line 4742 "../src/Photo.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 4742 "../src/Photo.vala"
			tag = (Tag*) _tmp84_;
#line 4743 "../src/Photo.vala"
			_tmp85_ = tag;
#line 4743 "../src/Photo.vala"
			_tmp86_ = map;
#line 4743 "../src/Photo.vala"
			_tmp87_ = tag;
#line 4743 "../src/Photo.vala"
			_tmp88_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp87_);
#line 4743 "../src/Photo.vala"
			_tmp89_ = _tmp88_;
#line 4743 "../src/Photo.vala"
			tag_attach_many (_tmp85_, _tmp89_);
#line 4743 "../src/Photo.vala"
			_g_object_unref0 (_tmp89_);
#line 4742 "../src/Photo.vala"
			_g_object_unref0 (tag);
#line 37236 "Photo.c"
		}
#line 4742 "../src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 37240 "Photo.c"
	}
#line 4745 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4690 "../src/Photo.vala"
	_g_object_unref0 (map);
#line 37246 "Photo.c"
}


static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4749 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4749 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4750 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37261 "Photo.c"
}


void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4749 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4749 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 37274 "Photo.c"
}


static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4754 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4754 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4755 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37289 "Photo.c"
}


void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4754 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4754 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 37302 "Photo.c"
}


static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4759 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4759 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4760 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37317 "Photo.c"
}


void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4759 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4759 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 37330 "Photo.c"
}


static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4764 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4764 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4765 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37345 "Photo.c"
}


void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4764 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4764 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 37358 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
#line 4768 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4769 "../src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4769 "../src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4769 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
#line 4769 "../src/Photo.vala"
	return result;
#line 37380 "Photo.c"
}


static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4772 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4772 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4772 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4774 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 37397 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4778 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4778 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4778 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4779 "../src/Photo.vala"
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4779 "../src/Photo.vala"
	return result;
#line 37417 "Photo.c"
}


static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4782 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4782 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 4782 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 4784 "../src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 37434 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4788 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4788 "../src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4788 "../src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4789 "../src/Photo.vala"
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4789 "../src/Photo.vala"
	return result;
#line 37454 "Photo.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 37478 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 37487 "Photo.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 37508 "Photo.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 37512 "Photo.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 37518 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 37528 "Photo.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 37532 "Photo.c"
		glong _tmp3_;
#line 1413 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 37540 "Photo.c"
	} else {
		glong _tmp4_;
#line 1416 "glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 37547 "Photo.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 37551 "Photo.c"
		glong _tmp5_;
#line 1419 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 37557 "Photo.c"
	}
#line 1421 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 37569 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
#line 4792 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4792 "../src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4793 "../src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix(Photo.TYPENAME)");
#line 4794 "../src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4794 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4794 "../src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4794 "../src/Photo.vala"
	numeric_only = _tmp2_;
#line 4796 "../src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), parse_int64 (numeric_only, 16));
#line 4796 "../src/Photo.vala"
	result = _tmp3_;
#line 4796 "../src/Photo.vala"
	_g_free0 (numeric_only);
#line 4796 "../src/Photo.vala"
	return result;
#line 37606 "Photo.c"
}


static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
#line 4799 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4799 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4800 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4800 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4800 "../src/Photo.vala"
	_tmp2_ = *event_id;
#line 4800 "../src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4800 "../src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4800 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4800 "../src/Photo.vala"
	result = _tmp4_;
#line 4800 "../src/Photo.vala"
	return result;
#line 37641 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_;
#line 4803 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4803 "../src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4804 "../src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4804 "../src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4804 "../src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp1_);
#line 4804 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4804 "../src/Photo.vala"
	return result;
#line 37667 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4807 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4807 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4808 "../src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4808 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4808 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4808 "../src/Photo.vala"
	return result;
#line 37690 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4811 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4811 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4812 "../src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4812 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4812 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4812 "../src/Photo.vala"
	return result;
#line 37713 "Photo.c"
}


static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4815 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4815 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4815 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4815 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4815 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4815 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_development));
#line 4818 "../src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4818 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4818 "../src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4818 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4818 "../src/Photo.vala"
	if (_tmp2_) {
#line 4819 "../src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 37759 "Photo.c"
	}
#line 4821 "../src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4821 "../src/Photo.vala"
	editable = _tmp3_;
#line 4822 "../src/Photo.vala"
	_tmp5_ = editable;
#line 4822 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 37769 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4822 "../src/Photo.vala"
		_tmp6_ = editable;
#line 4822 "../src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 37775 "Photo.c"
	} else {
#line 4822 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 37779 "Photo.c"
	}
#line 4822 "../src/Photo.vala"
	if (_tmp4_) {
#line 4823 "../src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 37785 "Photo.c"
	}
#line 4825 "../src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4825 "../src/Photo.vala"
	development = _tmp7_;
#line 4826 "../src/Photo.vala"
	_tmp8_ = development;
#line 4826 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 37795 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4827 "../src/Photo.vala"
			_tmp9_ = development;
#line 4827 "../src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4827 "../src/Photo.vala"
			_row_it = _tmp10_;
#line 4827 "../src/Photo.vala"
			while (TRUE) {
#line 37808 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4827 "../src/Photo.vala"
				_tmp11_ = _row_it;
#line 4827 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4827 "../src/Photo.vala"
					break;
#line 37820 "Photo.c"
				}
#line 4827 "../src/Photo.vala"
				_tmp12_ = _row_it;
#line 4827 "../src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4827 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4828 "../src/Photo.vala"
				_tmp14_ = row;
#line 4828 "../src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4829 "../src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4831 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4831 "../src/Photo.vala"
					break;
#line 37838 "Photo.c"
				}
#line 4827 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 37842 "Photo.c"
			}
#line 4827 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 37846 "Photo.c"
		}
	}
#line 4815 "../src/Photo.vala"
	_g_object_unref0 (development);
#line 4815 "../src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 37853 "Photo.c"
}


void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4839 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4839 "../src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 4839 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 4839 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 4839 "../src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matched_development));
#line 37874 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4841 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4841 "../src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4841 "../src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4841 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4841 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4841 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4841 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4841 "../src/Photo.vala"
		_photo_it = _tmp5_;
#line 4841 "../src/Photo.vala"
		while (TRUE) {
#line 37901 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4841 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4841 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4841 "../src/Photo.vala"
				break;
#line 37913 "Photo.c"
			}
#line 4841 "../src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4841 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4841 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4842 "../src/Photo.vala"
			_tmp9_ = photo;
#line 4842 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4841 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 37927 "Photo.c"
		}
#line 4841 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37931 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4844 "../src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4844 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4844 "../src/Photo.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4844 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4844 "../src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4844 "../src/Photo.vala"
		_media_it = _tmp13_;
#line 4844 "../src/Photo.vala"
		while (TRUE) {
#line 37953 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4844 "../src/Photo.vala"
			_tmp14_ = _media_it;
#line 4844 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4844 "../src/Photo.vala"
				break;
#line 37965 "Photo.c"
			}
#line 4844 "../src/Photo.vala"
			_tmp15_ = _media_it;
#line 4844 "../src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4844 "../src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4845 "../src/Photo.vala"
			_tmp17_ = media;
#line 4845 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4844 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 37979 "Photo.c"
		}
#line 4844 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37983 "Photo.c"
	}
}


void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp15_ = {0};
#line 4848 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4848 "../src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 37999 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4849 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4849 "../src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4849 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4849 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4849 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4849 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4849 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 4849 "../src/Photo.vala"
		while (TRUE) {
#line 38023 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 4849 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4849 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4849 "../src/Photo.vala"
				break;
#line 38039 "Photo.c"
			}
#line 4849 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4849 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4849 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4850 "../src/Photo.vala"
			_tmp8_ = photo;
#line 4850 "../src/Photo.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 4850 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4850 "../src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4850 "../src/Photo.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 4850 "../src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4850 "../src/Photo.vala"
			if (_tmp12_) {
#line 38061 "Photo.c"
				LibraryPhoto* _tmp13_;
				PhotoID _tmp14_ = {0};
#line 4851 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4851 "../src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo), &_tmp14_);
#line 4851 "../src/Photo.vala"
				*result = _tmp14_;
#line 4851 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4851 "../src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4851 "../src/Photo.vala"
				return;
#line 38076 "Photo.c"
			}
#line 4849 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 38080 "Photo.c"
		}
#line 4849 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 38084 "Photo.c"
	}
#line 4854 "../src/Photo.vala"
	photo_id_init (&_tmp15_, PHOTO_ID_INVALID);
#line 4854 "../src/Photo.vala"
	*result = _tmp15_;
#line 4854 "../src/Photo.vala"
	return;
#line 38092 "Photo.c"
}


gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 4858 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4858 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4859 "../src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4859 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4859 "../src/Photo.vala"
	return result;
#line 38113 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4862 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4862 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4863 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4863 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4863 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4863 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4863 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4863 "../src/Photo.vala"
	photo = _tmp3_;
#line 4864 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4864 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 38148 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4865 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4865 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4865 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4865 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4865 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4865 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 38164 "Photo.c"
	}
#line 4868 "../src/Photo.vala"
	result = photo;
#line 4868 "../src/Photo.vala"
	return result;
#line 38170 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4871 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4871 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4872 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4872 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4872 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4872 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4872 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4872 "../src/Photo.vala"
	result = _tmp3_;
#line 4872 "../src/Photo.vala"
	return result;
#line 38201 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4875 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4875 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4876 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4876 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4876 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4876 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4876 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4876 "../src/Photo.vala"
	photo = _tmp3_;
#line 4877 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4877 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 38236 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4878 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4878 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4878 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4878 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4878 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4878 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 38252 "Photo.c"
	}
#line 4881 "../src/Photo.vala"
	result = photo;
#line 4881 "../src/Photo.vala"
	return result;
#line 38258 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4884 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4884 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4885 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4885 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4885 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4885 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4885 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4885 "../src/Photo.vala"
	result = _tmp3_;
#line 4885 "../src/Photo.vala"
	return result;
#line 38289 "Photo.c"
}


gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
#line 4888 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4889 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4889 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4889 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank));
#line 4889 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4889 "../src/Photo.vala"
	result = _tmp2_;
#line 4889 "../src/Photo.vala"
	return result;
#line 38314 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
#line 4892 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4892 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 4893 "../src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
#line 4893 "../src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4894 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4894 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4895 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4897 "../src/Photo.vala"
		result = photo;
#line 4897 "../src/Photo.vala"
		if (state) {
#line 4897 "../src/Photo.vala"
			*state = _vala_state;
#line 38358 "Photo.c"
		}
#line 4897 "../src/Photo.vala"
		return result;
#line 38362 "Photo.c"
	}
#line 4900 "../src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4900 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4900 "../src/Photo.vala"
	photo = _tmp2_;
#line 4901 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4901 "../src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4902 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4904 "../src/Photo.vala"
		result = photo;
#line 4904 "../src/Photo.vala"
		if (state) {
#line 4904 "../src/Photo.vala"
			*state = _vala_state;
#line 38382 "Photo.c"
		}
#line 4904 "../src/Photo.vala"
		return result;
#line 38386 "Photo.c"
	}
#line 4907 "../src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4907 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4907 "../src/Photo.vala"
	photo = _tmp4_;
#line 4908 "../src/Photo.vala"
	_tmp5_ = photo;
#line 4908 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4909 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4911 "../src/Photo.vala"
		result = photo;
#line 4911 "../src/Photo.vala"
		if (state) {
#line 4911 "../src/Photo.vala"
			*state = _vala_state;
#line 38406 "Photo.c"
		}
#line 4911 "../src/Photo.vala"
		return result;
#line 38410 "Photo.c"
	}
#line 4914 "../src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4914 "../src/Photo.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4914 "../src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4914 "../src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 38420 "Photo.c"
	}
#line 4914 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4914 "../src/Photo.vala"
	photo = _tmp7_;
#line 4915 "../src/Photo.vala"
	_tmp8_ = photo;
#line 4915 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4916 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4918 "../src/Photo.vala"
		result = photo;
#line 4918 "../src/Photo.vala"
		if (state) {
#line 4918 "../src/Photo.vala"
			*state = _vala_state;
#line 38438 "Photo.c"
		}
#line 4918 "../src/Photo.vala"
		return result;
#line 38442 "Photo.c"
	}
#line 4921 "../src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 4921 "../src/Photo.vala"
	_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 4921 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 4921 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 38452 "Photo.c"
	}
#line 4921 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4921 "../src/Photo.vala"
	photo = _tmp10_;
#line 4922 "../src/Photo.vala"
	_tmp11_ = photo;
#line 4922 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4923 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4925 "../src/Photo.vala"
		result = photo;
#line 4925 "../src/Photo.vala"
		if (state) {
#line 4925 "../src/Photo.vala"
			*state = _vala_state;
#line 38470 "Photo.c"
		}
#line 4925 "../src/Photo.vala"
		return result;
#line 38474 "Photo.c"
	}
#line 4928 "../src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4930 "../src/Photo.vala"
	result = NULL;
#line 4930 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4930 "../src/Photo.vala"
	if (state) {
#line 4930 "../src/Photo.vala"
		*state = _vala_state;
#line 38486 "Photo.c"
	}
#line 4930 "../src/Photo.vala"
	return result;
#line 38490 "Photo.c"
}


static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
#line 4933 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4933 "../src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4934 "../src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink)) {
#line 4935 "../src/Photo.vala"
		result = TRUE;
#line 4935 "../src/Photo.vala"
		return result;
#line 38516 "Photo.c"
	}
#line 4937 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4937 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4937 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4937 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4937 "../src/Photo.vala"
	if (_tmp2_) {
#line 4938 "../src/Photo.vala"
		result = TRUE;
#line 4938 "../src/Photo.vala"
		return result;
#line 38532 "Photo.c"
	}
#line 4940 "../src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4940 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4940 "../src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4940 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4940 "../src/Photo.vala"
	if (_tmp5_) {
#line 4941 "../src/Photo.vala"
		result = TRUE;
#line 4941 "../src/Photo.vala"
		return result;
#line 38548 "Photo.c"
	}
#line 4943 "../src/Photo.vala"
	result = FALSE;
#line 4943 "../src/Photo.vala"
	return result;
#line 38554 "Photo.c"
}


static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4946 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4946 "../src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4947 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4947 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4947 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4947 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4948 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4948 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4948 "../src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4948 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4950 "../src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink);
#line 38589 "Photo.c"
}


static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4467 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4468 "../src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4468 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 38606 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4469 "../src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4469 "../src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4469 "../src/Photo.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 38614 "Photo.c"
	}
#line 4471 "../src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4471 "../src/Photo.vala"
	result = _tmp2_;
#line 4471 "../src/Photo.vala"
	return result;
#line 38622 "Photo.c"
}


static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4489 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4489 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 38635 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4456 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4456 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4456 "../src/Photo.vala"
		data1 = closure->data;
#line 4456 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 38661 "Photo.c"
	} else {
#line 4456 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4456 "../src/Photo.vala"
		data2 = closure->data;
#line 38667 "Photo.c"
	}
#line 4456 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4456 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 38673 "Photo.c"
}


static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4492 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4492 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 38686 "Photo.c"
}


static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4495 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4495 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 38699 "Photo.c"
}


static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4498 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4498 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 38712 "Photo.c"
}


static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass)
{
#line 4456 "../src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4456 "../src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4456 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceCollection_private_offset);
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4456 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4456 "../src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4456 "../src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4456 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4456 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4456 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4456 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4456 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4456 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4456 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4456 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4456 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 38779 "Photo.c"
}


static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4456 "../src/Photo.vala"
	self->priv = library_photo_source_collection_get_instance_private (self);
#line 4475 "../src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4476 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4476 "../src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4478 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4478 "../src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4480 "../src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4480 "../src/Photo.vala"
	self->priv->filesize_to_photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 4482 "../src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4482 "../src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4484 "../src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4484 "../src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4486 "../src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4486 "../src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 38820 "Photo.c"
}


static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4456 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4475 "../src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4476 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4478 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4480 "../src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4482 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4484 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4486 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4456 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 38846 "Photo.c"
}


GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		LibraryPhotoSourceCollection_private_offset = g_type_add_instance_private (library_photo_source_collection_type_id, sizeof (LibraryPhotoSourceCollectionPrivate));
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static inline gpointer
library_photo_get_instance_private (LibraryPhoto* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhoto_private_offset);
}


static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 4978 "../src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 38877 "Photo.c"
}


static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
	guint64 _tmp1_;
	guint64 _tmp4_;
#line 4973 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 4974 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 4976 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4976 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4978 "../src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4978 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4978 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 4981 "../src/Photo.vala"
	_tmp1_ = row->flags;
#line 4981 "../src/Photo.vala"
	if ((_tmp1_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38907 "Photo.c"
		LibraryPhotoSourceCollection* _tmp2_;
		const gchar* _tmp3_;
#line 4982 "../src/Photo.vala"
		_tmp2_ = library_photo_global;
#line 4982 "../src/Photo.vala"
		_tmp3_ = row->backlinks;
#line 4982 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp3_);
#line 38916 "Photo.c"
	}
#line 4984 "../src/Photo.vala"
	_tmp4_ = row->flags;
#line 4984 "../src/Photo.vala"
	if ((_tmp4_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 38922 "Photo.c"
		guint64 _tmp5_;
#line 4985 "../src/Photo.vala"
		_tmp5_ = row->flags;
#line 4985 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp5_);
#line 38928 "Photo.c"
	}
#line 4973 "../src/Photo.vala"
	return self;
#line 38932 "Photo.c"
}


static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 4973 "../src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 38941 "Photo.c"
}


static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
	guint64 _tmp5_;
	PhotoRow* _tmp9_;
	guint64 _tmp10_;
#line 4988 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 4989 "../src/Photo.vala"
	_tmp0_ = import_params->row;
#line 4989 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4991 "../src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 4991 "../src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 4991 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4991 "../src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 4992 "../src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4992 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4992 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 4995 "../src/Photo.vala"
	_tmp4_ = import_params->row;
#line 4995 "../src/Photo.vala"
	_tmp5_ = _tmp4_->flags;
#line 4995 "../src/Photo.vala"
	if ((_tmp5_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 38984 "Photo.c"
		LibraryPhotoSourceCollection* _tmp6_;
		PhotoRow* _tmp7_;
		const gchar* _tmp8_;
#line 4996 "../src/Photo.vala"
		_tmp6_ = library_photo_global;
#line 4996 "../src/Photo.vala"
		_tmp7_ = import_params->row;
#line 4996 "../src/Photo.vala"
		_tmp8_ = _tmp7_->backlinks;
#line 4996 "../src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp8_);
#line 38996 "Photo.c"
	}
#line 4998 "../src/Photo.vala"
	_tmp9_ = import_params->row;
#line 4998 "../src/Photo.vala"
	_tmp10_ = _tmp9_->flags;
#line 4998 "../src/Photo.vala"
	if ((_tmp10_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 39004 "Photo.c"
		PhotoRow* _tmp11_;
		guint64 _tmp12_;
#line 4999 "../src/Photo.vala"
		_tmp11_ = import_params->row;
#line 4999 "../src/Photo.vala"
		_tmp12_ = _tmp11_->flags;
#line 4999 "../src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp12_);
#line 39013 "Photo.c"
	}
#line 4988 "../src/Photo.vala"
	return self;
#line 39017 "Photo.c"
}


static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 4988 "../src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 39026 "Photo.c"
}


void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp32_;
	GeeArrayList* _tmp33_;
	GeeCollection* _tmp34_;
	GeeCollection* _tmp35_;
	LibraryPhotoSourceCollection* _tmp36_;
	GeeArrayList* _tmp37_;
	LibraryPhotoSourceCollection* _tmp38_;
	GeeArrayList* _tmp39_;
#line 5003 "../src/Photo.vala"
	photo_init_photo ();
#line 5005 "../src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5005 "../src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5005 "../src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5009 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5009 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5009 "../src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5009 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5009 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5009 "../src/Photo.vala"
	all = _tmp4_;
#line 5010 "../src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5010 "../src/Photo.vala"
	all_photos = _tmp5_;
#line 5011 "../src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5011 "../src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5012 "../src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5012 "../src/Photo.vala"
	offline_photos = _tmp7_;
#line 5013 "../src/Photo.vala"
	_tmp8_ = all;
#line 5013 "../src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 5013 "../src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5013 "../src/Photo.vala"
	count = _tmp10_;
#line 39098 "Photo.c"
	{
		gint ctr = 0;
#line 5014 "../src/Photo.vala"
		ctr = 0;
#line 39103 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5014 "../src/Photo.vala"
			_tmp11_ = TRUE;
#line 5014 "../src/Photo.vala"
			while (TRUE) {
#line 39110 "Photo.c"
				gint _tmp13_;
				gint _tmp14_;
				PhotoRow* row = NULL;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp18_;
				LibraryPhoto* _tmp19_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp20_;
				guint64 _tmp21_;
				guint64 _tmp22_;
#line 5014 "../src/Photo.vala"
				if (!_tmp11_) {
#line 39126 "Photo.c"
					gint _tmp12_;
#line 5014 "../src/Photo.vala"
					_tmp12_ = ctr;
#line 5014 "../src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 39132 "Photo.c"
				}
#line 5014 "../src/Photo.vala"
				_tmp11_ = FALSE;
#line 5014 "../src/Photo.vala"
				_tmp13_ = ctr;
#line 5014 "../src/Photo.vala"
				_tmp14_ = count;
#line 5014 "../src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 5014 "../src/Photo.vala"
					break;
#line 39144 "Photo.c"
				}
#line 5015 "../src/Photo.vala"
				_tmp15_ = all;
#line 5015 "../src/Photo.vala"
				_tmp16_ = ctr;
#line 5015 "../src/Photo.vala"
				_tmp17_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp16_);
#line 5015 "../src/Photo.vala"
				row = (PhotoRow*) _tmp17_;
#line 5016 "../src/Photo.vala"
				_tmp18_ = row;
#line 5016 "../src/Photo.vala"
				_tmp19_ = library_photo_new (_tmp18_);
#line 5016 "../src/Photo.vala"
				photo = _tmp19_;
#line 5017 "../src/Photo.vala"
				_tmp20_ = row;
#line 5017 "../src/Photo.vala"
				_tmp21_ = _tmp20_->flags;
#line 5017 "../src/Photo.vala"
				flags = _tmp21_;
#line 5019 "../src/Photo.vala"
				_tmp22_ = flags;
#line 5019 "../src/Photo.vala"
				if ((_tmp22_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 39170 "Photo.c"
					GeeArrayList* _tmp23_;
					LibraryPhoto* _tmp24_;
#line 5020 "../src/Photo.vala"
					_tmp23_ = trashed_photos;
#line 5020 "../src/Photo.vala"
					_tmp24_ = photo;
#line 5020 "../src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 39179 "Photo.c"
				} else {
					guint64 _tmp25_;
#line 5021 "../src/Photo.vala"
					_tmp25_ = flags;
#line 5021 "../src/Photo.vala"
					if ((_tmp25_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 39186 "Photo.c"
						GeeArrayList* _tmp26_;
						LibraryPhoto* _tmp27_;
#line 5022 "../src/Photo.vala"
						_tmp26_ = offline_photos;
#line 5022 "../src/Photo.vala"
						_tmp27_ = photo;
#line 5022 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp27_);
#line 39195 "Photo.c"
					} else {
						GeeArrayList* _tmp28_;
						LibraryPhoto* _tmp29_;
#line 5024 "../src/Photo.vala"
						_tmp28_ = all_photos;
#line 5024 "../src/Photo.vala"
						_tmp29_ = photo;
#line 5024 "../src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp29_);
#line 39205 "Photo.c"
					}
				}
#line 5026 "../src/Photo.vala"
				if (monitor != NULL) {
#line 39210 "Photo.c"
					gint _tmp30_;
					gint _tmp31_;
#line 5027 "../src/Photo.vala"
					_tmp30_ = ctr;
#line 5027 "../src/Photo.vala"
					_tmp31_ = count;
#line 5027 "../src/Photo.vala"
					monitor ((guint64) _tmp30_, (guint64) _tmp31_, TRUE, monitor_target);
#line 39219 "Photo.c"
				}
#line 5014 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5014 "../src/Photo.vala"
				_photo_row_unref0 (row);
#line 39225 "Photo.c"
			}
		}
	}
#line 5030 "../src/Photo.vala"
	_tmp32_ = library_photo_global;
#line 5030 "../src/Photo.vala"
	_tmp33_ = all_photos;
#line 5030 "../src/Photo.vala"
	_tmp34_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 5030 "../src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 5030 "../src/Photo.vala"
	_g_object_unref0 (_tmp35_);
#line 5031 "../src/Photo.vala"
	_tmp36_ = library_photo_global;
#line 5031 "../src/Photo.vala"
	_tmp37_ = trashed_photos;
#line 5031 "../src/Photo.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5032 "../src/Photo.vala"
	_tmp38_ = library_photo_global;
#line 5032 "../src/Photo.vala"
	_tmp39_ = offline_photos;
#line 5032 "../src/Photo.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5002 "../src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5002 "../src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5002 "../src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5002 "../src/Photo.vala"
	_g_object_unref0 (all);
#line 39259 "Photo.c"
}


void
library_photo_terminate (void)
{
#line 5036 "../src/Photo.vala"
	photo_terminate_photo ();
#line 39268 "Photo.c"
}


ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto* * photo)
{
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
#line 5043 "../src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 5045 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5045 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5045 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 5045 "../src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5045 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5045 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5045 "../src/Photo.vala"
	photo_id = _tmp4_;
#line 5046 "../src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5047 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5047 "../src/Photo.vala"
		_vala_photo = NULL;
#line 5049 "../src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5049 "../src/Photo.vala"
		if (photo) {
#line 5049 "../src/Photo.vala"
			*photo = _vala_photo;
#line 39313 "Photo.c"
		} else {
#line 5049 "../src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 39317 "Photo.c"
		}
#line 5049 "../src/Photo.vala"
		return result;
#line 39321 "Photo.c"
	}
#line 5053 "../src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5053 "../src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5053 "../src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5055 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5055 "../src/Photo.vala"
	if (photo) {
#line 5055 "../src/Photo.vala"
		*photo = _vala_photo;
#line 39335 "Photo.c"
	} else {
#line 5055 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 39339 "Photo.c"
	}
#line 5055 "../src/Photo.vala"
	return result;
#line 39343 "Photo.c"
}


void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5058 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 39353 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5060 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5060 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5060 "../src/Photo.vala"
		photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo), &_tmp2_);
#line 5060 "../src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5060 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5060 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5060 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 39372 "Photo.c"
				goto __catch415_database_error;
			}
#line 5060 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5060 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5060 "../src/Photo.vala"
			return;
#line 39381 "Photo.c"
		}
	}
	goto __finally415;
	__catch415_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5059 "../src/Photo.vala"
		err = _inner_error0_;
#line 5059 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5062 "../src/Photo.vala"
		_tmp3_ = err;
#line 5062 "../src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5059 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39399 "Photo.c"
	}
	__finally415:
#line 5059 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5059 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5059 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5059 "../src/Photo.vala"
		return;
#line 39410 "Photo.c"
	}
}


static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5066 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5066 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5067 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5069 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5069 "../src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 39431 "Photo.c"
}


static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5072 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5072 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5073 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5075 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5075 "../src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 39451 "Photo.c"
}


static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5078 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5078 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5079 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5081 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5081 "../src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 39471 "Photo.c"
}


static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5084 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5084 "../src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5085 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5087 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5087 "../src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 39491 "Photo.c"
}


static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5090 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 39501 "Photo.c"
	{
#line 5092 "../src/Photo.vala"
		thumbnail_cache_import_from_source (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), TRUE, &_inner_error0_);
#line 5092 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39507 "Photo.c"
			goto __catch416_g_error;
		}
	}
	goto __finally416;
	__catch416_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5091 "../src/Photo.vala"
		err = _inner_error0_;
#line 5091 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5094 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5094 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5094 "../src/Photo.vala"
		_tmp2_ = err;
#line 5094 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5094 "../src/Photo.vala"
		g_warning ("Photo.vala:5094: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5094 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5091 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39537 "Photo.c"
	}
	__finally416:
#line 5091 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5091 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5091 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5091 "../src/Photo.vala"
		return;
#line 39548 "Photo.c"
	}
#line 5098 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39552 "Photo.c"
}


GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 5102 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5103 "../src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5103 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5103 "../src/Photo.vala"
	result = _tmp1_;
#line 5103 "../src/Photo.vala"
	return result;
#line 39572 "Photo.c"
}


void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5106 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5107 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5107 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 39585 "Photo.c"
}


static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 5110 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5110 "../src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 5112 "../src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 5112 "../src/Photo.vala"
	if (!_tmp1_) {
#line 5112 "../src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 39606 "Photo.c"
	} else {
#line 5112 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 39610 "Photo.c"
	}
#line 5112 "../src/Photo.vala"
	if (_tmp0_) {
#line 39614 "Photo.c"
		OneShotScheduler* _tmp2_;
#line 5113 "../src/Photo.vala"
		_tmp2_ = self->priv->thumbnail_scheduler;
#line 5113 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp2_, G_PRIORITY_LOW);
#line 39620 "Photo.c"
	}
#line 5115 "../src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_OBJECT, DataObject), alteration);
#line 39624 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 5118 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5118 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5119 "../src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5119 "../src/Photo.vala"
	pixbuf = _tmp0_;
#line 5119 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5119 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5119 "../src/Photo.vala"
		return NULL;
#line 39653 "Photo.c"
	}
#line 5121 "../src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5121 "../src/Photo.vala"
	result = _tmp1_;
#line 5121 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5121 "../src/Photo.vala"
	return result;
#line 39663 "Photo.c"
}


static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5124 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5126 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5127 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5128 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 39681 "Photo.c"
	{
#line 5136 "../src/Photo.vala"
		thumbnail_cache_rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), rotation, &_inner_error0_);
#line 5136 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39687 "Photo.c"
			goto __catch417_g_error;
		}
	}
	goto __finally417;
	__catch417_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5135 "../src/Photo.vala"
		err = _inner_error0_;
#line 5135 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5139 "../src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5139 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5139 "../src/Photo.vala"
		_tmp2_ = err;
#line 5139 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5139 "../src/Photo.vala"
		g_warning ("Photo.vala:5139: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5139 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5135 "../src/Photo.vala"
		_g_error_free0 (err);
#line 39717 "Photo.c"
	}
	__finally417:
#line 5135 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5135 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5135 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5135 "../src/Photo.vala"
		return;
#line 39728 "Photo.c"
	}
#line 5142 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39732 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 5146 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5147 "../src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
#line 5147 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5147 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5147 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5147 "../src/Photo.vala"
		return NULL;
#line 39759 "Photo.c"
	}
#line 5147 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5147 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 5147 "../src/Photo.vala"
	result = _tmp2_;
#line 5147 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5147 "../src/Photo.vala"
	return result;
#line 39771 "Photo.c"
}


static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5159 "../src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 39782 "Photo.c"
}


static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5152 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5152 "../src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 5153 "../src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5154 "../src/Photo.vala"
	if (backing == NULL) {
#line 5154 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 39809 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5154 "../src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5154 "../src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 39816 "Photo.c"
	}
#line 5154 "../src/Photo.vala"
	if (_tmp0_) {
#line 5155 "../src/Photo.vala"
		*result = backing_id;
#line 5155 "../src/Photo.vala"
		return;
#line 39824 "Photo.c"
	}
#line 5157 "../src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5157 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5157 "../src/Photo.vala"
	file = _tmp3_;
#line 5158 "../src/Photo.vala"
	_tmp4_ = file;
#line 5158 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 39836 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5159 "../src/Photo.vala"
		_tmp5_ = file;
#line 5159 "../src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5159 "../src/Photo.vala"
		dupe_file = _tmp6_;
#line 5159 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5159 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5159 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5159 "../src/Photo.vala"
			return;
#line 39860 "Photo.c"
		}
#line 5162 "../src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5162 "../src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5162 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5162 "../src/Photo.vala"
		detected = _tmp8_;
#line 5162 "../src/Photo.vala"
		state = _tmp9_;
#line 5162 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5162 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5162 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5162 "../src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5162 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5162 "../src/Photo.vala"
			return;
#line 39884 "Photo.c"
		}
#line 5164 "../src/Photo.vala"
		_tmp10_ = state;
#line 5164 "../src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 39890 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5165 "../src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5165 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5165 "../src/Photo.vala"
			_tmp13_ = state;
#line 5165 "../src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5165 "../src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5165 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5165 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5165 "../src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5165 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5165 "../src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5165 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 5165 "../src/Photo.vala"
				return;
#line 39920 "Photo.c"
			}
#line 5166 "../src/Photo.vala"
			_tmp14_ = state;
#line 5166 "../src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5166 "../src/Photo.vala"
			backing_id = _tmp15_;
#line 39928 "Photo.c"
		}
#line 5158 "../src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5158 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5158 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 39936 "Photo.c"
	}
#line 5170 "../src/Photo.vala"
	*result = backing_id;
#line 5170 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 5170 "../src/Photo.vala"
	return;
#line 39944 "Photo.c"
}


LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GError* _inner_error0_ = NULL;
#line 5173 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5175 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5175 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5175 "../src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5175 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5175 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5175 "../src/Photo.vala"
	dupe_file = _tmp3_;
#line 5175 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5175 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5175 "../src/Photo.vala"
		return NULL;
#line 40032 "Photo.c"
	}
#line 5178 "../src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 5178 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5178 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5178 "../src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5178 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5178 "../src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5178 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5178 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5178 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5178 "../src/Photo.vala"
		return NULL;
#line 40054 "Photo.c"
	}
#line 5179 "../src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_SHOTWELL);
#line 5179 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5179 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5179 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5179 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5179 "../src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5179 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5179 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5179 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5179 "../src/Photo.vala"
		return NULL;
#line 40076 "Photo.c"
	}
#line 5181 "../src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA);
#line 5181 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5181 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5181 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5181 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5181 "../src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5181 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5181 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5181 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5181 "../src/Photo.vala"
		return NULL;
#line 40098 "Photo.c"
	}
#line 5183 "../src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_EMBEDDED);
#line 5183 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5183 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5183 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5183 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5183 "../src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5183 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5183 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5183 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5183 "../src/Photo.vala"
		return NULL;
#line 40120 "Photo.c"
	}
#line 5187 "../src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5187 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5187 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp22_);
#line 5187 "../src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5187 "../src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5187 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5187 "../src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5187 "../src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5187 "../src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5187 "../src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5187 "../src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5187 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5187 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5187 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5187 "../src/Photo.vala"
	dupe_id = _tmp31_;
#line 5189 "../src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5189 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5189 "../src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5189 "../src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5189 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5189 "../src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5189 "../src/Photo.vala"
	dupe_row = _tmp36_;
#line 5192 "../src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5192 "../src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5192 "../src/Photo.vala"
	dupe = _tmp38_;
#line 5195 "../src/Photo.vala"
	_tmp39_ = dupe;
#line 5195 "../src/Photo.vala"
	thumbnail_cache_duplicate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 5198 "../src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5198 "../src/Photo.vala"
	_tmp41_ = dupe;
#line 5198 "../src/Photo.vala"
	data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5201 "../src/Photo.vala"
	_tmp42_ = dupe;
#line 5201 "../src/Photo.vala"
	_tmp43_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5201 "../src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5201 "../src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5201 "../src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5201 "../src/Photo.vala"
	if (_tmp45_) {
#line 40194 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5202 "../src/Photo.vala"
		_tmp46_ = dupe;
#line 5202 "../src/Photo.vala"
		_tmp47_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5202 "../src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5202 "../src/Photo.vala"
		_tmp49_ = dupe;
#line 5202 "../src/Photo.vala"
		event_attach (_tmp48_, G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5202 "../src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 40211 "Photo.c"
	}
#line 5205 "../src/Photo.vala"
	_tmp50_ = tag_global;
#line 5205 "../src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5205 "../src/Photo.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5206 "../src/Photo.vala"
	_tmp52_ = tags;
#line 5206 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 40223 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5207 "../src/Photo.vala"
			_tmp53_ = tags;
#line 5207 "../src/Photo.vala"
			_tmp54_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5207 "../src/Photo.vala"
			_tag_it = _tmp54_;
#line 5207 "../src/Photo.vala"
			while (TRUE) {
#line 40236 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5207 "../src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5207 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5207 "../src/Photo.vala"
					break;
#line 40249 "Photo.c"
				}
#line 5207 "../src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5207 "../src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5207 "../src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5208 "../src/Photo.vala"
				_tmp58_ = tag;
#line 5208 "../src/Photo.vala"
				_tmp59_ = dupe;
#line 5208 "../src/Photo.vala"
				tag_attach (_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5207 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 40265 "Photo.c"
			}
#line 5207 "../src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 40269 "Photo.c"
		}
	}
#line 5228 "../src/Photo.vala"
	result = dupe;
#line 5228 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5228 "../src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5228 "../src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5228 "../src/Photo.vala"
	return result;
#line 40282 "Photo.c"
}


static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5231 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5232 "../src/Photo.vala"
	spin_event_loop ();
#line 40295 "Photo.c"
}


static void
library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                    guint64 flags)
{
#line 5235 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5236 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 5237 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_REJECTED);
#line 5238 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 40311 "Photo.c"
	}
#line 5241 "../src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 5242 "../src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_FIVE);
#line 5243 "../src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 40319 "Photo.c"
	}
}


static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5248 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5249 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH);
#line 5249 "../src/Photo.vala"
	return result;
#line 40335 "Photo.c"
}


static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5252 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5253 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 40347 "Photo.c"
}


static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5256 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5257 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 40359 "Photo.c"
}


static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5260 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5261 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5261 "../src/Photo.vala"
	return result;
#line 40374 "Photo.c"
}


static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5264 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5265 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 40386 "Photo.c"
}


static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5268 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5269 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 40398 "Photo.c"
}


static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5272 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5273 "../src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5273 "../src/Photo.vala"
	return result;
#line 40413 "Photo.c"
}


static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5276 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5277 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5277 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5277 "../src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5277 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 40433 "Photo.c"
}


static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5280 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5281 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5281 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5281 "../src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5281 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 40453 "Photo.c"
}


static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 5284 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5287 "../src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 5287 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40471 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5287 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5287 "../src/Photo.vala"
		return _tmp1_;
#line 40477 "Photo.c"
	}
#line 5287 "../src/Photo.vala"
	if (!_tmp0_) {
#line 5288 "../src/Photo.vala"
		result = FALSE;
#line 5288 "../src/Photo.vala"
		return result;
#line 40485 "Photo.c"
	}
#line 5290 "../src/Photo.vala"
	result = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5290 "../src/Photo.vala"
	return result;
#line 40491 "Photo.c"
}


static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5293 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5294 "../src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp0_);
#line 5294 "../src/Photo.vala"
	photo_id = _tmp0_;
#line 5297 "../src/Photo.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 40510 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5303 "../src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5303 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5303 "../src/Photo.vala"
		_tmp3_ = photo_id;
#line 5303 "../src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5303 "../src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5303 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5303 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 40529 "Photo.c"
				goto __catch418_database_error;
			}
#line 5303 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5303 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5303 "../src/Photo.vala"
			return;
#line 40538 "Photo.c"
		}
	}
	goto __finally418;
	__catch418_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5302 "../src/Photo.vala"
		err = _inner_error0_;
#line 5302 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5305 "../src/Photo.vala"
		_tmp4_ = err;
#line 5305 "../src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5302 "../src/Photo.vala"
		_g_error_free0 (err);
#line 40556 "Photo.c"
	}
	__finally418:
#line 5302 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5302 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5302 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5302 "../src/Photo.vala"
		return;
#line 40567 "Photo.c"
	}
#line 5308 "../src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource));
#line 40571 "Photo.c"
}


gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 5311 "../src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 5313 "../src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5313 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5313 "../src/Photo.vala"
	return result;
#line 40591 "Photo.c"
}


void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5316 "../src/Photo.vala"
	g_return_if_fail ((file == NULL) || G_IS_FILE (file));
#line 5318 "../src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5318 "../src/Photo.vala"
	ids = _tmp1_;
#line 5318 "../src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5318 "../src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5320 "../src/Photo.vala"
	_tmp3_ = ids;
#line 5320 "../src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5320 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5320 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 40631 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5320 "../src/Photo.vala"
		_tmp4_ = ids;
#line 5320 "../src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5320 "../src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 40641 "Photo.c"
	}
#line 5320 "../src/Photo.vala"
	if (_tmp2_) {
#line 40645 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5321 "../src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5321 "../src/Photo.vala"
		*result = _tmp5_;
#line 5321 "../src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5321 "../src/Photo.vala"
		return;
#line 40655 "Photo.c"
	}
#line 5323 "../src/Photo.vala"
	_tmp6_ = ids;
#line 5323 "../src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 40661 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5323 "../src/Photo.vala"
		id_collection = _tmp6_;
#line 5323 "../src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5323 "../src/Photo.vala"
		for (id_it = 0; id_it < _tmp6__length1; id_it = id_it + 1) {
#line 40673 "Photo.c"
			PhotoID id = {0};
#line 5323 "../src/Photo.vala"
			id = id_collection[id_it];
#line 40677 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5324 "../src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5324 "../src/Photo.vala"
				_tmp8_ = id;
#line 5324 "../src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5324 "../src/Photo.vala"
				photo = _tmp9_;
#line 5325 "../src/Photo.vala"
				_tmp11_ = photo;
#line 5325 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 40697 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5325 "../src/Photo.vala"
					_tmp12_ = photo;
#line 5325 "../src/Photo.vala"
					_tmp10_ = !media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_MEDIA_SOURCE, MediaSource));
#line 40703 "Photo.c"
				} else {
#line 5325 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 40707 "Photo.c"
				}
#line 5325 "../src/Photo.vala"
				if (_tmp10_) {
#line 5326 "../src/Photo.vala"
					*result = id;
#line 5326 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 5326 "../src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5326 "../src/Photo.vala"
					return;
#line 40719 "Photo.c"
				}
#line 5323 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 40723 "Photo.c"
			}
		}
	}
#line 5329 "../src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5329 "../src/Photo.vala"
	*result = _tmp13_;
#line 5329 "../src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5329 "../src/Photo.vala"
	return;
#line 40735 "Photo.c"
}


static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp10_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp11_;
	GeeSet* _tmp12_;
	gint _tmp13_ = 0;
	GeeList* _tmp14_;
	gint tags_count = 0;
	gint _tmp18_ = 0;
	GeeSet* _tmp19_;
	gint keywords_count = 0;
	gint _tmp23_;
	gint _tmp24_;
	gboolean _tmp25_ = FALSE;
	GeeList* _tmp26_;
#line 5332 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5333 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5333 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5333 "../src/Photo.vala"
	tags = _tmp1_;
#line 5335 "../src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5335 "../src/Photo.vala"
	metadata = _tmp2_;
#line 5336 "../src/Photo.vala"
	_tmp3_ = metadata;
#line 5336 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 40780 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		GeeList* _tmp6_;
#line 5337 "../src/Photo.vala"
		_tmp6_ = tags;
#line 5337 "../src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 5337 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 40790 "Photo.c"
		} else {
			GeeList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 5337 "../src/Photo.vala"
			_tmp7_ = tags;
#line 5337 "../src/Photo.vala"
			_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5337 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5337 "../src/Photo.vala"
			_tmp5_ = _tmp9_ > 0;
#line 40803 "Photo.c"
		}
#line 5337 "../src/Photo.vala"
		if (_tmp5_) {
#line 5337 "../src/Photo.vala"
			_tmp4_ = TRUE;
#line 40809 "Photo.c"
		} else {
#line 5337 "../src/Photo.vala"
			_tmp4_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != RATING_UNRATED;
#line 40813 "Photo.c"
		}
#line 5337 "../src/Photo.vala"
		result = _tmp4_;
#line 5337 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5337 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5337 "../src/Photo.vala"
		return result;
#line 40823 "Photo.c"
	}
#line 5339 "../src/Photo.vala"
	_tmp10_ = metadata;
#line 5339 "../src/Photo.vala"
	if (media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != photo_metadata_get_rating (_tmp10_)) {
#line 5340 "../src/Photo.vala"
		result = TRUE;
#line 5340 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5340 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5340 "../src/Photo.vala"
		return result;
#line 40837 "Photo.c"
	}
#line 5342 "../src/Photo.vala"
	_tmp11_ = metadata;
#line 5342 "../src/Photo.vala"
	_tmp12_ = photo_metadata_get_keywords (_tmp11_, NULL, NULL, NULL);
#line 5342 "../src/Photo.vala"
	keywords = _tmp12_;
#line 5343 "../src/Photo.vala"
	_tmp14_ = tags;
#line 5343 "../src/Photo.vala"
	if (_tmp14_ != NULL) {
#line 40849 "Photo.c"
		GeeList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 5343 "../src/Photo.vala"
		_tmp15_ = tags;
#line 5343 "../src/Photo.vala"
		_tmp16_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5343 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 5343 "../src/Photo.vala"
		_tmp13_ = _tmp17_;
#line 40861 "Photo.c"
	} else {
#line 5343 "../src/Photo.vala"
		_tmp13_ = 0;
#line 40865 "Photo.c"
	}
#line 5343 "../src/Photo.vala"
	tags_count = _tmp13_;
#line 5344 "../src/Photo.vala"
	_tmp19_ = keywords;
#line 5344 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 40873 "Photo.c"
		GeeSet* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 5344 "../src/Photo.vala"
		_tmp20_ = keywords;
#line 5344 "../src/Photo.vala"
		_tmp21_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5344 "../src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 5344 "../src/Photo.vala"
		_tmp18_ = _tmp22_;
#line 40885 "Photo.c"
	} else {
#line 5344 "../src/Photo.vala"
		_tmp18_ = 0;
#line 40889 "Photo.c"
	}
#line 5344 "../src/Photo.vala"
	keywords_count = _tmp18_;
#line 5346 "../src/Photo.vala"
	_tmp23_ = tags_count;
#line 5346 "../src/Photo.vala"
	_tmp24_ = keywords_count;
#line 5346 "../src/Photo.vala"
	if (_tmp23_ != _tmp24_) {
#line 5347 "../src/Photo.vala"
		result = TRUE;
#line 5347 "../src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5347 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5347 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5347 "../src/Photo.vala"
		return result;
#line 40909 "Photo.c"
	}
#line 5349 "../src/Photo.vala"
	_tmp26_ = tags;
#line 5349 "../src/Photo.vala"
	if (_tmp26_ != NULL) {
#line 40915 "Photo.c"
		GeeSet* _tmp27_;
#line 5349 "../src/Photo.vala"
		_tmp27_ = keywords;
#line 5349 "../src/Photo.vala"
		_tmp25_ = _tmp27_ != NULL;
#line 40921 "Photo.c"
	} else {
#line 5349 "../src/Photo.vala"
		_tmp25_ = FALSE;
#line 40925 "Photo.c"
	}
#line 5349 "../src/Photo.vala"
	if (_tmp25_) {
#line 40929 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp28_;
			GeeList* _tmp29_;
			gint _tag_size = 0;
			GeeList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _tag_index = 0;
#line 5350 "../src/Photo.vala"
			_tmp28_ = tags;
#line 5350 "../src/Photo.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 5350 "../src/Photo.vala"
			_tag_list = _tmp29_;
#line 5350 "../src/Photo.vala"
			_tmp30_ = _tag_list;
#line 5350 "../src/Photo.vala"
			_tmp31_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5350 "../src/Photo.vala"
			_tmp32_ = _tmp31_;
#line 5350 "../src/Photo.vala"
			_tag_size = _tmp32_;
#line 5350 "../src/Photo.vala"
			_tag_index = -1;
#line 5350 "../src/Photo.vala"
			while (TRUE) {
#line 40957 "Photo.c"
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				Tag* tag = NULL;
				GeeList* _tmp36_;
				gint _tmp37_;
				gpointer _tmp38_;
				GeeSet* _tmp39_;
				Tag* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				gboolean _tmp45_;
#line 5350 "../src/Photo.vala"
				_tmp33_ = _tag_index;
#line 5350 "../src/Photo.vala"
				_tag_index = _tmp33_ + 1;
#line 5350 "../src/Photo.vala"
				_tmp34_ = _tag_index;
#line 5350 "../src/Photo.vala"
				_tmp35_ = _tag_size;
#line 5350 "../src/Photo.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 5350 "../src/Photo.vala"
					break;
#line 40984 "Photo.c"
				}
#line 5350 "../src/Photo.vala"
				_tmp36_ = _tag_list;
#line 5350 "../src/Photo.vala"
				_tmp37_ = _tag_index;
#line 5350 "../src/Photo.vala"
				_tmp38_ = gee_list_get (_tmp36_, _tmp37_);
#line 5350 "../src/Photo.vala"
				tag = (Tag*) _tmp38_;
#line 5351 "../src/Photo.vala"
				_tmp39_ = keywords;
#line 5351 "../src/Photo.vala"
				_tmp40_ = tag;
#line 5351 "../src/Photo.vala"
				_tmp41_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_OBJECT, DataObject));
#line 5351 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5351 "../src/Photo.vala"
				_tmp43_ = g_utf8_normalize (_tmp42_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5351 "../src/Photo.vala"
				_tmp44_ = _tmp43_;
#line 5351 "../src/Photo.vala"
				_tmp45_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _tmp44_);
#line 5351 "../src/Photo.vala"
				_g_free0 (_tmp44_);
#line 5351 "../src/Photo.vala"
				_g_free0 (_tmp42_);
#line 5351 "../src/Photo.vala"
				if (_tmp45_) {
#line 5352 "../src/Photo.vala"
					result = TRUE;
#line 5352 "../src/Photo.vala"
					_g_object_unref0 (tag);
#line 5352 "../src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5352 "../src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5352 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5352 "../src/Photo.vala"
					_g_object_unref0 (tags);
#line 5352 "../src/Photo.vala"
					return result;
#line 41028 "Photo.c"
				}
#line 5350 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 41032 "Photo.c"
			}
#line 5350 "../src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 41036 "Photo.c"
		}
	}
#line 5356 "../src/Photo.vala"
	result = FALSE;
#line 5356 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5356 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5356 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5356 "../src/Photo.vala"
	return result;
#line 41049 "Photo.c"
}


static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 5359 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5359 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5360 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5360 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5360 "../src/Photo.vala"
	photo_tags = _tmp1_;
#line 5361 "../src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5361 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 41076 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp19_;
#line 5362 "../src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5362 "../src/Photo.vala"
		string_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 41084 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _tag_size = 0;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_index = 0;
#line 5363 "../src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5363 "../src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5363 "../src/Photo.vala"
			_tag_list = _tmp5_;
#line 5363 "../src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5363 "../src/Photo.vala"
			_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5363 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5363 "../src/Photo.vala"
			_tag_size = _tmp8_;
#line 5363 "../src/Photo.vala"
			_tag_index = -1;
#line 5363 "../src/Photo.vala"
			while (TRUE) {
#line 41112 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				Tag* tag = NULL;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 5363 "../src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5363 "../src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5363 "../src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5363 "../src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5363 "../src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5363 "../src/Photo.vala"
					break;
#line 41136 "Photo.c"
				}
#line 5363 "../src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5363 "../src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5363 "../src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5363 "../src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5364 "../src/Photo.vala"
				_tmp15_ = string_tags;
#line 5364 "../src/Photo.vala"
				_tmp16_ = tag;
#line 5364 "../src/Photo.vala"
				_tmp17_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
#line 5364 "../src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5364 "../src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5364 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5363 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 41160 "Photo.c"
			}
#line 5363 "../src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 41164 "Photo.c"
		}
#line 5366 "../src/Photo.vala"
		_tmp19_ = string_tags;
#line 5366 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp19_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5361 "../src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 41172 "Photo.c"
	} else {
#line 5368 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 41176 "Photo.c"
	}
#line 5370 "../src/Photo.vala"
	photo_metadata_set_rating (metadata, media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 5359 "../src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 41182 "Photo.c"
}


static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5373 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5373 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5374 "../src/Photo.vala"
	new_htag_index = NULL;
#line 5376 "../src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 41204 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5377 "../src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5377 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5377 "../src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5377 "../src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5377 "../src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5377 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 41220 "Photo.c"
	}
#line 5381 "../src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5381 "../src/Photo.vala"
	keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5382 "../src/Photo.vala"
	_tmp4_ = keywords;
#line 5382 "../src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 41230 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5383 "../src/Photo.vala"
			_tmp5_ = keywords;
#line 5383 "../src/Photo.vala"
			_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5383 "../src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5383 "../src/Photo.vala"
			while (TRUE) {
#line 41243 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5383 "../src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5383 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5383 "../src/Photo.vala"
					break;
#line 41269 "Photo.c"
				}
#line 5383 "../src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5383 "../src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5383 "../src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5384 "../src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5384 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 41281 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5384 "../src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5384 "../src/Photo.vala"
					_tmp13_ = keyword;
#line 5384 "../src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 41290 "Photo.c"
				} else {
#line 5384 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 41294 "Photo.c"
				}
#line 5384 "../src/Photo.vala"
				if (_tmp10_) {
#line 5385 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5385 "../src/Photo.vala"
					continue;
#line 41302 "Photo.c"
				}
#line 5387 "../src/Photo.vala"
				_tmp14_ = keyword;
#line 5387 "../src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5387 "../src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5388 "../src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5388 "../src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5388 "../src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5391 "../src/Photo.vala"
				_tmp18_ = tag_global;
#line 5391 "../src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5391 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 41322 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5392 "../src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5392 "../src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5392 "../src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5392 "../src/Photo.vala"
					tag_attach (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5392 "../src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5393 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5393 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5393 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5393 "../src/Photo.vala"
					continue;
#line 41344 "Photo.c"
				}
#line 5396 "../src/Photo.vala"
				_tmp23_ = tag_global;
#line 5396 "../src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5396 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 41352 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5397 "../src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5397 "../src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5397 "../src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5397 "../src/Photo.vala"
					tag_attach (_tmp27_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5397 "../src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5398 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5398 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5398 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5398 "../src/Photo.vala"
					continue;
#line 41374 "Photo.c"
				}
#line 5401 "../src/Photo.vala"
				_tmp28_ = keyword;
#line 5401 "../src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5401 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5401 "../src/Photo.vala"
				tag_attach (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5401 "../src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5383 "../src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5383 "../src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5383 "../src/Photo.vala"
				_g_free0 (keyword);
#line 41392 "Photo.c"
			}
#line 5383 "../src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 41396 "Photo.c"
		}
	}
#line 5405 "../src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5405 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 41403 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5406 "../src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5406 "../src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5406 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5406 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5406 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5406 "../src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5406 "../src/Photo.vala"
			_path_it = _tmp36_;
#line 5406 "../src/Photo.vala"
			while (TRUE) {
#line 41427 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5406 "../src/Photo.vala"
				_tmp37_ = _path_it;
#line 5406 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5406 "../src/Photo.vala"
					break;
#line 41441 "Photo.c"
				}
#line 5406 "../src/Photo.vala"
				_tmp38_ = _path_it;
#line 5406 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5406 "../src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5407 "../src/Photo.vala"
				_tmp40_ = path;
#line 5407 "../src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5407 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5407 "../src/Photo.vala"
				tag_attach (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5407 "../src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5406 "../src/Photo.vala"
				_g_free0 (path);
#line 41461 "Photo.c"
			}
#line 5406 "../src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 41465 "Photo.c"
		}
	}
#line 5373 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5373 "../src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 41472 "Photo.c"
}


static void
library_photo_class_init (LibraryPhotoClass * klass)
{
#line 4958 "../src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4958 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhoto_private_offset);
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 4958 "../src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 4958 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 4958 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 4958 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 4958 "../src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 4958 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 4958 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 41523 "Photo.c"
}


static void
library_photo_flaggable_interface_init (FlaggableIface * iface)
{
#line 4958 "../src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4958 "../src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 4958 "../src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 4958 "../src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 41538 "Photo.c"
}


static void
library_photo_monitorable_interface_init (MonitorableIface * iface)
{
#line 4958 "../src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4958 "../src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 4958 "../src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 4958 "../src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 4958 "../src/Photo.vala"
	iface->set_master_file = (void (*) (Photo*, GFile*)) photo_set_master_file;
#line 4958 "../src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Photo*, GFileInfo*)) photo_set_master_timestamp;
#line 41557 "Photo.c"
}


static void
library_photo_instance_init (LibraryPhoto * self)
{
#line 4958 "../src/Photo.vala"
	self->priv = library_photo_get_instance_private (self);
#line 4969 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4970 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 41570 "Photo.c"
}


static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 4958 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4970 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4971 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4958 "../src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 41586 "Photo.c"
}


GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		LibraryPhoto_private_offset = g_type_add_instance_private (library_photo_type_id, sizeof (LibraryPhotoPrivate));
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


static inline gpointer
library_photo_source_holding_tank_get_instance_private (LibraryPhotoSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceHoldingTank_private_offset);
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5423 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5425 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5423 "../src/Photo.vala"
	return self;
#line 41631 "Photo.c"
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5423 "../src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 41644 "Photo.c"
}


LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
#line 5428 "../src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5428 "../src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 5429 "../src/Photo.vala"
	ret = NULL;
#line 5430 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5430 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5430 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5430 "../src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5431 "../src/Photo.vala"
	_tmp2_ = ret;
#line 5431 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5432 "../src/Photo.vala"
		result = ret;
#line 5432 "../src/Photo.vala"
		return result;
#line 41681 "Photo.c"
	}
#line 5434 "../src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5434 "../src/Photo.vala"
	_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5434 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5434 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5434 "../src/Photo.vala"
	return result;
#line 41693 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5458 "../src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 41705 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5459 "../src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 41715 "Photo.c"
}


static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5437 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5437 "../src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 5437 "../src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 5439 "../src/Photo.vala"
	if (added != NULL) {
#line 41733 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5440 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable));
#line 5440 "../src/Photo.vala"
			_source_it = _tmp0_;
#line 5440 "../src/Photo.vala"
			while (TRUE) {
#line 41743 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5440 "../src/Photo.vala"
				_tmp1_ = _source_it;
#line 5440 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5440 "../src/Photo.vala"
					break;
#line 41767 "Photo.c"
				}
#line 5440 "../src/Photo.vala"
				_tmp2_ = _source_it;
#line 5440 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5440 "../src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5441 "../src/Photo.vala"
				_tmp4_ = source;
#line 5441 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5441 "../src/Photo.vala"
				photo = _tmp5_;
#line 5444 "../src/Photo.vala"
				_tmp6_ = photo;
#line 5444 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 5444 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5444 "../src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5444 "../src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5444 "../src/Photo.vala"
				if (_tmp9_) {
#line 41793 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5445 "../src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5445 "../src/Photo.vala"
					_tmp11_ = photo;
#line 5445 "../src/Photo.vala"
					_tmp12_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_PHOTO, Photo));
#line 5445 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5445 "../src/Photo.vala"
					_tmp14_ = photo;
#line 5445 "../src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp14_);
#line 5445 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5446 "../src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5446 "../src/Photo.vala"
					_tmp16_ = photo;
#line 5446 "../src/Photo.vala"
					_tmp17_ = photo;
#line 5446 "../src/Photo.vala"
					_tmp18_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5446 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5446 "../src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5446 "../src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 41832 "Photo.c"
				}
#line 5450 "../src/Photo.vala"
				_tmp20_ = photo;
#line 5450 "../src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5450 "../src/Photo.vala"
				raw_files = _tmp21_;
#line 5451 "../src/Photo.vala"
				_tmp22_ = raw_files;
#line 5451 "../src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 41844 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5452 "../src/Photo.vala"
						_tmp23_ = raw_files;
#line 5452 "../src/Photo.vala"
						_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5452 "../src/Photo.vala"
						_f_it = _tmp24_;
#line 5452 "../src/Photo.vala"
						while (TRUE) {
#line 41857 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5452 "../src/Photo.vala"
							_tmp25_ = _f_it;
#line 5452 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5452 "../src/Photo.vala"
								break;
#line 41874 "Photo.c"
							}
#line 5452 "../src/Photo.vala"
							_tmp26_ = _f_it;
#line 5452 "../src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5452 "../src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5453 "../src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5453 "../src/Photo.vala"
							_tmp29_ = f;
#line 5453 "../src/Photo.vala"
							_tmp30_ = photo;
#line 5453 "../src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 5454 "../src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5454 "../src/Photo.vala"
							_tmp32_ = photo;
#line 5454 "../src/Photo.vala"
							_tmp33_ = f;
#line 5454 "../src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5452 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 41900 "Photo.c"
						}
#line 5452 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 41904 "Photo.c"
					}
				}
#line 5458 "../src/Photo.vala"
				_tmp34_ = photo;
#line 5458 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5459 "../src/Photo.vala"
				_tmp35_ = photo;
#line 5459 "../src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5440 "../src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5440 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5440 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 41921 "Photo.c"
			}
#line 5440 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41925 "Photo.c"
		}
	}
#line 5463 "../src/Photo.vala"
	if (removed != NULL) {
#line 41930 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5464 "../src/Photo.vala"
			_tmp36_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_ITERABLE, GeeIterable));
#line 5464 "../src/Photo.vala"
			_source_it = _tmp36_;
#line 5464 "../src/Photo.vala"
			while (TRUE) {
#line 41940 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5464 "../src/Photo.vala"
				_tmp37_ = _source_it;
#line 5464 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5464 "../src/Photo.vala"
					break;
#line 41962 "Photo.c"
				}
#line 5464 "../src/Photo.vala"
				_tmp38_ = _source_it;
#line 5464 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5464 "../src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5465 "../src/Photo.vala"
				_tmp40_ = source;
#line 5465 "../src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5465 "../src/Photo.vala"
				photo = _tmp41_;
#line 41976 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5466 "../src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5466 "../src/Photo.vala"
					_tmp43_ = photo;
#line 5466 "../src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5466 "../src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5466 "../src/Photo.vala"
					_tmp46_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5466 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5466 "../src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5466 "../src/Photo.vala"
					_f_it = _tmp47_;
#line 5466 "../src/Photo.vala"
					while (TRUE) {
#line 42003 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5466 "../src/Photo.vala"
						_tmp48_ = _f_it;
#line 5466 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5466 "../src/Photo.vala"
							break;
#line 42016 "Photo.c"
						}
#line 5466 "../src/Photo.vala"
						_tmp49_ = _f_it;
#line 5466 "../src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5466 "../src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5467 "../src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5467 "../src/Photo.vala"
						_tmp52_ = f;
#line 5467 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp52_, NULL);
#line 5466 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 42032 "Photo.c"
					}
#line 5466 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 42036 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5469 "../src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5469 "../src/Photo.vala"
					_tmp54_ = photo;
#line 5469 "../src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5469 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5469 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5469 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5469 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5469 "../src/Photo.vala"
					_f_it = _tmp58_;
#line 5469 "../src/Photo.vala"
					while (TRUE) {
#line 42064 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5469 "../src/Photo.vala"
						_tmp59_ = _f_it;
#line 5469 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5469 "../src/Photo.vala"
							break;
#line 42077 "Photo.c"
						}
#line 5469 "../src/Photo.vala"
						_tmp60_ = _f_it;
#line 5469 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5469 "../src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5470 "../src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5470 "../src/Photo.vala"
						_tmp63_ = f;
#line 5470 "../src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp63_, NULL);
#line 5469 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 42093 "Photo.c"
					}
#line 5469 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 42097 "Photo.c"
				}
#line 5472 "../src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5472 "../src/Photo.vala"
				_tmp65_ = photo;
#line 5472 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5473 "../src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5473 "../src/Photo.vala"
				_tmp67_ = photo;
#line 5473 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5475 "../src/Photo.vala"
				_tmp68_ = photo;
#line 5475 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5475 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5476 "../src/Photo.vala"
				_tmp70_ = photo;
#line 5476 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5476 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5464 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5464 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 42127 "Photo.c"
			}
#line 5464 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 42131 "Photo.c"
		}
	}
#line 5480 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), added, removed);
#line 42136 "Photo.c"
}


static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5483 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5483 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5483 "../src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 5483 "../src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 5484 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5484 "../src/Photo.vala"
	photo = _tmp0_;
#line 5485 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5485 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5487 "../src/Photo.vala"
	if (old_file != NULL) {
#line 42169 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5488 "../src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5488 "../src/Photo.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 5489 "../src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5489 "../src/Photo.vala"
		_tmp4_ = photo;
#line 5489 "../src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 42183 "Photo.c"
	}
#line 5492 "../src/Photo.vala"
	if (new_file != NULL) {
#line 42187 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5493 "../src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5493 "../src/Photo.vala"
		_tmp6_ = photo;
#line 5493 "../src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, _tmp6_);
#line 42196 "Photo.c"
	}
#line 5494 "../src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5494 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5494 "../src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5483 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 42206 "Photo.c"
}


static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5497 "../src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5497 "../src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5498 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5498 "../src/Photo.vala"
	photo = _tmp0_;
#line 5499 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5499 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5502 "../src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5502 "../src/Photo.vala"
	_tmp3_ = photo;
#line 5502 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 42241 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5503 "../src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5503 "../src/Photo.vala"
			_tmp5_ = photo;
#line 5503 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5503 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5503 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5503 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5503 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5503 "../src/Photo.vala"
			_f_it = _tmp9_;
#line 5503 "../src/Photo.vala"
			while (TRUE) {
#line 42270 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5503 "../src/Photo.vala"
				_tmp10_ = _f_it;
#line 5503 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5503 "../src/Photo.vala"
					break;
#line 42283 "Photo.c"
				}
#line 5503 "../src/Photo.vala"
				_tmp11_ = _f_it;
#line 5503 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5503 "../src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5504 "../src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5504 "../src/Photo.vala"
				_tmp14_ = f;
#line 5504 "../src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 5503 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 42299 "Photo.c"
			}
#line 5503 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 42303 "Photo.c"
		}
#line 5505 "../src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5505 "../src/Photo.vala"
		_tmp16_ = photo;
#line 5505 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 42311 "Photo.c"
	}
#line 5509 "../src/Photo.vala"
	_tmp17_ = photo;
#line 5509 "../src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5509 "../src/Photo.vala"
	raw_list = _tmp18_;
#line 5510 "../src/Photo.vala"
	_tmp19_ = raw_list;
#line 5510 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 42323 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5511 "../src/Photo.vala"
			_tmp20_ = raw_list;
#line 5511 "../src/Photo.vala"
			_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5511 "../src/Photo.vala"
			_f_it = _tmp21_;
#line 5511 "../src/Photo.vala"
			while (TRUE) {
#line 42336 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5511 "../src/Photo.vala"
				_tmp22_ = _f_it;
#line 5511 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5511 "../src/Photo.vala"
					break;
#line 42353 "Photo.c"
				}
#line 5511 "../src/Photo.vala"
				_tmp23_ = _f_it;
#line 5511 "../src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5511 "../src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5512 "../src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5512 "../src/Photo.vala"
				_tmp26_ = f;
#line 5512 "../src/Photo.vala"
				_tmp27_ = photo;
#line 5512 "../src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp26_, _tmp27_);
#line 5513 "../src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5513 "../src/Photo.vala"
				_tmp29_ = photo;
#line 5513 "../src/Photo.vala"
				_tmp30_ = f;
#line 5513 "../src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5511 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 42379 "Photo.c"
			}
#line 5511 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 42383 "Photo.c"
		}
	}
#line 5497 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5497 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 42390 "Photo.c"
}


static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass)
{
#line 5413 "../src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5413 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5413 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceHoldingTank_private_offset);
#line 5413 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 42405 "Photo.c"
}


static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5413 "../src/Photo.vala"
	self->priv = library_photo_source_holding_tank_get_instance_private (self);
#line 5414 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5414 "../src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5416 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5416 "../src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5418 "../src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5418 "../src/Photo.vala"
	self->priv->reverse_editable_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 5420 "../src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5420 "../src/Photo.vala"
	self->priv->reverse_development_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 42434 "Photo.c"
}


static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5413 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5414 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5416 "../src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5418 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5420 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5413 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 42454 "Photo.c"
}


GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		LibraryPhotoSourceHoldingTank_private_offset = g_type_add_instance_private (library_photo_source_holding_tank_type_id, sizeof (LibraryPhotoSourceHoldingTankPrivate));
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



