/* VideoSupport.c generated by valac 0.42.7, the Vala compiler
 * generated from VideoSupport.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/pbutils/pbutils.h>
#include <gst/gst.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gunixinputstream.h>
#include <sys/wait.h>
#include <glib/gstdio.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
typedef struct _ParamSpecVideoImportParams ParamSpecVideoImportParams;

#define TYPE_VIDEO_READER (video_reader_get_type ())
#define VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_READER, VideoReader))
#define VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_READER, VideoReaderClass))
#define IS_VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_READER))
#define IS_VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_READER))
#define VIDEO_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_READER, VideoReaderClass))

typedef struct _VideoReader VideoReader;
typedef struct _VideoReaderClass VideoReaderClass;
typedef struct _VideoReaderPrivate VideoReaderPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;


#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _video_reader_unref0(var) ((var == NULL) ? NULL : (var = (video_reader_unref (var), NULL)))

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;


#define TYPE_RATING (rating_get_type ())
typedef struct _ParamSpecVideoReader ParamSpecVideoReader;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;


#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;


#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;
typedef struct _VideoSourcePrivate VideoSourcePrivate;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_VIDEO (video_get_type ())
#define VIDEO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO, Video))
#define VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO, VideoClass))
#define IS_VIDEO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO))
#define IS_VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO))
#define VIDEO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO, VideoClass))

typedef struct _Video Video;
typedef struct _VideoClass VideoClass;
typedef struct _VideoPrivate VideoPrivate;
enum  {
	VIDEO_0_PROPERTY,
	VIDEO_NUM_PROPERTIES
};
static GParamSpec* video_properties[VIDEO_NUM_PROPERTIES];

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_VIDEO_SOURCE_COLLECTION (video_source_collection_get_type ())
#define VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection))
#define VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))
#define IS_VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE_COLLECTION))
#define IS_VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE_COLLECTION))
#define VIDEO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))

typedef struct _VideoSourceCollection VideoSourceCollection;
typedef struct _VideoSourceCollectionClass VideoSourceCollectionClass;
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_EXPORTER (exporter_get_type ())
#define EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER, Exporter))
#define EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER, ExporterClass))
#define IS_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER))
#define IS_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER))
#define EXPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER, ExporterClass))

typedef struct _Exporter Exporter;
typedef struct _ExporterClass ExporterClass;
typedef void (*ExporterCompletionCallback) (Exporter* exporter, gboolean is_cancelled, gpointer user_data);

#define TYPE_EXPORTER_UI (exporter_ui_get_type ())
#define EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER_UI, ExporterUI))
#define EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER_UI, ExporterUIClass))
#define IS_EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER_UI))
#define IS_EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER_UI))
#define EXPORTER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER_UI, ExporterUIClass))

typedef struct _ExporterUI ExporterUI;
typedef struct _ExporterUIClass ExporterUIClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;


#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;


#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;
#define _backing_file_state_unref0(var) ((var == NULL) ? NULL : (var = (backing_file_state_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;


#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define VIDEO_TYPE_INTERPRETABLE_RESULTS (video_interpretable_results_get_type ())
#define VIDEO_INTERPRETABLE_RESULTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResults))
#define VIDEO_INTERPRETABLE_RESULTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResultsClass))
#define VIDEO_IS_INTERPRETABLE_RESULTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS))
#define VIDEO_IS_INTERPRETABLE_RESULTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIDEO_TYPE_INTERPRETABLE_RESULTS))
#define VIDEO_INTERPRETABLE_RESULTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResultsClass))

typedef struct _VideoInterpretableResults VideoInterpretableResults;
typedef struct _VideoInterpretableResultsClass VideoInterpretableResultsClass;
#define _video_interpretable_results_unref0(var) ((var == NULL) ? NULL : (var = (video_interpretable_results_unref (var), NULL)))
typedef struct _VideoInterpretableResultsPrivate VideoInterpretableResultsPrivate;
typedef struct _VideoParamSpecInterpretableResults VideoParamSpecInterpretableResults;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
typedef struct _VideoSourceCollectionPrivate VideoSourceCollectionPrivate;
typedef enum  {
	VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN,
	VIDEO_SOURCE_COLLECTION_STATE_ONLINE,
	VIDEO_SOURCE_COLLECTION_STATE_OFFLINE,
	VIDEO_SOURCE_COLLECTION_STATE_TRASH
} VideoSourceCollectionState;


#define VIDEO_SOURCE_COLLECTION_TYPE_STATE (video_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_VIDEO_MONITOR (video_monitor_get_type ())
#define VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_MONITOR, VideoMonitor))
#define VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_MONITOR, VideoMonitorClass))
#define IS_VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_MONITOR))
#define IS_VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_MONITOR))
#define VIDEO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_MONITOR, VideoMonitorClass))

typedef struct _VideoMonitor VideoMonitor;
typedef struct _VideoMonitorClass VideoMonitorClass;

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	VIDEO_ERROR_FILE,
	VIDEO_ERROR_CONTENTS
} VideoError;
#define VIDEO_ERROR video_error_quark ()
struct _ImportID {
	gint64 id;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	time_t exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _ParamSpecVideoImportParams {
	GParamSpec parent_instance;
};

struct _VideoReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoReaderPrivate * priv;
};

struct _VideoReaderClass {
	GTypeClass parent_class;
	void (*finalize) (VideoReader *self);
};

struct _VideoReaderPrivate {
	gdouble clip_duration;
	GdkPixbuf* preview_frame;
	GFile* file;
	GPid thumbnailer_pid;
	GDateTime* _timestamp;
};

struct _VideoID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoReader {
	GParamSpec parent_instance;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _VideoSource {
	MediaSource parent_instance;
	VideoSourcePrivate * priv;
};

struct _VideoSourceClass {
	MediaSourceClass parent_class;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _Video {
	VideoSource parent_instance;
	VideoPrivate * priv;
};

struct _VideoClass {
	VideoSourceClass parent_class;
};

struct _VideoPrivate {
	VideoRow* backing_row;
	GRecMutex __lock_backing_row;
};

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _VideoInterpretableResults {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoInterpretableResultsPrivate * priv;
	Video* video;
	gboolean update_interpretable;
	gboolean is_interpretable;
	GdkPixbuf* new_thumbnail;
};

struct _VideoInterpretableResultsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoInterpretableResults *self);
};

struct _VideoParamSpecInterpretableResults {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _VideoSourceCollection {
	MediaSourceCollection parent_instance;
	VideoSourceCollectionPrivate * priv;
};

struct _VideoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
};

struct _VideoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeMultiMap* filesize_to_video;
};


static gpointer video_import_params_parent_class = NULL;
static gint VideoReader_private_offset;
static gpointer video_reader_parent_class = NULL;
static gint Video_private_offset;
static gpointer video_parent_class = NULL;
static gboolean video_interpreter_state_changed;
static gboolean video_interpreter_state_changed = FALSE;
static gint video_current_state;
static gint video_current_state = 0;
static gboolean video_normal_regen_complete;
static gboolean video_normal_regen_complete = FALSE;
static gboolean video_offline_regen_complete;
static gboolean video_offline_regen_complete = FALSE;
extern VideoSourceCollection* video_global;
VideoSourceCollection* video_global = NULL;
static gpointer video_interpretable_results_parent_class = NULL;
static FlaggableIface * video_flaggable_parent_iface = NULL;
static MonitorableIface * video_monitorable_parent_iface = NULL;
static DateableIface * video_dateable_parent_iface = NULL;
static gint VideoSourceCollection_private_offset;
static gpointer video_source_collection_parent_class = NULL;

GQuark video_error_quark (void);
gpointer video_import_params_ref (gpointer instance);
void video_import_params_unref (gpointer instance);
GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_video_import_params (const GValue* value);
GType video_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_video_row (GValue* value,
                          gpointer v_object);
void value_take_video_row (GValue* value,
                           gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST;
#define IMPORT_ID_INVALID ((gint64) 0)
void import_id_init (ImportID *self,
                     gint64 id);
VideoRow* video_row_new (void);
VideoRow* video_row_construct (GType object_type);
VideoImportParams* video_import_params_new (GFile* file,
                                            ImportID* import_id,
                                            const gchar* md5,
                                            Thumbnails* thumbnails,
                                            time_t exposure_time_override);
VideoImportParams* video_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id,
                                                  const gchar* md5,
                                                  Thumbnails* thumbnails,
                                                  time_t exposure_time_override);
static void video_import_params_finalize (VideoImportParams * obj);
gpointer video_reader_ref (gpointer instance);
void video_reader_unref (gpointer instance);
GParamSpec* param_spec_video_reader (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_video_reader (GValue* value,
                             gpointer v_object);
void value_take_video_reader (GValue* value,
                              gpointer v_object);
gpointer value_get_video_reader (const GValue* value);
GType video_reader_get_type (void) G_GNUC_CONST;
#define VIDEO_READER_UNKNOWN_CLIP_DURATION (-1.0)
#define VIDEO_READER_THUMBNAILER_TIMEOUT ((guint) 10000)
VideoReader* video_reader_new (GFile* file);
VideoReader* video_reader_construct (GType object_type,
                                     GFile* file);
gboolean video_reader_is_supported_video_file (GFile* file);
gboolean video_reader_is_supported_video_filename (const gchar* filename);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gint utf8_ci_compare (void* a,
                      void* b);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult video_reader_prepare_for_import (VideoImportParams* params);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
GdkPixbuf* video_reader_read_preview_frame (VideoReader* self);
gdouble video_reader_read_clip_duration (VideoReader* self,
                                         GError** error);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType video_metadata_get_type (void) G_GNUC_CONST;
VideoMetadata* video_reader_read_metadata (VideoReader* self,
                                           GError** error);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GDateTime* video_reader_get_timestamp (VideoReader* self);
GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST;
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
Thumbnails* thumbnails_new (void);
Thumbnails* thumbnails_construct (GType object_type);
void thumbnail_cache_generate_for_video_frame (Thumbnails* thumbnails,
                                               GdkPixbuf* preview_frame);
static void video_reader_read_internal (VideoReader* self,
                                 GError** error);
static gboolean video_reader_does_file_exist (VideoReader* self);
static GDate* _g_date_dup (GDate* self);
static void video_reader_set_timestamp (VideoReader* self,
                                 GDateTime* value);
static gboolean video_reader_on_thumbnailer_timer (VideoReader* self);
static GdkPixbuf* video_reader_thumbnailer (VideoReader* self,
                                     const gchar* video_file);
GFile* app_dirs_get_thumbnailer_bin (void);
static gboolean _video_reader_on_thumbnailer_timer_gsource_func (gpointer self);
GdkPixbuf* resources_get_noninterpretable_badge_pixbuf (void);
VideoMetadata* video_metadata_new (void);
VideoMetadata* video_metadata_construct (GType object_type);
void media_metadata_read_from_file (MediaMetadata* self,
                                    GFile* file,
                                    GError** error);
static void video_reader_finalize (VideoReader * obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType video_source_get_type (void) G_GNUC_CONST;
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType video_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType video_source_collection_get_type (void) G_GNUC_CONST;
#define VIDEO_TYPENAME "video"
#define VIDEO_FLAG_TRASH ((guint64) 0x0000000000000001)
#define VIDEO_FLAG_OFFLINE ((guint64) 0x0000000000000002)
#define VIDEO_FLAG_FLAGGED ((guint64) 0x0000000000000004)
Video* video_new (VideoRow* row);
Video* video_construct (GType object_type,
                        VideoRow* row);
VideoSource* video_source_construct (GType object_type);
gchar* media_source_prep_title (const gchar* title);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
void video_init (ProgressMonitor monitor,
                 gpointer monitor_target);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
gint configuration_facade_get_video_interpreter_state_cookie (ConfigurationFacade* self);
#define CONFIG_FACADE_NO_VIDEO_INTERPRETER_STATE -1
static gboolean __lambda12_ (GstPluginFeature* f);
static gboolean ___lambda12__gst_plugin_feature_filter (GstPluginFeature* feature,
                                                 gpointer self);
VideoSourceCollection* video_source_collection_new (void);
VideoSourceCollection* video_source_collection_construct (GType object_type);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
VideoTable* video_table_get_instance (void);
GeeArrayList* video_table_get_all (VideoTable* self);
static void video_set_is_interpretable (Video* self,
                                 gboolean is_interpretable);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gboolean video_has_interpreter_state_changed (void);
void video_notify_normal_thumbs_regenerated (void);
static void video_save_interpreter_state (void);
void video_notify_offline_thumbs_regenerated (void);
void configuration_facade_set_video_interpreter_state_cookie (ConfigurationFacade* self,
                                                              gint state_cookie);
void video_terminate (void);
GType exporter_get_type (void) G_GNUC_CONST;
gpointer exporter_ui_ref (gpointer instance);
void exporter_ui_unref (gpointer instance);
GParamSpec* param_spec_exporter_ui (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_exporter_ui (GValue* value,
                            gpointer v_object);
void value_take_exporter_ui (GValue* value,
                             gpointer v_object);
gpointer value_get_exporter_ui (const GValue* value);
GType exporter_ui_get_type (void) G_GNUC_CONST;
ExporterUI* video_export_many (GeeCollection* videos,
                               ExporterCompletionCallback done,
                               gpointer done_target,
                               gboolean export_in_place);
void scaling_for_original (Scaling* result);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
void export_format_parameters_unmodified (ExportFormatParameters* result);
Exporter* exporter_new_for_temp_file (GeeCollection* to_export,
                                      Scaling* scaling,
                                      ExportFormatParameters* export_params);
Exporter* exporter_construct_for_temp_file (GType object_type,
                                            GeeCollection* to_export,
                                            Scaling* scaling,
                                            ExportFormatParameters* export_params);
ExporterUI* exporter_ui_new (Exporter* exporter);
ExporterUI* exporter_ui_construct (GType object_type,
                                   Exporter* exporter);
void exporter_ui_export (ExporterUI* self,
                         ExporterCompletionCallback completion_callback,
                         gpointer completion_callback_target);
GFile* export_ui_choose_file (const gchar* current_file_basename);
gchar* media_source_get_basename (MediaSource* self);
GType page_window_get_type (void) G_GNUC_CONST;
GType app_window_get_type (void) G_GNUC_CONST;
AppWindow* app_window_get_instance (void);
void page_window_set_busy_cursor (PageWindow* self);
void video_export (Video* self,
                   GFile* dest_file,
                   GError** error);
void page_window_set_normal_cursor (PageWindow* self);
GtkResponseType export_error_dialog (GFile* dest,
                                     gboolean photos_remaining);
GFile* export_ui_choose_dir (const gchar* user_title);
Exporter* exporter_new (GeeCollection* to_export,
                        GFile* dir,
                        Scaling* scaling,
                        ExportFormatParameters* export_params,
                        gboolean auto_replace_all);
Exporter* exporter_construct (GType object_type,
                              GeeCollection* to_export,
                              GFile* dir,
                              Scaling* scaling,
                              ExportFormatParameters* export_params,
                              gboolean auto_replace_all);
static void video_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
GQuark database_error_quark (void);
void video_table_update_backlinks (VideoTable* self,
                                   VideoID* video_id,
                                   const gchar* backlinks,
                                   GError** error);
void video_get_video_id (Video* self,
                         VideoID* result);
gchar* data_object_to_string (DataObject* self);
static gboolean video_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean video_table_set_event (VideoTable* self,
                                VideoID* video_id,
                                EventID* event_id);
gboolean video_is_duplicate (GFile* file,
                             const gchar* full_md5);
gboolean video_table_has_duplicate (VideoTable* self,
                                    GFile* file,
                                    const gchar* md5);
ImportResult video_import_create (VideoImportParams* params,
                                  Video* * video);
void video_table_add (VideoTable* self,
                      VideoRow* video_row,
                      VideoID* result,
                      GError** error);
gboolean video_id_is_invalid (VideoID *self);
void video_import_failed (Video* video);
void video_table_remove (VideoTable* self,
                         VideoID* videoID,
                         GError** error);
void app_window_database_error (GError* err);
static BackingFileState** video_real_get_backing_files_state (MediaSource* base,
                                                       int* result_length1);
BackingFileState* backing_file_state_new (const gchar* filepath,
                                          gint64 filesize,
                                          time_t modification_time,
                                          const gchar* md5);
BackingFileState* backing_file_state_construct (GType object_type,
                                                const gchar* filepath,
                                                gint64 filesize,
                                                time_t modification_time,
                                                const gchar* md5);
static GdkPixbuf* video_real_get_thumbnail (ThumbnailSource* base,
                                     gint scale,
                                     GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static gchar* video_real_get_master_md5 (MediaSource* base);
static GdkPixbuf* video_real_get_preview_pixbuf (MediaSource* base,
                                          Scaling* scaling,
                                          GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static GdkPixbuf* video_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GFile* media_source_get_file (MediaSource* self);
static gchar* video_real_get_typename (DataSource* base);
static gint64 video_real_get_instance_id (DataSource* base);
static void video_real_get_import_id (MediaSource* base,
                               ImportID* result);
static PhotoFileFormat video_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_file_format_get_system_default_format (void);
static gchar* video_real_get_title (MediaSource* base);
static void video_real_set_title (MediaSource* base,
                           const gchar* title);
void video_table_set_title (VideoTable* self,
                            VideoID* video_id,
                            const gchar* new_title,
                            GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
static gchar* video_real_get_comment (MediaSource* base);
static gboolean video_real_set_comment (MediaSource* base,
                                 const gchar* comment);
void video_table_set_comment (VideoTable* self,
                              VideoID* video_id,
                              const gchar* new_comment,
                              GError** error);
static Rating video_real_get_rating (MediaSource* base);
static void video_real_set_rating (MediaSource* base,
                            Rating rating);
gboolean rating_is_valid (Rating self);
void video_table_set_rating (VideoTable* self,
                             VideoID* video_id,
                             Rating rating,
                             GError** error);
static void video_real_increase_rating (MediaSource* base);
void media_source_set_rating (MediaSource* self,
                              Rating rating);
Rating rating_increase (Rating self);
static void video_real_decrease_rating (MediaSource* base);
Rating rating_decrease (Rating self);
static gboolean video_real_is_trashed (MediaSource* base);
gboolean video_is_flag_set (Video* self,
                            guint64 flag);
static gboolean video_real_is_offline (Monitorable* base);
static void video_real_mark_offline (Monitorable* base);
guint64 video_add_flags (Video* self,
                         guint64 flags_to_add,
                         Alteration* additional_alteration);
static void video_real_mark_online (Monitorable* base);
guint64 video_remove_flags (Video* self,
                            guint64 flags_to_remove,
                            Alteration* additional_alteration);
gboolean video_get_is_interpretable (Video* self);
gpointer video_interpretable_results_ref (gpointer instance);
void video_interpretable_results_unref (gpointer instance);
GParamSpec* video_param_spec_interpretable_results (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void video_value_set_interpretable_results (GValue* value,
                                            gpointer v_object);
void video_value_take_interpretable_results (GValue* value,
                                             gpointer v_object);
gpointer video_value_get_interpretable_results (const GValue* value);
GType video_interpretable_results_get_type (void) G_GNUC_CONST;
VideoInterpretableResults* video_check_is_interpretable (Video* self);
void video_interpretable_results_foreground_finish (VideoInterpretableResults* self);
static void video_real_trash (MediaSource* base);
static void video_real_untrash (MediaSource* base);
static gboolean video_real_is_flagged (Flaggable* base);
static void video_real_mark_flagged (Flaggable* base);
static void video_real_mark_unflagged (Flaggable* base);
static void video_real_get_event_id (MediaSource* base,
                              EventID* result);
static gchar* video_real_to_string (DataObject* base);
static time_t video_real_get_exposure_time (Dateable* base);
static void video_real_set_exposure_time (Dateable* base,
                                   time_t time);
void video_table_set_exposure_time (VideoTable* self,
                                    VideoID* video_id,
                                    time_t time,
                                    GError** error);
void video_get_frame_dimensions (Video* self,
                                 Dimensions* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
static void video_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
static guint64 video_real_get_filesize (MediaSource* base);
guint64 media_source_get_master_filesize (MediaSource* self);
static guint64 video_real_get_master_filesize (MediaSource* base);
static time_t video_real_get_timestamp (MediaSource* base);
static void video_real_set_master_timestamp (Monitorable* base,
                                      GFileInfo* info);
void video_table_set_timestamp (VideoTable* self,
                                VideoID* video_id,
                                time_t timestamp,
                                GError** error);
gchar* video_get_filename (Video* self);
static GFile* video_real_get_file (MediaSource* base);
static GFile* video_real_get_master_file (MediaSource* base);
gdouble video_get_clip_duration (Video* self);
void video_table_update_is_interpretable (VideoTable* self,
                                          VideoID* video_id,
                                          gboolean is_interpretable,
                                          GError** error);
VideoInterpretableResults* video_interpretable_results_new (Video* video);
VideoInterpretableResults* video_interpretable_results_construct (GType object_type,
                                                                  Video* video);
static void video_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
static gboolean video_real_internal_delete_backing (DataSource* base,
                                             GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
static void video_notify_flags_altered (Video* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
void video_table_set_flags (VideoTable* self,
                            VideoID* video_id,
                            guint64 flags,
                            GError** error);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
static void video_real_set_master_file (Monitorable* base,
                                 GFile* file);
void video_table_set_filepath (VideoTable* self,
                               VideoID* video_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
VideoMetadata* video_read_metadata (Video* self,
                                    GError** error);
void thumbnail_cache_replace (ThumbnailSource* source,
                              ThumbnailCacheSize size,
                              GdkPixbuf* replacement,
                              GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void video_interpretable_results_finalize (VideoInterpretableResults * obj);
static void video_finalize (GObject * obj);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType video_source_collection_state_get_type (void) G_GNUC_CONST;
gint uint64_compare (guint64* a,
                     guint64* b);
static gint _uint64_compare_gcompare_data_func (gconstpointer a,
                                         gconstpointer b,
                                         gpointer self);
static guint64* _uint64_dup (guint64* self);
gint64 video_source_collection_get_video_key (DataSource* source);
static gint64 _video_source_collection_get_video_key_get_source_database_key (DataSource* source,
                                                                       gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void video_source_collection_on_trashcan_contents_altered (VideoSourceCollection* self,
                                                           GeeCollection* added,
                                                           GeeCollection* removed);
static void _video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                 GeeCollection* added,
                                                                                                 GeeCollection* removed,
                                                                                                 gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void video_source_collection_on_offline_contents_altered (VideoSourceCollection* self,
                                                          GeeCollection* added,
                                                          GeeCollection* removed);
static void _video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                GeeCollection* added,
                                                                                                GeeCollection* removed,
                                                                                                gpointer self);
static MediaSourceHoldingTank* video_source_collection_real_create_trashcan (MediaSourceCollection* base);
gboolean video_source_collection_is_video_trashed (DataSource* source);
static gboolean _video_source_collection_is_video_trashed_source_holding_tank_check_to_keep (DataSource* source,
                                                                                      Alteration* alteration,
                                                                                      gpointer self);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static MediaSourceHoldingTank* video_source_collection_real_create_offline_bin (MediaSourceCollection* base);
gboolean video_source_collection_is_video_offline (DataSource* source);
static gboolean _video_source_collection_is_video_offline_source_holding_tank_check_to_keep (DataSource* source,
                                                                                      Alteration* alteration,
                                                                                      gpointer self);
static MediaMonitor* video_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                 Workers* workers,
                                                                 GCancellable* cancellable);
VideoMonitor* video_monitor_new (GCancellable* cancellable);
VideoMonitor* video_monitor_construct (GType object_type,
                                       GCancellable* cancellable);
GType video_monitor_get_type (void) G_GNUC_CONST;
static gboolean video_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                            DataSource* source);
static gchar* video_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean video_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                          GFile* file);
static MediaSource* video_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                               gint64 numeric_id);
Video* video_source_collection_fetch (VideoSourceCollection* self,
                                      VideoID* video_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
static GeeCollection* video_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                  EventID* event_id);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self,
                                                EventID* event_id);
Video* video_source_collection_get_state_by_file (VideoSourceCollection* self,
                                                  GFile* file,
                                                  VideoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
static void video_source_collection_compare_backing (VideoSourceCollection* self,
                                              Video* video,
                                              GFileInfo* info,
                                              GeeCollection* matching_master);
guint64 media_source_get_filesize (MediaSource* self);
time_t media_source_get_timestamp (MediaSource* self);
void video_source_collection_fetch_by_matching_backing (VideoSourceCollection* self,
                                                        GFileInfo* info,
                                                        GeeCollection* matching_master);
GeeCollection* data_collection_get_all (DataCollection* self);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
static void video_source_collection_real_notify_contents_altered (DataCollection* base,
                                                           GeeIterable* added,
                                                           GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
void video_source_collection_get_basename_filesize_duplicate (VideoSourceCollection* self,
                                                              const gchar* basename,
                                                              guint64 filesize,
                                                              VideoID* result);
GFile* media_source_get_master_file (MediaSource* self);
gboolean video_source_collection_has_basename_filesize_duplicate (VideoSourceCollection* self,
                                                                  const gchar* basename,
                                                                  guint64 filesize);
gboolean video_id_is_valid (VideoID *self);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void video_source_collection_finalize (DataCollection * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS[4] = {"bdm", "bdmv", "cpi", "mpl"};

GQuark
video_error_quark (void)
{
	return g_quark_from_static_string ("video-error-quark");
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/VideoSupport.vala"
	return self ? g_object_ref (self) : NULL;
#line 1840 "VideoSupport.c"
}


static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 33 "../src/VideoSupport.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 1849 "VideoSupport.c"
}


VideoImportParams*
video_import_params_construct (GType object_type,
                               GFile* file,
                               ImportID* import_id,
                               const gchar* md5,
                               Thumbnails* thumbnails,
                               time_t exposure_time_override)
{
	VideoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
	gchar* _tmp2_;
	Thumbnails* _tmp3_;
#line 28 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 28 "../src/VideoSupport.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 28 "../src/VideoSupport.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 28 "../src/VideoSupport.vala"
	self = (VideoImportParams*) g_type_create_instance (object_type);
#line 30 "../src/VideoSupport.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 30 "../src/VideoSupport.vala"
	_g_object_unref0 (self->file);
#line 30 "../src/VideoSupport.vala"
	self->file = _tmp0_;
#line 31 "../src/VideoSupport.vala"
	_tmp1_ = *import_id;
#line 31 "../src/VideoSupport.vala"
	self->import_id = _tmp1_;
#line 32 "../src/VideoSupport.vala"
	_tmp2_ = g_strdup (md5);
#line 32 "../src/VideoSupport.vala"
	_g_free0 (self->md5);
#line 32 "../src/VideoSupport.vala"
	self->md5 = _tmp2_;
#line 33 "../src/VideoSupport.vala"
	_tmp3_ = _thumbnails_ref0 (thumbnails);
#line 33 "../src/VideoSupport.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 33 "../src/VideoSupport.vala"
	self->thumbnails = _tmp3_;
#line 34 "../src/VideoSupport.vala"
	self->exposure_time_override = exposure_time_override;
#line 28 "../src/VideoSupport.vala"
	return self;
#line 1900 "VideoSupport.c"
}


VideoImportParams*
video_import_params_new (GFile* file,
                         ImportID* import_id,
                         const gchar* md5,
                         Thumbnails* thumbnails,
                         time_t exposure_time_override)
{
#line 28 "../src/VideoSupport.vala"
	return video_import_params_construct (TYPE_VIDEO_IMPORT_PARAMS, file, import_id, md5, thumbnails, exposure_time_override);
#line 1913 "VideoSupport.c"
}


static void
value_video_import_params_init (GValue* value)
{
#line 15 "../src/VideoSupport.vala"
	value->data[0].v_pointer = NULL;
#line 1922 "VideoSupport.c"
}


static void
value_video_import_params_free_value (GValue* value)
{
#line 15 "../src/VideoSupport.vala"
	if (value->data[0].v_pointer) {
#line 15 "../src/VideoSupport.vala"
		video_import_params_unref (value->data[0].v_pointer);
#line 1933 "VideoSupport.c"
	}
}


static void
value_video_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 15 "../src/VideoSupport.vala"
	if (src_value->data[0].v_pointer) {
#line 15 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = video_import_params_ref (src_value->data[0].v_pointer);
#line 1946 "VideoSupport.c"
	} else {
#line 15 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1950 "VideoSupport.c"
	}
}


static gpointer
value_video_import_params_peek_pointer (const GValue* value)
{
#line 15 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 1960 "VideoSupport.c"
}


static gchar*
value_video_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 15 "../src/VideoSupport.vala"
	if (collect_values[0].v_pointer) {
#line 1972 "VideoSupport.c"
		VideoImportParams * object;
		object = collect_values[0].v_pointer;
#line 15 "../src/VideoSupport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 15 "../src/VideoSupport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1979 "VideoSupport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 15 "../src/VideoSupport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1983 "VideoSupport.c"
		}
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = video_import_params_ref (object);
#line 1987 "VideoSupport.c"
	} else {
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 1991 "VideoSupport.c"
	}
#line 15 "../src/VideoSupport.vala"
	return NULL;
#line 1995 "VideoSupport.c"
}


static gchar*
value_video_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	VideoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 15 "../src/VideoSupport.vala"
	if (!object_p) {
#line 15 "../src/VideoSupport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2011 "VideoSupport.c"
	}
#line 15 "../src/VideoSupport.vala"
	if (!value->data[0].v_pointer) {
#line 15 "../src/VideoSupport.vala"
		*object_p = NULL;
#line 2017 "VideoSupport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 15 "../src/VideoSupport.vala"
		*object_p = value->data[0].v_pointer;
#line 2021 "VideoSupport.c"
	} else {
#line 15 "../src/VideoSupport.vala"
		*object_p = video_import_params_ref (value->data[0].v_pointer);
#line 2025 "VideoSupport.c"
	}
#line 15 "../src/VideoSupport.vala"
	return NULL;
#line 2029 "VideoSupport.c"
}


GParamSpec*
param_spec_video_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecVideoImportParams* spec;
#line 15 "../src/VideoSupport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_IMPORT_PARAMS), NULL);
#line 15 "../src/VideoSupport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 15 "../src/VideoSupport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 15 "../src/VideoSupport.vala"
	return G_PARAM_SPEC (spec);
#line 2049 "VideoSupport.c"
}


gpointer
value_get_video_import_params (const GValue* value)
{
#line 15 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS), NULL);
#line 15 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 2060 "VideoSupport.c"
}


void
value_set_video_import_params (GValue* value,
                               gpointer v_object)
{
	VideoImportParams * old;
#line 15 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS));
#line 15 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/VideoSupport.vala"
	if (v_object) {
#line 15 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_IMPORT_PARAMS));
#line 15 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 15 "../src/VideoSupport.vala"
		video_import_params_ref (value->data[0].v_pointer);
#line 2083 "VideoSupport.c"
	} else {
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 2087 "VideoSupport.c"
	}
#line 15 "../src/VideoSupport.vala"
	if (old) {
#line 15 "../src/VideoSupport.vala"
		video_import_params_unref (old);
#line 2093 "VideoSupport.c"
	}
}


void
value_take_video_import_params (GValue* value,
                                gpointer v_object)
{
	VideoImportParams * old;
#line 15 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS));
#line 15 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/VideoSupport.vala"
	if (v_object) {
#line 15 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_IMPORT_PARAMS));
#line 15 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 2115 "VideoSupport.c"
	} else {
#line 15 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 2119 "VideoSupport.c"
	}
#line 15 "../src/VideoSupport.vala"
	if (old) {
#line 15 "../src/VideoSupport.vala"
		video_import_params_unref (old);
#line 2125 "VideoSupport.c"
	}
}


static void
video_import_params_class_init (VideoImportParamsClass * klass)
{
#line 15 "../src/VideoSupport.vala"
	video_import_params_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/VideoSupport.vala"
	((VideoImportParamsClass *) klass)->finalize = video_import_params_finalize;
#line 2137 "VideoSupport.c"
}


static void
video_import_params_instance_init (VideoImportParams * self)
{
	VideoRow* _tmp0_;
#line 18 "../src/VideoSupport.vala"
	import_id_init (&self->import_id, IMPORT_ID_INVALID);
#line 26 "../src/VideoSupport.vala"
	_tmp0_ = video_row_new ();
#line 26 "../src/VideoSupport.vala"
	self->row = _tmp0_;
#line 15 "../src/VideoSupport.vala"
	self->ref_count = 1;
#line 2153 "VideoSupport.c"
}


static void
video_import_params_finalize (VideoImportParams * obj)
{
	VideoImportParams * self;
#line 15 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams);
#line 15 "../src/VideoSupport.vala"
	g_signal_handlers_destroy (self);
#line 17 "../src/VideoSupport.vala"
	_g_object_unref0 (self->file);
#line 19 "../src/VideoSupport.vala"
	_g_free0 (self->md5);
#line 23 "../src/VideoSupport.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 26 "../src/VideoSupport.vala"
	_video_row_unref0 (self->row);
#line 2173 "VideoSupport.c"
}


GType
video_import_params_get_type (void)
{
	static volatile gsize video_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&video_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_import_params_init, value_video_import_params_free_value, value_video_import_params_copy_value, value_video_import_params_peek_pointer, "p", value_video_import_params_collect_value, "p", value_video_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoImportParams), 0, (GInstanceInitFunc) video_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_import_params_type_id;
		video_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_import_params_type_id__volatile, video_import_params_type_id);
	}
	return video_import_params_type_id__volatile;
}


gpointer
video_import_params_ref (gpointer instance)
{
	VideoImportParams * self;
	self = instance;
#line 15 "../src/VideoSupport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 15 "../src/VideoSupport.vala"
	return instance;
#line 2202 "VideoSupport.c"
}


void
video_import_params_unref (gpointer instance)
{
	VideoImportParams * self;
	self = instance;
#line 15 "../src/VideoSupport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 15 "../src/VideoSupport.vala"
		VIDEO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 15 "../src/VideoSupport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2217 "VideoSupport.c"
	}
}


static inline gpointer
video_reader_get_instance_private (VideoReader* self)
{
	return G_STRUCT_MEMBER_P (self, VideoReader_private_offset);
}


VideoReader*
video_reader_construct (GType object_type,
                        GFile* file)
{
	VideoReader* self = NULL;
	GFile* _tmp0_;
#line 51 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 51 "../src/VideoSupport.vala"
	self = (VideoReader*) g_type_create_instance (object_type);
#line 52 "../src/VideoSupport.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 52 "../src/VideoSupport.vala"
	_g_object_unref0 (self->priv->file);
#line 52 "../src/VideoSupport.vala"
	self->priv->file = _tmp0_;
#line 51 "../src/VideoSupport.vala"
	return self;
#line 2247 "VideoSupport.c"
}


VideoReader*
video_reader_new (GFile* file)
{
#line 51 "../src/VideoSupport.vala"
	return video_reader_construct (TYPE_VIDEO_READER, file);
#line 2256 "VideoSupport.c"
}


gboolean
video_reader_is_supported_video_file (GFile* file)
{
	gboolean result = FALSE;
	gchar* mime_type = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
#line 55 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 56 "../src/VideoSupport.vala"
	_tmp0_ = g_file_get_basename (file);
#line 56 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/VideoSupport.vala"
	_tmp2_ = g_new0 (guchar, 0);
#line 56 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 56 "../src/VideoSupport.vala"
	_tmp3__length1 = 0;
#line 56 "../src/VideoSupport.vala"
	_tmp4_ = g_content_type_guess (_tmp1_, _tmp3_, (gsize) 0, NULL);
#line 56 "../src/VideoSupport.vala"
	_tmp5_ = _tmp4_;
#line 56 "../src/VideoSupport.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 56 "../src/VideoSupport.vala"
	_g_free0 (_tmp1_);
#line 56 "../src/VideoSupport.vala"
	mime_type = _tmp5_;
#line 58 "../src/VideoSupport.vala"
	_tmp7_ = mime_type;
#line 58 "../src/VideoSupport.vala"
	if (g_strcmp0 (_tmp7_, "audio/ogg") == 0) {
#line 58 "../src/VideoSupport.vala"
		_tmp6_ = g_file_has_uri_scheme (file, "file");
#line 2306 "VideoSupport.c"
	} else {
#line 58 "../src/VideoSupport.vala"
		_tmp6_ = FALSE;
#line 2310 "VideoSupport.c"
	}
#line 58 "../src/VideoSupport.vala"
	if (_tmp6_) {
#line 2314 "VideoSupport.c"
		{
			GFileInfo* info = NULL;
			GFileInfo* _tmp8_;
			gchar* content_type = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
#line 60 "../src/VideoSupport.vala"
			_tmp8_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 60 "../src/VideoSupport.vala"
			info = _tmp8_;
#line 60 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2330 "VideoSupport.c"
				goto __catch501_g_error;
			}
#line 62 "../src/VideoSupport.vala"
			_tmp9_ = info;
#line 62 "../src/VideoSupport.vala"
			_tmp10_ = g_file_info_get_content_type (_tmp9_);
#line 62 "../src/VideoSupport.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 62 "../src/VideoSupport.vala"
			content_type = _tmp11_;
#line 63 "../src/VideoSupport.vala"
			_tmp13_ = content_type;
#line 63 "../src/VideoSupport.vala"
			if (_tmp13_ != NULL) {
#line 2345 "VideoSupport.c"
				const gchar* _tmp14_;
#line 63 "../src/VideoSupport.vala"
				_tmp14_ = content_type;
#line 63 "../src/VideoSupport.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "video/");
#line 2351 "VideoSupport.c"
			} else {
#line 63 "../src/VideoSupport.vala"
				_tmp12_ = FALSE;
#line 2355 "VideoSupport.c"
			}
#line 63 "../src/VideoSupport.vala"
			if (_tmp12_) {
#line 64 "../src/VideoSupport.vala"
				result = TRUE;
#line 64 "../src/VideoSupport.vala"
				_g_free0 (content_type);
#line 64 "../src/VideoSupport.vala"
				_g_object_unref0 (info);
#line 64 "../src/VideoSupport.vala"
				_g_free0 (mime_type);
#line 64 "../src/VideoSupport.vala"
				return result;
#line 2369 "VideoSupport.c"
			}
#line 59 "../src/VideoSupport.vala"
			_g_free0 (content_type);
#line 59 "../src/VideoSupport.vala"
			_g_object_unref0 (info);
#line 2375 "VideoSupport.c"
		}
		goto __finally501;
		__catch501_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 59 "../src/VideoSupport.vala"
			_error_ = _inner_error0_;
#line 59 "../src/VideoSupport.vala"
			_inner_error0_ = NULL;
#line 67 "../src/VideoSupport.vala"
			_tmp15_ = _error_;
#line 67 "../src/VideoSupport.vala"
			_tmp16_ = _tmp15_->message;
#line 67 "../src/VideoSupport.vala"
			g_debug ("VideoSupport.vala:67: Failed to query content type: %s", _tmp16_);
#line 59 "../src/VideoSupport.vala"
			_g_error_free0 (_error_);
#line 2395 "VideoSupport.c"
		}
		__finally501:
#line 59 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2400 "VideoSupport.c"
			gboolean _tmp17_ = FALSE;
#line 59 "../src/VideoSupport.vala"
			_g_free0 (mime_type);
#line 59 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 59 "../src/VideoSupport.vala"
			return _tmp17_;
#line 2410 "VideoSupport.c"
		}
	}
#line 71 "../src/VideoSupport.vala"
	_tmp18_ = g_file_get_basename (file);
#line 71 "../src/VideoSupport.vala"
	_tmp19_ = _tmp18_;
#line 71 "../src/VideoSupport.vala"
	_tmp20_ = video_reader_is_supported_video_filename (_tmp19_);
#line 71 "../src/VideoSupport.vala"
	_g_free0 (_tmp19_);
#line 71 "../src/VideoSupport.vala"
	result = _tmp20_;
#line 71 "../src/VideoSupport.vala"
	_g_free0 (mime_type);
#line 71 "../src/VideoSupport.vala"
	return result;
#line 2427 "VideoSupport.c"
}


gboolean
video_reader_is_supported_video_filename (const gchar* filename)
{
	gboolean result = FALSE;
	gchar* mime_type = NULL;
	guchar* _tmp0_;
	guchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 74 "../src/VideoSupport.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 76 "../src/VideoSupport.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 76 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/VideoSupport.vala"
	_tmp1__length1 = 0;
#line 76 "../src/VideoSupport.vala"
	_tmp2_ = g_content_type_guess (filename, _tmp1_, (gsize) 0, NULL);
#line 76 "../src/VideoSupport.vala"
	_g_free0 (mime_type);
#line 76 "../src/VideoSupport.vala"
	mime_type = _tmp2_;
#line 76 "../src/VideoSupport.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 78 "../src/VideoSupport.vala"
	_tmp4_ = mime_type;
#line 78 "../src/VideoSupport.vala"
	if (g_str_has_prefix (_tmp4_, "video/")) {
#line 78 "../src/VideoSupport.vala"
		_tmp3_ = TRUE;
#line 2464 "VideoSupport.c"
	} else {
		const gchar* _tmp5_;
#line 78 "../src/VideoSupport.vala"
		_tmp5_ = mime_type;
#line 78 "../src/VideoSupport.vala"
		_tmp3_ = g_str_has_suffix (_tmp5_, "mp4");
#line 2471 "VideoSupport.c"
	}
#line 78 "../src/VideoSupport.vala"
	if (_tmp3_) {
#line 2475 "VideoSupport.c"
		gchar* extension = NULL;
		gchar* name = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_;
#line 79 "../src/VideoSupport.vala"
		extension = NULL;
#line 80 "../src/VideoSupport.vala"
		name = NULL;
#line 81 "../src/VideoSupport.vala"
		disassemble_filename (filename, &_tmp6_, &_tmp7_);
#line 81 "../src/VideoSupport.vala"
		_g_free0 (name);
#line 81 "../src/VideoSupport.vala"
		name = _tmp6_;
#line 81 "../src/VideoSupport.vala"
		_g_free0 (extension);
#line 81 "../src/VideoSupport.vala"
		extension = _tmp7_;
#line 83 "../src/VideoSupport.vala"
		_tmp8_ = extension;
#line 83 "../src/VideoSupport.vala"
		if (_tmp8_ == NULL) {
#line 84 "../src/VideoSupport.vala"
			result = TRUE;
#line 84 "../src/VideoSupport.vala"
			_g_free0 (name);
#line 84 "../src/VideoSupport.vala"
			_g_free0 (extension);
#line 84 "../src/VideoSupport.vala"
			_g_free0 (mime_type);
#line 84 "../src/VideoSupport.vala"
			return result;
#line 2509 "VideoSupport.c"
		}
		{
			const gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 86 "../src/VideoSupport.vala"
			s_collection = VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS;
#line 86 "../src/VideoSupport.vala"
			s_collection_length1 = G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS);
#line 86 "../src/VideoSupport.vala"
			for (s_it = 0; s_it < G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS); s_it = s_it + 1) {
#line 2522 "VideoSupport.c"
				gchar* _tmp9_;
				gchar* s = NULL;
#line 86 "../src/VideoSupport.vala"
				_tmp9_ = g_strdup (s_collection[s_it]);
#line 86 "../src/VideoSupport.vala"
				s = _tmp9_;
#line 2529 "VideoSupport.c"
				{
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 87 "../src/VideoSupport.vala"
					_tmp10_ = s;
#line 87 "../src/VideoSupport.vala"
					_tmp11_ = extension;
#line 87 "../src/VideoSupport.vala"
					if (utf8_ci_compare (_tmp10_, _tmp11_) == 0) {
#line 88 "../src/VideoSupport.vala"
						result = FALSE;
#line 88 "../src/VideoSupport.vala"
						_g_free0 (s);
#line 88 "../src/VideoSupport.vala"
						_g_free0 (name);
#line 88 "../src/VideoSupport.vala"
						_g_free0 (extension);
#line 88 "../src/VideoSupport.vala"
						_g_free0 (mime_type);
#line 88 "../src/VideoSupport.vala"
						return result;
#line 2551 "VideoSupport.c"
					}
#line 86 "../src/VideoSupport.vala"
					_g_free0 (s);
#line 2555 "VideoSupport.c"
				}
			}
		}
#line 91 "../src/VideoSupport.vala"
		result = TRUE;
#line 91 "../src/VideoSupport.vala"
		_g_free0 (name);
#line 91 "../src/VideoSupport.vala"
		_g_free0 (extension);
#line 91 "../src/VideoSupport.vala"
		_g_free0 (mime_type);
#line 91 "../src/VideoSupport.vala"
		return result;
#line 2569 "VideoSupport.c"
	} else {
		const gchar* _tmp12_;
#line 93 "../src/VideoSupport.vala"
		_tmp12_ = mime_type;
#line 93 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:93: Skipping %s, unsupported mime type %s", filename, _tmp12_);
#line 94 "../src/VideoSupport.vala"
		result = FALSE;
#line 94 "../src/VideoSupport.vala"
		_g_free0 (mime_type);
#line 94 "../src/VideoSupport.vala"
		return result;
#line 2582 "VideoSupport.c"
	}
#line 74 "../src/VideoSupport.vala"
	_g_free0 (mime_type);
#line 2586 "VideoSupport.c"
}


ImportResult
video_reader_prepare_for_import (VideoImportParams* params)
{
	ImportResult result = 0;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp11_;
	GTimeVal _tmp12_ = {0};
	const gchar* _tmp13_;
	time_t exposure_time = 0;
	time_t _tmp14_;
	gchar* title = NULL;
	gchar* _tmp15_;
	gchar* comment = NULL;
	gchar* _tmp16_;
	VideoReader* reader = NULL;
	GFile* _tmp17_;
	VideoReader* _tmp18_;
	gboolean is_interpretable = FALSE;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* _tmp19_;
	GdkPixbuf* _tmp20_;
	time_t _tmp45_;
	VideoRow* _tmp51_;
	VideoRow* _tmp52_;
	GFile* _tmp53_;
	gchar* _tmp54_;
	VideoRow* _tmp55_;
	GFileInfo* _tmp56_;
	VideoRow* _tmp57_;
	GTimeVal _tmp58_;
	glong _tmp59_;
	VideoRow* _tmp60_;
	GdkPixbuf* _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	VideoRow* _tmp64_;
	GdkPixbuf* _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	VideoRow* _tmp68_;
	gdouble _tmp69_;
	VideoRow* _tmp70_;
	gboolean _tmp71_;
	VideoRow* _tmp72_;
	time_t _tmp73_;
	VideoRow* _tmp74_;
	ImportID _tmp75_;
	VideoRow* _tmp76_;
	VideoRow* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	VideoRow* _tmp80_;
	VideoRow* _tmp81_;
	const gchar* _tmp82_;
	gchar* _tmp83_;
	VideoRow* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_;
	VideoRow* _tmp87_;
	gchar* _tmp88_;
	VideoRow* _tmp89_;
	VideoRow* _tmp90_;
	Thumbnails* _tmp91_;
	GError* _inner_error0_ = NULL;
#line 98 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
#line 102 "../src/VideoSupport.vala"
	_tmp0_ = params->file;
#line 102 "../src/VideoSupport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 102 "../src/VideoSupport.vala"
	file = _tmp1_;
#line 104 "../src/VideoSupport.vala"
	info = NULL;
#line 2671 "VideoSupport.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 106 "../src/VideoSupport.vala"
		_tmp3_ = file;
#line 106 "../src/VideoSupport.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 106 "../src/VideoSupport.vala"
		_tmp2_ = _tmp4_;
#line 106 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2685 "VideoSupport.c"
			goto __catch502_g_error;
		}
#line 106 "../src/VideoSupport.vala"
		_tmp5_ = _tmp2_;
#line 106 "../src/VideoSupport.vala"
		_tmp2_ = NULL;
#line 106 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 106 "../src/VideoSupport.vala"
		info = _tmp5_;
#line 105 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp2_);
#line 2698 "VideoSupport.c"
	}
	goto __finally502;
	__catch502_g_error:
	{
		GError* err = NULL;
#line 105 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 105 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 109 "../src/VideoSupport.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 109 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 109 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 109 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 109 "../src/VideoSupport.vala"
		return result;
#line 2718 "VideoSupport.c"
	}
	__finally502:
#line 105 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 105 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 105 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 105 "../src/VideoSupport.vala"
		return 0;
#line 2733 "VideoSupport.c"
	}
#line 112 "../src/VideoSupport.vala"
	_tmp6_ = info;
#line 112 "../src/VideoSupport.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 113 "../src/VideoSupport.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 113 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 113 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 113 "../src/VideoSupport.vala"
		return result;
#line 2747 "VideoSupport.c"
	}
#line 115 "../src/VideoSupport.vala"
	_tmp7_ = file;
#line 115 "../src/VideoSupport.vala"
	if (!video_reader_is_supported_video_file (_tmp7_)) {
#line 2753 "VideoSupport.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 116 "../src/VideoSupport.vala"
		_tmp8_ = file;
#line 116 "../src/VideoSupport.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 116 "../src/VideoSupport.vala"
		_tmp10_ = _tmp9_;
#line 116 "../src/VideoSupport.vala"
		g_message ("Not importing %s: file is marked as a video file but doesn't have a" "supported extension", _tmp10_);
#line 116 "../src/VideoSupport.vala"
		_g_free0 (_tmp10_);
#line 119 "../src/VideoSupport.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 119 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 119 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 119 "../src/VideoSupport.vala"
		return result;
#line 2775 "VideoSupport.c"
	}
#line 122 "../src/VideoSupport.vala"
	_tmp11_ = info;
#line 122 "../src/VideoSupport.vala"
	g_file_info_get_modification_time (_tmp11_, &_tmp12_);
#line 122 "../src/VideoSupport.vala"
	timestamp = _tmp12_;
#line 125 "../src/VideoSupport.vala"
	_tmp13_ = params->md5;
#line 125 "../src/VideoSupport.vala"
	_vala_assert (_tmp13_ != NULL, "params.md5 != null");
#line 127 "../src/VideoSupport.vala"
	_tmp14_ = params->exposure_time_override;
#line 127 "../src/VideoSupport.vala"
	exposure_time = _tmp14_;
#line 128 "../src/VideoSupport.vala"
	_tmp15_ = g_strdup ("");
#line 128 "../src/VideoSupport.vala"
	title = _tmp15_;
#line 129 "../src/VideoSupport.vala"
	_tmp16_ = g_strdup ("");
#line 129 "../src/VideoSupport.vala"
	comment = _tmp16_;
#line 131 "../src/VideoSupport.vala"
	_tmp17_ = file;
#line 131 "../src/VideoSupport.vala"
	_tmp18_ = video_reader_new (_tmp17_);
#line 131 "../src/VideoSupport.vala"
	reader = _tmp18_;
#line 132 "../src/VideoSupport.vala"
	is_interpretable = TRUE;
#line 133 "../src/VideoSupport.vala"
	clip_duration = 0.0;
#line 134 "../src/VideoSupport.vala"
	_tmp19_ = reader;
#line 134 "../src/VideoSupport.vala"
	_tmp20_ = video_reader_read_preview_frame (_tmp19_);
#line 134 "../src/VideoSupport.vala"
	preview_frame = _tmp20_;
#line 2815 "VideoSupport.c"
	{
		gdouble _tmp21_ = 0.0;
		VideoReader* _tmp22_;
#line 136 "../src/VideoSupport.vala"
		_tmp22_ = reader;
#line 136 "../src/VideoSupport.vala"
		_tmp21_ = video_reader_read_clip_duration (_tmp22_, &_inner_error0_);
#line 136 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 2827 "VideoSupport.c"
				goto __catch503_video_error;
			}
#line 136 "../src/VideoSupport.vala"
			_g_object_unref0 (preview_frame);
#line 136 "../src/VideoSupport.vala"
			_video_reader_unref0 (reader);
#line 136 "../src/VideoSupport.vala"
			_g_free0 (comment);
#line 136 "../src/VideoSupport.vala"
			_g_free0 (title);
#line 136 "../src/VideoSupport.vala"
			_g_object_unref0 (info);
#line 136 "../src/VideoSupport.vala"
			_g_object_unref0 (file);
#line 136 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 136 "../src/VideoSupport.vala"
			return 0;
#line 2848 "VideoSupport.c"
		}
#line 136 "../src/VideoSupport.vala"
		clip_duration = _tmp21_;
#line 2852 "VideoSupport.c"
	}
	goto __finally503;
	__catch503_video_error:
	{
		GError* err = NULL;
		GError* _tmp23_;
#line 135 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 135 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 138 "../src/VideoSupport.vala"
		_tmp23_ = err;
#line 138 "../src/VideoSupport.vala"
		if (g_error_matches (_tmp23_, VIDEO_ERROR, VIDEO_ERROR_FILE)) {
#line 139 "../src/VideoSupport.vala"
			result = IMPORT_RESULT_FILE_ERROR;
#line 139 "../src/VideoSupport.vala"
			_g_error_free0 (err);
#line 139 "../src/VideoSupport.vala"
			_g_object_unref0 (preview_frame);
#line 139 "../src/VideoSupport.vala"
			_video_reader_unref0 (reader);
#line 139 "../src/VideoSupport.vala"
			_g_free0 (comment);
#line 139 "../src/VideoSupport.vala"
			_g_free0 (title);
#line 139 "../src/VideoSupport.vala"
			_g_object_unref0 (info);
#line 139 "../src/VideoSupport.vala"
			_g_object_unref0 (file);
#line 139 "../src/VideoSupport.vala"
			return result;
#line 2885 "VideoSupport.c"
		} else {
			GError* _tmp24_;
#line 140 "../src/VideoSupport.vala"
			_tmp24_ = err;
#line 140 "../src/VideoSupport.vala"
			if (g_error_matches (_tmp24_, VIDEO_ERROR, VIDEO_ERROR_CONTENTS)) {
#line 141 "../src/VideoSupport.vala"
				is_interpretable = FALSE;
#line 142 "../src/VideoSupport.vala"
				clip_duration = 0.0;
#line 2896 "VideoSupport.c"
			} else {
#line 144 "../src/VideoSupport.vala"
				g_error ("VideoSupport.vala:144: can't prepare video for import: an unknown kind" \
" of video error occurred");
#line 2900 "VideoSupport.c"
			}
		}
#line 135 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 2905 "VideoSupport.c"
	}
	__finally503:
#line 135 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 135 "../src/VideoSupport.vala"
		_video_reader_unref0 (reader);
#line 135 "../src/VideoSupport.vala"
		_g_free0 (comment);
#line 135 "../src/VideoSupport.vala"
		_g_free0 (title);
#line 135 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 135 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 135 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 135 "../src/VideoSupport.vala"
		return 0;
#line 2928 "VideoSupport.c"
	}
	{
		VideoMetadata* metadata = NULL;
		VideoReader* _tmp25_;
		VideoMetadata* _tmp26_;
		MetadataDateTime* creation_date_time = NULL;
		VideoMetadata* _tmp27_;
		MetadataDateTime* _tmp28_;
		gboolean _tmp29_ = FALSE;
		MetadataDateTime* _tmp30_;
		gchar* video_title = NULL;
		VideoMetadata* _tmp33_;
		gchar* _tmp34_;
		gchar* video_comment = NULL;
		VideoMetadata* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp40_;
#line 149 "../src/VideoSupport.vala"
		_tmp25_ = reader;
#line 149 "../src/VideoSupport.vala"
		_tmp26_ = video_reader_read_metadata (_tmp25_, &_inner_error0_);
#line 149 "../src/VideoSupport.vala"
		metadata = _tmp26_;
#line 149 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2955 "VideoSupport.c"
			goto __catch504_g_error;
		}
#line 150 "../src/VideoSupport.vala"
		_tmp27_ = metadata;
#line 150 "../src/VideoSupport.vala"
		_tmp28_ = media_metadata_get_creation_date_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 150 "../src/VideoSupport.vala"
		creation_date_time = _tmp28_;
#line 152 "../src/VideoSupport.vala"
		_tmp30_ = creation_date_time;
#line 152 "../src/VideoSupport.vala"
		if (_tmp30_ != NULL) {
#line 2968 "VideoSupport.c"
			MetadataDateTime* _tmp31_;
#line 152 "../src/VideoSupport.vala"
			_tmp31_ = creation_date_time;
#line 152 "../src/VideoSupport.vala"
			_tmp29_ = metadata_date_time_get_timestamp (_tmp31_) != ((time_t) 0);
#line 2974 "VideoSupport.c"
		} else {
#line 152 "../src/VideoSupport.vala"
			_tmp29_ = FALSE;
#line 2978 "VideoSupport.c"
		}
#line 152 "../src/VideoSupport.vala"
		if (_tmp29_) {
#line 2982 "VideoSupport.c"
			MetadataDateTime* _tmp32_;
#line 153 "../src/VideoSupport.vala"
			_tmp32_ = creation_date_time;
#line 153 "../src/VideoSupport.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp32_);
#line 2988 "VideoSupport.c"
		}
#line 155 "../src/VideoSupport.vala"
		_tmp33_ = metadata;
#line 155 "../src/VideoSupport.vala"
		_tmp34_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 155 "../src/VideoSupport.vala"
		video_title = _tmp34_;
#line 156 "../src/VideoSupport.vala"
		_tmp35_ = metadata;
#line 156 "../src/VideoSupport.vala"
		_tmp36_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 156 "../src/VideoSupport.vala"
		video_comment = _tmp36_;
#line 157 "../src/VideoSupport.vala"
		_tmp37_ = video_title;
#line 157 "../src/VideoSupport.vala"
		if (_tmp37_ != NULL) {
#line 3006 "VideoSupport.c"
			const gchar* _tmp38_;
			gchar* _tmp39_;
#line 158 "../src/VideoSupport.vala"
			_tmp38_ = video_title;
#line 158 "../src/VideoSupport.vala"
			_tmp39_ = g_strdup (_tmp38_);
#line 158 "../src/VideoSupport.vala"
			_g_free0 (title);
#line 158 "../src/VideoSupport.vala"
			title = _tmp39_;
#line 3017 "VideoSupport.c"
		}
#line 159 "../src/VideoSupport.vala"
		_tmp40_ = video_comment;
#line 159 "../src/VideoSupport.vala"
		if (_tmp40_ != NULL) {
#line 3023 "VideoSupport.c"
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 160 "../src/VideoSupport.vala"
			_tmp41_ = video_comment;
#line 160 "../src/VideoSupport.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 160 "../src/VideoSupport.vala"
			_g_free0 (comment);
#line 160 "../src/VideoSupport.vala"
			comment = _tmp42_;
#line 3034 "VideoSupport.c"
		}
#line 148 "../src/VideoSupport.vala"
		_g_free0 (video_comment);
#line 148 "../src/VideoSupport.vala"
		_g_free0 (video_title);
#line 148 "../src/VideoSupport.vala"
		_metadata_date_time_unref0 (creation_date_time);
#line 148 "../src/VideoSupport.vala"
		_media_metadata_unref0 (metadata);
#line 3044 "VideoSupport.c"
	}
	goto __finally504;
	__catch504_g_error:
	{
		GError* err = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 148 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 148 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 162 "../src/VideoSupport.vala"
		_tmp43_ = err;
#line 162 "../src/VideoSupport.vala"
		_tmp44_ = _tmp43_->message;
#line 162 "../src/VideoSupport.vala"
		g_warning ("VideoSupport.vala:162: Unable to read video metadata: %s", _tmp44_);
#line 148 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 3064 "VideoSupport.c"
	}
	__finally504:
#line 148 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 148 "../src/VideoSupport.vala"
		_video_reader_unref0 (reader);
#line 148 "../src/VideoSupport.vala"
		_g_free0 (comment);
#line 148 "../src/VideoSupport.vala"
		_g_free0 (title);
#line 148 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 148 "../src/VideoSupport.vala"
		_g_object_unref0 (file);
#line 148 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 148 "../src/VideoSupport.vala"
		return 0;
#line 3087 "VideoSupport.c"
	}
#line 165 "../src/VideoSupport.vala"
	_tmp45_ = exposure_time;
#line 165 "../src/VideoSupport.vala"
	if (_tmp45_ == ((time_t) 0)) {
#line 3093 "VideoSupport.c"
		gint64 _tmp46_ = 0LL;
		VideoReader* _tmp47_;
		GDateTime* _tmp48_;
#line 167 "../src/VideoSupport.vala"
		_tmp47_ = reader;
#line 167 "../src/VideoSupport.vala"
		_tmp48_ = _tmp47_->priv->_timestamp;
#line 167 "../src/VideoSupport.vala"
		if (_tmp48_ != NULL) {
#line 3103 "VideoSupport.c"
			VideoReader* _tmp49_;
			GDateTime* _tmp50_;
#line 168 "../src/VideoSupport.vala"
			_tmp49_ = reader;
#line 168 "../src/VideoSupport.vala"
			_tmp50_ = _tmp49_->priv->_timestamp;
#line 168 "../src/VideoSupport.vala"
			_tmp46_ = g_date_time_to_unix (_tmp50_);
#line 3112 "VideoSupport.c"
		} else {
#line 168 "../src/VideoSupport.vala"
			_tmp46_ = (gint64) 0;
#line 3116 "VideoSupport.c"
		}
#line 167 "../src/VideoSupport.vala"
		exposure_time = (time_t) _tmp46_;
#line 3120 "VideoSupport.c"
	}
#line 171 "../src/VideoSupport.vala"
	_tmp51_ = params->row;
#line 171 "../src/VideoSupport.vala"
	video_id_init (&_tmp51_->video_id, VIDEO_ID_INVALID);
#line 172 "../src/VideoSupport.vala"
	_tmp52_ = params->row;
#line 172 "../src/VideoSupport.vala"
	_tmp53_ = file;
#line 172 "../src/VideoSupport.vala"
	_tmp54_ = g_file_get_path (_tmp53_);
#line 172 "../src/VideoSupport.vala"
	_g_free0 (_tmp52_->filepath);
#line 172 "../src/VideoSupport.vala"
	_tmp52_->filepath = _tmp54_;
#line 173 "../src/VideoSupport.vala"
	_tmp55_ = params->row;
#line 173 "../src/VideoSupport.vala"
	_tmp56_ = info;
#line 173 "../src/VideoSupport.vala"
	_tmp55_->filesize = g_file_info_get_size (_tmp56_);
#line 174 "../src/VideoSupport.vala"
	_tmp57_ = params->row;
#line 174 "../src/VideoSupport.vala"
	_tmp58_ = timestamp;
#line 174 "../src/VideoSupport.vala"
	_tmp59_ = _tmp58_.tv_sec;
#line 174 "../src/VideoSupport.vala"
	_tmp57_->timestamp = (time_t) _tmp59_;
#line 175 "../src/VideoSupport.vala"
	_tmp60_ = params->row;
#line 175 "../src/VideoSupport.vala"
	_tmp61_ = preview_frame;
#line 175 "../src/VideoSupport.vala"
	_tmp62_ = gdk_pixbuf_get_width (_tmp61_);
#line 175 "../src/VideoSupport.vala"
	_tmp63_ = _tmp62_;
#line 175 "../src/VideoSupport.vala"
	_tmp60_->width = _tmp63_;
#line 176 "../src/VideoSupport.vala"
	_tmp64_ = params->row;
#line 176 "../src/VideoSupport.vala"
	_tmp65_ = preview_frame;
#line 176 "../src/VideoSupport.vala"
	_tmp66_ = gdk_pixbuf_get_height (_tmp65_);
#line 176 "../src/VideoSupport.vala"
	_tmp67_ = _tmp66_;
#line 176 "../src/VideoSupport.vala"
	_tmp64_->height = _tmp67_;
#line 177 "../src/VideoSupport.vala"
	_tmp68_ = params->row;
#line 177 "../src/VideoSupport.vala"
	_tmp69_ = clip_duration;
#line 177 "../src/VideoSupport.vala"
	_tmp68_->clip_duration = _tmp69_;
#line 178 "../src/VideoSupport.vala"
	_tmp70_ = params->row;
#line 178 "../src/VideoSupport.vala"
	_tmp71_ = is_interpretable;
#line 178 "../src/VideoSupport.vala"
	_tmp70_->is_interpretable = _tmp71_;
#line 179 "../src/VideoSupport.vala"
	_tmp72_ = params->row;
#line 179 "../src/VideoSupport.vala"
	_tmp73_ = exposure_time;
#line 179 "../src/VideoSupport.vala"
	_tmp72_->exposure_time = _tmp73_;
#line 180 "../src/VideoSupport.vala"
	_tmp74_ = params->row;
#line 180 "../src/VideoSupport.vala"
	_tmp75_ = params->import_id;
#line 180 "../src/VideoSupport.vala"
	_tmp74_->import_id = _tmp75_;
#line 181 "../src/VideoSupport.vala"
	_tmp76_ = params->row;
#line 181 "../src/VideoSupport.vala"
	event_id_init (&_tmp76_->event_id, EVENT_ID_INVALID);
#line 182 "../src/VideoSupport.vala"
	_tmp77_ = params->row;
#line 182 "../src/VideoSupport.vala"
	_tmp78_ = params->md5;
#line 182 "../src/VideoSupport.vala"
	_tmp79_ = g_strdup (_tmp78_);
#line 182 "../src/VideoSupport.vala"
	_g_free0 (_tmp77_->md5);
#line 182 "../src/VideoSupport.vala"
	_tmp77_->md5 = _tmp79_;
#line 183 "../src/VideoSupport.vala"
	_tmp80_ = params->row;
#line 183 "../src/VideoSupport.vala"
	_tmp80_->time_created = (time_t) 0;
#line 184 "../src/VideoSupport.vala"
	_tmp81_ = params->row;
#line 184 "../src/VideoSupport.vala"
	_tmp82_ = title;
#line 184 "../src/VideoSupport.vala"
	_tmp83_ = g_strdup (_tmp82_);
#line 184 "../src/VideoSupport.vala"
	_g_free0 (_tmp81_->title);
#line 184 "../src/VideoSupport.vala"
	_tmp81_->title = _tmp83_;
#line 185 "../src/VideoSupport.vala"
	_tmp84_ = params->row;
#line 185 "../src/VideoSupport.vala"
	_tmp85_ = comment;
#line 185 "../src/VideoSupport.vala"
	_tmp86_ = g_strdup (_tmp85_);
#line 185 "../src/VideoSupport.vala"
	_g_free0 (_tmp84_->comment);
#line 185 "../src/VideoSupport.vala"
	_tmp84_->comment = _tmp86_;
#line 186 "../src/VideoSupport.vala"
	_tmp87_ = params->row;
#line 186 "../src/VideoSupport.vala"
	_tmp88_ = g_strdup ("");
#line 186 "../src/VideoSupport.vala"
	_g_free0 (_tmp87_->backlinks);
#line 186 "../src/VideoSupport.vala"
	_tmp87_->backlinks = _tmp88_;
#line 187 "../src/VideoSupport.vala"
	_tmp89_ = params->row;
#line 187 "../src/VideoSupport.vala"
	_tmp89_->time_reimported = (time_t) 0;
#line 188 "../src/VideoSupport.vala"
	_tmp90_ = params->row;
#line 188 "../src/VideoSupport.vala"
	_tmp90_->flags = (guint64) 0;
#line 190 "../src/VideoSupport.vala"
	_tmp91_ = params->thumbnails;
#line 190 "../src/VideoSupport.vala"
	if (_tmp91_ != NULL) {
#line 3252 "VideoSupport.c"
		Thumbnails* _tmp92_;
		Thumbnails* _tmp93_;
		GdkPixbuf* _tmp94_;
#line 191 "../src/VideoSupport.vala"
		_tmp92_ = thumbnails_new ();
#line 191 "../src/VideoSupport.vala"
		_thumbnails_unref0 (params->thumbnails);
#line 191 "../src/VideoSupport.vala"
		params->thumbnails = _tmp92_;
#line 192 "../src/VideoSupport.vala"
		_tmp93_ = params->thumbnails;
#line 192 "../src/VideoSupport.vala"
		_tmp94_ = preview_frame;
#line 192 "../src/VideoSupport.vala"
		thumbnail_cache_generate_for_video_frame (_tmp93_, _tmp94_);
#line 3268 "VideoSupport.c"
	}
#line 198 "../src/VideoSupport.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 198 "../src/VideoSupport.vala"
	_g_object_unref0 (preview_frame);
#line 198 "../src/VideoSupport.vala"
	_video_reader_unref0 (reader);
#line 198 "../src/VideoSupport.vala"
	_g_free0 (comment);
#line 198 "../src/VideoSupport.vala"
	_g_free0 (title);
#line 198 "../src/VideoSupport.vala"
	_g_object_unref0 (info);
#line 198 "../src/VideoSupport.vala"
	_g_object_unref0 (file);
#line 198 "../src/VideoSupport.vala"
	return result;
#line 3286 "VideoSupport.c"
}


static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
#line 216 "../src/VideoSupport.vala"
	dup = g_new0 (GDate, 1);
#line 216 "../src/VideoSupport.vala"
	memcpy (dup, self, sizeof (GDate));
#line 216 "../src/VideoSupport.vala"
	return dup;
#line 3300 "VideoSupport.c"
}


static gpointer
__g_date_dup0 (gpointer self)
{
#line 216 "../src/VideoSupport.vala"
	return self ? _g_date_dup (self) : NULL;
#line 3309 "VideoSupport.c"
}


static void
video_reader_read_internal (VideoReader* self,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
#line 201 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 202 "../src/VideoSupport.vala"
	if (!video_reader_does_file_exist (self)) {
#line 3322 "VideoSupport.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 203 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->file;
#line 203 "../src/VideoSupport.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 203 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 203 "../src/VideoSupport.vala"
		_tmp3_ = g_strdup_printf ("video file '%s' does not exist or is inaccessible", _tmp2_);
#line 203 "../src/VideoSupport.vala"
		_tmp4_ = _tmp3_;
#line 203 "../src/VideoSupport.vala"
		_tmp5_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_FILE, _tmp4_);
#line 203 "../src/VideoSupport.vala"
		_tmp6_ = _tmp5_;
#line 203 "../src/VideoSupport.vala"
		_g_free0 (_tmp4_);
#line 203 "../src/VideoSupport.vala"
		_g_free0 (_tmp2_);
#line 203 "../src/VideoSupport.vala"
		_inner_error0_ = _tmp6_;
#line 203 "../src/VideoSupport.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 203 "../src/VideoSupport.vala"
			g_propagate_error (error, _inner_error0_);
#line 203 "../src/VideoSupport.vala"
			return;
#line 3356 "VideoSupport.c"
		} else {
#line 203 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 203 "../src/VideoSupport.vala"
			return;
#line 3364 "VideoSupport.c"
		}
	}
	{
		GstDiscoverer* d = NULL;
		GstDiscoverer* _tmp7_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GstDiscovererInfo* _tmp12_;
		GstDiscovererInfo* _tmp13_;
		GstDiscovererInfo* _tmp14_;
		GDate* video_date = NULL;
		gboolean _tmp15_ = FALSE;
		GstDiscovererInfo* _tmp16_;
		GstTagList* _tmp17_;
#line 207 "../src/VideoSupport.vala"
		_tmp7_ = gst_discoverer_new ((GstClockTime) (GST_SECOND * 5), &_inner_error0_);
#line 207 "../src/VideoSupport.vala"
		d = _tmp7_;
#line 207 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3388 "VideoSupport.c"
			goto __catch505_g_error;
		}
#line 208 "../src/VideoSupport.vala"
		_tmp8_ = d;
#line 208 "../src/VideoSupport.vala"
		_tmp9_ = self->priv->file;
#line 208 "../src/VideoSupport.vala"
		_tmp10_ = g_file_get_uri (_tmp9_);
#line 208 "../src/VideoSupport.vala"
		_tmp11_ = _tmp10_;
#line 208 "../src/VideoSupport.vala"
		_tmp12_ = gst_discoverer_discover_uri (_tmp8_, _tmp11_, &_inner_error0_);
#line 208 "../src/VideoSupport.vala"
		_tmp13_ = _tmp12_;
#line 208 "../src/VideoSupport.vala"
		_g_free0 (_tmp11_);
#line 208 "../src/VideoSupport.vala"
		info = _tmp13_;
#line 208 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/VideoSupport.vala"
			_g_object_unref0 (d);
#line 3411 "VideoSupport.c"
			goto __catch505_g_error;
		}
#line 210 "../src/VideoSupport.vala"
		_tmp14_ = info;
#line 210 "../src/VideoSupport.vala"
		self->priv->clip_duration = ((gdouble) gst_discoverer_info_get_duration (_tmp14_)) / 1000000000.0;
#line 215 "../src/VideoSupport.vala"
		video_date = NULL;
#line 216 "../src/VideoSupport.vala"
		_tmp16_ = info;
#line 216 "../src/VideoSupport.vala"
		_tmp17_ = gst_discoverer_info_get_tags (_tmp16_);
#line 216 "../src/VideoSupport.vala"
		if (_tmp17_ != NULL) {
#line 3426 "VideoSupport.c"
			GstDiscovererInfo* _tmp18_;
			GstTagList* _tmp19_;
			GDate _tmp20_ = {0};
			gboolean _tmp21_;
			GDate _tmp22_;
			GDate* _tmp23_;
#line 216 "../src/VideoSupport.vala"
			_tmp18_ = info;
#line 216 "../src/VideoSupport.vala"
			_tmp19_ = gst_discoverer_info_get_tags (_tmp18_);
#line 216 "../src/VideoSupport.vala"
			_tmp21_ = gst_tag_list_get_date (_tmp19_, GST_TAG_DATE, &_tmp20_);
#line 216 "../src/VideoSupport.vala"
			_g_free0 (video_date);
#line 216 "../src/VideoSupport.vala"
			_tmp22_ = _tmp20_;
#line 216 "../src/VideoSupport.vala"
			_tmp23_ = __g_date_dup0 (&_tmp22_);
#line 216 "../src/VideoSupport.vala"
			video_date = _tmp23_;
#line 216 "../src/VideoSupport.vala"
			_tmp15_ = _tmp21_;
#line 3449 "VideoSupport.c"
		} else {
#line 216 "../src/VideoSupport.vala"
			_tmp15_ = FALSE;
#line 3453 "VideoSupport.c"
		}
#line 216 "../src/VideoSupport.vala"
		if (_tmp15_) {
#line 3457 "VideoSupport.c"
			GDate* _tmp24_;
#line 218 "../src/VideoSupport.vala"
			_tmp24_ = video_date;
#line 218 "../src/VideoSupport.vala"
			if (_tmp24_ != NULL) {
#line 3463 "VideoSupport.c"
				GDate* _tmp25_;
				GDate* _tmp26_;
				GDate* _tmp27_;
				GDateTime* _tmp28_;
				GDateTime* _tmp29_;
#line 219 "../src/VideoSupport.vala"
				_tmp25_ = video_date;
#line 219 "../src/VideoSupport.vala"
				_tmp26_ = video_date;
#line 219 "../src/VideoSupport.vala"
				_tmp27_ = video_date;
#line 219 "../src/VideoSupport.vala"
				_tmp28_ = g_date_time_new_local ((gint) g_date_get_year (_tmp25_), (gint) g_date_get_month (_tmp26_), (gint) g_date_get_day (_tmp27_), 0, 0, (gdouble) 0);
#line 219 "../src/VideoSupport.vala"
				_tmp29_ = _tmp28_;
#line 219 "../src/VideoSupport.vala"
				video_reader_set_timestamp (self, _tmp29_);
#line 219 "../src/VideoSupport.vala"
				_g_date_time_unref0 (_tmp29_);
#line 3483 "VideoSupport.c"
			}
		}
#line 206 "../src/VideoSupport.vala"
		_g_free0 (video_date);
#line 206 "../src/VideoSupport.vala"
		_g_object_unref0 (info);
#line 206 "../src/VideoSupport.vala"
		_g_object_unref0 (d);
#line 3492 "VideoSupport.c"
	}
	goto __finally505;
	__catch505_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GError* _tmp36_;
		GError* _tmp37_;
#line 206 "../src/VideoSupport.vala"
		e = _inner_error0_;
#line 206 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 224 "../src/VideoSupport.vala"
		_tmp30_ = e;
#line 224 "../src/VideoSupport.vala"
		_tmp31_ = _tmp30_->message;
#line 224 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:224: Video read error: %s", _tmp31_);
#line 225 "../src/VideoSupport.vala"
		_tmp32_ = e;
#line 225 "../src/VideoSupport.vala"
		_tmp33_ = _tmp32_->message;
#line 225 "../src/VideoSupport.vala"
		_tmp34_ = g_strdup_printf ("GStreamer couldn't extract clip information: %s", _tmp33_);
#line 225 "../src/VideoSupport.vala"
		_tmp35_ = _tmp34_;
#line 225 "../src/VideoSupport.vala"
		_tmp36_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_CONTENTS, _tmp35_);
#line 225 "../src/VideoSupport.vala"
		_tmp37_ = _tmp36_;
#line 225 "../src/VideoSupport.vala"
		_g_free0 (_tmp35_);
#line 225 "../src/VideoSupport.vala"
		_inner_error0_ = _tmp37_;
#line 225 "../src/VideoSupport.vala"
		_g_error_free0 (e);
#line 3534 "VideoSupport.c"
		goto __finally505;
	}
	__finally505:
#line 206 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/VideoSupport.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 206 "../src/VideoSupport.vala"
			g_propagate_error (error, _inner_error0_);
#line 206 "../src/VideoSupport.vala"
			return;
#line 3546 "VideoSupport.c"
		} else {
#line 206 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 206 "../src/VideoSupport.vala"
			return;
#line 3554 "VideoSupport.c"
		}
	}
}


static gboolean
video_reader_on_thumbnailer_timer (VideoReader* self)
{
	gboolean result = FALSE;
	GPid _tmp0_;
#line 231 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 232 "../src/VideoSupport.vala"
	g_debug ("VideoSupport.vala:232: Thumbnailer timer called");
#line 233 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->thumbnailer_pid;
#line 233 "../src/VideoSupport.vala"
	if (_tmp0_ != ((GPid) 0)) {
#line 3573 "VideoSupport.c"
		GPid _tmp1_;
		GPid _tmp2_;
#line 234 "../src/VideoSupport.vala"
		_tmp1_ = self->priv->thumbnailer_pid;
#line 234 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:234: Killing thumbnailer process: %d", (gint) _tmp1_);
#line 236 "../src/VideoSupport.vala"
		_tmp2_ = self->priv->thumbnailer_pid;
#line 236 "../src/VideoSupport.vala"
		kill ((pid_t) _tmp2_, (gint) SIGKILL);
#line 3584 "VideoSupport.c"
	}
#line 241 "../src/VideoSupport.vala"
	result = FALSE;
#line 241 "../src/VideoSupport.vala"
	return result;
#line 3590 "VideoSupport.c"
}


static gboolean
_video_reader_on_thumbnailer_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = video_reader_on_thumbnailer_timer ((VideoReader*) self);
#line 264 "../src/VideoSupport.vala"
	return result;
#line 3601 "VideoSupport.c"
}


static GdkPixbuf*
video_reader_thumbnailer (VideoReader* self,
                          const gchar* video_file)
{
	GdkPixbuf* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** argv = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint argv_length1;
	gint _argv_size_;
	gint child_stdout = 0;
	GdkPixbuf* buf = NULL;
	gint child_status = 0;
	gint ret_waitpid = 0;
	GPid _tmp26_;
	gint _tmp27_ = 0;
	pid_t _tmp28_;
	gint _tmp29_;
	GPid _tmp33_;
	GError* _inner_error0_ = NULL;
#line 246 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 246 "../src/VideoSupport.vala"
	g_return_val_if_fail (video_file != NULL, NULL);
#line 248 "../src/VideoSupport.vala"
	_tmp0_ = app_dirs_get_thumbnailer_bin ();
#line 248 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 248 "../src/VideoSupport.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 248 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 248 "../src/VideoSupport.vala"
	g_debug ("VideoSupport.vala:248: Launching thumbnailer process: %s", _tmp3_);
#line 248 "../src/VideoSupport.vala"
	_g_free0 (_tmp3_);
#line 248 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp1_);
#line 249 "../src/VideoSupport.vala"
	_tmp4_ = app_dirs_get_thumbnailer_bin ();
#line 249 "../src/VideoSupport.vala"
	_tmp5_ = _tmp4_;
#line 249 "../src/VideoSupport.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 249 "../src/VideoSupport.vala"
	_tmp7_ = g_strdup (video_file);
#line 249 "../src/VideoSupport.vala"
	_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 249 "../src/VideoSupport.vala"
	_tmp8_[0] = _tmp6_;
#line 249 "../src/VideoSupport.vala"
	_tmp8_[1] = _tmp7_;
#line 249 "../src/VideoSupport.vala"
	_tmp9_ = _tmp8_;
#line 249 "../src/VideoSupport.vala"
	_tmp9__length1 = 2;
#line 249 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp5_);
#line 249 "../src/VideoSupport.vala"
	argv = _tmp9_;
#line 249 "../src/VideoSupport.vala"
	argv_length1 = _tmp9__length1;
#line 249 "../src/VideoSupport.vala"
	_argv_size_ = argv_length1;
#line 3678 "VideoSupport.c"
	{
		gchar** _tmp10_;
		gint _tmp10__length1;
		GPid _tmp11_ = 0;
		gint _tmp12_ = 0;
		GPid _tmp13_;
#line 252 "../src/VideoSupport.vala"
		_tmp10_ = argv;
#line 252 "../src/VideoSupport.vala"
		_tmp10__length1 = argv_length1;
#line 252 "../src/VideoSupport.vala"
		g_spawn_async_with_pipes (NULL, _tmp10_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp11_, NULL, &_tmp12_, NULL, &_inner_error0_);
#line 252 "../src/VideoSupport.vala"
		self->priv->thumbnailer_pid = _tmp11_;
#line 252 "../src/VideoSupport.vala"
		child_stdout = _tmp12_;
#line 252 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3697 "VideoSupport.c"
			goto __catch506_g_error;
		}
#line 255 "../src/VideoSupport.vala"
		_tmp13_ = self->priv->thumbnailer_pid;
#line 255 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:255: Spawned thumbnailer, child pid: %d", (gint) _tmp13_);
#line 3704 "VideoSupport.c"
	}
	goto __finally506;
	__catch506_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		GPid _tmp16_;
#line 251 "../src/VideoSupport.vala"
		e = _inner_error0_;
#line 251 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 257 "../src/VideoSupport.vala"
		_tmp14_ = e;
#line 257 "../src/VideoSupport.vala"
		_tmp15_ = _tmp14_->message;
#line 257 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:257: Error spawning process: %s", _tmp15_);
#line 258 "../src/VideoSupport.vala"
		_tmp16_ = self->priv->thumbnailer_pid;
#line 258 "../src/VideoSupport.vala"
		if (_tmp16_ != ((GPid) 0)) {
#line 3727 "VideoSupport.c"
			GPid _tmp17_;
#line 259 "../src/VideoSupport.vala"
			_tmp17_ = self->priv->thumbnailer_pid;
#line 259 "../src/VideoSupport.vala"
			g_spawn_close_pid (_tmp17_);
#line 3733 "VideoSupport.c"
		}
#line 260 "../src/VideoSupport.vala"
		result = NULL;
#line 260 "../src/VideoSupport.vala"
		_g_error_free0 (e);
#line 260 "../src/VideoSupport.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 260 "../src/VideoSupport.vala"
		return result;
#line 3743 "VideoSupport.c"
	}
	__finally506:
#line 251 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/VideoSupport.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 251 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 251 "../src/VideoSupport.vala"
		return NULL;
#line 3756 "VideoSupport.c"
	}
#line 264 "../src/VideoSupport.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, VIDEO_READER_THUMBNAILER_TIMEOUT, _video_reader_on_thumbnailer_timer_gsource_func, video_reader_ref (self), video_reader_unref);
#line 267 "../src/VideoSupport.vala"
	buf = NULL;
#line 3762 "VideoSupport.c"
	{
		GUnixInputStream* unix_input = NULL;
		gint _tmp18_;
		GUnixInputStream* _tmp19_;
		GdkPixbuf* _tmp20_ = NULL;
		GUnixInputStream* _tmp21_;
		GdkPixbuf* _tmp22_;
		GdkPixbuf* _tmp23_;
#line 269 "../src/VideoSupport.vala"
		_tmp18_ = child_stdout;
#line 269 "../src/VideoSupport.vala"
		_tmp19_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp18_, TRUE);
#line 269 "../src/VideoSupport.vala"
		unix_input = _tmp19_;
#line 270 "../src/VideoSupport.vala"
		_tmp21_ = unix_input;
#line 270 "../src/VideoSupport.vala"
		_tmp22_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
#line 270 "../src/VideoSupport.vala"
		_tmp20_ = _tmp22_;
#line 270 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "../src/VideoSupport.vala"
			_g_object_unref0 (unix_input);
#line 3787 "VideoSupport.c"
			goto __catch507_g_error;
		}
#line 270 "../src/VideoSupport.vala"
		_tmp23_ = _tmp20_;
#line 270 "../src/VideoSupport.vala"
		_tmp20_ = NULL;
#line 270 "../src/VideoSupport.vala"
		_g_object_unref0 (buf);
#line 270 "../src/VideoSupport.vala"
		buf = _tmp23_;
#line 268 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp20_);
#line 268 "../src/VideoSupport.vala"
		_g_object_unref0 (unix_input);
#line 3802 "VideoSupport.c"
	}
	goto __finally507;
	__catch507_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 268 "../src/VideoSupport.vala"
		e = _inner_error0_;
#line 268 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 272 "../src/VideoSupport.vala"
		_tmp24_ = e;
#line 272 "../src/VideoSupport.vala"
		_tmp25_ = _tmp24_->message;
#line 272 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:272: Error creating pixbuf: %s", _tmp25_);
#line 273 "../src/VideoSupport.vala"
		_g_object_unref0 (buf);
#line 273 "../src/VideoSupport.vala"
		buf = NULL;
#line 268 "../src/VideoSupport.vala"
		_g_error_free0 (e);
#line 3826 "VideoSupport.c"
	}
	__finally507:
#line 268 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/VideoSupport.vala"
		_g_object_unref0 (buf);
#line 268 "../src/VideoSupport.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 268 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 268 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 268 "../src/VideoSupport.vala"
		return NULL;
#line 3841 "VideoSupport.c"
	}
#line 277 "../src/VideoSupport.vala"
	child_status = 0;
#line 278 "../src/VideoSupport.vala"
	_tmp26_ = self->priv->thumbnailer_pid;
#line 278 "../src/VideoSupport.vala"
	_tmp28_ = waitpid ((pid_t) _tmp26_, &_tmp27_, 0);
#line 278 "../src/VideoSupport.vala"
	child_status = _tmp27_;
#line 278 "../src/VideoSupport.vala"
	ret_waitpid = (gint) _tmp28_;
#line 279 "../src/VideoSupport.vala"
	_tmp29_ = ret_waitpid;
#line 279 "../src/VideoSupport.vala"
	if (_tmp29_ < 0) {
#line 3857 "VideoSupport.c"
		gint _tmp30_;
#line 280 "../src/VideoSupport.vala"
		_tmp30_ = ret_waitpid;
#line 280 "../src/VideoSupport.vala"
		g_debug ("VideoSupport.vala:280: waitpid returned error code: %d", _tmp30_);
#line 281 "../src/VideoSupport.vala"
		_g_object_unref0 (buf);
#line 281 "../src/VideoSupport.vala"
		buf = NULL;
#line 3867 "VideoSupport.c"
	} else {
		gint _tmp31_;
#line 282 "../src/VideoSupport.vala"
		_tmp31_ = child_status;
#line 282 "../src/VideoSupport.vala"
		if (0 != WEXITSTATUS (_tmp31_)) {
#line 3874 "VideoSupport.c"
			gint _tmp32_;
#line 283 "../src/VideoSupport.vala"
			_tmp32_ = child_status;
#line 283 "../src/VideoSupport.vala"
			g_debug ("VideoSupport.vala:283: Thumbnailer exited with error code: %d", WEXITSTATUS (_tmp32_));
#line 285 "../src/VideoSupport.vala"
			_g_object_unref0 (buf);
#line 285 "../src/VideoSupport.vala"
			buf = NULL;
#line 3884 "VideoSupport.c"
		}
	}
#line 288 "../src/VideoSupport.vala"
	_tmp33_ = self->priv->thumbnailer_pid;
#line 288 "../src/VideoSupport.vala"
	g_spawn_close_pid (_tmp33_);
#line 289 "../src/VideoSupport.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 290 "../src/VideoSupport.vala"
	result = buf;
#line 290 "../src/VideoSupport.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 290 "../src/VideoSupport.vala"
	return result;
#line 3899 "VideoSupport.c"
}


static gboolean
video_reader_does_file_exist (VideoReader* self)
{
	gboolean result = FALSE;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 293 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 294 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->file;
#line 294 "../src/VideoSupport.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 294 "../src/VideoSupport.vala"
	_tmp2_ = _tmp1_;
#line 294 "../src/VideoSupport.vala"
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR);
#line 294 "../src/VideoSupport.vala"
	_g_free0 (_tmp2_);
#line 294 "../src/VideoSupport.vala"
	result = _tmp3_;
#line 294 "../src/VideoSupport.vala"
	return result;
#line 3927 "VideoSupport.c"
}


GdkPixbuf*
video_reader_read_preview_frame (VideoReader* self)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
#line 297 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 298 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->preview_frame;
#line 298 "../src/VideoSupport.vala"
	if (_tmp0_ != NULL) {
#line 3949 "VideoSupport.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 299 "../src/VideoSupport.vala"
		_tmp1_ = self->priv->preview_frame;
#line 299 "../src/VideoSupport.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 299 "../src/VideoSupport.vala"
		result = _tmp2_;
#line 299 "../src/VideoSupport.vala"
		return result;
#line 3960 "VideoSupport.c"
	}
#line 301 "../src/VideoSupport.vala"
	if (!video_reader_does_file_exist (self)) {
#line 302 "../src/VideoSupport.vala"
		result = NULL;
#line 302 "../src/VideoSupport.vala"
		return result;
#line 3968 "VideoSupport.c"
	}
#line 305 "../src/VideoSupport.vala"
	_tmp3_ = self->priv->file;
#line 305 "../src/VideoSupport.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 305 "../src/VideoSupport.vala"
	_tmp5_ = _tmp4_;
#line 305 "../src/VideoSupport.vala"
	_tmp6_ = video_reader_thumbnailer (self, _tmp5_);
#line 305 "../src/VideoSupport.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 305 "../src/VideoSupport.vala"
	self->priv->preview_frame = _tmp6_;
#line 305 "../src/VideoSupport.vala"
	_g_free0 (_tmp5_);
#line 306 "../src/VideoSupport.vala"
	_tmp7_ = self->priv->preview_frame;
#line 306 "../src/VideoSupport.vala"
	if (NULL == _tmp7_) {
#line 3988 "VideoSupport.c"
		GdkPixbuf* _tmp8_;
#line 307 "../src/VideoSupport.vala"
		_tmp8_ = resources_get_noninterpretable_badge_pixbuf ();
#line 307 "../src/VideoSupport.vala"
		_g_object_unref0 (self->priv->preview_frame);
#line 307 "../src/VideoSupport.vala"
		self->priv->preview_frame = _tmp8_;
#line 3996 "VideoSupport.c"
	}
#line 309 "../src/VideoSupport.vala"
	_tmp9_ = self->priv->preview_frame;
#line 309 "../src/VideoSupport.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 309 "../src/VideoSupport.vala"
	result = _tmp10_;
#line 309 "../src/VideoSupport.vala"
	return result;
#line 4006 "VideoSupport.c"
}


gdouble
video_reader_read_clip_duration (VideoReader* self,
                                 GError** error)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp3_;
	GError* _inner_error0_ = NULL;
#line 312 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), 0.0);
#line 313 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->clip_duration;
#line 313 "../src/VideoSupport.vala"
	if (_tmp0_ == VIDEO_READER_UNKNOWN_CLIP_DURATION) {
#line 314 "../src/VideoSupport.vala"
		video_reader_read_internal (self, &_inner_error0_);
#line 314 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 314 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 4030 "VideoSupport.c"
				gdouble _tmp1_ = -1.0;
#line 314 "../src/VideoSupport.vala"
				g_propagate_error (error, _inner_error0_);
#line 314 "../src/VideoSupport.vala"
				return _tmp1_;
#line 4036 "VideoSupport.c"
			} else {
				gdouble _tmp2_ = -1.0;
#line 314 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 314 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 314 "../src/VideoSupport.vala"
				return _tmp2_;
#line 4045 "VideoSupport.c"
			}
		}
	}
#line 316 "../src/VideoSupport.vala"
	_tmp3_ = self->priv->clip_duration;
#line 316 "../src/VideoSupport.vala"
	result = _tmp3_;
#line 316 "../src/VideoSupport.vala"
	return result;
#line 4055 "VideoSupport.c"
}


VideoMetadata*
video_reader_read_metadata (VideoReader* self,
                            GError** error)
{
	VideoMetadata* result = NULL;
	VideoMetadata* metadata = NULL;
	VideoMetadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 319 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 320 "../src/VideoSupport.vala"
	_tmp0_ = video_metadata_new ();
#line 320 "../src/VideoSupport.vala"
	metadata = _tmp0_;
#line 321 "../src/VideoSupport.vala"
	_tmp1_ = self->priv->file;
#line 321 "../src/VideoSupport.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 321 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 321 "../src/VideoSupport.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 321 "../src/VideoSupport.vala"
	_tmp5_ = _tmp4_;
#line 321 "../src/VideoSupport.vala"
	media_metadata_read_from_file (G_TYPE_CHECK_INSTANCE_CAST (metadata, TYPE_MEDIA_METADATA, MediaMetadata), _tmp5_, &_inner_error0_);
#line 321 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp5_);
#line 321 "../src/VideoSupport.vala"
	_g_free0 (_tmp3_);
#line 321 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 321 "../src/VideoSupport.vala"
		_media_metadata_unref0 (metadata);
#line 321 "../src/VideoSupport.vala"
		return NULL;
#line 4102 "VideoSupport.c"
	}
#line 323 "../src/VideoSupport.vala"
	result = metadata;
#line 323 "../src/VideoSupport.vala"
	return result;
#line 4108 "VideoSupport.c"
}


GDateTime*
video_reader_get_timestamp (VideoReader* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 49 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 49 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->_timestamp;
#line 49 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 49 "../src/VideoSupport.vala"
	return result;
#line 4125 "VideoSupport.c"
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 49 "../src/VideoSupport.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 4134 "VideoSupport.c"
}


static void
video_reader_set_timestamp (VideoReader* self,
                            GDateTime* value)
{
	GDateTime* _tmp0_;
#line 49 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 49 "../src/VideoSupport.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 49 "../src/VideoSupport.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 49 "../src/VideoSupport.vala"
	self->priv->_timestamp = _tmp0_;
#line 4151 "VideoSupport.c"
}


static void
value_video_reader_init (GValue* value)
{
#line 38 "../src/VideoSupport.vala"
	value->data[0].v_pointer = NULL;
#line 4160 "VideoSupport.c"
}


static void
value_video_reader_free_value (GValue* value)
{
#line 38 "../src/VideoSupport.vala"
	if (value->data[0].v_pointer) {
#line 38 "../src/VideoSupport.vala"
		video_reader_unref (value->data[0].v_pointer);
#line 4171 "VideoSupport.c"
	}
}


static void
value_video_reader_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 38 "../src/VideoSupport.vala"
	if (src_value->data[0].v_pointer) {
#line 38 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = video_reader_ref (src_value->data[0].v_pointer);
#line 4184 "VideoSupport.c"
	} else {
#line 38 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4188 "VideoSupport.c"
	}
}


static gpointer
value_video_reader_peek_pointer (const GValue* value)
{
#line 38 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 4198 "VideoSupport.c"
}


static gchar*
value_video_reader_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 38 "../src/VideoSupport.vala"
	if (collect_values[0].v_pointer) {
#line 4210 "VideoSupport.c"
		VideoReader * object;
		object = collect_values[0].v_pointer;
#line 38 "../src/VideoSupport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 38 "../src/VideoSupport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4217 "VideoSupport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 38 "../src/VideoSupport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4221 "VideoSupport.c"
		}
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = video_reader_ref (object);
#line 4225 "VideoSupport.c"
	} else {
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 4229 "VideoSupport.c"
	}
#line 38 "../src/VideoSupport.vala"
	return NULL;
#line 4233 "VideoSupport.c"
}


static gchar*
value_video_reader_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	VideoReader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 38 "../src/VideoSupport.vala"
	if (!object_p) {
#line 38 "../src/VideoSupport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4249 "VideoSupport.c"
	}
#line 38 "../src/VideoSupport.vala"
	if (!value->data[0].v_pointer) {
#line 38 "../src/VideoSupport.vala"
		*object_p = NULL;
#line 4255 "VideoSupport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 38 "../src/VideoSupport.vala"
		*object_p = value->data[0].v_pointer;
#line 4259 "VideoSupport.c"
	} else {
#line 38 "../src/VideoSupport.vala"
		*object_p = video_reader_ref (value->data[0].v_pointer);
#line 4263 "VideoSupport.c"
	}
#line 38 "../src/VideoSupport.vala"
	return NULL;
#line 4267 "VideoSupport.c"
}


GParamSpec*
param_spec_video_reader (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecVideoReader* spec;
#line 38 "../src/VideoSupport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_READER), NULL);
#line 38 "../src/VideoSupport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 38 "../src/VideoSupport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 38 "../src/VideoSupport.vala"
	return G_PARAM_SPEC (spec);
#line 4287 "VideoSupport.c"
}


gpointer
value_get_video_reader (const GValue* value)
{
#line 38 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER), NULL);
#line 38 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 4298 "VideoSupport.c"
}


void
value_set_video_reader (GValue* value,
                        gpointer v_object)
{
	VideoReader * old;
#line 38 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 38 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/VideoSupport.vala"
	if (v_object) {
#line 38 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 38 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 38 "../src/VideoSupport.vala"
		video_reader_ref (value->data[0].v_pointer);
#line 4321 "VideoSupport.c"
	} else {
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 4325 "VideoSupport.c"
	}
#line 38 "../src/VideoSupport.vala"
	if (old) {
#line 38 "../src/VideoSupport.vala"
		video_reader_unref (old);
#line 4331 "VideoSupport.c"
	}
}


void
value_take_video_reader (GValue* value,
                         gpointer v_object)
{
	VideoReader * old;
#line 38 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 38 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 38 "../src/VideoSupport.vala"
	if (v_object) {
#line 38 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 38 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 4353 "VideoSupport.c"
	} else {
#line 38 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 4357 "VideoSupport.c"
	}
#line 38 "../src/VideoSupport.vala"
	if (old) {
#line 38 "../src/VideoSupport.vala"
		video_reader_unref (old);
#line 4363 "VideoSupport.c"
	}
}


static void
video_reader_class_init (VideoReaderClass * klass)
{
#line 38 "../src/VideoSupport.vala"
	video_reader_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/VideoSupport.vala"
	((VideoReaderClass *) klass)->finalize = video_reader_finalize;
#line 38 "../src/VideoSupport.vala"
	g_type_class_adjust_private_offset (klass, &VideoReader_private_offset);
#line 4377 "VideoSupport.c"
}


static void
video_reader_instance_init (VideoReader * self)
{
#line 38 "../src/VideoSupport.vala"
	self->priv = video_reader_get_instance_private (self);
#line 45 "../src/VideoSupport.vala"
	self->priv->clip_duration = VIDEO_READER_UNKNOWN_CLIP_DURATION;
#line 46 "../src/VideoSupport.vala"
	self->priv->preview_frame = NULL;
#line 47 "../src/VideoSupport.vala"
	self->priv->file = NULL;
#line 48 "../src/VideoSupport.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 49 "../src/VideoSupport.vala"
	self->priv->_timestamp = NULL;
#line 38 "../src/VideoSupport.vala"
	self->ref_count = 1;
#line 4398 "VideoSupport.c"
}


static void
video_reader_finalize (VideoReader * obj)
{
	VideoReader * self;
#line 38 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_READER, VideoReader);
#line 38 "../src/VideoSupport.vala"
	g_signal_handlers_destroy (self);
#line 46 "../src/VideoSupport.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 47 "../src/VideoSupport.vala"
	_g_object_unref0 (self->priv->file);
#line 49 "../src/VideoSupport.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 4416 "VideoSupport.c"
}


GType
video_reader_get_type (void)
{
	static volatile gsize video_reader_type_id__volatile = 0;
	if (g_once_init_enter (&video_reader_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_reader_init, value_video_reader_free_value, value_video_reader_copy_value, value_video_reader_peek_pointer, "p", value_video_reader_collect_value, "p", value_video_reader_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoReader), 0, (GInstanceInitFunc) video_reader_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_reader_type_id;
		video_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
		VideoReader_private_offset = g_type_add_instance_private (video_reader_type_id, sizeof (VideoReaderPrivate));
		g_once_init_leave (&video_reader_type_id__volatile, video_reader_type_id);
	}
	return video_reader_type_id__volatile;
}


gpointer
video_reader_ref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 38 "../src/VideoSupport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 38 "../src/VideoSupport.vala"
	return instance;
#line 4446 "VideoSupport.c"
}


void
video_reader_unref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 38 "../src/VideoSupport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 38 "../src/VideoSupport.vala"
		VIDEO_READER_GET_CLASS (self)->finalize (self);
#line 38 "../src/VideoSupport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4461 "VideoSupport.c"
	}
}


static inline gpointer
video_get_instance_private (Video* self)
{
	return G_STRUCT_MEMBER_P (self, Video_private_offset);
}


static gpointer
_video_row_ref0 (gpointer self)
{
#line 371 "../src/VideoSupport.vala"
	return self ? video_row_ref (self) : NULL;
#line 4478 "VideoSupport.c"
}


Video*
video_construct (GType object_type,
                 VideoRow* row)
{
	Video * self = NULL;
	VideoRow* _tmp0_;
	VideoRow* _tmp1_;
	VideoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	guint64 _tmp6_;
#line 370 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_ROW (row), NULL);
#line 370 "../src/VideoSupport.vala"
	self = (Video*) video_source_construct (object_type);
#line 371 "../src/VideoSupport.vala"
	_tmp0_ = _video_row_ref0 (row);
#line 371 "../src/VideoSupport.vala"
	_video_row_unref0 (self->priv->backing_row);
#line 371 "../src/VideoSupport.vala"
	self->priv->backing_row = _tmp0_;
#line 374 "../src/VideoSupport.vala"
	_tmp1_ = self->priv->backing_row;
#line 374 "../src/VideoSupport.vala"
	_tmp2_ = self->priv->backing_row;
#line 374 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_->title;
#line 374 "../src/VideoSupport.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 374 "../src/VideoSupport.vala"
	_g_free0 (_tmp1_->title);
#line 374 "../src/VideoSupport.vala"
	_tmp1_->title = _tmp4_;
#line 376 "../src/VideoSupport.vala"
	_tmp6_ = row->flags;
#line 376 "../src/VideoSupport.vala"
	if ((_tmp6_ & VIDEO_FLAG_TRASH) != ((guint64) 0)) {
#line 376 "../src/VideoSupport.vala"
		_tmp5_ = TRUE;
#line 4522 "VideoSupport.c"
	} else {
		guint64 _tmp7_;
#line 376 "../src/VideoSupport.vala"
		_tmp7_ = row->flags;
#line 376 "../src/VideoSupport.vala"
		_tmp5_ = (_tmp7_ & VIDEO_FLAG_OFFLINE) != ((guint64) 0);
#line 4529 "VideoSupport.c"
	}
#line 376 "../src/VideoSupport.vala"
	if (_tmp5_) {
#line 4533 "VideoSupport.c"
		VideoSourceCollection* _tmp8_;
		const gchar* _tmp9_;
#line 377 "../src/VideoSupport.vala"
		_tmp8_ = video_global;
#line 377 "../src/VideoSupport.vala"
		_tmp9_ = row->backlinks;
#line 377 "../src/VideoSupport.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp9_);
#line 4542 "VideoSupport.c"
	}
#line 370 "../src/VideoSupport.vala"
	return self;
#line 4546 "VideoSupport.c"
}


Video*
video_new (VideoRow* row)
{
#line 370 "../src/VideoSupport.vala"
	return video_construct (TYPE_VIDEO, row);
#line 4555 "VideoSupport.c"
}


static gboolean
__lambda12_ (GstPluginFeature* f)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
#line 411 "../src/VideoSupport.vala"
	g_return_val_if_fail (GST_IS_PLUGIN_FEATURE (f), FALSE);
#line 412 "../src/VideoSupport.vala"
	_tmp0_ = gst_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (f, gst_object_get_type (), GstObject));
#line 412 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 412 "../src/VideoSupport.vala"
	_tmp2_ = g_str_has_prefix (_tmp1_, "vaapi");
#line 412 "../src/VideoSupport.vala"
	_g_free0 (_tmp1_);
#line 412 "../src/VideoSupport.vala"
	result = _tmp2_;
#line 412 "../src/VideoSupport.vala"
	return result;
#line 4580 "VideoSupport.c"
}


static gboolean
___lambda12__gst_plugin_feature_filter (GstPluginFeature* feature,
                                        gpointer self)
{
	gboolean result;
	result = __lambda12_ (feature);
#line 411 "../src/VideoSupport.vala"
	return result;
#line 4592 "VideoSupport.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 380 "../src/VideoSupport.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4601 "VideoSupport.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 380 "../src/VideoSupport.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4610 "VideoSupport.c"
}


void
video_init (ProgressMonitor monitor,
            gpointer monitor_target)
{
	gchar** args = NULL;
	gint args_length1;
	gint _args_size_;
	GstRegistry* registry = NULL;
	GstRegistry* _tmp0_;
	GstRegistry* _tmp1_;
	gint saved_state = 0;
	ConfigFacade* _tmp2_;
	ConfigFacade* _tmp3_;
	gint _tmp4_;
	GstRegistry* _tmp5_;
	gint _tmp6_;
	GList* features = NULL;
	GstRegistry* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	VideoSourceCollection* _tmp18_;
	GeeArrayList* all = NULL;
	VideoTable* _tmp19_;
	VideoTable* _tmp20_;
	GeeArrayList* _tmp21_;
	GeeArrayList* _tmp22_;
	GeeArrayList* all_videos = NULL;
	GeeArrayList* _tmp23_;
	GeeArrayList* trashed_videos = NULL;
	GeeArrayList* _tmp24_;
	GeeArrayList* offline_videos = NULL;
	GeeArrayList* _tmp25_;
	gint count = 0;
	GeeArrayList* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	VideoSourceCollection* _tmp51_;
	GeeArrayList* _tmp52_;
	VideoSourceCollection* _tmp53_;
	GeeArrayList* _tmp54_;
	VideoSourceCollection* _tmp55_;
	GeeArrayList* _tmp56_;
	GeeCollection* _tmp57_;
	GeeCollection* _tmp58_;
#line 384 "../src/VideoSupport.vala"
	video_interpreter_state_changed = FALSE;
#line 385 "../src/VideoSupport.vala"
	video_current_state = -1;
#line 386 "../src/VideoSupport.vala"
	video_normal_regen_complete = FALSE;
#line 387 "../src/VideoSupport.vala"
	video_offline_regen_complete = FALSE;
#line 391 "../src/VideoSupport.vala"
	args = NULL;
#line 391 "../src/VideoSupport.vala"
	args_length1 = 0;
#line 391 "../src/VideoSupport.vala"
	_args_size_ = args_length1;
#line 392 "../src/VideoSupport.vala"
	gst_init (&args_length1, &args);
#line 394 "../src/VideoSupport.vala"
	_tmp0_ = gst_registry_get ();
#line 394 "../src/VideoSupport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 394 "../src/VideoSupport.vala"
	registry = _tmp1_;
#line 395 "../src/VideoSupport.vala"
	_tmp2_ = config_facade_get_instance ();
#line 395 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 395 "../src/VideoSupport.vala"
	_tmp4_ = configuration_facade_get_video_interpreter_state_cookie (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 395 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp3_);
#line 395 "../src/VideoSupport.vala"
	saved_state = _tmp4_;
#line 396 "../src/VideoSupport.vala"
	_tmp5_ = registry;
#line 396 "../src/VideoSupport.vala"
	video_current_state = (gint) gst_registry_get_feature_list_cookie (_tmp5_);
#line 397 "../src/VideoSupport.vala"
	_tmp6_ = saved_state;
#line 397 "../src/VideoSupport.vala"
	if (_tmp6_ == CONFIG_FACADE_NO_VIDEO_INTERPRETER_STATE) {
#line 398 "../src/VideoSupport.vala"
		g_message ("VideoSupport.vala:398: interpreter state cookie not found; assuming al" \
"l video thumbnails are out of date");
#line 399 "../src/VideoSupport.vala"
		video_interpreter_state_changed = TRUE;
#line 4702 "VideoSupport.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 400 "../src/VideoSupport.vala"
		_tmp7_ = saved_state;
#line 400 "../src/VideoSupport.vala"
		_tmp8_ = video_current_state;
#line 400 "../src/VideoSupport.vala"
		if (_tmp7_ != _tmp8_) {
#line 401 "../src/VideoSupport.vala"
			g_message ("VideoSupport.vala:401: interpreter state has changed; video thumbnails" \
" may be out of date");
#line 402 "../src/VideoSupport.vala"
			video_interpreter_state_changed = TRUE;
#line 4716 "VideoSupport.c"
		}
	}
#line 411 "../src/VideoSupport.vala"
	_tmp9_ = registry;
#line 411 "../src/VideoSupport.vala"
	_tmp10_ = gst_registry_feature_filter (_tmp9_, ___lambda12__gst_plugin_feature_filter, FALSE, NULL);
#line 411 "../src/VideoSupport.vala"
	features = _tmp10_;
#line 415 "../src/VideoSupport.vala"
	_tmp11_ = features;
#line 4727 "VideoSupport.c"
	{
		GList* feature_collection = NULL;
		GList* feature_it = NULL;
#line 415 "../src/VideoSupport.vala"
		feature_collection = _tmp11_;
#line 415 "../src/VideoSupport.vala"
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 4735 "VideoSupport.c"
			GstPluginFeature* _tmp12_;
			GstPluginFeature* feature = NULL;
#line 415 "../src/VideoSupport.vala"
			_tmp12_ = _g_object_ref0 ((GstPluginFeature*) feature_it->data);
#line 415 "../src/VideoSupport.vala"
			feature = _tmp12_;
#line 4742 "VideoSupport.c"
			{
				GstPluginFeature* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				GstRegistry* _tmp16_;
				GstPluginFeature* _tmp17_;
#line 416 "../src/VideoSupport.vala"
				_tmp13_ = feature;
#line 416 "../src/VideoSupport.vala"
				_tmp14_ = gst_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gst_object_get_type (), GstObject));
#line 416 "../src/VideoSupport.vala"
				_tmp15_ = _tmp14_;
#line 416 "../src/VideoSupport.vala"
				g_debug ("VideoSupport.vala:416: Removing registry feature %s", _tmp15_);
#line 416 "../src/VideoSupport.vala"
				_g_free0 (_tmp15_);
#line 417 "../src/VideoSupport.vala"
				_tmp16_ = registry;
#line 417 "../src/VideoSupport.vala"
				_tmp17_ = feature;
#line 417 "../src/VideoSupport.vala"
				gst_registry_remove_feature (_tmp16_, _tmp17_);
#line 415 "../src/VideoSupport.vala"
				_g_object_unref0 (feature);
#line 4767 "VideoSupport.c"
			}
		}
	}
#line 420 "../src/VideoSupport.vala"
	_tmp18_ = video_source_collection_new ();
#line 420 "../src/VideoSupport.vala"
	_data_collection_unref0 (video_global);
#line 420 "../src/VideoSupport.vala"
	video_global = _tmp18_;
#line 422 "../src/VideoSupport.vala"
	_tmp19_ = video_table_get_instance ();
#line 422 "../src/VideoSupport.vala"
	_tmp20_ = _tmp19_;
#line 422 "../src/VideoSupport.vala"
	_tmp21_ = video_table_get_all (_tmp20_);
#line 422 "../src/VideoSupport.vala"
	_tmp22_ = _tmp21_;
#line 422 "../src/VideoSupport.vala"
	_database_table_unref0 (_tmp20_);
#line 422 "../src/VideoSupport.vala"
	all = _tmp22_;
#line 423 "../src/VideoSupport.vala"
	_tmp23_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 423 "../src/VideoSupport.vala"
	all_videos = _tmp23_;
#line 424 "../src/VideoSupport.vala"
	_tmp24_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 424 "../src/VideoSupport.vala"
	trashed_videos = _tmp24_;
#line 425 "../src/VideoSupport.vala"
	_tmp25_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 425 "../src/VideoSupport.vala"
	offline_videos = _tmp25_;
#line 426 "../src/VideoSupport.vala"
	_tmp26_ = all;
#line 426 "../src/VideoSupport.vala"
	_tmp27_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 426 "../src/VideoSupport.vala"
	_tmp28_ = _tmp27_;
#line 426 "../src/VideoSupport.vala"
	count = _tmp28_;
#line 4809 "VideoSupport.c"
	{
		gint ctr = 0;
#line 427 "../src/VideoSupport.vala"
		ctr = 0;
#line 4814 "VideoSupport.c"
		{
			gboolean _tmp29_ = FALSE;
#line 427 "../src/VideoSupport.vala"
			_tmp29_ = TRUE;
#line 427 "../src/VideoSupport.vala"
			while (TRUE) {
#line 4821 "VideoSupport.c"
				gint _tmp31_;
				gint _tmp32_;
				Video* video = NULL;
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gpointer _tmp35_;
				VideoRow* _tmp36_;
				Video* _tmp37_;
				Video* _tmp38_;
				gboolean _tmp39_;
				Video* _tmp41_;
#line 427 "../src/VideoSupport.vala"
				if (!_tmp29_) {
#line 4835 "VideoSupport.c"
					gint _tmp30_;
#line 427 "../src/VideoSupport.vala"
					_tmp30_ = ctr;
#line 427 "../src/VideoSupport.vala"
					ctr = _tmp30_ + 1;
#line 4841 "VideoSupport.c"
				}
#line 427 "../src/VideoSupport.vala"
				_tmp29_ = FALSE;
#line 427 "../src/VideoSupport.vala"
				_tmp31_ = ctr;
#line 427 "../src/VideoSupport.vala"
				_tmp32_ = count;
#line 427 "../src/VideoSupport.vala"
				if (!(_tmp31_ < _tmp32_)) {
#line 427 "../src/VideoSupport.vala"
					break;
#line 4853 "VideoSupport.c"
				}
#line 428 "../src/VideoSupport.vala"
				_tmp33_ = all;
#line 428 "../src/VideoSupport.vala"
				_tmp34_ = ctr;
#line 428 "../src/VideoSupport.vala"
				_tmp35_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp34_);
#line 428 "../src/VideoSupport.vala"
				_tmp36_ = (VideoRow*) _tmp35_;
#line 428 "../src/VideoSupport.vala"
				_tmp37_ = video_new (_tmp36_);
#line 428 "../src/VideoSupport.vala"
				_tmp38_ = _tmp37_;
#line 428 "../src/VideoSupport.vala"
				_video_row_unref0 (_tmp36_);
#line 428 "../src/VideoSupport.vala"
				video = _tmp38_;
#line 430 "../src/VideoSupport.vala"
				_tmp39_ = video_interpreter_state_changed;
#line 430 "../src/VideoSupport.vala"
				if (_tmp39_) {
#line 4875 "VideoSupport.c"
					Video* _tmp40_;
#line 431 "../src/VideoSupport.vala"
					_tmp40_ = video;
#line 431 "../src/VideoSupport.vala"
					video_set_is_interpretable (_tmp40_, FALSE);
#line 4881 "VideoSupport.c"
				}
#line 433 "../src/VideoSupport.vala"
				_tmp41_ = video;
#line 433 "../src/VideoSupport.vala"
				if (media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_MEDIA_SOURCE, MediaSource))) {
#line 4887 "VideoSupport.c"
					GeeArrayList* _tmp42_;
					Video* _tmp43_;
#line 434 "../src/VideoSupport.vala"
					_tmp42_ = trashed_videos;
#line 434 "../src/VideoSupport.vala"
					_tmp43_ = video;
#line 434 "../src/VideoSupport.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp43_);
#line 4896 "VideoSupport.c"
				} else {
					Video* _tmp44_;
#line 435 "../src/VideoSupport.vala"
					_tmp44_ = video;
#line 435 "../src/VideoSupport.vala"
					if (media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, TYPE_MEDIA_SOURCE, MediaSource))) {
#line 4903 "VideoSupport.c"
						GeeArrayList* _tmp45_;
						Video* _tmp46_;
#line 436 "../src/VideoSupport.vala"
						_tmp45_ = offline_videos;
#line 436 "../src/VideoSupport.vala"
						_tmp46_ = video;
#line 436 "../src/VideoSupport.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp46_);
#line 4912 "VideoSupport.c"
					} else {
						GeeArrayList* _tmp47_;
						Video* _tmp48_;
#line 438 "../src/VideoSupport.vala"
						_tmp47_ = all_videos;
#line 438 "../src/VideoSupport.vala"
						_tmp48_ = video;
#line 438 "../src/VideoSupport.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp48_);
#line 4922 "VideoSupport.c"
					}
				}
#line 440 "../src/VideoSupport.vala"
				if (monitor != NULL) {
#line 4927 "VideoSupport.c"
					gint _tmp49_;
					gint _tmp50_;
#line 441 "../src/VideoSupport.vala"
					_tmp49_ = ctr;
#line 441 "../src/VideoSupport.vala"
					_tmp50_ = count;
#line 441 "../src/VideoSupport.vala"
					monitor ((guint64) _tmp49_, (guint64) _tmp50_, TRUE, monitor_target);
#line 4936 "VideoSupport.c"
				}
#line 427 "../src/VideoSupport.vala"
				_g_object_unref0 (video);
#line 4940 "VideoSupport.c"
			}
		}
	}
#line 444 "../src/VideoSupport.vala"
	_tmp51_ = video_global;
#line 444 "../src/VideoSupport.vala"
	_tmp52_ = trashed_videos;
#line 444 "../src/VideoSupport.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_COLLECTION, GeeCollection));
#line 445 "../src/VideoSupport.vala"
	_tmp53_ = video_global;
#line 445 "../src/VideoSupport.vala"
	_tmp54_ = offline_videos;
#line 445 "../src/VideoSupport.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_COLLECTION, GeeCollection));
#line 446 "../src/VideoSupport.vala"
	_tmp55_ = video_global;
#line 446 "../src/VideoSupport.vala"
	_tmp56_ = all_videos;
#line 446 "../src/VideoSupport.vala"
	_tmp57_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 446 "../src/VideoSupport.vala"
	_tmp58_ = _tmp57_;
#line 446 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp58_);
#line 380 "../src/VideoSupport.vala"
	_g_object_unref0 (offline_videos);
#line 380 "../src/VideoSupport.vala"
	_g_object_unref0 (trashed_videos);
#line 380 "../src/VideoSupport.vala"
	_g_object_unref0 (all_videos);
#line 380 "../src/VideoSupport.vala"
	_g_object_unref0 (all);
#line 380 "../src/VideoSupport.vala"
	(features == NULL) ? NULL : (features = (_g_list_free__g_object_unref0_ (features), NULL));
#line 380 "../src/VideoSupport.vala"
	_g_object_unref0 (registry);
#line 4978 "VideoSupport.c"
}


gboolean
video_has_interpreter_state_changed (void)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 450 "../src/VideoSupport.vala"
	_tmp0_ = video_interpreter_state_changed;
#line 450 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 450 "../src/VideoSupport.vala"
	return result;
#line 4993 "VideoSupport.c"
}


void
video_notify_normal_thumbs_regenerated (void)
{
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 454 "../src/VideoSupport.vala"
	_tmp0_ = video_normal_regen_complete;
#line 454 "../src/VideoSupport.vala"
	if (_tmp0_) {
#line 455 "../src/VideoSupport.vala"
		return;
#line 5009 "VideoSupport.c"
	}
#line 457 "../src/VideoSupport.vala"
	g_message ("VideoSupport.vala:457: normal video thumbnail regeneration completed");
#line 459 "../src/VideoSupport.vala"
	video_normal_regen_complete = TRUE;
#line 460 "../src/VideoSupport.vala"
	_tmp2_ = video_normal_regen_complete;
#line 460 "../src/VideoSupport.vala"
	if (_tmp2_) {
#line 5019 "VideoSupport.c"
		gboolean _tmp3_;
#line 460 "../src/VideoSupport.vala"
		_tmp3_ = video_offline_regen_complete;
#line 460 "../src/VideoSupport.vala"
		_tmp1_ = _tmp3_;
#line 5025 "VideoSupport.c"
	} else {
#line 460 "../src/VideoSupport.vala"
		_tmp1_ = FALSE;
#line 5029 "VideoSupport.c"
	}
#line 460 "../src/VideoSupport.vala"
	if (_tmp1_) {
#line 461 "../src/VideoSupport.vala"
		video_save_interpreter_state ();
#line 5035 "VideoSupport.c"
	}
}


void
video_notify_offline_thumbs_regenerated (void)
{
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 465 "../src/VideoSupport.vala"
	_tmp0_ = video_offline_regen_complete;
#line 465 "../src/VideoSupport.vala"
	if (_tmp0_) {
#line 466 "../src/VideoSupport.vala"
		return;
#line 5052 "VideoSupport.c"
	}
#line 468 "../src/VideoSupport.vala"
	g_message ("VideoSupport.vala:468: offline video thumbnail regeneration completed");
#line 470 "../src/VideoSupport.vala"
	video_offline_regen_complete = TRUE;
#line 471 "../src/VideoSupport.vala"
	_tmp2_ = video_normal_regen_complete;
#line 471 "../src/VideoSupport.vala"
	if (_tmp2_) {
#line 5062 "VideoSupport.c"
		gboolean _tmp3_;
#line 471 "../src/VideoSupport.vala"
		_tmp3_ = video_offline_regen_complete;
#line 471 "../src/VideoSupport.vala"
		_tmp1_ = _tmp3_;
#line 5068 "VideoSupport.c"
	} else {
#line 471 "../src/VideoSupport.vala"
		_tmp1_ = FALSE;
#line 5072 "VideoSupport.c"
	}
#line 471 "../src/VideoSupport.vala"
	if (_tmp1_) {
#line 472 "../src/VideoSupport.vala"
		video_save_interpreter_state ();
#line 5078 "VideoSupport.c"
	}
}


static void
video_save_interpreter_state (void)
{
	gboolean _tmp0_;
#line 476 "../src/VideoSupport.vala"
	_tmp0_ = video_interpreter_state_changed;
#line 476 "../src/VideoSupport.vala"
	if (_tmp0_) {
#line 5091 "VideoSupport.c"
		ConfigFacade* _tmp1_;
		ConfigFacade* _tmp2_;
		gint _tmp3_;
#line 477 "../src/VideoSupport.vala"
		g_message ("VideoSupport.vala:477: saving video interpreter state to configuration" \
" system");
#line 479 "../src/VideoSupport.vala"
		_tmp1_ = config_facade_get_instance ();
#line 479 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 479 "../src/VideoSupport.vala"
		_tmp3_ = video_current_state;
#line 479 "../src/VideoSupport.vala"
		configuration_facade_set_video_interpreter_state_cookie (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), _tmp3_);
#line 479 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp2_);
#line 480 "../src/VideoSupport.vala"
		video_interpreter_state_changed = FALSE;
#line 5109 "VideoSupport.c"
	}
}


void
video_terminate (void)
{
}


ExporterUI*
video_export_many (GeeCollection* videos,
                   ExporterCompletionCallback done,
                   gpointer done_target,
                   gboolean export_in_place)
{
	ExporterUI* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp9_;
	gint _tmp10_;
	GFile* export_dir = NULL;
	GFile* _tmp32_;
	GFile* _tmp33_;
	ExporterUI* exporter = NULL;
	GFile* _tmp34_;
	Scaling _tmp35_ = {0};
	ExportFormatParameters _tmp36_ = {0};
	Exporter* _tmp37_;
	Exporter* _tmp38_;
	ExporterUI* _tmp39_;
	ExporterUI* _tmp40_;
	ExporterUI* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 487 "../src/VideoSupport.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (videos), NULL);
#line 489 "../src/VideoSupport.vala"
	_tmp0_ = gee_collection_get_size (videos);
#line 489 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 489 "../src/VideoSupport.vala"
	if (_tmp1_ == 0) {
#line 490 "../src/VideoSupport.vala"
		result = NULL;
#line 490 "../src/VideoSupport.vala"
		return result;
#line 5156 "VideoSupport.c"
	}
#line 493 "../src/VideoSupport.vala"
	if (export_in_place) {
#line 5160 "VideoSupport.c"
		ExporterUI* temp_exporter = NULL;
		Scaling _tmp2_ = {0};
		ExportFormatParameters _tmp3_ = {0};
		Exporter* _tmp4_;
		Exporter* _tmp5_;
		ExporterUI* _tmp6_;
		ExporterUI* _tmp7_;
		ExporterUI* _tmp8_;
#line 494 "../src/VideoSupport.vala"
		scaling_for_original (&_tmp2_);
#line 494 "../src/VideoSupport.vala"
		export_format_parameters_unmodified (&_tmp3_);
#line 494 "../src/VideoSupport.vala"
		_tmp4_ = exporter_new_for_temp_file (videos, &_tmp2_, &_tmp3_);
#line 494 "../src/VideoSupport.vala"
		_tmp5_ = _tmp4_;
#line 494 "../src/VideoSupport.vala"
		_tmp6_ = exporter_ui_new (_tmp5_);
#line 494 "../src/VideoSupport.vala"
		_tmp7_ = _tmp6_;
#line 494 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp5_);
#line 494 "../src/VideoSupport.vala"
		temp_exporter = _tmp7_;
#line 496 "../src/VideoSupport.vala"
		_tmp8_ = temp_exporter;
#line 496 "../src/VideoSupport.vala"
		exporter_ui_export (_tmp8_, done, done_target);
#line 497 "../src/VideoSupport.vala"
		result = temp_exporter;
#line 497 "../src/VideoSupport.vala"
		return result;
#line 5193 "VideoSupport.c"
	}
#line 501 "../src/VideoSupport.vala"
	_tmp9_ = gee_collection_get_size (videos);
#line 501 "../src/VideoSupport.vala"
	_tmp10_ = _tmp9_;
#line 501 "../src/VideoSupport.vala"
	if (_tmp10_ == 1) {
#line 5201 "VideoSupport.c"
		Video* video = NULL;
		GFile* save_as = NULL;
		Video* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
#line 502 "../src/VideoSupport.vala"
		video = NULL;
#line 5212 "VideoSupport.c"
		{
			GeeIterator* _v_it = NULL;
			GeeIterator* _tmp11_;
#line 503 "../src/VideoSupport.vala"
			_tmp11_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (videos, GEE_TYPE_ITERABLE, GeeIterable));
#line 503 "../src/VideoSupport.vala"
			_v_it = _tmp11_;
#line 503 "../src/VideoSupport.vala"
			while (TRUE) {
#line 5222 "VideoSupport.c"
				GeeIterator* _tmp12_;
				Video* v = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				Video* _tmp15_;
				Video* _tmp16_;
#line 503 "../src/VideoSupport.vala"
				_tmp12_ = _v_it;
#line 503 "../src/VideoSupport.vala"
				if (!gee_iterator_next (_tmp12_)) {
#line 503 "../src/VideoSupport.vala"
					break;
#line 5235 "VideoSupport.c"
				}
#line 503 "../src/VideoSupport.vala"
				_tmp13_ = _v_it;
#line 503 "../src/VideoSupport.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 503 "../src/VideoSupport.vala"
				v = (Video*) _tmp14_;
#line 504 "../src/VideoSupport.vala"
				_tmp15_ = v;
#line 504 "../src/VideoSupport.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 504 "../src/VideoSupport.vala"
				_g_object_unref0 (video);
#line 504 "../src/VideoSupport.vala"
				video = _tmp16_;
#line 505 "../src/VideoSupport.vala"
				_g_object_unref0 (v);
#line 505 "../src/VideoSupport.vala"
				break;
#line 5255 "VideoSupport.c"
			}
#line 503 "../src/VideoSupport.vala"
			_g_object_unref0 (_v_it);
#line 5259 "VideoSupport.c"
		}
#line 508 "../src/VideoSupport.vala"
		_tmp17_ = video;
#line 508 "../src/VideoSupport.vala"
		_tmp18_ = media_source_get_basename (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
#line 508 "../src/VideoSupport.vala"
		_tmp19_ = _tmp18_;
#line 508 "../src/VideoSupport.vala"
		_tmp20_ = export_ui_choose_file (_tmp19_);
#line 508 "../src/VideoSupport.vala"
		_tmp21_ = _tmp20_;
#line 508 "../src/VideoSupport.vala"
		_g_free0 (_tmp19_);
#line 508 "../src/VideoSupport.vala"
		save_as = _tmp21_;
#line 509 "../src/VideoSupport.vala"
		_tmp22_ = save_as;
#line 509 "../src/VideoSupport.vala"
		if (_tmp22_ == NULL) {
#line 510 "../src/VideoSupport.vala"
			result = NULL;
#line 510 "../src/VideoSupport.vala"
			_g_object_unref0 (save_as);
#line 510 "../src/VideoSupport.vala"
			_g_object_unref0 (video);
#line 510 "../src/VideoSupport.vala"
			return result;
#line 5287 "VideoSupport.c"
		}
		{
			AppWindow* _tmp23_;
			AppWindow* _tmp24_;
			Video* _tmp25_;
			GFile* _tmp26_;
			AppWindow* _tmp27_;
			AppWindow* _tmp28_;
#line 513 "../src/VideoSupport.vala"
			_tmp23_ = app_window_get_instance ();
#line 513 "../src/VideoSupport.vala"
			_tmp24_ = _tmp23_;
#line 513 "../src/VideoSupport.vala"
			page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PAGE_WINDOW, PageWindow));
#line 513 "../src/VideoSupport.vala"
			_g_object_unref0 (_tmp24_);
#line 514 "../src/VideoSupport.vala"
			_tmp25_ = video;
#line 514 "../src/VideoSupport.vala"
			_tmp26_ = save_as;
#line 514 "../src/VideoSupport.vala"
			video_export (_tmp25_, _tmp26_, &_inner_error0_);
#line 514 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5312 "VideoSupport.c"
				goto __catch508_g_error;
			}
#line 515 "../src/VideoSupport.vala"
			_tmp27_ = app_window_get_instance ();
#line 515 "../src/VideoSupport.vala"
			_tmp28_ = _tmp27_;
#line 515 "../src/VideoSupport.vala"
			page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_PAGE_WINDOW, PageWindow));
#line 515 "../src/VideoSupport.vala"
			_g_object_unref0 (_tmp28_);
#line 5323 "VideoSupport.c"
		}
		goto __finally508;
		__catch508_g_error:
		{
			GError* err = NULL;
			AppWindow* _tmp29_;
			AppWindow* _tmp30_;
			GFile* _tmp31_;
#line 512 "../src/VideoSupport.vala"
			err = _inner_error0_;
#line 512 "../src/VideoSupport.vala"
			_inner_error0_ = NULL;
#line 517 "../src/VideoSupport.vala"
			_tmp29_ = app_window_get_instance ();
#line 517 "../src/VideoSupport.vala"
			_tmp30_ = _tmp29_;
#line 517 "../src/VideoSupport.vala"
			page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PAGE_WINDOW, PageWindow));
#line 517 "../src/VideoSupport.vala"
			_g_object_unref0 (_tmp30_);
#line 518 "../src/VideoSupport.vala"
			_tmp31_ = save_as;
#line 518 "../src/VideoSupport.vala"
			export_error_dialog (_tmp31_, FALSE);
#line 512 "../src/VideoSupport.vala"
			_g_error_free0 (err);
#line 5350 "VideoSupport.c"
		}
		__finally508:
#line 512 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 512 "../src/VideoSupport.vala"
			_g_object_unref0 (save_as);
#line 512 "../src/VideoSupport.vala"
			_g_object_unref0 (video);
#line 512 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 512 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 512 "../src/VideoSupport.vala"
			return NULL;
#line 5365 "VideoSupport.c"
		}
#line 521 "../src/VideoSupport.vala"
		result = NULL;
#line 521 "../src/VideoSupport.vala"
		_g_object_unref0 (save_as);
#line 521 "../src/VideoSupport.vala"
		_g_object_unref0 (video);
#line 521 "../src/VideoSupport.vala"
		return result;
#line 5375 "VideoSupport.c"
	}
#line 525 "../src/VideoSupport.vala"
	_tmp32_ = export_ui_choose_dir (_ ("Export Videos"));
#line 525 "../src/VideoSupport.vala"
	export_dir = _tmp32_;
#line 526 "../src/VideoSupport.vala"
	_tmp33_ = export_dir;
#line 526 "../src/VideoSupport.vala"
	if (_tmp33_ == NULL) {
#line 527 "../src/VideoSupport.vala"
		result = NULL;
#line 527 "../src/VideoSupport.vala"
		_g_object_unref0 (export_dir);
#line 527 "../src/VideoSupport.vala"
		return result;
#line 5391 "VideoSupport.c"
	}
#line 529 "../src/VideoSupport.vala"
	_tmp34_ = export_dir;
#line 529 "../src/VideoSupport.vala"
	scaling_for_original (&_tmp35_);
#line 529 "../src/VideoSupport.vala"
	export_format_parameters_unmodified (&_tmp36_);
#line 529 "../src/VideoSupport.vala"
	_tmp37_ = exporter_new (videos, _tmp34_, &_tmp35_, &_tmp36_, FALSE);
#line 529 "../src/VideoSupport.vala"
	_tmp38_ = _tmp37_;
#line 529 "../src/VideoSupport.vala"
	_tmp39_ = exporter_ui_new (_tmp38_);
#line 529 "../src/VideoSupport.vala"
	_tmp40_ = _tmp39_;
#line 529 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp38_);
#line 529 "../src/VideoSupport.vala"
	exporter = _tmp40_;
#line 531 "../src/VideoSupport.vala"
	_tmp41_ = exporter;
#line 531 "../src/VideoSupport.vala"
	exporter_ui_export (_tmp41_, done, done_target);
#line 533 "../src/VideoSupport.vala"
	result = exporter;
#line 533 "../src/VideoSupport.vala"
	_g_object_unref0 (export_dir);
#line 533 "../src/VideoSupport.vala"
	return result;
#line 5421 "VideoSupport.c"
}


static void
video_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Video * self;
	GError* _inner_error0_ = NULL;
#line 536 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 536 "../src/VideoSupport.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 5436 "VideoSupport.c"
	{
		VideoTable* _tmp0_;
		VideoTable* _tmp1_;
		VideoID _tmp2_ = {0};
#line 538 "../src/VideoSupport.vala"
		_tmp0_ = video_table_get_instance ();
#line 538 "../src/VideoSupport.vala"
		_tmp1_ = _tmp0_;
#line 538 "../src/VideoSupport.vala"
		video_get_video_id (self, &_tmp2_);
#line 538 "../src/VideoSupport.vala"
		video_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 538 "../src/VideoSupport.vala"
		_database_table_unref0 (_tmp1_);
#line 538 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 538 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5455 "VideoSupport.c"
				goto __catch509_database_error;
			}
#line 538 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 538 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 538 "../src/VideoSupport.vala"
			return;
#line 5464 "VideoSupport.c"
		}
		{
			VideoRow* _tmp3_;
#line 539 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 539 "../src/VideoSupport.vala"
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 5472 "VideoSupport.c"
			{
				VideoRow* _tmp4_;
				gchar* _tmp5_;
#line 540 "../src/VideoSupport.vala"
				_tmp4_ = self->priv->backing_row;
#line 540 "../src/VideoSupport.vala"
				_tmp5_ = g_strdup (backlinks);
#line 540 "../src/VideoSupport.vala"
				_g_free0 (_tmp4_->backlinks);
#line 540 "../src/VideoSupport.vala"
				_tmp4_->backlinks = _tmp5_;
#line 5484 "VideoSupport.c"
			}
			__finally510:
			{
				VideoRow* _tmp6_;
#line 539 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->backing_row;
#line 539 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 5493 "VideoSupport.c"
			}
#line 539 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 539 "../src/VideoSupport.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5499 "VideoSupport.c"
					goto __catch509_database_error;
				}
#line 539 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 539 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 539 "../src/VideoSupport.vala"
				return;
#line 5508 "VideoSupport.c"
			}
		}
	}
	goto __finally509;
	__catch509_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 537 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 537 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 543 "../src/VideoSupport.vala"
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 543 "../src/VideoSupport.vala"
		_tmp8_ = _tmp7_;
#line 543 "../src/VideoSupport.vala"
		_tmp9_ = err;
#line 543 "../src/VideoSupport.vala"
		_tmp10_ = _tmp9_->message;
#line 543 "../src/VideoSupport.vala"
		g_warning ("VideoSupport.vala:543: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 543 "../src/VideoSupport.vala"
		_g_free0 (_tmp8_);
#line 537 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 5538 "VideoSupport.c"
	}
	__finally509:
#line 537 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 537 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 537 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 537 "../src/VideoSupport.vala"
		return;
#line 5549 "VideoSupport.c"
	}
}


static gboolean
video_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Video * self;
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 547 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 547 "../src/VideoSupport.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 5565 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 548 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 548 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 5573 "VideoSupport.c"
		{
			gboolean committed = FALSE;
			VideoTable* _tmp1_;
			VideoTable* _tmp2_;
			VideoRow* _tmp3_;
			VideoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 549 "../src/VideoSupport.vala"
			_tmp1_ = video_table_get_instance ();
#line 549 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_;
#line 549 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 549 "../src/VideoSupport.vala"
			_tmp4_ = _tmp3_->video_id;
#line 549 "../src/VideoSupport.vala"
			_tmp5_ = *event_id;
#line 549 "../src/VideoSupport.vala"
			_tmp6_ = video_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 549 "../src/VideoSupport.vala"
			_database_table_unref0 (_tmp2_);
#line 549 "../src/VideoSupport.vala"
			committed = _tmp6_;
#line 551 "../src/VideoSupport.vala"
			_tmp7_ = committed;
#line 551 "../src/VideoSupport.vala"
			if (_tmp7_) {
#line 5603 "VideoSupport.c"
				VideoRow* _tmp8_;
				EventID _tmp9_;
#line 552 "../src/VideoSupport.vala"
				_tmp8_ = self->priv->backing_row;
#line 552 "../src/VideoSupport.vala"
				_tmp9_ = *event_id;
#line 552 "../src/VideoSupport.vala"
				_tmp8_->event_id = _tmp9_;
#line 5612 "VideoSupport.c"
			}
#line 554 "../src/VideoSupport.vala"
			result = committed;
#line 5616 "VideoSupport.c"
			{
				VideoRow* _tmp10_;
#line 548 "../src/VideoSupport.vala"
				_tmp10_ = self->priv->backing_row;
#line 548 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 5623 "VideoSupport.c"
			}
#line 554 "../src/VideoSupport.vala"
			return result;
#line 5627 "VideoSupport.c"
		}
		__finally511:
		{
			VideoRow* _tmp11_;
#line 548 "../src/VideoSupport.vala"
			_tmp11_ = self->priv->backing_row;
#line 548 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 5636 "VideoSupport.c"
		}
#line 548 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 548 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 548 "../src/VideoSupport.vala"
		return _tmp12_;
#line 5644 "VideoSupport.c"
	}
}


gboolean
video_is_duplicate (GFile* file,
                    const gchar* full_md5)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	VideoTable* _tmp1_;
	VideoTable* _tmp2_;
	gboolean _tmp3_;
#line 558 "../src/VideoSupport.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 559 "../src/VideoSupport.vala"
	if (file != NULL) {
#line 559 "../src/VideoSupport.vala"
		_tmp0_ = TRUE;
#line 5664 "VideoSupport.c"
	} else {
#line 559 "../src/VideoSupport.vala"
		_tmp0_ = full_md5 != NULL;
#line 5668 "VideoSupport.c"
	}
#line 559 "../src/VideoSupport.vala"
	_vala_assert (_tmp0_, "file != null || full_md5 != null");
#line 561 "../src/VideoSupport.vala"
	_tmp1_ = video_table_get_instance ();
#line 561 "../src/VideoSupport.vala"
	_tmp2_ = _tmp1_;
#line 561 "../src/VideoSupport.vala"
	_tmp3_ = video_table_has_duplicate (_tmp2_, file, full_md5);
#line 561 "../src/VideoSupport.vala"
	_database_table_unref0 (_tmp2_);
#line 561 "../src/VideoSupport.vala"
	result = _tmp3_;
#line 561 "../src/VideoSupport.vala"
	return result;
#line 5684 "VideoSupport.c"
}


ImportResult
video_import_create (VideoImportParams* params,
                     Video* * video)
{
	Video* _vala_video = NULL;
	ImportResult result = 0;
	VideoRow* _tmp6_;
	Video* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 567 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
#line 568 "../src/VideoSupport.vala"
	_g_object_unref0 (_vala_video);
#line 568 "../src/VideoSupport.vala"
	_vala_video = NULL;
#line 5703 "VideoSupport.c"
	{
		VideoID _tmp0_ = {0};
		VideoTable* _tmp1_;
		VideoTable* _tmp2_;
		VideoRow* _tmp3_;
		VideoID _tmp4_ = {0};
		VideoID _tmp5_;
#line 572 "../src/VideoSupport.vala"
		_tmp1_ = video_table_get_instance ();
#line 572 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 572 "../src/VideoSupport.vala"
		_tmp3_ = params->row;
#line 572 "../src/VideoSupport.vala"
		video_table_add (_tmp2_, _tmp3_, &_tmp4_, &_inner_error0_);
#line 572 "../src/VideoSupport.vala"
		_tmp5_ = _tmp4_;
#line 572 "../src/VideoSupport.vala"
		_database_table_unref0 (_tmp2_);
#line 572 "../src/VideoSupport.vala"
		_tmp0_ = _tmp5_;
#line 572 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 572 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5729 "VideoSupport.c"
				goto __catch512_database_error;
			}
#line 572 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 572 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 572 "../src/VideoSupport.vala"
			return 0;
#line 5738 "VideoSupport.c"
		}
#line 572 "../src/VideoSupport.vala"
		if (video_id_is_invalid (&_tmp0_)) {
#line 573 "../src/VideoSupport.vala"
			result = IMPORT_RESULT_DATABASE_ERROR;
#line 573 "../src/VideoSupport.vala"
			if (video) {
#line 573 "../src/VideoSupport.vala"
				*video = _vala_video;
#line 5748 "VideoSupport.c"
			} else {
#line 573 "../src/VideoSupport.vala"
				_g_object_unref0 (_vala_video);
#line 5752 "VideoSupport.c"
			}
#line 573 "../src/VideoSupport.vala"
			return result;
#line 5756 "VideoSupport.c"
		}
	}
	goto __finally512;
	__catch512_database_error:
	{
		GError* err = NULL;
#line 571 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 571 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 575 "../src/VideoSupport.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 575 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 575 "../src/VideoSupport.vala"
		if (video) {
#line 575 "../src/VideoSupport.vala"
			*video = _vala_video;
#line 5775 "VideoSupport.c"
		} else {
#line 575 "../src/VideoSupport.vala"
			_g_object_unref0 (_vala_video);
#line 5779 "VideoSupport.c"
		}
#line 575 "../src/VideoSupport.vala"
		return result;
#line 5783 "VideoSupport.c"
	}
	__finally512:
#line 571 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 571 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 571 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 571 "../src/VideoSupport.vala"
		return 0;
#line 5794 "VideoSupport.c"
	}
#line 579 "../src/VideoSupport.vala"
	_tmp6_ = params->row;
#line 579 "../src/VideoSupport.vala"
	_tmp7_ = video_new (_tmp6_);
#line 579 "../src/VideoSupport.vala"
	_g_object_unref0 (_vala_video);
#line 579 "../src/VideoSupport.vala"
	_vala_video = _tmp7_;
#line 581 "../src/VideoSupport.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 581 "../src/VideoSupport.vala"
	if (video) {
#line 581 "../src/VideoSupport.vala"
		*video = _vala_video;
#line 5810 "VideoSupport.c"
	} else {
#line 581 "../src/VideoSupport.vala"
		_g_object_unref0 (_vala_video);
#line 5814 "VideoSupport.c"
	}
#line 581 "../src/VideoSupport.vala"
	return result;
#line 5818 "VideoSupport.c"
}


void
video_import_failed (Video* video)
{
	GError* _inner_error0_ = NULL;
#line 584 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (video));
#line 5828 "VideoSupport.c"
	{
		VideoTable* _tmp0_;
		VideoTable* _tmp1_;
		VideoID _tmp2_ = {0};
#line 586 "../src/VideoSupport.vala"
		_tmp0_ = video_table_get_instance ();
#line 586 "../src/VideoSupport.vala"
		_tmp1_ = _tmp0_;
#line 586 "../src/VideoSupport.vala"
		video_get_video_id (video, &_tmp2_);
#line 586 "../src/VideoSupport.vala"
		video_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 586 "../src/VideoSupport.vala"
		_database_table_unref0 (_tmp1_);
#line 586 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5847 "VideoSupport.c"
				goto __catch513_database_error;
			}
#line 586 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 586 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 586 "../src/VideoSupport.vala"
			return;
#line 5856 "VideoSupport.c"
		}
	}
	goto __finally513;
	__catch513_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 585 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 585 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 588 "../src/VideoSupport.vala"
		_tmp3_ = err;
#line 588 "../src/VideoSupport.vala"
		app_window_database_error (_tmp3_);
#line 585 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 5874 "VideoSupport.c"
	}
	__finally513:
#line 585 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 585 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 585 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 585 "../src/VideoSupport.vala"
		return;
#line 5885 "VideoSupport.c"
	}
}


static BackingFileState**
video_real_get_backing_files_state (MediaSource* base,
                                    int* result_length1)
{
	Video * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp12_;
	gint _tmp12__length1;
	GError* _inner_error0_ = NULL;
#line 592 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 593 "../src/VideoSupport.vala"
	_tmp0_ = g_new0 (BackingFileState*, 1 + 1);
#line 593 "../src/VideoSupport.vala"
	backing = _tmp0_;
#line 593 "../src/VideoSupport.vala"
	backing_length1 = 1;
#line 593 "../src/VideoSupport.vala"
	_backing_size_ = backing_length1;
#line 5913 "VideoSupport.c"
	{
		VideoRow* _tmp1_;
#line 594 "../src/VideoSupport.vala"
		_tmp1_ = self->priv->backing_row;
#line 594 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 5920 "VideoSupport.c"
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			VideoRow* _tmp4_;
			gint64 _tmp5_;
			VideoRow* _tmp6_;
			time_t _tmp7_;
			VideoRow* _tmp8_;
			const gchar* _tmp9_;
			BackingFileState* _tmp10_;
#line 595 "../src/VideoSupport.vala"
			_tmp2_ = self->priv->backing_row;
#line 595 "../src/VideoSupport.vala"
			_tmp3_ = _tmp2_->filepath;
#line 595 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 595 "../src/VideoSupport.vala"
			_tmp5_ = _tmp4_->filesize;
#line 595 "../src/VideoSupport.vala"
			_tmp6_ = self->priv->backing_row;
#line 595 "../src/VideoSupport.vala"
			_tmp7_ = _tmp6_->timestamp;
#line 595 "../src/VideoSupport.vala"
			_tmp8_ = self->priv->backing_row;
#line 595 "../src/VideoSupport.vala"
			_tmp9_ = _tmp8_->md5;
#line 595 "../src/VideoSupport.vala"
			_tmp10_ = backing_file_state_new (_tmp3_, _tmp5_, _tmp7_, _tmp9_);
#line 595 "../src/VideoSupport.vala"
			_backing_file_state_unref0 (backing[0]);
#line 595 "../src/VideoSupport.vala"
			backing[0] = _tmp10_;
#line 5953 "VideoSupport.c"
		}
		__finally514:
		{
			VideoRow* _tmp11_;
#line 594 "../src/VideoSupport.vala"
			_tmp11_ = self->priv->backing_row;
#line 594 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 5962 "VideoSupport.c"
		}
#line 594 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 594 "../src/VideoSupport.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 594 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 594 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 594 "../src/VideoSupport.vala"
			return NULL;
#line 5974 "VideoSupport.c"
		}
	}
#line 599 "../src/VideoSupport.vala"
	_tmp12_ = backing;
#line 599 "../src/VideoSupport.vala"
	_tmp12__length1 = backing_length1;
#line 599 "../src/VideoSupport.vala"
	if (result_length1) {
#line 599 "../src/VideoSupport.vala"
		*result_length1 = _tmp12__length1;
#line 5985 "VideoSupport.c"
	}
#line 599 "../src/VideoSupport.vala"
	result = _tmp12_;
#line 599 "../src/VideoSupport.vala"
	return result;
#line 5991 "VideoSupport.c"
}


static GdkPixbuf*
video_real_get_thumbnail (ThumbnailSource* base,
                          gint scale,
                          GError** error)
{
	Video * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 602 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 603 "../src/VideoSupport.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
#line 603 "../src/VideoSupport.vala"
	_tmp0_ = _tmp1_;
#line 603 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 603 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 603 "../src/VideoSupport.vala"
		return NULL;
#line 6018 "VideoSupport.c"
	}
#line 603 "../src/VideoSupport.vala"
	_tmp2_ = _tmp0_;
#line 603 "../src/VideoSupport.vala"
	_tmp0_ = NULL;
#line 603 "../src/VideoSupport.vala"
	result = _tmp2_;
#line 603 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp0_);
#line 603 "../src/VideoSupport.vala"
	return result;
#line 6030 "VideoSupport.c"
}


static gchar*
video_real_get_master_md5 (MediaSource* base)
{
	Video * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 606 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6042 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 607 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 607 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6049 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 608 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 608 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->md5;
#line 608 "../src/VideoSupport.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 608 "../src/VideoSupport.vala"
			result = _tmp3_;
#line 6062 "VideoSupport.c"
			{
				VideoRow* _tmp4_;
#line 607 "../src/VideoSupport.vala"
				_tmp4_ = self->priv->backing_row;
#line 607 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6069 "VideoSupport.c"
			}
#line 608 "../src/VideoSupport.vala"
			return result;
#line 6073 "VideoSupport.c"
		}
		__finally515:
		{
			VideoRow* _tmp5_;
#line 607 "../src/VideoSupport.vala"
			_tmp5_ = self->priv->backing_row;
#line 607 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6082 "VideoSupport.c"
		}
#line 607 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 607 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 607 "../src/VideoSupport.vala"
		return NULL;
#line 6090 "VideoSupport.c"
	}
}


static GdkPixbuf*
video_real_get_preview_pixbuf (MediaSource* base,
                               Scaling* scaling,
                               GError** error)
{
	Video * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 612 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 612 "../src/VideoSupport.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 613 "../src/VideoSupport.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 613 "../src/VideoSupport.vala"
	pixbuf = _tmp0_;
#line 613 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 613 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 613 "../src/VideoSupport.vala"
		return NULL;
#line 6120 "VideoSupport.c"
	}
#line 615 "../src/VideoSupport.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_NEAREST, TRUE);
#line 615 "../src/VideoSupport.vala"
	result = _tmp1_;
#line 615 "../src/VideoSupport.vala"
	_g_object_unref0 (pixbuf);
#line 615 "../src/VideoSupport.vala"
	return result;
#line 6130 "VideoSupport.c"
}


static GdkPixbuf*
video_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Video * self;
	GdkPixbuf* result = NULL;
	VideoReader* reader = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	VideoReader* _tmp2_;
	VideoReader* _tmp3_;
	GdkPixbuf* frame = NULL;
	VideoReader* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_ = NULL;
	GdkPixbuf* _tmp7_;
#line 618 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 619 "../src/VideoSupport.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 619 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 619 "../src/VideoSupport.vala"
	_tmp2_ = video_reader_new (_tmp1_);
#line 619 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 619 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp1_);
#line 619 "../src/VideoSupport.vala"
	reader = _tmp3_;
#line 620 "../src/VideoSupport.vala"
	_tmp4_ = reader;
#line 620 "../src/VideoSupport.vala"
	_tmp5_ = video_reader_read_preview_frame (_tmp4_);
#line 620 "../src/VideoSupport.vala"
	frame = _tmp5_;
#line 622 "../src/VideoSupport.vala"
	_tmp7_ = frame;
#line 622 "../src/VideoSupport.vala"
	if (_tmp7_ != NULL) {
#line 6175 "VideoSupport.c"
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 622 "../src/VideoSupport.vala"
		_tmp8_ = frame;
#line 622 "../src/VideoSupport.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 622 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp6_);
#line 622 "../src/VideoSupport.vala"
		_tmp6_ = _tmp9_;
#line 6186 "VideoSupport.c"
	} else {
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 622 "../src/VideoSupport.vala"
		_tmp10_ = resources_get_noninterpretable_badge_pixbuf ();
#line 622 "../src/VideoSupport.vala"
		_tmp11_ = _tmp10_;
#line 622 "../src/VideoSupport.vala"
		_tmp12_ = gdk_pixbuf_copy (_tmp11_);
#line 622 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp6_);
#line 622 "../src/VideoSupport.vala"
		_tmp6_ = _tmp12_;
#line 622 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp11_);
#line 6203 "VideoSupport.c"
	}
#line 622 "../src/VideoSupport.vala"
	result = _tmp6_;
#line 622 "../src/VideoSupport.vala"
	_g_object_unref0 (frame);
#line 622 "../src/VideoSupport.vala"
	_video_reader_unref0 (reader);
#line 622 "../src/VideoSupport.vala"
	return result;
#line 6213 "VideoSupport.c"
}


static gchar*
video_real_get_typename (DataSource* base)
{
	Video * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 625 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 626 "../src/VideoSupport.vala"
	_tmp0_ = g_strdup (VIDEO_TYPENAME);
#line 626 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 626 "../src/VideoSupport.vala"
	return result;
#line 6231 "VideoSupport.c"
}


static gint64
video_real_get_instance_id (DataSource* base)
{
	Video * self;
	gint64 result = 0LL;
	VideoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 629 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 630 "../src/VideoSupport.vala"
	video_get_video_id (self, &_tmp0_);
#line 630 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_.id;
#line 630 "../src/VideoSupport.vala"
	result = _tmp1_;
#line 630 "../src/VideoSupport.vala"
	return result;
#line 6252 "VideoSupport.c"
}


static void
video_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Video * self;
	GError* _inner_error0_ = NULL;
#line 633 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6264 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 634 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 634 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6271 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			ImportID _tmp2_;
#line 635 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 635 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->import_id;
#line 635 "../src/VideoSupport.vala"
			*result = _tmp2_;
#line 6281 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 634 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 634 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6288 "VideoSupport.c"
			}
#line 635 "../src/VideoSupport.vala"
			return;
#line 6292 "VideoSupport.c"
		}
		__finally516:
		{
			VideoRow* _tmp4_;
#line 634 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 634 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6301 "VideoSupport.c"
		}
#line 634 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 634 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 634 "../src/VideoSupport.vala"
		return;
#line 6309 "VideoSupport.c"
	}
}


static PhotoFileFormat
video_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Video * self;
	PhotoFileFormat result = 0;
#line 639 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 640 "../src/VideoSupport.vala"
	result = photo_file_format_get_system_default_format ();
#line 640 "../src/VideoSupport.vala"
	return result;
#line 6325 "VideoSupport.c"
}


static gchar*
video_real_get_title (MediaSource* base)
{
	Video * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 643 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6337 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 644 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 644 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6344 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 645 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 645 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->title;
#line 645 "../src/VideoSupport.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 645 "../src/VideoSupport.vala"
			result = _tmp3_;
#line 6357 "VideoSupport.c"
			{
				VideoRow* _tmp4_;
#line 644 "../src/VideoSupport.vala"
				_tmp4_ = self->priv->backing_row;
#line 644 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6364 "VideoSupport.c"
			}
#line 645 "../src/VideoSupport.vala"
			return result;
#line 6368 "VideoSupport.c"
		}
		__finally517:
		{
			VideoRow* _tmp5_;
#line 644 "../src/VideoSupport.vala"
			_tmp5_ = self->priv->backing_row;
#line 644 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6377 "VideoSupport.c"
		}
#line 644 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 644 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 644 "../src/VideoSupport.vala"
		return NULL;
#line 6385 "VideoSupport.c"
	}
}


static void
video_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Video * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	Alteration* _tmp19_;
	Alteration* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 649 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 650 "../src/VideoSupport.vala"
	_tmp0_ = media_source_prep_title (title);
#line 650 "../src/VideoSupport.vala"
	new_title = _tmp0_;
#line 6406 "VideoSupport.c"
	{
		VideoRow* _tmp1_;
#line 652 "../src/VideoSupport.vala"
		_tmp1_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6413 "VideoSupport.c"
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			VideoRow* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 653 "../src/VideoSupport.vala"
			_tmp2_ = self->priv->backing_row;
#line 653 "../src/VideoSupport.vala"
			_tmp3_ = _tmp2_->title;
#line 653 "../src/VideoSupport.vala"
			_tmp4_ = new_title;
#line 653 "../src/VideoSupport.vala"
			if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 6429 "VideoSupport.c"
				{
					VideoRow* _tmp5_;
#line 652 "../src/VideoSupport.vala"
					_tmp5_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6436 "VideoSupport.c"
				}
#line 654 "../src/VideoSupport.vala"
				_g_free0 (new_title);
#line 654 "../src/VideoSupport.vala"
				return;
#line 6442 "VideoSupport.c"
			}
			{
				VideoTable* _tmp6_;
				VideoTable* _tmp7_;
				VideoRow* _tmp8_;
				VideoID _tmp9_;
				const gchar* _tmp10_;
#line 657 "../src/VideoSupport.vala"
				_tmp6_ = video_table_get_instance ();
#line 657 "../src/VideoSupport.vala"
				_tmp7_ = _tmp6_;
#line 657 "../src/VideoSupport.vala"
				_tmp8_ = self->priv->backing_row;
#line 657 "../src/VideoSupport.vala"
				_tmp9_ = _tmp8_->video_id;
#line 657 "../src/VideoSupport.vala"
				_tmp10_ = new_title;
#line 657 "../src/VideoSupport.vala"
				video_table_set_title (_tmp7_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 657 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp7_);
#line 657 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 657 "../src/VideoSupport.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6468 "VideoSupport.c"
						goto __catch519_database_error;
					}
					{
						VideoRow* _tmp11_;
#line 652 "../src/VideoSupport.vala"
						_tmp11_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6477 "VideoSupport.c"
					}
#line 657 "../src/VideoSupport.vala"
					_g_free0 (new_title);
#line 657 "../src/VideoSupport.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 657 "../src/VideoSupport.vala"
					g_clear_error (&_inner_error0_);
#line 657 "../src/VideoSupport.vala"
					return;
#line 6487 "VideoSupport.c"
				}
			}
			goto __finally519;
			__catch519_database_error:
			{
				GError* e = NULL;
				GError* _tmp12_;
#line 656 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 656 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 659 "../src/VideoSupport.vala"
				_tmp12_ = e;
#line 659 "../src/VideoSupport.vala"
				app_window_database_error (_tmp12_);
#line 660 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 6505 "VideoSupport.c"
				{
					VideoRow* _tmp13_;
#line 652 "../src/VideoSupport.vala"
					_tmp13_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6512 "VideoSupport.c"
				}
#line 660 "../src/VideoSupport.vala"
				_g_free0 (new_title);
#line 660 "../src/VideoSupport.vala"
				return;
#line 6518 "VideoSupport.c"
			}
			__finally519:
#line 656 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6523 "VideoSupport.c"
				{
					VideoRow* _tmp14_;
#line 652 "../src/VideoSupport.vala"
					_tmp14_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6530 "VideoSupport.c"
				}
#line 656 "../src/VideoSupport.vala"
				_g_free0 (new_title);
#line 656 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 656 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 656 "../src/VideoSupport.vala"
				return;
#line 6540 "VideoSupport.c"
			}
#line 664 "../src/VideoSupport.vala"
			_tmp15_ = self->priv->backing_row;
#line 664 "../src/VideoSupport.vala"
			_tmp16_ = new_title;
#line 664 "../src/VideoSupport.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 664 "../src/VideoSupport.vala"
			_g_free0 (_tmp15_->title);
#line 664 "../src/VideoSupport.vala"
			_tmp15_->title = _tmp17_;
#line 6552 "VideoSupport.c"
		}
		__finally518:
		{
			VideoRow* _tmp18_;
#line 652 "../src/VideoSupport.vala"
			_tmp18_ = self->priv->backing_row;
#line 652 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6561 "VideoSupport.c"
		}
#line 652 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 652 "../src/VideoSupport.vala"
			_g_free0 (new_title);
#line 652 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 652 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 652 "../src/VideoSupport.vala"
			return;
#line 6573 "VideoSupport.c"
		}
	}
#line 667 "../src/VideoSupport.vala"
	_tmp19_ = alteration_new ("metadata", "name");
#line 667 "../src/VideoSupport.vala"
	_tmp20_ = _tmp19_;
#line 667 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp20_);
#line 667 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp20_);
#line 649 "../src/VideoSupport.vala"
	_g_free0 (new_title);
#line 6586 "VideoSupport.c"
}


static gchar*
video_real_get_comment (MediaSource* base)
{
	Video * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 670 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6598 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 671 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 671 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6605 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 672 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 672 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->comment;
#line 672 "../src/VideoSupport.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 672 "../src/VideoSupport.vala"
			result = _tmp3_;
#line 6618 "VideoSupport.c"
			{
				VideoRow* _tmp4_;
#line 671 "../src/VideoSupport.vala"
				_tmp4_ = self->priv->backing_row;
#line 671 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6625 "VideoSupport.c"
			}
#line 672 "../src/VideoSupport.vala"
			return result;
#line 6629 "VideoSupport.c"
		}
		__finally520:
		{
			VideoRow* _tmp5_;
#line 671 "../src/VideoSupport.vala"
			_tmp5_ = self->priv->backing_row;
#line 671 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6638 "VideoSupport.c"
		}
#line 671 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 671 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 671 "../src/VideoSupport.vala"
		return NULL;
#line 6646 "VideoSupport.c"
	}
}


static gboolean
video_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Video * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	Alteration* _tmp22_;
	Alteration* _tmp23_;
	GError* _inner_error0_ = NULL;
#line 676 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 677 "../src/VideoSupport.vala"
	_tmp0_ = media_source_prep_title (comment);
#line 677 "../src/VideoSupport.vala"
	new_comment = _tmp0_;
#line 6668 "VideoSupport.c"
	{
		VideoRow* _tmp1_;
#line 679 "../src/VideoSupport.vala"
		_tmp1_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6675 "VideoSupport.c"
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			VideoRow* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 680 "../src/VideoSupport.vala"
			_tmp2_ = self->priv->backing_row;
#line 680 "../src/VideoSupport.vala"
			_tmp3_ = _tmp2_->comment;
#line 680 "../src/VideoSupport.vala"
			_tmp4_ = new_comment;
#line 680 "../src/VideoSupport.vala"
			if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 681 "../src/VideoSupport.vala"
				result = TRUE;
#line 6693 "VideoSupport.c"
				{
					VideoRow* _tmp5_;
#line 679 "../src/VideoSupport.vala"
					_tmp5_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6700 "VideoSupport.c"
				}
#line 681 "../src/VideoSupport.vala"
				_g_free0 (new_comment);
#line 681 "../src/VideoSupport.vala"
				return result;
#line 6706 "VideoSupport.c"
			}
			{
				VideoTable* _tmp6_;
				VideoTable* _tmp7_;
				VideoRow* _tmp8_;
				VideoID _tmp9_;
				const gchar* _tmp10_;
#line 684 "../src/VideoSupport.vala"
				_tmp6_ = video_table_get_instance ();
#line 684 "../src/VideoSupport.vala"
				_tmp7_ = _tmp6_;
#line 684 "../src/VideoSupport.vala"
				_tmp8_ = self->priv->backing_row;
#line 684 "../src/VideoSupport.vala"
				_tmp9_ = _tmp8_->video_id;
#line 684 "../src/VideoSupport.vala"
				_tmp10_ = new_comment;
#line 684 "../src/VideoSupport.vala"
				video_table_set_comment (_tmp7_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 684 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp7_);
#line 684 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6730 "VideoSupport.c"
					gboolean _tmp12_ = FALSE;
#line 684 "../src/VideoSupport.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6734 "VideoSupport.c"
						goto __catch522_database_error;
					}
					{
						VideoRow* _tmp11_;
#line 679 "../src/VideoSupport.vala"
						_tmp11_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6743 "VideoSupport.c"
					}
#line 684 "../src/VideoSupport.vala"
					_g_free0 (new_comment);
#line 684 "../src/VideoSupport.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 684 "../src/VideoSupport.vala"
					g_clear_error (&_inner_error0_);
#line 684 "../src/VideoSupport.vala"
					return _tmp12_;
#line 6753 "VideoSupport.c"
				}
			}
			goto __finally522;
			__catch522_database_error:
			{
				GError* e = NULL;
				GError* _tmp13_;
#line 683 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 683 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 686 "../src/VideoSupport.vala"
				_tmp13_ = e;
#line 686 "../src/VideoSupport.vala"
				app_window_database_error (_tmp13_);
#line 687 "../src/VideoSupport.vala"
				result = FALSE;
#line 687 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 6773 "VideoSupport.c"
				{
					VideoRow* _tmp14_;
#line 679 "../src/VideoSupport.vala"
					_tmp14_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6780 "VideoSupport.c"
				}
#line 687 "../src/VideoSupport.vala"
				_g_free0 (new_comment);
#line 687 "../src/VideoSupport.vala"
				return result;
#line 6786 "VideoSupport.c"
			}
			__finally522:
#line 683 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6791 "VideoSupport.c"
				gboolean _tmp16_ = FALSE;
				{
					VideoRow* _tmp15_;
#line 679 "../src/VideoSupport.vala"
					_tmp15_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6799 "VideoSupport.c"
				}
#line 683 "../src/VideoSupport.vala"
				_g_free0 (new_comment);
#line 683 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 683 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 683 "../src/VideoSupport.vala"
				return _tmp16_;
#line 6809 "VideoSupport.c"
			}
#line 691 "../src/VideoSupport.vala"
			_tmp17_ = self->priv->backing_row;
#line 691 "../src/VideoSupport.vala"
			_tmp18_ = new_comment;
#line 691 "../src/VideoSupport.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 691 "../src/VideoSupport.vala"
			_g_free0 (_tmp17_->comment);
#line 691 "../src/VideoSupport.vala"
			_tmp17_->comment = _tmp19_;
#line 6821 "VideoSupport.c"
		}
		__finally521:
		{
			VideoRow* _tmp20_;
#line 679 "../src/VideoSupport.vala"
			_tmp20_ = self->priv->backing_row;
#line 679 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6830 "VideoSupport.c"
		}
#line 679 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6834 "VideoSupport.c"
			gboolean _tmp21_ = FALSE;
#line 679 "../src/VideoSupport.vala"
			_g_free0 (new_comment);
#line 679 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 679 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 679 "../src/VideoSupport.vala"
			return _tmp21_;
#line 6844 "VideoSupport.c"
		}
	}
#line 694 "../src/VideoSupport.vala"
	_tmp22_ = alteration_new ("metadata", "comment");
#line 694 "../src/VideoSupport.vala"
	_tmp23_ = _tmp22_;
#line 694 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 694 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp23_);
#line 696 "../src/VideoSupport.vala"
	result = TRUE;
#line 696 "../src/VideoSupport.vala"
	_g_free0 (new_comment);
#line 696 "../src/VideoSupport.vala"
	return result;
#line 6861 "VideoSupport.c"
}


static Rating
video_real_get_rating (MediaSource* base)
{
	Video * self;
	Rating result = 0;
	GError* _inner_error0_ = NULL;
#line 700 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6873 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 701 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 701 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6880 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
#line 702 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 702 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->rating;
#line 702 "../src/VideoSupport.vala"
			result = _tmp2_;
#line 6890 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 701 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 701 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6897 "VideoSupport.c"
			}
#line 702 "../src/VideoSupport.vala"
			return result;
#line 6901 "VideoSupport.c"
		}
		__finally523:
		{
			VideoRow* _tmp4_;
#line 701 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 701 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6910 "VideoSupport.c"
		}
#line 701 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 701 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 701 "../src/VideoSupport.vala"
		return 0;
#line 6918 "VideoSupport.c"
	}
}


static void
video_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Video * self;
	Alteration* _tmp14_;
	Alteration* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 706 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 6933 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 707 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 6940 "VideoSupport.c"
		{
			gboolean _tmp1_ = FALSE;
			VideoRow* _tmp12_;
#line 708 "../src/VideoSupport.vala"
			if (!rating_is_valid (rating)) {
#line 708 "../src/VideoSupport.vala"
				_tmp1_ = TRUE;
#line 6948 "VideoSupport.c"
			} else {
				VideoRow* _tmp2_;
				Rating _tmp3_;
#line 708 "../src/VideoSupport.vala"
				_tmp2_ = self->priv->backing_row;
#line 708 "../src/VideoSupport.vala"
				_tmp3_ = _tmp2_->rating;
#line 708 "../src/VideoSupport.vala"
				_tmp1_ = rating == _tmp3_;
#line 6958 "VideoSupport.c"
			}
#line 708 "../src/VideoSupport.vala"
			if (_tmp1_) {
#line 6962 "VideoSupport.c"
				{
					VideoRow* _tmp4_;
#line 707 "../src/VideoSupport.vala"
					_tmp4_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 6969 "VideoSupport.c"
				}
#line 709 "../src/VideoSupport.vala"
				return;
#line 6973 "VideoSupport.c"
			}
			{
				VideoTable* _tmp5_;
				VideoTable* _tmp6_;
				VideoID _tmp7_ = {0};
#line 712 "../src/VideoSupport.vala"
				_tmp5_ = video_table_get_instance ();
#line 712 "../src/VideoSupport.vala"
				_tmp6_ = _tmp5_;
#line 712 "../src/VideoSupport.vala"
				video_get_video_id (self, &_tmp7_);
#line 712 "../src/VideoSupport.vala"
				video_table_set_rating (_tmp6_, &_tmp7_, rating, &_inner_error0_);
#line 712 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp6_);
#line 712 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 712 "../src/VideoSupport.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6993 "VideoSupport.c"
						goto __catch525_database_error;
					}
					{
						VideoRow* _tmp8_;
#line 707 "../src/VideoSupport.vala"
						_tmp8_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7002 "VideoSupport.c"
					}
#line 712 "../src/VideoSupport.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 712 "../src/VideoSupport.vala"
					g_clear_error (&_inner_error0_);
#line 712 "../src/VideoSupport.vala"
					return;
#line 7010 "VideoSupport.c"
				}
			}
			goto __finally525;
			__catch525_database_error:
			{
				GError* e = NULL;
				GError* _tmp9_;
#line 711 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 711 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 714 "../src/VideoSupport.vala"
				_tmp9_ = e;
#line 714 "../src/VideoSupport.vala"
				app_window_database_error (_tmp9_);
#line 715 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 7028 "VideoSupport.c"
				{
					VideoRow* _tmp10_;
#line 707 "../src/VideoSupport.vala"
					_tmp10_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7035 "VideoSupport.c"
				}
#line 715 "../src/VideoSupport.vala"
				return;
#line 7039 "VideoSupport.c"
			}
			__finally525:
#line 711 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7044 "VideoSupport.c"
				{
					VideoRow* _tmp11_;
#line 707 "../src/VideoSupport.vala"
					_tmp11_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7051 "VideoSupport.c"
				}
#line 711 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 711 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 711 "../src/VideoSupport.vala"
				return;
#line 7059 "VideoSupport.c"
			}
#line 719 "../src/VideoSupport.vala"
			_tmp12_ = self->priv->backing_row;
#line 719 "../src/VideoSupport.vala"
			_tmp12_->rating = rating;
#line 7065 "VideoSupport.c"
		}
		__finally524:
		{
			VideoRow* _tmp13_;
#line 707 "../src/VideoSupport.vala"
			_tmp13_ = self->priv->backing_row;
#line 707 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7074 "VideoSupport.c"
		}
#line 707 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 707 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 707 "../src/VideoSupport.vala"
			return;
#line 7084 "VideoSupport.c"
		}
	}
#line 722 "../src/VideoSupport.vala"
	_tmp14_ = alteration_new ("metadata", "rating");
#line 722 "../src/VideoSupport.vala"
	_tmp15_ = _tmp14_;
#line 722 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 722 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp15_);
#line 7095 "VideoSupport.c"
}


static void
video_real_increase_rating (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
#line 725 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7106 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 726 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 726 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7113 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
#line 727 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 727 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->rating;
#line 727 "../src/VideoSupport.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp2_));
#line 7123 "VideoSupport.c"
		}
		__finally526:
		{
			VideoRow* _tmp3_;
#line 726 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 726 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7132 "VideoSupport.c"
		}
#line 726 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 726 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 726 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 726 "../src/VideoSupport.vala"
			return;
#line 7142 "VideoSupport.c"
		}
	}
}


static void
video_real_decrease_rating (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
#line 731 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7155 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 732 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 732 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7162 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
#line 733 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 733 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->rating;
#line 733 "../src/VideoSupport.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp2_));
#line 7172 "VideoSupport.c"
		}
		__finally527:
		{
			VideoRow* _tmp3_;
#line 732 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 732 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7181 "VideoSupport.c"
		}
#line 732 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 732 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 732 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 732 "../src/VideoSupport.vala"
			return;
#line 7191 "VideoSupport.c"
		}
	}
}


static gboolean
video_real_is_trashed (MediaSource* base)
{
	Video * self;
	gboolean result = FALSE;
#line 737 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 738 "../src/VideoSupport.vala"
	result = video_is_flag_set (self, VIDEO_FLAG_TRASH);
#line 738 "../src/VideoSupport.vala"
	return result;
#line 7208 "VideoSupport.c"
}


static gboolean
video_real_is_offline (Monitorable* base)
{
	Video * self;
	gboolean result = FALSE;
#line 741 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 742 "../src/VideoSupport.vala"
	result = video_is_flag_set (self, VIDEO_FLAG_OFFLINE);
#line 742 "../src/VideoSupport.vala"
	return result;
#line 7223 "VideoSupport.c"
}


static void
video_real_mark_offline (Monitorable* base)
{
	Video * self;
#line 745 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 746 "../src/VideoSupport.vala"
	video_add_flags (self, VIDEO_FLAG_OFFLINE, NULL);
#line 7235 "VideoSupport.c"
}


static void
video_real_mark_online (Monitorable* base)
{
	Video * self;
	gboolean _tmp0_ = FALSE;
#line 749 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 750 "../src/VideoSupport.vala"
	video_remove_flags (self, VIDEO_FLAG_OFFLINE, NULL);
#line 752 "../src/VideoSupport.vala"
	if (!video_get_is_interpretable (self)) {
#line 752 "../src/VideoSupport.vala"
		_tmp0_ = video_has_interpreter_state_changed ();
#line 7252 "VideoSupport.c"
	} else {
#line 752 "../src/VideoSupport.vala"
		_tmp0_ = FALSE;
#line 7256 "VideoSupport.c"
	}
#line 752 "../src/VideoSupport.vala"
	if (_tmp0_) {
#line 7260 "VideoSupport.c"
		VideoInterpretableResults* _tmp1_;
		VideoInterpretableResults* _tmp2_;
#line 753 "../src/VideoSupport.vala"
		_tmp1_ = video_check_is_interpretable (self);
#line 753 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 753 "../src/VideoSupport.vala"
		video_interpretable_results_foreground_finish (_tmp2_);
#line 753 "../src/VideoSupport.vala"
		_video_interpretable_results_unref0 (_tmp2_);
#line 7271 "VideoSupport.c"
	}
}


static void
video_real_trash (MediaSource* base)
{
	Video * self;
#line 756 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 757 "../src/VideoSupport.vala"
	video_add_flags (self, VIDEO_FLAG_TRASH, NULL);
#line 7284 "VideoSupport.c"
}


static void
video_real_untrash (MediaSource* base)
{
	Video * self;
#line 760 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 761 "../src/VideoSupport.vala"
	video_remove_flags (self, VIDEO_FLAG_TRASH, NULL);
#line 7296 "VideoSupport.c"
}


static gboolean
video_real_is_flagged (Flaggable* base)
{
	Video * self;
	gboolean result = FALSE;
#line 764 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 765 "../src/VideoSupport.vala"
	result = video_is_flag_set (self, VIDEO_FLAG_FLAGGED);
#line 765 "../src/VideoSupport.vala"
	return result;
#line 7311 "VideoSupport.c"
}


static void
video_real_mark_flagged (Flaggable* base)
{
	Video * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 768 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 769 "../src/VideoSupport.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 769 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 769 "../src/VideoSupport.vala"
	video_add_flags (self, VIDEO_FLAG_FLAGGED, _tmp1_);
#line 769 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp1_);
#line 7331 "VideoSupport.c"
}


static void
video_real_mark_unflagged (Flaggable* base)
{
	Video * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 772 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 773 "../src/VideoSupport.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 773 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 773 "../src/VideoSupport.vala"
	video_remove_flags (self, VIDEO_FLAG_FLAGGED, _tmp1_);
#line 773 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp1_);
#line 7351 "VideoSupport.c"
}


static void
video_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Video * self;
	GError* _inner_error0_ = NULL;
#line 776 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7363 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 777 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 777 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7370 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			EventID _tmp2_;
#line 778 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 778 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->event_id;
#line 778 "../src/VideoSupport.vala"
			*result = _tmp2_;
#line 7380 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 777 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 777 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7387 "VideoSupport.c"
			}
#line 778 "../src/VideoSupport.vala"
			return;
#line 7391 "VideoSupport.c"
		}
		__finally528:
		{
			VideoRow* _tmp4_;
#line 777 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 777 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7400 "VideoSupport.c"
		}
#line 777 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 777 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 777 "../src/VideoSupport.vala"
		return;
#line 7408 "VideoSupport.c"
	}
}


static gchar*
video_real_to_string (DataObject* base)
{
	Video * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 782 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7421 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 783 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 783 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7428 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			VideoID _tmp2_;
			gint64 _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			VideoRow* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 784 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 784 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->video_id;
#line 784 "../src/VideoSupport.vala"
			_tmp3_ = _tmp2_.id;
#line 784 "../src/VideoSupport.vala"
			_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp3_);
#line 784 "../src/VideoSupport.vala"
			_tmp5_ = _tmp4_;
#line 784 "../src/VideoSupport.vala"
			_tmp6_ = self->priv->backing_row;
#line 784 "../src/VideoSupport.vala"
			_tmp7_ = _tmp6_->filepath;
#line 784 "../src/VideoSupport.vala"
			_tmp8_ = g_strdup_printf ("[%s] %s", _tmp5_, _tmp7_);
#line 784 "../src/VideoSupport.vala"
			_tmp9_ = _tmp8_;
#line 784 "../src/VideoSupport.vala"
			_g_free0 (_tmp5_);
#line 784 "../src/VideoSupport.vala"
			result = _tmp9_;
#line 7461 "VideoSupport.c"
			{
				VideoRow* _tmp10_;
#line 783 "../src/VideoSupport.vala"
				_tmp10_ = self->priv->backing_row;
#line 783 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7468 "VideoSupport.c"
			}
#line 784 "../src/VideoSupport.vala"
			return result;
#line 7472 "VideoSupport.c"
		}
		__finally529:
		{
			VideoRow* _tmp11_;
#line 783 "../src/VideoSupport.vala"
			_tmp11_ = self->priv->backing_row;
#line 783 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7481 "VideoSupport.c"
		}
#line 783 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 783 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 783 "../src/VideoSupport.vala"
		return NULL;
#line 7489 "VideoSupport.c"
	}
}


void
video_get_video_id (Video* self,
                    VideoID* result)
{
	GError* _inner_error0_ = NULL;
#line 788 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (self));
#line 7501 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 789 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 789 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7508 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			VideoID _tmp2_;
#line 790 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 790 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->video_id;
#line 790 "../src/VideoSupport.vala"
			*result = _tmp2_;
#line 7518 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 789 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 789 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7525 "VideoSupport.c"
			}
#line 790 "../src/VideoSupport.vala"
			return;
#line 7529 "VideoSupport.c"
		}
		__finally530:
		{
			VideoRow* _tmp4_;
#line 789 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 789 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7538 "VideoSupport.c"
		}
#line 789 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 789 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 789 "../src/VideoSupport.vala"
		return;
#line 7546 "VideoSupport.c"
	}
}


static time_t
video_real_get_exposure_time (Dateable* base)
{
	Video * self;
	time_t result = 0;
	GError* _inner_error0_ = NULL;
#line 794 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7559 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		time_t _tmp5_ = 0;
#line 795 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 795 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7567 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			time_t _tmp2_;
#line 796 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 796 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->exposure_time;
#line 796 "../src/VideoSupport.vala"
			result = _tmp2_;
#line 7577 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 795 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 795 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7584 "VideoSupport.c"
			}
#line 796 "../src/VideoSupport.vala"
			return result;
#line 7588 "VideoSupport.c"
		}
		__finally531:
		{
			VideoRow* _tmp4_;
#line 795 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 795 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7597 "VideoSupport.c"
		}
#line 795 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 795 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 795 "../src/VideoSupport.vala"
		return _tmp5_;
#line 7605 "VideoSupport.c"
	}
}


static void
video_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Video * self;
	Alteration* _tmp10_;
	Alteration* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 800 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7620 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 801 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 801 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7627 "VideoSupport.c"
		{
			VideoRow* _tmp8_;
			{
				VideoTable* _tmp1_;
				VideoTable* _tmp2_;
				VideoRow* _tmp3_;
				VideoID _tmp4_;
#line 803 "../src/VideoSupport.vala"
				_tmp1_ = video_table_get_instance ();
#line 803 "../src/VideoSupport.vala"
				_tmp2_ = _tmp1_;
#line 803 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 803 "../src/VideoSupport.vala"
				_tmp4_ = _tmp3_->video_id;
#line 803 "../src/VideoSupport.vala"
				video_table_set_exposure_time (_tmp2_, &_tmp4_, time, &_inner_error0_);
#line 803 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp2_);
#line 803 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7649 "VideoSupport.c"
					goto __catch533_g_error;
				}
			}
			goto __finally533;
			__catch533_g_error:
			{
				GError* e = NULL;
				GError* _tmp5_;
				const gchar* _tmp6_;
#line 802 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 802 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 805 "../src/VideoSupport.vala"
				_tmp5_ = e;
#line 805 "../src/VideoSupport.vala"
				_tmp6_ = _tmp5_->message;
#line 805 "../src/VideoSupport.vala"
				g_debug ("VideoSupport.vala:805: Warning - %s", _tmp6_);
#line 802 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 7671 "VideoSupport.c"
			}
			__finally533:
#line 802 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7676 "VideoSupport.c"
				{
					VideoRow* _tmp7_;
#line 801 "../src/VideoSupport.vala"
					_tmp7_ = self->priv->backing_row;
#line 801 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7683 "VideoSupport.c"
				}
#line 802 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 802 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 802 "../src/VideoSupport.vala"
				return;
#line 7691 "VideoSupport.c"
			}
#line 807 "../src/VideoSupport.vala"
			_tmp8_ = self->priv->backing_row;
#line 807 "../src/VideoSupport.vala"
			_tmp8_->exposure_time = time;
#line 7697 "VideoSupport.c"
		}
		__finally532:
		{
			VideoRow* _tmp9_;
#line 801 "../src/VideoSupport.vala"
			_tmp9_ = self->priv->backing_row;
#line 801 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7706 "VideoSupport.c"
		}
#line 801 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 801 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 801 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 801 "../src/VideoSupport.vala"
			return;
#line 7716 "VideoSupport.c"
		}
	}
#line 810 "../src/VideoSupport.vala"
	_tmp10_ = alteration_new ("metadata", "exposure-time");
#line 810 "../src/VideoSupport.vala"
	_tmp11_ = _tmp10_;
#line 810 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp11_);
#line 810 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp11_);
#line 7727 "VideoSupport.c"
}


void
video_get_frame_dimensions (Video* self,
                            Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 813 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (self));
#line 7738 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 814 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 814 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7745 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			gint _tmp2_;
			VideoRow* _tmp3_;
			gint _tmp4_;
			Dimensions _tmp5_ = {0};
#line 815 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 815 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->width;
#line 815 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 815 "../src/VideoSupport.vala"
			_tmp4_ = _tmp3_->height;
#line 815 "../src/VideoSupport.vala"
			dimensions_init (&_tmp5_, _tmp2_, _tmp4_);
#line 815 "../src/VideoSupport.vala"
			*result = _tmp5_;
#line 7764 "VideoSupport.c"
			{
				VideoRow* _tmp6_;
#line 814 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->backing_row;
#line 814 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7771 "VideoSupport.c"
			}
#line 815 "../src/VideoSupport.vala"
			return;
#line 7775 "VideoSupport.c"
		}
		__finally534:
		{
			VideoRow* _tmp7_;
#line 814 "../src/VideoSupport.vala"
			_tmp7_ = self->priv->backing_row;
#line 814 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7784 "VideoSupport.c"
		}
#line 814 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 814 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 814 "../src/VideoSupport.vala"
		return;
#line 7792 "VideoSupport.c"
	}
}


static void
video_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Video * self;
	Dimensions _tmp0_ = {0};
#line 819 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 820 "../src/VideoSupport.vala"
	video_get_frame_dimensions (self, &_tmp0_);
#line 820 "../src/VideoSupport.vala"
	*result = _tmp0_;
#line 820 "../src/VideoSupport.vala"
	return;
#line 7812 "VideoSupport.c"
}


static guint64
video_real_get_filesize (MediaSource* base)
{
	Video * self;
	guint64 result = 0ULL;
#line 823 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 824 "../src/VideoSupport.vala"
	result = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 824 "../src/VideoSupport.vala"
	return result;
#line 7827 "VideoSupport.c"
}


static guint64
video_real_get_master_filesize (MediaSource* base)
{
	Video * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 827 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7839 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 828 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 828 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7847 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			gint64 _tmp2_;
#line 829 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 829 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->filesize;
#line 829 "../src/VideoSupport.vala"
			result = (guint64) _tmp2_;
#line 7857 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 828 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 828 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7864 "VideoSupport.c"
			}
#line 829 "../src/VideoSupport.vala"
			return result;
#line 7868 "VideoSupport.c"
		}
		__finally535:
		{
			VideoRow* _tmp4_;
#line 828 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 828 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7877 "VideoSupport.c"
		}
#line 828 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 828 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 828 "../src/VideoSupport.vala"
		return _tmp5_;
#line 7885 "VideoSupport.c"
	}
}


static time_t
video_real_get_timestamp (MediaSource* base)
{
	Video * self;
	time_t result = 0;
	GError* _inner_error0_ = NULL;
#line 833 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 7898 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		time_t _tmp5_ = 0;
#line 834 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 834 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7906 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			time_t _tmp2_;
#line 835 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 835 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 835 "../src/VideoSupport.vala"
			result = _tmp2_;
#line 7916 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 834 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 834 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7923 "VideoSupport.c"
			}
#line 835 "../src/VideoSupport.vala"
			return result;
#line 7927 "VideoSupport.c"
		}
		__finally536:
		{
			VideoRow* _tmp4_;
#line 834 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 834 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 7936 "VideoSupport.c"
		}
#line 834 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 834 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 834 "../src/VideoSupport.vala"
		return _tmp5_;
#line 7944 "VideoSupport.c"
	}
}


static void
video_real_set_master_timestamp (Monitorable* base,
                                 GFileInfo* info)
{
	Video * self;
	GTimeVal time_val = {0};
	GTimeVal _tmp0_ = {0};
	Alteration* _tmp18_;
	Alteration* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 839 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 839 "../src/VideoSupport.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 840 "../src/VideoSupport.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 840 "../src/VideoSupport.vala"
	time_val = _tmp0_;
#line 7967 "VideoSupport.c"
	{
		{
			VideoRow* _tmp1_;
#line 843 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 843 "../src/VideoSupport.vala"
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 7975 "VideoSupport.c"
			{
				VideoRow* _tmp2_;
				time_t _tmp3_;
				GTimeVal _tmp4_;
				glong _tmp5_;
				VideoTable* _tmp7_;
				VideoTable* _tmp8_;
				VideoRow* _tmp9_;
				VideoID _tmp10_;
				GTimeVal _tmp11_;
				glong _tmp12_;
				VideoRow* _tmp13_;
				GTimeVal _tmp14_;
				glong _tmp15_;
#line 844 "../src/VideoSupport.vala"
				_tmp2_ = self->priv->backing_row;
#line 844 "../src/VideoSupport.vala"
				_tmp3_ = _tmp2_->timestamp;
#line 844 "../src/VideoSupport.vala"
				_tmp4_ = time_val;
#line 844 "../src/VideoSupport.vala"
				_tmp5_ = _tmp4_.tv_sec;
#line 844 "../src/VideoSupport.vala"
				if (_tmp3_ == ((time_t) _tmp5_)) {
#line 8000 "VideoSupport.c"
					{
						GError* _inner_error0_ = NULL;
						VideoRow* _tmp6_;
#line 843 "../src/VideoSupport.vala"
						_tmp6_ = self->priv->backing_row;
#line 843 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8008 "VideoSupport.c"
					}
#line 845 "../src/VideoSupport.vala"
					return;
#line 8012 "VideoSupport.c"
				}
#line 847 "../src/VideoSupport.vala"
				_tmp7_ = video_table_get_instance ();
#line 847 "../src/VideoSupport.vala"
				_tmp8_ = _tmp7_;
#line 847 "../src/VideoSupport.vala"
				_tmp9_ = self->priv->backing_row;
#line 847 "../src/VideoSupport.vala"
				_tmp10_ = _tmp9_->video_id;
#line 847 "../src/VideoSupport.vala"
				_tmp11_ = time_val;
#line 847 "../src/VideoSupport.vala"
				_tmp12_ = _tmp11_.tv_sec;
#line 847 "../src/VideoSupport.vala"
				video_table_set_timestamp (_tmp8_, &_tmp10_, (time_t) _tmp12_, &_inner_error0_);
#line 847 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp8_);
#line 847 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8032 "VideoSupport.c"
					goto __finally538;
				}
#line 848 "../src/VideoSupport.vala"
				_tmp13_ = self->priv->backing_row;
#line 848 "../src/VideoSupport.vala"
				_tmp14_ = time_val;
#line 848 "../src/VideoSupport.vala"
				_tmp15_ = _tmp14_.tv_sec;
#line 848 "../src/VideoSupport.vala"
				_tmp13_->timestamp = (time_t) _tmp15_;
#line 8043 "VideoSupport.c"
			}
			__finally538:
			{
				GError* _inner_error1_ = NULL;
				VideoRow* _tmp16_;
#line 843 "../src/VideoSupport.vala"
				_tmp16_ = self->priv->backing_row;
#line 843 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8053 "VideoSupport.c"
			}
#line 843 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "../src/VideoSupport.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 8059 "VideoSupport.c"
					goto __catch537_database_error;
				}
#line 843 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 843 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 843 "../src/VideoSupport.vala"
				return;
#line 8068 "VideoSupport.c"
			}
		}
	}
	goto __finally537;
	__catch537_database_error:
	{
		GError* err = NULL;
		GError* _tmp17_;
#line 842 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 842 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 851 "../src/VideoSupport.vala"
		_tmp17_ = err;
#line 851 "../src/VideoSupport.vala"
		app_window_database_error (_tmp17_);
#line 853 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 853 "../src/VideoSupport.vala"
		return;
#line 8089 "VideoSupport.c"
	}
	__finally537:
#line 842 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 842 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 842 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 842 "../src/VideoSupport.vala"
		return;
#line 8100 "VideoSupport.c"
	}
#line 856 "../src/VideoSupport.vala"
	_tmp18_ = alteration_new ("metadata", "master-timestamp");
#line 856 "../src/VideoSupport.vala"
	_tmp19_ = _tmp18_;
#line 856 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
#line 856 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp19_);
#line 8110 "VideoSupport.c"
}


gchar*
video_get_filename (Video* self)
{
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 859 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), NULL);
#line 8121 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 860 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 860 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8128 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 861 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 861 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->filepath;
#line 861 "../src/VideoSupport.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 861 "../src/VideoSupport.vala"
			result = _tmp3_;
#line 8141 "VideoSupport.c"
			{
				VideoRow* _tmp4_;
#line 860 "../src/VideoSupport.vala"
				_tmp4_ = self->priv->backing_row;
#line 860 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8148 "VideoSupport.c"
			}
#line 861 "../src/VideoSupport.vala"
			return result;
#line 8152 "VideoSupport.c"
		}
		__finally539:
		{
			VideoRow* _tmp5_;
#line 860 "../src/VideoSupport.vala"
			_tmp5_ = self->priv->backing_row;
#line 860 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8161 "VideoSupport.c"
		}
#line 860 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 860 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 860 "../src/VideoSupport.vala"
		return NULL;
#line 8169 "VideoSupport.c"
	}
}


static GFile*
video_real_get_file (MediaSource* base)
{
	Video * self;
	GFile* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 865 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 866 "../src/VideoSupport.vala"
	_tmp0_ = video_get_filename (self);
#line 866 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 866 "../src/VideoSupport.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 866 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 866 "../src/VideoSupport.vala"
	_g_free0 (_tmp1_);
#line 866 "../src/VideoSupport.vala"
	result = _tmp3_;
#line 866 "../src/VideoSupport.vala"
	return result;
#line 8199 "VideoSupport.c"
}


static GFile*
video_real_get_master_file (MediaSource* base)
{
	Video * self;
	GFile* result = NULL;
	GFile* _tmp0_;
#line 869 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 870 "../src/VideoSupport.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 870 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 870 "../src/VideoSupport.vala"
	return result;
#line 8217 "VideoSupport.c"
}


void
video_export (Video* self,
              GFile* dest_file,
              GError** error)
{
	GFile* source_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 873 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (self));
#line 873 "../src/VideoSupport.vala"
	g_return_if_fail (G_IS_FILE (dest_file));
#line 874 "../src/VideoSupport.vala"
	_tmp0_ = video_get_filename (self);
#line 874 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 874 "../src/VideoSupport.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 874 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 874 "../src/VideoSupport.vala"
	_g_free0 (_tmp1_);
#line 874 "../src/VideoSupport.vala"
	source_file = _tmp3_;
#line 875 "../src/VideoSupport.vala"
	g_file_copy (source_file, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 875 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 875 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 875 "../src/VideoSupport.vala"
		_g_object_unref0 (source_file);
#line 875 "../src/VideoSupport.vala"
		return;
#line 8258 "VideoSupport.c"
	}
#line 873 "../src/VideoSupport.vala"
	_g_object_unref0 (source_file);
#line 8262 "VideoSupport.c"
}


gdouble
video_get_clip_duration (Video* self)
{
	gdouble result = 0.0;
	GError* _inner_error0_ = NULL;
#line 879 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), 0.0);
#line 8273 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		gdouble _tmp5_ = -1.0;
#line 880 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 880 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8281 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			gdouble _tmp2_;
#line 881 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 881 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->clip_duration;
#line 881 "../src/VideoSupport.vala"
			result = _tmp2_;
#line 8291 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 880 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 880 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8298 "VideoSupport.c"
			}
#line 881 "../src/VideoSupport.vala"
			return result;
#line 8302 "VideoSupport.c"
		}
		__finally540:
		{
			VideoRow* _tmp4_;
#line 880 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 880 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8311 "VideoSupport.c"
		}
#line 880 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 880 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 880 "../src/VideoSupport.vala"
		return _tmp5_;
#line 8319 "VideoSupport.c"
	}
}


gboolean
video_get_is_interpretable (Video* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 885 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), FALSE);
#line 8331 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 886 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 886 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8339 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			gboolean _tmp2_;
#line 887 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 887 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->is_interpretable;
#line 887 "../src/VideoSupport.vala"
			result = _tmp2_;
#line 8349 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 886 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 886 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8356 "VideoSupport.c"
			}
#line 887 "../src/VideoSupport.vala"
			return result;
#line 8360 "VideoSupport.c"
		}
		__finally541:
		{
			VideoRow* _tmp4_;
#line 886 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 886 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8369 "VideoSupport.c"
		}
#line 886 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 886 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 886 "../src/VideoSupport.vala"
		return _tmp5_;
#line 8377 "VideoSupport.c"
	}
}


static void
video_set_is_interpretable (Video* self,
                            gboolean is_interpretable)
{
	GError* _inner_error0_ = NULL;
#line 891 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (self));
#line 8389 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 892 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 892 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8396 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			gboolean _tmp2_;
			VideoRow* _tmp4_;
#line 893 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 893 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->is_interpretable;
#line 893 "../src/VideoSupport.vala"
			if (_tmp2_ == is_interpretable) {
#line 8407 "VideoSupport.c"
				{
					VideoRow* _tmp3_;
#line 892 "../src/VideoSupport.vala"
					_tmp3_ = self->priv->backing_row;
#line 892 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8414 "VideoSupport.c"
				}
#line 894 "../src/VideoSupport.vala"
				return;
#line 8418 "VideoSupport.c"
			}
#line 896 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 896 "../src/VideoSupport.vala"
			_tmp4_->is_interpretable = is_interpretable;
#line 8424 "VideoSupport.c"
		}
		__finally542:
		{
			VideoRow* _tmp5_;
#line 892 "../src/VideoSupport.vala"
			_tmp5_ = self->priv->backing_row;
#line 892 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8433 "VideoSupport.c"
		}
#line 892 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 892 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 892 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 892 "../src/VideoSupport.vala"
			return;
#line 8443 "VideoSupport.c"
		}
	}
	{
		VideoTable* _tmp6_;
		VideoTable* _tmp7_;
		VideoID _tmp8_ = {0};
#line 900 "../src/VideoSupport.vala"
		_tmp6_ = video_table_get_instance ();
#line 900 "../src/VideoSupport.vala"
		_tmp7_ = _tmp6_;
#line 900 "../src/VideoSupport.vala"
		video_get_video_id (self, &_tmp8_);
#line 900 "../src/VideoSupport.vala"
		video_table_update_is_interpretable (_tmp7_, &_tmp8_, is_interpretable, &_inner_error0_);
#line 900 "../src/VideoSupport.vala"
		_database_table_unref0 (_tmp7_);
#line 900 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 900 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 8464 "VideoSupport.c"
				goto __catch543_database_error;
			}
#line 900 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 900 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 900 "../src/VideoSupport.vala"
			return;
#line 8473 "VideoSupport.c"
		}
	}
	goto __finally543;
	__catch543_database_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
#line 899 "../src/VideoSupport.vala"
		e = _inner_error0_;
#line 899 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 902 "../src/VideoSupport.vala"
		_tmp9_ = e;
#line 902 "../src/VideoSupport.vala"
		app_window_database_error (_tmp9_);
#line 899 "../src/VideoSupport.vala"
		_g_error_free0 (e);
#line 8491 "VideoSupport.c"
	}
	__finally543:
#line 899 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 899 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 899 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 899 "../src/VideoSupport.vala"
		return;
#line 8502 "VideoSupport.c"
	}
}


VideoInterpretableResults*
video_check_is_interpretable (Video* self)
{
	VideoInterpretableResults* result = NULL;
	VideoInterpretableResults* results = NULL;
	VideoInterpretableResults* _tmp0_;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* backing_file_reader = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	VideoReader* _tmp3_;
	VideoReader* _tmp4_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	VideoInterpretableResults* _tmp21_;
	VideoInterpretableResults* _tmp22_;
	VideoInterpretableResults* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 909 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), NULL);
#line 910 "../src/VideoSupport.vala"
	_tmp0_ = video_interpretable_results_new (self);
#line 910 "../src/VideoSupport.vala"
	results = _tmp0_;
#line 912 "../src/VideoSupport.vala"
	clip_duration = -1.0;
#line 913 "../src/VideoSupport.vala"
	preview_frame = NULL;
#line 915 "../src/VideoSupport.vala"
	_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 915 "../src/VideoSupport.vala"
	_tmp2_ = _tmp1_;
#line 915 "../src/VideoSupport.vala"
	_tmp3_ = video_reader_new (_tmp2_);
#line 915 "../src/VideoSupport.vala"
	_tmp4_ = _tmp3_;
#line 915 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp2_);
#line 915 "../src/VideoSupport.vala"
	backing_file_reader = _tmp4_;
#line 8552 "VideoSupport.c"
	{
		gdouble _tmp5_ = 0.0;
		VideoReader* _tmp6_;
		VideoReader* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 917 "../src/VideoSupport.vala"
		_tmp6_ = backing_file_reader;
#line 917 "../src/VideoSupport.vala"
		_tmp5_ = video_reader_read_clip_duration (_tmp6_, &_inner_error0_);
#line 917 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 917 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 8566 "VideoSupport.c"
				goto __catch544_video_error;
			}
#line 917 "../src/VideoSupport.vala"
			_video_reader_unref0 (backing_file_reader);
#line 917 "../src/VideoSupport.vala"
			_g_object_unref0 (preview_frame);
#line 917 "../src/VideoSupport.vala"
			_video_interpretable_results_unref0 (results);
#line 917 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 917 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 917 "../src/VideoSupport.vala"
			return NULL;
#line 8581 "VideoSupport.c"
		}
#line 917 "../src/VideoSupport.vala"
		clip_duration = _tmp5_;
#line 918 "../src/VideoSupport.vala"
		_tmp7_ = backing_file_reader;
#line 918 "../src/VideoSupport.vala"
		_tmp8_ = video_reader_read_preview_frame (_tmp7_);
#line 918 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 918 "../src/VideoSupport.vala"
		preview_frame = _tmp8_;
#line 8593 "VideoSupport.c"
	}
	goto __finally544;
	__catch544_video_error:
	{
		GError* e = NULL;
		VideoInterpretableResults* _tmp9_;
		VideoInterpretableResults* _tmp10_;
#line 916 "../src/VideoSupport.vala"
		e = _inner_error0_;
#line 916 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 922 "../src/VideoSupport.vala"
		_tmp9_ = results;
#line 922 "../src/VideoSupport.vala"
		_tmp9_->update_interpretable = video_get_is_interpretable (self);
#line 923 "../src/VideoSupport.vala"
		_tmp10_ = results;
#line 923 "../src/VideoSupport.vala"
		_tmp10_->is_interpretable = FALSE;
#line 925 "../src/VideoSupport.vala"
		result = results;
#line 925 "../src/VideoSupport.vala"
		_g_error_free0 (e);
#line 925 "../src/VideoSupport.vala"
		_video_reader_unref0 (backing_file_reader);
#line 925 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 925 "../src/VideoSupport.vala"
		return result;
#line 8623 "VideoSupport.c"
	}
	__finally544:
#line 916 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 916 "../src/VideoSupport.vala"
		_video_reader_unref0 (backing_file_reader);
#line 916 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 916 "../src/VideoSupport.vala"
		_video_interpretable_results_unref0 (results);
#line 916 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 916 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 916 "../src/VideoSupport.vala"
		return NULL;
#line 8640 "VideoSupport.c"
	}
#line 929 "../src/VideoSupport.vala"
	if (video_get_is_interpretable (self)) {
#line 8644 "VideoSupport.c"
		VideoInterpretableResults* _tmp11_;
		VideoInterpretableResults* _tmp12_;
#line 930 "../src/VideoSupport.vala"
		_tmp11_ = results;
#line 930 "../src/VideoSupport.vala"
		_tmp11_->update_interpretable = FALSE;
#line 931 "../src/VideoSupport.vala"
		_tmp12_ = results;
#line 931 "../src/VideoSupport.vala"
		_tmp12_->is_interpretable = TRUE;
#line 933 "../src/VideoSupport.vala"
		result = results;
#line 933 "../src/VideoSupport.vala"
		_video_reader_unref0 (backing_file_reader);
#line 933 "../src/VideoSupport.vala"
		_g_object_unref0 (preview_frame);
#line 933 "../src/VideoSupport.vala"
		return result;
#line 8663 "VideoSupport.c"
	}
#line 936 "../src/VideoSupport.vala"
	_tmp13_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 936 "../src/VideoSupport.vala"
	_tmp14_ = _tmp13_;
#line 936 "../src/VideoSupport.vala"
	_tmp15_ = g_file_get_basename (_tmp14_);
#line 936 "../src/VideoSupport.vala"
	_tmp16_ = _tmp15_;
#line 936 "../src/VideoSupport.vala"
	g_debug ("VideoSupport.vala:936: video %s has become interpretable", _tmp16_);
#line 936 "../src/VideoSupport.vala"
	_g_free0 (_tmp16_);
#line 936 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp14_);
#line 8679 "VideoSupport.c"
	{
		VideoRow* _tmp17_;
#line 939 "../src/VideoSupport.vala"
		_tmp17_ = self->priv->backing_row;
#line 939 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8686 "VideoSupport.c"
		{
			VideoRow* _tmp18_;
			gdouble _tmp19_;
#line 940 "../src/VideoSupport.vala"
			_tmp18_ = self->priv->backing_row;
#line 940 "../src/VideoSupport.vala"
			_tmp19_ = clip_duration;
#line 940 "../src/VideoSupport.vala"
			_tmp18_->clip_duration = _tmp19_;
#line 8696 "VideoSupport.c"
		}
		__finally545:
		{
			VideoRow* _tmp20_;
#line 939 "../src/VideoSupport.vala"
			_tmp20_ = self->priv->backing_row;
#line 939 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8705 "VideoSupport.c"
		}
#line 939 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 939 "../src/VideoSupport.vala"
			_video_reader_unref0 (backing_file_reader);
#line 939 "../src/VideoSupport.vala"
			_g_object_unref0 (preview_frame);
#line 939 "../src/VideoSupport.vala"
			_video_interpretable_results_unref0 (results);
#line 939 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 939 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 939 "../src/VideoSupport.vala"
			return NULL;
#line 8721 "VideoSupport.c"
		}
	}
#line 943 "../src/VideoSupport.vala"
	_tmp21_ = results;
#line 943 "../src/VideoSupport.vala"
	_tmp21_->update_interpretable = TRUE;
#line 944 "../src/VideoSupport.vala"
	_tmp22_ = results;
#line 944 "../src/VideoSupport.vala"
	_tmp22_->is_interpretable = TRUE;
#line 945 "../src/VideoSupport.vala"
	_tmp23_ = results;
#line 945 "../src/VideoSupport.vala"
	_tmp24_ = preview_frame;
#line 945 "../src/VideoSupport.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 945 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp23_->new_thumbnail);
#line 945 "../src/VideoSupport.vala"
	_tmp23_->new_thumbnail = _tmp25_;
#line 947 "../src/VideoSupport.vala"
	result = results;
#line 947 "../src/VideoSupport.vala"
	_video_reader_unref0 (backing_file_reader);
#line 947 "../src/VideoSupport.vala"
	_g_object_unref0 (preview_frame);
#line 947 "../src/VideoSupport.vala"
	return result;
#line 8750 "VideoSupport.c"
}


static void
video_real_destroy (DataSource* base)
{
	Video * self;
	VideoID video_id = {0};
	VideoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 950 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 951 "../src/VideoSupport.vala"
	video_get_video_id (self, &_tmp0_);
#line 951 "../src/VideoSupport.vala"
	video_id = _tmp0_;
#line 953 "../src/VideoSupport.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 8769 "VideoSupport.c"
	{
		VideoTable* _tmp1_;
		VideoTable* _tmp2_;
		VideoID _tmp3_;
#line 956 "../src/VideoSupport.vala"
		_tmp1_ = video_table_get_instance ();
#line 956 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 956 "../src/VideoSupport.vala"
		_tmp3_ = video_id;
#line 956 "../src/VideoSupport.vala"
		video_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 956 "../src/VideoSupport.vala"
		_database_table_unref0 (_tmp2_);
#line 956 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 956 "../src/VideoSupport.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 8788 "VideoSupport.c"
				goto __catch546_database_error;
			}
#line 956 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 956 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 956 "../src/VideoSupport.vala"
			return;
#line 8797 "VideoSupport.c"
		}
	}
	goto __finally546;
	__catch546_database_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 955 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 955 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 958 "../src/VideoSupport.vala"
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 958 "../src/VideoSupport.vala"
		_tmp5_ = _tmp4_;
#line 958 "../src/VideoSupport.vala"
		g_error ("VideoSupport.vala:958: failed to remove video %s from video table", _tmp5_);
#line 958 "../src/VideoSupport.vala"
		_g_free0 (_tmp5_);
#line 955 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 8820 "VideoSupport.c"
	}
	__finally546:
#line 955 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 955 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 955 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 955 "../src/VideoSupport.vala"
		return;
#line 8831 "VideoSupport.c"
	}
#line 961 "../src/VideoSupport.vala"
	DATA_SOURCE_CLASS (video_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_VIDEO_SOURCE, VideoSource), TYPE_DATA_SOURCE, DataSource));
#line 8835 "VideoSupport.c"
}


static gboolean
video_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Video * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 964 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 965 "../src/VideoSupport.vala"
	ret = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 968 "../src/VideoSupport.vala"
	_tmp1_ = DATA_SOURCE_CLASS (video_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_VIDEO_SOURCE, VideoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 968 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8857 "VideoSupport.c"
		gboolean _tmp2_ = FALSE;
#line 968 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 968 "../src/VideoSupport.vala"
		return _tmp2_;
#line 8863 "VideoSupport.c"
	}
#line 968 "../src/VideoSupport.vala"
	if (_tmp1_) {
#line 968 "../src/VideoSupport.vala"
		_tmp0_ = ret;
#line 8869 "VideoSupport.c"
	} else {
#line 968 "../src/VideoSupport.vala"
		_tmp0_ = FALSE;
#line 8873 "VideoSupport.c"
	}
#line 968 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 968 "../src/VideoSupport.vala"
	return result;
#line 8879 "VideoSupport.c"
}


static void
video_notify_flags_altered (Video* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 971 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (self));
#line 971 "../src/VideoSupport.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 972 "../src/VideoSupport.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 972 "../src/VideoSupport.vala"
	alteration = _tmp0_;
#line 973 "../src/VideoSupport.vala"
	if (additional_alteration != NULL) {
#line 8900 "VideoSupport.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 974 "../src/VideoSupport.vala"
		_tmp1_ = alteration;
#line 974 "../src/VideoSupport.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 974 "../src/VideoSupport.vala"
		_alteration_unref0 (alteration);
#line 974 "../src/VideoSupport.vala"
		alteration = _tmp2_;
#line 8911 "VideoSupport.c"
	}
#line 976 "../src/VideoSupport.vala"
	_tmp3_ = alteration;
#line 976 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 971 "../src/VideoSupport.vala"
	_alteration_unref0 (alteration);
#line 8919 "VideoSupport.c"
}


guint64
video_add_flags (Video* self,
                 guint64 flags_to_add,
                 Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 new_flags = 0ULL;
	GError* _inner_error0_ = NULL;
#line 979 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), 0ULL);
#line 979 "../src/VideoSupport.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 8935 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 981 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 8942 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			guint64 _tmp2_;
			VideoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
			VideoRow* _tmp21_;
			guint64 _tmp22_;
#line 982 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 982 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->flags;
#line 982 "../src/VideoSupport.vala"
			new_flags = media_source_internal_add_flags (_tmp2_, flags_to_add);
#line 983 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 983 "../src/VideoSupport.vala"
			_tmp4_ = _tmp3_->flags;
#line 983 "../src/VideoSupport.vala"
			_tmp5_ = new_flags;
#line 983 "../src/VideoSupport.vala"
			if (_tmp4_ == _tmp5_) {
#line 8965 "VideoSupport.c"
				VideoRow* _tmp6_;
				guint64 _tmp7_;
#line 984 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->backing_row;
#line 984 "../src/VideoSupport.vala"
				_tmp7_ = _tmp6_->flags;
#line 984 "../src/VideoSupport.vala"
				result = _tmp7_;
#line 8974 "VideoSupport.c"
				{
					VideoRow* _tmp8_;
#line 981 "../src/VideoSupport.vala"
					_tmp8_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 8981 "VideoSupport.c"
				}
#line 984 "../src/VideoSupport.vala"
				return result;
#line 8985 "VideoSupport.c"
			}
			{
				VideoTable* _tmp9_;
				VideoTable* _tmp10_;
				VideoID _tmp11_ = {0};
				guint64 _tmp12_;
#line 987 "../src/VideoSupport.vala"
				_tmp9_ = video_table_get_instance ();
#line 987 "../src/VideoSupport.vala"
				_tmp10_ = _tmp9_;
#line 987 "../src/VideoSupport.vala"
				video_get_video_id (self, &_tmp11_);
#line 987 "../src/VideoSupport.vala"
				_tmp12_ = new_flags;
#line 987 "../src/VideoSupport.vala"
				video_table_set_flags (_tmp10_, &_tmp11_, _tmp12_, &_inner_error0_);
#line 987 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp10_);
#line 987 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9006 "VideoSupport.c"
					guint64 _tmp14_ = 0ULL;
#line 987 "../src/VideoSupport.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 9010 "VideoSupport.c"
						goto __catch548_database_error;
					}
					{
						VideoRow* _tmp13_;
#line 981 "../src/VideoSupport.vala"
						_tmp13_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9019 "VideoSupport.c"
					}
#line 987 "../src/VideoSupport.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 987 "../src/VideoSupport.vala"
					g_clear_error (&_inner_error0_);
#line 987 "../src/VideoSupport.vala"
					return _tmp14_;
#line 9027 "VideoSupport.c"
				}
			}
			goto __finally548;
			__catch548_database_error:
			{
				GError* e = NULL;
				GError* _tmp15_;
				VideoRow* _tmp16_;
				guint64 _tmp17_;
#line 986 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 986 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 989 "../src/VideoSupport.vala"
				_tmp15_ = e;
#line 989 "../src/VideoSupport.vala"
				app_window_database_error (_tmp15_);
#line 990 "../src/VideoSupport.vala"
				_tmp16_ = self->priv->backing_row;
#line 990 "../src/VideoSupport.vala"
				_tmp17_ = _tmp16_->flags;
#line 990 "../src/VideoSupport.vala"
				result = _tmp17_;
#line 990 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 9053 "VideoSupport.c"
				{
					VideoRow* _tmp18_;
#line 981 "../src/VideoSupport.vala"
					_tmp18_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9060 "VideoSupport.c"
				}
#line 990 "../src/VideoSupport.vala"
				return result;
#line 9064 "VideoSupport.c"
			}
			__finally548:
#line 986 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9069 "VideoSupport.c"
				guint64 _tmp20_ = 0ULL;
				{
					VideoRow* _tmp19_;
#line 981 "../src/VideoSupport.vala"
					_tmp19_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9077 "VideoSupport.c"
				}
#line 986 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 986 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 986 "../src/VideoSupport.vala"
				return _tmp20_;
#line 9085 "VideoSupport.c"
			}
#line 993 "../src/VideoSupport.vala"
			_tmp21_ = self->priv->backing_row;
#line 993 "../src/VideoSupport.vala"
			_tmp22_ = new_flags;
#line 993 "../src/VideoSupport.vala"
			_tmp21_->flags = _tmp22_;
#line 9093 "VideoSupport.c"
		}
		__finally547:
		{
			VideoRow* _tmp23_;
#line 981 "../src/VideoSupport.vala"
			_tmp23_ = self->priv->backing_row;
#line 981 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9102 "VideoSupport.c"
		}
#line 981 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9106 "VideoSupport.c"
			guint64 _tmp24_ = 0ULL;
#line 981 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 981 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 981 "../src/VideoSupport.vala"
			return _tmp24_;
#line 9114 "VideoSupport.c"
		}
	}
#line 996 "../src/VideoSupport.vala"
	video_notify_flags_altered (self, additional_alteration);
#line 998 "../src/VideoSupport.vala"
	result = new_flags;
#line 998 "../src/VideoSupport.vala"
	return result;
#line 9123 "VideoSupport.c"
}


guint64
video_remove_flags (Video* self,
                    guint64 flags_to_remove,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 new_flags = 0ULL;
	GError* _inner_error0_ = NULL;
#line 1001 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), 0ULL);
#line 1001 "../src/VideoSupport.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 9139 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
#line 1003 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 9146 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			guint64 _tmp2_;
			VideoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
			VideoRow* _tmp21_;
			guint64 _tmp22_;
#line 1004 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 1004 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->flags;
#line 1004 "../src/VideoSupport.vala"
			new_flags = media_source_internal_remove_flags (_tmp2_, flags_to_remove);
#line 1005 "../src/VideoSupport.vala"
			_tmp3_ = self->priv->backing_row;
#line 1005 "../src/VideoSupport.vala"
			_tmp4_ = _tmp3_->flags;
#line 1005 "../src/VideoSupport.vala"
			_tmp5_ = new_flags;
#line 1005 "../src/VideoSupport.vala"
			if (_tmp4_ == _tmp5_) {
#line 9169 "VideoSupport.c"
				VideoRow* _tmp6_;
				guint64 _tmp7_;
#line 1006 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->backing_row;
#line 1006 "../src/VideoSupport.vala"
				_tmp7_ = _tmp6_->flags;
#line 1006 "../src/VideoSupport.vala"
				result = _tmp7_;
#line 9178 "VideoSupport.c"
				{
					VideoRow* _tmp8_;
#line 1003 "../src/VideoSupport.vala"
					_tmp8_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9185 "VideoSupport.c"
				}
#line 1006 "../src/VideoSupport.vala"
				return result;
#line 9189 "VideoSupport.c"
			}
			{
				VideoTable* _tmp9_;
				VideoTable* _tmp10_;
				VideoID _tmp11_ = {0};
				guint64 _tmp12_;
#line 1009 "../src/VideoSupport.vala"
				_tmp9_ = video_table_get_instance ();
#line 1009 "../src/VideoSupport.vala"
				_tmp10_ = _tmp9_;
#line 1009 "../src/VideoSupport.vala"
				video_get_video_id (self, &_tmp11_);
#line 1009 "../src/VideoSupport.vala"
				_tmp12_ = new_flags;
#line 1009 "../src/VideoSupport.vala"
				video_table_set_flags (_tmp10_, &_tmp11_, _tmp12_, &_inner_error0_);
#line 1009 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp10_);
#line 1009 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9210 "VideoSupport.c"
					guint64 _tmp14_ = 0ULL;
#line 1009 "../src/VideoSupport.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 9214 "VideoSupport.c"
						goto __catch550_database_error;
					}
					{
						VideoRow* _tmp13_;
#line 1003 "../src/VideoSupport.vala"
						_tmp13_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9223 "VideoSupport.c"
					}
#line 1009 "../src/VideoSupport.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1009 "../src/VideoSupport.vala"
					g_clear_error (&_inner_error0_);
#line 1009 "../src/VideoSupport.vala"
					return _tmp14_;
#line 9231 "VideoSupport.c"
				}
			}
			goto __finally550;
			__catch550_database_error:
			{
				GError* e = NULL;
				GError* _tmp15_;
				VideoRow* _tmp16_;
				guint64 _tmp17_;
#line 1008 "../src/VideoSupport.vala"
				e = _inner_error0_;
#line 1008 "../src/VideoSupport.vala"
				_inner_error0_ = NULL;
#line 1011 "../src/VideoSupport.vala"
				_tmp15_ = e;
#line 1011 "../src/VideoSupport.vala"
				app_window_database_error (_tmp15_);
#line 1012 "../src/VideoSupport.vala"
				_tmp16_ = self->priv->backing_row;
#line 1012 "../src/VideoSupport.vala"
				_tmp17_ = _tmp16_->flags;
#line 1012 "../src/VideoSupport.vala"
				result = _tmp17_;
#line 1012 "../src/VideoSupport.vala"
				_g_error_free0 (e);
#line 9257 "VideoSupport.c"
				{
					VideoRow* _tmp18_;
#line 1003 "../src/VideoSupport.vala"
					_tmp18_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9264 "VideoSupport.c"
				}
#line 1012 "../src/VideoSupport.vala"
				return result;
#line 9268 "VideoSupport.c"
			}
			__finally550:
#line 1008 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9273 "VideoSupport.c"
				guint64 _tmp20_ = 0ULL;
				{
					VideoRow* _tmp19_;
#line 1003 "../src/VideoSupport.vala"
					_tmp19_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9281 "VideoSupport.c"
				}
#line 1008 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1008 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 1008 "../src/VideoSupport.vala"
				return _tmp20_;
#line 9289 "VideoSupport.c"
			}
#line 1015 "../src/VideoSupport.vala"
			_tmp21_ = self->priv->backing_row;
#line 1015 "../src/VideoSupport.vala"
			_tmp22_ = new_flags;
#line 1015 "../src/VideoSupport.vala"
			_tmp21_->flags = _tmp22_;
#line 9297 "VideoSupport.c"
		}
		__finally549:
		{
			VideoRow* _tmp23_;
#line 1003 "../src/VideoSupport.vala"
			_tmp23_ = self->priv->backing_row;
#line 1003 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9306 "VideoSupport.c"
		}
#line 1003 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9310 "VideoSupport.c"
			guint64 _tmp24_ = 0ULL;
#line 1003 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1003 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 1003 "../src/VideoSupport.vala"
			return _tmp24_;
#line 9318 "VideoSupport.c"
		}
	}
#line 1018 "../src/VideoSupport.vala"
	video_notify_flags_altered (self, additional_alteration);
#line 1020 "../src/VideoSupport.vala"
	result = new_flags;
#line 1020 "../src/VideoSupport.vala"
	return result;
#line 9327 "VideoSupport.c"
}


gboolean
video_is_flag_set (Video* self,
                   guint64 flag)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1023 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), FALSE);
#line 9339 "VideoSupport.c"
	{
		VideoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1024 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->backing_row;
#line 1024 "../src/VideoSupport.vala"
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 9347 "VideoSupport.c"
		{
			VideoRow* _tmp1_;
			guint64 _tmp2_;
#line 1025 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 1025 "../src/VideoSupport.vala"
			_tmp2_ = _tmp1_->flags;
#line 1025 "../src/VideoSupport.vala"
			result = media_source_internal_is_flag_set (_tmp2_, flag);
#line 9357 "VideoSupport.c"
			{
				VideoRow* _tmp3_;
#line 1024 "../src/VideoSupport.vala"
				_tmp3_ = self->priv->backing_row;
#line 1024 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9364 "VideoSupport.c"
			}
#line 1025 "../src/VideoSupport.vala"
			return result;
#line 9368 "VideoSupport.c"
		}
		__finally551:
		{
			VideoRow* _tmp4_;
#line 1024 "../src/VideoSupport.vala"
			_tmp4_ = self->priv->backing_row;
#line 1024 "../src/VideoSupport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9377 "VideoSupport.c"
		}
#line 1024 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1024 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 1024 "../src/VideoSupport.vala"
		return _tmp5_;
#line 9385 "VideoSupport.c"
	}
}


static void
video_real_set_master_file (Monitorable* base,
                            GFile* file)
{
	Video * self;
	gchar* new_filepath = NULL;
	gchar* _tmp0_;
	gchar* old_filepath = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	Alteration* _tmp23_;
	Alteration* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 1029 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
#line 1029 "../src/VideoSupport.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1030 "../src/VideoSupport.vala"
	_tmp0_ = g_file_get_path (file);
#line 1030 "../src/VideoSupport.vala"
	new_filepath = _tmp0_;
#line 1031 "../src/VideoSupport.vala"
	old_filepath = NULL;
#line 9415 "VideoSupport.c"
	{
		{
			VideoRow* _tmp1_;
#line 1033 "../src/VideoSupport.vala"
			_tmp1_ = self->priv->backing_row;
#line 1033 "../src/VideoSupport.vala"
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
#line 9423 "VideoSupport.c"
			{
				VideoRow* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				VideoRow* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				VideoTable* _tmp9_;
				VideoTable* _tmp10_;
				VideoRow* _tmp11_;
				VideoID _tmp12_;
				const gchar* _tmp13_;
				VideoRow* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 1034 "../src/VideoSupport.vala"
				_tmp2_ = self->priv->backing_row;
#line 1034 "../src/VideoSupport.vala"
				_tmp3_ = _tmp2_->filepath;
#line 1034 "../src/VideoSupport.vala"
				_tmp4_ = new_filepath;
#line 1034 "../src/VideoSupport.vala"
				if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 9447 "VideoSupport.c"
					{
						GError* _inner_error0_ = NULL;
						VideoRow* _tmp5_;
#line 1033 "../src/VideoSupport.vala"
						_tmp5_ = self->priv->backing_row;
#line 1033 "../src/VideoSupport.vala"
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9455 "VideoSupport.c"
					}
#line 1035 "../src/VideoSupport.vala"
					_g_free0 (old_filepath);
#line 1035 "../src/VideoSupport.vala"
					_g_free0 (new_filepath);
#line 1035 "../src/VideoSupport.vala"
					return;
#line 9463 "VideoSupport.c"
				}
#line 1037 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->backing_row;
#line 1037 "../src/VideoSupport.vala"
				_tmp7_ = _tmp6_->filepath;
#line 1037 "../src/VideoSupport.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 1037 "../src/VideoSupport.vala"
				_g_free0 (old_filepath);
#line 1037 "../src/VideoSupport.vala"
				old_filepath = _tmp8_;
#line 1039 "../src/VideoSupport.vala"
				_tmp9_ = video_table_get_instance ();
#line 1039 "../src/VideoSupport.vala"
				_tmp10_ = _tmp9_;
#line 1039 "../src/VideoSupport.vala"
				_tmp11_ = self->priv->backing_row;
#line 1039 "../src/VideoSupport.vala"
				_tmp12_ = _tmp11_->video_id;
#line 1039 "../src/VideoSupport.vala"
				_tmp13_ = new_filepath;
#line 1039 "../src/VideoSupport.vala"
				video_table_set_filepath (_tmp10_, &_tmp12_, _tmp13_, &_inner_error0_);
#line 1039 "../src/VideoSupport.vala"
				_database_table_unref0 (_tmp10_);
#line 1039 "../src/VideoSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9491 "VideoSupport.c"
					goto __finally553;
				}
#line 1040 "../src/VideoSupport.vala"
				_tmp14_ = self->priv->backing_row;
#line 1040 "../src/VideoSupport.vala"
				_tmp15_ = new_filepath;
#line 1040 "../src/VideoSupport.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 1040 "../src/VideoSupport.vala"
				_g_free0 (_tmp14_->filepath);
#line 1040 "../src/VideoSupport.vala"
				_tmp14_->filepath = _tmp16_;
#line 9504 "VideoSupport.c"
			}
			__finally553:
			{
				GError* _inner_error1_ = NULL;
				VideoRow* _tmp17_;
#line 1033 "../src/VideoSupport.vala"
				_tmp17_ = self->priv->backing_row;
#line 1033 "../src/VideoSupport.vala"
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
#line 9514 "VideoSupport.c"
			}
#line 1033 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1033 "../src/VideoSupport.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 9520 "VideoSupport.c"
					goto __catch552_database_error;
				}
#line 1033 "../src/VideoSupport.vala"
				_g_free0 (old_filepath);
#line 1033 "../src/VideoSupport.vala"
				_g_free0 (new_filepath);
#line 1033 "../src/VideoSupport.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1033 "../src/VideoSupport.vala"
				g_clear_error (&_inner_error0_);
#line 1033 "../src/VideoSupport.vala"
				return;
#line 9533 "VideoSupport.c"
			}
		}
	}
	goto __finally552;
	__catch552_database_error:
	{
		GError* err = NULL;
		GError* _tmp18_;
#line 1032 "../src/VideoSupport.vala"
		err = _inner_error0_;
#line 1032 "../src/VideoSupport.vala"
		_inner_error0_ = NULL;
#line 1043 "../src/VideoSupport.vala"
		_tmp18_ = err;
#line 1043 "../src/VideoSupport.vala"
		app_window_database_error (_tmp18_);
#line 1045 "../src/VideoSupport.vala"
		_g_error_free0 (err);
#line 1045 "../src/VideoSupport.vala"
		_g_free0 (old_filepath);
#line 1045 "../src/VideoSupport.vala"
		_g_free0 (new_filepath);
#line 1045 "../src/VideoSupport.vala"
		return;
#line 9558 "VideoSupport.c"
	}
	__finally552:
#line 1032 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1032 "../src/VideoSupport.vala"
		_g_free0 (old_filepath);
#line 1032 "../src/VideoSupport.vala"
		_g_free0 (new_filepath);
#line 1032 "../src/VideoSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1032 "../src/VideoSupport.vala"
		g_clear_error (&_inner_error0_);
#line 1032 "../src/VideoSupport.vala"
		return;
#line 9573 "VideoSupport.c"
	}
#line 1048 "../src/VideoSupport.vala"
	_tmp19_ = old_filepath;
#line 1048 "../src/VideoSupport.vala"
	_vala_assert (_tmp19_ != NULL, "old_filepath != null");
#line 1049 "../src/VideoSupport.vala"
	_tmp20_ = old_filepath;
#line 1049 "../src/VideoSupport.vala"
	_tmp21_ = g_file_new_for_path (_tmp20_);
#line 1049 "../src/VideoSupport.vala"
	_tmp22_ = _tmp21_;
#line 1049 "../src/VideoSupport.vala"
	media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp22_, file);
#line 1049 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp22_);
#line 1051 "../src/VideoSupport.vala"
	_tmp23_ = alteration_new_from_list ("backing:master,metadata:name");
#line 1051 "../src/VideoSupport.vala"
	_tmp24_ = _tmp23_;
#line 1051 "../src/VideoSupport.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp24_);
#line 1051 "../src/VideoSupport.vala"
	_alteration_unref0 (_tmp24_);
#line 1029 "../src/VideoSupport.vala"
	_g_free0 (old_filepath);
#line 1029 "../src/VideoSupport.vala"
	_g_free0 (new_filepath);
#line 9601 "VideoSupport.c"
}


VideoMetadata*
video_read_metadata (Video* self,
                     GError** error)
{
	VideoMetadata* result = NULL;
	VideoMetadata* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	VideoReader* _tmp3_;
	VideoReader* _tmp4_;
	VideoMetadata* _tmp5_;
	VideoMetadata* _tmp6_;
	VideoMetadata* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1054 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (self), NULL);
#line 1055 "../src/VideoSupport.vala"
	_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1055 "../src/VideoSupport.vala"
	_tmp2_ = _tmp1_;
#line 1055 "../src/VideoSupport.vala"
	_tmp3_ = video_reader_new (_tmp2_);
#line 1055 "../src/VideoSupport.vala"
	_tmp4_ = _tmp3_;
#line 1055 "../src/VideoSupport.vala"
	_tmp5_ = video_reader_read_metadata (_tmp4_, &_inner_error0_);
#line 1055 "../src/VideoSupport.vala"
	_tmp6_ = _tmp5_;
#line 1055 "../src/VideoSupport.vala"
	_video_reader_unref0 (_tmp4_);
#line 1055 "../src/VideoSupport.vala"
	_g_object_unref0 (_tmp2_);
#line 1055 "../src/VideoSupport.vala"
	_tmp0_ = _tmp6_;
#line 1055 "../src/VideoSupport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1055 "../src/VideoSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 1055 "../src/VideoSupport.vala"
		return NULL;
#line 9645 "VideoSupport.c"
	}
#line 1055 "../src/VideoSupport.vala"
	_tmp7_ = _tmp0_;
#line 1055 "../src/VideoSupport.vala"
	_tmp0_ = NULL;
#line 1055 "../src/VideoSupport.vala"
	result = _tmp7_;
#line 1055 "../src/VideoSupport.vala"
	_media_metadata_unref0 (_tmp0_);
#line 1055 "../src/VideoSupport.vala"
	return result;
#line 9657 "VideoSupport.c"
}


VideoInterpretableResults*
video_interpretable_results_construct (GType object_type,
                                       Video* video)
{
	VideoInterpretableResults* self = NULL;
	Video* _tmp0_;
#line 340 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO (video), NULL);
#line 340 "../src/VideoSupport.vala"
	self = (VideoInterpretableResults*) g_type_create_instance (object_type);
#line 341 "../src/VideoSupport.vala"
	_tmp0_ = _g_object_ref0 (video);
#line 341 "../src/VideoSupport.vala"
	_g_object_unref0 (self->video);
#line 341 "../src/VideoSupport.vala"
	self->video = _tmp0_;
#line 340 "../src/VideoSupport.vala"
	return self;
#line 9679 "VideoSupport.c"
}


VideoInterpretableResults*
video_interpretable_results_new (Video* video)
{
#line 340 "../src/VideoSupport.vala"
	return video_interpretable_results_construct (VIDEO_TYPE_INTERPRETABLE_RESULTS, video);
#line 9688 "VideoSupport.c"
}


void
video_interpretable_results_foreground_finish (VideoInterpretableResults* self)
{
	gboolean _tmp0_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 344 "../src/VideoSupport.vala"
	g_return_if_fail (VIDEO_IS_INTERPRETABLE_RESULTS (self));
#line 345 "../src/VideoSupport.vala"
	_tmp0_ = self->update_interpretable;
#line 345 "../src/VideoSupport.vala"
	if (_tmp0_) {
#line 9704 "VideoSupport.c"
		Video* _tmp1_;
		gboolean _tmp2_;
#line 346 "../src/VideoSupport.vala"
		_tmp1_ = self->video;
#line 346 "../src/VideoSupport.vala"
		_tmp2_ = self->is_interpretable;
#line 346 "../src/VideoSupport.vala"
		video_set_is_interpretable (_tmp1_, _tmp2_);
#line 9713 "VideoSupport.c"
	}
#line 348 "../src/VideoSupport.vala"
	_tmp3_ = self->new_thumbnail;
#line 348 "../src/VideoSupport.vala"
	if (_tmp3_ != NULL) {
#line 9719 "VideoSupport.c"
		{
			Video* _tmp4_;
			GdkPixbuf* _tmp5_;
			Video* _tmp6_;
			GdkPixbuf* _tmp7_;
			Video* _tmp8_;
#line 350 "../src/VideoSupport.vala"
			_tmp4_ = self->video;
#line 350 "../src/VideoSupport.vala"
			_tmp5_ = self->new_thumbnail;
#line 350 "../src/VideoSupport.vala"
			thumbnail_cache_replace (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), THUMBNAIL_CACHE_SIZE_BIG, _tmp5_, &_inner_error0_);
#line 350 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9734 "VideoSupport.c"
				goto __catch554_g_error;
			}
#line 351 "../src/VideoSupport.vala"
			_tmp6_ = self->video;
#line 351 "../src/VideoSupport.vala"
			_tmp7_ = self->new_thumbnail;
#line 351 "../src/VideoSupport.vala"
			thumbnail_cache_replace (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), THUMBNAIL_CACHE_SIZE_MEDIUM, _tmp7_, &_inner_error0_);
#line 351 "../src/VideoSupport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9745 "VideoSupport.c"
				goto __catch554_g_error;
			}
#line 353 "../src/VideoSupport.vala"
			_tmp8_ = self->video;
#line 353 "../src/VideoSupport.vala"
			thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 9752 "VideoSupport.c"
		}
		goto __finally554;
		__catch554_g_error:
		{
			GError* err = NULL;
			Video* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 349 "../src/VideoSupport.vala"
			err = _inner_error0_;
#line 349 "../src/VideoSupport.vala"
			_inner_error0_ = NULL;
#line 355 "../src/VideoSupport.vala"
			_tmp9_ = self->video;
#line 355 "../src/VideoSupport.vala"
			_tmp10_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_DATA_OBJECT, DataObject));
#line 355 "../src/VideoSupport.vala"
			_tmp11_ = _tmp10_;
#line 355 "../src/VideoSupport.vala"
			_tmp12_ = err;
#line 355 "../src/VideoSupport.vala"
			_tmp13_ = _tmp12_->message;
#line 355 "../src/VideoSupport.vala"
			g_message ("VideoSupport.vala:355: Unable to update video thumbnails for %s: %s", _tmp11_, _tmp13_);
#line 355 "../src/VideoSupport.vala"
			_g_free0 (_tmp11_);
#line 349 "../src/VideoSupport.vala"
			_g_error_free0 (err);
#line 9783 "VideoSupport.c"
		}
		__finally554:
#line 349 "../src/VideoSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "../src/VideoSupport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 349 "../src/VideoSupport.vala"
			g_clear_error (&_inner_error0_);
#line 349 "../src/VideoSupport.vala"
			return;
#line 9794 "VideoSupport.c"
		}
	}
}


static void
video_value_interpretable_results_init (GValue* value)
{
#line 334 "../src/VideoSupport.vala"
	value->data[0].v_pointer = NULL;
#line 9805 "VideoSupport.c"
}


static void
video_value_interpretable_results_free_value (GValue* value)
{
#line 334 "../src/VideoSupport.vala"
	if (value->data[0].v_pointer) {
#line 334 "../src/VideoSupport.vala"
		video_interpretable_results_unref (value->data[0].v_pointer);
#line 9816 "VideoSupport.c"
	}
}


static void
video_value_interpretable_results_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 334 "../src/VideoSupport.vala"
	if (src_value->data[0].v_pointer) {
#line 334 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = video_interpretable_results_ref (src_value->data[0].v_pointer);
#line 9829 "VideoSupport.c"
	} else {
#line 334 "../src/VideoSupport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9833 "VideoSupport.c"
	}
}


static gpointer
video_value_interpretable_results_peek_pointer (const GValue* value)
{
#line 334 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 9843 "VideoSupport.c"
}


static gchar*
video_value_interpretable_results_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 334 "../src/VideoSupport.vala"
	if (collect_values[0].v_pointer) {
#line 9855 "VideoSupport.c"
		VideoInterpretableResults * object;
		object = collect_values[0].v_pointer;
#line 334 "../src/VideoSupport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 334 "../src/VideoSupport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9862 "VideoSupport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 334 "../src/VideoSupport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9866 "VideoSupport.c"
		}
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = video_interpretable_results_ref (object);
#line 9870 "VideoSupport.c"
	} else {
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 9874 "VideoSupport.c"
	}
#line 334 "../src/VideoSupport.vala"
	return NULL;
#line 9878 "VideoSupport.c"
}


static gchar*
video_value_interpretable_results_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	VideoInterpretableResults ** object_p;
	object_p = collect_values[0].v_pointer;
#line 334 "../src/VideoSupport.vala"
	if (!object_p) {
#line 334 "../src/VideoSupport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9894 "VideoSupport.c"
	}
#line 334 "../src/VideoSupport.vala"
	if (!value->data[0].v_pointer) {
#line 334 "../src/VideoSupport.vala"
		*object_p = NULL;
#line 9900 "VideoSupport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 334 "../src/VideoSupport.vala"
		*object_p = value->data[0].v_pointer;
#line 9904 "VideoSupport.c"
	} else {
#line 334 "../src/VideoSupport.vala"
		*object_p = video_interpretable_results_ref (value->data[0].v_pointer);
#line 9908 "VideoSupport.c"
	}
#line 334 "../src/VideoSupport.vala"
	return NULL;
#line 9912 "VideoSupport.c"
}


GParamSpec*
video_param_spec_interpretable_results (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	VideoParamSpecInterpretableResults* spec;
#line 334 "../src/VideoSupport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIDEO_TYPE_INTERPRETABLE_RESULTS), NULL);
#line 334 "../src/VideoSupport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 334 "../src/VideoSupport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 334 "../src/VideoSupport.vala"
	return G_PARAM_SPEC (spec);
#line 9932 "VideoSupport.c"
}


gpointer
video_value_get_interpretable_results (const GValue* value)
{
#line 334 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS), NULL);
#line 334 "../src/VideoSupport.vala"
	return value->data[0].v_pointer;
#line 9943 "VideoSupport.c"
}


void
video_value_set_interpretable_results (GValue* value,
                                       gpointer v_object)
{
	VideoInterpretableResults * old;
#line 334 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS));
#line 334 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 334 "../src/VideoSupport.vala"
	if (v_object) {
#line 334 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIDEO_TYPE_INTERPRETABLE_RESULTS));
#line 334 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 334 "../src/VideoSupport.vala"
		video_interpretable_results_ref (value->data[0].v_pointer);
#line 9966 "VideoSupport.c"
	} else {
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 9970 "VideoSupport.c"
	}
#line 334 "../src/VideoSupport.vala"
	if (old) {
#line 334 "../src/VideoSupport.vala"
		video_interpretable_results_unref (old);
#line 9976 "VideoSupport.c"
	}
}


void
video_value_take_interpretable_results (GValue* value,
                                        gpointer v_object)
{
	VideoInterpretableResults * old;
#line 334 "../src/VideoSupport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS));
#line 334 "../src/VideoSupport.vala"
	old = value->data[0].v_pointer;
#line 334 "../src/VideoSupport.vala"
	if (v_object) {
#line 334 "../src/VideoSupport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIDEO_TYPE_INTERPRETABLE_RESULTS));
#line 334 "../src/VideoSupport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = v_object;
#line 9998 "VideoSupport.c"
	} else {
#line 334 "../src/VideoSupport.vala"
		value->data[0].v_pointer = NULL;
#line 10002 "VideoSupport.c"
	}
#line 334 "../src/VideoSupport.vala"
	if (old) {
#line 334 "../src/VideoSupport.vala"
		video_interpretable_results_unref (old);
#line 10008 "VideoSupport.c"
	}
}


static void
video_interpretable_results_class_init (VideoInterpretableResultsClass * klass)
{
#line 334 "../src/VideoSupport.vala"
	video_interpretable_results_parent_class = g_type_class_peek_parent (klass);
#line 334 "../src/VideoSupport.vala"
	((VideoInterpretableResultsClass *) klass)->finalize = video_interpretable_results_finalize;
#line 10020 "VideoSupport.c"
}


static void
video_interpretable_results_instance_init (VideoInterpretableResults * self)
{
#line 336 "../src/VideoSupport.vala"
	self->update_interpretable = FALSE;
#line 337 "../src/VideoSupport.vala"
	self->is_interpretable = FALSE;
#line 338 "../src/VideoSupport.vala"
	self->new_thumbnail = NULL;
#line 334 "../src/VideoSupport.vala"
	self->ref_count = 1;
#line 10035 "VideoSupport.c"
}


static void
video_interpretable_results_finalize (VideoInterpretableResults * obj)
{
	VideoInterpretableResults * self;
#line 334 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResults);
#line 334 "../src/VideoSupport.vala"
	g_signal_handlers_destroy (self);
#line 335 "../src/VideoSupport.vala"
	_g_object_unref0 (self->video);
#line 338 "../src/VideoSupport.vala"
	_g_object_unref0 (self->new_thumbnail);
#line 10051 "VideoSupport.c"
}


GType
video_interpretable_results_get_type (void)
{
	static volatile gsize video_interpretable_results_type_id__volatile = 0;
	if (g_once_init_enter (&video_interpretable_results_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { video_value_interpretable_results_init, video_value_interpretable_results_free_value, video_value_interpretable_results_copy_value, video_value_interpretable_results_peek_pointer, "p", video_value_interpretable_results_collect_value, "p", video_value_interpretable_results_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoInterpretableResultsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_interpretable_results_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoInterpretableResults), 0, (GInstanceInitFunc) video_interpretable_results_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_interpretable_results_type_id;
		video_interpretable_results_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoInterpretableResults", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_interpretable_results_type_id__volatile, video_interpretable_results_type_id);
	}
	return video_interpretable_results_type_id__volatile;
}


gpointer
video_interpretable_results_ref (gpointer instance)
{
	VideoInterpretableResults * self;
	self = instance;
#line 334 "../src/VideoSupport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 334 "../src/VideoSupport.vala"
	return instance;
#line 10080 "VideoSupport.c"
}


void
video_interpretable_results_unref (gpointer instance)
{
	VideoInterpretableResults * self;
	self = instance;
#line 334 "../src/VideoSupport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 334 "../src/VideoSupport.vala"
		VIDEO_INTERPRETABLE_RESULTS_GET_CLASS (self)->finalize (self);
#line 334 "../src/VideoSupport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 10095 "VideoSupport.c"
	}
}


static void
video_class_init (VideoClass * klass)
{
#line 327 "../src/VideoSupport.vala"
	video_parent_class = g_type_class_peek_parent (klass);
#line 327 "../src/VideoSupport.vala"
	g_type_class_adjust_private_offset (klass, &Video_private_offset);
#line 327 "../src/VideoSupport.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) video_real_commit_backlinks;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) video_real_set_event_id;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, int*)) video_real_get_backing_files_state;
#line 327 "../src/VideoSupport.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_real_get_thumbnail;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) video_real_get_master_md5;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) video_real_get_preview_pixbuf;
#line 327 "../src/VideoSupport.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_real_create_thumbnail;
#line 327 "../src/VideoSupport.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) video_real_get_typename;
#line 327 "../src/VideoSupport.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) video_real_get_instance_id;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) video_real_get_import_id;
#line 327 "../src/VideoSupport.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) video_real_get_preferred_thumbnail_format;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) video_real_get_title;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) video_real_set_title;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) video_real_get_comment;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) video_real_set_comment;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) video_real_get_rating;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) video_real_set_rating;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) video_real_increase_rating;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) video_real_decrease_rating;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) video_real_is_trashed;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) video_real_is_offline;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) video_real_mark_offline;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) video_real_mark_online;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) video_real_trash;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) video_real_untrash;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) video_real_get_event_id;
#line 327 "../src/VideoSupport.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) video_real_to_string;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) video_real_get_exposure_time;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) video_real_get_dimensions;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) video_real_get_filesize;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) video_real_get_master_filesize;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) video_real_get_timestamp;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) video_real_get_file;
#line 327 "../src/VideoSupport.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) video_real_get_master_file;
#line 327 "../src/VideoSupport.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) video_real_destroy;
#line 327 "../src/VideoSupport.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) video_real_internal_delete_backing;
#line 327 "../src/VideoSupport.vala"
	G_OBJECT_CLASS (klass)->finalize = video_finalize;
#line 10181 "VideoSupport.c"
}


static void
video_flaggable_interface_init (FlaggableIface * iface)
{
#line 327 "../src/VideoSupport.vala"
	video_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 327 "../src/VideoSupport.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) video_real_is_flagged;
#line 327 "../src/VideoSupport.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) video_real_mark_flagged;
#line 327 "../src/VideoSupport.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) video_real_mark_unflagged;
#line 10196 "VideoSupport.c"
}


static void
video_monitorable_interface_init (MonitorableIface * iface)
{
#line 327 "../src/VideoSupport.vala"
	video_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 327 "../src/VideoSupport.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) video_real_is_offline;
#line 327 "../src/VideoSupport.vala"
	iface->mark_offline = (void (*) (Monitorable*)) video_real_mark_offline;
#line 327 "../src/VideoSupport.vala"
	iface->mark_online = (void (*) (Monitorable*)) video_real_mark_online;
#line 327 "../src/VideoSupport.vala"
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) video_real_set_master_timestamp;
#line 327 "../src/VideoSupport.vala"
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) video_real_set_master_file;
#line 10215 "VideoSupport.c"
}


static void
video_dateable_interface_init (DateableIface * iface)
{
#line 327 "../src/VideoSupport.vala"
	video_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 327 "../src/VideoSupport.vala"
	iface->get_exposure_time = (time_t (*) (Dateable*)) video_real_get_exposure_time;
#line 327 "../src/VideoSupport.vala"
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) video_real_set_exposure_time;
#line 10228 "VideoSupport.c"
}


static void
video_instance_init (Video * self)
{
#line 327 "../src/VideoSupport.vala"
	self->priv = video_get_instance_private (self);
#line 368 "../src/VideoSupport.vala"
	g_rec_mutex_init (&self->priv->__lock_backing_row);
#line 10239 "VideoSupport.c"
}


static void
video_finalize (GObject * obj)
{
	Video * self;
#line 327 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO, Video);
#line 368 "../src/VideoSupport.vala"
	g_rec_mutex_clear (&self->priv->__lock_backing_row);
#line 368 "../src/VideoSupport.vala"
	_video_row_unref0 (self->priv->backing_row);
#line 327 "../src/VideoSupport.vala"
	G_OBJECT_CLASS (video_parent_class)->finalize (obj);
#line 10255 "VideoSupport.c"
}


GType
video_get_type (void)
{
	static volatile gsize video_type_id__volatile = 0;
	if (g_once_init_enter (&video_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Video), 0, (GInstanceInitFunc) video_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) video_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) video_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) video_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType video_type_id;
		video_type_id = g_type_register_static (TYPE_VIDEO_SOURCE, "Video", &g_define_type_info, 0);
		g_type_add_interface_static (video_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (video_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_type_add_interface_static (video_type_id, TYPE_DATEABLE, &dateable_info);
		Video_private_offset = g_type_add_instance_private (video_type_id, sizeof (VideoPrivate));
		g_once_init_leave (&video_type_id__volatile, video_type_id);
	}
	return video_type_id__volatile;
}


static inline gpointer
video_source_collection_get_instance_private (VideoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, VideoSourceCollection_private_offset);
}


GType
video_source_collection_state_get_type (void)
{
	static volatile gsize video_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&video_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN, "VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {VIDEO_SOURCE_COLLECTION_STATE_ONLINE, "VIDEO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {VIDEO_SOURCE_COLLECTION_STATE_OFFLINE, "VIDEO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {VIDEO_SOURCE_COLLECTION_STATE_TRASH, "VIDEO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {0, NULL, NULL}};
		GType video_source_collection_state_type_id;
		video_source_collection_state_type_id = g_enum_register_static ("VideoSourceCollectionState", values);
		g_once_init_leave (&video_source_collection_state_type_id__volatile, video_source_collection_state_type_id);
	}
	return video_source_collection_state_type_id__volatile;
}


static gint
_uint64_compare_gcompare_data_func (gconstpointer a,
                                    gconstpointer b,
                                    gpointer self)
{
	gint result;
	result = uint64_compare ((guint64*) a, (guint64*) b);
#line 1077 "../src/VideoSupport.vala"
	return result;
#line 10310 "VideoSupport.c"
}


static guint64*
_uint64_dup (guint64* self)
{
	guint64* dup;
#line 1077 "../src/VideoSupport.vala"
	dup = g_new0 (guint64, 1);
#line 1077 "../src/VideoSupport.vala"
	memcpy (dup, self, sizeof (guint64));
#line 1077 "../src/VideoSupport.vala"
	return dup;
#line 10324 "VideoSupport.c"
}


static gint64
_video_source_collection_get_video_key_get_source_database_key (DataSource* source,
                                                                gpointer self)
{
	gint64 result;
	result = video_source_collection_get_video_key (source);
#line 1081 "../src/VideoSupport.vala"
	return result;
#line 10336 "VideoSupport.c"
}


static void
_video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                            GeeCollection* added,
                                                                                            GeeCollection* removed,
                                                                                            gpointer self)
{
#line 1083 "../src/VideoSupport.vala"
	video_source_collection_on_trashcan_contents_altered ((VideoSourceCollection*) self, added, removed);
#line 10348 "VideoSupport.c"
}


static void
_video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                           GeeCollection* added,
                                                                                           GeeCollection* removed,
                                                                                           gpointer self)
{
#line 1084 "../src/VideoSupport.vala"
	video_source_collection_on_offline_contents_altered ((VideoSourceCollection*) self, added, removed);
#line 10360 "VideoSupport.c"
}


VideoSourceCollection*
video_source_collection_construct (GType object_type)
{
	VideoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 1081 "../src/VideoSupport.vala"
	self = (VideoSourceCollection*) media_source_collection_construct (object_type, "VideoSourceCollection", _video_source_collection_get_video_key_get_source_database_key, NULL);
#line 1083 "../src/VideoSupport.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1083 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 1083 "../src/VideoSupport.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 1083 "../src/VideoSupport.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 1084 "../src/VideoSupport.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1084 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 1084 "../src/VideoSupport.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 1084 "../src/VideoSupport.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 1080 "../src/VideoSupport.vala"
	return self;
#line 10392 "VideoSupport.c"
}


VideoSourceCollection*
video_source_collection_new (void)
{
#line 1080 "../src/VideoSupport.vala"
	return video_source_collection_construct (TYPE_VIDEO_SOURCE_COLLECTION);
#line 10401 "VideoSupport.c"
}


static gboolean
_video_source_collection_is_video_trashed_source_holding_tank_check_to_keep (DataSource* source,
                                                                             Alteration* alteration,
                                                                             gpointer self)
{
	gboolean result;
	result = video_source_collection_is_video_trashed (source);
#line 1088 "../src/VideoSupport.vala"
	return result;
#line 10414 "VideoSupport.c"
}


static MediaSourceHoldingTank*
video_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
#line 1087 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1088 "../src/VideoSupport.vala"
	_tmp0_ = media_source_holding_tank_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _video_source_collection_is_video_trashed_source_holding_tank_check_to_keep, NULL, _video_source_collection_get_video_key_get_source_database_key, NULL);
#line 1088 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 1088 "../src/VideoSupport.vala"
	return result;
#line 10432 "VideoSupport.c"
}


static gboolean
_video_source_collection_is_video_offline_source_holding_tank_check_to_keep (DataSource* source,
                                                                             Alteration* alteration,
                                                                             gpointer self)
{
	gboolean result;
	result = video_source_collection_is_video_offline (source);
#line 1092 "../src/VideoSupport.vala"
	return result;
#line 10445 "VideoSupport.c"
}


static MediaSourceHoldingTank*
video_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
#line 1091 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1092 "../src/VideoSupport.vala"
	_tmp0_ = media_source_holding_tank_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _video_source_collection_is_video_offline_source_holding_tank_check_to_keep, NULL, _video_source_collection_get_video_key_get_source_database_key, NULL);
#line 1092 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 1092 "../src/VideoSupport.vala"
	return result;
#line 10463 "VideoSupport.c"
}


static MediaMonitor*
video_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                   Workers* workers,
                                                   GCancellable* cancellable)
{
	VideoSourceCollection * self;
	MediaMonitor* result = NULL;
	VideoMonitor* _tmp0_;
#line 1095 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1095 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 1095 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 1096 "../src/VideoSupport.vala"
	_tmp0_ = video_monitor_new (cancellable);
#line 1096 "../src/VideoSupport.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 1096 "../src/VideoSupport.vala"
	return result;
#line 10487 "VideoSupport.c"
}


static gboolean
video_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                   DataSource* source)
{
	VideoSourceCollection * self;
	gboolean result = FALSE;
#line 1099 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1099 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1100 "../src/VideoSupport.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_VIDEO);
#line 1100 "../src/VideoSupport.vala"
	return result;
#line 10505 "VideoSupport.c"
}


static gchar*
video_source_collection_real_get_typename (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1103 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1104 "../src/VideoSupport.vala"
	_tmp0_ = g_strdup (VIDEO_TYPENAME);
#line 1104 "../src/VideoSupport.vala"
	result = _tmp0_;
#line 1104 "../src/VideoSupport.vala"
	return result;
#line 10523 "VideoSupport.c"
}


static gboolean
video_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                 GFile* file)
{
	VideoSourceCollection * self;
	gboolean result = FALSE;
#line 1107 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1107 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1108 "../src/VideoSupport.vala"
	result = video_reader_is_supported_video_file (file);
#line 1108 "../src/VideoSupport.vala"
	return result;
#line 10541 "VideoSupport.c"
}


static void
video_source_collection_on_trashcan_contents_altered (VideoSourceCollection* self,
                                                      GeeCollection* added,
                                                      GeeCollection* removed)
{
#line 1111 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
#line 1111 "../src/VideoSupport.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1111 "../src/VideoSupport.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1113 "../src/VideoSupport.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 10558 "VideoSupport.c"
}


static void
video_source_collection_on_offline_contents_altered (VideoSourceCollection* self,
                                                     GeeCollection* added,
                                                     GeeCollection* removed)
{
#line 1117 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
#line 1117 "../src/VideoSupport.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 1117 "../src/VideoSupport.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 1119 "../src/VideoSupport.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 10575 "VideoSupport.c"
}


static MediaSource*
video_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                  gint64 numeric_id)
{
	VideoSourceCollection * self;
	MediaSource* result = NULL;
	VideoID _tmp0_ = {0};
	Video* _tmp1_;
#line 1123 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1124 "../src/VideoSupport.vala"
	video_id_init (&_tmp0_, numeric_id);
#line 1124 "../src/VideoSupport.vala"
	_tmp1_ = video_source_collection_fetch (self, &_tmp0_);
#line 1124 "../src/VideoSupport.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
#line 1124 "../src/VideoSupport.vala"
	return result;
#line 10597 "VideoSupport.c"
}


gint64
video_source_collection_get_video_key (DataSource* source)
{
	gint64 result = 0LL;
	Video* video = NULL;
	Video* _tmp0_;
	VideoID video_id = {0};
	VideoID _tmp1_ = {0};
	VideoID _tmp2_;
	gint64 _tmp3_;
#line 1127 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1128 "../src/VideoSupport.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video));
#line 1128 "../src/VideoSupport.vala"
	video = _tmp0_;
#line 1129 "../src/VideoSupport.vala"
	video_get_video_id (video, &_tmp1_);
#line 1129 "../src/VideoSupport.vala"
	video_id = _tmp1_;
#line 1131 "../src/VideoSupport.vala"
	_tmp2_ = video_id;
#line 1131 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_.id;
#line 1131 "../src/VideoSupport.vala"
	result = _tmp3_;
#line 1131 "../src/VideoSupport.vala"
	_g_object_unref0 (video);
#line 1131 "../src/VideoSupport.vala"
	return result;
#line 10631 "VideoSupport.c"
}


gboolean
video_source_collection_is_video_trashed (DataSource* source)
{
	gboolean result = FALSE;
#line 1134 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1135 "../src/VideoSupport.vala"
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video), TYPE_MEDIA_SOURCE, MediaSource));
#line 1135 "../src/VideoSupport.vala"
	return result;
#line 10645 "VideoSupport.c"
}


gboolean
video_source_collection_is_video_offline (DataSource* source)
{
	gboolean result = FALSE;
#line 1138 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1139 "../src/VideoSupport.vala"
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video), TYPE_MEDIA_SOURCE, MediaSource));
#line 1139 "../src/VideoSupport.vala"
	return result;
#line 10659 "VideoSupport.c"
}


Video*
video_source_collection_fetch (VideoSourceCollection* self,
                               VideoID* video_id)
{
	Video* result = NULL;
	VideoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_;
#line 1142 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), NULL);
#line 1142 "../src/VideoSupport.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 1143 "../src/VideoSupport.vala"
	_tmp0_ = *video_id;
#line 1143 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_.id;
#line 1143 "../src/VideoSupport.vala"
	_tmp2_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp1_);
#line 1143 "../src/VideoSupport.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_VIDEO, Video);
#line 1143 "../src/VideoSupport.vala"
	return result;
#line 10685 "VideoSupport.c"
}


static GeeCollection*
video_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                   EventID* event_id)
{
	VideoSourceCollection * self;
	GeeCollection* result = NULL;
	VideoTable* _tmp0_;
	VideoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
#line 1146 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1146 "../src/VideoSupport.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 1147 "../src/VideoSupport.vala"
	_tmp0_ = video_table_get_instance ();
#line 1147 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_;
#line 1147 "../src/VideoSupport.vala"
	_tmp2_ = *event_id;
#line 1147 "../src/VideoSupport.vala"
	_tmp3_ = video_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 1147 "../src/VideoSupport.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1147 "../src/VideoSupport.vala"
	_database_table_unref0 (_tmp1_);
#line 1147 "../src/VideoSupport.vala"
	result = _tmp4_;
#line 1147 "../src/VideoSupport.vala"
	return result;
#line 10720 "VideoSupport.c"
}


Video*
video_source_collection_get_state_by_file (VideoSourceCollection* self,
                                           GFile* file,
                                           VideoSourceCollectionState* state)
{
	VideoSourceCollectionState _vala_state = 0;
	Video* result = NULL;
	Video* video = NULL;
	MediaSource* _tmp0_;
	Video* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSource* _tmp4_;
	Video* _tmp5_;
	MediaSourceHoldingTank* _tmp6_;
	MediaSourceHoldingTank* _tmp7_;
	MediaSource* _tmp8_;
	Video* _tmp9_;
#line 1150 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), NULL);
#line 1150 "../src/VideoSupport.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1151 "../src/VideoSupport.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
#line 1151 "../src/VideoSupport.vala"
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_VIDEO, Video);
#line 1152 "../src/VideoSupport.vala"
	_tmp1_ = video;
#line 1152 "../src/VideoSupport.vala"
	if (_tmp1_ != NULL) {
#line 1153 "../src/VideoSupport.vala"
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_ONLINE;
#line 1155 "../src/VideoSupport.vala"
		result = video;
#line 1155 "../src/VideoSupport.vala"
		if (state) {
#line 1155 "../src/VideoSupport.vala"
			*state = _vala_state;
#line 10762 "VideoSupport.c"
		}
#line 1155 "../src/VideoSupport.vala"
		return result;
#line 10766 "VideoSupport.c"
	}
#line 1158 "../src/VideoSupport.vala"
	_tmp2_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1158 "../src/VideoSupport.vala"
	_tmp3_ = _tmp2_;
#line 1158 "../src/VideoSupport.vala"
	_tmp4_ = media_source_holding_tank_fetch_by_master_file (_tmp3_, file);
#line 1158 "../src/VideoSupport.vala"
	_g_object_unref0 (video);
#line 1158 "../src/VideoSupport.vala"
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_VIDEO, Video);
#line 1158 "../src/VideoSupport.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 1159 "../src/VideoSupport.vala"
	_tmp5_ = video;
#line 1159 "../src/VideoSupport.vala"
	if (_tmp5_ != NULL) {
#line 1160 "../src/VideoSupport.vala"
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_TRASH;
#line 1162 "../src/VideoSupport.vala"
		result = video;
#line 1162 "../src/VideoSupport.vala"
		if (state) {
#line 1162 "../src/VideoSupport.vala"
			*state = _vala_state;
#line 10792 "VideoSupport.c"
		}
#line 1162 "../src/VideoSupport.vala"
		return result;
#line 10796 "VideoSupport.c"
	}
#line 1165 "../src/VideoSupport.vala"
	_tmp6_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1165 "../src/VideoSupport.vala"
	_tmp7_ = _tmp6_;
#line 1165 "../src/VideoSupport.vala"
	_tmp8_ = media_source_holding_tank_fetch_by_master_file (_tmp7_, file);
#line 1165 "../src/VideoSupport.vala"
	_g_object_unref0 (video);
#line 1165 "../src/VideoSupport.vala"
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_VIDEO, Video);
#line 1165 "../src/VideoSupport.vala"
	_source_holding_tank_unref0 (_tmp7_);
#line 1166 "../src/VideoSupport.vala"
	_tmp9_ = video;
#line 1166 "../src/VideoSupport.vala"
	if (_tmp9_ != NULL) {
#line 1167 "../src/VideoSupport.vala"
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 1169 "../src/VideoSupport.vala"
		result = video;
#line 1169 "../src/VideoSupport.vala"
		if (state) {
#line 1169 "../src/VideoSupport.vala"
			*state = _vala_state;
#line 10822 "VideoSupport.c"
		}
#line 1169 "../src/VideoSupport.vala"
		return result;
#line 10826 "VideoSupport.c"
	}
#line 1172 "../src/VideoSupport.vala"
	_vala_state = VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 1174 "../src/VideoSupport.vala"
	result = NULL;
#line 1174 "../src/VideoSupport.vala"
	_g_object_unref0 (video);
#line 1174 "../src/VideoSupport.vala"
	if (state) {
#line 1174 "../src/VideoSupport.vala"
		*state = _vala_state;
#line 10838 "VideoSupport.c"
	}
#line 1174 "../src/VideoSupport.vala"
	return result;
#line 10842 "VideoSupport.c"
}


static void
video_source_collection_compare_backing (VideoSourceCollection* self,
                                         Video* video,
                                         GFileInfo* info,
                                         GeeCollection* matching_master)
{
	GTimeVal _tmp0_ = {0};
	glong _tmp1_;
#line 1177 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
#line 1177 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO (video));
#line 1177 "../src/VideoSupport.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1177 "../src/VideoSupport.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matching_master));
#line 1178 "../src/VideoSupport.vala"
	if (media_source_get_filesize (G_TYPE_CHECK_INSTANCE_CAST (video, TYPE_MEDIA_SOURCE, MediaSource)) != ((guint64) g_file_info_get_size (info))) {
#line 1179 "../src/VideoSupport.vala"
		return;
#line 10866 "VideoSupport.c"
	}
#line 1181 "../src/VideoSupport.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1181 "../src/VideoSupport.vala"
	_tmp1_ = _tmp0_.tv_sec;
#line 1181 "../src/VideoSupport.vala"
	if (media_source_get_timestamp (G_TYPE_CHECK_INSTANCE_CAST (video, TYPE_MEDIA_SOURCE, MediaSource)) == ((time_t) _tmp1_)) {
#line 1182 "../src/VideoSupport.vala"
		gee_collection_add (matching_master, video);
#line 10876 "VideoSupport.c"
	}
}


void
video_source_collection_fetch_by_matching_backing (VideoSourceCollection* self,
                                                   GFileInfo* info,
                                                   GeeCollection* matching_master)
{
#line 1185 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
#line 1185 "../src/VideoSupport.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1185 "../src/VideoSupport.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matching_master));
#line 10892 "VideoSupport.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1186 "../src/VideoSupport.vala"
		_tmp0_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1186 "../src/VideoSupport.vala"
		_tmp1_ = _tmp0_;
#line 1186 "../src/VideoSupport.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1186 "../src/VideoSupport.vala"
		_tmp3_ = _tmp2_;
#line 1186 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp1_);
#line 1186 "../src/VideoSupport.vala"
		_object_it = _tmp3_;
#line 1186 "../src/VideoSupport.vala"
		while (TRUE) {
#line 10913 "VideoSupport.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataObject* _tmp7_;
#line 1186 "../src/VideoSupport.vala"
			_tmp4_ = _object_it;
#line 1186 "../src/VideoSupport.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1186 "../src/VideoSupport.vala"
				break;
#line 10925 "VideoSupport.c"
			}
#line 1186 "../src/VideoSupport.vala"
			_tmp5_ = _object_it;
#line 1186 "../src/VideoSupport.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1186 "../src/VideoSupport.vala"
			object = (DataObject*) _tmp6_;
#line 1187 "../src/VideoSupport.vala"
			_tmp7_ = object;
#line 1187 "../src/VideoSupport.vala"
			video_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_VIDEO, Video), info, matching_master);
#line 1186 "../src/VideoSupport.vala"
			_g_object_unref0 (object);
#line 10939 "VideoSupport.c"
		}
#line 1186 "../src/VideoSupport.vala"
		_g_object_unref0 (_object_it);
#line 10943 "VideoSupport.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 1189 "../src/VideoSupport.vala"
		_tmp8_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1189 "../src/VideoSupport.vala"
		_tmp9_ = _tmp8_;
#line 1189 "../src/VideoSupport.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1189 "../src/VideoSupport.vala"
		_tmp11_ = _tmp10_;
#line 1189 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp9_);
#line 1189 "../src/VideoSupport.vala"
		_media_it = _tmp11_;
#line 1189 "../src/VideoSupport.vala"
		while (TRUE) {
#line 10965 "VideoSupport.c"
			GeeIterator* _tmp12_;
			MediaSource* media = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			MediaSource* _tmp15_;
#line 1189 "../src/VideoSupport.vala"
			_tmp12_ = _media_it;
#line 1189 "../src/VideoSupport.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 1189 "../src/VideoSupport.vala"
				break;
#line 10977 "VideoSupport.c"
			}
#line 1189 "../src/VideoSupport.vala"
			_tmp13_ = _media_it;
#line 1189 "../src/VideoSupport.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 1189 "../src/VideoSupport.vala"
			media = (MediaSource*) _tmp14_;
#line 1190 "../src/VideoSupport.vala"
			_tmp15_ = media;
#line 1190 "../src/VideoSupport.vala"
			video_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_VIDEO, Video), info, matching_master);
#line 1189 "../src/VideoSupport.vala"
			_g_object_unref0 (media);
#line 10991 "VideoSupport.c"
		}
#line 1189 "../src/VideoSupport.vala"
		_g_object_unref0 (_media_it);
#line 10995 "VideoSupport.c"
	}
}


static void
video_source_collection_real_notify_contents_altered (DataCollection* base,
                                                      GeeIterable* added,
                                                      GeeIterable* removed)
{
	VideoSourceCollection * self;
#line 1193 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1193 "../src/VideoSupport.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 1193 "../src/VideoSupport.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 1195 "../src/VideoSupport.vala"
	if (added != NULL) {
#line 11014 "VideoSupport.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 1196 "../src/VideoSupport.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 1196 "../src/VideoSupport.vala"
			_object_it = _tmp0_;
#line 1196 "../src/VideoSupport.vala"
			while (TRUE) {
#line 11024 "VideoSupport.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Video* video = NULL;
				DataObject* _tmp4_;
				Video* _tmp5_;
				GeeMultiMap* _tmp6_;
				Video* _tmp7_;
				guint64 _tmp8_;
				Video* _tmp9_;
#line 1196 "../src/VideoSupport.vala"
				_tmp1_ = _object_it;
#line 1196 "../src/VideoSupport.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 1196 "../src/VideoSupport.vala"
					break;
#line 11042 "VideoSupport.c"
				}
#line 1196 "../src/VideoSupport.vala"
				_tmp2_ = _object_it;
#line 1196 "../src/VideoSupport.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 1196 "../src/VideoSupport.vala"
				object = (DataObject*) _tmp3_;
#line 1197 "../src/VideoSupport.vala"
				_tmp4_ = object;
#line 1197 "../src/VideoSupport.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_VIDEO, Video));
#line 1197 "../src/VideoSupport.vala"
				video = _tmp5_;
#line 1199 "../src/VideoSupport.vala"
				_tmp6_ = self->priv->filesize_to_video;
#line 1199 "../src/VideoSupport.vala"
				_tmp7_ = video;
#line 1199 "../src/VideoSupport.vala"
				_tmp8_ = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1199 "../src/VideoSupport.vala"
				_tmp9_ = video;
#line 1199 "../src/VideoSupport.vala"
				gee_multi_map_set (_tmp6_, &_tmp8_, _tmp9_);
#line 1196 "../src/VideoSupport.vala"
				_g_object_unref0 (video);
#line 1196 "../src/VideoSupport.vala"
				_g_object_unref0 (object);
#line 11070 "VideoSupport.c"
			}
#line 1196 "../src/VideoSupport.vala"
			_g_object_unref0 (_object_it);
#line 11074 "VideoSupport.c"
		}
	}
#line 1203 "../src/VideoSupport.vala"
	if (removed != NULL) {
#line 11079 "VideoSupport.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp10_;
#line 1204 "../src/VideoSupport.vala"
			_tmp10_ = gee_iterable_iterator (removed);
#line 1204 "../src/VideoSupport.vala"
			_object_it = _tmp10_;
#line 1204 "../src/VideoSupport.vala"
			while (TRUE) {
#line 11089 "VideoSupport.c"
				GeeIterator* _tmp11_;
				DataObject* object = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				Video* video = NULL;
				DataObject* _tmp14_;
				Video* _tmp15_;
				GeeMultiMap* _tmp16_;
				Video* _tmp17_;
				guint64 _tmp18_;
				Video* _tmp19_;
#line 1204 "../src/VideoSupport.vala"
				_tmp11_ = _object_it;
#line 1204 "../src/VideoSupport.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 1204 "../src/VideoSupport.vala"
					break;
#line 11107 "VideoSupport.c"
				}
#line 1204 "../src/VideoSupport.vala"
				_tmp12_ = _object_it;
#line 1204 "../src/VideoSupport.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 1204 "../src/VideoSupport.vala"
				object = (DataObject*) _tmp13_;
#line 1205 "../src/VideoSupport.vala"
				_tmp14_ = object;
#line 1205 "../src/VideoSupport.vala"
				_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_VIDEO, Video));
#line 1205 "../src/VideoSupport.vala"
				video = _tmp15_;
#line 1207 "../src/VideoSupport.vala"
				_tmp16_ = self->priv->filesize_to_video;
#line 1207 "../src/VideoSupport.vala"
				_tmp17_ = video;
#line 1207 "../src/VideoSupport.vala"
				_tmp18_ = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1207 "../src/VideoSupport.vala"
				_tmp19_ = video;
#line 1207 "../src/VideoSupport.vala"
				gee_multi_map_remove (_tmp16_, &_tmp18_, _tmp19_);
#line 1204 "../src/VideoSupport.vala"
				_g_object_unref0 (video);
#line 1204 "../src/VideoSupport.vala"
				_g_object_unref0 (object);
#line 11135 "VideoSupport.c"
			}
#line 1204 "../src/VideoSupport.vala"
			_g_object_unref0 (_object_it);
#line 11139 "VideoSupport.c"
		}
	}
#line 1211 "../src/VideoSupport.vala"
	DATA_COLLECTION_CLASS (video_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
#line 11144 "VideoSupport.c"
}


void
video_source_collection_get_basename_filesize_duplicate (VideoSourceCollection* self,
                                                         const gchar* basename,
                                                         guint64 filesize,
                                                         VideoID* result)
{
	VideoID _tmp15_ = {0};
#line 1214 "../src/VideoSupport.vala"
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
#line 1214 "../src/VideoSupport.vala"
	g_return_if_fail (basename != NULL);
#line 11159 "VideoSupport.c"
	{
		GeeIterator* _video_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1215 "../src/VideoSupport.vala"
		_tmp0_ = self->priv->filesize_to_video;
#line 1215 "../src/VideoSupport.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 1215 "../src/VideoSupport.vala"
		_tmp2_ = _tmp1_;
#line 1215 "../src/VideoSupport.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1215 "../src/VideoSupport.vala"
		_tmp4_ = _tmp3_;
#line 1215 "../src/VideoSupport.vala"
		_g_object_unref0 (_tmp2_);
#line 1215 "../src/VideoSupport.vala"
		_video_it = _tmp4_;
#line 1215 "../src/VideoSupport.vala"
		while (TRUE) {
#line 11183 "VideoSupport.c"
			GeeIterator* _tmp5_;
			Video* video = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Video* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 1215 "../src/VideoSupport.vala"
			_tmp5_ = _video_it;
#line 1215 "../src/VideoSupport.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1215 "../src/VideoSupport.vala"
				break;
#line 11199 "VideoSupport.c"
			}
#line 1215 "../src/VideoSupport.vala"
			_tmp6_ = _video_it;
#line 1215 "../src/VideoSupport.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1215 "../src/VideoSupport.vala"
			video = (Video*) _tmp7_;
#line 1216 "../src/VideoSupport.vala"
			_tmp8_ = video;
#line 1216 "../src/VideoSupport.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1216 "../src/VideoSupport.vala"
			_tmp10_ = _tmp9_;
#line 1216 "../src/VideoSupport.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 1216 "../src/VideoSupport.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 1216 "../src/VideoSupport.vala"
			_g_object_unref0 (_tmp10_);
#line 1216 "../src/VideoSupport.vala"
			if (_tmp12_) {
#line 11221 "VideoSupport.c"
				Video* _tmp13_;
				VideoID _tmp14_ = {0};
#line 1217 "../src/VideoSupport.vala"
				_tmp13_ = video;
#line 1217 "../src/VideoSupport.vala"
				video_get_video_id (_tmp13_, &_tmp14_);
#line 1217 "../src/VideoSupport.vala"
				*result = _tmp14_;
#line 1217 "../src/VideoSupport.vala"
				_g_object_unref0 (video);
#line 1217 "../src/VideoSupport.vala"
				_g_object_unref0 (_video_it);
#line 1217 "../src/VideoSupport.vala"
				return;
#line 11236 "VideoSupport.c"
			}
#line 1215 "../src/VideoSupport.vala"
			_g_object_unref0 (video);
#line 11240 "VideoSupport.c"
		}
#line 1215 "../src/VideoSupport.vala"
		_g_object_unref0 (_video_it);
#line 11244 "VideoSupport.c"
	}
#line 1220 "../src/VideoSupport.vala"
	video_id_init (&_tmp15_, VIDEO_ID_INVALID);
#line 1220 "../src/VideoSupport.vala"
	*result = _tmp15_;
#line 1220 "../src/VideoSupport.vala"
	return;
#line 11252 "VideoSupport.c"
}


gboolean
video_source_collection_has_basename_filesize_duplicate (VideoSourceCollection* self,
                                                         const gchar* basename,
                                                         guint64 filesize)
{
	gboolean result = FALSE;
	VideoID _tmp0_ = {0};
#line 1224 "../src/VideoSupport.vala"
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), FALSE);
#line 1224 "../src/VideoSupport.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1225 "../src/VideoSupport.vala"
	video_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 1225 "../src/VideoSupport.vala"
	result = video_id_is_valid (&_tmp0_);
#line 1225 "../src/VideoSupport.vala"
	return result;
#line 11273 "VideoSupport.c"
}


static TransactionController*
video_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	VideoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 1068 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1069 "../src/VideoSupport.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 1069 "../src/VideoSupport.vala"
	if (_tmp0_ == NULL) {
#line 11290 "VideoSupport.c"
		MediaSourceTransactionController* _tmp1_;
#line 1070 "../src/VideoSupport.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 1070 "../src/VideoSupport.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 1070 "../src/VideoSupport.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 11298 "VideoSupport.c"
	}
#line 1072 "../src/VideoSupport.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 1072 "../src/VideoSupport.vala"
	result = _tmp2_;
#line 1072 "../src/VideoSupport.vala"
	return result;
#line 11306 "VideoSupport.c"
}


static void
video_source_collection_class_init (VideoSourceCollectionClass * klass)
{
#line 1059 "../src/VideoSupport.vala"
	video_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 1059 "../src/VideoSupport.vala"
	((DataCollectionClass *) klass)->finalize = video_source_collection_finalize;
#line 1059 "../src/VideoSupport.vala"
	g_type_class_adjust_private_offset (klass, &VideoSourceCollection_private_offset);
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) video_source_collection_real_create_trashcan;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) video_source_collection_real_create_offline_bin;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) video_source_collection_real_create_media_monitor;
#line 1059 "../src/VideoSupport.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) video_source_collection_real_holds_type_of_source;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) video_source_collection_real_get_typename;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) video_source_collection_real_is_file_recognized;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) video_source_collection_real_fetch_by_numeric_id;
#line 1059 "../src/VideoSupport.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) video_source_collection_real_get_event_source_ids;
#line 1059 "../src/VideoSupport.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) video_source_collection_real_notify_contents_altered;
#line 1059 "../src/VideoSupport.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = video_source_collection_real_get_transaction_controller;
#line 11339 "VideoSupport.c"
}


static void
video_source_collection_instance_init (VideoSourceCollection * self)
{
	GeeTreeMultiMap* _tmp0_;
#line 1059 "../src/VideoSupport.vala"
	self->priv = video_source_collection_get_instance_private (self);
#line 1076 "../src/VideoSupport.vala"
	self->priv->_transaction_controller = NULL;
#line 1077 "../src/VideoSupport.vala"
	_tmp0_ = gee_tree_multi_map_new (G_TYPE_UINT64, (GBoxedCopyFunc) _uint64_dup, (GDestroyNotify) g_free, TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _uint64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 1077 "../src/VideoSupport.vala"
	self->priv->filesize_to_video = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 11355 "VideoSupport.c"
}


static void
video_source_collection_finalize (DataCollection * obj)
{
	VideoSourceCollection * self;
#line 1059 "../src/VideoSupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
#line 1076 "../src/VideoSupport.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 1077 "../src/VideoSupport.vala"
	_g_object_unref0 (self->priv->filesize_to_video);
#line 1059 "../src/VideoSupport.vala"
	DATA_COLLECTION_CLASS (video_source_collection_parent_class)->finalize (obj);
#line 11371 "VideoSupport.c"
}


GType
video_source_collection_get_type (void)
{
	static volatile gsize video_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&video_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoSourceCollection), 0, (GInstanceInitFunc) video_source_collection_instance_init, NULL };
		GType video_source_collection_type_id;
		video_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "VideoSourceCollection", &g_define_type_info, 0);
		VideoSourceCollection_private_offset = g_type_add_instance_private (video_source_collection_type_id, sizeof (VideoSourceCollectionPrivate));
		g_once_init_leave (&video_source_collection_type_id__volatile, video_source_collection_type_id);
	}
	return video_source_collection_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



